unit HumDB;

interface
uses
  Windows, Classes, SysUtils, Forms, MudUtil, MirGrobal,SerGrobal;
resourcestring
  sDBHeaderDesc = 'Ϸݿļ 2006/07/01';
  sDBIdxHeaderDesc = 'Ϸݿļ 2006/07/01';

type





  TFileHumInfo = class
    n4: Integer; //0x04
    m_nFileHandle: Integer; //0x08
    m_OnChange: TNotifyEvent;
    m_boChanged: Boolean; //0x18
    m_Header: THumDBHeader; //0x1C
    m_QuickList: TQuickList; //0x98
    m_QuickIDList: TQuickIDList; //0x9C
    m_DeletedList: TList; //0xA0 ѱɾļ¼
    m_sDBFileName: string; //0xA4
  private
    procedure LoadQuickList;
    procedure Lock;
    procedure UnLock;
    function UpdateRecord(nIndex: Integer; HumRecord: THumInfo; boNew: Boolean): Boolean;
    function DeleteRecord(nIndex: Integer): Boolean;
    function GetRecord(n08: Integer; var HumDBRecord: THumInfo): Boolean;
  public
    constructor Create(sFileName: string);
    destructor Destroy; override;

    function Open(): Boolean;
    function OpenEx(): Boolean;
    procedure Close();
    function Index(sName: string): Integer;
    function Get(n08: Integer; var HumDBRecord: THumInfo): Integer;
    function GetBy(n08: Integer; var HumDBRecord: THumInfo): Boolean;
    function FindByName(sChrName: string; ChrList: TStringList): Integer;
    function FindByAccount(sAccount: string; var ChrList: TStringList): Integer;
    function ChrCountOfAccount(sAccount: string): Integer;
    function Add(HumRecord: THumInfo): Boolean;
    function Delete(sName: string): Boolean;
    function Update(nIndex: Integer; var HumDBRecord: THumInfo): Boolean;
    function UpdateBy(nIndex: Integer; var HumDBRecord: THumInfo): Boolean;
    function Count(): Integer;
  end;
  TFileDB = class
    n4: Integer; //0x4
    m_nFileHandle: Integer; //0x08
    nC: Integer;
    m_OnChange: TNotifyEvent; //0x10
    m_boChanged: Boolean; //0x18
    m_nLastIndex: Integer; //0x1C
    m_dUpdateTime: TDateTime; //0x20
    m_Header: THumDBHeader; //0x28
    m_FileDBQuickList: TQuickList; //0xA4
    m_FileDBDeletedList: TList; //0xA8 ѱɾļ¼
    m_sDBFileName: string; //0xAC
    m_sIdxFileName: string; //0xB0
  private
    procedure LoadQuickList;
    function LoadDBIndex(): Boolean;
    procedure SaveIndex();
    function GetRecord(nIndex: Integer; var HumDataInfo: THumDataInfo): Boolean;
    function UpdateRecord(nIndex: Integer; var HumDataInfo: THumDataInfo; boNew: Boolean): Boolean;
    function DeleteRecord(nIndex: Integer): Boolean;
  public
    constructor Create(sFileName: string);
    destructor Destroy; override;
    procedure Lock;
    procedure UnLock;
    function Open(): Boolean;
    function OpenEx(): Boolean;
    procedure Close();
    function Index(sName: string): Integer;
    function Get(nIndex: Integer; var HumDataInfo: THumDataInfo): Integer;
    function Update(nIndex: Integer; var HumDataInfo: THumDataInfo): Boolean;
    function Add(var HumDataInfo: THumDataInfo): Boolean;
    function Find(sChrName: string; List: TStrings): Integer;
    procedure Rebuild();
    function Count(): Integer;
    function Delete(sChrName: string): Boolean; overload;
    function Delete(nIndex: Integer): Boolean; overload;
  end;

implementation

uses DBShare, HUtil32;

{ TFileHumDB }

constructor TFileHumInfo.Create(sFileName: string); //0x0048B73C
begin
  m_sDBFileName := sFileName;
  m_QuickList := TQuickList.Create;
  m_QuickIDList := TQuickIDList.Create;
  m_DeletedList := TList.Create;
  n4ADAFC := 0;
  n4ADB04 := 0;
  boHumDBReady := False;
  LoadQuickList();
end;
destructor TFileHumInfo.Destroy;
begin
  m_QuickList.Free;
  m_QuickIDList.Free;
  inherited;
end;
procedure TFileHumInfo.Lock(); //0x0048B870
begin
  EnterCriticalSection(HumDB_CS);
end;
procedure TFileHumInfo.UnLock(); //0x0048B888
begin
  LeaveCriticalSection(HumDB_CS);
end;

procedure TFileHumInfo.LoadQuickList();
//0x48BA64
var
  nRecordIndex: Integer;
  nIndex: Integer;
  AccountList: TStringList;
  ChrNameList: TStringList;
  DBHeader: THumDBHeader;
  DBRecord: THumInfo;
begin
  n4 := 0;
  m_QuickList.Clear;
  m_QuickIDList.Clear;
  m_DeletedList.Clear;
  nRecordIndex := 0;
  n4ADAFC := 0;
  n4ADB00 := 0;
  n4ADB04 := 0;
  AccountList := TStringList.Create;
  ChrNameList := TStringList.Create;
  try
    if Open then begin
      FileSeek(m_nFileHandle, 0, 0);
      if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then begin
        n4ADB04 := DBHeader.nHumCount;
        for nIndex := 0 to DBHeader.nHumCount - 1 do begin
          Inc(n4ADAFC);
          if FileRead(m_nFileHandle, DBRecord, SizeOf(THumInfo)) <> SizeOf(THumInfo) then begin
            break;
          end;
          if not DBRecord.Header.boDeleted then begin
            m_QuickList.AddObject(DBRecord.Header.sName, TObject(nRecordIndex));
            AccountList.AddObject(DBRecord.sAccount, TObject(DBRecord.Header.btSelectID));
            ChrNameList.AddObject(DBRecord.sChrName, TObject(nRecordIndex));
            Inc(n4ADB00);
          end else begin //0x0048BC04
            m_DeletedList.Add(TObject(nIndex));
          end;
          Inc(nRecordIndex);
          Application.ProcessMessages;
          if Application.Terminated then begin
            Close;
            Exit;
          end;
        end;
      end; //0x0048BC52
    end;
  finally
    Close();
  end;
  for nIndex := 0 to AccountList.Count - 1 do begin
    m_QuickIDList.AddRecord(AccountList.Strings[nIndex],
      ChrNameList.Strings[nIndex],
      Integer(ChrNameList.Objects[nIndex]) {,
      Integer(AccountList.Objects[nIndex])});
    if (nIndex mod 100) = 0 then
      Application.ProcessMessages;
  end;
  //0x0048BCF4
  AccountList.Free;
  ChrNameList.Free;
  m_QuickList.SortString(0, m_QuickList.Count - 1);
  boHumDBReady := True;
  //m_QuickList.SaveToFile('C:\TFileHumInfo_L.txt');
end;
function TFileHumInfo.Count(): Integer;
begin
  Result := m_Header.nHumCount;
end;
procedure TFileHumInfo.Close; //0x0048BA24
begin
  FileClose(m_nFileHandle);
  if m_boChanged and Assigned(m_OnChange) then begin
    m_OnChange(Self);
  end;
  UnLock();
end;

function TFileHumInfo.Open: Boolean; //0x0048B928
begin
  Lock();
  n4 := 0;
  m_boChanged := False;
  if FileExists(m_sDBFileName) then begin
    m_nFileHandle := FileOpen(m_sDBFileName, fmOpenReadWrite or fmShareDenyNone);
    if m_nFileHandle > 0 then
      FileRead(m_nFileHandle, m_Header, SizeOf(m_Header));
  end else begin //0x0048B999
    m_nFileHandle := FileCreate(m_sDBFileName);
    if m_nFileHandle > 0 then begin
      m_Header.sDesc := sDBHeaderDesc;
      m_Header.nHumCount := 0;

      FileWrite(m_nFileHandle, m_Header, SizeOf(m_Header));
    end;
  end;
  if m_nFileHandle > 0 then Result := True
  else Result := False;
end;

function TFileHumInfo.OpenEx: Boolean; //0x0048B8A0
var
  DBHeader: THumDBHeader;
begin
  Lock();
  m_boChanged := False;
  m_nFileHandle := FileOpen(m_sDBFileName, fmOpenReadWrite or fmShareDenyNone);
  if m_nFileHandle > 0 then begin
    Result := True;
    if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then
      m_Header := DBHeader;
    n4 := 0;
  end else Result := False;
end;

function TFileHumInfo.Index(sName: string): Integer; //0x0048C384
begin
  Result := m_QuickList.GetIndex(sName);
end;

function TFileHumInfo.Get(n08: Integer;
  var HumDBRecord: THumInfo): Integer; //0x0048C0CC
var
  nIndex: Integer;
begin
  nIndex := Integer(m_QuickList.Objects[n08]);
  if GetRecord(nIndex, HumDBRecord) then Result := nIndex
  else Result := -1;
end;

function TFileHumInfo.GetRecord(n08: Integer;
  var HumDBRecord: THumInfo): Boolean;
//0x0048BEEC
begin
  if FileSeek(m_nFileHandle, SizeOf(THumInfo) * n08 + SizeOf(THumDBHeader), 0) <> -1 then begin
    FileRead(m_nFileHandle, HumDBRecord, SizeOf(THumInfo));
    FileSeek(m_nFileHandle, -SizeOf(THumInfo) * n08 + SizeOf(THumDBHeader), 1);
    n4 := n08;
    Result := True;
  end else Result := False;
end;

function TFileHumInfo.FindByName(sChrName: string;
  ChrList: TStringList): Integer; //0x0048C3E0
var
  i: Integer;
begin
  for i := 0 to m_QuickList.Count - 1 do begin
    if CompareLStr(m_QuickList.Strings[i], sChrName, Length(sChrName)) then begin
      ChrList.AddObject(m_QuickList.Strings[i], m_QuickList.Objects[i]);
    end;
  end;
  Result := ChrList.Count;
end;

function TFileHumInfo.GetBy(n08: Integer;
  var HumDBRecord: THumInfo): Boolean; //0x0048C118
begin
  if n08 >= 0 then
    Result := GetRecord(n08, HumDBRecord)
  else Result := False;
end;

function TFileHumInfo.FindByAccount(sAccount: string;
  var ChrList: TStringList): Integer; //0x0048C4DC
var
  ChrNameList: TList;
  QuickID: pTQuickID;
  i: Integer;
begin
  ChrNameList := nil;
  m_QuickIDList.GetChrList(sAccount, ChrNameList);
  if ChrNameList <> nil then begin
    for i := 0 to ChrNameList.Count - 1 do begin
      QuickID := ChrNameList.Items[i];
      ChrList.AddObject(QuickID.sAccount, TObject(QuickID));
    end;
  end;
  Result := ChrList.Count;
end;

function TFileHumInfo.ChrCountOfAccount(sAccount: string): Integer; //0x0048C5B0
var
  ChrList: TList;
  i, n18: Integer;
  HumDBRecord: THumInfo;
begin
  n18 := 0;
  ChrList := nil;
  m_QuickIDList.GetChrList(sAccount, ChrList);
  if ChrList <> nil then begin
    for i := 0 to ChrList.Count - 1 do begin
      if GetBy(pTQuickID(ChrList.Items[i]).nIndex, HumDBRecord) and
        not HumDBRecord.boDeleted then Inc(n18);
    end;
  end;
  Result := n18;
end;

function TFileHumInfo.Add(HumRecord: THumInfo): Boolean; //0x0048C1F4
var
  Header: THumDBHeader;
  nIndex: Integer;
begin
  if m_QuickList.GetIndex(HumRecord.Header.sName) >= 0 then Result := False
  else begin
    Header := m_Header;
    if m_DeletedList.Count > 0 then begin
      nIndex := Integer(m_DeletedList.Items[0]);
      m_DeletedList.Delete(0);
    end else begin
      nIndex := m_Header.nHumCount;
      Inc(m_Header.nHumCount);
    end;
    if UpdateRecord(nIndex, HumRecord, True) then begin
      m_QuickList.AddRecord(HumRecord.Header.sName, nIndex);
      m_QuickIDList.AddRecord(HumRecord.sAccount, HumRecord.sChrName, nIndex {,HumRecord.Header.nSelectID});
      Result := True;
    end else begin
      m_Header := Header;
      Result := False;
    end;
  end;
end;

function TFileHumInfo.UpdateRecord(nIndex: Integer; HumRecord: THumInfo;
  boNew: Boolean): Boolean; //0x0048BF5C
var
  HumRcd: THumInfo;
  nPosion, n10: Integer;
begin
  nPosion := nIndex * SizeOf(THumInfo) + SizeOf(THumDBHeader);
  if FileSeek(m_nFileHandle, nPosion, 0) = nPosion then begin
    n10 := FileSeek(m_nFileHandle, 0, 1);
    if boNew and
      (FileRead(m_nFileHandle, HumRcd, SizeOf(THumInfo)) = SizeOf(THumInfo)) and
      (not HumRcd.Header.boDeleted) and (HumRcd.Header.sName <> '') then Result := True
    else begin
      HumRecord.Header.boDeleted := False;
      HumRecord.Header.dCreateDate := Now();
      m_Header.dUpdateDate := Now();
      FileSeek(m_nFileHandle, 0, 0);
      FileWrite(m_nFileHandle, m_Header, SizeOf(m_Header));
      FileSeek(m_nFileHandle, n10, 0);
      FileWrite(m_nFileHandle, HumRecord, SizeOf(THumInfo));
      FileSeek(m_nFileHandle, -SizeOf(THumInfo), 1);
      n4 := nIndex;
      m_boChanged := True;
      Result := True;
    end;
  end else Result := False;
end;

function TFileHumInfo.Delete(sName: string): Boolean; //0x0048BDE0
var
  n10: Integer;
  HumRecord: THumInfo;
  ChrNameList: TList;
  n14: Integer;
begin
  Result := False;
  n10 := m_QuickList.GetIndex(sName);
  if n10 < 0 then Exit;
  Get(n10, HumRecord);
  if DeleteRecord(Integer(m_QuickList.Objects[n10])) then begin
    m_QuickList.Delete(n10);
    Result := True;
  end;
  n14 := m_QuickIDList.GetChrList(HumRecord.sAccount, ChrNameList);
  if n14 >= 0 then begin
    m_QuickIDList.DelRecord(n14, HumRecord.sChrName);
  end;

end;

function TFileHumInfo.DeleteRecord(nIndex: Integer): Boolean; //0x0048BD58
var
  HumRcdHeader: THumRecordHeader;
begin
  Result := False;
  if FileSeek(m_nFileHandle, nIndex * SizeOf(THumInfo) + SizeOf(THumDBHeader), 0) = -1 then Exit;
  HumRcdHeader.boDeleted := True;
  HumRcdHeader.dCreateDate := Now();
  FileWrite(m_nFileHandle, HumRcdHeader, SizeOf(HumRcdHeader));
  m_DeletedList.Add(Pointer(nIndex));
  m_boChanged := True;
  Result := True;
end;

function TFileHumInfo.Update(nIndex: Integer; var HumDBRecord: THumInfo): Boolean; //0x0048C14C
begin
  Result := False;
  if nIndex < 0 then Exit;
  if m_QuickList.Count <= nIndex then Exit;
  if UpdateRecord(Integer(m_QuickList.Objects[nIndex]), HumDBRecord, False) then Result := True;
end;



function TFileHumInfo.UpdateBy(nIndex: Integer; var HumDBRecord: THumInfo): Boolean; //00048C1B4
begin
  Result := False;
  if UpdateRecord(nIndex, HumDBRecord, False) then Result := True;
end;

{ TFileDB }



constructor TFileDB.Create(sFileName: string); //0x0048A0F4
begin
  n4 := 0;
  boDataDBReady := False;
  m_sDBFileName := sFileName;
  m_sIdxFileName := sFileName + '.idx';
  m_FileDBQuickList := TQuickList.Create;
  m_FileDBDeletedList := TList.Create;
  n4ADAE4 := 0;
  n4ADAF0 := 0;
  m_nLastIndex := -1;
  {if LoadDBIndex then boDataDBReady := True
  else }LoadQuickList();
end;
destructor TFileDB.Destroy;
begin
  if boDataDBReady then SaveIndex();

  m_FileDBQuickList.Free;
  m_FileDBDeletedList.Free;
  inherited;
end;
function TFileDB.LoadDBIndex: Boolean; //0x0048AA6C
var
  nIdxFileHandle: Integer;
  IdxHeader: THumIdxHeader;
  DBHeader: THumDBHeader;
  IdxRecord: THumIdxRecord;
  HumRecord: THumDataInfo;
  i: Integer;
  n14: Integer;
begin
  Result := False;
  nIdxFileHandle := 0;
  FillChar(IdxHeader, SizeOf(IdxHeader), #0);
  if FileExists(m_sIdxFileName) then
    nIdxFileHandle := FileOpen(m_sIdxFileName, fmOpenReadWrite or fmShareDenyNone);
  if nIdxFileHandle > 0 then begin
    Result := True;
    FileRead(nIdxFileHandle, IdxHeader, SizeOf(IdxHeader));

    try
      if Open then begin
        FileSeek(m_nFileHandle, 0, 0);
        if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then begin
          if IdxHeader.nHumCount <> DBHeader.nHumCount then
            Result := False;
          if IdxHeader.sDesc <> sDBIdxHeaderDesc then
            Result := False;
        end; //0x0048AB65
        if IdxHeader.nLastIndex <> DBHeader.nLastIndex then begin
          Result := False;
        end;
        if IdxHeader.nLastIndex > -1 then begin
          FileSeek(m_nFileHandle, IdxHeader.nLastIndex * SizeOf(THumDataInfo) + SizeOf(THumDBHeader), 0);
          if FileRead(m_nFileHandle, HumRecord, SizeOf(THumDataInfo)) = SizeOf(THumDataInfo) then
            if IdxHeader.dUpdateDate <> HumRecord.Header.dCreateDate then
              Result := False;
        end;
      end; //0x0048ABD7
    finally
      Close();
    end;
    if Result then begin
      m_nLastIndex := IdxHeader.nLastIndex;
      m_dUpdateTime := IdxHeader.dUpdateDate;
      for i := 0 to IdxHeader.nQuickCount - 1 do begin
        if FileRead(nIdxFileHandle, IdxRecord, SizeOf(IdxRecord)) = SizeOf(IdxRecord) then begin
          m_FileDBQuickList.AddObject(IdxRecord.sChrName, TObject(IdxRecord.nIndex));
        end else begin
          Result := False;
          break;
        end;
      end; //0048AC7A
      for i := 0 to IdxHeader.nDeleteCount - 1 do begin
        if FileRead(nIdxFileHandle, n14, SizeOf(Integer)) = SizeOf(Integer) then
          m_FileDBDeletedList.Add(Pointer(n14))
        else begin
          Result := False;
          break;
        end;
      end;
    end; //0048ACC5
    FileClose(nIdxFileHandle);
  end; //0048ACCD
  if Result then begin
    n4ADAE4 := m_FileDBQuickList.Count;
    n4ADAE8 := m_FileDBQuickList.Count;
    n4ADAF0 := DBHeader.nHumCount;
    m_FileDBQuickList.SortString(0, m_FileDBQuickList.Count - 1);
  end else m_FileDBQuickList.Clear;
  //m_FileDBQuickList.SaveToFile('C:\m_FileDBQuickList.txt');
end;

procedure TFileDB.SaveIndex; //0x0048A83C
var
  IdxHeader: THumIdxHeader;
  nIdxFileHandle: Integer;
  i: Integer;
  nDeletedIdx: Integer;
  IdxRecord: THumIdxRecord;
begin
  FillChar(IdxHeader, SizeOf(IdxHeader), #0);
  IdxHeader.sDesc := sDBIdxHeaderDesc;
  IdxHeader.nQuickCount := m_FileDBQuickList.Count;
  IdxHeader.nHumCount := m_Header.nHumCount;
  IdxHeader.nDeleteCount := m_FileDBDeletedList.Count;
  IdxHeader.nLastIndex := m_nLastIndex;
  IdxHeader.dUpdateDate := m_dUpdateTime;
  if FileExists(m_sIdxFileName) then
    nIdxFileHandle := FileOpen(m_sIdxFileName, fmOpenReadWrite or fmShareDenyNone)
  else nIdxFileHandle := FileCreate(m_sIdxFileName);

  if nIdxFileHandle > 0 then begin
    FileWrite(nIdxFileHandle, IdxHeader, SizeOf(IdxHeader));
    for i := 0 to m_FileDBQuickList.Count - 1 do begin
      IdxRecord.sChrName := m_FileDBQuickList.Strings[i];
      IdxRecord.nIndex := Integer(m_FileDBQuickList.Objects[i]);
      FileWrite(nIdxFileHandle, IdxRecord, SizeOf(IdxRecord));
    end;
    for i := 0 to m_FileDBDeletedList.Count - 1 do begin
      nDeletedIdx := Integer(m_FileDBDeletedList.Items[i]);
      FileWrite(nIdxFileHandle, nDeletedIdx, SizeOf(Integer));
    end;
    FileClose(nIdxFileHandle);
  end;
end;
procedure TFileDB.LoadQuickList; //0x0048A440
var
  nIndex: Integer;
  DBHeader: THumDBHeader;
  RecordHeader: THumRecordHeader;
begin
  n4 := 0;
  m_FileDBQuickList.Clear;
  m_FileDBDeletedList.Clear;
  n4ADAE4 := 0;
  n4ADAE8 := 0;
  n4ADAF0 := 0;
  try
    if Open then begin
      FileSeek(m_nFileHandle, 0, 0);
      if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then begin
        n4ADAF0 := DBHeader.nHumCount;
        for nIndex := 0 to DBHeader.nHumCount - 1 do begin
          Inc(n4ADAE4);
          if FileSeek(m_nFileHandle, nIndex * SizeOf(THumDataInfo) + SizeOf(DBHeader), 0) = -1 then break;
          if FileRead(m_nFileHandle, RecordHeader, SizeOf(RecordHeader)) <> SizeOf(RecordHeader) then break;
          if not RecordHeader.boDeleted then begin
            if RecordHeader.sName <> '' then begin
              m_FileDBQuickList.AddObject(RecordHeader.sName, TObject(nIndex));
              Inc(n4ADAE8);
            end else m_FileDBDeletedList.Add(TObject(nIndex));
          end else begin
            m_FileDBDeletedList.Add(TObject(nIndex));
            Inc(n4ADAEC);
          end;
          Application.ProcessMessages;
          if Application.Terminated then begin
            Close;
            Exit;
          end;
        end;
      end;
    end;
  finally
    Close();
  end;
  m_FileDBQuickList.SortString(0, m_FileDBQuickList.Count - 1);
  m_nLastIndex := m_Header.nLastIndex;
  m_dUpdateTime := m_Header.dLastDate;
  boDataDBReady := True;
end;

procedure TFileDB.Lock; //00048A254
begin
  EnterCriticalSection(HumDB_CS);
end;
procedure TFileDB.UnLock; //0048A268
begin
  LeaveCriticalSection(HumDB_CS);
end;

function TFileDB.Open: Boolean; //0048A304
begin
  Lock();
  n4 := 0;
  m_boChanged := False;
  if FileExists(m_sDBFileName) then begin
    m_nFileHandle := FileOpen(m_sDBFileName, fmOpenReadWrite or fmShareDenyNone);
    if m_nFileHandle > 0 then
      FileRead(m_nFileHandle, m_Header, SizeOf(m_Header));
  end else begin //0048B999
    m_nFileHandle := FileCreate(m_sDBFileName);
    if m_nFileHandle > 0 then begin
      m_Header.sDesc := sDBHeaderDesc;
      m_Header.nHumCount := 0;
      FileWrite(m_nFileHandle, m_Header, SizeOf(m_Header));
    end;
  end;
  if m_nFileHandle > 0 then Result := True
  else Result := False;
end;

procedure TFileDB.Close; //0x0048A400
begin
  FileClose(m_nFileHandle);
  if m_boChanged and Assigned(m_OnChange) then begin
    m_OnChange(Self);
  end;
  UnLock();
end;

function TFileDB.OpenEx: Boolean; //0x0048A27C
var
  DBHeader: THumDBHeader;
begin
  Lock();
  m_boChanged := False;
  m_nFileHandle := FileOpen(m_sDBFileName, fmOpenReadWrite or fmShareDenyNone);
  if m_nFileHandle > 0 then begin
    Result := True;
    if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then
      m_Header := DBHeader;
    n4 := 0;
  end else Result := False;
end;

function TFileDB.Index(sName: string): Integer; //0x0048B534
begin
  Result := m_FileDBQuickList.GetIndex(sName);
end;

function TFileDB.Get(nIndex: Integer; var HumDataInfo: THumDataInfo): Integer; //0x0048B320
var
  nIdx: Integer;
begin
  Result := -1;
  if (nIndex < 0) or (m_FileDBQuickList.Count-1 < nIndex) then Exit;
  nIdx := Integer(m_FileDBQuickList.Objects[nIndex]);
  if GetRecord(nIdx, HumDataInfo) then Result := nIdx;
end;

function TFileDB.Update(nIndex: Integer;
  var HumDataInfo: THumDataInfo): Boolean; //0x0048B36C
begin
  Result := False;
  if (nIndex >= 0) and (m_FileDBQuickList.Count > nIndex) then
    if UpdateRecord(Integer(m_FileDBQuickList.Objects[nIndex]), HumDataInfo, False) then Result := True;
end;

function TFileDB.Add(var HumDataInfo: THumDataInfo): Boolean; //0x0048B3E0
var
  sHumanName: string;
  DBHeader: THumDBHeader;
  nIdx: Integer;
begin
  sHumanName := HumDataInfo.Header.sName;
  if m_FileDBQuickList.GetIndex(sHumanName) >= 0 then begin
    Result := False;
  end else begin
    DBHeader := m_Header;
    if m_FileDBDeletedList.Count > 0 then begin
      nIdx := Integer(m_FileDBDeletedList.Items[0]);
      m_FileDBDeletedList.Delete(0);
    end else begin
      nIdx := m_Header.nHumCount;
      Inc(m_Header.nHumCount);
    end;
    if UpdateRecord(nIdx, HumDataInfo, True) then begin
      m_FileDBQuickList.AddRecord(HumDataInfo.Header.sName, nIdx);
      Result := True;
    end else begin
      m_Header := DBHeader;
      Result := False;
    end;
  end;
end;

function TFileDB.GetRecord(nIndex: Integer;
  var HumDataInfo: THumDataInfo): Boolean; //0x0048B0C8
begin
  if FileSeek(m_nFileHandle, nIndex * SizeOf(THumDataInfo) + SizeOf(THumDBHeader), 0) <> -1 then begin
    FileRead(m_nFileHandle, HumDataInfo, SizeOf(THumDataInfo));
    FileSeek(m_nFileHandle, -SizeOf(THumDataInfo), 1);
    n4 := nIndex;
    Result := True;
  end else Result := False;
end;

function TFileDB.UpdateRecord(nIndex: Integer;
  var HumDataInfo: THumDataInfo; boNew: Boolean): Boolean; //0x0048B134
var
  nPosion, n10: Integer;
  dt20: TDateTime;
  ReadRCD: THumDataInfo;
begin
  nPosion := nIndex * SizeOf(THumDataInfo) + SizeOf(THumDBHeader);
  if FileSeek(m_nFileHandle, nPosion, 0) = nPosion then begin
    dt20 := Now();
    m_nLastIndex := nIndex;
    m_dUpdateTime := dt20;
    n10 := FileSeek(m_nFileHandle, 0, 1);
    if boNew
      and (FileRead(m_nFileHandle, ReadRCD, SizeOf(THumDataInfo)) = SizeOf(THumDataInfo))
      and not ReadRCD.Header.boDeleted and (ReadRCD.Header.sName <> '') then begin
      Result := False;
    end else begin //0048B1F5
      HumDataInfo.Header.boDeleted := False;
      HumDataInfo.Header.dCreateDate := Now();
      m_Header.nLastIndex := m_nLastIndex;
      m_Header.dLastDate := m_dUpdateTime;
      m_Header.dUpdateDate := Now();
      FileSeek(m_nFileHandle, 0, 0);
      FileWrite(m_nFileHandle, m_Header, SizeOf(m_Header));
      FileSeek(m_nFileHandle, n10, 0);
      FileWrite(m_nFileHandle, HumDataInfo, SizeOf(THumDataInfo));
      FileSeek(m_nFileHandle, -SizeOf(THumDataInfo), 1);
      n4 := nIndex;
      m_boChanged := True;
      Result := True;
    end;
  end else Result := False;
end;

function TFileDB.Find(sChrName: string;
  List: TStrings): Integer; //0x0048B590
var
  i: Integer;
begin
  for i := 0 to m_FileDBQuickList.Count - 1 do begin
    if CompareLStr(m_FileDBQuickList.Strings[i], sChrName, Length(sChrName)) then begin
      List.AddObject(m_FileDBQuickList.Strings[i], m_FileDBQuickList.Objects[i]);
    end;
  end;
  Result := List.Count;
end;

function TFileDB.Delete(nIndex: Integer): Boolean; //0x0048AF4C
var
  i: Integer;
  s14: string;
begin
  Result := False;
  for i := 0 to m_FileDBQuickList.Count - 1 do begin
    if Integer(m_FileDBQuickList.Objects[i]) = nIndex then begin
      s14 := m_FileDBQuickList.Strings[i];
      if DeleteRecord(nIndex) then begin
        m_FileDBQuickList.Delete(i);
        Result := True;
        break;
      end;
    end;
  end;
end;

function TFileDB.DeleteRecord(nIndex: Integer): Boolean; //0x0048AD8C
var
  ChrRecordHeader: THumRecordHeader;
begin
  Result := False;
  if FileSeek(m_nFileHandle, nIndex * SizeOf(THumDataInfo) + SizeOf(THumDBHeader), 0) = -1 then Exit;
  m_nLastIndex := nIndex;
  m_dUpdateTime := Now();
  ChrRecordHeader.boDeleted := True;
  ChrRecordHeader.dCreateDate := Now();
  FileWrite(m_nFileHandle, ChrRecordHeader, SizeOf(THumRecordHeader));
  m_FileDBDeletedList.Add(Pointer(nIndex));
  m_Header.nLastIndex := m_nLastIndex;
  m_Header.dLastDate := m_dUpdateTime;
  m_Header.dUpdateDate := Now();
  FileSeek(m_nFileHandle, 0, 0);
  FileWrite(m_nFileHandle, m_Header, SizeOf(THumDBHeader));
  m_boChanged := True;
  Result := True;
end;

procedure TFileDB.Rebuild; //0x0048A688
var
  sTempFileName: string;
  nHandle, n10: Integer;
  DBHeader: THumDBHeader;
  ChrRecord: THumDataInfo;
begin
  sTempFileName := 'Mir#$00.DB';
  if FileExists(sTempFileName) then
    DeleteFile(sTempFileName);
  nHandle := FileCreate(sTempFileName);
  n10 := 0;
  if nHandle < 0 then Exit;
  try
    if Open then begin
      FileSeek(m_nFileHandle, 0, 0);
      if FileRead(m_nFileHandle, DBHeader, SizeOf(DBHeader)) = SizeOf(DBHeader) then begin
        FileWrite(nHandle, DBHeader, SizeOf(DBHeader));
        while (True) do begin
          if FileRead(m_nFileHandle, ChrRecord, SizeOf(THumDataInfo)) = SizeOf(THumDataInfo) then begin
            if ChrRecord.Header.boDeleted then Continue;
            FileWrite(nHandle, ChrRecord, SizeOf(THumDataInfo));
            Inc(n10);
          end else break;
        end;
        DBHeader.nHumCount := n10;
        DBHeader.dUpdateDate := Now();
        FileSeek(nHandle, 0, 0);
        FileWrite(nHandle, DBHeader, SizeOf(DBHeader));
      end;
    end;
  finally
    Close;
  end;
  FileClose(nHandle);
  FileCopy(sTempFileName, m_sDBFileName);
  DeleteFile(sTempFileName);
end;

function TFileDB.Count: Integer;
begin
  Result := m_Header.nHumCount;
end;

function TFileDB.Delete(sChrName: string): Boolean; //0x0048AEB4
var
  n10: Integer;
begin
  Result := False;
  n10 := m_FileDBQuickList.GetIndex(sChrName);
  if n10 < 0 then Exit;
  if DeleteRecord(Integer(m_FileDBQuickList.Objects[n10])) then begin
    m_FileDBQuickList.Delete(n10);
    Result := True;
  end;
end;



end.




