unit BasicSet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin;

type
  TFrmBasicSet = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    CheckBoxTestServer: TCheckBox;
    CheckBoxEnableMakingID: TCheckBox;
    CheckBoxEnableGetbackPassword: TCheckBox;
    CheckBoxAutoClear: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    ButtonSave: TButton;
    ButtonClose: TButton;
    SpinEditAutoClearTime: TSpinEdit;
    ButtonRestoreBasic: TButton;
    ButtonRestoreNet: TButton;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    CheckBoxDynamicIPMode: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    EditGateAddr: TEdit;
    EditGatePort: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    EditMonAddr: TEdit;
    EditMonPort: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    EditServerAddr: TEdit;
    EditServerPort: TEdit;
    GroupBox7: TGroupBox;
    CheckBoxAutoUnLockAccount: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    SpinEditUnLockAccountTime: TSpinEdit;
    procedure CheckBoxTestServerClick(Sender: TObject);
    procedure CheckBoxEnableMakingIDClick(Sender: TObject);
    procedure CheckBoxEnableGetbackPasswordClick(Sender: TObject);
    procedure CheckBoxAutoClearClick(Sender: TObject);
    procedure SpinEditAutoClearTimeChange(Sender: TObject);
    procedure CheckBoxAutoUnLockAccountClick(Sender: TObject);
    procedure SpinEditUnLockAccountTimeChange(Sender: TObject);
    procedure ButtonRestoreBasicClick(Sender: TObject);
    procedure EditGateAddrChange(Sender: TObject);
    procedure EditGatePortChange(Sender: TObject);
    procedure EditMonAddrChange(Sender: TObject);
    procedure EditMonPortChange(Sender: TObject);
    procedure EditServerAddrChange(Sender: TObject);
    procedure EditServerPortChange(Sender: TObject);
    procedure CheckBoxDynamicIPModeClick(Sender: TObject);
    procedure ButtonRestoreNetClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
  private
    { Private declarations }
    procedure LockSaveButtonEnabled();
    procedure UnLockSaveButtonEnabled();
  public
    { Public declarations }
    procedure OpenBasicSet();
  end;

var
  FrmBasicSet: TFrmBasicSet;

implementation
uses HUtil32, LSShare;
{$R *.dfm}
procedure TFrmBasicSet.LockSaveButtonEnabled();
begin
  ButtonSave.Enabled:=False;
end;

procedure TFrmBasicSet.UnLockSaveButtonEnabled();
begin
  ButtonSave.Enabled:=True;
end;

procedure TFrmBasicSet.OpenBasicSet();
begin
  CheckBoxTestServer.Checked:=g_Config.boTestServer;
  CheckBoxEnableMakingID.Checked:=g_Config.boEnableMakingID;
  CheckBoxEnableGetbackPassword.Checked:=g_Config.boEnableGetbackPassword;
  CheckBoxAutoClear.Checked:=g_Config.boAutoClearID;
  SpinEditAutoClearTime.Value:=g_Config.dwAutoClearTime;

  CheckBoxAutoUnLockAccount.Checked:=g_Config.boUnLockAccount;
  SpinEditUnLockAccountTime.Value:=g_Config.dwUnLockAccountTime;

  EditGateAddr.Text:=g_Config.sGateAddr;
  EditGatePort.Text:=IntToStr(g_Config.nGatePort);

  EditServerAddr.Text:=g_Config.sServerAddr;
  EditServerPort.Text:=IntToStr(g_Config.nServerPort);

  EditMonAddr.Text:=g_Config.sMonAddr;
  EditMonPort.Text:=IntToStr(g_Config.nMonPort);

  CheckBoxDynamicIPMode.Checked:=g_Config.boDynamicIPMode;
  LockSaveButtonEnabled();
  ShowModal;
end;

procedure TFrmBasicSet.CheckBoxTestServerClick(Sender: TObject);
begin
  g_Config.boTestServer:=CheckBoxTestServer.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.CheckBoxEnableMakingIDClick(Sender: TObject);
begin
  g_Config.boEnableMakingID:=CheckBoxEnableMakingID.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.CheckBoxEnableGetbackPasswordClick(Sender: TObject);
begin
  g_Config.boEnableGetbackPassword:=CheckBoxEnableGetbackPassword.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.CheckBoxAutoClearClick(Sender: TObject);
begin
  g_Config.boAutoClearID:=CheckBoxAutoClear.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.SpinEditAutoClearTimeChange(Sender: TObject);
begin
  g_Config.dwAutoClearTime:=SpinEditAutoClearTime.Value;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.CheckBoxAutoUnLockAccountClick(Sender: TObject);
begin
  g_Config.boUnLockAccount:=CheckBoxAutoUnLockAccount.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.SpinEditUnLockAccountTimeChange(Sender: TObject);
begin
  g_Config.dwUnLockAccountTime:=SpinEditUnLockAccountTime.Value;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.ButtonRestoreBasicClick(Sender: TObject);
begin
  CheckBoxTestServer.Checked:=True;
  CheckBoxEnableMakingID.Checked:=True;
  CheckBoxEnableGetbackPassword.Checked:=True;
  CheckBoxAutoClear.Checked:=True;
  SpinEditAutoClearTime.Value:=1;
  CheckBoxAutoUnLockAccount.Checked:=False;
  SpinEditUnLockAccountTime.Value:=10;
end;

procedure TFrmBasicSet.EditGateAddrChange(Sender: TObject);
begin
  g_Config.sGateAddr:=Trim(EditGateAddr.Text);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.EditGatePortChange(Sender: TObject);
begin
  g_Config.nGatePort:=Str_ToInt(Trim(EditGatePort.Text),5500);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.EditMonAddrChange(Sender: TObject);
begin
  g_Config.sMonAddr:=Trim(EditMonAddr.Text);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.EditMonPortChange(Sender: TObject);
begin
  g_Config.nMonPort:=Str_ToInt(Trim(EditMonPort.Text),3000);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.EditServerAddrChange(Sender: TObject);
begin
  g_Config.sServerAddr:=Trim(EditServerAddr.Text);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.EditServerPortChange(Sender: TObject);
begin
  g_Config.nServerPort:=Str_ToInt(Trim(EditServerPort.Text),5600);
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.CheckBoxDynamicIPModeClick(Sender: TObject);
begin
  g_Config.boDynamicIPMode:=CheckBoxDynamicIPMode.Checked;
  UnLockSaveButtonEnabled();
end;

procedure TFrmBasicSet.ButtonRestoreNetClick(Sender: TObject);
begin
  EditGateAddr.Text:='0.0.0.0';
  EditGatePort.Text:='5500';
  EditServerAddr.Text:='0.0.0.0';
  EditServerPort.Text:='5600';
  EditMonAddr.Text:='0.0.0.0';
  EditMonPort.Text:='3000';
  CheckBoxDynamicIPMode.Checked:=False;
end;

procedure WriteConfig();
  procedure WriteConfigString(sSection, sIdent, sDefault: string);
  begin
    g_Config.IniConf.WriteString(sSection, sIdent, sDefault);
  end;
  procedure WriteConfigInteger(sSection, sIdent: string; nDefault: Integer);
  begin
    g_Config.IniConf.WriteInteger(sSection, sIdent, nDefault);
  end;
  procedure WriteConfigBoolean(sSection, sIdent: string; boDefault: Boolean);
  begin
    g_Config.IniConf.WriteBool(sSection, sIdent, boDefault);
  end;
resourcestring
  sSectionServer = 'Server';
  sSectionDB = 'DB';
  sIdentDBServer = 'DBServer';
  sIdentFeeServer = 'FeeServer';
  sIdentLogServer = 'LogServer';
  sIdentGateAddr = 'GateAddr';
  sIdentGatePort = 'GatePort';
  sIdentServerAddr = 'ServerAddr';
  sIdentServerPort = 'ServerPort';
  sIdentMonAddr = 'MonAddr';
  sIdentMonPort = 'MonPort';
  sIdentDBSPort = 'DBSPort';
  sIdentFeePort = 'FeePort';
  sIdentLogPort = 'LogPort';
  sIdentReadyServers = 'ReadyServers';
  sIdentTestServer = 'TestServer';
  sIdentDynamicIPMode = 'DynamicIPMode';
  sIdentIdDir = 'IdDir';
  sIdentWebLogDir = 'WebLogDir';
  sIdentCountLogDir = 'CountLogDir';
  sIdentFeedIDList = 'FeedIDList';
  sIdentFeedIPList = 'FeedIPList';

  sIdentEnableGetbackPassword = 'GetbackPassword';
  sIdentAutoClearID    = 'AutoClearID';
  sIdentAutoClearTime  = 'AutoClearTime';
  sIdentUnLockAccount  = 'UnLockAccount';
  sIdentUnLockAccountTime  = 'UnLockAccountTime';
begin
  WriteConfigString(sSectionServer, sIdentDBServer, g_Config.sDBServer);
  WriteConfigString(sSectionServer, sIdentFeeServer, g_Config.sFeeServer);
  WriteConfigString(sSectionServer, sIdentLogServer, g_Config.sLogServer);

  WriteConfigString(sSectionServer, sIdentGateAddr, g_Config.sGateAddr);
  WriteConfigInteger(sSectionServer, sIdentGatePort, g_Config.nGatePort);
  WriteConfigString(sSectionServer, sIdentServerAddr, g_Config.sServerAddr);
  WriteConfigInteger(sSectionServer, sIdentServerPort, g_Config.nServerPort);
  WriteConfigString(sSectionServer, sIdentMonAddr, g_Config.sMonAddr);
  WriteConfigInteger(sSectionServer, sIdentMonPort, g_Config.nMonPort);

  WriteConfigInteger(sSectionServer, sIdentDBSPort, g_Config.nDBSPort);
  WriteConfigInteger(sSectionServer, sIdentFeePort, g_Config.nFeePort);
  WriteConfigInteger(sSectionServer, sIdentLogPort, g_Config.nLogPort);
  WriteConfigInteger(sSectionServer, sIdentReadyServers, g_Config.nReadyServers);
  WriteConfigBoolean(sSectionServer, sIdentTestServer, g_Config.boEnableMakingID);

  WriteConfigBoolean(sSectionServer, sIdentEnableGetbackPassword, g_Config.boEnableGetbackPassword);
  WriteConfigBoolean(sSectionServer, sIdentAutoClearID, g_Config.boAutoClearID);
  WriteConfigInteger(sSectionServer, sIdentAutoClearTime, g_Config.dwAutoClearTime);
  WriteConfigBoolean(sSectionServer, sIdentUnLockAccount, g_Config.boUnLockAccount);
  WriteConfigInteger(sSectionServer, sIdentUnLockAccountTime, g_Config.dwUnLockAccountTime);

  WriteConfigBoolean(sSectionServer, sIdentDynamicIPMode, g_Config.boDynamicIPMode);

  WriteConfigString(sSectionDB, sIdentIdDir, g_Config.sIdDir);
  WriteConfigString(sSectionDB, sIdentWebLogDir, g_Config.sWebLogDir);
  WriteConfigString(sSectionDB, sIdentCountLogDir, g_Config.sCountLogDir);
  WriteConfigString(sSectionDB, sIdentFeedIDList, g_Config.sFeedIDList);
  WriteConfigString(sSectionDB, sIdentFeedIPList, g_Config.sFeedIPList);
end;

procedure TFrmBasicSet.ButtonSaveClick(Sender: TObject);
begin
  WriteConfig();
  LockSaveButtonEnabled();
end;

procedure TFrmBasicSet.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

end.
