unit FrmFindId;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls, Grids, IDDB, MirGrobal,SerGrobal;
type
  TFrmFindUserId = class(TForm)
    IdGrid: TStringGrid;
    Panel1: TPanel;
    EdFindId: TEdit;
    Label1: TLabel;
    BtnFindAll: TButton;
    BtnEdit: TButton;
    Button2: TButton;
    Button1: TButton;
    SaveDialog1: TSaveDialog;

    procedure FormCreate(Sender: TObject);
    procedure BtnFindAllClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BtnEditClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EdFindIdKeyPress(Sender: TObject; var Key: Char);
  private
    procedure RefChrGrid(nIndex: Integer; var DBRecord: TIDDBRecord);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFindUserId: TFrmFindUserId;

implementation

uses EditUserInfo, LMain, MasSock, LSShare;
{$R *.DFM}
//00467AB4
procedure TFrmFindUserId.EdFindIdKeyPress(Sender: TObject; var Key: Char);
var
  sAccount: String;
  n08, nIndex: Integer;
  DBRecord: TIDDBRecord;
begin
  if Key <> #13 then exit;
  sAccount := Trim(EdFindId.Text);
  IdGrid.RowCount := 1;
  try
    if AccountDB.Open then begin
      if sAccount = '*' then begin
        for n08 := 0 to AccountDB.Count-1 do begin
          nIndex := AccountDB.Get(n08, DBRecord);
          if nIndex >= 0 then RefChrGrid(-1, DBRecord);
        end;   
      end else begin
        n08 := AccountDB.Index(sAccount);
        if n08 >= 0 then begin
          nIndex := AccountDB.Get(n08, DBRecord);
          if nIndex >= 0 then RefChrGrid(-1, DBRecord);
        end;
      end;
    end;
  finally
    AccountDB.Close;
  end;
end;

procedure TFrmFindUserId.FormCreate(Sender: TObject);
begin
  IdGrid.RowCount := 2;
  IdGrid.Cells[0, 0] := 'ʺ';
  IdGrid.Cells[1, 0] := '';
  IdGrid.Cells[2, 0] := 'û';
  IdGrid.Cells[3, 0] := '';
  IdGrid.Cells[4, 0] := 'һ';
  IdGrid.Cells[5, 0] := 'һ';
  IdGrid.Cells[6, 0] := '';
  IdGrid.Cells[7, 0] := '𰸶';
  IdGrid.Cells[8, 0] := 'ʱ';
  IdGrid.Cells[9, 0] := '¼ʱ';
  IdGrid.Cells[10, 0] := '绰';
  IdGrid.Cells[11, 0] := 'ƶ绰';
  IdGrid.Cells[12, 0] := '';
end;
//0x00467BF8
procedure TFrmFindUserId.BtnFindAllClick(Sender: TObject);
var
  sAccount: String;
  AccountList: TStringList;
  i, nIndex: Integer;
  DBRecord: TIDDBRecord;
begin
  try
    IdGrid.RowCount := 1;
    sAccount := Trim(EdFindId.Text);
    if sAccount = '' then exit;
    AccountList := TStringList.Create;
    try
      if AccountDB.Open then begin
        if AccountDB.FindByName(sAccount, AccountList) > 0 then begin
          for i := 0 to AccountList.Count - 1 do begin
            nIndex := Integer(AccountList.Objects[i]);
            if AccountDB.GetBy(nIndex, DBRecord) then begin
              RefChrGrid(-1, DBRecord);
            end;
          end;
        end;
      end;
    finally
      AccountDB.Close;
    end;
    AccountList.Free;
  except
    MainOutMessage('TFrmFindUserId.BtnFindAllClick');
  end;
end;

procedure TFrmFindUserId.Button1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then Exit;
  IdGrid.Cols[0].SaveToFile(SaveDialog1.FileName);
end;
//0x00467D84
procedure TFrmFindUserId.BtnEditClick(Sender: TObject);
var
  nRow, nIndex: Integer;
  sAccount: String;
  DBRecord: TIDDBRecord;
  bo11, bo12: Boolean;
ResourceString
  sEditAccount = 'ch2';
begin
  nRow := IdGrid.Row;
  if nRow <= 0 then exit;
  sAccount := IdGrid.Cells[0, nRow];
  if sAccount = '' then exit;
  bo11 := False;
  try
    if AccountDB.OpenEx then begin
      nIndex := AccountDB.Index(sAccount);
      if nIndex >= 0 then
        if AccountDB.Get(nIndex, DBRecord) >= 0 then bo11 := True;
    end;
  finally
    AccountDB.Close;
  end;
  if FrmUserInfoEdit.EditAccount(DBRecord) then begin
    try
      if AccountDB.Open then begin
        nIndex := AccountDB.Index(sAccount);
        if nIndex >= 0 then
          if AccountDB.Update(nIndex, DBRecord) then begin
            RefChrGrid(nRow, DBRecord);
            bo12 := True;
          end;
      end;
    finally
      AccountDB.Close;
    end;
  end;
  if bo12 then begin //00467F34
    WriteLogMsg(sEditAccount, DBRecord.UserEntry);
  end;
end;
//00467F94
procedure TFrmFindUserId.Button2Click(Sender: TObject);
var
  DBRecord: TIDDBRecord;
  sAccount: String;
  nIndex: Integer;
  boMakeSuccess: Boolean;
ResourceString
  sAddAccount = 'ch2';
  sMakingIDSuccess = 'ʺųɹ: %s';
begin
  FillChar(DBRecord, SizeOf(TIDDBRecord), #0);
  boMakeSuccess := False;
  if FrmUserInfoEdit.NewAccount(True, DBRecord) and (DBRecord.UserEntry.sLoginID <> '') then begin
    sAccount := DBRecord.UserEntry.sLoginID;
    DBRecord.Header.sAccount := sAccount;
    try
      if AccountDB.Open then begin
        nIndex := AccountDB.Index(sAccount);
        if nIndex < 0 then begin
          if AccountDB.Add(DBRecord) then boMakeSuccess := True;
        end;
      end;
    finally
      AccountDB.Close;
    end;
  end;
  if boMakeSuccess then begin
    MainOutMessage(format(sMakingIDSuccess, [sAccount]));
    WriteLogMsg(sAddAccount, DBRecord.UserEntry);
  end;
end;

procedure TFrmFindUserId.RefChrGrid(nIndex: Integer; var DBRecord: TIDDBRecord);
var
  nRow: Integer;
begin
  try
    if nIndex <= 0 then begin
      IdGrid.RowCount := IdGrid.RowCount + 1;
      IdGrid.FixedRows := 1;
      nRow := IdGrid.RowCount - 1;
    end else begin
      nRow := nIndex;
    end;
    IdGrid.Cells[0, nRow] := DBRecord.UserEntry.sLoginID;
    IdGrid.Cells[1, nRow] := DBRecord.UserEntry.sPassword;
    IdGrid.Cells[2, nRow] := DBRecord.UserEntry.sUserName;
    IdGrid.Cells[3, nRow] := DBRecord.UserEntry.sBirthDay;
    IdGrid.Cells[4, nRow] := DBRecord.UserEntry.sQuiz;
    IdGrid.Cells[5, nRow] := DBRecord.UserEntry.sAnswer;
    IdGrid.Cells[6, nRow] := DBRecord.UserEntry.sQuiz2;
    IdGrid.Cells[7, nRow] := DBRecord.UserEntry.sAnswer2;
    IdGrid.Cells[8, nRow] := DateTimeToStr(DBRecord.Header.CreateDate);
    IdGrid.Cells[9, nRow] := DateTimeToStr(DBRecord.Header.UpdateDate);
    IdGrid.Cells[10, nRow] := DBRecord.UserEntry.sPhone;
    IdGrid.Cells[11, nRow] := DBRecord.UserEntry.sMobilePhone;
    IdGrid.Cells[12, nRow] := DBRecord.UserEntry.sEMail;
  except

  end;
end;

end.

