unit LMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, WinSock,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls, JSocket, SyncObjs, Grids, Buttons, IniFiles, MudUtil, Parse,
  Menus, MirGrobal,SerGrobal , LSShare,  Common, AppEvnts,IDDB;
type
  TConnInfo = record //Size 0x20 Address: 0x00468601
    sAccount: string; //0x00
    sIPaddr: string; //0x04
    sServerName: string; //0x08
    nSessionID: Integer; //0x0C
    boPayCost: Boolean; //0x10
    bo11: Boolean; //0x11
    dwKickTick: LongWord; //0x14
    dwStartTick: LongWord; //0x18
    boKicked: Boolean; //0x1C
    nLockCount: Integer;
  end;
  pTConnInfo = ^TConnInfo;
  TGateInfo = record //Size 0x14 Address: 0x004686A0
    Socket: TCustomWinSocket; //0x00
    sIPaddr: string; //0x04
    sReceiveMsg: string; //0x08
    UserList: TList; //0x0C
    dwKeepAliveTick: LongWord; //0x10
  end;
  pTGateInfo = ^TGateInfo;
  TUserInfo = record //Size 0x68 Address: 0x004686C8
    sAccount: string; //0x00
    sUserIPaddr: string; //0x0B
    sGateIPaddr: string; //ûӵأصIP
    sSockIndex: string; //0x20
    nVersionDate: Integer; //0x24
    boCertificationOK: Boolean; //0x28

    nSessionID: Integer; //0x2C
    boPayCost: Boolean; //0x30
    nIDDay: Integer; //0x34
    nIDHour: Integer; //0x38
    nIPDay: Integer; //0x3C
    nIPHour: Integer; //0x40
    dtDateTime: TDateTime; //0x48
    boSelServer: Boolean; //0x50

    Socket: TCustomWinSocket; //0x54
    sReceiveMsg: string; //0x58
    dwTime5C: LongWord; //0x5C
    dwClientTick: LongWord; //0x64
    Gate: pTGateInfo
  end;
  pTUserInfo = ^TUserInfo;
  TFrmMain = class(TForm)
    GSocket: TServerSocket;
    ExecTimer: TTimer;
    Panel1: TPanel;
    Memo1: TMemo;
    Timer1: TTimer;
    StartTimer: TTimer;
    WebLogTimer: TTimer;
    BtnDump: TSpeedButton;
    LogTimer: TTimer;
    MonitorGrid: TStringGrid;
    Panel2: TPanel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    LbMasCount: TLabel;
    CkLogin: TCheckBox;
    CbViewLog: TCheckBox;
    BtnView: TSpeedButton;
    CountLogTimer: TTimer;
    BtnShowServerUsers: TSpeedButton;
    MonitorTimer: TTimer;
    SpeedButton2: TSpeedButton;
    MainMenu: TMainMenu;
    MENU_CONTROL: TMenuItem;
    MENU_CONTROL_EXIT: TMenuItem;
    MENU_VIEW: TMenuItem;
    MENU_OPTION: TMenuItem;
    MENU_TOOLS: TMenuItem;
    MENU_HELP: TMenuItem;
    MENU_HELP_ABOUT: TMenuItem;
    MENU_OPTION_GENERAL: TMenuItem;
    MENU_OPTION_ROUTE: TMenuItem;
    MENU_VIEW_SESSION: TMenuItem;
    N1: TMenuItem;
    C1: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    CheckBoxAttack: TCheckBox;
    CSCheckName: TClientSocket;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExecTimerTimer(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartTimerTimer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnViewClick(Sender: TObject);
    procedure CountLogTimerTimer(Sender: TObject);
    procedure BtnShowServerUsersClick(Sender: TObject);
    procedure MonitorTimerTimer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);

    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure GSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure GSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure GSocketClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure GSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure Panel2DblClick(Sender: TObject);
    procedure CbViewLogClick(Sender: TObject);
    procedure MENU_CONTROL_EXITClick(Sender: TObject);
    procedure MENU_OPTION_ROUTEClick(Sender: TObject);
    procedure MENU_VIEW_SESSIONClick(Sender: TObject);
    procedure MENU_HELP_ABOUTClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure MENU_OPTION_GENERALClick(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure CSCheckNameConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure CSCheckNameDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    SList_0344: TStringList; //0x344
    ParseList: TThreadParseList; //0x350
    procedure GameCenterGetUserAccount(sData: string);
    procedure GameCenterChangeAccountInfo(sData: string);
    procedure OpenRouteConfig();
    { Private declarations }
  public
    procedure MyMessage(var MsgData: TWmCopyData); message WM_COPYDATA;
    { Public declarations }
  end;
procedure StartService;
procedure StopService;
procedure InitializeConfig;
procedure UnInitializeConfig;
procedure LoadConfig;
procedure LoadAddrTable;
procedure GenServerNameList;

procedure WriteLogMsg(sType: string; var UserEntry: TUserEntryInfo);
procedure SaveContLogMsg(sLogMsg: string);

procedure SendGateMsg(Socket: TCustomWinSocket; sSockIndex, sMsg: string);
procedure SendGateKickMsg(Socket: TCustomWinSocket; sSockIndex: string);
procedure SendKeepAlivePacket(Socket: TCustomWinSocket);
procedure SendGateAddBlockList(Socket: TCustomWinSocket; sSockIndex: string);
procedure SendGateAddTempBlockList(Socket: TCustomWinSocket; sSockIndex: string);

procedure SessionAdd(sAccount, sIPaddr: string; nSessionID: Integer; boPayCost, bo11: Boolean);
procedure SessionDel(nSessionID: Integer);
procedure SessionKick(sLoginID: string);
procedure SessionUpdate(nSessionID: Integer; sServerName: string; boPayCost: Boolean);
procedure SessionClearKick();
function IsPayMent(sIPaddr, sAccount: string): Boolean;
procedure SessionClearNoPayMent();
function IsLogin(sLoginID: string): Boolean; overload;
function IsLogin(nSessionID: Integer): Boolean; overload;

function GetServerListInfo(): string;
procedure GetSelGateInfo(sServerName, sIPaddr: string; var sSelGateIP: string; var nSelGatePort: Integer);

function KickUser(UserInfo: pTUserInfo; nKickType: Integer): Boolean;
procedure CloseUser(sAccount: string; nSessionID: Integer);

procedure AccountCreate(UserInfo: pTUserInfo; sData: string);
procedure AccountChangePassword(UserInfo: pTUserInfo; sData: string);
procedure AccountCheckProtocol(UserInfo: pTUserInfo; nDate: Integer);
procedure AccountLogin(UserInfo: pTUserInfo; sData: string);
procedure AccountSelectServer(UserInfo: pTUserInfo; sData: string);
procedure AccountUpdateUserInfo(UserInfo: pTUserInfo; sData: string);
procedure AccountGetBackPassword(UserInfo: pTUserInfo; sData: string);

procedure ReceiveSendUser(sSockIndex: string; GateInfo: pTGateInfo; sData: string);
procedure ReceiveOpenUser(sSockIndex: string; sIPaddr: string; GateInfo: pTGateInfo);
procedure ReceiveCloseUser(sSockIndex: string; GateInfo: pTGateInfo);

procedure ProcessUserMsg(UserInfo: pTUserInfo; sMsg: string);

procedure DecodeGateData(GateInfo: pTGateInfo);
procedure DecodeUserData(UserInfo: pTUserInfo);
procedure ProcessGate();

procedure LoadAccountCostList(QuickList: TQuickList);
procedure LoadIPaddrCostList(QuickList: TQuickList);
var
  FrmMain: TFrmMain;
  AccountDB: TFileIDDB;
implementation

uses MasSock, FrmFindId, HUtil32, EDcode, GateSet,
  FAccountView, GrobalSession, BasicSet;

{$R *.DFM}
procedure TFrmMain.OpenRouteConfig;
begin
  FrmGateSetting := TFrmGateSetting.Create(nil);
  FrmGateSetting.Open;
  FrmGateSetting.Free;
end;
{
procedure TFrmMain.OpenRouteConfig;
var
  Config  :pTConfig;
begin
  Config:=@g_Config;
  if FrmGateSetting.Open then begin
    LoadAddrTable(Config);
  end;
end;
}
procedure TFrmMain.MENU_OPTION_ROUTEClick(Sender: TObject);
begin
  OpenRouteConfig();
end;

procedure TFrmMain.MENU_VIEW_SESSIONClick(Sender: TObject);
begin
  frmGrobalSession := TfrmGrobalSession.Create(nil);
  frmGrobalSession.Open;
  frmGrobalSession.Free;
end;

procedure TFrmMain.CbViewLogClick(Sender: TObject);
begin
  g_Config.boShowDetailMsg := CbViewLog.Checked;
end;

procedure TFrmMain.GSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  GateInfo: pTGateInfo;
begin
  if not ExecTimer.Enabled then begin
    Socket.Close;
    Exit;
  end;
  New(GateInfo);
  GateInfo.Socket := Socket;
  GateInfo.sIPaddr := GetGatePublicAddr( Socket.RemoteAddress);
  GateInfo.sReceiveMsg := '';
  GateInfo.UserList := TList.Create;
  GateInfo.dwKeepAliveTick := GetTickCount();
  EnterCriticalSection(g_Config.GateCriticalSection);
  try
    g_Config.GateList.Add(GateInfo);
  finally
    LeaveCriticalSection(g_Config.GateCriticalSection);
  end;
end;

procedure TFrmMain.GSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  I: Integer;
  II: Integer;
  GateInfo: pTGateInfo;
  UserInfo: pTUserInfo;
begin
  EnterCriticalSection(g_Config.GateCriticalSection);
  try
    for I := 0 to g_Config.GateList.Count - 1 do begin
      GateInfo := g_Config.GateList.Items[I];
      if GateInfo.Socket = Socket then begin
        for II := 0 to GateInfo.UserList.Count - 1 do begin
          UserInfo := GateInfo.UserList.Items[II];
          if g_Config.boShowDetailMsg then
            MainOutMessage('Close: ' + UserInfo.sUserIPaddr);
          Dispose(UserInfo);
        end;
        GateInfo.UserList.Free;
        Dispose(GateInfo);
        g_Config.GateList.Delete(I);
        break;
      end;
    end;
  finally
    LeaveCriticalSection(g_Config.GateCriticalSection);
  end;
end;

procedure TFrmMain.GSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
  Socket.Close;
end;

procedure TFrmMain.GSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  I: Integer;
  GateInfo: pTGateInfo;
begin
  EnterCriticalSection(g_Config.GateCriticalSection);
  try
    for I := 0 to g_Config.GateList.Count - 1 do begin
      GateInfo := g_Config.GateList.Items[I];
      if GateInfo.Socket = Socket then begin
        GateInfo.sReceiveMsg := GateInfo.sReceiveMsg + Socket.ReceiveText;
        break;
      end;
    end;
  finally
    LeaveCriticalSection(g_Config.GateCriticalSection);
  end;
end;

procedure LoadAddrTable();
var
  LoadList: TStringList;
  sFileName: string;
  I: Integer;
  nRouteIdx: Integer;
  nSelGateIdx: Integer;
  sLineText, sTitle, sServerName, sGate, sRemote, sPublic, sGatePort: string;
  II: Integer;
begin
  g_Config.ServerNameList.Clear;
  for I := Low(g_Config.GateRoute) to High(g_Config.GateRoute) do begin
    g_Config.GateRoute[I].sServerName := '';
    g_Config.GateRoute[I].sTitle := '';
    g_Config.GateRoute[I].sRemoteAddr := '';
    g_Config.GateRoute[I].sPublicAddr := '';
    g_Config.GateRoute[I].nSelIdx := 0;
    for II := Low(g_Config.GateRoute[I].Gate) to High(g_Config.GateRoute[I].Gate) do begin
      g_Config.GateRoute[I].Gate[II].sIPaddr := '';
      g_Config.GateRoute[I].Gate[II].nPort := 0;
      g_Config.GateRoute[I].Gate[II].boEnable := False;
    end;
  end;

  sFileName := '.\!addrtable.txt';
  LoadList := TStringList.Create;
  if FileExists(sFileName) then begin
    LoadList.LoadFromFile(sFileName);
    nRouteIdx := 0;
    for I := 0 to LoadList.Count - 1 do begin
      sLineText := LoadList.Strings[I];
      if (sLineText <> '') and (sLineText[1] <> ';') then begin
        sLineText := GetValidStr3(sLineText, sServerName, [' ']);
        sLineText := GetValidStr3(sLineText, sTitle, [' ']);
        sLineText := GetValidStr3(sLineText, sRemote, [' ']);
        sLineText := GetValidStr3(sLineText, sPublic, [' ']);
        sLineText := Trim(sLineText);
        if (sTitle <> '') and (sRemote <> '') and (sPublic <> '') and (nRouteIdx < MAXGATEROUTE) then begin
          g_Config.GateRoute[nRouteIdx].sServerName := sServerName;
          g_Config.GateRoute[nRouteIdx].sTitle := sTitle;
          g_Config.GateRoute[nRouteIdx].sRemoteAddr := sRemote;
          g_Config.GateRoute[nRouteIdx].sPublicAddr := sPublic;
          nSelGateIdx := 0;
          while (sLineText <> '') do begin
            if nSelGateIdx > 9 then break;
            sLineText := GetValidStr3(sLineText, sGate, [' ']);
            if sGate <> '' then begin
              if sGate[1] = '*' then begin
                sGate := Copy(sGate, 2, length(sGate) - 1);
                g_Config.GateRoute[nRouteIdx].Gate[nSelGateIdx].boEnable := False;
              end else begin
                g_Config.GateRoute[nRouteIdx].Gate[nSelGateIdx].boEnable := True;
              end;
              sGatePort := GetValidStr3(sGate, sGate, [':']);
              g_Config.GateRoute[nRouteIdx].Gate[nSelGateIdx].sIPaddr := sGate;
              g_Config.GateRoute[nRouteIdx].Gate[nSelGateIdx].nPort := Str_ToInt(sGatePort, 0);
              g_Config.GateRoute[nRouteIdx].nSelIdx := 0;
              Inc(nSelGateIdx);
            end;
            sLineText := Trim(sLineText);
          end;
          Inc(nRouteIdx);
        end;
      end;
    end;
    g_Config.nRouteCount := nRouteIdx;
  end;
  LoadList.Free;
  GenServerNameList;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var
  nX, nY: Integer;
begin
  g_dwGameCenterHandle := Str_ToInt(ParamStr(1), 0);
  nX := Str_ToInt(ParamStr(2), -1);
  nY := Str_ToInt(ParamStr(3), -1);
  if (nX >= 0) or (nY >= 0) then begin
    Left := nX;
    Top := nY;
  end;
  g_Config.boRemoteClose := False;
  SendGameCenterMsg(SG_FORMHANDLE, IntToStr(Self.Handle));

  CSCheckName.Port := g_Config.nCSCheckNamePort;
  CSCheckName.Address :=g_Config.sCSCheckNameAddr;
  
  StartService;

  AccountDB := nil;
  //  g_MainMsgList:=TStringList.Create;
  CS_DB := TCriticalSection.Create;
  StringList_0 := TStringList.Create;
  nSessionIdx := 1;
  n47328C := 1;
  nMemoHeigh := Memo1.Height;

  AttackIPaddrList := TGList.Create;

  g_Config.GateList := TList.Create;
  g_Config.SessionList := TGList.Create;
  g_Config.ServerNameList := TStringList.Create;
  SList_0344 := TStringList.Create;
  g_Config.AccountCostList := TQuickList.Create;
  g_Config.IPaddrCostList := TQuickList.Create;
  ParseList := TThreadParseList.Create(True);

  LoadAddrTable;
  MonitorGrid.Cells[0, 0] := '';
  MonitorGrid.Cells[1, 0] := 'û';
  MonitorGrid.Cells[2, 0] := '״̬';
  MonitorGrid.Cells[3, 0] := '';
  MonitorGrid.Cells[4, 0] := 'û';
  MonitorGrid.Cells[5, 0] := '״̬';
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
var
  I, II: Integer;
  GateInfo: pTGateInfo;
  UserInfo: pTUserInfo;
  IPList: TList;
begin
  StopService;
  if AccountDB <> nil then AccountDB.Free;
  for I := 0 to g_Config.GateList.Count - 1 do begin
    GateInfo := g_Config.GateList.Items[I];
    for II := 0 to GateInfo.UserList.Count - 1 do begin
      UserInfo := GateInfo.UserList.Items[I];
      Dispose(UserInfo);
    end;
    GateInfo.UserList.Free;
    Dispose(GateInfo);
  end;
  g_Config.GateList.Free;
  g_Config.SessionList.Free;
  g_Config.ServerNameList.Free;

  AttackIPaddrList.Lock;
  try
    for I := 0 to AttackIPaddrList.Count - 1 do begin
      Dispose(pTSockaddr(AttackIPaddrList.Items[I]));
    end;
  finally
    AttackIPaddrList.UnLock;
    AttackIPaddrList.Free;
  end;

  SList_0344.Free;
  StringList_0.Free;
  CS_DB.Free;
end;

procedure TFrmMain.ExecTimerTimer(Sender: TObject);
var
  ConnInfo: pTConnInfo;
begin
  if bo470D20 and not g_boDataDBReady then Exit;
  bo470D20 := True;
  try
    ProcessGate;
    {if (Config.SessionList<>nil) and (Config.SessionList.Count>0) then begin
      ConnInfo:=pTConnInfo(Config.SessionList.Items[0]);
      Memo1.Lines.Add(ConnInfo.sAccount);
    end;}
  finally
    bo470D20 := False;
  end;
end;

procedure TFrmMain.Memo1DblClick(Sender: TObject);
begin
  OpenRouteConfig();
end;

procedure TFrmMain.Timer1Timer(Sender: TObject);
var
  I: Integer;
begin
  Label1.Caption := IntToStr(g_Config.dwProcessGateTime);
  CkLogin.Checked := GSocket.Socket.Connected;
  CkLogin.Caption := ' (' + IntToStr(GSocket.Socket.ActiveConnections) + ')';
  LbMasCount.Caption := IntToStr(nOnlineCountMin) + '/' + IntToStr(nOnlineCountMax);
  if Memo1.Lines.Count > 200 then Memo1.Clear;
  EnterCriticalSection(g_OutMessageCS);
  try
    for I := 0 to g_MainMsgList.Count - 1 do begin
      Memo1.Lines.Add(g_MainMsgList.Strings[I]);
    end;
    g_MainMsgList.Clear;
  finally
    LeaveCriticalSection(g_OutMessageCS);
  end;
  I := 0;
  while (True) do begin
    if StringList_0.Count <= I then break;
    if GetTickCount - LongWord(StringList_0.Objects[I]) > 60000 then begin
      StringList_0.Delete(I);
      Continue;
    end;
    Inc(I);
  end;
  SessionClearKick;
  SessionClearNoPayMent;
end;

procedure TFrmMain.StartTimerTimer(Sender: TObject);
begin
  StartTimer.Enabled := False;
  SendGameCenterMsg(SG_STARTNOW, '¼...');
  Memo1.Lines.Add('1) ...');
  Application.ProcessMessages;
  AccountDB := TFileIDDB.Create(g_Config.sIdDir + 'Id.DB');
  ParseList.Resume;
  Memo1.Lines.Add('2) ڵȴ...');
  while (True) do begin
    Application.ProcessMessages;
    if Application.Terminated then Exit;
    if FrmMasSoc.CheckReadyServers then break;
    Sleep(1);
  end;
  GSocket.Active := False;
  GSocket.Address := g_Config.sGateAddr;
  GSocket.Port := g_Config.nGatePort;
  GSocket.Active := True;
  Memo1.Lines.Add('3) ...');
  ExecTimer.Enabled := True;
  SendGameCenterMsg(SG_STARTOK, '¼...');
end;

procedure TFrmMain.SpeedButton1Click(Sender: TObject);
begin
  FrmFindUserId.Top := Top;
  FrmFindUserId.Left := Left;
  FrmFindUserId.Show;
end;

procedure TFrmMain.MENU_CONTROL_EXITClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
resourcestring
  sExitMsg = 'Ƿȷֹͣ¼ ?';
  sExitTitle = 'ȷϢ';
begin
  if g_Config.boRemoteClose then Exit;
  if MessageBox(Handle, PChar(sExitMsg), PChar(sExitTitle), MB_YESNO + MB_ICONQUESTION) = mrYes then
    CanClose := True
  else CanClose := False;
end;

procedure TFrmMain.BtnViewClick(Sender: TObject);
begin
  try
    CS_DB.Enter;
    FrmAccountView.ListBox1.Items := g_Config.AccountCostList;
    FrmAccountView.ListBox2.Items := g_Config.IPaddrCostList;
  finally
    CS_DB.Leave;
  end;
  FrmAccountView.Top := Top;
  FrmAccountView.Left := Left;
  FrmAccountView.ShowModal;
end;

procedure TFrmMain.CountLogTimerTimer(Sender: TObject);
var
  sLogMsg: string;
resourcestring
  sFormatMsg = '%d/%d';
begin
  sLogMsg := format(sFormatMsg, [nOnlineCountMin, nOnlineCountMax]);
  SaveContLogMsg(sLogMsg);
  nOnlineCountMax := 0;
end;

procedure TFrmMain.BtnShowServerUsersClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to nUserLimit - 1 do begin
    MainOutMessage(UserLimit[I].sServerName + ' ' + IntToStr(UserLimit[I].nLimitCountMin) + '/' + IntToStr(UserLimit[I].nLimitCountMax));
  end;
end;

procedure TFrmMain.MonitorTimerTimer(Sender: TObject);
var
  I: Integer;
  nCol: Integer;
  sServerName: string;
  ServerList: TList;
  MsgServer: pTMsgServerInfo;
begin
  CSCheckName.Open;
  try
    ServerList := FrmMasSoc.m_ServerList;
    if (ServerList.Count div 2) < 2 then begin
      MonitorGrid.RowCount := 2;
      MonitorGrid.Cells[0, 1] := '';
      MonitorGrid.Cells[1, 1] := '';
      MonitorGrid.Cells[2, 1] := '';
      MonitorGrid.Cells[3, 1] := '';
      MonitorGrid.Cells[4, 1] := '';
      MonitorGrid.Cells[5, 1] := '';
    end else begin
      MonitorGrid.RowCount := ((ServerList.Count div 2) + 1) + (ServerList.Count mod 2);
    end; //0046ED54
    for I := 0 to ServerList.Count - 1 do begin
      nCol := (I mod 2) * 3;
      MsgServer := ServerList.Items[I];
      sServerName := MsgServer.sServerName;
      if sServerName <> '' then begin
        if MsgServer.nServerIndex = 99 then
          MonitorGrid.Cells[nCol, (I div 2 + 1)] := sServerName + ' [DB]'
        else MonitorGrid.Cells[nCol, (I div 2 + 1)] := sServerName + ' ' + IntToStr(MsgServer.nServerIndex);
        MonitorGrid.Cells[nCol + 1, (I div 2 + 1)] := IntToStr(MsgServer.nOnlineCount);
        if (GetTickCount - MsgServer.dwKeepAliveTick) < 30000 then
          MonitorGrid.Cells[nCol + 2, (I div 2 + 1)] := ''
        else MonitorGrid.Cells[nCol + 2, (I div 2 + 1)] := 'ʱ';
      end else begin //0046EEF2
        MonitorGrid.Cells[nCol, (I div 2 + 1)] := '-';
        MonitorGrid.Cells[nCol + 1, (I div 2 + 1)] := '-';
        MonitorGrid.Cells[nCol + 2, (I div 2 + 1)] := '-';
      end;
    end;
  except
    MainOutMessage('TFrmMain.MonitorTimerTimer');
  end;
end;

procedure TFrmMain.SpeedButton2Click(Sender: TObject);
begin
  if Memo1.Height = nMemoHeigh then Memo1.Height := nMemoHeigh * 3
  else Memo1.Height := nMemoHeigh;
end;

function IsPayMent(sIPaddr, sAccount: string): Boolean;
begin
  Result := False;
  try
    CS_DB.Enter;
    if (g_Config.AccountCostList.GetIndex(sAccount) >= 0) or (g_Config.IPaddrCostList.GetIndex(sIPaddr) >= 0) then
      Result := True;
  finally
    CS_DB.Leave;
  end;
end;

procedure CloseUser(sAccount: string; nSessionID: Integer);
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  g_Config.SessionList.Lock;
  try
    for I := g_Config.SessionList.Count - 1 downto 0 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if (ConnInfo.sAccount = sAccount) or (ConnInfo.nSessionID = nSessionID) then begin
        FrmMasSoc.SendServerMsg(SS_CLOSESESSION, ConnInfo.sServerName, ConnInfo.sAccount + '/' + IntToStr(ConnInfo.nSessionID));
        Dispose(ConnInfo);
        g_Config.SessionList.Delete(I);
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure ProcessGate();
var
  I: Integer;
  II: Integer;
  GateInfo: pTGateInfo;
  UserInfo: pTUserInfo;
begin
  EnterCriticalSection(g_Config.GateCriticalSection);
  try
    g_Config.dwProcessGateTick := GetTickCount();
    I := 0;
    while (True) do begin
      if g_Config.GateList.Count <= I then break;
      GateInfo := g_Config.GateList.Items[I];
      if GateInfo.sReceiveMsg <> '' then begin
        DecodeGateData(GateInfo);
        g_Config.sGateIPaddr := GateInfo.sIPaddr;
        II := 0;
        while (True) do begin
          if GateInfo.UserList.Count <= II then break;
          UserInfo := GateInfo.UserList.Items[II];
          if UserInfo.sReceiveMsg <> '' then DecodeUserData(UserInfo);
          Inc(II);
        end;
      end;
      Inc(I);
    end;
    if g_Config.dwProcessGateTime < g_Config.dwProcessGateTick then
      g_Config.dwProcessGateTime := GetTickCount - g_Config.dwProcessGateTick;
    if g_Config.dwProcessGateTime > 100 then Dec(g_Config.dwProcessGateTime, 100);
  finally
    LeaveCriticalSection(g_Config.GateCriticalSection);
  end;
end;

procedure DecodeGateData(GateInfo: pTGateInfo);
var
  nCount: Integer;
  sMsg: string;
  sSockIndex: string;
  sData: string;
  Code: Char;
begin
  try
    nCount := 0;
    while (True) do begin
      if TagCount(GateInfo.sReceiveMsg, '$') <= 0 then break;
      GateInfo.sReceiveMsg := ArrestStringEx(GateInfo.sReceiveMsg, '%', '$', sMsg);
      if sMsg <> '' then begin
        Code := sMsg[1];
        sMsg := Copy(sMsg, 2, length(sMsg) - 1);
        case Code of
          '-': begin
              SendKeepAlivePacket(GateInfo.Socket);
              GateInfo.dwKeepAliveTick := GetTickCount();
            end;
          'D': begin
              sData := GetValidStr3(sMsg, sSockIndex, ['/']);
              ReceiveSendUser(sSockIndex, GateInfo, sData);
            end;
          'N': begin
              sData := GetValidStr3(sMsg, sSockIndex, ['/']);
              ReceiveOpenUser(sSockIndex, sData, GateInfo);
            end;
          'C': begin
              sSockIndex := sMsg;
              ReceiveCloseUser(sSockIndex, GateInfo);
            end;
        end;
      end else begin
        if nCount >= 1 then GateInfo.sReceiveMsg := '';
        Inc(nCount);
      end;
    end;
  except
    MainOutMessage('[Exception] TFrmMain.DecodeGateData');
  end;
end;

procedure SendKeepAlivePacket(Socket: TCustomWinSocket);
begin
  if Socket.Connected then Socket.SendText('%++$');
end;

procedure ReceiveCloseUser(sSockIndex: string;
  GateInfo: pTGateInfo);
var
  UserInfo: pTUserInfo;
  IPaddr: pTSockaddr;
  I, II: Integer;
  nIPaddr: Integer;
  IPList: TList;
resourcestring
  sCloseMsg = 'Close: %s';
begin
  for I := 0 to GateInfo.UserList.Count - 1 do begin
    UserInfo := GateInfo.UserList.Items[I];
    if UserInfo.sSockIndex = sSockIndex then begin
      if g_Config.boShowDetailMsg then
        MainOutMessage(format(sCloseMsg, [UserInfo.sUserIPaddr]));
      if not UserInfo.boSelServer then SessionDel(UserInfo.nSessionID);
      Dispose(UserInfo);
      GateInfo.UserList.Delete(I);
      break;
    end;
  end;
end;

procedure ReceiveOpenUser(sSockIndex, sIPaddr: string;
  GateInfo: pTGateInfo);
var
  UserInfo: pTUserInfo;
  I: Integer;
  sGateIPaddr: string;
  sUserIPaddr: string;
resourcestring
  sOpenMsg = 'Open: %s/%s';
begin
  sGateIPaddr := GetValidStr3(sIPaddr, sUserIPaddr, ['/']);
  try
    for I := 0 to GateInfo.UserList.Count - 1 do begin
      UserInfo := GateInfo.UserList.Items[I];
      if UserInfo.sSockIndex = sSockIndex then begin
        UserInfo.sUserIPaddr := sUserIPaddr;
        UserInfo.sGateIPaddr := sGateIPaddr;
        UserInfo.sAccount := '';
        UserInfo.nSessionID := 0;
        UserInfo.sReceiveMsg := '';
        UserInfo.dwTime5C := GetTickCount();
        UserInfo.dwClientTick := GetTickCount();
        Exit;
      end;
    end;
    New(UserInfo);
    UserInfo.sAccount := '';
    UserInfo.sUserIPaddr := sUserIPaddr;
    UserInfo.sGateIPaddr := sGateIPaddr;
    UserInfo.sSockIndex := sSockIndex;
    UserInfo.nVersionDate := 0;
    UserInfo.boCertificationOK := False;
    UserInfo.nSessionID := 0;

    UserInfo.Socket := GateInfo.Socket;
    UserInfo.sReceiveMsg := '';
    UserInfo.dwTime5C := GetTickCount();
    UserInfo.dwClientTick := GetTickCount();

    UserInfo.Gate := GateInfo;
    GateInfo.UserList.Add(UserInfo);
    if g_Config.boShowDetailMsg then
      MainOutMessage(format(sOpenMsg, [sUserIPaddr, sGateIPaddr]));
  except
    MainOutMessage('TFrmMain.ReceiveOpenUser');
  end;
end;

procedure ReceiveSendUser(sSockIndex: string;
  GateInfo: pTGateInfo; sData: string);
var
  UserInfo: pTUserInfo;
  I: Integer;
begin
  try
    for I := 0 to GateInfo.UserList.Count - 1 do begin
      UserInfo := GateInfo.UserList.Items[I];
      if UserInfo.sSockIndex = sSockIndex then begin
        if length(UserInfo.sReceiveMsg) < 4069 then begin
          UserInfo.sReceiveMsg := UserInfo.sReceiveMsg + sData;
        end;
        break;
      end;
    end;
  except
    MainOutMessage('TFrmMain.ReceiveSendUser');
  end;
end;

procedure SessionClearKick();
var
  I: Integer;
  ConnInfo: pTConnInfo;
begin
  g_Config.SessionList.Lock;
  try
    for I := g_Config.SessionList.Count - 1 downto 0 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if ConnInfo.boKicked and ((GetTickCount - ConnInfo.dwKickTick) > 5 * 1000) then begin
        Dispose(ConnInfo);
        g_Config.SessionList.Delete(I);
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure DecodeUserData(UserInfo: pTUserInfo);
var
  sMsg: string;
  nCount: Integer;
begin
  nCount := 0;
  try
    //if UserInfo = nil then nErrCode:=1;
    while (True) do begin
      if TagCount(UserInfo.sReceiveMsg, '!') <= 0 then break;
      UserInfo.sReceiveMsg := ArrestStringEx(UserInfo.sReceiveMsg, '#', '!', sMsg);
      if sMsg <> '' then begin
        if length(sMsg) >= DEFBLOCKSIZE + 1 then begin
          sMsg := Copy(sMsg, 2, length(sMsg) - 1);
          ProcessUserMsg(UserInfo, sMsg);
        end;
      end else begin
        if nCount >= 1 then UserInfo.sReceiveMsg := '';
        Inc(nCount);
      end;
      if UserInfo.sReceiveMsg = '' then break;
    end;
  except
    MainOutMessage('[Exception] TFrmMain.DecodeUserData ');
  end;
end;

procedure SessionDel(nSessionID: Integer);
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  g_Config.SessionList.Lock;
  try
    for I := 0 to g_Config.SessionList.Count - 1 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if ConnInfo.nSessionID = nSessionID then begin
        Dispose(ConnInfo);
        g_Config.SessionList.Delete(I);
        break;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure ProcessUserMsg(UserInfo: pTUserInfo; sMsg: string);
var
  sDefMsg: string;
  sData: string;
  DefMsg: TDefaultMessage;
begin
  try
    sDefMsg := Copy(sMsg, 1, DEFBLOCKSIZE);
    sData := Copy(sMsg, DEFBLOCKSIZE + 1, length(sMsg) - DEFBLOCKSIZE);
    DefMsg := DecodeMessage(sDefMsg);
    //AddLogMsg('Code: ' + IntToStr(DefMsg.Ident) + ' Msg: ' + sData,0);
    case DefMsg.Ident of
      CM_SelectServer: begin
          if not UserInfo.boSelServer then begin
            AccountSelectServer( UserInfo, sData);
          end;
        end;
      CM_PROTOCOL: begin
          AccountCheckProtocol(UserInfo, DefMsg.Recog);
        end;
      CM_AccountLogin: begin
          if UserInfo.sAccount = '' then begin
            AccountLogin( UserInfo, sData);
          end else begin
            KickUser( UserInfo, 0);
          end;
        end;
      CM_AccountCreate: begin
          if g_Config.boEnableMakingID then begin
            if (GetTickCount - UserInfo.dwClientTick) > 5000 then begin
              UserInfo.dwClientTick := GetTickCount();
              AccountCreate( UserInfo, sData);
            end else begin
              if FrmMain.CheckBoxAttack.Checked then begin
                if AddAttackIP(UserInfo.sUserIPaddr) then
                 KickUser(UserInfo, 2);
              end;
              MainOutMessage('[ٲ] ʺ ' + '/' + UserInfo.sUserIPaddr);
            end;
          end;
        end;
      CM_ChangeAccountPassword: begin
          if UserInfo.sAccount = '' then begin
            if (GetTickCount - UserInfo.dwClientTick) > 5000 then begin
              UserInfo.dwClientTick := GetTickCount();
              AccountChangePassword(UserInfo, sData);
            end else begin
              if FrmMain.CheckBoxAttack.Checked then begin
                if AddAttackIP(UserInfo.sUserIPaddr) then KickUser(UserInfo, 1);
              end;
              MainOutMessage('[ٲ] ޸ ' + '/' + UserInfo.sUserIPaddr);
            end;
          end else UserInfo.sAccount := '';
        end;
      CM_UPDATEUSER: begin
          if (GetTickCount - UserInfo.dwClientTick) > 5000 then begin
            UserInfo.dwClientTick := GetTickCount();
            AccountUpdateUserInfo(UserInfo, sData);
          end else begin
            if FrmMain.CheckBoxAttack.Checked then begin
              if AddAttackIP(UserInfo.sUserIPaddr) then
              KickUser(UserInfo, 1);
            end;
            MainOutMessage('[ٲ] ʺ ' + '/' + UserInfo.sUserIPaddr);
          end;
        end;
      CM_GETBACKPASSWORD: begin
          if g_Config.boEnableGetbackPassword then begin
            if (GetTickCount - UserInfo.dwClientTick) > 5000 then begin
              UserInfo.dwClientTick := GetTickCount();
              AccountGetBackPassword(UserInfo, sData);
            end else begin
              if FrmMain.CheckBoxAttack.Checked then begin
                if AddAttackIP(UserInfo.sUserIPaddr) then
                  KickUser(UserInfo, 1);
              end;
              MainOutMessage('[ٲ] һ ' + '/' + UserInfo.sUserIPaddr);
            end;
          end;
        end;
    end;
  except
    MainOutMessage('[Exception] TFrmMain.ProcessUserMsg ' + 'wIdent: ' + IntToStr(DefMsg.Ident) + ' sData: ' + sData);
  end;
end;

procedure AccountCreate(UserInfo: pTUserInfo; sData: string);
var
  UserEntry: TUserEntryInfo;
  DBRecord: TIDDBRecord;
  nErrCode: Integer;
  DefMsg: TDefaultMessage;
  n10: Integer;
resourcestring
  sAddNewuserFail = '[½ʺʧ] %s/%s';
  sLogNewFlag = 'new';
begin
  try
    nErrCode := -1;
    FillChar(UserEntry, SizeOf(TUserEntryInfo), #0);
    if (sData <> '')then begin
      DecodeBuffer(sData, @UserEntry, SizeOf(TUserEntryInfo));
      if CheckAccountName(UserEntry.sLoginID) then begin
        try
          if AccountDB.Open then begin
            n10 := AccountDB.Index(UserEntry.sLoginID);
            if n10 < 0 then begin
              FillChar(DBRecord, SizeOf(TIDDBRecord), #0);
              DBRecord.UserEntry := UserEntry;
              if UserEntry.sLoginID <> '' then begin
                if AccountDB.Add(DBRecord) then begin
                  nErrCode := 1;
                end;
              end;
            end else nErrCode := 0;
          end;
        finally
          AccountDB.Close;
        end;
      end else begin
        MainOutMessage(format(sAddNewuserFail, [UserEntry.sLoginID, UserEntry.sUserName]));
      end;
    end;
    if nErrCode = 1 then begin
      WriteLogMsg(sLogNewFlag, UserEntry);
      DefMsg := MakeDefaultMsg(SM_NEWID_SUCCESS, 0, 0, 0, 0);
    end else begin
      DefMsg := MakeDefaultMsg(SM_NEWID_FAIL, nErrCode, 0, 0, 0);
    end;
    SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
  except
    MainOutMessage('TFrmMain.AddNewUser');
  end;
end;

procedure AccountChangePassword(UserInfo: pTUserInfo; sData: string);
var
  sMsg: string;
  sLoginID: string;
  sOldPassword: string;
  sNewPassword: string;
  DefMsg: TDefaultMessage;
  nCode: Integer;
  n10: Integer;
  DBRecord: TIDDBRecord;
resourcestring
  sChgMsg = 'chg';
begin
  try
    sMsg := DecodeString(sData);
    sMsg := GetValidStr3(sMsg, sLoginID, [#9]);
    sNewPassword := GetValidStr3(sMsg, sOldPassword, [#9]);
    nCode := 0;
    try
      if AccountDB.Open and (length(sNewPassword) >= 3) then begin
        n10 := AccountDB.Index(sLoginID);
        if (n10 >= 0) and (AccountDB.Get(n10, DBRecord) >= 0) then begin
          //if (DBRecord.nErrorCount >= 5) or ((GetTickCount - DBRecord.dwActionTick) > 180000) then begin
          if (DBRecord.nErrorCount < 5) or ((GetTickCount - DBRecord.dwActionTick) > 180000) then begin
            if DBRecord.UserEntry.sPassword = sOldPassword then begin
              DBRecord.nErrorCount := 0;
              DBRecord.UserEntry.sPassword := sNewPassword;
              nCode := 1;
            end else begin
              Inc(DBRecord.nErrorCount);
              DBRecord.dwActionTick := GetTickCount();
              nCode := -1;
            end;
            AccountDB.Update(n10, DBRecord);
          end else begin
            nCode := -2;
            if GetTickCount < DBRecord.dwActionTick then begin
              DBRecord.dwActionTick := GetTickCount();
              AccountDB.Update(n10, DBRecord);
            end;
          end;
        end;
      end;
    finally
      AccountDB.Close;
    end;
    if nCode = 1 then begin
      DefMsg := MakeDefaultMsg(SM_CHGPASSWD_SUCCESS, 0, 0, 0, 0);
      WriteLogMsg(sChgMsg, DBRecord.UserEntry);
    end else begin
      DefMsg := MakeDefaultMsg(SM_CHGPASSWD_FAIL, nCode, 0, 0, 0);
    end;
    SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
  except
    MainOutMessage('TFrmMain.ChangePassword');
  end;
end;

procedure AccountCheckProtocol(UserInfo: pTUserInfo; nDate: Integer);
var
  DefMsg: TDefaultMessage;
begin
  //MainOutMessage(IntToStr(nVersionDate));
  if nDate < nVersionDate then begin
    DefMsg := MakeDefaultMsg(SM_CERTIFICATION_FAIL, 0, 0, 0, 0);
  end else begin
    DefMsg := MakeDefaultMsg(SM_CERTIFICATION_SUCCESS, 0, 0, 0, 0);
    UserInfo.nVersionDate := nDate;
    UserInfo.boCertificationOK := True;
  end;
  SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
end;

function KickUser(UserInfo: pTUserInfo; nKickType: Integer): Boolean;
var
  I: Integer;
  II: Integer;
  GateInfo: pTGateInfo;
  User: pTUserInfo;
resourcestring
  sKickMsg = 'Kick: %s';
begin
  Result := False;
  EnterCriticalSection(g_Config.GateCriticalSection);
  try
    for I := 0 to g_Config.GateList.Count - 1 do begin
      GateInfo := g_Config.GateList.Items[I];
      for II := 0 to GateInfo.UserList.Count - 1 do begin
        User := GateInfo.UserList.Items[II];
        if User = UserInfo then begin
          if g_Config.boShowDetailMsg then
            MainOutMessage(format(sKickMsg, [UserInfo.sUserIPaddr]));
          case nKickType of
            0: SendGateKickMsg(GateInfo.Socket, UserInfo.sSockIndex);
            1: SendGateAddTempBlockList(GateInfo.Socket, UserInfo.sSockIndex);
            2: SendGateAddBlockList(GateInfo.Socket, UserInfo.sSockIndex);
          end;
          Dispose(UserInfo);
          GateInfo.UserList.Delete(II);
          Result := True;
          Exit;
        end;
      end;
    end;
  finally
    LeaveCriticalSection(g_Config.GateCriticalSection);
  end;
end;

procedure AccountLogin(UserInfo: pTUserInfo; sData: string);
var
  sLoginID: string;
  sPassword: string;
  nCode: Integer;
  DefMsg: TDefaultMessage;
  UserEntry: TUserEntryInfo;
  nIDCost: Integer;
  nIPCost: Integer;
  nIDCostIndex: Integer;
  nIPCostIndex: Integer;
  DBRecord: TIDDBRecord;
  n10: Integer;
  boPayCost: Boolean;
  sServerName: string;
begin
  try
    sPassword := GetValidStr3(DecodeString(sData), sLoginID, ['/']);
    MainOutMessage('Login:'+sLoginID);
    nCode := 0;
    try
      if AccountDB.Open then begin
        n10 := AccountDB.Index(sLoginID);
        if (n10 >= 0) and (AccountDB.Get(n10, DBRecord) >= 0) then begin
          {Զ˺}
          if (g_Config.boUnLockAccount) and (DBRecord.nErrorCount >= 5) and
          ((GetTickCount - DBRecord.dwActionTick) >= g_Config.dwUnLockAccountTime * 60 * 1000) then begin
            DBRecord.nErrorCount := 0;
            DBRecord.dwActionTick := 0;
            DBRecord.dwActionTick := GetTickCount - 70000;
          end;

          if (DBRecord.nErrorCount < 5) or
          ((GetTickCount - DBRecord.dwActionTick) > 60000) then begin
            if DBRecord.UserEntry.sPassword = sPassword then begin
              DBRecord.nErrorCount := 0;
              nCode := 1;
            end else begin
              Inc(DBRecord.nErrorCount);
              DBRecord.dwActionTick := GetTickCount();
              nCode := -1;
            end;
            AccountDB.Update(n10, DBRecord);
          end else begin
            nCode := -2;
            DBRecord.dwActionTick := GetTickCount();
            DBRecord.Header.UpdateDate := Now;
            AccountDB.Update(n10, DBRecord);
          end;
        end;
      end;
    finally
      AccountDB.Close;
    end;
    if (nCode = 1) and IsLogin(sLoginID) then begin
      SessionKick(sLoginID);
      nCode := -3;
    end;
    if nCode = 1 then begin
      UserInfo.sAccount := sLoginID;
      UserInfo.nSessionID := GetSessionID();
      UserInfo.boSelServer := False;
      UserInfo.boPayCost := False;
      {try
        CS_DB.Enter;
        nIDCostIndex := g_Config.AccountCostList.GetIndex(UserInfo.sAccount);
        nIPCostIndex := g_Config.IPaddrCostList.GetIndex(UserInfo.sUserIPaddr);
        nIDCost := 0;
        nIPCost := 0;
        boPayCost := False;
        if nIDCostIndex >= 0 then nIDCost := Integer(g_Config.AccountCostList.Objects[nIDCostIndex]);
        if nIPCostIndex >= 0 then begin
          nIPCost := Integer(g_Config.IPaddrCostList.Objects[nIPCostIndex]);
          boPayCost := True;
        end;
      finally
        CS_DB.Leave;
      end;
      if (nIDCost >= 0) or (nIPCost >= 0) then UserInfo.boPayCost := True;
      UserInfo.nIDDay := LoWord(nIDCost);
      UserInfo.nIDHour := HiWord(nIDCost);
      UserInfo.nIPDay := LoWord(nIPCost);
      UserInfo.nIPHour := HiWord(nIPCost);}
      if not UserInfo.boPayCost then begin
        DefMsg := MakeDefaultMsg(SM_PASSOK_SELECTSERVER, 0, 0, 0, g_Config.ServerNameList.Count);
      end else begin
        DefMsg := MakeDefaultMsg(SM_PASSOK_SELECTSERVER,
          nIDCost,
          LoWord(nIPCost),
          HiWord(nIPCost),
          g_Config.ServerNameList.Count);
      end;
      sServerName := GetServerListInfo;
      SendGateMsg(UserInfo.Socket,
        UserInfo.sSockIndex,
        EncodeMessage(DefMsg) + EncodeString(sServerName));
      SessionAdd(
        UserInfo.sAccount,
        UserInfo.sUserIPaddr,
        UserInfo.nSessionID,
        UserInfo.boPayCost,
        False);
      //CODE:0046B857                 call    sub_46C150
    end else begin
      MainOutMessage('LoginFail:'+inttostr(nCode)+'/'+sLoginID);
      DefMsg := MakeDefaultMsg(SM_PASSWD_FAIL, nCode, 0, 0, 0);
      SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
    end;
  except
    MainOutMessage('TFrmMain.LoginUser');
  end;
end;
//0046D890
procedure GetSelGateInfo(sServerName, sIPaddr: string; var sSelGateIP: string; var nSelGatePort: Integer);
var
  I: Integer;
  nGateIdx: Integer;
  nGateCount: Integer;
  nSelIdx: Integer;
  boSelected: Boolean;
begin
  try
    sSelGateIP := '';
    nSelGatePort := 0;
    for I := 0 to g_Config.nRouteCount - 1 do begin
      if g_Config.boDynamicIPMode or ((g_Config.GateRoute[I].sServerName = sServerName) and (g_Config.GateRoute[I].sPublicAddr = sIPaddr)) then begin
        nGateCount := 0;
        nGateIdx := 0;
        while (True) do begin
          if (g_Config.GateRoute[I].Gate[nGateIdx].sIPaddr <> '') and (g_Config.GateRoute[I].Gate[nGateIdx].boEnable) then
            Inc(nGateCount);
          Inc(nGateIdx);
          if nGateIdx >= 10 then break;
        end; //0046D956
        if nGateCount <= 0 then break; //ûIPã

        nSelIdx := g_Config.GateRoute[I].nSelIdx;
        boSelected := False;
        for nGateIdx := nSelIdx + 1 to 9 do begin
          if (g_Config.GateRoute[I].Gate[nGateIdx].sIPaddr <> '') and
             (g_Config.GateRoute[I].Gate[nGateIdx].boEnable) then begin
            g_Config.GateRoute[I].nSelIdx := nGateIdx;
            boSelected := True;
            break;
          end;
        end;
        if not boSelected then begin
          for nGateIdx := 0 to nSelIdx - 1 do begin
            if (g_Config.GateRoute[I].Gate[nGateIdx].sIPaddr <> '') and (g_Config.GateRoute[I].Gate[nGateIdx].boEnable) then begin
              g_Config.GateRoute[I].nSelIdx := nGateIdx;
              break;
            end;
          end;
        end; //0046DA2B
        nSelIdx := g_Config.GateRoute[I].nSelIdx;
        sSelGateIP := g_Config.GateRoute[I].Gate[nSelIdx].sIPaddr;
        nSelGatePort := g_Config.GateRoute[I].Gate[nSelIdx].nPort;
        break;
      end; //0046DA72
    end; //0046DA7E
  except
    MainOutMessage('TFrmMain.GetSelGateInfo');
  end;
end;

function GetServerListInfo: string;
var
  sServerInfo: string;
  I: Integer;
  sServerName: string;
begin
  try
    for I := 0 to g_Config.ServerNameList.Count - 1 do begin
      sServerName := g_Config.ServerNameList.Strings[I];
      if sServerName <> '' then
        sServerInfo := sServerInfo + sServerName + '/' + IntToStr(FrmMasSoc.ServerStatus(sServerName)) + '/';
    end;
    {
    for I := 0 to n473290 - 1 do begin
      if (GateRoute[i].sServerName <> '') then begin
        sServerInfo:=sServerInfo + GateRoute[i].sServerName + '/' + IntToStr(FrmMasSoc.ServerStatus(GateRoute[i].sServerName)) + '/';
      end;
    end;
    }
    Result := sServerInfo;
  except
    MainOutMessage('TFrmMain.GetServerListInfo');
  end;
end;

procedure AccountSelectServer(UserInfo: pTUserInfo; sData: string); //0046B908
var
  sServerName: string;
  DefMsg: TDefaultMessage;
  boPayCost: Boolean;
  nPayMode: Integer;
  sSelGateIP: string;
  nSelGatePort: Integer;
resourcestring
  sSelServerMsg = 'SelectServer::=> Server %s/%s -> SelGate %s:%d';
begin
  sServerName := DecodeString(sData);
  if (UserInfo.sAccount <> '') and
     (sServerName <> '') and
     IsLogin(UserInfo.nSessionID) then begin
    GetSelGateInfo(sServerName, g_Config.sGateIPaddr, sSelGateIP, nSelGatePort);
    if (sSelGateIP <> '') and (nSelGatePort > 0) then begin
      if g_Config.boDynamicIPMode then
        sSelGateIP := UserInfo.sGateIPaddr; //֧̬IP
      if g_Config.boShowDetailMsg then
        MainOutMessage(format(sSelServerMsg, [sServerName, g_Config.sGateIPaddr, sSelGateIP, nSelGatePort]));
      UserInfo.boSelServer := True;
      boPayCost := False;
      nPayMode := 5;
      if UserInfo.nIDHour > 0 then nPayMode := 2;
      if UserInfo.nIPHour > 0 then nPayMode := 4;
      if UserInfo.nIPDay > 0 then nPayMode := 3;
      if UserInfo.nIDDay > 0 then nPayMode := 1;

      if FrmMasSoc.IsNotUserFull(sServerName) then begin
        SessionUpdate(UserInfo.nSessionID, sServerName, boPayCost);

        FrmMasSoc.SendServerMsg(SS_OPENSESSION, sServerName,
          UserInfo.sAccount + '/' + IntToStr(UserInfo.nSessionID) + '/' + IntToStr(Integer(UserInfo.boPayCost)) + '/' + IntToStr(nPayMode) + '/' + UserInfo.sUserIPaddr);

        DefMsg := MakeDefaultMsg(SM_SELECTSERVER_OK, UserInfo.nSessionID, 0, 0, 0);

        SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg) + EncodeString(sSelGateIP + '/' + IntToStr(nSelGatePort) + '/' + IntToStr(UserInfo.nSessionID)));
      end else begin
        UserInfo.boSelServer := False;
        SessionDel(UserInfo.nSessionID);
        DefMsg := MakeDefaultMsg(SM_STARTFAIL, 0, 0, 0, 0);
        SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
      end;
    end;
  end;
end;
//0046C570
procedure AccountUpdateUserInfo(UserInfo: pTUserInfo; sData: string);
var
  UserEntry: TUserEntryInfo;
  DBRecord: TIDDBRecord;
  nLen: Integer;
  sUserEntryMsg: string;
  sUserAddEntryMsg: string;
  nCode: Integer;
  DefMsg: TDefaultMessage;
  n10: Integer;
begin
  try
    FillChar(UserEntry, SizeOf(TUserEntryInfo), #0);
    nLen := GetCodeMsgSize(SizeOf(TUserEntryInfo) * 4 / 3);
    sUserEntryMsg := Copy(sData, 1, nLen);
    sUserAddEntryMsg := Copy(sData, nLen + 1, length(sData) - nLen);
    DecodeBuffer(sUserEntryMsg, @UserEntry, SizeOf(TUserEntryInfo));
    nCode := -1;
    if (UserInfo.sAccount = UserEntry.sLoginID) and CheckAccountName(UserEntry.sLoginID) then begin
      try
        if AccountDB.Open then begin
          n10 := AccountDB.Index(UserEntry.sLoginID);
          if (n10 >= 0) then begin
            if (AccountDB.Get(n10, DBRecord) >= 0) then begin
              DBRecord.UserEntry := UserEntry;
              AccountDB.Update(n10, DBRecord);
              nCode := 1;
            end;
          end else nCode := 0;
        end;
      finally
        AccountDB.Close;
      end;
    end; //0046C74B
    if nCode = 1 then begin
      WriteLogMsg('upg', UserEntry);
      DefMsg := MakeDefaultMsg(SM_UPDATEID_SUCCESS, 0, 0, 0, 0);
    end else begin
      DefMsg := MakeDefaultMsg(SM_UPDATEID_FAIL, nCode, 0, 0, 0);
    end;
    SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
  except
    MainOutMessage('TFrmMain.UpdateUserInfo');
  end;
end;

procedure AccountGetBackPassword(UserInfo: pTUserInfo;
  sData: string);
var
  sMsg: string;
  sAccount: string;
  sQuest1: string;
  sAnswer1: string;
  sQuest2: string;
  sAnswer2: string;
  sPassword: string;
  sBirthDay: string;
  nCode: Integer;
  nIndex: Integer;
  DefMsg: TDefaultMessage;
  DBRecord: TIDDBRecord;
begin
  sMsg := DecodeString(sData);
  sMsg := GetValidStr3(sMsg, sAccount, [#9]);
  sMsg := GetValidStr3(sMsg, sQuest1, [#9]);
  sMsg := GetValidStr3(sMsg, sAnswer1, [#9]);
  sMsg := GetValidStr3(sMsg, sQuest2, [#9]);
  sMsg := GetValidStr3(sMsg, sAnswer2, [#9]);
  //sMsg := GetValidStr3(sMsg, sBirthDay, [#9]);
  sMsg := GetValidStr3(sMsg, sPassword, [#9]);
  nCode := 0;
  try
    if (sAccount <> '')and (sPassword <> '') and AccountDB.Open then begin
      nIndex := AccountDB.Index(sAccount);
      if (nIndex >= 0) and (AccountDB.Get(nIndex, DBRecord) >= 0) then begin
        if (DBRecord.nErrorCount < 5) or ((GetTickCount - DBRecord.dwActionTick) > 180000) then begin
          nCode := -1;
          if (DBRecord.UserEntry.sQuiz = sQuest1) and
              (DBRecord.UserEntry.sAnswer = sAnswer1)and
              (DBRecord.UserEntry.sQuiz2 = sQuest2)and
               (DBRecord.UserEntry.sAnswer2 = sAnswer2) then nCode := 1;
          {if (DBRecord.UserEntry.sQuiz = sQuest1) then begin
            nCode := -3;
            if DBRecord.UserEntry.sAnswer = sAnswer1 then begin
              if DBRecord.UserEntry.sBirthDay = sBirthDay then begin
                nCode := 1;
              end;
            end;
          end;
          if nCode <> 1 then begin
            if (DBRecord.UserEntry.sQuiz2 = sQuest2) then begin
              nCode := -3;
              if DBRecord.UserEntry.sAnswer2 = sAnswer2 then begin
                if DBRecord.UserEntry.sBirthDay = sBirthDay then begin
                  nCode := 1;
                end;
              end;
            end;
          end;   }
          if nCode = 1 then begin
            DBRecord.UserEntry.sPassword := sPassword;
            AccountDB.Update(nIndex, DBRecord);
          end else begin
            Inc(DBRecord.nErrorCount);
            DBRecord.dwActionTick := GetTickCount();
            AccountDB.Update(nIndex, DBRecord);
          end;
        end else begin
          nCode := -2;
          if GetTickCount < DBRecord.dwActionTick then begin
            DBRecord.dwActionTick := GetTickCount();
            AccountDB.Update(nIndex, DBRecord);
          end;
        end;
      end;
    end;
  finally
    AccountDB.Close;
  end;
  if nCode = 1 then begin
    DefMsg := MakeDefaultMsg(SM_GETBACKPASSWD_SUCCESS, 0, 0, 0, 0);
    SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
  end else begin
    DefMsg := MakeDefaultMsg(SM_GETBACKPASSWD_FAIL, nCode, 0, 0, 0);
    SendGateMsg(UserInfo.Socket, UserInfo.sSockIndex, EncodeMessage(DefMsg));
  end;
end;

procedure SendGateMsg(Socket: TCustomWinSocket; sSockIndex,
  sMsg: string);
var
  sSendMsg: string;
begin
  sSendMsg := '%' + sSockIndex + '/#' + sMsg + '!$';
  Socket.SendText(sSendMsg);
end;

function IsLogin(nSessionID: Integer): Boolean;
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  Result := False;
  g_Config.SessionList.Lock;
  try
    for I := 0 to g_Config.SessionList.Count - 1 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if (ConnInfo.nSessionID = nSessionID) then begin
        Result := True;
        break;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

function IsLogin(sLoginID: string): Boolean;
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  Result := False;
  g_Config.SessionList.Lock;
  try
    for I := 0 to g_Config.SessionList.Count - 1 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if (ConnInfo.sAccount = sLoginID) then begin
        Result := True;
        break;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure SessionKick(sLoginID: string);
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  g_Config.SessionList.Lock;
  try
    for I := 0 to g_Config.SessionList.Count - 1 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if (ConnInfo.sAccount = sLoginID) and not ConnInfo.boKicked then begin
        FrmMasSoc.SendServerMsg(SS_CLOSESESSION, ConnInfo.sServerName, ConnInfo.sAccount + '/' + IntToStr(ConnInfo.nSessionID));
        ConnInfo.dwKickTick := GetTickCount();
        ConnInfo.boKicked := True;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure SessionAdd(sAccount, sIPaddr: string;
  nSessionID: Integer; boPayCost, bo11: Boolean);
var
  ConnInfo: pTConnInfo;
begin
  New(ConnInfo);
  ConnInfo.sAccount := sAccount;
  ConnInfo.sIPaddr := sIPaddr;
  ConnInfo.nSessionID := nSessionID;
  ConnInfo.boPayCost := boPayCost;
  ConnInfo.bo11 := bo11;
  ConnInfo.dwKickTick := GetTickCount();
  ConnInfo.dwStartTick := GetTickCount();
  ConnInfo.boKicked := False;
  g_Config.SessionList.Lock;
  try
    g_Config.SessionList.Add(ConnInfo);
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure SendGateKickMsg(Socket: TCustomWinSocket;
  sSockIndex: string);
var
  sSendMsg: string;
begin
  sSendMsg := '%+-' + sSockIndex + '$';
  Socket.SendText(sSendMsg);
end;

procedure SendGateAddBlockList(Socket: TCustomWinSocket;
  sSockIndex: string);
var
  sSendMsg: string;
begin
  sSendMsg := '%+B' + sSockIndex + '$';
  Socket.SendText(sSendMsg);
end;

procedure SendGateAddTempBlockList(Socket: TCustomWinSocket;
  sSockIndex: string);
var
  sSendMsg: string;
begin
  sSendMsg := '%+T' + sSockIndex + '$';
  Socket.SendText(sSendMsg);
end;

procedure SessionUpdate(nSessionID: Integer; sServerName: string; boPayCost: Boolean);
var
  ConnInfo: pTConnInfo;
  I: Integer;
begin
  g_Config.SessionList.Lock;
  try
    for I := 0 to g_Config.SessionList.Count - 1 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if (ConnInfo.nSessionID = nSessionID) then begin
        ConnInfo.sServerName := sServerName;
        ConnInfo.bo11 := boPayCost;
        break;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure GenServerNameList();
var
  I, II: Integer;
  boD: Boolean;
begin
  try
    g_Config.ServerNameList.Clear;
    for I := 0 to g_Config.nRouteCount - 1 do begin
      boD := True;
      for II := 0 to g_Config.ServerNameList.Count - 1 do begin
        if g_Config.ServerNameList.Strings[II] = g_Config.GateRoute[I].sServerName then
          boD := False;
      end;
      if boD then g_Config.ServerNameList.Add(g_Config.GateRoute[I].sServerName);
    end;
  except
    MainOutMessage('TFrmMain.GenServerNameList');
  end;
end;

procedure SessionClearNoPayMent();
var
  I: Integer;
  ConnInfo: pTConnInfo;
begin
  g_Config.SessionList.Lock;
  try
    for I := g_Config.SessionList.Count - 1 downto 0 do begin
      ConnInfo := g_Config.SessionList.Items[I];
      if not ConnInfo.boKicked and not g_Config.boTestServer and not ConnInfo.bo11 then begin
        if (GetTickCount - ConnInfo.dwStartTick) > 60 * 60 * 1000 then begin
          ConnInfo.dwStartTick := GetTickCount();
          if not IsPayMent(ConnInfo.sIPaddr, ConnInfo.sAccount) then begin
            FrmMasSoc.SendServerMsg(SS_KICKUSER, ConnInfo.sServerName, ConnInfo.sAccount + '/' + IntToStr(ConnInfo.nSessionID));
            Dispose(ConnInfo);
            g_Config.SessionList.Delete(I);
          end;
        end;
      end;
    end;
  finally
    g_Config.SessionList.UnLock;
  end;
end;

procedure LoadIPaddrCostList(QuickList: TQuickList);
begin
  try
    CS_DB.Enter;
    g_Config.IPaddrCostList.Clear;
    g_Config.IPaddrCostList.AddStrings(QuickList);
  finally
    CS_DB.Leave;
  end;
end;

procedure LoadAccountCostList(QuickList: TQuickList);
begin
  try
    CS_DB.Enter;
    g_Config.AccountCostList.Clear;
    g_Config.AccountCostList.AddStrings(QuickList);
  finally
    CS_DB.Leave;
  end;
end;

procedure TFrmMain.Panel2DblClick(Sender: TObject);
begin
  MainOutMessage(GetServerListInfo);
end;

procedure TFrmMain.MyMessage(var MsgData: TWmCopyData);
var
  sData: string;
  wIdent: Word;
begin
  wIdent := HiWord(MsgData.From);
  sData := StrPas(MsgData.CopyDataStruct^.lpData);
  case wIdent of
    GS_QUIT: begin
        g_Config.boRemoteClose := True;
        Close();
      end;
    GS_USERACCOUNT: begin //̨˺
        GameCenterGetUserAccount(sData);
      end;
    GS_CHANGEACCOUNTINFO: GameCenterChangeAccountInfo(sData); //̨޸˺
    3: ;
  end;
end;

procedure TFrmMain.GameCenterGetUserAccount(sData: string);
var
  DBRecord: TIDDBRecord;
  nIndex: Integer;
  nCode: Integer;
  DefMsg: TDefaultMessage;
begin
  try
    nCode := -1;
    if AccountDB.Open then begin
      nIndex := AccountDB.Index(sData);
      if (nIndex >= 0) and (AccountDB.Get(nIndex, DBRecord) >= 0) then begin
        nCode := 1;
      end;
    end;
  finally
    AccountDB.Close;
  end;
  if nCode > 0 then begin
    DefMsg := MakeDefaultMsg(0, nCode, 0, 0, 0);
    SendGameCenterMsg(SG_USERACCOUNT, EncodeMessage(DefMsg) + EncodeBuffer(@DBRecord, SizeOf(DBRecord)));
  end else begin
    DefMsg := MakeDefaultMsg(SG_USERACCOUNTNOTFOUND, nCode, 0, 0, 0);
    SendGameCenterMsg(SG_USERACCOUNT, EncodeMessage(DefMsg));
  end;
end;

procedure TFrmMain.GameCenterChangeAccountInfo(sData: string);
var
  NewRecord, DBRecord: TIDDBRecord;
  DefMsg: TDefaultMessage;
  sDefMsg: string;
  nCode, nIndex: Integer;
begin
  if length(sData) < DEFBLOCKSIZE then Exit;
  sDefMsg := Copy(sData, 1, DEFBLOCKSIZE);
  sData := Copy(sData, DEFBLOCKSIZE + 1, length(sData) - DEFBLOCKSIZE);
  DefMsg := DecodeMessage(sDefMsg);
  DecodeBuffer(sData, @NewRecord, SizeOf(NewRecord));
  nCode := -1;
  try
    if AccountDB.Open then begin
      nIndex := AccountDB.Index(NewRecord.UserEntry.sLoginID);
      if (nIndex >= 0) and (AccountDB.Get(nIndex, DBRecord) >= 0) then begin
        if DBRecord.UserEntry.sLoginID = NewRecord.UserEntry.sLoginID then begin
          DBRecord.nErrorCount := 0;
          DBRecord.dwActionTick := 0;
          DBRecord.UserEntry := NewRecord.UserEntry;
          AccountDB.Update(nIndex, DBRecord);
          nCode := 1;
        end else begin
          nCode := 2;
        end;
      end;
    end;
  finally
    AccountDB.Close;
  end;
  DefMsg := MakeDefaultMsg(0, nCode, 0, 0, 0);
  SendGameCenterMsg(SG_USERACCOUNTCHANGESTATUS, EncodeMessage(DefMsg));
end;

procedure SaveContLogMsg(sLogMsg: string);
var
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
  sLogDir, sLogFileName: string;
  LogFile: TextFile;
begin
  if sLogMsg = '' then Exit;
  DecodeDate(Date, Year, Month, Day);
  DecodeTime(Time, Hour, Min, Sec, MSec);
  if not DirectoryExists(g_Config.sCountLogDir) then begin
    CreateDir(g_Config.sCountLogDir);
  end;
  sLogDir := g_Config.sCountLogDir + IntToStr(Year) + '-' + IntToStr2(Month);
  if not DirectoryExists(sLogDir) then begin
    CreateDirectory(PChar(sLogDir), nil);
  end;
  sLogFileName := sLogDir + '\' + IntToStr(Year) + '-' + IntToStr2(Month) + '-' + IntToStr2(Day) + '.txt';
  AssignFile(LogFile, sLogFileName);
  if not FileExists(sLogFileName) then begin
    Rewrite(LogFile);
  end else begin
    Append(LogFile);
  end;
  sLogMsg := sLogMsg + #9 + TimeToStr(Time);
  WriteLn(LogFile, sLogMsg);
  CloseFile(LogFile);
end;

procedure WriteLogMsg(sType: string; var UserEntry: TUserEntryInfo);
var
  Year, Month, Day: Word;
  sLogDir, sLogFileName: string;
  LogFile: TextFile;
  sLogFormat, sLogMsg: string;
begin
  DecodeDate(Date, Year, Month, Day);
  if not DirectoryExists(g_Config.sChrLogDir) then begin
    CreateDir(g_Config.sChrLogDir);
  end;
  sLogDir := g_Config.sChrLogDir + IntToStr(Year) + '-' + IntToStr2(Month);
  if not DirectoryExists(sLogDir) then begin
    CreateDirectory(PChar(sLogDir), nil);
  end;
  sLogFileName := sLogDir + '\Id_' + IntToStr2(Day) + '.log';
  AssignFile(LogFile, sLogFileName);
  if not FileExists(sLogFileName) then begin
    Rewrite(LogFile);
  end else begin
    Append(LogFile);
  end;
  sLogFormat := '*%s*'#9'%s'#9'"%s"'#9'%s'#9'%s'#9'%s'#9'%s'#9'%s'#9'%s'#9'%s'#9'%s'#9'%s'#9'[%s]';
  sLogMsg := format(sLogFormat, [sType,
    UserEntry.sLoginID,
      UserEntry.sPassword,
      UserEntry.sUserName,
      UserEntry.sSSNo,
      UserEntry.sQuiz,
      UserEntry.sAnswer,
      UserEntry.sEMail,
      UserEntry.sQuiz2,
      UserEntry.sAnswer2,
      UserEntry.sBirthDay,
      UserEntry.sMobilePhone,
      TimeToStr(Now)]);

  //sLogMsg:= UserAddEntry.sQuiz2 + UserAddEntry.sAnswer2 + UserAddEntry.sBirthDay + UserAddEntry.sMobilePhone + '[' + TimeToStr(Now) + ']';

  WriteLn(LogFile, sLogMsg);
  CloseFile(LogFile);
end;

procedure StartService();
begin
  InitializeConfig();
  LoadConfig();
end;

procedure StopService();
begin
  UnInitializeConfig();
end;

procedure InitializeConfig();
resourcestring
  sConfigFile = '.\Logsrv.ini';
begin
  g_Config.IniConf := TIniFile.Create(sConfigFile);
  InitializeCriticalSection(g_Config.GateCriticalSection);
end;
procedure UnInitializeConfig();
begin
  g_Config.IniConf.Free;
  DeleteCriticalSection(g_Config.GateCriticalSection);
end;
procedure LoadConfig();
  function LoadConfigString(sSection, sIdent, sDefault: string): string;
  var
    sString: string;
  begin
    sString := g_Config.IniConf.ReadString(sSection, sIdent, '');
    if sString = '' then begin
      g_Config.IniConf.WriteString(sSection, sIdent, sDefault);
      Result := sDefault;
    end else begin
      Result := sString;
    end;
  end;
  function LoadConfigInteger(sSection, sIdent: string; nDefault: Integer): Integer;
  var
    nLoadInteger: Integer;
  begin
    nLoadInteger := g_Config.IniConf.ReadInteger(sSection, sIdent, -1);
    if nLoadInteger < 0 then begin
      g_Config.IniConf.WriteInteger(sSection, sIdent, nDefault);
      Result := nDefault;
    end else begin
      Result := nLoadInteger;
    end;
  end;
  function LoadConfigBoolean(sSection, sIdent: string; boDefault: Boolean): Boolean;
  var
    nLoadInteger: Integer;
  begin
    nLoadInteger := g_Config.IniConf.ReadInteger(sSection, sIdent, -1);
    if nLoadInteger < 0 then begin
      g_Config.IniConf.WriteBool(sSection, sIdent, boDefault);
      Result := boDefault;
    end else begin
      Result := nLoadInteger = 1;
    end;
  end;
resourcestring
  sSectionServer = 'Server';
  sSectionDB = 'DB';
  sIdentDBServer = 'DBServer';
  sIdentFeeServer = 'FeeServer';
  sIdentLogServer = 'LogServer';
  sIdentGateAddr = 'GateAddr';
  sIdentGatePort = 'GatePort';
  sIdentServerAddr = 'ServerAddr';
  sIdentServerPort = 'ServerPort';
  sIdentMonAddr = 'MonAddr';
  sIdentMonPort = 'MonPort';
  sIdentDBSPort = 'DBSPort';
  sIdentFeePort = 'FeePort';
  sIdentLogPort = 'LogPort';
  sIdentReadyServers = 'ReadyServers';
  sIdentTestServer = 'TestServer';
  sIdentDynamicIPMode = 'DynamicIPMode';
  sIdentIdDir = 'IdDir';
  sIdentWebLogDir = 'WebLogDir';
  sIdentCountLogDir = 'CountLogDir';
  sIdentFeedIDList = 'FeedIDList';
  sIdentFeedIPList = 'FeedIPList';

  sIdentEnableGetbackPassword = 'GetbackPassword';
  sIdentAutoClearID = 'AutoClearID';
  sIdentAutoClearTime = 'AutoClearTime';
  sIdentUnLockAccount = 'UnLockAccount';
  sIdentUnLockAccountTime = 'UnLockAccountTime';
begin
  g_Config.sDBServer := LoadConfigString(sSectionServer, sIdentDBServer, g_Config.sDBServer);
  g_Config.sFeeServer := LoadConfigString(sSectionServer, sIdentFeeServer, g_Config.sFeeServer);
  g_Config.sLogServer := LoadConfigString(sSectionServer, sIdentLogServer, g_Config.sLogServer);

  g_Config.sGateAddr := LoadConfigString(sSectionServer, sIdentGateAddr, g_Config.sGateAddr);
  g_Config.nGatePort := LoadConfigInteger(sSectionServer, sIdentGatePort, g_Config.nGatePort);
  g_Config.sServerAddr := LoadConfigString(sSectionServer, sIdentServerAddr, g_Config.sServerAddr);
  g_Config.nServerPort := LoadConfigInteger(sSectionServer, sIdentServerPort, g_Config.nServerPort);
  g_Config.sMonAddr := LoadConfigString(sSectionServer, sIdentMonAddr, g_Config.sMonAddr);
  g_Config.nMonPort := LoadConfigInteger(sSectionServer, sIdentMonPort, g_Config.nMonPort);

  g_Config.nDBSPort := LoadConfigInteger(sSectionServer, sIdentDBSPort, g_Config.nDBSPort);
  g_Config.nFeePort := LoadConfigInteger(sSectionServer, sIdentFeePort, g_Config.nFeePort);
  g_Config.nLogPort := LoadConfigInteger(sSectionServer, sIdentLogPort, g_Config.nLogPort);
  g_Config.nReadyServers := LoadConfigInteger(sSectionServer, sIdentReadyServers, g_Config.nReadyServers);
  g_Config.boEnableMakingID := LoadConfigBoolean(sSectionServer, sIdentTestServer, g_Config.boEnableMakingID);

  g_Config.boEnableGetbackPassword := LoadConfigBoolean(sSectionServer, sIdentEnableGetbackPassword, g_Config.boEnableGetbackPassword);
  g_Config.boAutoClearID := LoadConfigBoolean(sSectionServer, sIdentAutoClearID, g_Config.boAutoClearID);
  g_Config.dwAutoClearTime := LoadConfigInteger(sSectionServer, sIdentAutoClearTime, g_Config.dwAutoClearTime);
  g_Config.boUnLockAccount := LoadConfigBoolean(sSectionServer, sIdentUnLockAccount, g_Config.boUnLockAccount);
  g_Config.dwUnLockAccountTime := LoadConfigInteger(sSectionServer, sIdentUnLockAccountTime, g_Config.dwUnLockAccountTime);

  g_Config.nCSCheckNamePort := LoadConfigInteger(sSectionServer, 'CSCheckNamePort', g_Config.nCSCheckNamePort);
  g_Config.sCSCheckNameAddr := LoadConfigString(sSectionServer, 'CSCheckNameAddr', g_Config.sCSCheckNameAddr);
  g_Config.boDynamicIPMode := LoadConfigBoolean(sSectionServer, sIdentDynamicIPMode, g_Config.boDynamicIPMode);

  g_Config.sIdDir := LoadConfigString(sSectionDB, sIdentIdDir, g_Config.sIdDir);
  g_Config.sWebLogDir := LoadConfigString(sSectionDB, sIdentWebLogDir, g_Config.sWebLogDir);
  g_Config.sCountLogDir := LoadConfigString(sSectionDB, sIdentCountLogDir, g_Config.sCountLogDir);
  g_Config.sFeedIDList := LoadConfigString(sSectionDB, sIdentFeedIDList, g_Config.sFeedIDList);
  g_Config.sFeedIPList := LoadConfigString(sSectionDB, sIdentFeedIPList, g_Config.sFeedIPList);
end;

procedure TFrmMain.MENU_OPTION_GENERALClick(Sender: TObject);
begin
  FrmBasicSet := TFrmBasicSet.Create(Owner);
  FrmBasicSet.Top := Top;
  FrmBasicSet.Left := Left;
  FrmBasicSet.OpenBasicSet();
  FrmBasicSet.Free;
end;

procedure TFrmMain.MENU_HELP_ABOUTClick(Sender: TObject);
begin
  Memo1.Height := nMemoHeigh * 3;
  Memo1.Lines.Add(g_sVersion);
  Memo1.Lines.Add(g_sUpDateTime);
  Memo1.Lines.Add(g_sProgram);
  Memo1.Lines.Add(g_sWebSite);
end;

procedure TFrmMain.N1Click(Sender: TObject);
var
  I, II: Integer;
begin
  g_Config.ServerNameList.Clear;
  for I := Low(g_Config.GateRoute) to High(g_Config.GateRoute) do begin
    g_Config.GateRoute[I].sServerName := '';
    g_Config.GateRoute[I].sTitle := '';
    g_Config.GateRoute[I].sRemoteAddr := '';
    g_Config.GateRoute[I].sPublicAddr := '';
    g_Config.GateRoute[I].nSelIdx := 0;
    for II := Low(g_Config.GateRoute[I].Gate) to High(g_Config.GateRoute[I].Gate) do begin
      g_Config.GateRoute[I].Gate[II].sIPaddr := '';
      g_Config.GateRoute[I].Gate[II].nPort := 0;
      g_Config.GateRoute[I].Gate[II].boEnable := False;
    end;
  end;
  LoadAddrTable();
  MainOutMessage('·б...');
end;

procedure TFrmMain.C1Click(Sender: TObject);
var
  I: Integer;
begin
  for I := Low(ServerAddr) to High(ServerAddr) do begin
    ServerAddr[I] := '';
  end;
  FrmMasSoc.LoadServerAddr();
  for I := Low(UserLimit) to High(UserLimit) do begin
    UserLimit[I].sServerName := '';
    UserLimit[I].sName := '';
    UserLimit[I].nLimitCountMin := 3000;
    UserLimit[I].nLimitCountMax := 0;
  end;
  FrmMasSoc.LoadUserLimit();
  MainOutMessage('ļ...');
end;

procedure TFrmMain.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
  MainOutMessage(E.Message);
end;

procedure TFrmMain.CSCheckNameConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  MainOutMessage('IDӳɹ...');
end;

procedure TFrmMain.CSCheckNameDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  MainOutMessage('IDӶϿ...');
end;

end.


