unit ConfigMonGen;

interface

uses
  SysUtils, Classes, Controls, Forms,Dialogs, StdCtrls, ComCtrls,Windows,ObjBase,LocalDB,MirGrobal;

type
  TfrmConfigMonGen = class(TForm)
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function HeXieMon(List: TList):Integer;
  public
    procedure Open();
    { Public declarations }
  end;

var
  frmConfigMonGen: TfrmConfigMonGen;

implementation

uses UsrEngn, M2Share;

{$R *.dfm}

{ TfrmConfigMonGen }

procedure TfrmConfigMonGen.Open;
var
  i: Integer;
  MonGen: pTMonGenInfo;
begin
  ListView1.Items.BeginUpdate;
  Caption:= Caption+'('+inttostr(UserEngine.m_MonGenList.Count)+')';
  for i := 0 to UserEngine.m_MonGenList.Count - 1 do begin
    MonGen := UserEngine.m_MonGenList.Items[i];
    if MonGen = nil then Continue;
    with ListView1.Items.Add do begin
      Data := MonGen;
      if MonGen.Map <> nil then
        Caption := MonGen.Map.sMapDesc
      else Caption := '';
      SubItems.Add(MonGen.sMapName);
      SubItems.Add(IntToStr(MonGen.nX));
      SubItems.Add(IntToStr(MonGen.nY));
      SubItems.Add(MonGen.sMonName);
      SubItems.Add(IntToStr(MonGen.nRange));
      SubItems.Add(IntToStr(MonGen.nCount));
      SubItems.Add(IntToStr(MonGen.dwZenTime div 60 div 1000));
      if MonGen.dwStartTick = 0 then
        SubItems.Add('')
      else 
        SubItems.Add(IntToStr(((GetTickCount - MonGen.dwStartTick) - UserEngine.GetZenTime(MonGen.dwZenTime))));
      if MonGen.CertList = nil then
        SubItems.Add('0')
      else
        SubItems.Add(IntToStr(MonGen.CertList.Count))
    end;
  end;
  ListView1.Items.EndUpdate;  
  Self.ShowModal;
end;
function  TfrmConfigMonGen.HeXieMon(List: TList):Integer;
var
  ii:Integer;
  BaseObject: TBaseObject;
begin
  Result := 0;
  for ii := 0 to List.Count -1 do begin
    BaseObject := TBaseObject(List[ii]);
    if (BaseObject = nil) or BaseObject.m_boDeath or (BaseObject.m_btRaceServer = RC_GUARD)or (BaseObject.m_btRaceServer = RC_PEACENPC) then Continue;
    BaseObject.m_boNoItem := True;
    BaseObject.m_WAbil.HP := 0;
    Inc(Result);
  end;
  List.Clear;
end;
procedure TfrmConfigMonGen.Button1Click(Sender: TObject);
var
  i, ii: Integer;
  nMonCount: Integer;
  MonGen: pTMonGenInfo;
begin
  nMonCount := 0;
  EnterCriticalSection(ProcessHumanCriticalSection);
  try
    for i := 0 to ListView1.Items.Count - 1 do begin
      MonGen := ListView1.Items[i].Data;
      if (MonGen = nil) or (MonGen.CertList = nil) or (MonGen.CertList.Count = 0) then Continue;
      Inc(nMonCount,HeXieMon(MonGen.CertList));
    end;
    ShowMessage('г: '+inttostr(nMonCount)+' ...');
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
end;

procedure TfrmConfigMonGen.Button2Click(Sender: TObject);
var
  i: Integer;
  ii: Integer;
  MonGen: pTMonGenInfo;
begin
  EnterCriticalSection(ProcessHumanCriticalSection);
  try
    for i := 0 to UserEngine.m_MonGenList.Count - 1 do begin
      MonGen := UserEngine.m_MonGenList.Items[i];
      HeXieMon(MonGen.CertList);
      DisPose(pTMonGenInfo(UserEngine.m_MonGenList.Items[i]));
    end;
    UserEngine.m_MonGenList.Clear;
    FrmDB.LoadMonGen;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
  Close;
end;

end.
