unit GameMap;

interface

uses
  Windows, SysUtils, Classes,
  SList,
  M2Config,
  TyFunc, MirGrobal,SerGrobal, M2Type;
type
  TMapHeader = packed record
    wWidth: Word;
    wHeight: Word;
    sTitle: string[16];
    UpdateDate: TDateTime;
    Reserved: array[0..22] of Char;
  end;
  TMapUnitInfo = packed record
    wBkImg: Word; //32768 $8000 Ϊֹƶ
    wMidImg: Word;
    wFrImg: Word;
    btDoorIndex: Byte; //$80 (¦),  ĺ ε
    btDoorOffset: Byte; //  ׸  ġ, $80 (/(⺻))
    btAniFrame: Byte; //$80(Draw Alpha) +   
    btAniTick: Byte;
    btArea: Byte; // 
    btLight: Byte; //0..1..4  ȿ
  end;
  pTMapUnitInfo = ^TMapUnitInfo;
  TMapArr = array[0..1000 * 1000 - 1] of TMapUnitInfo;
  pTMapArr = ^TMapArr;
const
  McfNotCanMove       = 0;
  McfNotCanMagicMove  = 1;
  //McfIsSafe        = 2;
type
  TMapCellinfo = record //ÿͼӵĶ̬ݽṹ
    chCellFlag: Byte;   // (0,1ħܷɹ,2ȫ)
    //SetBitValue(ItemCheckInf^, Tag, Checked);
    //IsBitOn(StdItem.NeedIdentify, 6)
    ObjList: TSimpleList;//б
  end;
  pTMapCellinfo = ^TMapCellinfo;

  TMapCellArray = array[0..1000 * 1000 - 1] of TMapCellinfo;
  pTMapCellArray = ^TMapCellArray;
  PTMap = ^TMap;
  TMap = class
    sMapName: string; //0x4
    sMapDesc: string;
    sMainMapName: string; //0x4
    sSubMapName: string; //0x4
    m_boMainMap: Boolean; //0x25
    MapCellArray: pTMapCellArray; //0x0C
    m_nMinMap: Integer; //0x10
    sNoReconnectMap: string; //0x38
    QuestNPC: TObject; //0x3C
    m_QuestList: TList; //0x48
    nServerIndex: Integer; //0x14
    nRequestLevel: Integer; //0x18 뱾ͼȼ
    m_nWidth: Integer; //0x1C
    m_nHeight: Integer; //0x20
    m_boDARK: Boolean; //0x24
    m_boDAY: Boolean; //0x25
    m_boDarkness: Boolean;
    m_boDayLight: Boolean;
    m_DoorList: TList; //0x28
    bo2C: Boolean; // ִ GetItem Ƿƶ
    m_boSAFE: Boolean; //0x2D
    m_boFightZone: Boolean; //0x2E
    m_boFight3Zone: Boolean; //0x2F  //лսͼ
    m_boQUIZ: Boolean; //0x30
    m_boNORECONNECT: Boolean; //0x31
    m_boNEEDHOLE: Boolean; //0x32
    m_boNORECALL: Boolean; //0x33
    m_boNOGUILDRECALL: Boolean;
    m_boNODEARRECALL: Boolean;
    m_boNOMASTERRECALL: Boolean;
    m_boNORANDOMMOVE: Boolean; //0x34
    m_boNODRUG: Boolean; //0x35
    m_boMINE: Boolean; //0x36
    m_boNOPOSITIONMOVE: Boolean; //0x37

    nNEEDSETONFlag: Integer; //0x40
    nNeedONOFF: Integer; //0x44

    m_boRUNHUMAN: Boolean; //Դ
    m_boRUNMON: Boolean; //Դ
    m_boINCHP: Boolean; //ԶHPֵ
    m_boINCGAMEPOINT: Boolean; //Զӵ
    m_boDECHP: Boolean; //ԶHPֵ

    m_boDECGAMEPOINT: Boolean; //Զ
    m_boEXPRATE: Boolean; //ɱ־鱶
    m_boPKWINLEVEL: Boolean; //PKõȼ
    m_boPKWINEXP: Boolean; //PKþ
    m_boPKLOSTLEVEL: Boolean; //PKȼ
    m_boPKLOSTEXP: Boolean; //PK

    m_boNotIncPKPoint: Boolean;//PKֵ
    m_boNotDropItem: Boolean; //װ
    m_boNotShowName: Boolean; //ʾ
    m_boNotSay: Boolean; //˵
    m_btAttackMode: Byte; //˵
    m_nPKWINLEVEL: Integer; //PKõȼ
    m_nPKLOSTLEVEL: Integer; //PKȼ
    m_nPKWINEXP: Integer; //PKþ
    m_nPKLOSTEXP: Integer; //PK
    m_nDECHPTIME: Integer; //HPʱ
    m_nDECHPPOINT: Integer; //һμ
    m_nINCHPTIME: Integer; //HPʱ
    m_nINCHPPOINT: Integer; //һμӵ

    m_nDECGAMEGOLDTIME: Integer; //ϷҼʱ
    m_nDecGameGold: Integer; //һμ
    m_nDECGAMEPOINTTIME: Integer; //Ϸʱ
    m_nDECGAMEPOINT: Integer; //һμ

    m_nINCGAMEGOLDTIME: Integer; //ϷҼʱ
    m_nIncGameGold: Integer; //һμ
    m_nINCGAMEPOINTTIME: Integer; //ϷҼʱ
    m_nINCGAMEPOINT: Integer; //һμ
    m_nEXPRATE: Integer; //鱶
    m_nMonCount: Integer;
    m_nHumCount: Integer;

    m_boUnAllowStdItems: Boolean; //ǷʹƷ
    m_UnAllowStdItemsList: TGStringList; //ʹƷб
    m_boUnAllowFireMagic: Boolean; //ʹûǽ
    m_pStartPoint:pTStartPoint;
  private
    procedure Initialize(nWidth, nHeight: SmallInt);
  public
    constructor Create();
    destructor Destroy; override;
    function LoadMapData(sMapFile: string): Boolean;
    function AddToMapMineEvent(nX, nY: SmallInt; aType: TMapObjType; Event: TObject): TObject;
    function CreateQuest(nFlag, nValue: Integer; s24, s28, s2C: string; boGrouped: Boolean): Boolean;

    function AddToMap(nX, nY: SmallInt; aType: TMapObjType; pRemoveObject: TObject): Pointer;
    function CanWalk(nX, nY: SmallInt; boFlag: Boolean): Boolean;
    function CanWalkOfItem(nX, nY: SmallInt; boFlag, boItem: Boolean): Boolean;
    function CanWalkEx(nX, nY: SmallInt; boFlag: Boolean): Boolean;
    function CanFly(nSX, nSY, nDX, nDY: SmallInt): Boolean;
    function ActMoveToXY(nNowX, nNowY: SmallInt; Obj: TObject; nDesX, nDesY: SmallInt; boFlag: Boolean): Integer;
    procedure SetXYFlag(nX, nY: SmallInt; boFlag: Boolean);
    function DeleteFromMap(nX, nY: SmallInt; aType: TMapObjType; pRemoveObject: TObject): Integer;
    function IsCheapStuff(): Boolean;
    procedure AddDoorToMap;
    procedure MakeStoneMines;
    procedure ClearStoneMines; //TasNat ûͷŰ2009-11-27 18:29:19
    function GetItem(nX, nY: SmallInt): PTMapItem;
    function GetMapCellInfo(nX, nY: SmallInt; var MapCellInfo: pTMapCellinfo;BoNeedCanMove:Boolean = False): Boolean;
    function GetXYObjCount(nX, nY: SmallInt): Integer;
    function GetNextPosition(sX, sY, nDir, nFlag: SmallInt; var snx: SmallInt; var sny: SmallInt): Boolean;
    function MagicCanMove(nX, nY: SmallInt): Boolean;
    procedure VerifyMapTime(nX, nY: SmallInt; BaseObject: TObject);
    function CanSafeWalk(nX, nY: SmallInt): Boolean;
    function ArroundDoorOpened(nX, nY: SmallInt): Boolean;
    function GetMovingObject(nX, nY: SmallInt; boFlag: Boolean): Pointer;
    function GetQuestNPC(BaseObject: TObject; sCharName, sStr: string; boFlag: Boolean): TObject;
    function GetItemEx(nX, nY: SmallInt; var nCount: Integer): Pointer;
    function GetDoor(nX, nY: SmallInt): pTDoorInfo;
    function IsValidObject(nX, nY: SmallInt; nRage: SmallInt; BaseObject: TObject): Boolean;
    function GetRangeBaseObject(nX, nY: SmallInt; nRage: SmallInt; boFlag: Boolean; BaseObjectList: TList): Integer;
    function GeTBaseObjects(nX, nY: SmallInt; boFlag: Boolean; BaseObjectList: TList): Integer;
    function GetEvent(nX, nY: SmallInt): TObject;

    function GetXYHuman(nMapX, nMapY: SmallInt): Boolean;
    function GetEnvirInfo(): string;

    function AllowStdItems(sItemName: string): Boolean; overload;
    function AllowStdItems(nItemIdx: Integer): Boolean; overload;
    procedure AddObject(nType: Integer);
    procedure DelObjectCount(BaseObject: TObject);


    property MonCount: Integer read m_nMonCount;//
    property HumCount: Integer read m_nHumCount;//

  end;
  TMapManager = class(TGList) //004B52B0
  private
  public
    constructor Create();
    destructor Destroy; override;
    procedure LoadMapDoor();
    function AddMap(sMapName, sMainMapName, sMapDesc: string; nServerNumber: Integer; MapFlag: pTMapFlag; QuestNPC: TObject): TMap;
    function GetMapInfo(nServerIdx: Integer; sMapName: string): TMap;
    function AddMapRoute(sSMapNO: string; nSMapX, nSMapY: Integer; sDMapNO: string; nDMapX, nDMapY: Integer): Boolean;
    function GetMapOfServerIndex(sMapName: string): Integer;
    function FindMap(sMapName: string): TMap;
    function GetMainMap(Map: TMap): string;
    procedure ReSetMinMap();
    procedure ProcessMapDoor();
    procedure MakeSafePkZone();
  end;
implementation

uses ObjBase, ObjNpc,  M2Share, Event, ObjMon, HUtil32, Castle;

{ TEnvirList }

procedure TMapManager.MakeSafePkZone();
var
  nX, nY: Integer;
  SafeEvent: TSafeEvent;
  nMinX, nMaxX, nMinY, nMaxY: Integer;

  I: Integer;
  StartPoint: pTStartPoint;
  Map: TMap;
begin
  g_StartPointList.Lock;
  for I := 0 to g_StartPointList.Count - 1 do begin
    StartPoint := pTStartPoint(g_StartPointList.Objects[I]);
    if (StartPoint <> nil) and (StartPoint.m_nType > 0) then begin
      Map := TMap(StartPoint.m_Map);
      if Map <> nil then begin
        nMinX := StartPoint.m_nCurrX - StartPoint.m_nRange;
        nMaxX := StartPoint.m_nCurrX + StartPoint.m_nRange;
        nMinY := StartPoint.m_nCurrY - StartPoint.m_nRange;
        nMaxY := StartPoint.m_nCurrY + StartPoint.m_nRange;
        for nX := nMinX to nMaxX do begin
          for nY := nMinY to nMaxY do begin
            if ((nX < nMaxX) and (nY = nMinY)) or
              ((nY < nMaxY) and (nX = nMinX)) or
              (nX = nMaxX) or (nY = nMaxY) then begin
              SafeEvent := TSafeEvent.Create(Map, nX, nY, StartPoint.m_nType);
              g_EventManager.AddEvent(SafeEvent);
            end;
          end;
        end;
      end;
    end;
  end;
  g_StartPointList.UnLock;
end;

function TMapManager.AddMap(sMapName, sMainMapName, sMapDesc: string; nServerNumber: Integer; MapFlag: pTMapFlag; QuestNPC: TObject): TMap;
var
  Map: TMap;
  I: Integer;
  nStd: Integer;
  TempList: TStringList;
begin
  Result := nil;
  Map := TMap.Create;
  Map.sMapName := sMapName;
  Map.sMainMapName := sMainMapName;
  Map.sSubMapName := sMapName;
  Map.sMapDesc := sMapDesc;
  if sMainMapName <> '' then Map.m_boMainMap := True;
  Map.nServerIndex := nServerNumber;
  Map.m_boSAFE := MapFlag.boSAFE;
  Map.m_boFightZone := MapFlag.boFIGHT;
  Map.m_boFight3Zone := MapFlag.boFIGHT3;
  Map.m_boDARK := MapFlag.boDARK;
  Map.m_boDAY := MapFlag.boDAY;
  Map.m_boQUIZ := MapFlag.boQUIZ;
  Map.m_boNORECONNECT := MapFlag.boNORECONNECT;
  Map.m_boNEEDHOLE := MapFlag.boNEEDHOLE;
  Map.m_boNORECALL := MapFlag.boNORECALL;
  Map.m_boNOGUILDRECALL := MapFlag.boNOGUILDRECALL;
  Map.m_boNODEARRECALL := MapFlag.boNODEARRECALL;
  Map.m_boNOMASTERRECALL := MapFlag.boNOMASTERRECALL;
  Map.m_boNORANDOMMOVE := MapFlag.boNORANDOMMOVE;
  Map.m_boNODRUG := MapFlag.boNODRUG;
  Map.m_boMINE := MapFlag.boMINE;
  Map.m_boNOPOSITIONMOVE := MapFlag.boNOPOSITIONMOVE;
  Map.m_boNotIncPKPoint:= MapFlag.boNotIncPKPoint ;//PKֵ
  Map.m_boNotDropItem:= MapFlag.boNotDropItem ; //װ
  Map.m_boNotShowName:= MapFlag.boNotShowName ; //
  Map.m_boNotSay:= MapFlag.boNotSay ; //
  Map.m_btAttackMode:= MapFlag.btAttackMode ; //ǿƹģʽ
  Map.m_boRUNHUMAN := MapFlag.boRUNHUMAN; //Դ
  Map.m_boRUNMON := MapFlag.boRUNMON; //Դ
  Map.m_boDECHP := MapFlag.boDECHP; //ԶHPֵ
  Map.m_boINCHP := MapFlag.boINCHP; //ԶHPֵ
  Map.m_boDECGAMEPOINT := MapFlag.boDECGAMEPOINT; //ԶϷ
  Map.m_boINCGAMEPOINT := MapFlag.boINCGAMEPOINT; //ԶϷ
  Map.m_boEXPRATE := MapFlag.boEXPRATE; //ɱ־鱶
  Map.m_boPKWINLEVEL := MapFlag.boPKWINLEVEL; //PKõȼ
  Map.m_boPKWINEXP := MapFlag.boPKWINEXP; //PKþ
  Map.m_boPKLOSTLEVEL := MapFlag.boPKLOSTLEVEL;
  Map.m_boPKLOSTEXP := MapFlag.boPKLOSTEXP;
  Map.m_nPKWINLEVEL := MapFlag.nPKWINLEVEL; //PKõȼ
  Map.m_nPKWINEXP := MapFlag.nPKWINEXP; //PKþ
  Map.m_nPKLOSTLEVEL := MapFlag.nPKLOSTLEVEL;
  Map.m_nPKLOSTEXP := MapFlag.nPKLOSTEXP;
  Map.m_nPKWINEXP := MapFlag.nPKWINEXP; //PKþ
  Map.m_nDECHPTIME := MapFlag.nDECHPTIME; //HPʱ
  Map.m_nDECHPPOINT := MapFlag.nDECHPPOINT; //һμ
  Map.m_nINCHPTIME := MapFlag.nINCHPTIME; //HPʱ
  Map.m_nINCHPPOINT := MapFlag.nINCHPPOINT; //һμӵ
  Map.m_nDECGAMEGOLDTIME := MapFlag.nDECGAMEGOLDTIME; //ϷҼʱ
  Map.m_nDecGameGold := MapFlag.nDECGAMEGOLD; //һμ
  Map.m_nINCGAMEGOLDTIME := MapFlag.nINCGAMEGOLDTIME; //ϷҼʱ
  Map.m_nIncGameGold := MapFlag.nINCGAMEGOLD; //һμ
  Map.m_nINCGAMEPOINTTIME := MapFlag.nINCGAMEPOINTTIME; //ϷҼʱ
  Map.m_nINCGAMEPOINT := MapFlag.nINCGAMEPOINT; //һμ
  Map.m_nEXPRATE := MapFlag.nEXPRATE; //鱶

  Map.sNoReconnectMap := MapFlag.sReConnectMap;
  Map.QuestNPC := QuestNPC;
  Map.nNEEDSETONFlag := MapFlag.nNEEDSETONFlag;
  Map.nNeedONOFF := MapFlag.nNeedONOFF;

  Map.m_boUnAllowFireMagic := MapFlag.boNOFIREMAGIC; //ʹûǽ

  if (MapFlag.boUnAllowStdItems) and (MapFlag.sUnAllowStdItemsText <> '') then begin
    Map.m_boUnAllowStdItems := True;
    Map.m_UnAllowStdItemsList := TGStringList.Create;
    TempList := TStringList.Create;
    ExtractStrings(['|', '\', '/'], [], PChar(Trim(MapFlag.sUnAllowStdItemsText)), TempList);
    for I := 0 to TempList.Count - 1 do begin
      nStd := UserEngine.GetStdItemIdx(Trim(TempList.Strings[I]));
      if nStd >= 0 then
        Map.m_UnAllowStdItemsList.AddObject(Trim(TempList.Strings[I]), TObject(nStd));
    end;
    TempList.Free;
  end;

  for I := 0 to g_MiniMapList.Count - 1 do begin
    if CompareText(g_MiniMapList.Strings[I], Map.sMapName) = 0 then begin
      Map.m_nMinMap := Integer(g_MiniMapList.Objects[I]);
      break;
    end;
  end;
  if not DirectoryExists(g_Config.sMapDir) then g_Config.sMapDir := 'D:\Ѫ\Map\';
  if not DirectoryExists(g_Config.sMapDir) then g_Config.sMapDir := 'G:\Ѫ\Map\';
  if not DirectoryExists(g_Config.sMapDir) then g_Config.sMapDir := 'E:\Ѫ\Map\';
  if sMainMapName <> '' then begin

    if Map.LoadMapData(g_Config.sMapDir + sMainMapName + '.map') then begin
      Result := Map;
      Self.Add(Map);
    end else begin
      MainOutMessage('ͼļ ' + g_Config.sMapDir + sMainMapName + '.map' + ' δҵ');
    end;
  end else begin
    if Map.LoadMapData(g_Config.sMapDir + sMapName + '.map') then begin
      Result := Map;
      Self.Add(Map);
    end else begin
      MainOutMessage('ͼļ ' + g_Config.sMapDir + sMapName + '.map' + ' δҵ');
    end;
  end;
end;

function TMapManager.AddMapRoute(sSMapNO: string; nSMapX, nSMapY: Integer; sDMapNO: string; nDMapX, nDMapY: Integer): Boolean;
var
  GateObj: pTGateObj;
  SMap: TMap;
  DMap: TMap;
begin
  Result := False;

  SMap := FindMap(sSMapNO);
  DMap := FindMap(sDMapNO);
  if (SMap <> nil) and (DMap <> nil) then begin
    New(GateObj);
    GateObj.boFlag := False;
    GateObj.DMap := DMap;
    GateObj.nDMapX := nDMapX;
    GateObj.nDMapY := nDMapY;
    SMap.AddToMap(nSMapX, nSMapY, MotGate, TObject(GateObj));
    Result := True;
  end;
  {if Pos('3',SMap.sMapName) > 0 then
  MainOutMessage('AddMapRoute ' + SMap.sMapName + ':'+DMap.sMapName); }
end;






{==============================================================================
         tttttttt                        a            ppppp         
            t           m     m         a  a          p   p         
            t          m  m  m m       a a a a        ppppp         
            t         m    m    m     a       a       p         
==============================================================================}








function TMap.AddToMap(nX, nY: SmallInt; aType: TMapObjType;
  pRemoveObject: TObject): Pointer;
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  MapItem: PTMapItem;
  I: Integer;
  nGoldCount: Integer;
  bo1E: Boolean;
  btRaceServer: Byte;
const
  sExceptionMsg = '[쳣!!] TEnvirnoment::AddToMap';
begin
  Result := nil;
  try
    bo1E := False;
    if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
      if MapCellInfo.ObjList = nil then begin
        MapCellInfo.ObjList := TSimpleList.Create;
      end else begin
        if aType = MotItem then begin
          if PTMapItem(pRemoveObject).Name = g_Config.sGoldName then begin
            for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
              OSObject := MapCellInfo.ObjList.Items[I];
              if (OSObject <> nil) and (OSObject.MapObjType = MotItem) then begin
                MapItem := PTMapItem(pTOSObject(MapCellInfo.ObjList.Items[I]).CellObj);
                if MapItem.Name = g_Config.sGoldName then begin
                  nGoldCount := MapItem.Count + PTMapItem(pRemoveObject).Count;
                  if nGoldCount <= 2000 then begin
                    MapItem.Count := nGoldCount;
                    MapItem.Looks := GetGoldShape(nGoldCount);
                    MapItem.AniCount := 0;
                    MapItem.Reserved := 0;
                    OSObject.dwAddToMapTime := GetTickCount();
                    Result := MapItem;
                    bo1E := True;
                  end;
                end;
              end;
            end; //004B653D
          end; //btType = OS_ITEMOBJECT
          if not bo1E and (MapCellInfo.ObjList.Count >= 5) then begin
            Result := nil;
            bo1E := True;
          end; //004B6558
        end; //004B6558
        if aType = MotEvent then begin
          //MapCellInfo.ObjList.Add(pRemoveObject);
        end;
      end; //004B655C
      if not bo1E then begin
        New(OSObject);
        OSObject.MapObjType := aType;
        OSObject.CellObj := pRemoveObject;
        OSObject.dwAddToMapTime := GetTickCount();
        MapCellInfo.ObjList.Add(OSObject);
        Result := Pointer(pRemoveObject);

        if (aType = MotAct) and
           (not TBaseObject(pRemoveObject).m_boAddToMaped) then begin
          TBaseObject(pRemoveObject).m_boDelFormMaped := False;
          TBaseObject(pRemoveObject).m_boAddToMaped := True;
          btRaceServer := TBaseObject(pRemoveObject).m_btRaceServer;

          if btRaceServer = RC_PLAYOBJECT then begin
            //if m_boNotShowName then begin
              TPlayObject(pRemoveObject).RefShowName();
              if m_btAttackMode <> 255 then
                TPlayObject(pRemoveObject).CmdChangeAttackMode(0);
            //end;
            //m_boNotSay
            Inc(m_nHumCount);
          end;
          if btRaceServer >= RC_ANIMAL then
          Inc(m_nMonCount);
        end;
      end;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
end;

function TMap.AllowStdItems(sItemName: string): Boolean; //ǷʹƷ
var
  I: Integer;
begin
  Result := True;
  if (not m_boUnAllowStdItems) or (m_UnAllowStdItemsList = nil) then Exit;
  m_UnAllowStdItemsList.Lock;
  try
    for I := 0 to m_UnAllowStdItemsList.Count - 1 do begin
      if CompareText(m_UnAllowStdItemsList.Strings[I], sItemName) = 0 then begin
        Result := False;
        break;
      end;
    end;
  finally
    m_UnAllowStdItemsList.UnLock;
  end;
end;

function TMap.AllowStdItems(nItemIdx: Integer): Boolean; //ǷʹƷ
var
  I: Integer;
begin
  Result := True;
  if (not m_boUnAllowStdItems) or (m_UnAllowStdItemsList = nil) then Exit;
  m_UnAllowStdItemsList.Lock;
  try
    for I := 0 to m_UnAllowStdItemsList.Count - 1 do begin
      if Integer(m_UnAllowStdItemsList.Objects[I]) = nItemIdx then begin
        Result := False;
        break;
      end;
    end;
  finally
    m_UnAllowStdItemsList.UnLock;
  end;
end;

procedure TMap.AddDoorToMap();
var
  I: Integer;
  Door: pTDoorInfo;
begin
  for I := 0 to m_DoorList.Count - 1 do begin
    Door := m_DoorList.Items[I];
    AddToMap(Door.nX, Door.nY, MotDoor, TObject(Door));
  end;
end;

function TMap.GetMapCellInfo(nX, nY: SmallInt; var MapCellInfo: pTMapCellinfo;BoNeedCanMove:Boolean): Boolean; //004B57D8
begin
  Result := False;
  if (nX >= 0) and (nX < m_nWidth) and
     (nY >= 0) and (nY < m_nHeight) then begin
    MapCellInfo := @MapCellArray[nX * m_nHeight + nY];
    Result := True;
  end;
  if BoNeedCanMove and Result then //ȡɹ Ҫ ߶
   Result := not IsBitOn(MapCellInfo.chCellFlag, McfNotCanMove);

end;



{ƶͼеһ ֺ}

{boFlag False ʾ 
TBaseObject.RunTo,TPlayObject.HorseRunTo  ȫtrue
TBaseObject.CharPushed ҰFalse
 ȫ }

{Result > 0   ʾƶOK}

function TMap.ActMoveToXY(nNowX, nNowY: SmallInt; Obj: TObject; nDesX, nDesY: SmallInt; boFlag: Boolean): Integer; //004B612C
var
  MapCellInfo: pTMapCellinfo;
  BaseObject: TBaseObject;
  OSObject: pTOSObject;
  I,Code: Integer;
  boGetInfOk:Boolean;
  boNotOut: Boolean;
const
  sExceptionMsg = '[쳣!!] TEnvirnoment::MoveToMovingObject code %d Cell%p BObj %p OSObj%p Cert%p';
label
  Loop, Over;
begin
  Result := 0;
  try
    {GetMapCellInfo ֻⷶΧ ڵͼΧھOK}
    boNotOut := True;
    Code := 0;
    //
    boGetInfOk := GetMapCellInfo(nDesX, nDesY, MapCellInfo,True);
    if not boFlag and boGetInfOk then begin
      Code := 1;
      //if MapCellInfo.chCellFlag = 0 then begin
        Code := 2;
        if MapCellInfo.ObjList <> nil then begin
          Code := 3;
          for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
            Code := 4;
            with pTOSObject(MapCellInfo.ObjList[I])^ do begin
              if MapObjType = MotAct then begin
                Code := 5;
                BaseObject := TBaseObject(CellObj);
                if BaseObject <> nil then begin
                  Code := 6;
                  if not BaseObject.m_boGhost
                    //and BaseObject.bo2B9
                    and not BaseObject.m_boDeath
                    and not BaseObject.m_boFixedHideMode
                    and not BaseObject.m_boObMode then begin
                    boNotOut := False;
                    break;
                  end;
                end;
              end;
            end;
          end;
        end;
      end else begin //if MapCellInfo.chFlag = 0 then begin
        Result := -1;
        boNotOut := boGetInfOk;
      //end;
    end;//if not boFlag and GetMapCellInfo(nX, nY, MapCellInfo) then
    Code := 7;
    if boNotOut then begin
      {if boGetInfOk and (MapCellInfo.chCellFlag <> 0) then begin //ƶ ٴʧ
        Code := 8;
        Result := -1;
      end else begin }//
        Code := 9;
        if GetMapCellInfo(nNowX, nNowY, MapCellInfo) and
          (MapCellInfo.ObjList <> nil) then begin
          Code := 10;
          I := 0;
          while (True) do begin
            if MapCellInfo.ObjList.Count <= I then break;
            Code := 11;
            OSObject := MapCellInfo.ObjList.Items[I];
            Code := 12;
            if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
              Code := 13;
              if OSObject.CellObj = Obj then begin
                Code := 14;
                MapCellInfo.ObjList.Delete(I);
                Code := 15;
                DisPoseAndNil(OSObject);
                Code := 16;
                //if MapCellInfo.ObjList.Count > 0 then Continue;
                Code := 17;
                if MapCellInfo.ObjList.Count <= 0 then begin
                  Code := 18;
                  FreeAndNil(MapCellInfo.ObjList);
                end;
                break;
              end;
            end;
            Inc(I);
          end;
        end;
        Code := 19;
        if GetMapCellInfo(nDesX, nDesY, MapCellInfo) then begin
          Code := 20;
          if (MapCellInfo.ObjList = nil) then begin
            Code := 21;
            MapCellInfo.ObjList := TSimpleList.Create;
          end;
          Code := 22;
          New(OSObject);
          Code := 23;
          OSObject.MapObjType := MotAct;
          OSObject.CellObj := Obj;
          OSObject.dwAddToMapTime := GetTickCount;
          Code := 24;
          MapCellInfo.ObjList.Add(OSObject);
          Result := 1;
        end;
      //end;
    end;
  except
    on E: Exception do begin
      MainOutMessage(format(sExceptionMsg,[code,MapCellInfo,BaseObject,OSObject,Obj]));
      MainOutMessage(E.Message);
    end;
  end;
end;



//======================================================================
//ͼָǷƶ
//boFlag  ΪTRUE Ƿнɫ
//ֵ True ΪƶFalse Ϊƶ
//======================================================================
{
TBaseObject.Initialize;CanWalk(m_nCurrX, m_nCurrY, True)
}
function TMap.CanWalk(nX, nY: SmallInt; boFlag: Boolean): Boolean;
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
  I: Integer;
begin
  Result := False;//Ĭϲƶ
  if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
    Result := True;
    if not boFlag and (MapCellInfo.ObjList <> nil) then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList.Items[I];
        if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
          BaseObject := TBaseObject(OSObject.CellObj);
          if BaseObject <> nil then begin
            if not BaseObject.m_boGhost
              //and BaseObject.bo2B9
              and not BaseObject.m_boDeath
              and not BaseObject.m_boFixedHideMode
              and not BaseObject.m_boObMode then begin
              Result := False;
              break;
            end;
          end;
        end;
      end;
    end;
  end;
end;

//======================================================================
//ͼָǷƶ
//boFlag  ΪTRUE Ƿнɫ
//ֵ True ΪƶFalse Ϊƶ
//======================================================================

function TMap.CanWalkOfItem(nX, nY: SmallInt; boFlag, boItem: Boolean): Boolean;
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
  I: Integer;
begin
  Result := True;
  if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
    //    Result:=True;
    if (MapCellInfo.ObjList <> nil) then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList.Items[I];
        if not boFlag and (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
          BaseObject := TBaseObject(OSObject.CellObj);
          if BaseObject <> nil then begin
            if not BaseObject.m_boGhost
              //and BaseObject.bo2B9
            and not BaseObject.m_boDeath
              and not BaseObject.m_boFixedHideMode
              and not BaseObject.m_boObMode then begin
              Result := False;
              break;
            end;
          end;
        end;
        if not boItem and (OSObject.MapObjType = MotItem) then begin
          Result := False;
          break;
        end;
      end;
    end;
  end;
end;

function TMap.CanWalkEx(nX, nY: SmallInt; boFlag: Boolean): Boolean;
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
  I: Integer;
  Castle: TUserCastle;
begin
  Result := False;
  if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
    Result := True;
    if not boFlag and (MapCellInfo.ObjList <> nil) then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList[I];
        if OSObject <> nil then begin
          if OSObject.MapObjType = MotAct then begin
            BaseObject := TBaseObject(OSObject.CellObj);
            if BaseObject <> nil then begin
              {//01/25 Ǳ 
              if g_Config.boWarDisHumRun and UserCastle.m_boUnderWar and
                UserCastle.InCastleWarArea(BaseObject.m_PEnvir,BaseObject.m_nCurrX,BaseObject.m_nCurrY) then begin
              }
              Castle := g_CastleManager.InCastleWarArea(BaseObject);
              if g_Config.boWarDisHumRun and
              (Castle <> nil) and (Castle.m_boUnderWar) then begin
              end else begin
                if BaseObject.m_btRaceServer = RC_PLAYOBJECT then begin
                  if g_Config.boRUNHUMAN or m_boRUNHUMAN then Continue;
                end else begin
                  if BaseObject.m_btRaceServer = RC_NPC then begin
                    if g_Config.boRunNpc then Continue;
                  end else begin
                    if BaseObject.m_btRaceServer in [RC_GUARD, RC_ARCHERGUARD] then begin
                      if g_Config.boRunGuard then Continue;
                    end else begin
                      if BaseObject.m_btRaceServer <> 55 then begin //ʦ
                        if g_Config.boRUNMON or m_boRUNMON then Continue;
                      end;
                    end;
                  end;
                end;
              end;
              if not BaseObject.m_boGhost
                //and BaseObject.bo2B9
              and not BaseObject.m_boDeath
                and not BaseObject.m_boFixedHideMode
                and not BaseObject.m_boObMode then begin
                Result := False;
                break;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

constructor TMapManager.Create;
begin

  inherited Create;
end;

destructor TMapManager.Destroy;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do begin
    TMap(Items[I]).Free;
  end;

  inherited;
end;
//Envir:TEnvirnoment

function TMapManager.GetMainMap(Map: TMap): string;
begin
  if Map.m_boMainMap then Result := Map.sMainMapName
  else Result := Map.sMapName;
end;

function TMapManager.FindMap(sMapName: string): TMap;
var
  Map: TMap;
  I: Integer;
begin
  Result := nil;
  Lock;
  try
    for I := 0 to Count - 1 do begin
      Map := TMap(Items[I]);
      if CompareText(Map.sMapName, sMapName) = 0 then begin
        Result := Map;
        break;
      end;
    end;
  finally
    UnLock;
  end;
end;

function TMapManager.GetMapInfo(nServerIdx: Integer; sMapName: string): TMap;
var
  I: Integer;
  Map: TMap;
begin
  Result := nil;
  Lock;
  try
    for I := 0 to Count - 1 do begin
      Map := Items[I];
      if (Map.nServerIndex = nServerIdx) and (CompareText(Map.sMapName, sMapName) = 0) then begin
        Result := Map;
        break;
      end;
    end;
  finally
    UnLock;
  end;
end;



function TMapManager.GetMapOfServerIndex(sMapName: string): Integer;
var
  I: Integer;
  Map: TMap;
begin
  Result := 0;
  Lock;
  try
    for I := 0 to Count - 1 do begin
      Map := Items[I];
      if (CompareText(Map.sMapName, sMapName) = 0) then begin
        Result := Map.nServerIndex;
        break;
      end;
    end;
  finally
    UnLock;
  end;
end;

procedure TMapManager.LoadMapDoor;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do begin
    TMap(Items[I]).AddDoorToMap;
  end;
end;

procedure TMapManager.ProcessMapDoor;
begin

end;

procedure TMapManager.ReSetMinMap;
var
  I, ii: Integer;
  Map: TMap;
begin
  for I := 0 to Count - 1 do begin
    Map := TMap(Items[I]);
    for ii := 0 to g_MiniMapList.Count - 1 do begin
      if CompareText(g_MiniMapList.Strings[ii], Map.sMapName) = 0 then begin
        Map.m_nMinMap := Integer(g_MiniMapList.Objects[ii]);
        break;
      end;
    end;
  end;
end;
function TMap.DeleteFromMap(nX, nY: SmallInt; aType: TMapObjType;
  pRemoveObject: TObject): Integer;
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  n18: Integer;
  btRaceServer: Byte;
const
  sExceptionMsg1 = '[쳣!!] TEnvirnoment::DeleteFromMap -> Except 1 ** %d';
  sExceptionMsg2 = '[쳣!!] TEnvirnoment::DeleteFromMap -> Except 2 ** %d';
begin
  Result := -1;
  try
    if GetMapCellInfo(nX, nY, MapCellInfo) then begin
      if MapCellInfo <> nil then begin
        try
          if MapCellInfo.ObjList <> nil then begin
            n18 := 0;
            while (True) do begin
              if MapCellInfo.ObjList.Count <= n18 then break;
              OSObject := MapCellInfo.ObjList.Items[n18];
              if OSObject <> nil then begin
                if (OSObject.MapObjType = aType) and
                (OSObject.CellObj = pRemoveObject) then begin
                  DisPoseAndNil(OSObject);
                  MapCellInfo.ObjList.Delete(n18);
                  Result := 1;
                  //ͼ
                  if (aType = MotAct) and (not TBaseObject(pRemoveObject).m_boDelFormMaped) then begin
                    TBaseObject(pRemoveObject).m_boDelFormMaped := True;
                    TBaseObject(pRemoveObject).m_boAddToMaped := False;
                    btRaceServer := TBaseObject(pRemoveObject).m_btRaceServer;
                    if btRaceServer = RC_PLAYOBJECT then Dec(m_nHumCount);
                    if btRaceServer >= RC_ANIMAL then Dec(m_nMonCount);
                  end;
                  if MapCellInfo.ObjList.Count <= 0 then  begin
                  {FreeAndNil(MapCellInfo.ObjList);
                  break; }
                  //Jacky ֹڴй¶ д
                  FreeAndNil(MapCellInfo.ObjList);
                  end;
                  Break;
                end
              end else begin
                MapCellInfo.ObjList.Delete(n18);

                if MapCellInfo.ObjList.Count > 0 then Continue;

                FreeAndNil(MapCellInfo.ObjList);
                break;
              end;
              Inc(n18);
            end;
          end else begin
            Result := -2;
          end;
        except
          OSObject := nil;
          MainOutMessage(format(sExceptionMsg1, [Byte(aType)]));
        end;
      end else Result := -3;
    end else Result := 0;
  except
    MainOutMessage(format(sExceptionMsg2, [Byte(aType)]));
  end;
end;

function TMap.GetItem(nX, nY: SmallInt): PTMapItem;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  Result := nil;
  bo2C := False;
  if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
    bo2C := True;
    if MapCellInfo.ObjList <> nil then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList.Items[I];
        if OSObject <> nil then begin
          if OSObject.MapObjType = MotItem then begin
            Result := PTMapItem(OSObject.CellObj);
            Exit;
          end;
          if OSObject.MapObjType = MotGate then
            bo2C := False;
          if OSObject.MapObjType = MotAct then begin
            BaseObject := TBaseObject(OSObject.CellObj);
            if not BaseObject.m_boDeath then
              bo2C := False;
          end;
        end;
      end;
    end;
  end;
end;
function TMap.IsCheapStuff: Boolean; //004B6E24
begin
  if m_QuestList.Count > 0 then Result := True
  else Result := False;
end;

function TMap.AddToMapMineEvent(nX, nY: SmallInt; aType: TMapObjType; Event: TObject): TObject; //004B6600
var
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  bo19, bo1A: Boolean;
const
  sExceptionMsg = '[쳣!!] TEnvirnoment::AddToMapMineEvent ';
begin
  Result := nil;
  try
    bo19 := GetMapCellInfo(nX, nY, MapCellInfo);
    bo1A := False;
    if bo19 and (MapCellInfo.chCellFlag <> 0) then begin
      if MapCellInfo.ObjList = nil then MapCellInfo.ObjList := TSimpleList.Create;
      if not bo1A then begin
        New(OSObject);
        OSObject.MapObjType := aType;
        OSObject.CellObj := Event;
        OSObject.dwAddToMapTime := GetTickCount();
        MapCellInfo.ObjList.Add(OSObject);
        Result := Event;
      end;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
end;

procedure TMap.VerifyMapTime(nX, nY: SmallInt; BaseObject: TObject);
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  boVerify: Boolean;
const
  sExceptionMsg = '[쳣!!] TEnvirnoment::VerifyMapTime';
begin
  try
    boVerify := False;
    if GetMapCellInfo(nX, nY, MapCellInfo) and
      (MapCellInfo <> nil) and (MapCellInfo.ObjList <> nil) then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList.Items[I];
        if (OSObject <> nil) and
           (OSObject.MapObjType = MotAct) and
           (OSObject.CellObj = BaseObject) then begin
          OSObject.dwAddToMapTime := GetTickCount();
          boVerify := True;
          break;
        end;
      end;
    end;
    if not boVerify then
      AddToMap(nX, nY, MotAct, BaseObject);
  except
    MainOutMessage(sExceptionMsg);
  end;
end;

constructor TMap.Create; //004B5318
begin
  MapCellArray := nil;
  m_pStartPoint:= nil;
  sMapName := '';
  sSubMapName := '';
  sMainMapName := '';
  m_boMainMap := False;
  nServerIndex := 0;
  m_nMinMap := 0;
  m_nWidth := 0;
  m_nHeight := 0;
  m_boDARK := False;
  m_boDAY := False;
  m_nMonCount := 0;
  m_nHumCount := 0; ;
  m_DoorList := TList.Create;
  m_QuestList := TList.Create;
end;

destructor TMap.Destroy;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  nX, nY: Integer;
  DoorInfo: pTDoorInfo;
begin
  for nX := 0 to m_nWidth - 1 do begin
    for nY := 0 to m_nHeight - 1 do begin
      if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
        for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
          OSObject := MapCellInfo.ObjList.Items[I];
          case OSObject.MapObjType of
            MotItem: DisPose(PTMapItem(OSObject.CellObj));
            MotGate: DisPose(pTGateObj(OSObject.CellObj));
            MotEvent: TEvent(OSObject.CellObj).Free;
            //͹ֲڴͷ...
          end;
          DisPoseAndNil(OSObject);
        end;
        FreeAndNil(MapCellInfo.ObjList);
      end;
    end;
  end;

  for I := 0 to m_DoorList.Count - 1 do begin
    DoorInfo := m_DoorList.Items[I];
    Dec(DoorInfo.Status.nRefCount);
    if DoorInfo.Status.nRefCount <= 0 then
      DisPose(DoorInfo.Status);

    DisPose(DoorInfo);
  end;
  m_DoorList.Free;
  for I := 0 to m_QuestList.Count - 1 do begin
    DisPose(pTMapQuestInfo(m_QuestList.Items[I]));
  end;
  m_QuestList.Free;
  FreeMem(MapCellArray);
  //FreeMem(MapCellArray);
  MapCellArray := nil;
  inherited;
end;



function TMap.LoadMapData(sMapFile: string): Boolean; //004B54E0
var
  fHandle: Integer;
  Header: TMapHeader;
  nMapSize: Integer;
  n24, nW, nH: Integer;
  MapBuffer: pTMapArr;
  Point: Integer;
  Door: pTDoorInfo;
  I: Integer;
  MapCellInfo: pTMapCellinfo;
begin
  Result := False;
  if FileExists(sMapFile) then begin
    fHandle := FileOpen(sMapFile, fmOpenRead or fmShareExclusive);
    if fHandle > 0 then begin
      FileRead(fHandle, Header, SizeOf(TMapHeader));
      m_nWidth := Header.wWidth;
      m_nHeight := Header.wHeight;
      Initialize(m_nWidth, m_nHeight);
      nMapSize := m_nWidth * SizeOf(TMapUnitInfo) * m_nHeight;

      MapBuffer := AllocMem(nMapSize);
      FileRead(fHandle, MapBuffer^, nMapSize);

      for nW := 0 to m_nWidth - 1 do begin
        n24 := nW * m_nHeight;
        for nH := 0 to m_nHeight - 1 do begin
          if (MapBuffer[n24 + nH].wBkImg) and $8000 <> 0 then begin
            MapCellInfo := @MapCellArray[n24 + nH];
            MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMove, True);
          end; //004B5601
          if MapBuffer[n24 + nH].wFrImg and $8000 <> 0 then begin
            MapCellInfo := @MapCellArray[n24 + nH];
            MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMagicMove, True);
          end; //004B562C
          if MapBuffer[n24 + nH].btDoorIndex and $80 <> 0 then begin
            Point := (MapBuffer[n24 + nH].btDoorIndex and $7F);
            if Point > 0 then begin                       //1111111
              New(Door);
              Door.nX := nW;
              Door.nY := nH;
              Door.n08 := Point;
              Door.Status := nil;
              for I := 0 to m_DoorList.Count - 1 do begin
                if abs(pTDoorInfo(m_DoorList[I]).nX - Door.nX) <= 10 then begin
                  if abs(pTDoorInfo(m_DoorList[I]).nY - Door.nY) <= 10 then begin
                    if pTDoorInfo(m_DoorList[I]).n08 = Point then begin
                      Door.Status := pTDoorInfo(m_DoorList[I]).Status;
                      Inc(Door.Status.nRefCount);
                      break;
                    end;
                  end;
                end;
              end; //004B5730
              if Door.Status = nil then begin
                New(Door.Status);
                Door.Status.boOpened := False;
                Door.Status.bo01 := False;
                Door.Status.n04 := 0;
                Door.Status.dwOpenTick := 0;
                Door.Status.nRefCount := 1;
              end;
              m_DoorList.Add(Door);
            end; //004B5780
          end;
        end; //004B578C
      end; //004B5798
      //Dispose(MapBuffer);

      FreeMem(MapBuffer);

      FileClose(fHandle);
      Result := True;
    end; //004B57B1
  end; //004B57B1
end;

procedure TMap.Initialize(nWidth, nHeight: SmallInt); //004B53FC
var
  nW, nH: Integer;
  MapCellInfo: pTMapCellinfo;
begin
  if (nWidth > 1) and (nHeight > 1) then begin
    if MapCellArray <> nil then begin
      for nW := 0 to m_nWidth - 1 do begin
        for nH := 0 to m_nHeight - 1 do begin
          MapCellInfo := @MapCellArray[nW * m_nHeight + nH];
          if MapCellInfo.ObjList <> nil then begin
            FreeAndNil(MapCellInfo.ObjList);
          end;
        end;
      end;
      FreeMem(MapCellArray);
     // FreeMem(MapCellArray);
      MapCellArray := nil;
    end; //004B54AF
    m_nWidth := nWidth;
    m_nHeight := nHeight;
    GetMem(MapCellArray,(m_nWidth * m_nHeight) * SizeOf(TMapCellinfo));
    FillChar(MapCellArray^,(m_nWidth * m_nHeight) * SizeOf(TMapCellinfo),0);
  end; //004B54DB
end;

//nFlag,boFlag,Monster,Item,Quest,boGrouped

function TMap.CreateQuest(nFlag, nValue: Integer; s24, s28, s2C: string;
  boGrouped: Boolean): Boolean; //004B6C3C
var
  MapQuest: pTMapQuestInfo;
  MapMerchant: TMerchant;
begin
  Result := False;
  if nFlag < 0 then Exit;
  New(MapQuest);
  MapQuest.nFlag := nFlag;
  if nValue > 1 then nValue := 1;
  MapQuest.nValue := nValue;
  if s24 = '*' then s24 := '';
  MapQuest.s08 := s24;
  if s28 = '*' then s28 := '';
  MapQuest.s0C := s28;
  if s2C = '*' then s2C := '';

  MapQuest.bo10 := boGrouped;
  MapMerchant := TMerchant.Create;
  MapMerchant.m_sMapName := '3';
  MapMerchant.m_nCurrX := 0;
  MapMerchant.m_nCurrY := 0;
  MapMerchant.m_sCharName := s2C;
  MapMerchant.m_nNPCFlag := 0;
  MapMerchant.m_wAppr := 0;
  MapMerchant.m_sFilePath := 'MapQuest_def\';
  MapMerchant.m_boIsHide := True;
  MapMerchant.m_boIsQuest := False;

  UserEngine.QuestNPCList.Add(MapMerchant);
  MapQuest.NPC := MapMerchant;
  m_QuestList.Add(MapQuest);
  Result := True;
end;

function TMap.GetXYObjCount(nX, nY: SmallInt): Integer;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  Result := 0;
  if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
        BaseObject := TBaseObject(OSObject.CellObj);
        if BaseObject <> nil then begin
          if not BaseObject.m_boGhost and
            //BaseObject.bo2B9 and
          not BaseObject.m_boDeath and
            not BaseObject.m_boFixedHideMode and
            not BaseObject.m_boObMode then begin
            Inc(Result);
          end;
        end;
      end;
    end;
  end;
end;

function TMap.GetNextPosition(sX, sY, nDir, nFlag: SmallInt; var snx: SmallInt; var sny: SmallInt): Boolean;
begin
  snx := sX;
  sny := sY;
  case nDir of
    DR_UP: if sny > nFlag - 1 then Dec(sny, nFlag);
    DR_DOWN: if sny < (m_nHeight - nFlag) then Inc(sny, nFlag);
    DR_LEFT: if snx > nFlag - 1 then Dec(snx, nFlag);
    DR_RIGHT: if snx < (m_nWidth - nFlag) then Inc(snx, nFlag);
    DR_UPLEFT: begin
        if (snx > nFlag - 1) and (sny > nFlag - 1) then begin
          Dec(snx, nFlag);
          Dec(sny, nFlag);
        end;
      end;
    DR_UPRIGHT: begin //004B2B77
        if (snx > nFlag - 1) and (sny < (m_nHeight - nFlag)) then begin
          Inc(snx, nFlag);
          Dec(sny, nFlag);
        end;
      end;
    DR_DOWNLEFT: begin //004B2BAC
        if (snx < (m_nWidth - nFlag)) and (sny > nFlag - 1) then begin
          Dec(snx, nFlag);
          Inc(sny, nFlag);
        end;
      end;
    DR_DOWNRIGHT: begin
        if (snx < (m_nWidth - nFlag)) and (sny < (m_nHeight - nFlag)) then begin
          Inc(snx, nFlag);
          Inc(sny, nFlag);
        end;
      end;
  end;
  if (snx = sX) and (sny = sY) then Result := False
  else Result := True;

end;

function TMap.CanSafeWalk(nX, nY: SmallInt): Boolean;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
begin
  Result := True;
  if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := MapCellInfo.ObjList.Count - 1 downto 0 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotEvent) then begin
        if TEvent(OSObject.CellObj).m_nDamage > 0 then Result := False;
      end;
    end;
  end;
end;

function TMap.ArroundDoorOpened(nX, nY: SmallInt): Boolean;
var
  I: Integer;
  Door: pTDoorInfo;
const
  sExceptionMsg = '[쳣!!] TMap::ArroundDoorOpened ';
begin
  Result := True;
  try
    for I := 0 to m_DoorList.Count - 1 do begin
      Door := m_DoorList.Items[I];
      if (abs(Door.nX - nX) <= 1) and ((abs(Door.nY - nY) <= 1)) then begin
        if not Door.Status.boOpened then begin
          Result := False;
          break;
        end;
      end;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
end;

function TMap.GetMovingObject(nX, nY: SmallInt; boFlag: Boolean): Pointer;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  Result := nil;
  if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
        BaseObject := TBaseObject(OSObject.CellObj);
        if ((BaseObject <> nil) and
          (not BaseObject.m_boGhost) { and
          (BaseObject.bo2B9)}) and
          ((not boFlag) or (not BaseObject.m_boDeath)) then begin

          Result := BaseObject;
          break;
        end;
      end;
    end;
  end;
end;

function TMap.GetQuestNPC(BaseObject: TObject; sCharName, sStr: string; boFlag: Boolean): TObject; //004B6E4C
var
  I: Integer;
  MapQuestFlag: pTMapQuestInfo;
  nFlagValue: Integer;
  bo1D: Boolean;
begin
  Result := nil;
  for I := 0 to m_QuestList.Count - 1 do begin
    MapQuestFlag := m_QuestList.Items[I];
    nFlagValue := TBaseObject(BaseObject).GetQuestFalgStatus(MapQuestFlag.nFlag);
    if nFlagValue = MapQuestFlag.nValue then begin
      if (boFlag = MapQuestFlag.bo10) or (not boFlag) then begin
        bo1D := False;
        if (MapQuestFlag.s08 <> '') and (MapQuestFlag.s0C <> '') then begin
          if (MapQuestFlag.s08 = sCharName) and (MapQuestFlag.s0C = sStr) then
            bo1D := True;
        end;
        if (MapQuestFlag.s08 <> '') and (MapQuestFlag.s0C = '') then begin
          if (MapQuestFlag.s08 = sCharName) and (sStr = '') then
            bo1D := True;
        end;
        if (MapQuestFlag.s08 = '') and (MapQuestFlag.s0C <> '') then begin
          if (MapQuestFlag.s0C = sStr) then
            bo1D := True;
        end;
        if bo1D then begin
          Result := MapQuestFlag.NPC;
          break;
        end;
      end;
    end;
  end;
end;

function TMap.GetItemEx(nX, nY: SmallInt;
  var nCount: Integer): Pointer;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  Result := nil;
  nCount := 0;
  bo2C := False;
  if GetMapCellInfo(nX, nY, MapCellInfo,True) then begin
    bo2C := True;
    if MapCellInfo.ObjList <> nil then begin
      for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
        OSObject := MapCellInfo.ObjList[I];
        if OSObject <> nil then begin
          case OSObject.MapObjType of
            MotItem:begin
              Result := Pointer(OSObject.CellObj);
              Inc(nCount);
            end;
            MotGate:begin
              bo2C := False;
            end;
            MotAct:begin
              BaseObject := TBaseObject(OSObject.CellObj);
              if not BaseObject.m_boDeath then
                bo2C := False;
            end;
          end;
        end;
      end;
    end;
  end;

end;

function TMap.GetDoor(nX, nY: SmallInt): pTDoorInfo;
var
  I: Integer;
  Door: pTDoorInfo;
begin
  Result := nil;
  for I := 0 to m_DoorList.Count - 1 do begin
    Door := m_DoorList.Items[I];
    if (Door.nX = nX) and (Door.nY = nY) then begin
      Result := Door;
      Exit;
    end;
  end;
end;

function TMap.IsValidObject(nX, nY, nRage: SmallInt; BaseObject: TObject): Boolean;
var
  nXX, nYY, I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
begin
  Result := False;
  for nXX := nX - nRage to nX + nRage do begin
    for nYY := nY - nRage to nY + nRage do begin
      if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
        for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
          OSObject := MapCellInfo.ObjList.Items[I];
          if (OSObject <> nil) and (OSObject.CellObj = BaseObject) then begin
            Result := True;
            Exit;
          end;
        end;
      end;
    end;
  end;
end;

function TMap.GetRangeBaseObject(nX, nY, nRage: SmallInt; boFlag: Boolean;
  BaseObjectList: TList): Integer; //004B59C0
var
  nXX, nYY: Integer;
begin
  for nXX := nX - nRage to nX + nRage do begin
    for nYY := nY - nRage to nY + nRage do begin
      GeTBaseObjects(nXX, nYY, boFlag, BaseObjectList);
    end;
  end;
  Result := BaseObjectList.Count;
end;
//boFlag Ƿ
//FALSE 
//TRUE  

function TMap.GeTBaseObjects(nX, nY: SmallInt; boFlag: Boolean;
  BaseObjectList: TList): Integer; //004B58F8
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
        BaseObject := TBaseObject(OSObject.CellObj);
        if BaseObject <> nil then begin
          if not BaseObject.m_boGhost {and BaseObject.bo2B9} then begin
            if not boFlag or not BaseObject.m_boDeath then
              BaseObjectList.Add(BaseObject);
          end;
        end;
      end;
    end;
  end;
  Result := BaseObjectList.Count;
end;

function TMap.GetEvent(nX, nY: SmallInt): TObject;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
begin
  Result := nil;
  bo2C := False;
  if GetMapCellInfo(nX, nY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotEvent) then begin
        Result := OSObject.CellObj;
      end;
    end;
  end;
end;

procedure TMap.SetXYFlag(nX, nY: SmallInt; boFlag: Boolean);
var
  MapCellInfo: pTMapCellinfo;
begin
  if GetMapCellInfo(nX, nY, MapCellInfo) then begin
    if boFlag then begin
      MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMove, False);
      MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMagicMove,False);
    end
    else begin
      MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMove, True);
      MapCellInfo.chCellFlag := SetBitValue(MapCellInfo.chCellFlag, McfNotCanMagicMove,True);
    end;
  end;
end;

function TMap.CanFly(nSX, nSY, nDX, nDY: SmallInt): Boolean;
var
  r28, r30: real;
  n14, n18, n1C: Integer;
begin
  Result := True;
  r28 := (nDX - nSX) / 1.0E1;
  r30 := (nDY - nDX) / 1.0E1;
  n14 := 0;
  while (True) do begin
    n18 := ROUND(nSX + r28);
    n1C := ROUND(nSY + r30);
    if not CanWalk(n18, n1C, True) then begin
      Result := False;
      break;
    end;
    Inc(n14);
    if n14 >= 10 then break;
  end;
end;

{ָǷ}
function TMap.GetXYHuman(nMapX, nMapY: SmallInt): Boolean;
var
  I: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
begin
  Result := False;
  if GetMapCellInfo(nMapX, nMapY, MapCellInfo) and (MapCellInfo.ObjList <> nil) then begin
    for I := 0 to MapCellInfo.ObjList.Count - 1 do begin
      OSObject := MapCellInfo.ObjList.Items[I];
      if (OSObject <> nil) and (OSObject.MapObjType = MotAct) then begin
        BaseObject := TBaseObject(OSObject.CellObj);
        if BaseObject.m_btRaceServer = RC_PLAYOBJECT then begin
          Result := True;
          break;
        end;
      end;
    end;
  end;
end;

function TMap.MagicCanMove(nX, nY: SmallInt): Boolean;
var
  MapCellInfo: pTMapCellinfo;
begin
  Result := True;
  if GetMapCellInfo(nX, nY, MapCellInfo) and
    IsBitOn(MapCellInfo.chCellFlag, McfNotCanMagicMove)then
    Result := False;
end;

function TMap.GetEnvirInfo: string;
var
  sMsg: string;
begin
  sMsg := 'ͼ:%s(%s) :%s '+
                        'ҹ:%s '+
                        'ȫ:%s '+
                        'FIGHT:%s '+
                        'FIGHT3:%s '+
                        'QUIZ:%s '+
                        'С˻ͼ:%s(%s) '+
                        '鱶:%s(%f) '+
                        'ɱ:%s(%d) '+
                        'ɱ:%s(%d) '+
                        'ɱ˵þ:%s(%d) '+
                        'ɱ:%s(%d) '+
                        'Ѫ:%s(ʱ%d/%d) '+
                        'Ѫ:%s(ʱ%d/%d) ';

  sMsg := sMsg + //':%s(%d/%d) '+
                  //'ӽ:%s(%d/%d) '+
                  'Ϸ:%s(%d/%d) '+
                  ':%s '+
                  ':%s '+
                  'NEEDHOLE:%s '+
                  'NORECALL:%s '+
                  'NOGUILDRECALL:%s '+
                  'NODEARRECALL:%s '+
                  'NOMASTERRECALL:%s '+
                  'NODRUG:%s '+
                  'ڿ:%s '+
                  ':%s '+
                  'PKֵ:%s '+
                  ':%s '+
                  '˵:%s '+
                  'ǿƹģʽ:%d '+
                  'NOPOSITIONMOVE:%s';
  Result := format(sMsg, [sMapName,
      sMapDesc,
      BoolToCStr(m_boDAY),
      BoolToCStr(m_boDARK),
      BoolToCStr(m_boSAFE),
      BoolToCStr(m_boFightZone),
      BoolToCStr(m_boFight3Zone),
      BoolToCStr(m_boQUIZ),
      BoolToCStr(m_boNORECONNECT), sNoReconnectMap,
      BoolToCStr(m_boEXPRATE), m_nEXPRATE / 100,
      BoolToCStr(m_boPKWINLEVEL), m_nPKWINLEVEL,
      BoolToCStr(m_boPKLOSTLEVEL), m_nPKLOSTLEVEL,
      BoolToCStr(m_boPKWINEXP), m_nPKWINEXP,
      BoolToCStr(m_boPKLOSTEXP), m_nPKLOSTEXP,
      BoolToCStr(m_boDECHP), m_nDECHPTIME, m_nDECHPPOINT,
      BoolToCStr(m_boINCHP), m_nINCHPTIME, m_nINCHPPOINT,
      
      BoolToCStr(m_boINCGAMEPOINT), m_nINCGAMEPOINTTIME, m_nINCGAMEPOINT,
      BoolToCStr(m_boRUNHUMAN),
      BoolToCStr(m_boRUNMON),
      BoolToCStr(m_boNEEDHOLE),
      BoolToCStr(m_boNORECALL),
      BoolToCStr(m_boNOGUILDRECALL),
      BoolToCStr(m_boNODEARRECALL),
      BoolToCStr(m_boNOMASTERRECALL),
      BoolToCStr(m_boNODRUG),
      BoolToCStr(m_boMINE),
      BoolToCStr(m_boNotDropItem),
      BoolToCStr(m_boNotIncPKPoint),
      BoolToCStr(m_boNotShowName), //ʾ
      BoolToCStr(m_boNotSay), //˵
      m_btAttackMode,
      BoolToCStr(m_boNOPOSITIONMOVE)
      ]);
end;
procedure TMap.MakeStoneMines;
var
  nW,nH :SmallInt;
begin
      for nW := 0 to m_nWidth - 1 do begin
        for nH := 0 to m_nHeight - 1 do begin
          TStoneMineEvent.Create(Self, nW, nH, ET_STONEMINE);
        end;
      end;
end;
procedure TMap.ClearStoneMines;
var
  nW,nH :SmallInt;
begin

end;
procedure TMap.AddObject(nType: Integer);
begin
  case nType of
    0: Inc(m_nHumCount);
    1: Inc(m_nMonCount);
  end;
end;

procedure TMap.DelObjectCount(BaseObject: TObject);
var
  btRaceServer: Byte;
begin
  btRaceServer := TBaseObject(BaseObject).m_btRaceServer;
  if btRaceServer = RC_PLAYOBJECT then Dec(m_nHumCount);
  if btRaceServer >= RC_ANIMAL then Dec(m_nMonCount);
end;



end.

