unit InterMsgClient;

interface

uses
  Windows, Classes, Controls, Forms,
  JSocket;

type
  TFrmMsgClient = class(TForm)
    MsgClient: TClientSocket;
    procedure MsgClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure MsgClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure MsgClientRead(Sender: TObject; Socket: TCustomWinSocket);
  private
    dw2D4Tick: LongWord;
    sRecvMsg: string; //0x2D8
    procedure DecodeSocStr;
    { Private declarations }
  public
    procedure SendSocket(sMsg: string);
    procedure ConnectMsgServer();
    procedure Run();
    { Public declarations }
  end;

var
  FrmMsgClient: TFrmMsgClient;

implementation

uses M2Config, M2Share, HUtil32, EDcode, MirGrobal,SerGrobal;

{$R *.dfm}

{ TFrmMsgClient }

procedure TFrmMsgClient.ConnectMsgServer; //00495E68
begin
  MsgClient.Active := False;
  MsgClient.Address := g_Config.sMsgSrvAddr;
  MsgClient.Port := g_Config.nMsgSrvPort;
  dw2D4Tick := GetTickCount();
end;

procedure TFrmMsgClient.Run; //00496360
begin
  if MsgClient.Socket.Connected then begin
    DecodeSocStr();
  end else begin
    if GetTickCount - dw2D4Tick > 20 * 1000 then begin
      dw2D4Tick := GetTickCount();
      MsgClient.Active := True;
    end;
  end;
{$IF (DEBUG = 0) and (SoftVersion <> VERDEMO)}
  if IsDebuggerPresent then
    Application.Terminate;
{$IFEND}
end;

procedure TFrmMsgClient.DecodeSocStr; //00496020
var
  sData, SC, s10, s14, s18: string;
  n1C, n20: Integer;
const
  sExceptionMsg = '[쳣!!] FrmIdSoc::DecodeSocStr';
begin
  try
    if Pos(')', sRecvMsg) <= 0 then exit;
    sData := sRecvMsg;
    sRecvMsg := '';
    while (True) do begin
      sData := ArrestStringEx(sData, '(', ')', SC);
      if SC = '' then break;
      s14 := GetValidStr3(SC, s10, ['/']);
      s14 := GetValidStr3(s14, s18, ['/']);
      n1C := Str_ToInt(s10, 0);
      n20 := Str_ToInt(DeCodeString(s18), -1);
      case n1C of //
        ISM_USERSERVERCHANGE: ;
        ISM_USERLOGON: ;
        ISM_USERLOGOUT: ;
        ISM_WHISPER: ;
        ISM_SYSOPMSG: ;
        ISM_ADDGUILD: ;
        ISM_DELGUILD: ;
        ISM_RELOADGUILD: ;
        ISM_GUILDMSG: ;
        ISM_CHATPROHIBITION: ;
        ISM_CHATPROHIBITIONCANCEL: ;
        ISM_CHANGECASTLEOWNER: ;
        ISM_RELOADCASTLEINFO: ;
        ISM_RELOADADMIN: ;
        ISM_FRIEND_INFO: ;
      end;
      if Pos(')', sData) <= 0 then break;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
end;

procedure TFrmMsgClient.SendSocket(sMsg: string); //00495F74
begin
  if MsgClient.Socket.Connected then
    MsgClient.Socket.SendText('(' + sMsg + ')');
end;

procedure TFrmMsgClient.MsgClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  sRecvMsg := '';
end;

procedure TFrmMsgClient.MsgClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  Socket.Close;
  ErrorCode := 0;
end;

procedure TFrmMsgClient.MsgClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  sRecvMsg := sRecvMsg + Socket.ReceiveText;
end;

end.
