unit ItmUnit;

interface
uses
  Windows, Classes, SysUtils, M2Type, MirGrobal,SerGrobal;
type
  TItemUnit = class
  private
    function GetRandomRange(nCount, nRate: Integer): Integer;
  public
    m_ItemNameList: TGList;
    m_SubItemList: TGList;
    constructor Create();
    destructor Destroy; override;

    function GetSubItem(Item:pTUserItem;index:Byte):pTBaoShi;
    procedure GetItemAddValue(UserItem: pTUserItem; var StdItem: TStdItem);
    procedure GetAccessory(Item: TUserItem; var AddAbility: TAddAbility); //004C0EBC
    procedure ClearBaoShiList;

    procedure RandomUpgradeWeapon(UserItem: pTUserItem);
    procedure RandomUpgradeDress(UserItem: pTUserItem);
    procedure RandomUpgrade19(UserItem: pTUserItem);
    procedure RandomUpgrade202124(UserItem: pTUserItem);
    procedure RandomUpgrade26(UserItem: pTUserItem);
    procedure RandomUpgrade22(UserItem: pTUserItem);
    procedure RandomUpgrade23(UserItem: pTUserItem);
    procedure RandomUpgradeHelMet(UserItem: pTUserItem);
    procedure UnknowHelmet(UserItem: pTUserItem);
    procedure UnknowRing(UserItem: pTUserItem);
    procedure UnknowNecklace(UserItem: pTUserItem);
    function LoadCustomItemName(): Boolean;
    function SaveCustomItemName(): Boolean;
    function AddCustomItemName(UserItem: pTUserItem; sItemName: string): Boolean;
    function DelCustomItemName(UserItem: pTUserItem): Boolean;
    function GetCustomItemName(UserItem: pTUserItem): string;
    procedure Lock();
    procedure UnLock();
  end;
implementation

uses HUtil32, M2Config, M2Share;



{ TItemUnit }


constructor TItemUnit.Create;
begin
  m_ItemNameList := TGList.Create;
  m_SubItemList  := TGList.Create;
end;

destructor TItemUnit.Destroy;
var
  i: Integer;
begin
  for i := 0 to m_ItemNameList.Count - 1 do begin
    DisPose(pTItemName(m_ItemNameList.Items[i]));
  end;
  m_ItemNameList.Free;
  inherited;
end;
procedure TItemUnit.ClearBaoShiList;
var
  i: Integer;
begin
  for i := 0 to m_SubItemList.Count - 1 do begin
    DisPose(pTBaoShi(m_SubItemList.Items[i]));
  end;
  m_SubItemList.Clear;
end;

function TItemUnit.GetSubItem(Item:pTUserItem;index:Byte):pTBaoShi;
var
  i,ii,iii:Integer;
  Bs:pTBaoShi;
begin

  Result := nil;
  if Item.btArrXQ[0]+Item.btArrXQ[1]+Item.btArrXQ[2]+Item.btArrXQ[3]+Item.btArrXQ[4] = 0 then Exit;

  //for i := Low(Item.btArrXQ) to High(Item.btArrXQ)  do
  //begin
    if Item.btArrXQ[index] >= 2 then begin
      for ii := 0 to m_SubItemList.Count-1 do begin
        if m_SubItemList[ii] = nil then Continue;
        Bs := pTBaoShi(m_SubItemList[ii]);
        if Item.btArrXQ[index] = Bs.Source then begin
          Result := Bs;
        end;
      end;
    end;
  //end;
end;

function TItemUnit.GetRandomRange(nCount, nRate: Integer): Integer; //00494794
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to nCount - 1 do
    if Random(nRate) = 0 then Inc(Result);
end;

procedure TItemUnit.RandomUpgradeWeapon(UserItem: pTUserItem); //00494794
var
  nC, n10, n14: Integer;
begin
  nC := GetRandomRange(g_Config.nWeaponDCAddValueMaxLimit {12}, g_Config.nWeaponDCAddValueRate {15});
  if Random(15) = 0 then UserItem.btAddValue[0] := nC + 1;

  nC := GetRandomRange(12, 15);
  if Random(20) = 0 then begin
    n14 := (nC + 1) div 3;
    if n14 > 0 then begin
      if Random(3) <> 0 then begin
        UserItem.btAddValue[6] := n14;
      end else begin
        UserItem.btAddValue[6] := n14 + 10;
      end;
    end;
  end;

  nC := GetRandomRange(12, 15);
  if Random(15) = 0 then UserItem.btAddValue[1] := nC + 1;
  nC := GetRandomRange(12, 15);
  if Random(15) = 0 then UserItem.btAddValue[2] := nC + 1;
  nC := GetRandomRange(12, 15);
  if Random(24) = 0 then begin
    UserItem.btAddValue[5] := nC div 2 + 1;
  end;
  nC := GetRandomRange(12, 12);
  if Random(3) < 2 then begin
    n10 := (nC + 1) * 2000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
  nC := GetRandomRange(12, 15);
  if Random(10) = 0 then begin
    UserItem.btAddValue[7] := nC div 2 + 1;
  end;
end;

procedure TItemUnit.RandomUpgradeDress(UserItem: pTUserItem); //00494958
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 15);
  if Random(30) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 15);
  if Random(30) = 0 then UserItem.btAddValue[1] := nC + 1;

  nC := GetRandomRange(g_Config.nDressDCAddValueMaxLimit {6}, g_Config.nDressDCAddValueRate {20});
  if Random(g_Config.nDressDCAddRate {40}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nDressMCAddValueMaxLimit {6}, g_Config.nDressMCAddValueRate {20});
  if Random(g_Config.nDressMCAddRate {40}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nDressSCAddValueMaxLimit {6}, g_Config.nDressSCAddValueRate {20});
  if Random(g_Config.nDressSCAddRate {40}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 10);
  if Random(8) < 6 then begin
    n10 := (nC + 1) * 2000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgrade202124(UserItem: pTUserItem); //00494AB0
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 30);
  if Random(60) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 30);
  if Random(60) = 0 then UserItem.btAddValue[1] := nC + 1;
  nC := GetRandomRange(g_Config.nNeckLace202124DCAddValueMaxLimit {6}, g_Config.nNeckLace202124DCAddValueRate {20});
  if Random(g_Config.nNeckLace202124DCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nNeckLace202124MCAddValueMaxLimit {6}, g_Config.nNeckLace202124MCAddValueRate {20});
  if Random(g_Config.nNeckLace202124MCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nNeckLace202124SCAddValueMaxLimit {6}, g_Config.nNeckLace202124SCAddValueRate {20});
  if Random(g_Config.nNeckLace202124SCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 12);
  if Random(20) < 15 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgrade26(UserItem: pTUserItem); //00494C08
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 20);
  if Random(20) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 20);
  if Random(20) = 0 then UserItem.btAddValue[1] := nC + 1;

  nC := GetRandomRange(g_Config.nArmRing26DCAddValueMaxLimit {6}, g_Config.nArmRing26DCAddValueRate {20});
  if Random(g_Config.nArmRing26DCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nArmRing26MCAddValueMaxLimit {6}, g_Config.nArmRing26MCAddValueRate {20});
  if Random(g_Config.nArmRing26MCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nArmRing26SCAddValueMaxLimit {6}, g_Config.nArmRing26SCAddValueRate {20});
  if Random(g_Config.nArmRing26SCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 12);
  if Random(20) < 15 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgrade19(UserItem: pTUserItem); //00494D60
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 20);
  if Random(40) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 20);
  if Random(40) = 0 then UserItem.btAddValue[1] := nC + 1;

  nC := GetRandomRange(g_Config.nNeckLace19DCAddValueMaxLimit {6}, g_Config.nNeckLace19DCAddValueRate {20});
  if Random(g_Config.nNeckLace19DCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nNeckLace19MCAddValueMaxLimit {6}, g_Config.nNeckLace19MCAddValueRate {20});
  if Random(g_Config.nNeckLace19MCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nNeckLace19SCAddValueMaxLimit {6}, g_Config.nNeckLace19SCAddValueRate {20});
  if Random(g_Config.nNeckLace19SCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 10);
  if Random(4) < 3 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgrade22(UserItem: pTUserItem); //00494EB8
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(g_Config.nRing22DCAddValueMaxLimit {6}, g_Config.nRing22DCAddValueRate {20});
  if Random(g_Config.nRing22DCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nRing22MCAddValueMaxLimit {6}, g_Config.nRing22MCAddValueRate {20});
  if Random(g_Config.nRing22MCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nRing22SCAddValueMaxLimit {6}, g_Config.nRing22SCAddValueRate {20});
  if Random(g_Config.nRing22SCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 12);
  if Random(4) < 3 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgrade23(UserItem: pTUserItem); //00494FB8
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 20);
  if Random(40) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 20);
  if Random(40) = 0 then UserItem.btAddValue[1] := nC + 1;

  nC := GetRandomRange(g_Config.nRing23DCAddValueMaxLimit {6}, g_Config.nRing23DCAddValueRate {20});
  if Random(g_Config.nRing23DCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nRing23MCAddValueMaxLimit {6}, g_Config.nRing23MCAddValueRate {20});
  if Random(g_Config.nRing23MCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nRing23SCAddValueMaxLimit {6}, g_Config.nRing23SCAddValueRate {20});
  if Random(g_Config.nRing23SCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;


  nC := GetRandomRange(6, 12);
  if Random(4) < 3 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.RandomUpgradeHelMet(UserItem: pTUserItem); //00495110
var
  nC, n10: Integer;
begin
  nC := GetRandomRange(6, 20);
  if Random(40) = 0 then UserItem.btAddValue[0] := nC + 1;
  nC := GetRandomRange(6, 20);
  if Random(30) = 0 then UserItem.btAddValue[1] := nC + 1;

  nC := GetRandomRange(g_Config.nHelMetDCAddValueMaxLimit {6}, g_Config.nHelMetDCAddValueRate {20});
  if Random(g_Config.nHelMetDCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressDC] := nC + 1;

  nC := GetRandomRange(g_Config.nHelMetMCAddValueMaxLimit {6}, g_Config.nHelMetMCAddValueRate {20});
  if Random(g_Config.nHelMetMCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressMC] := nC + 1;

  nC := GetRandomRange(g_Config.nHelMetSCAddValueMaxLimit {6}, g_Config.nHelMetSCAddValueRate {20});
  if Random(g_Config.nHelMetSCAddRate {30}) = 0 then
    UserItem.btAddValue[IVIDressSC] := nC + 1;

  nC := GetRandomRange(6, 12);
  if Random(4) < 3 then begin
    n10 := (nC + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + n10);
    UserItem.Dura := _MIN(65000, UserItem.Dura + n10);
  end;
end;

procedure TItemUnit.UnknowHelmet(UserItem: pTUserItem); //00495268 ͷ
var
  nC, nRandPoint, n14: Integer;
begin
  nRandPoint := GetRandomRange(g_Config.nUnknowHelMetACAddValueMaxLimit {4}, g_Config.nUnknowHelMetACAddRate {20});
  if nRandPoint > 0 then UserItem.btAddValue[IVIDressAC] := nRandPoint;
  n14 := nRandPoint;


  nRandPoint := GetRandomRange(g_Config.nUnknowHelMetMACAddValueMaxLimit {4}, g_Config.nUnknowHelMetMACAddRate {20});
  if nRandPoint > 0 then UserItem.btAddValue[IVIDressMAC] := nRandPoint;
  Inc(n14, nRandPoint);


  nRandPoint := GetRandomRange(g_Config.nUnknowHelMetDCAddValueMaxLimit {3}, g_Config.nUnknowHelMetDCAddRate {30});
  if nRandPoint > 0 then UserItem.btAddValue[IVIDressDC] := nRandPoint;
  Inc(n14, nRandPoint);


  nRandPoint := GetRandomRange(g_Config.nUnknowHelMetMCAddValueMaxLimit {3}, g_Config.nUnknowHelMetMCAddRate {30});
  if nRandPoint > 0 then UserItem.btAddValue[IVIDressMC] := nRandPoint;
  Inc(n14, nRandPoint);


  nRandPoint := GetRandomRange(g_Config.nUnknowHelMetSCAddValueMaxLimit {3}, g_Config.nUnknowHelMetSCAddRate {30});
  if nRandPoint > 0 then UserItem.btAddValue[IVIDressSC] := nRandPoint;
  Inc(n14, nRandPoint);


  nRandPoint := GetRandomRange(6, 30);
  if nRandPoint > 0 then begin
    nC := (nRandPoint + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + nC);
    UserItem.Dura := _MIN(65000, UserItem.Dura + nC);
  end;
  if Random(30) = 0 then UserItem.btAddValue[7] := 1;
  UserItem.btAddValue[IVIUnknow] := 1;
  if n14 >= 3 then begin
    if UserItem.btAddValue[IVIDressAC] >= 5 then begin
      UserItem.btAddValue[5] := 1;
      UserItem.btAddValue[6] := UserItem.btAddValue[0] * 3 + 25;
      exit;
    end;
    if UserItem.btAddValue[IVIDressDC] >= 2 then begin
      UserItem.btAddValue[5] := 1;
      UserItem.btAddValue[6] := UserItem.btAddValue[2] * 4 + 35;
      exit;
    end;
    if UserItem.btAddValue[3] >= 2 then begin
      UserItem.btAddValue[5] := 2;
      UserItem.btAddValue[6] := UserItem.btAddValue[3] * 2 + 18;
      exit;
    end;
    if UserItem.btAddValue[4] >= 2 then begin
      UserItem.btAddValue[5] := 3;
      UserItem.btAddValue[6] := UserItem.btAddValue[4] * 2 + 18;
      exit;
    end;
    UserItem.btAddValue[6] := n14 * 2 + 18;
  end;
end;

procedure TItemUnit.UnknowRing(UserItem: pTUserItem); //00495500 ؽָ
var
  nC, n10, n14: Integer;
begin
  n10 := GetRandomRange(g_Config.nUnknowRingACAddValueMaxLimit {6}, g_Config.nUnknowRingACAddRate {20});
  if n10 > 0 then UserItem.btAddValue[0] := n10;
  n14 := n10;
  n10 := GetRandomRange(g_Config.nUnknowRingMACAddValueMaxLimit {6}, g_Config.nUnknowRingMACAddRate {20});
  if n10 > 0 then UserItem.btAddValue[1] := n10;
  Inc(n14, n10);
  // ϶Ϊӷħ

  n10 := GetRandomRange(g_Config.nUnknowRingDCAddValueMaxLimit {6}, g_Config.nUnknowRingDCAddRate {20});
  if n10 > 0 then UserItem.btAddValue[2] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(g_Config.nUnknowRingMCAddValueMaxLimit {6}, g_Config.nUnknowRingMCAddRate {20});
  if n10 > 0 then UserItem.btAddValue[3] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(g_Config.nUnknowRingSCAddValueMaxLimit {6}, g_Config.nUnknowRingSCAddRate {20});
  if n10 > 0 then UserItem.btAddValue[4] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(6, 30);
  if n10 > 0 then begin
    nC := (n10 + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + nC);
    UserItem.Dura := _MIN(65000, UserItem.Dura + nC);
  end;
  if Random(30) = 0 then UserItem.btAddValue[7] := 1;
  UserItem.btAddValue[IVIUnknow] := 1;
  if n14 >= 3 then begin
    if UserItem.btAddValue[2] >= 3 then begin
      UserItem.btAddValue[5] := 1;
      UserItem.btAddValue[6] := UserItem.btAddValue[2] * 3 + 25;
      exit;
    end;
    if UserItem.btAddValue[3] >= 3 then begin
      UserItem.btAddValue[5] := 2;
      UserItem.btAddValue[6] := UserItem.btAddValue[3] * 2 + 18;
      exit;
    end;
    if UserItem.btAddValue[4] >= 3 then begin
      UserItem.btAddValue[5] := 3;
      UserItem.btAddValue[6] := UserItem.btAddValue[4] * 2 + 18;
      exit;
    end;
    UserItem.btAddValue[6] := n14 * 2 + 18;
  end;
end;

procedure TItemUnit.UnknowNecklace(UserItem: pTUserItem); //00495704 
var
  nC, n10, n14: Integer;
begin
  n10 := GetRandomRange(g_Config.nUnknowNecklaceACAddValueMaxLimit {5}, g_Config.nUnknowNecklaceACAddRate {20});
  if n10 > 0 then UserItem.btAddValue[0] := n10;
  n14 := n10;
  n10 := GetRandomRange(g_Config.nUnknowNecklaceMACAddValueMaxLimit {5}, g_Config.nUnknowNecklaceMACAddRate {20});
  if n10 > 0 then UserItem.btAddValue[1] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(g_Config.nUnknowNecklaceDCAddValueMaxLimit {5}, g_Config.nUnknowNecklaceDCAddRate {30});
  if n10 > 0 then UserItem.btAddValue[2] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(g_Config.nUnknowNecklaceMCAddValueMaxLimit {5}, g_Config.nUnknowNecklaceMCAddRate {30});
  if n10 > 0 then UserItem.btAddValue[3] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(g_Config.nUnknowNecklaceSCAddValueMaxLimit {5}, g_Config.nUnknowNecklaceSCAddRate {30});
  if n10 > 0 then UserItem.btAddValue[4] := n10;
  Inc(n14, n10);
  n10 := GetRandomRange(6, 30);
  if n10 > 0 then begin
    nC := (n10 + 1) * 1000;
    UserItem.DuraMax := _MIN(65000, UserItem.DuraMax + nC);
    UserItem.Dura := _MIN(65000, UserItem.Dura + nC);
  end;
  if Random(30) = 0 then UserItem.btAddValue[7] := 1;
  UserItem.btAddValue[IVIUnknow] := 1;
  if n14 >= 2 then begin
    if UserItem.btAddValue[0] >= 3 then begin
      UserItem.btAddValue[IVINeedType] := 1;
      UserItem.btAddValue[6] := UserItem.btAddValue[0] * 3 + 25;
      exit;
    end;
    if UserItem.btAddValue[2] >= 2 then begin
      UserItem.btAddValue[IVINeedType] := 1;
      UserItem.btAddValue[6] := UserItem.btAddValue[2] * 3 + 30;
      exit;
    end;
    if UserItem.btAddValue[3] >= 2 then begin
      UserItem.btAddValue[IVINeedType] := 2;
      UserItem.btAddValue[6] := UserItem.btAddValue[3] * 2 + 20;
      exit;
    end;
    if UserItem.btAddValue[4] >= 2 then begin
      UserItem.btAddValue[IVINeedType] := 3;
      UserItem.btAddValue[6] := UserItem.btAddValue[4] * 2 + 20;
      exit;
    end;
    UserItem.btAddValue[6] := n14 * 2 + 18;
  end;
end;

procedure TItemUnit.GetAccessory(Item: TUserItem; var AddAbility: TAddAbility); //004C0EBC
var
  StdItem: pTStdItem;
  StdItemA: TStdItem;

begin
  StdItem := UserEngine.GetStdItem(Item.wIndex);
  if StdItem = nil then Exit;
  StdItemA := StdItem^;
  GetItemAddValue(@Item, StdItemA);
  case StdItem.StdMode of
    5, 6: begin

        Inc(AddAbility.wHitPoint, HiWord(StdItemA.AC));
        if HiWord(StdItemA.MAC) > 10 then begin
          Inc(AddAbility.nHitSpeed, HiWord(StdItemA.MAC) - 10);
        end else begin
          Dec(AddAbility.nHitSpeed, HiWord(StdItemA.MAC));
        end;
        Inc(AddAbility.btLuck, LoWord(StdItemA.AC));
        Inc(AddAbility.btUnLuck, LoWord(StdItemA.MAC));
      end;
    19: begin //004C0FBE
        Inc(AddAbility.wAntiMagic, HiWord(StdItemA.AC));
        Inc(AddAbility.btUnLuck, LoWord(StdItemA.MAC));
        Inc(AddAbility.btLuck, HiWord(StdItemA.MAC));
      end;
    53: begin //¼Ʒ
        if not g_Config.boAddUserItemNewValue then begin
          Inc(AddAbility.wAntiMagic, HiWord(StdItemA.AC));
          Inc(AddAbility.btUnLuck, LoWord(StdItemA.MAC));
          Inc(AddAbility.btLuck, HiWord(StdItemA.MAC));
        end else begin
          AddAbility.wAC := MakeLong(LoWord(AddAbility.wAC) + LoWord(StdItemA.AC), HiWord(AddAbility.wAC) + HiWord(StdItemA.AC));
          AddAbility.wMAC := MakeLong(LoWord(AddAbility.wMAC) + LoWord(StdItemA.MAC), HiWord(AddAbility.wMAC) + HiWord(StdItemA.MAC));
        end;
      end;
    20, 24: begin //004C0FF0
        Inc(AddAbility.wHitPoint, HiWord(StdItemA.AC));
        Inc(AddAbility.wSpeedPoint, HiWord(StdItemA.MAC));
      end;
    52: begin //ԭ 20,24 һԣڷֿ
        if not g_Config.boAddUserItemNewValue then begin
          Inc(AddAbility.wHitPoint, HiWord(StdItemA.AC));
          Inc(AddAbility.wSpeedPoint, HiWord(StdItemA.MAC));
        end else begin
          AddAbility.wAC := MakeLong(LoWord(AddAbility.wAC) + LoWord(StdItemA.AC), HiWord(AddAbility.wAC) + HiWord(StdItemA.AC));
          AddAbility.wMAC := MakeLong(LoWord(AddAbility.wMAC) + LoWord(StdItemA.MAC), HiWord(AddAbility.wMAC) + HiWord(StdItemA.MAC));
        end;
      end;
    21: begin
        Inc(AddAbility.wHealthRecover, HiWord(StdItemA.AC));
        Inc(AddAbility.wSpellRecover, HiWord(StdItemA.MAC));
        Inc(AddAbility.nHitSpeed, LoWord(StdItemA.AC));
        Dec(AddAbility.nHitSpeed, LoWord(StdItemA.MAC));
      end;
    54: begin
        if not g_Config.boAddUserItemNewValue then begin
          Inc(AddAbility.wHealthRecover, HiWord(StdItemA.AC));
          Inc(AddAbility.wSpellRecover, HiWord(StdItemA.MAC));
          Inc(AddAbility.nHitSpeed, LoWord(StdItemA.AC));
          Dec(AddAbility.nHitSpeed, LoWord(StdItemA.MAC));
        end else begin
          AddAbility.wAC := MakeLong(LoWord(AddAbility.wAC) + LoWord(StdItemA.AC), HiWord(AddAbility.wAC) + HiWord(StdItemA.AC));
          AddAbility.wMAC := MakeLong(LoWord(AddAbility.wMAC) + LoWord(StdItemA.MAC), HiWord(AddAbility.wMAC) + HiWord(StdItemA.MAC));
        end;
      end;
    23: begin
        Inc(AddAbility.wAntiPoison, HiWord(StdItemA.AC));
        Inc(AddAbility.wPoisonRecover, HiWord(StdItemA.MAC));
        Inc(AddAbility.nHitSpeed, LoWord(StdItemA.AC));
        Dec(AddAbility.nHitSpeed, LoWord(StdItemA.MAC));
      end;
  else begin
      AddAbility.wAC := MakeLong(LoWord(AddAbility.wAC) + LoWord(StdItemA.AC), HiWord(AddAbility.wAC) + HiWord(StdItemA.AC));
      AddAbility.wMAC := MakeLong(LoWord(AddAbility.wMAC) + LoWord(StdItemA.MAC), HiWord(AddAbility.wMAC) + HiWord(StdItemA.MAC));
    end;
  end;

  AddAbility.wDC := MakeLong(LoWord(AddAbility.wDC) + LoWord(StdItemA.DC), HiWord(AddAbility.wDC) + HiWord(StdItemA.DC));
  AddAbility.wMC := MakeLong(LoWord(AddAbility.wMC) + LoWord(StdItemA.MC), HiWord(AddAbility.wMC) + HiWord(StdItemA.MC));
  AddAbility.wSC := MakeLong(LoWord(AddAbility.wSC) + LoWord(StdItemA.SC), HiWord(AddAbility.wSC) + HiWord(StdItemA.SC));
end;

procedure TItemUnit.GetItemAddValue(UserItem: pTUserItem; var StdItem: TStdItem); //00495974
begin
  StdItem.UpLevel := UserItem.btUpValue[0];
  StdItem.btArrXQ[0] := UserItem.btArrXQ[0];
  StdItem.btArrXQ[1] := UserItem.btArrXQ[1];
  StdItem.btArrXQ[2] := UserItem.btArrXQ[2];
  StdItem.btArrXQ[3] := UserItem.btArrXQ[3];
  StdItem.btArrXQ[4] := UserItem.btArrXQ[4];
  case StdItem.StdMode of
    5, 6: begin
        StdItem.DC := MakeLong(LoWord(StdItem.DC) + UserItem.btUpValue[1], HiWord(StdItem.DC) + UserItem.btAddValue[0] + UserItem.btUpValue[2]);
        StdItem.MC := MakeLong(LoWord(StdItem.MC) + UserItem.btUpValue[3], HiWord(StdItem.MC) + UserItem.btAddValue[1] + UserItem.btUpValue[4]);
        StdItem.SC := MakeLong(LoWord(StdItem.SC) + UserItem.btUpValue[5], HiWord(StdItem.SC) + UserItem.btAddValue[2] + UserItem.btUpValue[6]);

        StdItem.AC := MakeLong(LoWord(StdItem.AC) + UserItem.btAddValue[3], HiWord(StdItem.AC) + UserItem.btAddValue[5]);
        StdItem.MAC := MakeLong(LoWord(StdItem.MAC) + UserItem.btAddValue[4], HiWord(StdItem.MAC) + UserItem.btAddValue[6]);

        if Byte(UserItem.btAddValue[7] - 1) < 10 then begin //ʥ
          StdItem.Source := UserItem.btAddValue[7];
        end;
        StdItem.NeedIdentify :=UserItem.btAddValue[IVIWeaptonUp];
        //  StdItem.btReserved := StdItem.btReserved or 1;
      end;
    10, 11: begin
        StdItem.AC := MakeLong(LoWord(StdItem.AC) + UserItem.btUpValue[7], HiWord(StdItem.AC) + UserItem.btAddValue[0] + UserItem.btUpValue[8]);
        StdItem.MAC := MakeLong(LoWord(StdItem.MAC) + UserItem.btUpValue[9], HiWord(StdItem.MAC) + UserItem.btAddValue[1] + UserItem.btUpValue[10]);

        StdItem.DC := MakeLong(LoWord(StdItem.DC) + UserItem.btUpValue[1], HiWord(StdItem.DC) + UserItem.btAddValue[2] + UserItem.btUpValue[2]);
        StdItem.MC := MakeLong(LoWord(StdItem.MC) + UserItem.btUpValue[3], HiWord(StdItem.MC) + UserItem.btAddValue[3] + UserItem.btUpValue[4]);
        StdItem.SC := MakeLong(LoWord(StdItem.SC) + UserItem.btUpValue[5], HiWord(StdItem.SC) + UserItem.btAddValue[4] + UserItem.btUpValue[6]);
        {StdItem.DuraMax := MakeWord(UserItem.[11], UserItem.[12]);
        StdItem.AniCount := UserItem.[13];
        StdItem.btReserved := UserItem.[14];
        StdItem.NeedIdentify := MakeWord(UserItem.[15], UserItem.[16]);  }
      end;
    15, 19, 20, 21, 22, 23, 24, 26, 28, 51, 52, 53, 54, 62, 63, 64: begin
        StdItem.AC := MakeLong(LoWord(StdItem.AC) + UserItem.btUpValue[7], HiWord(StdItem.AC) + UserItem.btAddValue[IVIDressAC] + UserItem.btUpValue[8]);
        StdItem.MAC := MakeLong(LoWord(StdItem.MAC) + UserItem.btUpValue[9], HiWord(StdItem.MAC) + UserItem.btAddValue[IVIDressMAC] + UserItem.btUpValue[10]);

        StdItem.DC := MakeLong(LoWord(StdItem.DC) + UserItem.btUpValue[1], HiWord(StdItem.DC) + UserItem.btAddValue[IVIDressDC] + UserItem.btUpValue[2]);
        StdItem.MC := MakeLong(LoWord(StdItem.MC) + UserItem.btUpValue[3], HiWord(StdItem.MC) + UserItem.btAddValue[IVIDressMC] + UserItem.btUpValue[4]);
        StdItem.SC := MakeLong(LoWord(StdItem.SC) + UserItem.btUpValue[5], HiWord(StdItem.SC) + UserItem.btAddValue[IVIDressSC] + UserItem.btUpValue[6]);

        if UserItem.btAddValue[IVINeedType] > 0 then begin
          StdItem.btNeedType := UserItem.btAddValue[IVINeedType];
        end;
        if UserItem.btAddValue[IVINeedLevel] > 0 then begin
          StdItem.NeedLevel := UserItem.btAddValue[IVINeedLevel];
        end;
        {StdItem.DuraMax := MakeWord(UserItem.[11], UserItem.[12]);
        StdItem.AniCount := UserItem.[13];
        StdItem.btReserved := UserItem.[14];
        StdItem.NeedIdentify := MakeWord(UserItem.[15], UserItem.[16]);
        }
      end;
  end;
end;

function TItemUnit.GetCustomItemName(UserItem: pTUserItem): string;
var
  i: Integer;
  ItemName: pTItemName;
begin
  Result := '';
  if UserItem.btAddValue[IVICustomItemName] <> 1 then Exit;
  m_ItemNameList.Lock;
  try
    for i := 0 to m_ItemNameList.Count - 1 do begin
      ItemName := m_ItemNameList.Items[i];
      if (ItemName.nMakeIndex = UserItem.MakeIndex) and (ItemName.nItemIndex = UserItem.wIndex) then begin
        Result := ItemName.sItemName;
        break;
      end;
    end;
  finally
    m_ItemNameList.UnLock;
  end;
end;


function TItemUnit.AddCustomItemName(UserItem: pTUserItem;
  sItemName: string): Boolean;
var
  i: Integer;
  ItemName: pTItemName;
begin
  Result := False;
  if UserItem.btAddValue[IVICustomItemName] = 1 then Exit;
  m_ItemNameList.Lock;
  try
    for i := 0 to m_ItemNameList.Count - 1 do begin
      ItemName := m_ItemNameList.Items[i];
      if (ItemName.nMakeIndex = UserItem.MakeIndex) and (ItemName.nItemIndex = UserItem.wIndex) then begin
        exit;
      end;
    end;
    New(ItemName);
    ItemName.nMakeIndex := UserItem.MakeIndex;
    ItemName.nItemIndex := UserItem.wIndex;
    ItemName.sItemName := sItemName;
    m_ItemNameList.Add(ItemName);
    Result := True;
  finally
    UserItem.btAddValue[IVICustomItemName] := 1;
    m_ItemNameList.UnLock;
  end;
end;

function TItemUnit.DelCustomItemName(UserItem: pTUserItem): Boolean;
var
  i: Integer;
  ItemName: pTItemName;
begin
  Result := False;
  if UserItem.btAddValue[IVICustomItemName] <> 1 then Exit;
  m_ItemNameList.Lock;
  try
    for i := 0 to m_ItemNameList.Count - 1 do begin
      ItemName := m_ItemNameList.Items[i];
      if (ItemName.nMakeIndex = UserItem.MakeIndex) and (ItemName.nItemIndex = UserItem.wIndex) then begin
        DisPose(ItemName);
        m_ItemNameList.Delete(i);
        Result := True;
        exit;
      end;
    end;
  finally
    UserItem.btAddValue[IVICustomItemName] := 0;
    m_ItemNameList.UnLock;
  end;
end;

function TItemUnit.LoadCustomItemName: Boolean;
var
  i: Integer;
  LoadList: TStringList;
  sFileName: string;
  sLineText: string;
  sMakeIndex: string;
  sItemIndex: string;
  nMakeIndex: Integer;
  nItemIndex: Integer;
  sItemName: string;
  ItemName: pTItemName;
begin
  Result := False;
  sFileName := g_Config.sEnvirDir + 'ItemNameList.txt';
  LoadList := TStringList.Create;
  if FileExists(sFileName) then begin
    m_ItemNameList.Lock;
    try
      m_ItemNameList.Clear;
      LoadList.LoadFromFile(sFileName);
      for i := 0 to LoadList.Count - 1 do begin
        sLineText := Trim(LoadList.Strings[i]);
        sLineText := GetValidStr3(sLineText, sMakeIndex, [' ', #9]);
        sLineText := GetValidStr3(sLineText, sItemIndex, [' ', #9]);
        sLineText := GetValidStr3(sLineText, sItemName, [' ', #9]);
        nMakeIndex := Str_ToInt(sMakeIndex, -1);
        nItemIndex := Str_ToInt(sItemIndex, -1);
        if (nMakeIndex >= 0) and (nItemIndex >= 0) then begin
          New(ItemName);
          ItemName.nMakeIndex := nMakeIndex;
          ItemName.nItemIndex := nItemIndex;
          ItemName.sItemName := sItemName;
          m_ItemNameList.Add(ItemName);
        end;
      end;
      Result := True;
    finally
      m_ItemNameList.UnLock;
    end;
  end else begin
    LoadList.SaveToFile(sFileName);
  end;
  LoadList.Free;
end;

function TItemUnit.SaveCustomItemName: Boolean;
var
  i: Integer;
  SaveList: TStringList;
  sFileName: string;
  ItemName: pTItemName;
begin
  sFileName := g_Config.sEnvirDir + 'ItemNameList.txt';
  SaveList := TStringList.Create;
  m_ItemNameList.Lock;
  try
    for i := 0 to m_ItemNameList.Count - 1 do begin
      ItemName := m_ItemNameList.Items[i];
      SaveList.Add(IntToStr(ItemName.nMakeIndex) + #9 + IntToStr(ItemName.nItemIndex) + #9 + ItemName.sItemName);
    end;
  finally
    m_ItemNameList.UnLock;
  end;
  SaveList.SaveToFile(sFileName);
  SaveList.Free;
  Result := True;
end;

procedure TItemUnit.Lock;
begin
  m_ItemNameList.Lock;
end;

procedure TItemUnit.UnLock;
begin
  m_ItemNameList.UnLock;
end;

end.
