unit ObjBActor;

interface
uses
  Windows,
  SysUtils,
  ObjBase,
  GameMap,
  HUtil32,
  Magic,
  M2Type,
  SerGrobal,
  MirGrobal;
type
{ TBActor }

  TBActor = class(TPlayObject)
    m_AActor: TPlayObject;
    constructor Create; override;
    destructor Destroy; override;
    procedure FeatureChanged(); override;
    procedure StatusChanged; override;

    procedure SysMsg(sMsg: string; MsgColor: TMsgColor; MsgType: TMsgType); override;
    procedure SendSocket(DefMsg: pTDefaultMessage; sMsg: string); override;
    procedure SendDefMessage(wIdent: Word; nRecog: Integer; nParam, nTag, nSeries: Word; sMsg: string); override;


    procedure AddAction(BaseObject: TBaseObject; wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string); override;
    procedure AddFirstAction(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string); override;
    procedure AddDelayAction(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord); override;
    procedure AddRefAction(wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string); override;
    procedure AddUpdateAction(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string); override;
    procedure SendUpdateDelayMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord); override;

    procedure SendActionMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string); virtual;
    procedure MakeGhost; override;
    procedure Login(AActor: TObject);

    function UseMagic(MagIdForList: Byte; nTargetX, nTargetY: SmallInt; TargeTBaseObject: TBaseObject; dwDelayTime: LongWord): Boolean;
    function GotoTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
    function WalkToTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
    function WalkToTargetXY2(nTargetX, nTargetY: SmallInt): Boolean;
    function RunToTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
  private

  protected

  published

  end;
implementation
uses M2Config, M2Share, Castle;

constructor TBActor.Create;
begin
  inherited Create;
  m_AActor := nil;
end;


destructor TBActor.Destroy;
begin
  inherited Destroy;
end;

procedure TBActor.SysMsg(sMsg: string; MsgColor: TMsgColor; MsgType: TMsgType);
begin
  if m_AActor <> nil then
    m_AActor.SysMsg('[Ӣ]' + sMsg, MsgColor, MsgType);
end;

procedure TBActor.MakeGhost;
begin
  inherited MakeGhost;
  {m_boSoftClose := True;
  m_boKickFlag := True;}
end;

procedure TBActor.Login(AActor: TObject);
var
  I: Integer;
  II: Integer;
  UserItem: pTUserItem;
  UserItem1: pTUserItem;
  StdItem: pTStdItem;
  s14: string;
  sItem: string;
  sIPaddr: string;
  Castle: TUserCastle;
const
  sExceptionMsg = '[Exception] THeroObject::Login';
begin
  Castle := nil;
  m_AActor := TPlayObject(AActor);
  TPlayObject(AActor).m_bActor := Self;
  try
    //Ʒ
    if m_boNewHuman then begin
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(g_Config.sBasicDrug, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(g_Config.sWoodenSword, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
      New(UserItem);
      if m_btGender = 0 then
        sItem := g_Config.sClothsMan
      else
        sItem := g_Config.sClothsWoman;
      if UserEngine.CopyToUserItemFromName(sItem, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
    end;
    //鱳еƷǷϷ
    for I := m_ItemList.Count - 1 downto 0 do begin
      if m_ItemList.Count <= 0 then Break;
      UserItem := m_ItemList.Items[I];
      if UserEngine.GetStdItemName(UserItem.wIndex) = '' then begin
        Dispose(pTUserItem(m_ItemList.Items[I]));
        m_ItemList.Delete(I);
      end;
    end;
    //ϵƷǷʹù
    //if g_Config.boCheckUserItemPlace then begin
    for I := Low(THumItems) to High(THumItems) do begin
      if m_UseItems[I].wIndex > 0 then begin
        StdItem := UserEngine.GetStdItem(m_UseItems[I].wIndex);
        if StdItem <> nil then begin
          if not CheckUserItems(I, StdItem) then begin
            New(UserItem);
            UserItem^ := m_UseItems[I];
            if not AddItemToBag(UserItem) then begin
              m_ItemList.Insert(0, UserItem);
            end;
            m_UseItems[I].wIndex := 0;
          end;
        end else m_UseItems[I].wIndex := 0;
      end;
    end;
    //end;
    //鱳ǷиƷ
    for I := m_ItemList.Count - 1 downto 0 do begin
      if m_ItemList.Count <= 0 then Break;
      UserItem := m_ItemList.Items[I];
      s14 := UserEngine.GetStdItemName(UserItem.wIndex);
      for II := I - 1 downto 0 do begin
        UserItem1 := m_ItemList.Items[II];
        if (UserEngine.GetStdItemName(UserItem1.wIndex) = s14) and
          (UserItem.MakeIndex = UserItem1.MakeIndex) then begin
          m_ItemList.Delete(II);
          Break;
        end;
      end;
    end;
    for I := Low(m_dwStatusArrTick) to High(m_dwStatusArrTick) do begin
      if m_wStatusTimeArr[I] > 0 then
        m_dwStatusArrTick[I] := GetTickCount();
    end;
    {RecalcLevelAbilitys();
    RecalcAbilitys();
    m_Abil.MaxExp := GetLevelExp(m_Abil.Level);}
    {if (g_ManageNPC <> nil) and (m_Master <> nil) then begin
      g_ManageNPC.GotoLable(TPlayObject(m_Master), '@HeroLogin', False);
    end;   }
    m_boFixedHideMode := False;
      //if m_Abil.HP <= 0 then begin
    ClearStatusTime();
    m_sMapName := m_AActor.m_sMapName;
    m_nCurrX := m_AActor.m_nCurrX + 1;
    m_nCurrY := m_AActor.m_nCurrY + 1;
        (*if PKLevel < 2 then begin
          Castle := g_CastleManager.IsCastleMember(Self);
          if (Castle <> nil) and Castle.m_boUnderWar then begin
            m_sMapName := Castle.m_sHomeMap;
            m_nCurrX := Castle.GetHomeX;
            m_nCurrY := Castle.GetHomeY;
          end else begin
            m_sMapName := m_sHomeMap;
            m_nCurrX := m_nHomeX - 2 + Random(5);
            m_nCurrY := m_nHomeY - 2 + Random(5);
          end;
        end else begin
          m_sMapName := g_Config.sRedDieHomeMap {'3'};
          m_nCurrX := Random(13) + g_Config.nRedDieHomeX {839};
          m_nCurrY := Random(13) + g_Config.nRedDieHomeY {668};
        end; *)
        // 
    if m_Abil.HP <= 0 then m_Abil.HP := 14;
      //end;
    AbilCopyToWAbil;
    Initialize;
    SearchViewRange;
  except
    on E: Exception do begin
      MainOutMessage(sExceptionMsg);
      MainOutMessage(E.Message);
    end;
  end;
  m_nServerIndex := g_MapManager.GetMapOfServerIndex(m_sMapName);
end;

function TBActor.UseMagic(MagIdForList: Byte; nTargetX, nTargetY: SmallInt; TargeTBaseObject: TBaseObject; dwDelayTime: LongWord): Boolean;
var
  UserMagic: pTUserMagic;
  nSpellPoint: Integer;
  n14: Integer;
  BaseObject: TBaseObject;
  dwCheckTime: LongWord;
  boIsWarrSkill: Boolean;
begin
  Result := False;
  dwDelayTime := 0;
  if not m_boCanSpell then Exit;
  if m_boDeath or ((m_wStatusTimeArr[POISON_STONE {5}] {0x6A} <> 0)) then Exit; //
  if MagIdForList in [0..m_MagicList.Count - 1] then
    UserMagic := m_MagicList.Items[MagIdForList];
  if UserMagic <> nil then MainOutMessage('Use-Magic:' + UserMagic.MagicInfo.sMagicName);

  if UserMagic = nil then Exit;

  boIsWarrSkill := MagicManager.IsWarrSkill(UserMagic.wMagIdx);

  if not boIsWarrSkill then begin
    if not CheckActionStatus(CM_SPELL, dwDelayTime) then begin
      m_boFilterAction := False;
      Exit;
    end;
    m_boFilterAction := True;
    dwCheckTime := GetTickCount - m_dwMagicAttackTick;
    if dwCheckTime < m_dwMagicAttackInterval then begin
      Inc(m_dwMagicAttackCount);
      dwDelayTime := m_dwMagicAttackInterval - dwCheckTime;
      if dwDelayTime > g_Config.dwMagicHitIntervalTime div 3 then begin
        if m_dwMagicAttackCount >= 4 then begin
          m_dwMagicAttackTick := GetTickCount();
          m_dwMagicAttackCount := 0;
          dwDelayTime := g_Config.dwMagicHitIntervalTime div 3;
          if m_boTestSpeedMode then
            SysMsg('ħæλ' + IntToStr(dwDelayTime), c_Red, t_Hint);
        end else m_dwMagicAttackCount := 0;
        Exit;
      end else begin
        if m_boTestSpeedMode then
          SysMsg('ħæ' + IntToStr(dwDelayTime), c_Red, t_Hint);
        Exit;
      end;
    end;
  end;

  Dec(m_nSpellTick, 450);
  m_nSpellTick := _MAX(0, m_nSpellTick);

  if boIsWarrSkill then begin
    //m_dwMagicAttackInterval:=0;
    //m_dwMagicAttackInterval:=g_Config.dwMagicHitIntervalTime;
  end else begin
    m_dwMagicAttackInterval := UserMagic.MagicInfo.dwDelayTime + g_Config.dwMagicHitIntervalTime;
  end;
  m_dwMagicAttackTick := GetTickCount();
  case UserMagic.wMagIdx of //
    SKILL_ERGUM {12}: begin //ɱ
        if m_MagicErgumSkill <> nil then begin
          if not m_boUseThrusting then begin
            ThrustingOnOff(True);
            SendSocket(nil, '+LNG-H');
          end else begin
            ThrustingOnOff(False);
            SendSocket(nil, '+ULNG-H');
          end;
        end;
        Result := True;
      end;
    SKILL_BANWOL {25}: begin //䵶
        if m_MagicBanwolSkill <> nil then begin
          if not m_boUseHalfMoon then begin
            HalfMoonOnOff(True);
            SendSocket(nil, '+WID-H');
          end else begin
            HalfMoonOnOff(False);
            SendSocket(nil, '+UWID-H');
          end;
        end;
        Result := True;
      end;
    SKILL_FIRESWORD {26}: begin //һ𽣷
        if m_MagicFireSwordSkill <> nil then begin
          if AllowFireHitSkill then begin
            nSpellPoint := GetSpellPoint(UserMagic);
            if m_WAbil.MP >= nSpellPoint then begin
              if nSpellPoint > 0 then begin
                DamageSpell(nSpellPoint);
                HealthSpellChanged();
              end;
              SendSocket(nil, '+FIR-H');
            end;
          end;
        end;
        Result := True;
      end;
    (*SKILL_MOOTEBO {27}: begin //Ұײ
        Result := True;
        if (GetTickCount - m_dwDoMotaeboTick) > 3 * 1000 then begin
          m_dwDoMotaeboTick := GetTickCount();
          m_btDirection := nTargetX;
          nSpellPoint := GetSpellPoint(UserMagic);
          if m_WAbil.MP >= nSpellPoint then begin
            if nSpellPoint > 0 then begin
              DamageSpell(nSpellPoint);
              HealthSpellChanged();
            end;
            if DoMotaebo(m_btDirection, UserMagic.btLevel) then begin
              if UserMagic.btLevel < 3 then begin
                if UserMagic.MagicInfo.TrainLevel[UserMagic.btLevel] < m_Abil.Level then begin
                  TrainSkill(UserMagic, Random(3) + 1);
                  if not CheckMagicLevelup(UserMagic) then begin

                    AddDelayAction(Self,
                      RM_MAGIC_LVEXP,
                      0,
                      UserMagic.MagicInfo.wMagicId,
                      UserMagic.btLevel,
                      UserMagic.nTranPoint,
                      '', 1000);
                  end;
                end;
              end;
            end;
          end;
        end;
      end;   *)
    SKILL_40: begin //˫ն
        if m_MagicCrsSkill <> nil then begin
          if not m_boCrsHitkill then begin
            SkillCrsOnOff(True);
            SendSocket(nil, '+CRS-H');
          end else begin
            SkillCrsOnOff(False);
            SendSocket(nil, '+UCRS-H');
          end;
        end;
        Result := True;
      end;
    42: begin //ն
        if m_Magic42Skill <> nil then begin
          if not m_bo42kill then begin
            Skill42OnOff(True);
            SendSocket(nil, '+TWN-H');
          end else begin
            Skill42OnOff(False);
            SendSocket(nil, '+UTWN-H');
          end;
        end;
        Result := True;
      end;
    43: begin //ƿս
        if m_Magic43Skill <> nil then begin
          if not m_bo43kill then begin
            Skill43OnOff(True);
            SendSocket(nil, '+CID-H');
          end else begin
            Skill43OnOff(False);
            SendSocket(nil, '+UCID-H');
          end;
        end;
        Result := True;
      end;
  else begin
      n14 := GetNextDirection(m_nCurrX, m_nCurrY, nTargetX, nTargetY);
      m_btDirection := n14;
      BaseObject := nil;
        //ĿɫĿΧΧĿ
      if CretInNearXY(TargeTBaseObject, nTargetX, nTargetY) then begin
        BaseObject := TargeTBaseObject;
        nTargetX := BaseObject.m_nCurrX;
        nTargetY := BaseObject.m_nCurrY;
      end;
      if not DoSpell(UserMagic, nTargetX, nTargetY, BaseObject) then begin
        AddRefAction(RM_MAGICFIREFAIL, 0, 0, 0, 0, '');
      end; // else MainOutMessage('Do-Spell');
      Result := True;
    end;
  end;
  //MainOutMessage('Use-Magic:'+UserMagic.MagicInfo.sMagicName+'Out');
end;



procedure TBActor.AddRefAction(wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string); //004B8EBC
var
  ii, nC: Integer;
  nCX, nCY, nLX, nLY, nHX, nHY: Integer;
  MapCellInfo: pTMapCellinfo;
  OSObject: pTOSObject;
  BaseObject: TBaseObject;
const
  sExceptionMsg = '[쳣!!] B::AddRefAction Name = %s';
begin
  if True then begin
    inherited;
    Exit;
  end;
  if m_PMap = nil then begin
    MainOutMessage(m_sCharName + ' AddRefAction nil PEnvir ');
    Exit;
  end;
end;

procedure TBActor.AddFirstAction(BaseObject: TBaseObject; wIdent, wParam: Word;
  lParam1, lParam2, lParam3: Integer; sMsg: string);
var
  Action: pTAction;
begin
  if True then begin
    inherited;
    Exit;
  end;
  try
    EnterCriticalSection(ProcessMsgCriticalSection);
    {if not m_boGhost then begin
      New(Action);
      Action.wIdent := wIdent;
      Action.wParam := wParam;
      Action.nParam1 := lParam1;
      Action.nParam2 := lParam2;
      Action.nParam3 := lParam3;
      Action.dwDeliveryTime := 0;
      Action.BaseObject := BaseObject;
      if sMsg <> '' then begin
        try
          GetMem(Action.Buff, Length(sMsg) + 1);
          Move(sMsg[1], Action.Buff^, Length(sMsg) + 1);
        except
          Action.Buff := nil;
        end;
      end else begin
        Action.Buff := nil;
      end;
      m_ActList.Insert(0, Action);
    end; }
    //ٷAActor
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
end;

procedure TBActor.AddAction(BaseObject: TBaseObject; wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string); //004B865C
var
  Action: pTAction;
begin
  if True then begin
    inherited;
    Exit;
  end;
  try
    EnterCriticalSection(ProcessMsgCriticalSection);
    {if not m_boGhost then begin
      New(Action);
      Action.wIdent := wIdent;
      Action.wParam := wParam;
      Action.nParam1 := nParam1;
      Action.nParam2 := nParam2;
      Action.nParam3 := nParam3;
      Action.dwDeliveryTime := 0;
      Action.BaseObject := BaseObject;
      Action.boLateDelivery := False;
      if sMsg <> '' then begin
        try
          GetMem(Action.Buff, Length(sMsg) + 1);
          Move(sMsg[1], Action.Buff^, Length(sMsg) + 1);
        except
          Action.Buff := nil;
        end;
      end else begin
        Action.Buff := nil;
      end;
      m_ActList.Add(Action);
    end;   }
    //ٷAActor
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
end;

procedure TBActor.AddDelayAction(BaseObject: TBaseObject; wIdent,
  wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string;
  dwDelay: LongWord); //004B87C4
var
  Action: pTAction;
begin
  if True then begin
    inherited;
    Exit;
  end;
  try
    EnterCriticalSection(ProcessMsgCriticalSection);
    {if not m_boGhost then begin
      New(Action);
      Action.wIdent := wIdent;
      Action.wParam := wParam;
      Action.nParam1 := lParam1;
      Action.nParam2 := lParam2;
      Action.nParam3 := lParam3;
      Action.dwDeliveryTime := GetTickCount + dwDelay;
      Action.BaseObject := BaseObject;
      Action.boLateDelivery := True;
      if sMsg <> '' then begin
        try
          GetMem(Action.Buff, Length(sMsg) + 1);
          Move(sMsg[1], Action.Buff^, Length(sMsg) + 1);
        except
          Action.Buff := nil;
        end;
      end else begin
        Action.Buff := nil;
      end;
      m_ActList.Add(Action);
    end;}
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
end;

procedure TBActor.SendUpdateDelayMsg(BaseObject: TBaseObject; wIdent,
  wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string;
  dwDelay: LongWord); //004B8930
var
  Action: pTAction;
  i: Integer;
begin
  if True then begin
    inherited;
    Exit;
  end;
  EnterCriticalSection(ProcessMsgCriticalSection);
  try
    {i := 0;
    while (True) do begin
      if m_ActList.Count <= i then break;
      Action := m_ActList.Items[i];
      if (Action.wIdent = wIdent) and (Action.nParam1 = lParam1) then begin
        m_ActList.Delete(i);
        if Action.Buff <> nil then FreeMem(Action.Buff);
        DisPose(Action);
        Continue;
      end;
      Inc(i);
    end;  }
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
  AddDelayAction(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg, dwDelay);
end;

procedure TBActor.AddUpdateAction(BaseObject: TBaseObject; wIdent, wParam: Word;
  lParam1, lParam2, lParam3: Integer; sMsg: string); //004B8A7C
var
  Action: pTAction;
  i: Integer;
begin
  if True then begin
    inherited;
    Exit;
  end;
  try
    EnterCriticalSection(ProcessMsgCriticalSection);
    {i := 0;
    while (True) do begin
      if m_ActList.Count <= i then break;
      Action := m_ActList.Items[i];
      if Action.wIdent = wIdent then begin
        m_ActList.Delete(i);
        if Action.Buff <> nil then FreeMem(Action.Buff);
        DisPose(Action);
        Continue;
      end;
      Inc(i);
    end;  }
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
  AddAction(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg);
end;

procedure TBActor.SendActionMsg(BaseObject: TBaseObject; wIdent, wParam: Word;
  lParam1, lParam2, lParam3: Integer; sMsg: string); //004B8A7C
var
  Action: pTAction;
  i: Integer;
begin
  if True then begin
    inherited;
    Exit;
  end;
  EnterCriticalSection(ProcessMsgCriticalSection);
  try
    i := 0;
    {while (True) do begin
      if m_ActList.Count <= i then break;
      Action := m_ActList.Items[i];
      if (Action.wIdent = CM_TURN) or
        (Action.wIdent = CM_WALK) or
        (Action.wIdent = CM_SITDOWN) or
        (Action.wIdent = CM_HORSERUN) or
        (Action.wIdent = CM_RUN) or
        (Action.wIdent = CM_HIT) or
        (Action.wIdent = CM_HEAVYHIT) or
        (Action.wIdent = CM_BIGHIT) or
        (Action.wIdent = CM_POWERHIT) or
        (Action.wIdent = CM_LONGHIT) or
        (Action.wIdent = CM_WIDEHIT) or
        (Action.wIdent = CM_FIREHIT) then begin
        m_ActList.Delete(i);
        if Action.Buff <> nil then FreeMem(Action.Buff);
        DisPose(Action);
        Continue;
      end;
      Inc(i);
    end;  }
  finally
    LeaveCriticalSection(ProcessMsgCriticalSection);
  end;
  AddAction(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg);
end;

procedure TBActor.FeatureChanged;
begin
  {if m_AActor <> nil then
    m_AActor.AddRefAction(RM_FEATURECHANGED, GetFeatureEx, GetFeatureToLong, 0, 0, 'Hero') }
end;

procedure TBActor.StatusChanged();
begin
  {if m_AActor <> nil then
    m_AActor.AddRefAction(RM_CHARSTATUSCHANGED, m_nHitSpeed, m_nCharStatus, 0, 0, 'Hero') }
end;

procedure TBActor.SendSocket(DefMsg: pTDefaultMessage; sMsg: string);
begin

end;

procedure TBActor.SendDefMessage(wIdent: Word; nRecog: Integer; nParam, nTag, nSeries: Word; sMsg: string);
begin

end;

function TBActor.GotoTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
begin
  if (abs(m_nCurrX - nTargetX) >= 3) or (abs(m_nCurrY - nTargetY) >= 3) then begin
    Result := RunToTargetXY(nTargetX, nTargetY);
  end else begin
    Result := WalkToTargetXY2(nTargetX, nTargetY);
  end;
end;


function TBActor.WalkToTargetXY2(nTargetX, nTargetY: SmallInt): Boolean;
var
  I: Integer;
  nDir: Integer;
  n10: Integer;
  n14: Integer;
  n20: Integer;
  nOldX: SmallInt;
  nOldY: SmallInt;
  n16: Integer;
begin
  Result := False;
  if (nTargetX <> m_nCurrX) or (nTargetY <> m_nCurrY) then begin
    n10 := nTargetX;
    n14 := nTargetY;
    nDir := DR_DOWN;
    if n10 > m_nCurrX then begin
      nDir := DR_RIGHT;
      if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
      if n14 < m_nCurrY then nDir := DR_UPRIGHT;
    end else begin
      if n10 < m_nCurrX then begin
        nDir := DR_LEFT;
        if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
        if n14 < m_nCurrY then nDir := DR_UPLEFT;
      end else begin
        if n14 > m_nCurrY then nDir := DR_DOWN
        else if n14 < m_nCurrY then nDir := DR_UP;
      end;
    end;
    nOldX := m_nCurrX;
    nOldY := m_nCurrY;
    WalkTo(nDir, False);
    if (nTargetX = m_nCurrX) and (nTargetY = m_nCurrY) then Result := True;
    if not Result then begin
      n20 := Random(3);
      for I := DR_UP to DR_UPLEFT do begin
        if (nOldX = m_nCurrX) and (nOldY = m_nCurrY) then begin
          if n20 <> 0 then Inc(nDir)
          else if nDir > 0 then Dec(nDir)
          else nDir := DR_UPLEFT;
          if (nDir > DR_UPLEFT) then nDir := DR_UP;
          WalkTo(nDir, False);
          if (nTargetX = m_nCurrX) and (nTargetY = m_nCurrY) then begin
            Result := True;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

function TBActor.WalkToTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
var
  I: Integer;
  nDir: Integer;
  n10: Integer;
  n14: Integer;
  n20: Integer;
  nOldX: SmallInt;
  nOldY: SmallInt;
  n16: Integer;
begin
  Result := False;
  if (abs(nTargetX - m_nCurrX) > 1) or (abs(nTargetY - m_nCurrY) > 1) then begin
    n10 := nTargetX;
    n14 := nTargetY;
    nDir := DR_DOWN;
    if n10 > m_nCurrX then begin
      nDir := DR_RIGHT;
      if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
      if n14 < m_nCurrY then nDir := DR_UPRIGHT;
    end else begin
      if n10 < m_nCurrX then begin
        nDir := DR_LEFT;
        if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
        if n14 < m_nCurrY then nDir := DR_UPLEFT;
      end else begin
        if n14 > m_nCurrY then nDir := DR_DOWN
        else if n14 < m_nCurrY then nDir := DR_UP;
      end;
    end;
    nOldX := m_nCurrX;
    nOldY := m_nCurrY;
    WalkTo(nDir, False);
    if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then Result := True;
    if not Result then begin
      n20 := Random(3);
      for I := DR_UP to DR_UPLEFT do begin
        if (nOldX = m_nCurrX) and (nOldY = m_nCurrY) then begin
          if n20 <> 0 then Inc(nDir)
          else if nDir > 0 then Dec(nDir)
          else nDir := DR_UPLEFT;
          if (nDir > DR_UPLEFT) then nDir := DR_UP;
          WalkTo(nDir, False);
          if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then begin
            Result := True;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

function TBActor.RunToTargetXY(nTargetX, nTargetY: SmallInt): Boolean;
var
  nDir: Integer;
  n10: Integer;
  n14: Integer;
begin
  Result := False;
  n10 := nTargetX;
  n14 := nTargetY;
  nDir := DR_DOWN;
  if n10 > m_nCurrX then begin
    nDir := DR_RIGHT;
    if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
    if n14 < m_nCurrY then nDir := DR_UPRIGHT;
  end else begin
    if n10 < m_nCurrX then begin
      nDir := DR_LEFT;
      if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
      if n14 < m_nCurrY then nDir := DR_UPLEFT;
    end else begin
      if n14 > m_nCurrY then nDir := DR_DOWN
      else if n14 < m_nCurrY then nDir := DR_UP;
    end;
  end;
  if not RunTo(nDir, False, nTargetX, nTargetY) then begin
    Result := WalkToTargetXY(nTargetX, nTargetY);
  end else begin
    if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then begin
      Result := True;
    end;
  end;
end;
end.
