unit RunDB;

interface
uses
  Windows, SysUtils, M2Type, MirGrobal,SerGrobal, WinSock, M2Config, M2Share, TyFunc, Common;
procedure DBSOcketThread(ThreadInfo: pTThreadInfo); stdcall;
function DBSocketConnected(): Boolean;
function GetDBSockMsg(nQueryID: Integer; var nIdent: Integer; var nRecog: Integer; var wParam: Word; var sStr: string; dwTimeOut: LongWord; boLoadRcd: Boolean): Boolean;

function RunDB_LoadHumRcdFromDB(sAccount, sCharName, sStr: string; var HumanRcd: THumDataInfo; nCertCode: Integer): Boolean;
function RunDB_SaveHumRcdToDB(SaveRcd: pTSaveRcd): Boolean;
function RunDB_SaveRcd(SaveRcd: pTSaveRcd): Boolean; //004B42C8
function RunDB_LoadRcdFromMsg(sAccount, sCharName, sStr: string; nCertCode: Integer; var HumanRcd: THumDataInfo): Boolean;
procedure SendDBSockMsg(nQueryID: Integer; sMsg: string);
function GetQueryID(Config: pTConfig): Integer;
//  function GetPlayStart():Boolean;
implementation

uses {M2Share, }  svMain, EDcode;

procedure DBSocketRead(Config: pTConfig);
var
  dwReceiveTimeTick: LongWord;
  nReceiveTime: Integer;
  sRecvText: string;
  nRecvLen: Integer;
  nRet: Integer;
begin
  if Config.nDBSocket = INVALID_SOCKET then exit;

  dwReceiveTimeTick := GetTickCount();
  nRet := ioctlsocket(Config.nDBSocket, FIONREAD, nRecvLen);
  if (nRet = SOCKET_ERROR) or (nRecvLen = 0) then begin
    nRet := WSAGetLastError;
    Config.nDBSocket := INVALID_SOCKET;
    Sleep(100);
    Config.boDBSocketConnected := False;
    exit;
  end;
  setlength(sRecvText, nRecvLen);
  nRecvLen := recv(Config.nDBSocket, Pointer(sRecvText)^, nRecvLen, 0);
  setlength(sRecvText, nRecvLen);

  Inc(Config.nDBSocketRecvIncLen, nRecvLen);
  if (nRecvLen <> SOCKET_ERROR) and (nRecvLen > 0) then begin
    if nRecvLen > Config.nDBSocketRecvMaxLen then Config.nDBSocketRecvMaxLen := nRecvLen;
    EnterCriticalSection(UserDBSection);
    try
      Config.sDBSocketRecvText := Config.sDBSocketRecvText + sRecvText;
      if not Config.boDBSocketWorking then begin
        Config.sDBSocketRecvText := '';
      end;
    finally
      LeaveCriticalSection(UserDBSection);
    end;
  end;

  Inc(Config.nDBSocketRecvCount);
  nReceiveTime := GetTickCount - dwReceiveTimeTick;
  if Config.nDBReceiveMaxTime < nReceiveTime then Config.nDBReceiveMaxTime := nReceiveTime;
end;

procedure DBSocketProcess(ThreadInfo: pTThreadInfo);
var
  aSocket: TSocket;
  Name: sockaddr_in;
  HostEnt: PHostEnt;
  argp: LongInt;
  readfds: TFDSet;
  timeout: TTimeVal;
  nRet: Integer;
  boRecvData: BOOL;
  nRunTime: Integer;
  dwRunTick: LongWord;
begin
  aSocket := INVALID_SOCKET;
  if g_Config.nDBSocket <> INVALID_SOCKET then
    aSocket := g_Config.nDBSocket;
  dwRunTick := GetTickCount();
  ThreadInfo.dwRunTick := dwRunTick;
  boRecvData := False;
  while True do begin
    if ThreadInfo.boTerminaled then break;
    if not boRecvData then Sleep(1)
    else Sleep(0);
    boRecvData := False;
    nRunTime := GetTickCount - ThreadInfo.dwRunTick;
    if ThreadInfo.nRunTime < nRunTime then ThreadInfo.nRunTime := nRunTime;
    if ThreadInfo.nMaxRunTime < nRunTime then ThreadInfo.nMaxRunTime := nRunTime;
    if GetTickCount - dwRunTick >= 1000 then begin
      dwRunTick := GetTickCount();
      if ThreadInfo.nRunTime > 0 then Dec(ThreadInfo.nRunTime);
    end;

    ThreadInfo.dwRunTick := GetTickCount();
    ThreadInfo.boActived := True;
    ThreadInfo.nRunFlag := 125;
    if (g_Config.nDBSocket = INVALID_SOCKET) or (aSocket = INVALID_SOCKET) then begin
      if g_Config.nDBSocket <> INVALID_SOCKET then begin
        g_Config.nDBSocket := INVALID_SOCKET;
        Sleep(100);
        ThreadInfo.nRunFlag := 126;
        g_Config.boDBSocketConnected := False;
      end;
      if aSocket <> INVALID_SOCKET then begin
        closesocket(aSocket);
        aSocket := INVALID_SOCKET;
      end;
      if g_Config.sDBAddr = '' then Continue;

      aSocket := Socket(PF_INET, SOCK_STREAM, IPPROTO_IP);
      if aSocket = INVALID_SOCKET then Continue;

      ThreadInfo.nRunFlag := 127;

      HostEnt := gethostbyname(PAnsiChar(@g_Config.sDBAddr[1]));
      if HostEnt = nil then Continue;

      PInteger(@Name.sin_addr.S_addr)^ := PInteger(HostEnt.h_addr^)^;
      Name.sin_family := HostEnt.h_addrtype;
      Name.sin_port := htons(g_Config.nDBPort);
      Name.sin_family := PF_INET;

      ThreadInfo.nRunFlag := 128;
      if connect(aSocket, Name, SizeOf(Name)) = SOCKET_ERROR then begin
        nRet := WSAGetLastError;

        closesocket(aSocket);
        aSocket := INVALID_SOCKET;
        Continue;
      end;

      argp := 1;
      if ioctlsocket(aSocket, FIONBIO, argp) = SOCKET_ERROR then begin
        closesocket(aSocket);
        aSocket := INVALID_SOCKET;
        Continue;
      end;
      ThreadInfo.nRunFlag := 129;
      g_Config.nDBSocket := aSocket;
      g_Config.boDBSocketConnected := True;
    end;
    readfds.fd_count := 1;
    readfds.fd_array[0] := aSocket;
    timeout.tv_sec := 0;
    timeout.tv_usec := 20;
    ThreadInfo.nRunFlag := 130;
    nRet := select(0, @readfds, nil, nil, @timeout);
    if nRet = SOCKET_ERROR then begin
      ThreadInfo.nRunFlag := 131;
      nRet := WSAGetLastError;
      if nRet = WSAEWOULDBLOCK then begin
        Sleep(10);
        Continue;
      end;
      ThreadInfo.nRunFlag := 132;
      nRet := WSAGetLastError;
      g_Config.nDBSocketWSAErrCode := nRet - WSABASEERR;
      Inc(g_Config.nDBSocketErrorCount);
      g_Config.nDBSocket := INVALID_SOCKET;
      Sleep(100);
      g_Config.boDBSocketConnected := False;
      closesocket(aSocket);
      aSocket := INVALID_SOCKET;
      Continue;
    end;
    boRecvData := True;
    ThreadInfo.nRunFlag := 133;
    while True do begin
      if nRet <= 0 then break;
      DBSocketRead(@g_Config);
      Dec(nRet);
    end;
  end;
  if g_Config.nDBSocket <> INVALID_SOCKET then begin
    g_Config.nDBSocket := INVALID_SOCKET;
    g_Config.boDBSocketConnected := False;
  end;
  if aSocket <> INVALID_SOCKET then begin
    closesocket(aSocket);
  end;
end;

procedure DBSOcketThread(ThreadInfo: pTThreadInfo); stdcall;
var
  nErrorCount: Integer;
const
  sExceptionMsg = '[쳣!!] DBSocketThread ErrorCount = %d';
begin
  nErrorCount := 0;
  while True do begin
    try
      DBSocketProcess(ThreadInfo);
      break;             
    except
      Inc(nErrorCount);
      if nErrorCount > 10 then break;
      MainOutMessage(format(sExceptionMsg, [nErrorCount]));
    end;
  end;
  ExitThread(0);
end;

function DBSocketConnected(): Boolean;
begin

  Result := FrmMain.DBSocket.Socket.Connected;
end;

function GetDBSockMsg(nQueryID: Integer; var nIdent: Integer; var nRecog: Integer; var wParam: Word; var sStr: string; dwTimeOut: LongWord; boLoadRcd: Boolean): Boolean;
var
  boLoadDBOK: Boolean;
  dwTimeOutTick: LongWord;
  s24, s28, s2C, sCheckFlag, sDefMsg, s38: string;
  nLen: Integer;
  nCheckCode: Integer;
  DefMsg: TDefaultMessage;
const
  sLoadDBTimeOut = '[RunDB] ȡݳʱ...';
  sSaveDBTimeOut = '[RunDB] ݳʱ...';
begin
  boLoadDBOK := False;
  Result := False;
  dwTimeOutTick := GetTickCount();
  while (True) do begin
    if (GetTickCount - dwTimeOutTick) > dwTimeOut then begin
      break;
    end;
    s24 := '';
    EnterCriticalSection(UserDBSection);
    try
      if Pos('!', g_Config.sDBSocketRecvText) > 0 then begin
        s24 := g_Config.sDBSocketRecvText;
        g_Config.sDBSocketRecvText := '';
      end;
    finally
      LeaveCriticalSection(UserDBSection);
    end;
    if s24 <> '' then begin
      s28 := '';
      s24 := ArrestStringEx(s24, '#', '!', s28);
      if s28 <> '' then begin
        s28 := GetValidStr3(s28, s2C, ['/']);
        nLen := Length(s28);
        if (nLen >= SizeOf(TDefaultMessage)) and (Str_ToInt(s2C, 0) = nQueryID) then begin
          nCheckCode := MakeLong(Str_ToInt(s2C, 0) xor 170, nLen);
          sCheckFlag := EncodeBuffer(@nCheckCode, SizeOf(Integer));
          if CompareBackLStr(s28, sCheckFlag, Length(sCheckFlag)) then begin
            if nLen = DEFBLOCKSIZE then begin
              sDefMsg := s28;
              s38 := ''; // -> 004B3F56
            end else begin //004B3F1F
              sDefMsg := Copy(s28, 1, DEFBLOCKSIZE);
              s38 := Copy(s28, DEFBLOCKSIZE + 1, Length(s28) - DEFBLOCKSIZE - 6);
            end; //004B3F56
            DefMsg := DecodeMessage(sDefMsg);
            nIdent := DefMsg.Ident;
            nRecog := DefMsg.Recog;
            wParam := DefMsg.Param;
            sStr := s38;
            boLoadDBOK := True;
            Result := True;
            break;
          end;// else MainOutMessage('s28:' + s28 + '/' + 'sCheckFlag:' + sCheckFlag);
        end else begin //004B3F87
          Inc(g_Config.nLoadDBErrorCount);
          //MainOutMessage('nLen:' + inttostr(nLen) + 'SizeOf' + inttostr(SizeOf(TDefaultMessage)));
          //MainOutMessage('s2C:' + s2C + 'nQueryID' + inttostr(nQueryID));
          break;
        end;
      end else begin //004B3F90
        Inc(g_Config.nLoadDBErrorCount); // -> 004B3FA5
        break;
      end;
      //end;//004B3FA5
    end else begin //004B3F99
      Sleep(1);
    end;
  end;
  //end;//004B3FA5
  if not boLoadDBOK then begin
    if boLoadRcd then begin
      MainOutMessage(sLoadDBTimeOut);
    end else begin
      MainOutMessage(sSaveDBTimeOut);
    end;
  end; //004B3FD7
  if (GetTickCount - dwTimeOutTick) > dwRunDBTimeMax then begin
    dwRunDBTimeMax := GetTickCount - dwTimeOutTick;
  end;
  g_Config.boDBSocketWorking := False;
end;



function RunDB_LoadHumRcdFromDB(sAccount, sCharName, sStr: string; var HumanRcd: THumDataInfo; nCertCode: Integer): Boolean; //004B3A68
begin
  Result := False;
  FillChar(HumanRcd, SizeOf(THumDataInfo), #0);
  if RunDB_LoadRcdFromMsg(sAccount, sCharName, sStr, nCertCode, HumanRcd) then begin
    //MainOutMessage('RunDB_LoadRcdFromMsg OK Data.sChrName:'+HumanRcd.Data.sChrName+'   sCharName:'+sCharName+'   Data.sAccount:'+HumanRcd.Data.sAccount+ '    sAccount:'+sAccount);
    if ((HumanRcd.Data.sChrName = sCharName) or (sCharName = '*TasNat')) and ((HumanRcd.Data.sAccount = '') or (HumanRcd.Data.sAccount = sAccount)) then
      Result := True;// else MainOutMessage('RunDB_LoadHumRcdFromDB Fail:'+sCharName);
  end else MainOutMessage('RunDB_LoadRcdFromMsg fail');
  Inc(g_Config.nLoadDBCount);
end;

function RunDB_SaveHumRcdToDB(SaveRcd: pTSaveRcd): Boolean; //004B3B5C
begin
  Result := RunDB_SaveRcd(SaveRcd);
  Inc(g_Config.nSaveDBCount);
end;

function RunDB_SaveRcd(SaveRcd: pTSaveRcd): Boolean; //004B42C8
var
  nQueryID: Integer;
  nIdent: Integer;
  nRecog: Integer;
  wParam: Word;
  sStr: string;
begin
  nQueryID := GetQueryID(@g_Config);
  Result := False;
  SendDBSockMsg(nQueryID, EncodeMessage(MakeDefaultMsg(DB_SAVEHUMANRCD, SaveRcd.nSessionID, 0, 0, 0)) + EncodeString(SaveRcd.sAccount) + '/' + EncodeString(SaveRcd.sChrName) + '/' + EncodeBuffer(@SaveRcd.HumDataInfo, SizeOf(THumDataInfo)));
  if GetDBSockMsg(nQueryID, nIdent, nRecog, wParam, sStr, g_Config.dwGetDBSockMsgTime {5000}, False) then begin
    if (nIdent = DBR_SAVEHUMANRCD) and (nRecog = 1) then
      Result := True;
  end;
end;

function RunDB_LoadRcdFromMsg(sAccount, sCharName, sStr: string; nCertCode: Integer; var HumanRcd: THumDataInfo): Boolean;
var
  DefMsg: TDefaultMessage;
  LoadHuman: TLoadHuman;
  nQueryID: Integer;
  nIdent, nRecog: Integer;
  wParam: Word;
  sHumanRcdStr: string;
  sDBMsg, sDBCharName: string;
begin
  nQueryID := GetQueryID(@g_Config);
  DefMsg := MakeDefaultMsg(DB_LOADHUMANRCD, 0, 0, 0, 0);
  LoadHuman.sAccount := sAccount;
  LoadHuman.sChrName := sCharName;
  LoadHuman.sUserAddr := sStr;
  LoadHuman.nSessionID := nCertCode;
  sDBMsg := EncodeMessage(DefMsg) + EncodeBuffer(@LoadHuman, SizeOf(TLoadHuman));
  {MainOutMessage('Ͷȡݷ... ' +
    LoadHuman.sAccount + '/' +
    LoadHuman.sChrName + '/' +
    LoadHuman.sUserAddr + '/' +
    IntToStr(LoadHuman.nSessionID));}
  SendDBSockMsg(nQueryID, sDBMsg);
  wParam := 0;
  if GetDBSockMsg(nQueryID, nIdent, nRecog, wParam, sHumanRcdStr, g_Config.dwGetDBSockMsgTime {5000}, True) then begin
    //MainOutMessage('GetDBSockMsg  OK');
    Result := False;
    if nIdent = DBR_LOADHUMANRCD then begin
      //MainOutMessage('nIdent = DBR_LOADHUMANRCD');
      if nRecog = 1 then begin
        if wParam = 1 then begin
          sHumanRcdStr := GetValidStr3(sHumanRcdStr, sDBMsg, ['/']);
          sDBCharName := DeCodeString(sDBMsg);
        //if sDBCharName = sCharName then begin
          if GetCodeMsgSize(SizeOf(THumDataInfo) * 4 / 3) = Length(sHumanRcdStr) then begin
            DecodeBuffer(sHumanRcdStr, @HumanRcd, SizeOf(THumDataInfo));
            if HumanRcd.Header.sName = sCharName then begin
              Result := True;
                //MainOutMessage('RunDB_LoadRcdFromMsg  OK');
            end else begin
                MainOutMessage(HumanRcd.Header.sName+'<>'+sCharName);
            end;
            if IsBitOn(HumanRcd.Data.bt8Boolean, HDBIIsHero) then begin
              Result := True;
                //MainOutMessage('GetDBSockMsg  boIsHero');
            end else begin
                //MainOutMessage('Not HumanRcd.Data.boIsHero');
            end;
          //end;
          end;// else MainOutMessage('GetCodeMsgSize fail');
        end;// else MainOutMessage('wParam <> 1 ');
      end;// else MainOutMessage('nRecog <> 1 ');
    end;// else MainOutMessage('nIdent <> DBR_LOADHUMANRCD');
  end;// else MainOutMessage('GetDBSockMsg fail');
  //MainOutMessage('RunDB_LoadRcdFromMsg OUT');
end;

procedure SendDBSockMsg(nQueryID: Integer; sMsg: string);
var
  sSendMsg: string;
  nCheckCode: Integer;
  sCheckStr: string;
  boSendData: Boolean;
  Config: pTConfig;
  ThreadInfo: pTThreadInfo;
  timeout: TTimeVal;
  writefds: TFDSet;
  nRet: Integer;
  s: TSocket;
begin
  Config := @g_Config;
  ThreadInfo := @g_Config.DBSOcketThread;
  if not DBSocketConnected then exit;
  EnterCriticalSection(UserDBSection);
  try
    Config.sDBSocketRecvText := '';
  finally
    LeaveCriticalSection(UserDBSection);
  end;
  nCheckCode := MakeLong(nQueryID xor 170, Length(sMsg) + 6);
  sCheckStr := EncodeBuffer(@nCheckCode, SizeOf(Integer));
  sSendMsg := '#' + IntToStr(nQueryID) + '/' + sMsg + sCheckStr + '!';
  Config.boDBSocketWorking := True;
  FrmMain.DBSocket.Socket.SendText(sSendMsg);
end;

//004E3E04

function GetQueryID(Config: pTConfig): Integer;
begin
  Inc(Config.nDBQueryID);
  if Config.nDBQueryID > High(SmallInt) - 1 then Config.nDBQueryID := 1;
  Result := Config.nDBQueryID;
end;

end.
