unit ShopConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ComCtrls, MirGrobal, M2Share,  LocalDB;

type
  TFrmShopItem = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ListViewItemList: TListView;
    ListBoxItemList: TListBox;
    Label1: TLabel;
    EditShopItemName: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ButtonChgShopItem: TButton;
    ButtonDelShopItem: TButton;
    SpinEditPrice: TSpinEdit;
    ButtonAddShopItem: TButton;
    ButtonLoadShopItemList: TButton;
    ButtonSaveShopItemList: TButton;
    Label4: TLabel;
    Edit_SM: TEdit;
    Edit1: TEdit;
    procedure ListViewItemListClick(Sender: TObject);
    procedure ButtonChgShopItemClick(Sender: TObject);
    procedure ButtonDelShopItemClick(Sender: TObject);
    procedure ButtonAddShopItemClick(Sender: TObject);
    procedure ListBoxItemListClick(Sender: TObject);
    procedure ButtonSaveShopItemListClick(Sender: TObject);
    procedure ButtonLoadShopItemListClick(Sender: TObject);
  private
    { Private declarations }
    function InListViewItemList(sItemName: string): Boolean;
    procedure RefLoadShopItemList();
  public
    { Public declarations }
    procedure Open();
  end;

var
  FrmShopItem: TFrmShopItem;

implementation
uses HUtil32;
{$R *.dfm}

function TFrmShopItem.InListViewItemList(sItemName: string): Boolean;
var
  I: Integer;
  ListItem: TListItem;
begin
  Result := False;
  ListViewItemList.Items.BeginUpdate;
  try
    for I := 0 to ListViewItemList.Items.Count - 1 do begin
      ListItem := ListViewItemList.Items.Item[I];
      if CompareText(sItemName, ListItem.Caption) = 0 then begin
        Result := True;
        Break;
      end;
    end;
  finally
    ListViewItemList.Items.EndUpdate;
  end;
end;

procedure TFrmShopItem.RefLoadShopItemList();
var
  I: Integer;
  ListItem: TListItem;
  sItemName: string;
  sPrice: string;
  sSM: string;
  sXXSM: string;
  ShopInfo: pTShopItem;
begin
  ListViewItemList.Clear;
  if UserEngine.g_ShopItemList <> nil then begin
    ListViewItemList.Items.BeginUpdate;
    try
      for I := 0 to UserEngine.g_ShopItemList.Count - 1 do begin
        ShopInfo := pTShopItem(UserEngine.g_ShopItemList.Items[I]);
        sItemName := ShopInfo.Name;
        sPrice := IntToStr(ShopInfo.wPrice);
        sSM := ShopInfo.sMemo1;
        sXXSM := ShopInfo.sMemo2;

        ListItem := ListViewItemList.Items.Add;
        ListItem.Caption := sItemName;
        ListItem.SubItems.Add(sPrice);
        ListItem.SubItems.Add(sSM);
        ListItem.SubItems.Add(sXXSM);
      end;
    finally
      ListViewItemList.Items.EndUpdate;
    end;
  end;
end;

procedure TFrmShopItem.Open();
var
  I: Integer;
  StdItem: pTStdItem;
  List: TList;
begin
  ButtonChgShopItem.Enabled := False;
  ButtonDelShopItem.Enabled := False;
  ButtonAddShopItem.Enabled := False;
  ListBoxItemList.Items.Clear;
  List := UserEngine.StdItemList;
  if List <> nil then begin
    for I := 0 to List.Count - 1 do begin
      StdItem := List.Items[I];
      ListBoxItemList.Items.AddObject(StdItem.Name, TObject(StdItem));
    end;
  end;
  //LoadShopItemList();
  RefLoadShopItemList();
  ShowModal;
end;

procedure TFrmShopItem.ListViewItemListClick(Sender: TObject);
var
  nItemIndex: Integer;
  ListItem: TListItem;
begin
  try
    nItemIndex := ListViewItemList.ItemIndex;
    ListItem := ListViewItemList.Items.Item[nItemIndex];
    if ListItem = nil then Exit;

    EditShopItemName.Text := ListItem.Caption;
    SpinEditPrice.Value := Str_ToInt(ListItem.SubItems.Strings[0], 0);
    Edit_SM.Text := ListItem.SubItems.Strings[1];
    Edit1.Text := ListItem.SubItems.Strings[2];

    ButtonChgShopItem.Enabled := True;
    ButtonDelShopItem.Enabled := True;
  except
    ButtonChgShopItem.Enabled := False;
    ButtonDelShopItem.Enabled := False;
  end;
end;

procedure TFrmShopItem.ButtonChgShopItemClick(Sender: TObject);
var
  nItemIndex: Integer;
  ListItem: TListItem;
begin
  try
    nItemIndex := ListViewItemList.ItemIndex;
    ListItem := ListViewItemList.Items.Item[nItemIndex];
    ListItem.SubItems.Strings[0] := IntToStr(SpinEditPrice.Value);
    ListItem.SubItems.Strings[1] := Trim(Edit_SM.Text);
    ListItem.SubItems.Strings[2] := Trim(Edit1.Text);
  except
  end;
end;

procedure TFrmShopItem.ButtonDelShopItemClick(Sender: TObject);
begin
  ListViewItemList.Items.BeginUpdate;
  try
    ListViewItemList.DeleteSelected;
  finally
    ListViewItemList.Items.EndUpdate;
  end;
end;

procedure TFrmShopItem.ButtonAddShopItemClick(Sender: TObject);
var
  ListItem: TListItem;
  sItemName: string;
  sPrice: string;
  sMemo: string;
  sJDSM: string;
begin
  sItemName := Trim(EditShopItemName.Text);
  sPrice := IntToStr(SpinEditPrice.Value);
  sMemo := Trim(Edit1.Text);
  sJDSM := Trim(Edit_SM.Text);
  if (sItemName = '') then begin
    Application.MessageBox('ѡҪӵƷ', 'ʾϢ', MB_ICONQUESTION);
    Exit;
  end;
  if (sMemo = '') or (sJDSM = '') then begin
    Application.MessageBox('Ʒ', 'ʾϢ', MB_ICONQUESTION);
    Exit;
  end;

  if InListViewItemList(sItemName) then begin
    Application.MessageBox('ҪӵƷѾڣѡƷ', 'ʾϢ', MB_ICONQUESTION);
    Exit;
  end;
  ListViewItemList.Items.BeginUpdate;
  try
    ListItem := ListViewItemList.Items.Add;
    ListItem.Caption := sItemName;
    ListItem.SubItems.Add(sPrice);
    ListItem.SubItems.Add(sJDSM);
    ListItem.SubItems.Add(sMemo);
  finally
    ListViewItemList.Items.EndUpdate;
  end;
end;

procedure TFrmShopItem.ListBoxItemListClick(Sender: TObject);
var
  nItemIndex: Integer;
begin
  try
    nItemIndex := ListBoxItemList.ItemIndex;
    EditShopItemName.Text := ListBoxItemList.Items.Strings[nItemIndex];
    ButtonAddShopItem.Enabled := True;
  except
    ButtonAddShopItem.Enabled := False;
  end;
end;

procedure TFrmShopItem.ButtonSaveShopItemListClick(Sender: TObject);
var
  I: Integer;
  ListItem: TListItem;
  SaveList: Classes.TStringList;
  sLineText: string;
  sFileName: string;
  sItemName: string;
  sPrice: string;
  sMemo: string;
  sJDSM: string;
begin
  ButtonSaveShopItemList.Enabled := False;
  sFileName := '.\Ʒб.txt';
  SaveList := TStringList.Create();
  SaveList.Add(';ļ');
  SaveList.Add(';Ʒ'#9'ۼ۸'#9''#9'ϸ');
  ListViewItemList.Items.BeginUpdate;
  try
    for I := 0 to ListViewItemList.Items.Count - 1 do begin
      ListItem := ListViewItemList.Items.Item[I];
      sItemName := ListItem.Caption;
      sPrice := ListItem.SubItems.Strings[0];
      sMemo := ListItem.SubItems.Strings[2];
      sJDSM := ListItem.SubItems.Strings[1];
      sLineText := sItemName + #9 + sPrice + #9 + sJDSM + #9 + sMemo;
      SaveList.Add(sLineText);
    end;
  finally
    ListViewItemList.Items.EndUpdate;
  end;
  SaveList.SaveToFile(sFileName);
  SaveList.Free;
  Application.MessageBox('ɣ', 'ʾϢ', MB_ICONQUESTION);
  ButtonSaveShopItemList.Enabled := True;
end;

procedure TFrmShopItem.ButtonLoadShopItemListClick(Sender: TObject);
begin
  ButtonLoadShopItemList.Enabled := False;
  LoadShopItemList();
  RefLoadShopItemList();
  Application.MessageBox('¼бɣ', 'ʾϢ', MB_ICONQUESTION);
  ButtonLoadShopItemList.Enabled := True;
end;

end.
