unit fmAutoPlayMan;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,ObjAutoPlay,ObjBase, M2Config, StdCtrls, Spin, ComCtrls;

type
  TFrmAutoPlayMan = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListView_AutoPlay: TListView;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    SpinEdit_StartX: TSpinEdit;
    SpinEdit_StartY: TSpinEdit;
    SpinEdit_DesX: TSpinEdit;
    SpinEdit_DesY: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    SpinEdit_Time: TSpinEdit;
    Label5: TLabel;
    Memo: TMemo;
    Button_ListView_AutoPlay_Add: TButton;
    Button_ListView_AutoPlay_Del: TButton;
    Label6: TLabel;
    Edit_Map: TEdit;
    SpinEdit_Count: TSpinEdit;
    Label7: TLabel;
    Button_ListView_AutoPlay_Change: TButton;
    Label8: TLabel;
    SpinEdit_MiOut: TSpinEdit;
    procedure Button_ListView_AutoPlay_DelClick(Sender: TObject);
    procedure Button_ListView_AutoPlay_AddClick(Sender: TObject);
    procedure ListView_AutoPlaySelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button_ListView_AutoPlay_ChangeClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    procedure FillControl;
    procedure Open;
  end;

var
  FrmAutoPlayMan: TFrmAutoPlayMan;
  CurpAutoPlayConfig:pTAutoPlayConfig;
implementation
uses
  M2Share;
{$R *.dfm}
procedure TFrmAutoPlayMan.Open;
begin
  CurpAutoPlayConfig := nil;
  FillControl;
  ShowModal;
end;
procedure TFrmAutoPlayMan.FillControl;
begin
  Edit_Map.Text := '';
  SpinEdit_Count.Value := 0;
  SpinEdit_StartX.Value := 0;
  SpinEdit_StartY.Value:= 0;
  SpinEdit_Time.Value:= 0;
  Memo.Clear;
  if CurpAutoPlayConfig = nil then Exit;
end;

procedure TFrmAutoPlayMan.Button_ListView_AutoPlay_DelClick(
  Sender: TObject);
var
  I:Integer;
begin
  if ListView_AutoPlay.ItemIndex < 0 then Exit;
  ListView_AutoPlay.Items.Delete(ListView_AutoPlay.ItemIndex);
  CurpAutoPlayConfig := nil;
  try
    g_AutoPlayMan.Lock;
    g_AutoPlayMan.Delete(CurpAutoPlayConfig.Index);
    CurpAutoPlayConfig.NameList.Free;
    CurpAutoPlayConfig.UseItemList.Free;
    CurpAutoPlayConfig.StruckHigeLevelSayMsgList.Free;
    CurpAutoPlayConfig.StruckLowLevelSayMsgList.Free;
    CurpAutoPlayConfig.RandomSayMsgList.Free;
    CurpAutoPlayConfig.BackSayMsgList.Free;
    CurpAutoPlayConfig.ObjList.Free;
    for i := 0 to CurpAutoPlayConfig.ObjList.Count -1 do begin
      if CurpAutoPlayConfig.ObjList[i] <> nil then begin
        with TAutoPlay(CurpAutoPlayConfig.ObjList[i]) do begin
          MakeGhost;
        end;
      end;
    end;

    Dispose(CurpAutoPlayConfig);
  finally
    g_AutoPlayMan.UnLock;
  end;
  FillControl;
end;

procedure TFrmAutoPlayMan.Button_ListView_AutoPlay_AddClick(
  Sender: TObject);
begin
  if (Edit_Map.Text = '')or(SpinEdit_Count.Value = 0)or (SpinEdit_StartX.Value  = 0) or (SpinEdit_StartY.Value = 0) or (SpinEdit_Time.Value = 0)  then Exit;
  CurpAutoPlayConfig := nil;
  New(CurpAutoPlayConfig);
  with CurpAutoPlayConfig^ do begin
    HomeMap:=Edit_Map.Text;
    SouX:=SpinEdit_StartX.Value;
    SouY:=SpinEdit_StartY.Value;
    DesX:=SpinEdit_DesX.Value;
    DesY:=SpinEdit_DesY.Value;
    MiOut:=SpinEdit_MiOut.Value;
    OutTime:=SpinEdit_Time.Value;
    GenCount:=SpinEdit_Count.Value;
    NowCount:= 0;
    NameList := TStringList.Create;
    UseItemList := TStringList.Create;      
    StruckHigeLevelSayMsgList := TStringList.Create;      
    StruckLowLevelSayMsgList := TStringList.Create;      
    RandomSayMsgList := TStringList.Create;      
    BackSayMsgList := TStringList.Create;      
    ObjList := TList.Create;
  end;
  FillControl;
end;

procedure TFrmAutoPlayMan.ListView_AutoPlaySelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  CurpAutoPlayConfig := nil;
  if Item = nil then Exit;
  if Item.Data = nil then Exit;
  CurpAutoPlayConfig := Item.Data;
  FillControl;
end;

procedure TFrmAutoPlayMan.Button_ListView_AutoPlay_ChangeClick(
  Sender: TObject);
begin
  if (CurpAutoPlayConfig = nil)or(Edit_Map.Text = '')or
  (SpinEdit_Count.Value = 0)or (SpinEdit_StartX.Value  = 0) or
  (SpinEdit_StartY.Value = 0) or (SpinEdit_Time.Value = 0)  then Exit;
  
  CurpAutoPlayConfig.HomeMap := Edit_Map.Text;
  CurpAutoPlayConfig.SouX := SpinEdit_StartX.Value;
  CurpAutoPlayConfig.SouY := SpinEdit_StartY.Value;
  CurpAutoPlayConfig.DesX := SpinEdit_DesX.Value;
  CurpAutoPlayConfig.DesY := SpinEdit_DesY.Value;
  CurpAutoPlayConfig.MiOut := SpinEdit_MiOut.Value;
  CurpAutoPlayConfig.OutTime := SpinEdit_Time.Value;
  CurpAutoPlayConfig.GenCount := SpinEdit_Count.Value;
  FillControl;
end;

procedure TFrmAutoPlayMan.ComboBox1Change(Sender: TObject);
begin
  if CurpAutoPlayConfig = nil then Exit;
  case ComboBox1.ItemIndex of
    0:Memo.Assign(CurpAutoPlayConfig.NameList);
    1:Memo.Assign(CurpAutoPlayConfig.UseItemList);  
    2:Memo.Assign(CurpAutoPlayConfig.BackSayMsgList);
    3:Memo.Assign(CurpAutoPlayConfig.RandomSayMsgList);
    4:Memo.Assign(CurpAutoPlayConfig.StruckLowLevelSayMsgList);
    5:Memo.Assign(CurpAutoPlayConfig.StruckHigeLevelSayMsgList);
  end;
{б
װб
ظб
б
ַб
ͼ𹥻б
߼𹥻б
}
end;

end.
