unit Actor;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms,
  MirGrobal, ClType, DXDraws, cliUtil, magiceff,
  TyFunc,
  EDCode,
  Debug,
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  ClVarConst,
  ClFunc;

const
  MAXACTORSOUND = 3;


  MAXBAGITEMCL = 46;

  SM_ACTION_MIN = 6;
  SM_ACTION_MAX = 23;
  SM_ACTION2_MIN = 24;
  SM_ACTION2_MAX = 25;

  HUMANFRAME = 600;
  MONFRAME = 280;
  EXPMONFRAME = 360;
  SCULMONFRAME = 440;
  ZOMBIFRAME = 430;
  MERCHANTFRAME = 60;
  MAXSAY = 5;


  RC_ZuMaJiaoZhu = 49; //


  RUN_MINHEALTH = 10;
  DefMagicFrameCount = 10;
  FIREHIT_READYFRAME = 6;
  MAGBUBBLEBASE = 3890;
  MAGBUBBLESTRUCKBASE = 3900;
  MAXWPEFFECTFRAME = 5;
  WPEFFECTBASE = 3750;
  EffectBase = 0;


type

  PTChrMsg = ^TChrMsg;
  TChrMsg = record
    ident: Word;
    Dir: Word;
    X: Integer;
    Y: Integer;
    State: Integer;
    Feature: Integer;
    saying: string;
    Sound: Integer;
  end;
  TActionInfo = record
    start: Word;
    frame: Word;
    skip: Word;
    ftime: Word;
    usetick: Byte;
  end;
  PTActionInfo = ^TActionInfo;

  THumanAction = record
    ActStand: TActionInfo;
    ActWalk: TActionInfo;
    ActRun: TActionInfo;
    ActRushLeft: TActionInfo;
    ActRushRight: TActionInfo;
    ActWarMode: TActionInfo;
    ActHit: TActionInfo;
    ActHeavyHit: TActionInfo;
    ActBigHit: TActionInfo;
    ActFireHitReady: TActionInfo;
    ActSpell: TActionInfo;
    ActSitdown: TActionInfo;
    ActStruck: TActionInfo;
    ActDie: TActionInfo;
  end;
  PTHumanAction = ^THumanAction;

  TMonsterAction = record
    ActStand: TActionInfo;
    ActWalk: TActionInfo;
    ActAttack: TActionInfo;
    ActCritical: TActionInfo;
    ActStruck: TActionInfo;
    ActDie: TActionInfo;
    ActDeath: TActionInfo;
  end;
  PTMonsterAction = ^TMonsterAction;

const
{  HA: THumanAction = (
    ActStand: (start: 0; frame: 4; skip: 4; ftime: 0; usetick: 0);
    ActWalk: (start: 64; frame: 6; skip: 2; ftime: 0; usetick: 2);
    ActRun: (start: 128; frame: 6; skip: 2; ftime: 0; usetick: 3);
    ActRushLeft: (start: 128; frame: 3; skip: 5; ftime: 0; usetick: 3);
    ActRushRight: (start: 131; frame: 3; skip: 5; ftime: 0; usetick: 3);
    ActWarMode: (start: 192; frame: 1; skip: 0; ftime: 0; usetick: 0);

    ActHit: (start: 200; frame: 6; skip: 2; ftime: 0; usetick: 0);
    ActHeavyHit: (start: 264; frame: 6; skip: 2; ftime: 0; usetick: 0);
    ActBigHit: (start: 328; frame: 8; skip: 0; ftime: 0; usetick: 0);
    ActFireHitReady: (start: 192; frame: 6; skip: 4; ftime: 0; usetick: 0);
    ActSpell: (start: 392; frame: 6; skip: 2; ftime: 0; usetick: 0);
    ActSitdown: (start: 456; frame: 2; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 472; frame: 3; skip: 5; ftime: 0; usetick: 0);
    ActDie: (start: 536; frame: 4; skip: 4; ftime: 0; usetick: 0)
    );}

  HA: THumanAction = (
    ActStand: (start: 0; frame: 4; skip: 4; ftime: 200; usetick: 0);
    ActWalk: (start: 64; frame: 6; skip: 2; ftime: 90; usetick: 2);
    ActRun: (start: 128; frame: 6; skip: 2; ftime: 120; usetick: 3);
    ActRushLeft: (start: 128; frame: 3; skip: 5; ftime: 120; usetick: 3);
    ActRushRight: (start: 131; frame: 3; skip: 5; ftime: 120; usetick: 3);
    ActWarMode: (start: 192; frame: 1; skip: 0; ftime: 200; usetick: 0);

    ActHit: (start: 200; frame: 6; skip: 2; ftime: 85; usetick: 0);
    ActHeavyHit: (start: 264; frame: 6; skip: 2; ftime: 90; usetick: 0);
    ActBigHit: (start: 328; frame: 8; skip: 0; ftime: 70; usetick: 0);
    ActFireHitReady: (start: 192; frame: 6; skip: 4; ftime: 70; usetick: 0);
    ActSpell: (start: 392; frame: 6; skip: 2; ftime: 60; usetick: 0);
    ActSitdown: (start: 456; frame: 2; skip: 0; ftime: 300; usetick: 0);
    ActStruck: (start: 472; frame: 3; skip: 5; ftime: 70; usetick: 0);
    ActDie: (start: 536; frame: 4; skip: 4; ftime: 120; usetick: 0)
    );

  MA9: TMonsterAction = (//4C03D4
    ActStand: (start: 0; frame: 1; skip: 7; ftime: 200; usetick: 0);
    ActWalk: (start: 64; frame: 6; skip: 2; ftime: 120; usetick: 3);
    ActAttack: (start: 64; frame: 6; skip: 2; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 64; frame: 6; skip: 2; ftime: 100; usetick: 0);
    ActDie: (start: 0; frame: 1; skip: 7; ftime: 140; usetick: 0);
    ActDeath: (start: 0; frame: 1; skip: 7; ftime: 0; usetick: 0);
    );
  MA10: TMonsterAction = (//(8Frame) ʿ
    ActStand: (start: 0; frame: 4; skip: 4; ftime: 200; usetick: 0);
    ActWalk: (start: 64; frame: 6; skip: 2; ftime: 120; usetick: 3);
    ActAttack: (start: 128; frame: 4; skip: 4; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 192; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 208; frame: 4; skip: 4; ftime: 140; usetick: 0);
    ActDeath: (start: 272; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA11: TMonsterAction = (//罿(10Frame¥)
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 120; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA12: TMonsterAction = (//,  ӵ .
    ActStand: (start: 0; frame: 4; skip: 4; ftime: 200; usetick: 0);
    ActWalk: (start: 64; frame: 6; skip: 2; ftime: 120; usetick: 3);
    ActAttack: (start: 128; frame: 6; skip: 2; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 192; frame: 2; skip: 0; ftime: 150; usetick: 0);
    ActDie: (start: 208; frame: 4; skip: 4; ftime: 160; usetick: 0);
    ActDeath: (start: 272; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA13: TMonsterAction = (//
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 10; frame: 8; skip: 2; ftime: 160; usetick: 0); //...
    ActAttack: (start: 30; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 110; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 130; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 20; frame: 9; skip: 0; ftime: 150; usetick: 0); //..
    );
  MA14: TMonsterAction = (//ذ 
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 340; frame: 10; skip: 0; ftime: 100; usetick: 0); //ΰ(ȯ)
    );
  MA15: TMonsterAction = (// 
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 1; frame: 1; skip: 0; ftime: 100; usetick: 0);
    );
  MA16: TMonsterAction = (// 
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 4; skip: 6; ftime: 160; usetick: 0);
    ActDeath: (start: 0; frame: 1; skip: 0; ftime: 160; usetick: 0);
    );
  MA17: TMonsterAction = (//ٵ 
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 60; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 100; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 140; usetick: 0); //
    );
  MA19: TMonsterAction = (// (״° )
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 140; usetick: 0); //
    );
  MA20: TMonsterAction = (//׾ Ƴ )
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 100; usetick: 0);
    ActDeath: (start: 340; frame: 10; skip: 0; ftime: 170; usetick: 0); //ٽ Ƴ
    );
  MA21: TMonsterAction = (//
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0); //
    ActAttack: (start: 10; frame: 6; skip: 4; ftime: 120; usetick: 0); // ߻
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 20; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 30; frame: 10; skip: 0; ftime: 160; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0); //
    );
  MA22: TMonsterAction = (//(Ҵ,屺)
    ActStand: (start: 80; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 240; frame: 6; skip: 4; ftime: 100; usetick: 0); //
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 320; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 340; frame: 10; skip: 0; ftime: 160; usetick: 0);
    ActDeath: (start: 0; frame: 6; skip: 4; ftime: 170; usetick: 0); //
    );
  MA23: TMonsterAction = (//ָ
    ActStand: (start: 20; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 100; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 180; frame: 6; skip: 4; ftime: 100; usetick: 0); //
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 260; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 280; frame: 10; skip: 0; ftime: 160; usetick: 0);
    ActDeath: (start: 0; frame: 20; skip: 0; ftime: 100; usetick: 0); //
    );
  MA24: TMonsterAction = (//,  2
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 240; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActStruck: (start: 320; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 340; frame: 10; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 420; frame: 1; skip: 0; ftime: 140; usetick: 0); //
    );
  {
MA25: TMonsterAction = (  //׿
    ActStand:  (start: 0;      frame: 4;  skip: 6;  ftime: 200;  usetick: 0);
    ActWalk:   (start: 70;     frame: 10; skip: 0;  ftime: 200;  usetick: 3); //
    ActAttack: (start: 20;     frame: 6;  skip: 4;  ftime: 120;  usetick: 0); //
    ActCritical:(start: 10;    frame: 6;  skip: 4;  ftime: 120;  usetick: 0); //ħ(Ÿ)
    ActStruck: (start: 50;     frame: 2;  skip: 0;  ftime: 100;  usetick: 0);
    ActDie:    (start: 60;     frame: 10; skip: 0;  ftime: 200;  usetick: 0);
    ActDeath:  (start: 0;      frame: 0;  skip: 0;  ftime: 140;  usetick: 0); //
  );
  }
  MA25: TMonsterAction = (//4C080C
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 70; frame: 10; skip: 0; ftime: 200; usetick: 3);
    ActAttack: (start: 20; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 10; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 50; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 60; frame: 10; skip: 0; ftime: 200; usetick: 0);
    ActDeath: (start: 80; frame: 10; skip: 0; ftime: 200; usetick: 3);
    );

  MA26: TMonsterAction = (//,
    ActStand: (start: 0; frame: 1; skip: 7; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 160; usetick: 0); //...
    ActAttack: (start: 56; frame: 6; skip: 2; ftime: 500; usetick: 0); //
    ActCritical: (start: 64; frame: 6; skip: 2; ftime: 500; usetick: 0); //ݱ
    ActStruck: (start: 0; frame: 4; skip: 4; ftime: 100; usetick: 0);
    ActDie: (start: 24; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 150; usetick: 0); //..
    );
  MA27: TMonsterAction = (//
    ActStand: (start: 0; frame: 1; skip: 7; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 160; usetick: 0); //...
    ActAttack: (start: 0; frame: 0; skip: 0; ftime: 250; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 250; usetick: 0);
    ActStruck: (start: 0; frame: 0; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 0; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 150; usetick: 0); //..
    );
  MA28: TMonsterAction = (//ż ( )
    ActStand: (start: 80; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 0; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 0; frame: 10; skip: 0; ftime: 100; usetick: 0); //..
    );
  MA29: TMonsterAction = (//ż ( )
    ActStand: (start: 80; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 3); //
    ActAttack: (start: 240; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 10; skip: 0; ftime: 100; usetick: 0);
    ActStruck: (start: 320; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 340; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 0; frame: 10; skip: 0; ftime: 100; usetick: 0); //..
    );
  MA30: TMonsterAction = (//4C0974
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 10; skip: 0; ftime: 200; usetick: 3);
    ActAttack: (start: 10; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 10; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 20; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 30; frame: 20; skip: 0; ftime: 150; usetick: 0);
    ActDeath: (start: 0; frame: 10; skip: 0; ftime: 200; usetick: 3);
    );
  MA31: TMonsterAction = (//4C09BC
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 10; skip: 0; ftime: 200; usetick: 3);
    ActAttack: (start: 10; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 0; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 0; frame: 2; skip: 8; ftime: 100; usetick: 0);
    ActDie: (start: 20; frame: 10; skip: 0; ftime: 200; usetick: 0);
    ActDeath: (start: 0; frame: 10; skip: 0; ftime: 200; usetick: 3);
    );

  MA32: TMonsterAction = (//4C0A04
    ActStand: (start: 0; frame: 1; skip: 9; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 6; skip: 4; ftime: 200; usetick: 3);
    ActAttack: (start: 0; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 0; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 0; frame: 2; skip: 8; ftime: 100; usetick: 0);
    ActDie: (start: 80; frame: 10; skip: 0; ftime: 80; usetick: 0);
    ActDeath: (start: 80; frame: 10; skip: 0; ftime: 200; usetick: 3);
    );

  MA33: TMonsterAction = (//4C0A4C
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 200; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 80; usetick: 0);
    ActCritical: (start: 340; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 200; usetick: 0);
    ActDeath: (start: 260; frame: 10; skip: 0; ftime: 200; usetick: 0);
    );

  MA34: TMonsterAction = (//4C0A94
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 200; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 320; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 400; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 420; frame: 20; skip: 0; ftime: 200; usetick: 0);
    ActDeath: (start: 420; frame: 20; skip: 0; ftime: 200; usetick: 0);
    );

  MA35: TMonsterAction = (//4C0ADC
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 30; frame: 10; skip: 0; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 1; skip: 9; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA36: TMonsterAction = (//4C0B24
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 30; frame: 20; skip: 0; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 1; skip: 9; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA37: TMonsterAction = (//4C0B6C
    ActStand: (start: 30; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 30; frame: 4; skip: 6; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 1; skip: 9; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA38: TMonsterAction = (//4C0BB4
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 80; frame: 6; skip: 4; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA39: TMonsterAction = (//4C0BFC
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 300; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 10; frame: 6; skip: 4; ftime: 150; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 20; frame: 2; skip: 0; ftime: 150; usetick: 0);
    ActDie: (start: 30; frame: 10; skip: 0; ftime: 80; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA40: TMonsterAction = (//4.6.6.20.2.20.20
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 250; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 210; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 110; usetick: 0);
    ActCritical: (start: 580; frame: 20; skip: 0; ftime: 135; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 120; usetick: 0);
    ActDie: (start: 260; frame: 20; skip: 0; ftime: 130; usetick: 0);
    ActDeath: (start: 260; frame: 20; skip: 0; ftime: 130; usetick: 0);
    );

  MA41: TMonsterAction = (//4C0C8C
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA42: TMonsterAction = (//4C0CD4
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 10; frame: 8; skip: 2; ftime: 160; usetick: 0);
    ActAttack: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDie: (start: 30; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 30; frame: 10; skip: 0; ftime: 150; usetick: 0);
    );

  MA43: TMonsterAction = (//4C0D1C
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 0);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 0);
    ActCritical: (start: 160; frame: 6; skip: 4; ftime: 160; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 150; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 120; usetick: 0);
    ActDeath: (start: 340; frame: 10; skip: 0; ftime: 100; usetick: 0);
    );

  MA44: TMonsterAction = (//4C0D64
    ActStand: (start: 0; frame: 10; skip: 0; ftime: 300; usetick: 0);
    ActWalk: (start: 10; frame: 6; skip: 4; ftime: 150; usetick: 0);
    ActAttack: (start: 20; frame: 6; skip: 4; ftime: 150; usetick: 0);
    ActCritical: (start: 40; frame: 10; skip: 0; ftime: 150; usetick: 0);
    ActStruck: (start: 40; frame: 2; skip: 8; ftime: 150; usetick: 0);
    ActDie: (start: 30; frame: 6; skip: 4; ftime: 150; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );

  MA45: TMonsterAction = (//4C0DAC
    ActStand: (start: 0; frame: 10; skip: 0; ftime: 300; usetick: 0);
    ActWalk: (start: 0; frame: 10; skip: 0; ftime: 300; usetick: 0);
    ActAttack: (start: 10; frame: 10; skip: 0; ftime: 300; usetick: 0);
    ActCritical: (start: 10; frame: 10; skip: 0; ftime: 100; usetick: 0);
    ActStruck: (start: 0; frame: 1; skip: 9; ftime: 300; usetick: 0);
    ActDie: (start: 0; frame: 1; skip: 9; ftime: 300; usetick: 0);
    ActDeath: (start: 0; frame: 1; skip: 9; ftime: 300; usetick: 0);
    );

  MA46: TMonsterAction = (//4C0DF4
    ActStand: (start: 0; frame: 20; skip: 0; ftime: 100; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActAttack: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDie: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActDeath: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    );
  MA47: TMonsterAction = (//4C0A4C Ѫ
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 200; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActCritical: (start: 260; frame: 6; skip: 4; ftime: 120; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 524; frame: 6; skip: 0; ftime: 200; usetick: 0);
    ActDeath: (start: 524; frame: 6; skip: 0; ftime: 200; usetick: 0);
    );

  MA53: TMonsterAction = (
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 10; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 140; usetick: 0);
    );
  MA60: TMonsterAction = (
    ActStand: (start: 0; frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk: (start: 80; frame: 6; skip: 4; ftime: 160; usetick: 3);
    ActAttack: (start: 160; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 260; frame: 20; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 140; usetick: 0);
    );
  MA61: TMonsterAction = (
    ActStand: (start: 0; frame: 10; skip: 0; ftime: 200; usetick: 0);
    ActWalk: (start: 0; frame: 0; skip: 0; ftime: 160; usetick: 3);
    ActAttack: (start: 10; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0; frame: 0; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 0; frame: 10; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 40; frame: 40; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 340; frame: 1; skip: 0; ftime: 140; usetick: 0);
    );

  MA001: TMonsterAction = ( //4.8.8.1.6
    ActStand: (start: 0; frame: 4; skip: 0; ftime: 200; usetick: 0);
    ActWalk: (start: 32; frame: 8; skip: 0; ftime: 80; usetick: 0);
    ActAttack: (start: 96; frame: 8; skip: 0; ftime: 100; usetick: 0);
    ActCritical: (start: 216; frame: 6; skip: 0; ftime: 0; usetick: 0);
    ActStruck: (start: 160; frame: 1; skip: 0; ftime: 100; usetick: 0);
    ActDie: (start: 168; frame: 6; skip: 0; ftime: 140; usetick: 0);
    ActDeath: (start: 168+5; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA002: TMonsterAction = ( // 4.8.8.1.8
    ActStand:    (start: 0;   frame: 4; skip: 0; ftime: 200; usetick: 0);
    ActWalk:     (start: 32;  frame: 8; skip: 0; ftime: 10; usetick: 0);
    ActAttack:   (start: 96;  frame: 8; skip: 0; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 160; frame: 1; skip: 0; ftime: 100; usetick: 0);
    ActDie:      (start: 168; frame: 8; skip: 0; ftime: 30; usetick: 0);
    ActDeath:    (start: 168+7; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA003: TMonsterAction = ( // 4.6.6.2.8
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 80;  frame: 6; skip: 4; ftime: 10; usetick: 0);
    ActAttack:   (start: 160; frame: 6; skip: 4; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie:      (start: 260; frame: 8; skip: 2; ftime: 30; usetick: 0);
    ActDeath:    (start: 340; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA004: TMonsterAction = ( // 4.6.10.2.9
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 590-510;  frame: 6; skip: 4; ftime: 10; usetick: 0);
    ActAttack:   (start: 670-510;  frame: 10; skip: 0; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 750-510; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie:      (start: 770-510; frame: 9; skip: 1; ftime: 30; usetick: 0);
    ActDeath:    (start: 850-510; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );

  MA005: TMonsterAction = ( // 4.6.6.2.7
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 80;  frame: 6; skip: 4; ftime: 10; usetick: 0);
    ActAttack:   (start: 190;  frame: 6; skip: 4; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 240; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie:      (start: 260; frame: 7; skip: 3; ftime: 30; usetick: 0);
    ActDeath:    (start: 340; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );

  MA006: TMonsterAction = ( // 4.8.3.6.6
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 1980-1900;  frame: 8; skip: 2; ftime: 10; usetick: 0);
    ActAttack:   (start: 2140-1900; frame: 6; skip: 4; ftime: 100; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 2060-1900;  frame: 3; skip: 7; ftime: 80; usetick: 0);
    ActDie:      (start: 2220-1900; frame: 6; skip: 4; ftime: 30; usetick: 0);
    ActDeath:    (start: 2300-1900; frame: 1; skip: 0; ftime: 0; usetick: 0););

  MA007: TMonsterAction = ( // 4.6.6.3.4
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 2380-2300;  frame: 6; skip: 4; ftime: 10; usetick: 0);
    ActAttack:   (start: 2460-2300;  frame: 6; skip: 4; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 2540-2300; frame: 3; skip: 7; ftime: 100; usetick: 0);

    ActDie:      (start: 2620-2300; frame: 4; skip: 6; ftime: 30; usetick: 0);
    ActDeath:    (start: 2700-2300; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  MA008: TMonsterAction = ( // 4.6.10.2.9
    ActStand:    (start: 0;   frame: 4; skip: 6; ftime: 200; usetick: 0);
    ActWalk:     (start: 80;  frame: 6; skip: 4; ftime: 10; usetick: 0);
    ActAttack:   (start: 670-510;  frame: 10; skip: 0; ftime: 80; usetick: 0);
    ActCritical: (start: 0;   frame: 0; skip: 0; ftime: 80; usetick: 0);
    ActStruck:   (start: 750-510; frame: 2; skip: 0; ftime: 100; usetick: 0);
    ActDie:      (start: 770-510; frame: 9; skip: 1; ftime: 30; usetick: 0);
    ActDeath:    (start: 269; frame: 1; skip: 0; ftime: 0; usetick: 0);
    );
  WORDER: array[0..1, 0..599] of Byte =(
    (

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1,
    0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1,

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,

    0, 1, 1, 1, 0, 0, 0, 0,

    1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1,

    0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
    1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1,

    1, 1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0,
    1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1,
    1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1,

    0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0,

    0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,

    0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1
    ),

    (

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1,
    0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1,

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,

    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,

    1, 1, 1, 1, 0, 0, 0, 0,

    1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1,

    0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
    1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1,

    1, 1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0,
    1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1,
    1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1,

    0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0,

    0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,

    0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1
    )
    );

  EffDir: array[0..7] of Byte = (0, 0, 1, 1, 1, 1, 1, 0);


type
  TActor = class
    RecogId: Integer;
    XX: SmallInt;
    YY: SmallInt;
    XX1: Word;
    YY1: Word;
    Dir: Byte;
    sex: Byte;
    Race: Byte;
    hair: Byte;
    dress: Byte;
    weapon: Byte;
    Job: Byte;
    Appearance: Word;
    DeathState: Byte;
    Feature: Integer;
    HorseState: Word;
    Horse, Wing: Byte;
    State: Integer;
    AttackState: Integer;
    AttackStateTime: Integer;
    Death: Boolean;
    DeathTime: DWord;
    Skeleton: Boolean;
    BoDelActor: Boolean;
    BoDelActionAfterFinished: Boolean;
    DescUserName: string;
    UserName: string;
    WorkName: string;
    NameColor: Integer;
    m_Abil: TAbility; //------------------------------

    HitSpeed: shortint;
    isVisible: Boolean;
    BoHoldPlace: Boolean;

    saying: array[0..MAXSAY - 1] of string;
    SayWidths: array[0..MAXSAY - 1] of Integer;
    SayTime: longword;
    SayX, SayY: SmallInt;
    SayLineCount: Integer;

    IsFace: Boolean;
    FaceIndex: Integer;
    FaceFram: Integer;
    FaceTime: Integer;
    FaceStartTime: Integer;
    EffectLightStarttime: Integer;
    IsAddBlood: Boolean;
    AddBloodNum: Integer;
    AddBloodFram: Integer;
    AddBloodTime: Integer;
    AddBloodStartTime: Integer;

    ShiftX: Integer;
    ShiftY: Integer;

    px, hpx, wpx, epx, horsex: SmallInt;
    py, hpy, wpy, epy, horsey: SmallInt;
    rx, ry: SmallInt;
    DownDrawLevel: Integer;
    MagicTargetX, MagicTargetY: SmallInt;

    TargetRecog: Integer;
    HiterCode: Integer;
    MagicNum: Integer;
    CurrentEvent: Integer;
    BoDigFragment: Boolean;
    BoThrow: Boolean;

    BodyOffset, HairOffset, WeaponOffset: Integer;
    BoUseMagic: Boolean;
    BoHitEffect: Boolean;
    BoUseEffect: Boolean;
    HitEffectNumber: Integer;
    WaitMagicRequest: longword;
    WaitForRecogId: Integer;
    WaitForFeature: Integer;
    WaitForStatus: Integer;


    CurMagicFrame: Integer;
    CurLightEffFram: Integer;
    MagicFrameCount: Integer;
    CurMagic: TUseMagicInfo;




    GenAniCount: Integer;
    BoOpenHealth: Boolean;
    BoInstanceOpenHealth: Boolean;
    OpenHealthStart: longword;
    OpenHealthTime: Integer;


    m_BodySurface: TDirectDrawSurface;
    StrSurface  : TDirectDrawSurface;//
    //m_BodySurface: TDirectDrawSurface;
    Grouped: Boolean;
    CurrentAction: Integer;
    ReverseFrame: Boolean;
    WarMode: Boolean;
    WarModeTime: longword;
    ChrLight: Integer;
    MagLight: Integer;
    RushDir: Integer;

    LockEndFrame: Boolean;
    LastStruckTime: longword;
    SendQueryUserNameTime: longword;
    DeleteTime: longword;


    MagicStruckSound: Integer;
    boRunSound: Boolean;
    footstepsound: Integer;
    strucksound: Integer;
    struckweaponsound: Integer;

    appearsound: Integer;
    normalsound: Integer;
    attacksound: Integer;
    weaponsound: Integer;
    screamsound: Integer;
    diesound: Integer;
    die2sound: Integer;

    magicstartsound: Integer;
    magicfiresound: Integer;
    magicexplosionsound: Integer;
  private
    
  protected
    startframe: Integer;
    endframe: Integer;
    currentframe: Integer;

    EffectStart: Integer;
    EffectFrame: Integer;
    EffectEnd: Integer;
    EffectStartTime: LongWord;
    EffectFrameTime: LongWord;

    currentwingframe, PreWingFrame: integer;
    EffectLightFram: Integer;
    boUseLightFram:Boolean;


    frametime: longword;
    starttime: longword;

    MaxTick: Integer;
    CurTick: Integer;
    MoveStep: Integer;
    muchAction: Boolean;
    struckframetime: longword;
    currentdefframe: Integer;
    defframetime: longword;
    defframecount: Integer;
    SkipTick: Integer;
    SmoothMoveTime: longword;
    genanicounttime: longword;
    m_loadsurfacetime: longword;

    oldx, oldy, olddir: Integer;
    actbeforex, actbeforey: Integer;
    wpord: Integer;

    procedure CalcActorFrame; virtual;
    procedure DefaultMotion; virtual;
    function GetDefaultFrame(wmode: Boolean): Integer; virtual;
    procedure DrawEffSurface(dsurface, Source: TDirectDrawSurface; ddx, ddy:
      Integer; blend: Boolean; ceff: TColorEffect);
    procedure DrawWeaponGlimmer(dsurface: TDirectDrawSurface; ddx, ddy:
      Integer);
  public
    MsgList: TList;
    RealActionMsg: TChrMsg;

    constructor Create; virtual;
    destructor Destroy; override;
    procedure AddAction(ident: Word; X, Y, cdir, Feature, State: Integer; Str:
      string; Sound: Integer);
    procedure UpdateMsg(ident: Word; X, Y, cdir, Feature, State: Integer; Str:
      string; Sound: Integer);
    procedure CleanUserMsgs;
    procedure ProcMsg;
    procedure ProcMagicMsg;
    function IsIdle: Boolean;

    procedure UpDataStrSurface;
    function CanWalk: Integer;
    function CanRun: Integer;
    function Strucked: Boolean;
    procedure MicroMove(Dir, step, cur, Max: Integer);
    procedure ReadyAction(msg: TChrMsg);
    function CharWidth: Integer;
    function CharHeight: Integer;
    function CheckSelect(dx, dy: Integer): Boolean;
    procedure CleanCharMapSetting(X, Y: Integer);
    procedure ProceSay(Str: string);
    procedure SetSound; virtual;
    procedure Run; virtual;
    function MagicTimeOut: Boolean;
    procedure RunSound; virtual;
    procedure RunActSound(frame: Integer); virtual;
    procedure RunFrameAction(frame: Integer); virtual;

    procedure ActionEnded; virtual;
    
    function Move: Boolean;virtual;
    function CanCancelAction: Boolean;
    procedure CancelAction;
    procedure FeatureChanged; virtual;
    function light: Integer; virtual;
    procedure DoLoadSurface; virtual;
    function GetDrawEffectValue: TColorEffect;
    procedure DrawAddBlood(dsurface: TDirectDrawSurface; dx, dy: Integer);
    procedure DrawChr(dsurface: TDirectDrawSurface; dx, dy: Integer; blend: Boolean); dynamic;
    procedure DrawEff(dsurface: TDirectDrawSurface; dx, dy: Integer); virtual;
  end;

  TNpcActor = class(TActor)
  private
  public
    procedure CalcActorFrame; override;
    function GetDefaultFrame(wmode: Boolean): Integer; override;
    procedure DoLoadSurface; override;
  end;


  THumActor = class(TActor)
  private
    m_pHairSurface: TDirectDrawSurface;
    m_pWeaponSurface: TDirectDrawSurface;
    m_pEffectSurface: TDirectDrawSurface;
    m_pHorseSurface: TDirectDrawSurface;
    BoWeaponEffect: Boolean;
    CurWpEffect: Integer;
    CurBubbleStruck: Integer;
    wpeffecttime: longword;
    BoHideWeapon: Boolean;

  protected
    procedure CalcActorFrame; override;
    procedure DefaultMotion; override;
    function GetDefaultFrame(wmode: Boolean): Integer; override;
  public

    constructor Create; override;
    destructor Destroy; override;
    procedure Run; override;
    procedure RunFrameAction(frame: Integer); override;
    function light: Integer; override;
    procedure DoLoadSurface; override;


    procedure DoWeaponBreakEffect;
    procedure DrawChr(dsurface: TDirectDrawSurface; dx, dy: Integer; blend:
      Boolean); override;

  end;



//function RaceByPM(Race: Integer): PTMonsterAction;
function GetRaceByPM(race: Integer; Appr: Word): pTMonsterAction;
function GetOffset(appr: Integer): Integer;



implementation

uses
  ClMain, SoundUtil, clMapEff;

function GetRaceByPM(race: Integer; Appr: Word): pTMonsterAction;
begin
  Result := nil;
  case race of
    9 {01}: Result := @MA9; //
    10 {02}: Result := @MA10; //
    11 {03}: Result := @MA11; //
    12 {04}: Result := @MA12; //
    13 {05}: Result := @MA13; //ʳ˻
    14 {06}: Result := @MA14; //
    15 {07}: Result := @MA15; //
    16 {08}: Result := @MA16; //
    17 {06}: Result := @MA14; //
    18 {06}: Result := @MA14; //
    19 {0A}: Result := @MA19; //
    20 {0A}: Result := @MA19; //
    21 {0A}: Result := @MA19; //
    22 {07}: Result := @MA15; //
    23 {06}: Result := @MA14; //
    24 {04}: Result := @MA12; //
    30 {09}: Result := @MA17; //
    31 {09}: Result := @MA17; //
    32 {0F}: Result := @MA24; //
    33 {10}: Result := @MA25; //
    34 {11}: Result := @MA30; //  ¶ħ
    35 {12}: Result := @MA31; //
    36 {13}: Result := @MA32; //
    37 {0A}: Result := @MA19; //
    40 {0A}: Result := @MA19; //
    41 {0B}: Result := @MA20; //
    42 {0B}: Result := @MA20; //
    43 {0C}: Result := @MA21; //
    45 {0A}: Result := @MA19; //
    47 {0D}: Result := @MA22; //
    48 {0E}: Result := @MA23; //
    49 {0E}: Result := @MA23; //
    (*50 {27}: begin //475F32
        case Appr of
          23 {01}: Result := @MA36; //
          24 {02}: Result := @MA37; //
          25 {02}: Result := @MA37; //
          26 {00}: Result := @MA35; //
          27 {02}: Result := @MA37; //
          28 {00}: Result := @MA35; //
          29 {00}: Result := @MA35; //
          30 {00}: Result := @MA35; //
          31 {00}: Result := @MA35; //
          32 {02}: Result := @MA37; //
          33 {00}: Result := @MA35; //
          34 {00}: Result := @MA35; //
          35 {03}: Result := @MA41; //
          36 {03}: Result := @MA41; //
          37 {03}: Result := @MA41; //
          38 {03}: Result := @MA41; //
          39 {03}: Result := @MA41; //
          40 {03}: Result := @MA41; //
          41 {03}: Result := @MA41; //
          42 {04}: Result := @MA46; //
          43 {04}: Result := @MA46; //
          44 {04}: Result := @MA46; //
          45 {04}: Result := @MA46; //
          46 {04}: Result := @MA46; //
          47 {04}: Result := @MA46; //
          48 {03}: Result := @MA41; //
          49 {03}: Result := @MA41; //
          50 {03}: Result := @MA41; //
          51 {00}: Result := @MA35; //
          52 {03}: Result := @MA41; //
          53 {03}: Result := @MA41; //
          else Result := @MA35;
        end;
      end;  *)

    52 {0A}: Result := @MA19; //
    53 {0A}: Result := @MA19; //
    54 {14}: Result := @MA28; //
    55 {15}: Result := @MA29; //
    60 {16}: Result := @MA33; //
    61 {16}: Result := @MA33; //
    62 {16}: Result := @MA33; //
    63 {17}: Result := @MA34; //
    64 {18}: Result := @MA19; //
    65 {18}: Result := @MA19; //
    66 {18}: Result := @MA19; //
    67 {18}: Result := @MA19; //
    68 {18}: Result := @MA19; //
    69 {18}: Result := @MA19; //
    70 {19}: Result := @MA33; //
    71 {19}: Result := @MA33; //
    72 {19}: Result := @MA33; //
    73 {1A}: Result := @MA19; //
    74 {1B}: Result := @MA19; //
    75 {1C}: Result := @MA39; //
    76 {1D}: Result := @MA38; //
    77 {1E}: Result := @MA39; //
    78 {1F}: Result := @MA40; //
    79 {20}: Result := @MA19; //
    80 {21}: Result := @MA42; //
    81 {22}: Result := @MA43; //
    83 {23}: Result := @MA44; //
    84 {24}: Result := @MA45; //
    85 {24}: Result := @MA45; //
    86 {24}: Result := @MA45; //
    87 {24}: Result := @MA45; //
    88 {24}: Result := @MA45; //
    89 {24}: Result := @MA45; //
    90 {11}: Result := @MA30; //
    98 {25}: Result := @MA27; //
    99 {26}: Result := @MA26; //
    100:Result := @MA001;
    101:Result := @MA002;
    102:Result := @MA003;
    103:Result := @MA004;
    104:Result := @MA005;
    105:Result := @MA006;
    106:Result := @MA007;
    107:Result := @MA008;

  end
end;


function GetOffset(appr: Integer): Integer;
var
  nrace, npos: Integer;
begin
  Result := 0;
  nrace := appr div 10;
  npos := appr mod 10;
  Result := npos * 360;
  //2, 3, 7..12, 14..16, 23: Result := npos * 360;
  case nrace of
    0: begin
        Result := npos * 280;
      end;
    1: begin
        Result := npos * 230;
      end;
    4: begin
        Result := npos * 360;
        if npos = 1 then
          Result := 600;
      end;
    5: begin
        Result := npos * 430;
      end;
    6: begin
        Result := npos * 440;
      end;
    13:
      case npos of
        0: Result := 0;
        1: Result := 360;
        2: Result := 440;
        3: Result := 550;
      end;
    17: Result := npos * 350;
    18:
      case npos of
        0: Result := 0;
        1: Result := 520;
        2: Result := 950;
        3: Result := 1574;
        4: Result := 1934;
        5: Result := 2294;
        6: Result := 2654;
        7: Result := 3014;
      end;
    19: case npos of
        0: Result := 0;
        1: Result := 370;
        2: Result := 810;
        3: Result := 1250;
        4: Result := 1630;
        5: Result := 2010;
        6: Result := 2390;
      end;
    20: begin
        Result := npos * 360;
        case npos of
          4: Result := 1440;
          5: Result := 1800;
          6: Result := 2350;
          7: Result := 3060;
        end;
      end;
    21:
      case npos of
        0: Result := 0;
        1: Result := 350;
        2: Result := 460;
        3: Result := 820;
        4: Result := 1180;
        5: Result := 1540;
        6: Result := 1900;
        7: Result := 2440;
        9: Result := 2700;
      end;
    22:
      case npos of
        0: Result := 0;
        1: Result := 430;
        2: Result := 1290;
        3: Result := 1810;

      end;
    24:begin
         case npos of
           0: Result := 0;
           1: Result := 510;
           2: Result := 1090;
         end;
       end;
    25:begin
         case npos of
           0: Result := 0;
           1: Result := 510;
           2: Result := 1020;
           3: Result := 1370;
           4: Result := 1720;
           5: Result := 2070;
           6: Result := 2740;
           7: Result := 3820;
           8: Result := 4170;
           //9: Result := 2008;
         end;
       end;
    26:begin
         case npos of
           0: Result := 0;
           1: Result := 340;
           2: Result := 680;
           3: Result := 1190;
           4: Result := 2540;
           5: Result := 3570;
         end;
       end;
    28:begin
         case npos of
           0: Result := 0;
         end;
       end;

    39:begin
         case npos of
           0: Result := 0;
           1: Result := 232;
           2: Result := 448;
           3: Result := 680;
           4: Result := 896;
           5: Result := 1128;
           6: Result := 1344;
           7: Result := 1560;
           8: Result := 1776;
           9: Result := 2008;
         end;
       end;
    40:begin
         case npos of
           0: Result := 0;
           1: Result := 350;
           2: Result :=   0;
           3: Result :=   0;
           4: Result := 1430;
           5: Result := 1890;
           6: Result := 2820;
           7: Result := 3840;
           8: Result := 4770;
           9: Result := 5870;
         end;
       end;
    41:begin
         case npos of
           0: Result := 0;
           1: Result := 1020;
           2: Result := 1460;
           3: Result := 1900;
           4: Result := 2300;
           5: Result := 2700;
           6: Result := 4150;
           7: Result := 4760;
           //8: Result := 4770;
           //9: Result := 5870;
         end;
       end;
    90: case npos of
        0: Result := 80;
        1: Result := 168;
        2: Result := 184;
        3: Result := 200;
      end;
  end;
end;

constructor TActor.Create;
begin
  inherited Create;
  MsgList := TList.Create;
  RecogId := 0;
  m_BodySurface := nil;
  StrSurface    := nil;
  Fillchar(m_Abil, SizeOf(TAbility), 0);

  isVisible := True;
  BoHoldPlace := True;
  boUseLightFram:= False;


  CurrentAction := 0;
  ReverseFrame := False;
  ShiftX := 0;
  ShiftY := 0;
  DownDrawLevel := 0;
  currentframe := -1;
  
  RealActionMsg.ident := 0;
  UserName := '';
  NameColor := clWhite;
  SendQueryUserNameTime := 0;

  WarMode := False;
  WarModeTime := 0;
  Death := False;
  Skeleton := False;
  BoDelActor := False;
  BoDelActionAfterFinished := False;

  ChrLight := 0;
  MagLight := 0;
  LockEndFrame := False;
  smoothmovetime := 0;
  genanicounttime := 0;
  defframetime := 0;
  m_loadsurfacetime := GetTickCount;
  Grouped := False;
  BoOpenHealth := False;
  BoInstanceOpenHealth := False;

  CurMagic.ServerMagicCode := 0;


  MagicFrameCount := DefMagicFrameCount;

  normalsound := -1;
  footstepsound := -1;
  attacksound := -1;
  weaponsound := -1;
  strucksound := s_struck_body_longstick;
  struckweaponsound := -1;
  screamsound := -1;
  diesound := -1;
  die2sound := -1;
end;

destructor TActor.Destroy;
begin
  MsgList.Free;
  inherited Destroy;
end;




procedure TActor.UpDataStrSurface;
var
  NameSurfaceW,NameSurfaceH:Integer;
begin
  NameSurfaceW := GameWindows.Canvas.TextWidth('');
  if StrSurface = nil then
    StrSurface := TDirectDrawSurface.Create(WILCSDD);
  StrSurface.SetSize(NameSurfaceW,NameSurfaceH);

end;
procedure TActor.AddAction(ident: Word; X, Y, cdir, Feature, State: Integer; Str:
  string; Sound: Integer);
var
  pmsg: PTChrMsg;
begin
  New(pmsg);
  pmsg.ident := ident;
  pmsg.X := X;
  pmsg.Y := Y;
  pmsg.Dir := cdir;
  pmsg.Feature := Feature;
  pmsg.State := State;
  pmsg.saying := Str;
  pmsg.Sound := Sound;
  MsgList.Add(pmsg);
end;

procedure TActor.UpdateMsg(ident: Word; X, Y, cdir, Feature, State: Integer;
  Str: string; Sound: Integer);
var
  i, n: Integer;

begin
  if Self = MySelf then begin
    n := 0;
    while True do begin
      if n >= MsgList.Count then
        Break;
      if (PTChrMsg(MsgList[n]).ident >= 3000) and
        (PTChrMsg(MsgList[n]).ident <= 3099) or
        (PTChrMsg(MsgList[n]).ident = ident)
        then begin
        Dispose(PTChrMsg(MsgList[n]));
        MsgList.Delete(n);
      end
      else
        Inc(n);
    end;
    AddAction(ident, X, Y, cdir, Feature, State, Str, Sound);
  end
  else begin

    if MsgList.Count > 0 then begin
      for i := 0 to MsgList.Count - 1 do begin
        if PTChrMsg(MsgList[i]).ident = ident then begin
          Dispose(PTChrMsg(MsgList[i]));
          MsgList.Delete(i);
          Break;
        end;
      end;
    end;
    AddAction(ident, X, Y, cdir, Feature, State, Str, Sound);
  end;
end;

procedure TActor.CleanUserMsgs;
var
  n: Integer;
begin
  n := 0;
  while True do begin
    if n >= MsgList.Count then
      Break;
    if (PTChrMsg(MsgList[n]).ident >= 3000) and
      (PTChrMsg(MsgList[n]).ident <= 3099)
      then begin
      Dispose(PTChrMsg(MsgList[n]));
      MsgList.Delete(n);
    end
    else
      Inc(n);
  end;
end;

procedure TActor.CalcActorFrame;
var
  pm: PTMonsterAction;


begin
  BoUseMagic := False;
  currentframe := -1;

  BodyOffset := GetOffset(Appearance);
  pm := GetRaceByPM(Race,Appearance);
  if pm = nil then
    Exit;

  case CurrentAction of
    SM_TURN: begin
        startframe := pm.ActStand.start + Dir * (pm.ActStand.frame +
          pm.ActStand.skip);
        endframe := startframe + pm.ActStand.frame - 1;
        frametime := pm.ActStand.ftime;
        starttime := GetTickCount;
        defframecount := pm.ActStand.frame;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_WALK, SM_RUSH, SM_RUSHKUNG, SM_BACKSTEP: begin
        startframe := pm.ActWalk.start + Dir * (pm.ActWalk.frame +
          pm.ActWalk.skip);
        endframe := startframe + pm.ActWalk.frame - 1;
        frametime := pm.ActWalk.ftime;
        starttime := GetTickCount;
        maxtick := pm.ActWalk.usetick;
        curtick := 0;
        movestep := 1;
        if CurrentAction = SM_BACKSTEP then
          MicroMove(GetBack(Dir), movestep, 0, endframe - startframe + 1)
        else
          MicroMove(Dir, movestep, 0, endframe - startframe + 1);
      end;

    SM_HIT: begin
        startframe := pm.ActAttack.start + Dir * (pm.ActAttack.frame +
          pm.ActAttack.skip);
        endframe := startframe + pm.ActAttack.frame - 1;
        frametime := pm.ActAttack.ftime;
        starttime := GetTickCount;

        WarModeTime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_STRUCK: begin
        startframe := pm.ActStruck.start + Dir * (pm.ActStruck.frame +
          pm.ActStruck.skip);
        endframe := startframe + pm.ActStruck.frame - 1;
        frametime := struckframetime;
        starttime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_DEATH: begin
        startframe := pm.ActDie.start + Dir * (pm.ActDie.frame +
          pm.ActDie.skip);
        endframe := startframe + pm.ActDie.frame - 1;
        startframe := endframe;
        frametime := pm.ActDie.ftime;
        starttime := GetTickCount;
      end;
    SM_NOWDEATH: begin
        startframe := pm.ActDie.start + Dir * (pm.ActDie.frame +
          pm.ActDie.skip);
        endframe := startframe + pm.ActDie.frame - 1;
        frametime := pm.ActDie.ftime;
        starttime := GetTickCount;
      end;
    SM_SKELETON: begin
        startframe := pm.ActDeath.start + Dir;
        endframe := startframe + pm.ActDeath.frame - 1;
        frametime := pm.ActDeath.ftime;
        starttime := GetTickCount;
      end;
  end;
end;

procedure TActor.ReadyAction(msg: TChrMsg);
var
  n: Integer;
  pmag: PTUseMagicInfo;
begin
  actbeforex := XX;
  actbeforey := YY;

  if msg.ident = SM_ALIVE then begin
    Death := False;
    Skeleton := False;
  end;

  if not Death then begin
    case msg.ident of
      SM_TURN, SM_WALK, SM_BACKSTEP, SM_RUSH, SM_RUSHKUNG, SM_RUN, SM_DIGUP,
        SM_ALIVE: begin
          Feature := msg.Feature;
          State := msg.State;
          if State and STATE_OPENHEATH <> 0 then
            BoOpenHealth := True
          else
            BoOpenHealth := True;
        end;
    end;
    if msg.ident = SM_LIGHTING then n := 0;
    if MySelf = Self then begin
      if (msg.ident = CM_WALK) then
        if not PlayScene.CanWalk(msg.X, msg.Y) then
          Exit;
      if (msg.ident = CM_RUN) then
        if not PlayScene.CanRun(MySelf.NowX, MySelf.NowY, msg.X, msg.Y) then
          Exit;


      case msg.ident of
        CM_TURN,
          CM_WALK,
          CM_SITDOWN,
          CM_RUN,
          CM_HORSERUN,
          CM_HIT,
          CM_POWERHIT,
          CM_LONGHIT,
          CM_WIDEHIT,
          CM_HEAVYHIT,
          CM_40HIT,
          CM_41HIT,
          CM_42HIT,
          CM_43HIT,
          CM_BIGHIT: begin
            RealActionMsg := msg;

            case Msg.ident of
              3009:
                Msg.ident := 13;
              CM_40HIT:
                Msg.ident := SM_40HIT;
              CM_41HIT:
                Msg.ident := SM_41HIT;
              CM_42HIT:
                Msg.ident := SM_42HIT;
              CM_43HIT:
                Msg.ident := SM_43HIT;

            else
              msg.ident := msg.ident - 3000;
            end;

          end;
        CM_THROW: begin
            if Feature <> 0 then begin
              MagicTargetX := TActor(msg.Feature).XX;
              MagicTargetY := TActor(msg.Feature).YY;
              TargetRecog := TActor(msg.Feature).RecogId;
            end;
            RealActionMsg := msg;
            msg.ident := SM_THROW;
          end;
        CM_FIREHIT: begin
            RealActionMsg := msg;
            msg.ident := SM_FIREHIT;
          end;
        CM_SPELL: begin


            //DScreen.AddChatBoardString('Ready=Action(CM-SPELL '+inttostr(msg.Feature),clRed,clBlack);
            RealActionMsg := msg;
            pmag := PTUseMagicInfo(msg.Feature);
            RealActionMsg.Dir := pmag.MagicSerial;
            msg.ident := msg.ident - 3000;//SM_SPELL; //SM=SPELL
          end;
      end;//case msg.ident of

      oldx := XX;
      oldy := YY;
      olddir := Dir;
    end;//if MySelf = Self then
    case msg.ident of
      SM_STRUCK: begin //
          MagicStruckSound := msg.X;
          n := Round(200 - m_Abil.Level * 5);
          if n > 80 then
            struckframetime := n
          else
            struckframetime := 80;
          LastStruckTime := GetTickCount;
        end;
      SM_SPELL: begin  //ʹħ
          Dir := msg.Dir;

          //DScreen.AddChatBoardString('Ready=Action(SM-SPELL '+inttostr(msg.Feature),clRed,clBlack);
          pmag := PTUseMagicInfo(msg.Feature);
          if pmag <> nil then begin
            CurMagic := pmag^;
            CurMagic.ServerMagicCode := -1;
            CurMagic.targx := msg.X;
            CurMagic.targy := msg.Y;
            Dispose(pmag);
          end;

        end;
    else begin
        XX := msg.X;
        YY := msg.Y;
        Dir := msg.Dir;

      end;
    end;

    CurrentAction := msg.ident;
    CalcActorFrame;

  end
  else begin
    if msg.ident = SM_SKELETON then begin
      CurrentAction := msg.ident;
      CalcActorFrame;
      Skeleton := True;
    end;
  end;
  if (msg.ident = SM_DEATH) or (msg.ident = SM_NOWDEATH) then begin
    Death := True;
    DeathTime := GetTickCount;
    PlayScene.ActorDied(Self);
  end;

  RunSound;

end;

procedure TActor.ProcMsg;
var
  msg: TChrMsg;
  meff: TMagicEff;

begin
  while True do begin
    if MsgList.Count <= 0 then
      Break;
    if CurrentAction <> 0 then //õ˳
      Break;
    msg := PTChrMsg(MsgList[0])^;


    Dispose(PTChrMsg(MsgList[0]));
    MsgList.Delete(0);
    case msg.ident of
      SM_STRUCK: begin  //
          HiterCode := msg.Sound;
          ReadyAction(msg);
        end;
      SM_DEATH, //
        SM_NOWDEATH, //
        SM_SKELETON, // ʬ
        SM_ALIVE, //?
        SM_ACTION_MIN {6}..SM_ACTION_MAX {23},
        SM_ACTION2_MIN..SM_ACTION2_MAX,
        3000..3099: begin
          ReadyAction(msg);
        end;
      SM_SPACEMOVE_HIDE: begin //
          meff := TScrollHideEffect.Create(250, 10, XX, YY, Self);
          PlayScene.EffectList.Add(meff);
          PlaySound(s_spacemove_out);
        end;
      SM_SPACEMOVE_HIDE2: begin
          meff := TScrollHideEffect.Create(1590, 10, XX, YY, Self);
          PlayScene.EffectList.Add(meff);
          PlaySound(s_spacemove_out);
        end;
      SM_SPACEMOVE_SHOW: begin //
          meff := TCharEffect.Create(260, 10, Self);
          PlayScene.EffectList.Add(meff);
          msg.ident := SM_TURN;
          ReadyAction(msg);
          PlaySound(s_spacemove_in);
        end;
      SM_SpaceMoveInByMagic: begin
          meff := TCharEffect.Create(1600, 10, Self);
          PlayScene.EffectList.Add(meff);
          msg.ident := SM_TURN;
          ReadyAction(msg);
          PlaySound(s_spacemove_in);
        end;
    else begin
      end;
    end;
  end;

end;

procedure TActor.ProcMagicMsg; //Ҫ
var
  n: Integer;
  msg: TChrMsg;
  fin: Boolean;
begin
  n := 0;
  while True do begin
    if MsgList.Count <= n then
      Break;
    msg := PTChrMsg(MsgList[n])^;
    fin := False;
    case msg.ident of
      SM_MAGICFIRE:
        if CurMagic.ServerMagicCode <> 0 then begin
          CurMagic.ServerMagicCode := 111;
          CurMagic.target := msg.X;
          if msg.Y in [0..MAXMAGICTYPE - 1] then
            CurMagic.EffectType := TMagicType(msg.Y);
          CurMagic.EffectNumber := msg.Dir;
          CurMagic.targx := msg.Feature;
          CurMagic.targy := msg.State;
          CurMagic.Recusion := True;

          fin := True;

        end;
      SM_MAGICFIRE_FAIL:
        if CurMagic.ServerMagicCode <> 0 then begin
          CurMagic.ServerMagicCode := 0;
          fin := True;
        end;
    end;
    if fin then begin
      Dispose(PTChrMsg(MsgList[n]));
      MsgList.Delete(n);
    end
    else
      Inc(n);
  end;
end;

function TActor.IsIdle: Boolean;
var
  p: PTChrMsg;
  i: Integer;
begin


  if (CurrentAction = 0) and (MsgList.Count = 0) then
    Result := True
  else
    Result := False;
end;



function TActor.CanWalk: Integer;
begin
  Result := 1;
end;

function TActor.CanRun: Integer;
begin


  Result := 1;
  if m_Abil.Hp < RUN_MINHEALTH then begin
    Result := -1;
  end;

end;

function TActor.Strucked: Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to MsgList.Count - 1 do begin
    if PTChrMsg(MsgList[i]).ident = SM_STRUCK then begin
      Result := True;
      Break;
    end;
  end;
end;







procedure TActor.MicroMove(Dir, step, cur, Max: Integer);
var
  unx, uny, ss, v: Integer;
begin
  if Max = 0 then Max := 1;

  unx := UNITX * step;
  uny := UNITY * step;
  if cur > Max then
    cur := Max;
  rx := XX;
  ry := YY;
  ss := Round((Max - cur - 1) / Max) * step;
  case Dir of
    DR_UP: begin
        ss := Round((Max - cur) / Max) * step;
        ShiftX := 0;
        ry := YY + ss;
        if ss = step then
          ShiftY := -Round(uny / Max * cur)
        else
          ShiftY := Round(uny / Max * (Max - cur));
      end;
    DR_UPRIGHT: begin
        if Max >= 6 then
          v := 1
        else
          v := 0;
        ss := Round((Max - cur + v) / Max) * step;
        rx := XX - ss;
        ry := YY + ss;
        if ss = step then begin
          ShiftX := Round(unx / Max * cur);
          ShiftY := -Round(uny / Max * cur);
        end
        else begin
          ShiftX := -Round(unx / Max * (Max - cur));
          ShiftY := Round(uny / Max * (Max - cur));
        end;
      end;
    DR_RIGHT: begin
        ss := Round((Max - cur) / Max) * step;
        rx := XX - ss;
        if ss = step then
          ShiftX := Round(unx / Max * cur)
        else
          ShiftX := -Round(unx / Max * (Max - cur));
        ShiftY := 0;
      end;
    DR_DOWNRIGHT: begin
        if Max >= 6 then
          v := 1
        else
          v := 0;
        ss := Round((Max - cur - v) / Max) * step;
        rx := XX - ss;
        ry := YY - ss;
        if ss = step then begin
          ShiftX := Round(unx / Max * cur);
          ShiftY := Round(uny / Max * cur);
        end
        else begin
          ShiftX := -Round(unx / Max * (Max - cur));
          ShiftY := -Round(uny / Max * (Max - cur));
        end;
      end;
    DR_DOWN: begin
        if Max >= 6 then
          v := 1
        else
          v := 0;
        ss := Round((Max - cur - v) / Max) * step;
        ShiftX := 0;
        ry := YY - ss;
        if ss = step then
          ShiftY := Round(uny / Max * cur)
        else
          ShiftY := -Round(uny / Max * (Max - cur));
      end;
    DR_DOWNLEFT: begin
        if Max >= 6 then
          v := 0
        else
          v := 0;
        ss := Round((Max - cur - v) / Max) * step;
        rx := XX + ss;
        ry := YY - ss;
        if ss = step then begin
          ShiftX := -Round(unx / Max * cur);
          ShiftY := Round(uny / Max * cur);
        end
        else begin
          ShiftX := Round(unx / Max * (Max - cur));
          ShiftY := -Round(uny / Max * (Max - cur));
        end;
      end;
    DR_LEFT: begin
        ss := Round((Max - cur) / Max) * step;
        rx := XX + ss;
        if ss = step then
          ShiftX := -Round(unx / Max * cur)
        else
          ShiftX := Round(unx / Max * (Max - cur));
        ShiftY := 0;
      end;
    DR_UPLEFT: begin
        if Max >= 6 then
          v := 1
        else
          v := 0;
        ss := Round((Max - cur + v) / Max) * step;
        rx := XX + ss;
        ry := YY + ss;
        if ss = step then begin
          ShiftX := -Round(unx / Max * cur);
          ShiftY := -Round(uny / Max * cur);
        end
        else begin
          ShiftX := Round(unx / Max * (Max - cur));
          ShiftY := Round(uny / Max * (Max - cur));
        end;
      end;
  end;
end;

procedure TActor.FeatureChanged;
var
  haircount: Integer;
begin
  case Race of

    0: begin
        hair := HAIRfeature(Feature);
        dress := DRESSfeature(Feature);
        weapon := WEAPONfeature(Feature);
        BodyOffset := HUMANFRAME * (dress);
        haircount := (WilHair.ImageCount + WilHair2.ImageCount) div HUMANFRAME div 2;
        if hair > haircount - 1 then
          hair := haircount - 1;
        hair := hair * 2;
        if hair > 1 then
          HairOffset := HUMANFRAME * (hair + sex)
        else
          HairOffset := -1;
        WeaponOffset := HUMANFRAME * weapon;
        Horse := LoByte(HorseState);
        Wing := HiByte(HorseState);
        boUseLightFram := False;
        if Wing = 50 then begin
          boUseLightFram := True;
          Wing := 0;
        end;
      end;
    50: ;
  else begin
      Appearance := APPRfeature(Feature);
      BodyOffset := GetOffset(Appearance);

    end;
  end;
end;

function TActor.light: Integer;
begin
  Result := ChrLight;
end;

procedure TActor.DoLoadSurface;
var
  MonImg: TTilFile;
begin
  //DScreen.AddDebugChatBoardString(UserName+'LoadSurface');
  if currentframe < 0 then currentframe := 0;
  MonImg := GetMonImg(Appearance);
  if MonImg <> nil then begin
    if (not ReverseFrame) then
      m_BodySurface := MonImg.GetImage(GetOffset(Appearance) + currentframe,px, py)
    else
      m_BodySurface := MonImg.GetImage(GetOffset(Appearance) + endframe - (currentframe - startframe),px, py);
  end;
end;

function TActor.CharWidth: Integer;
begin
  if m_BodySurface <> nil then
    Result := m_BodySurface.Width
  else
    Result := 48;
end;

function TActor.CharHeight: Integer;
begin
  if m_BodySurface <> nil then
    Result := m_BodySurface.Height
  else
    Result := 70;
end;

function TActor.CheckSelect(dx, dy: Integer): Boolean;
var
  c: Integer;
begin
  Result := False;
  if m_BodySurface <> nil then begin
    c := m_BodySurface.Pixels[dx, dy];
    if (c <> 0) and
      ((m_BodySurface.Pixels[dx - 1, dy] <> 0) and
      (m_BodySurface.Pixels[dx + 1, dy] <> 0) and
      (m_BodySurface.Pixels[dx, dy - 1] <> 0) and
      (m_BodySurface.Pixels[dx, dy + 1] <> 0)) then
      Result := True;
  end;
end;

procedure TActor.DrawEffSurface(dsurface, Source: TDirectDrawSurface; ddx, ddy:
  Integer; blend: Boolean; ceff: TColorEffect);
begin
  if (GetTickCount - AttackStateTime) > 20 * 1000 then
    AttackState := 0;

  if State and $00800000 <> 0 then begin
    blend := True;
  end;
  if not blend then begin
    if ceff = ceNone then begin
      if Source <> nil then
        dsurface.Draw(ddx, ddy, Source.ClientRect, Source, True);
    end
    else begin
      if Source <> nil then begin
        ImgMixSurface.Draw(0, 0, Source.ClientRect, Source, False);
        DrawEffect(0, 0, Source.Width, Source.Height, ImgMixSurface, ceff);
        dsurface.Draw(ddx, ddy, Source.ClientRect, ImgMixSurface, True);
      end;
    end;
  end
  else begin
    if ceff = ceNone then begin
      if Source <> nil then
        DrawBlend(dsurface, ddx, ddy, Source, DrawADDValue_ActorHide);
    end
    else begin
      if Source <> nil then begin

        ImgMixSurface.Fill(0);
        ImgMixSurface.Draw(0, 0, Source.ClientRect, Source, False);
        DrawEffect(0, 0, Source.Width, Source.Height, ImgMixSurface, ceff);
        DrawBlend(dsurface, ddx, ddy, ImgMixSurface, DrawADDValue_ActorHide);
      end;
    end;
  end;
end;

procedure TActor.DrawWeaponGlimmer(dsurface: TDirectDrawSurface; ddx, ddy:
  Integer);

begin


end;

function TActor.GetDrawEffectValue: TColorEffect;
var
  ceff: TColorEffect;
begin
  ceff := ceNone;
  if (FocusCret = Self) or (MagicTarget = Self) then begin
    ceff := ceBright;
  end;
  if State and $80000000 <> 0 then begin
    ceff := ceGreen;
  end;
  if State and $40000000 <> 0 then begin
    ceff := ceRed;
  end;
  if State and $20000000 <> 0 then begin
    ceff := ceBlue;
  end;
  if State and $10000000 <> 0 then begin
    ceff := ceYellow;
  end;
  if State and $08000000 <> 0 then begin
    ceff := ceFuchsia;
  end;
  if State and $04000000 <> 0 then begin
    ceff := ceGrayScale;
  end;
  if AttackState and $80000000 <> 0 then begin
    ceff := ceblue;
  end;
  if AttackState and $40000000 <> 0 then begin
    ceff := ceFuchsia;
  end;
  Result := ceff;
end;

procedure TActor.DrawAddBlood(dsurface: TDirectDrawSurface; dx, dy: Integer);
var
  BooldNum, jj, BooldIndex: Integer;
  d: TDirectDrawSurface;
  p, w: integer;
  TilFile:TTilFile;
  function GetIndex(var Index: Integer): Integer;
  var
    s: string;
  begin
    s := Inttostr(Index);
    Result := Strtoint(s[1]) + 1000;
    Delete(s, 1, 1);
    if s <> '' then
      Index := Strtoint(s)
    else
      Index := -1;
  end;
begin
  d := nil;
  if IsAddBlood then begin
    if GetTickCount - AddBloodTime > 1000 then
      IsAddBlood := False;
    if GetTickCount - AddBloodStartTime > 40 then begin
      Inc(AddBloodFram);
      AddBloodStartTime := GetTickCount;
    end;
  end;


  if (IsAddBlood) then begin
    BooldNum := abs(AddBloodNum);
    jj := 1;
    if Self = Myself then
      p := 24
    else
      if Race <> 0 then
        p := 0
      else
        P := 12;
    if p = 24 then
      w := 12
    else
      w := 8;
{$IF Ver_LCJ}
  TilFile:= w16ProgUse;
{$ELSE}
  TilFile:= WilNeiGua;
{$IFEND}
    if AddBloodnum > 0 then
      d := TilFile.Images[1011 + p]
    else
      d := TilFile.Images[1010 + p];




    if d <> nil then
      dsurface.Draw(SayX - d.Width div 2 {+ AddBloodFram * (2)}, dy + hpy + ShiftY - 10 - AddBloodFram * (2), d.ClientRect, d, True);

    while (BooldNum >= 0) do begin
      BooldIndex := GetIndex(BooldNum);
      d := TilFile.Images[BooldIndex + p];
      if d <> nil then
        dsurface.Draw(SayX - d.Width div 2 + {AddBloodFram*(2)+} jj * w, dy + hpy + ShiftY - 10 - AddBloodFram * (2), d.ClientRect, d, True);


      Inc(jj);
    end;
  end;
end;

procedure TActor.DrawChr(dsurface: TDirectDrawSurface; dx, dy: Integer; blend:
  Boolean);
var
  idx, ax, ay: SmallInt;
  d: TDirectDrawSurface;
  ceff: TColorEffect;
  wimg: TTilFile;

begin
  d := nil;
  if not (Dir in [0..7]) then
    Exit;


  if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
    m_loadsurfacetime := GetTickCount;
    DoLoadSurface;
  end;
  //m_loadsurfacetime := GetTickCount;
  ceff := GetDrawEffectValue;

  if m_BodySurface <> nil then begin
    DrawEffSurface(dsurface, m_BodySurface, dx + px + ShiftX, dy + py + ShiftY,
      blend, ceff);
  end;

  DrawAddBlood(dsurface, dx, dy);


  if BoUseMagic and (CurMagic.EffectNumber > 0) then
    if CurMagicFrame in [0..MagicFrameCount - 1] then begin
      GetMagicEffectBase(CurMagic.EffectNumber - 1, wimg, idx);
      idx := idx + CurMagicFrame;
      if wimg <> nil then
        d := wimg.GetImage(idx, ax, ay);
      if d <> nil then
        DrawBlend(dsurface,
          dx + ax + ShiftX,
          dy + ay + ShiftY,
          d, DrawADDValue_MagicEffect);
    end;
end;

procedure TActor.DrawEff(dsurface: TDirectDrawSurface; dx, dy: Integer);
begin

end;


function TActor.GetDefaultFrame(wmode: Boolean): Integer;
var
  cf: Integer;
  pm: PTMonsterAction;
begin
  Result := 0;
  pm := GetRaceByPM(Race,Appearance);
  if pm = nil then
    Exit;

  if Death then begin
    if Skeleton then
      Result := pm.ActDeath.start
    else
      Result := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip) +
        (pm.ActDie.frame - 1);
  end
  else begin
    defframecount := pm.ActStand.frame;
    if currentdefframe < 0 then
      cf := 0
    else if currentdefframe >= pm.ActStand.frame then
      cf := 0
    else
      cf := currentdefframe;
    Result := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip) +
      cf;
  end;
end;

procedure TActor.DefaultMotion;
begin
  ReverseFrame := False;
  if WarMode then begin
    if (GetTickCount - WarModeTime > 4 * 1000) then

      WarMode := False;
  end;
  currentframe := GetDefaultFrame(WarMode);
  MicroMove(Dir, 0, 1, 1);
end;



procedure TActor.SetSound;
var
  cx, cy, bidx, wunit, attackweapon: Integer;
  hiter: TActor;
begin
  if Race = 0 then begin
    if (Self = MySelf) and
      ((CurrentAction = SM_WALK) or
      (CurrentAction = SM_BACKSTEP) or
      (CurrentAction = SM_RUN) or
      (CurrentAction = SM_RUSH) or
      (CurrentAction = SM_RUSHKUNG)
      )
      then begin
      cx := MySelf.NowX - Map.BlockLeft;
      cy := MySelf.NowY - Map.BlockTop;
      cx := cx div 2 * 2;
      cy := cy div 2 * 2;
      bidx := Map.MArr[cx, cy].BkImg and $7FFF;
      wunit := Map.MArr[cx, cy].Area;
      bidx := wunit * 10000 + bidx - 1;
      case bidx of

        330..349, 450..454, 550..554, 750..754,
          950..954, 1250..1254, 1400..1424, 1455..1474,
          1500..1524, 1550..1574:
          footstepsound := s_walk_lawn_l;




        250..254, 1005..1009, 1050..1054, 1060..1064, 1450..1454,
          1650..1654:
          footstepsound := s_walk_rough_l;



        605..609, 650..654, 660..664, 2000..2049,
          3025..3049, 2400..2424, 4625..4649, 4675..4678:
          footstepsound := s_walk_stone_l;


        1825..1924, 2150..2174, 3075..3099, 3325..3349,
          3375..3399:
          footstepsound := s_walk_cave_l;


        3230, 3231, 3246, 3277:
          footstepsound := s_walk_wood_l;


        3780..3799:
          footstepsound := s_walk_wood_l;

        3825..4434:
          if (bidx - 3825) mod 25 = 0 then
            footstepsound := s_walk_wood_l
          else
            footstepsound := s_walk_ground_l;



        2075..2099, 2125..2149:
          footstepsound := s_walk_room_l;


        1800..1824:
          footstepsound := s_walk_water_l;

      else
        footstepsound := s_walk_ground_l;
      end;

      if (bidx >= 825) and (bidx <= 1349) then begin
        if ((bidx - 825) div 25) mod 2 = 0 then
          footstepsound := s_walk_stone_l;
      end;

      if (bidx >= 1375) and (bidx <= 1799) then begin
        if ((bidx - 1375) div 25) mod 2 = 0 then
          footstepsound := s_walk_cave_l;
      end;
      case bidx of
        1385, 1386, 1391, 1392:
          footstepsound := s_walk_wood_l;
      end;

      bidx := Map.MArr[cx, cy].MidImg and $7FFF;
      bidx := bidx - 1;
      case bidx of
        0..115:
          footstepsound := s_walk_ground_l;
        120..124:
          footstepsound := s_walk_lawn_l;
      end;

      bidx := Map.MArr[cx, cy].FrImg and $7FFF;
      bidx := bidx - 1;
      case bidx of

        221..289, 583..658, 1183..1206, 7163..7295,
          7404..7414:
          footstepsound := s_walk_stone_l;

        3125..3267, 3757..3948,
          6030..6999:
          footstepsound := s_walk_wood_l;

        3316..3589:
          footstepsound := s_walk_room_l;
      end;
      if CurrentAction = SM_RUN then
        footstepsound := footstepsound + 2;

    end;

    if sex = 0 then begin
      screamsound := s_man_struck;
      diesound := s_man_die;
    end
    else begin
      screamsound := s_wom_struck;
      diesound := s_wom_die;
    end;

    case CurrentAction of
      SM_THROW, SM_HIT, SM_HIT + 1, SM_HIT + 2, SM_POWERHIT, SM_LONGHIT,
        SM_WIDEHIT, SM_FIREHIT, SM_40HIT, SM_41HIT, SM_42HIT, SM_43HIT: begin
          case (weapon div 2) of
            6, 20: weaponsound := s_hit_short;
            1: weaponsound := s_hit_wooden;
            2, 13, 9, 5, 14, 22: weaponsound := s_hit_sword;
            4, 17, 10, 15, 16, 23: weaponsound := s_hit_do;
            3, 7, 11: weaponsound := s_hit_axe;
            24: weaponsound := s_hit_club;
            8, 12, 18, 21: weaponsound := s_hit_long;
          else
            weaponsound := s_hit_fist;
          end;
        end;
      SM_STRUCK: begin
          if MagicStruckSound >= 1 then begin

          end
          else begin
            hiter := PlayScene.FindActor(HiterCode);
            attackweapon := 0;
            if hiter <> nil then begin
              attackweapon := hiter.weapon div 2;
              if hiter.Race = 0 then
                case (dress div 2) of
                  3:
                    case attackweapon of
                      6: strucksound := s_struck_armor_sword;
                      1, 2, 4, 5, 9, 10, 13, 14, 15, 16, 17: strucksound :=
                        s_struck_armor_sword;
                      3, 7, 11: strucksound := s_struck_armor_axe;
                      8, 12, 18: strucksound := s_struck_armor_longstick;
                    else
                      strucksound := s_struck_armor_fist;
                    end;
                else
                  case attackweapon of
                    6: strucksound := s_struck_body_sword;
                    1, 2, 4, 5, 9, 10, 13, 14, 15, 16, 17: strucksound :=
                      s_struck_body_sword;
                    3, 7, 11: strucksound := s_struck_body_axe;
                    8, 12, 18: strucksound := s_struck_body_longstick;
                  else
                    strucksound := s_struck_body_fist;
                  end;
                end;
            end;
          end;
        end;
    end;


    if BoUseMagic and (CurMagic.MagicSerial > 0) then begin
      magicstartsound := 10000 + CurMagic.MagicSerial * 10;
      magicfiresound := 10000 + CurMagic.MagicSerial * 10 + 1;
      magicexplosionsound := 10000 + CurMagic.MagicSerial * 10 + 2;
    end;

  end
  else begin
    if Race = 25 then
      Race := 25;

    if CurrentAction = SM_STRUCK then begin
      if MagicStruckSound >= 1 then begin

      end
      else begin
        hiter := PlayScene.FindActor(HiterCode);
        if hiter <> nil then begin
          attackweapon := hiter.weapon div 2;
          case attackweapon of
            6: strucksound := s_struck_body_sword;
            1, 2, 4, 5, 9, 10, 13, 14, 15, 16, 17: strucksound :=
              s_struck_body_sword;
            3, 11: strucksound := s_struck_body_axe;
            8, 12, 18: strucksound := s_struck_body_longstick;
          else
            strucksound := s_struck_body_fist;
          end;
        end;
      end;
    end;

    if Race = 50 then begin
    end
    else begin
      appearsound := 200 + (Appearance) * 10;

      normalsound := 200 + (Appearance) * 10 + 1;
      attacksound := 200 + (Appearance) * 10 + 2;
      weaponsound := 200 + (Appearance) * 10 + 3;
      screamsound := 200 + (Appearance) * 10 + 4;

      diesound := 200 + (Appearance) * 10 + 5;
      die2sound := 200 + (Appearance) * 10 + 6;
    end;
  end;


  if CurrentAction = SM_STRUCK then begin
    hiter := PlayScene.FindActor(HiterCode);
    attackweapon := 0;
    if hiter <> nil then begin
      attackweapon := hiter.weapon div 2;
      if hiter.Race = 0 then
        case (attackweapon div 2) of
          6, 20: struckweaponsound := s_struck_short;
          1: struckweaponsound := s_struck_wooden;
          2, 13, 9, 5, 14, 22: struckweaponsound := s_struck_sword;
          4, 17, 10, 15, 16, 23: struckweaponsound := s_struck_do;
          3, 7, 11: struckweaponsound := s_struck_axe;
          24: struckweaponsound := s_struck_club;
          8, 12, 18, 21: struckweaponsound := s_struck_wooden;

        end;
    end;
  end;

end;

procedure TActor.RunSound;
begin
  borunsound := True;
  SetSound;
  case CurrentAction of
    SM_STRUCK, SM_STRUCK1: begin
        if (struckweaponsound >= 0) then
          PlaySound(struckweaponsound);
        if (strucksound >= 0) then
          PlaySound(strucksound);
        if (screamsound >= 0) then
          PlaySound(screamsound);
      end;
    SM_NOWDEATH: begin
        if (diesound >= 0) then
          PlaySound(diesound);
      end;
    SM_THROW, SM_HIT, SM_FLYAXE, SM_LIGHTING, SM_DIGDOWN: begin
        if attacksound >= 0 then
          PlaySound(attacksound);
      end;
    SM_ALIVE, SM_DIGUP: begin
        PlaySound(appearsound);
      end;
    SM_SPELL: begin
        PlaySound(magicstartsound);
      end;
  end;
end;

procedure TActor.RunActSound(frame: Integer);
begin
  if borunsound then begin
    if Race = 0 then begin
      case CurrentAction of
        SM_THROW, SM_HIT, SM_HIT + 1, SM_HIT + 2:
          if frame = 2 then begin
            PlaySound(weaponsound);
            borunsound := False;
          end;
        SM_POWERHIT:
          if frame = 2 then begin
            PlaySound(weaponsound);
            if sex = 0 then
              PlaySound(s_yedo_man)
            else
              PlaySound(s_yedo_woman);
            borunsound := False;
          end;
        SM_LONGHIT:
          if frame = 2 then begin
            PlaySound(weaponsound);
            PlaySound(s_longhit);
            borunsound := False;
          end;
        SM_WIDEHIT:
          if frame = 2 then begin
            PlaySound(weaponsound);
            PlaySound(s_widehit);
            borunsound := False;
          end;
        SM_FIREHIT:
          if frame = 2 then begin
            PlaySound(weaponsound);
            PlaySound(s_firehit);
            borunsound := False;
          end;
      end;
    end
    else begin
      if Race = 50 then begin
      end
      else begin

        if (CurrentAction = SM_WALK) or (CurrentAction = SM_TURN) then begin
          if (frame = 1) and (random(8) = 1) then begin
            //DScreen.AddDebugChatBoardString(IntToStr(normalsound));
            PlaySound(normalsound);
            borunsound := False;
          end;
        end;
        if CurrentAction = SM_HIT then begin
          if (frame = 3) and (attacksound >= 0) then begin
            PlaySound(weaponsound);
            borunsound := False;
          end;
        end;
        case Appearance of
          80: begin
              if CurrentAction = SM_NOWDEATH then begin
                if (frame = 2) then begin
                  PlaySound(die2sound);
                  borunsound := False;
                end;
              end;
            end;
        end;
      end;

    end;
  end;
end;

procedure TActor.RunFrameAction(frame: Integer);
begin
end;

procedure TActor.ActionEnded;
begin
end;

function TActor.MagicTimeOut: Boolean;
begin
  if Self = MySelf then begin
    Result := GetTickCount - WaitMagicRequest > 3000;
  end
  else
    Result := GetTickCount - WaitMagicRequest > 2000;
  if Result then
    CurMagic.ServerMagicCode := 0;
end;

procedure TActor.Run;
var
  prv: Integer;
  frametimetime: longword;
  bofly: Boolean;
begin
  if (CurrentAction = SM_WALK) or
    (CurrentAction = SM_BACKSTEP) or
    (CurrentAction = SM_RUN) or
    (CurrentAction = SM_RUSH) or
    (CurrentAction = SM_RUSHKUNG)
    then
    Exit;

  muchAction := False;
  if Self <> MySelf then begin
    if MsgList.Count >= 2 then
      muchAction := True; //ද
  end;


  RunActSound(currentframe - startframe);
  RunFrameAction(currentframe - startframe);

  prv := currentframe;
  if CurrentAction <> 0 then begin
    if (currentframe < startframe) or (currentframe > endframe) then
      currentframe := startframe;

    if (Self <> MySelf) and (BoUseMagic) then begin
      frametimetime := Round(frametime / 1.8);
    end
    else begin
      if muchAction then
        frametimetime := Round(frametime * 2 / 3)
      else
        frametimetime := frametime;
    end;

    if GetTickCount - starttime > (frametimetime) then begin
      if currentframe < endframe then begin

        if BoUseMagic then begin
          if (CurMagicFrame = MagicFrameCount - 2) or (MagicTimeOut) then begin
            if (CurMagic.ServerMagicCode >= 0) or (MagicTimeOut) then begin
              Inc(currentframe);
              Inc(CurMagicFrame);
              starttime := GetTickCount;
            end;
          end
          else begin
            if currentframe < endframe - 1 then
              Inc(currentframe);
            Inc(CurMagicFrame);
            starttime := GetTickCount;
          end;
        end
        else begin
          Inc(currentframe);
          Inc(CurLighteffFram);
          starttime := GetTickCount;
        end;

      end
      else begin
        if BoDelActionAfterFinished then begin

          BoDelActor := True;
        end;

        if Self = MySelf then begin

          if MySelf.ServerAcceptNextAction then begin
            ActionEnded;
            CurrentAction := 0;
            BoUseMagic := False;
          end;
        end
        else begin
          ActionEnded;
          CurrentAction := 0;
          BoUseMagic := False;
        end;
      end;
      if BoUseMagic then begin
        if CurMagicFrame = MagicFrameCount - 1 then begin
          if CurMagic.ServerMagicCode > 0 then begin
            with CurMagic do
              PlayScene.AddNewMagic(Self,
                ServerMagicCode,
                EffectNumber,
                XX,
                YY,
                targx,
                targy,
                target,
                EffectType,
                Recusion,
                AniTime,
                bofly);
            if bofly then
              PlaySound(magicfiresound)
            else
              PlaySound(magicexplosionsound);
          end;

          CurMagic.ServerMagicCode := 0;
        end;
      end;
    end;
    if Appearance in [0, 1, 43] then
      currentdefframe := -10
    else
      currentdefframe := 0;
    defframetime := GetTickCount;
  end
  else begin
    if GetTickCount - smoothmovetime > (200) then begin
      if GetTickCount - defframetime > (500) then begin
        defframetime := GetTickCount;
        Inc(currentdefframe);
        if currentdefframe >= defframecount then
          currentdefframe := 0;
      end;
      DefaultMotion;
    end;
  end;

  if prv <> currentframe then begin
    m_loadsurfacetime := GetTickCount;
    DoLoadSurface;
  end;

end;

function TActor.Move: Boolean;
var
  Oldframe, curstep, maxstep: Integer;
  fastmove, normmove: Boolean;
begin
  Result := False;
  fastmove := False;
  normmove := False;
  if (CurrentAction = SM_BACKSTEP) then

    fastmove := True;
  if (CurrentAction = SM_RUSH) or (CurrentAction = SM_RUSHKUNG) then
    normmove := True;
  if (Self = MySelf) and (not fastmove) and (not normmove) then begin
    BoMoveSlow := False;
    BoAttackSlow := False;
    MoveSlowLevel := 0;

    {if m_Abil.Weight > m_Abil.MaxWeight then begin
      MoveSlowLevel := m_Abil.Weight div (m_Abil.MaxWeight + 1);
      BoMoveSlow := True;
    end;
    if m_Abil.WearWeight > m_Abil.MaxWearWeight then begin
      MoveSlowLevel := MoveSlowLevel + m_Abil.WearWeight div (m_Abil.MaxWearWeight + 1);
      BoMoveSlow := True;
    end;
    if m_Abil.HandWeight > m_Abil.MaxHandWeight then begin
      BoAttackSlow := True;
    end;}

    if BoMoveSlow and (SkipTick < MoveSlowLevel) and (neigua.Base.Noweight = 0)
      then begin
      Inc(SkipTick);
      Exit;
    end
    else begin
      SkipTick := 0;
    end;

    if (CurrentAction = SM_WALK) or
      (CurrentAction = SM_BACKSTEP) or
      (CurrentAction = SM_RUN) or
      (CurrentAction = SM_RUSH) or
      (CurrentAction = SM_RUSHKUNG)
      then begin
      case (currentframe - startframe) of
        1: PlaySound(footstepsound);
        4: PlaySound(footstepsound + 1);
      end;
    end;
  end;

  Result := False;
  muchAction := False;
  if Self <> MySelf then begin
    if MsgList.Count >= 2 then
      muchAction := True; //ද
  end;
  Oldframe := currentframe;

  if (CurrentAction = SM_WALK) or
    (CurrentAction = SM_RUN) or
    (CurrentAction = SM_RUSH) or
    (CurrentAction = SM_RUSHKUNG)
    then begin
    if (currentframe < startframe) or (currentframe > endframe) then begin
      currentframe := startframe - 1;
    end;
    if currentframe < endframe then begin  //û
      Inc(currentframe);
      if (muchAction and not normmove) then
        if currentframe < endframe then
          Inc(currentframe);
      curstep := currentframe - startframe + 1;
      maxstep := endframe - startframe + 1;
      MicroMove(Dir, movestep, curstep, maxstep);
    end;
    if currentframe >= endframe then begin
      if Self = MySelf then begin
        if MySelf.ServerAcceptNextAction then begin
          CurrentAction := 0;
          LockEndFrame := True;
          smoothmovetime := GetTickCount;
        end;
      end
      else begin
        CurrentAction := 0;
        LockEndFrame := True;
        smoothmovetime := GetTickCount;
      end;
      Result := True;
    end;
    if CurrentAction = SM_RUSH then begin
      if Self = MySelf then begin
        DizzyDelayStart := GetTickCount;
        DizzyDelayTime := 300;
      end;
    end;
    if CurrentAction = SM_RUSHKUNG then begin //Ұ
      if currentframe >= endframe - 3 then begin
        XX := actbeforex;
        YY := actbeforey;
        rx := XX;
        ry := YY;

        CurrentAction := 0;
        LockEndFrame := True;

      end;
    end;
    Result := True;
  end;

  if (CurrentAction = SM_BACKSTEP) then begin //Ұײ
    if (currentframe > endframe) or (currentframe < startframe) then begin
      currentframe := endframe + 1;
    end;
    if currentframe > startframe then begin
      Dec(currentframe);
      if muchAction or fastmove then
        if currentframe > startframe then
          Dec(currentframe);


      curstep := endframe - currentframe + 1;
      maxstep := endframe - startframe + 1;
      MicroMove(GetBack(Dir), movestep, curstep, maxstep);
    end;
    if currentframe <= startframe then begin
      if Self = MySelf then begin
        CurrentAction := 0;
        LockEndFrame := True;
        smoothmovetime := GetTickCount;


        DizzyDelayStart := GetTickCount;
        DizzyDelayTime := 1000;

      end
      else begin
        CurrentAction := 0;
        LockEndFrame := True;
        smoothmovetime := GetTickCount;
      end;
      Result := True;
    end;
    Result := True;
  end;
  if Oldframe <> currentframe then begin
    m_loadsurfacetime := GetTickCount;
    DoLoadSurface;
  end;
end;


function TActor.CanCancelAction: Boolean;
begin
  Result := False;
  if CurrentAction = SM_HIT then
    if not BoUseEffect then
      Result := True;
end;

procedure TActor.CancelAction;
begin
  CurrentAction := 0;
  LockEndFrame := True;
end;

procedure TActor.CleanCharMapSetting(X, Y: Integer);
begin
  MySelf.XX := X;
  MySelf.YY := Y;
  MySelf.rx := X;
  MySelf.ry := Y;
  oldx := X;
  oldy := Y;
  CurrentAction := 0;
  currentframe := -1;
  CleanUserMsgs;
end;

procedure TActor.ProceSay(Str: string);
var
  i, Len, aline, n: Integer;
  Temp: string;
  Loop: Boolean;
const
  MAXWIDTH = 150;
begin
  SayTime := GetTickCount;
  SayLineCount := 0;

  n := 0;
  Loop := True;
  while Loop do begin
    Temp := '';
    i := 1;
    Len := length(Str);
    while True do begin
      if i > Len then begin
        Loop := False;
        Break;
      end;
      if Byte(Str[i]) >= 128 then begin
        Temp := Temp + Str[i];
        Inc(i);
        if i <= Len then
          Temp := Temp + Str[i]
        else begin
          Loop := False;
          Break;
        end;
      end
      else
        Temp := Temp + Str[i];

      aline := GameWindows.Canvas.TextWidth(Temp);
      if aline > MAXWIDTH then begin
        saying[n] := Temp;
        SayWidths[n] := aline;
        Inc(SayLineCount);
        Inc(n);
        if n >= MAXSAY then begin
          Loop := False;
          Break;
        end;
        Str := Copy(Str, i + 1, Len - i);
        Temp := '';
        Break;
      end;
      Inc(i);
    end;
    if Temp <> '' then begin
      if n < MAXSay then begin
        saying[n] := Temp;
        SayWidths[n] := GameWindows.Canvas.TextWidth(Temp);
        Inc(SayLineCount);
      end;
    end;
  end;
end;

const
    DefNpcActStand:TActionInfo =(start: 0; frame: 4; skip: 6; ftime: 150; usetick: 0);
    DefNpcActAttack:TActionInfo =(start: 30; frame: 10; skip: 0; ftime: 150; usetick: 0);

    ActAttackNil:TActionInfo =(start: 0; frame: 4; skip: 6; ftime: 150; usetick: 0);

    ActAttack2: TActionInfo =   (start: 30; frame: 18; skip: 0; ftime: 150; usetick: 0);

  function GetNpc(var PA:pTActionInfo;Index: Integer): Integer;
  begin
    Result := MERCHANTFRAME * Index;
    PA := @DefNpcActAttack;
    case Index of
      0..23:Result:= MERCHANTFRAME * (Index);
      24: begin
        PA := @ActAttack2;
        Result := 01380;
      end;
      26:begin
        Result := 01620;
      end;
      28:begin
        Result := 01740;
         end;
      29:begin
        Result := 01800;
         end;
      30:begin
        Result := 01860;
         end;
      31:begin
        Result := 01920;
         end;
      25,27,32,35..41,43..46:begin
        PA :=@DefNpcActStand;
        case Index of
          24:Result:= 01500;
          25:Result:= 01560;
          27:Result:= 01680;
          32:Result:= 01980;
          35:Result:= 02160;

          36:Result:= 02220;
          37:Result:= 02280;
          38:Result:= 02340;
          39:Result:= 02400;
          40:Result:= 02460;
          41:Result:= 02520;
          44:Result:= 02700;
          45:Result:= 02760;
          46:Result:= 02820;
        end;
      end;
      51..58:PA := @ActAttackNil;
    end;
  end;
procedure TNpcActor.CalcActorFrame;


var
  px1, py1: SmallInt;
  TempSurface: TDirectDrawSurface;
  PA:pTActionInfo;
begin
  TempSurface := nil;
  BoUseMagic := False;
  currentframe := -1;



  BodyOffset := GetNpc(PA,Appearance);
  if PA = nil then exit;
  Dir := Dir mod 3;
  if Appearance = 75 then Dir := 0;
  if Appearance in [51..58] then
  Dir := 2;
  case CurrentAction of
    SM_TURN: begin
        startframe := PA.start + Dir * (PA.frame + PA.skip);
        endframe := startframe + PA.frame - 1;
        frametime := PA.ftime;
        starttime := GetTickCount;
        defframecount := PA.frame;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_HIT: begin
        {if Appearance = 25 then begin
          startframe := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
          endframe := startframe + pm.ActStand.frame - 1;
          frametime := pm.ActStand.ftime;
          starttime := GetTickCount;
          defframecount := pm.ActStand.frame;
          MicroMove(Dir, 0, 0, 1);

        end
        else begin}
          startframe := PA.start + Dir * (PA.frame + PA.skip);
          endframe := startframe + PA.frame - 1;
          frametime := PA.ftime;
          TempSurface := GetNpcEx(BodyOffset + startframe, px1, py1);
          if (TempSurface = nil) or ((TempSurface.Height <= 1) or (TempSurface.Width <= 1)) then begin
            startframe := DefNpcActStand.start + Dir * (DefNpcActStand.frame + DefNpcActStand.skip);
            endframe := startframe + DefNpcActStand.frame - 1;
            frametime := DefNpcActStand.ftime;
          end;
          starttime := GetTickCount;
        //end;
      end;
  end;
  {if Appearance = 52 then  begin
    BodyOffset := 3320;
    currentframe := 0;
    startframe := 0;
    endframe := 0;
  end; }
end;
procedure TNpcActor.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
  m_BodySurface := GetNpcEx(BodyOffset + currentframe, px, py);
end;
function TNpcActor.GetDefaultFrame(wmode: Boolean): Integer;
var
  cf: Integer;
  pm: pTActionInfo;
begin
  result := 0;
  GetNpc(pm,Appearance);
  if pm = nil then
    Exit;
  Dir := Dir mod 3;

  if currentdefframe < 0 then
    cf := 0
  else if currentdefframe >= pm.frame then
    cf := 0
  else
    cf := currentdefframe;
  Result := pm.start + Dir * (pm.frame + pm.skip) +
    cf;
end;



constructor THumActor.Create;
begin
  inherited Create;
  m_pHairSurface := nil;
  m_pWeaponSurface := nil;
  m_pEffectSurface := nil;
  m_pHorseSurface := nil;
  BoWeaponEffect := False;
end;

destructor THumActor.Destroy;
begin
  inherited Destroy;
end;



procedure THumActor.CalcActorFrame;
var
  haircount: Integer;
begin
  BoUseMagic := False;
  BoHitEffect := False;
  currentframe := -1;

  hair := HAIRfeature(Feature);
  dress := DRESSfeature(Feature);
  weapon := WEAPONfeature(Feature);
    BodyOffset := HUMANFRAME * (dress);


  haircount := (WilHair.ImageCount + WilHair2.ImageCount) div HUMANFRAME div 2;
  if hair > haircount - 1 then
    hair := haircount - 1;
  hair := hair * 2;
  if hair > 1 then
    HairOffset := HUMANFRAME * (hair + sex)
  else
    HairOffset := -1;
  WeaponOffset := HUMANFRAME * weapon;

  case CurrentAction of
    SM_TURN: begin
        startframe := HA.ActStand.start + Dir * (HA.ActStand.frame + HA.ActStand.skip);
        endframe := startframe + HA.ActStand.frame - 1;
        frametime := HA.ActStand.ftime;
        starttime := GetTickCount;
        defframecount := HA.ActStand.frame;
        MicroMove(Dir, 0, 0, endframe - startframe + 1);
      end;
    SM_WALK, SM_BACKSTEP: begin
        startframe := HA.ActWalk.start + Dir * (HA.ActWalk.frame +
          HA.ActWalk.skip);
        endframe := startframe + HA.ActWalk.frame - 1;
        frametime := HA.ActWalk.ftime;
        starttime := GetTickCount;
        maxtick := HA.ActWalk.usetick;
        curtick := 0;
        movestep := 1;
        if CurrentAction = SM_BACKSTEP then
          MicroMove(GetBack(Dir), movestep, 0, endframe - startframe + 1)
        else
          MicroMove(Dir, movestep, 0, endframe - startframe + 1);
      end;
    SM_RUSH: begin //Ұײ
        if RushDir = 0 then begin
          RushDir := 1;
          startframe := HA.ActRushLeft.start + Dir * (HA.ActRushLeft.frame +
            HA.ActRushLeft.skip);
          endframe := startframe + HA.ActRushLeft.frame - 1;
          frametime := HA.ActRushLeft.ftime;
          starttime := GetTickCount;
          maxtick := HA.ActRushLeft.usetick;
          curtick := 0;
          movestep := 1;
          MicroMove(Dir, 1, 0, endframe - startframe + 1);
        end
        else begin
          RushDir := 0;
          startframe := HA.ActRushRight.start + Dir * (HA.ActRushRight.frame +
            HA.ActRushRight.skip);
          endframe := startframe + HA.ActRushRight.frame - 1;
          frametime := HA.ActRushRight.ftime;
          starttime := GetTickCount;
          maxtick := HA.ActRushRight.usetick;
          curtick := 0;
          movestep := 1;
          MicroMove(Dir, 1, 0, endframe - startframe + 1);
        end;
      end;
    SM_RUSHKUNG: begin
        startframe := HA.ActRun.start + Dir * (HA.ActRun.frame +
          HA.ActRun.skip);
        endframe := startframe + HA.ActRun.frame - 1;
        frametime := HA.ActRun.ftime;
        starttime := GetTickCount;
        maxtick := HA.ActRun.usetick;
        curtick := 0;
        movestep := 1;
        MicroMove(Dir, movestep, 0, endframe - startframe + 1);
      end;

    SM_SITDOWN: begin
        startframe := HA.ActSitdown.start + Dir * (HA.ActSitdown.frame +
          HA.ActSitdown.skip);
        endframe := startframe + HA.ActSitdown.frame - 1;
        frametime := HA.ActSitdown.ftime;
        starttime := GetTickCount;
      end;
    SM_RUN, SM_HORSERUN: begin
        startframe := HA.ActRun.start + Dir * (HA.ActRun.frame +
          HA.ActRun.skip);
        endframe := startframe + HA.ActRun.frame - 1;
        frametime := HA.ActRun.ftime;
        starttime := GetTickCount;
        maxtick := HA.ActRun.usetick;
        curtick := 0;

        if CurrentAction = SM_RUN then begin
          if Horse > 0 then
            movestep := 3
          else
            movestep := 2;

        end
        else
          movestep := 1;

        MicroMove(Dir, movestep, 0, endframe - startframe + 1);
      end;
    SM_THROW: begin
        startframe := HA.ActHit.start + Dir * (HA.ActHit.frame +
          HA.ActHit.skip);
        endframe := startframe + HA.ActHit.frame - 1;
        frametime := HA.ActHit.ftime;
        starttime := GetTickCount;
        WarMode := True;
        WarModeTime := GetTickCount;
        BoThrow := True;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_HIT, SM_POWERHIT, SM_LONGHIT, SM_WIDEHIT, SM_FIREHIT, SM_40HIT, SM_41HIT, SM_42HIT, SM_43HIT: begin
        startframe := HA.ActHit.start + Dir * (HA.ActHit.frame +
          HA.ActHit.skip);
        endframe := startframe + HA.ActHit.frame - 1;
        frametime := HA.ActHit.ftime;
        starttime := GetTickCount;
        WarMode := True;
        WarModeTime := GetTickCount;
        if (CurrentAction = SM_POWERHIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 1;
        end;
        if (CurrentAction = SM_LONGHIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 2;
        end;
        if (CurrentAction = SM_WIDEHIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 3;
        end;

        if (CurrentAction = SM_FIREHIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 4;
        end;
        if (CurrentAction = SM_40HIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 6;
        end;
        if (CurrentAction = SM_42HIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 7;
        end;
        if (CurrentAction = SM_43HIT) then begin
          BoHitEffect := True;
          MagLight := 2;
          HitEffectNumber := 8;
        end;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_HEAVYHIT: begin
        startframe := HA.ActHeavyHit.start + Dir * (HA.ActHeavyHit.frame +
          HA.ActHeavyHit.skip);
        endframe := startframe + HA.ActHeavyHit.frame - 1;
        frametime := HA.ActHeavyHit.ftime;
        starttime := GetTickCount;
        WarMode := True;
        WarModeTime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_BIGHIT: begin
        startframe := HA.ActBigHit.start + Dir * (HA.ActBigHit.frame +
          HA.ActBigHit.skip);
        endframe := startframe + HA.ActBigHit.frame - 1;
        frametime := HA.ActBigHit.ftime;
        starttime := GetTickCount;
        WarMode := True;
        WarModeTime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);
      end;
    SM_SPELL: begin
        startframe := HA.ActSpell.start + Dir * (HA.ActSpell.frame + HA.ActSpell.skip);
        endframe := startframe + HA.ActSpell.frame - 1;
        frametime := HA.ActSpell.ftime;
        starttime := GetTickCount;
        CurMagicFrame := 0;
        BoUseMagic := True;
        case CurMagic.EffectNumber of
          22: begin
              MagLight := 4;
              MagicFrameCount := 10;
            end;
          26, 43: begin
              MagLight := 2;
              MagicFrameCount := 20;
              frametime := frametime div 2;
            end;

        else begin
            MagLight := 2;
            MagicFrameCount := DefMagicFrameCount;
          end;
        end;
         {if CurMagic.EffectNumber =MagicId[41] then
            begin
              MagLight := 4;
              SpellFrame :=20;
            end;
         if CurMagic.EffectNumber =MagicId[50] then
            begin
              MagLight := 4;
              SpellFrame :=16;
            end;
         if CurMagic.EffectNumber =MagicId[52] then
          begin
            MagLight := 4;
            SpellFrame :=24;
          end;   }

        WaitMagicRequest := GetTickCount;
        WarMode := True;
        WarModeTime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);
      end;

    SM_STRUCK: begin
        startframe := HA.ActStruck.start + Dir * (HA.ActStruck.frame +
          HA.ActStruck.skip);
        endframe := startframe + HA.ActStruck.frame - 1;
        frametime := struckframetime;
        starttime := GetTickCount;
        MicroMove(Dir, 0, 0, 1);

        genanicounttime := GetTickCount;
        CurBubbleStruck := 0;
      end;
    SM_NOWDEATH: begin
        startframe := HA.ActDie.start + Dir * (HA.ActDie.frame +
          HA.ActDie.skip);
        endframe := startframe + HA.ActDie.frame - 1;
        frametime := HA.ActDie.ftime;
        starttime := GetTickCount;
      end;
  end;
end;

procedure THumActor.DefaultMotion;
begin
  inherited DefaultMotion;
end;

function THumActor.GetDefaultFrame(wmode: Boolean): Integer;
var
  cf: Integer;

begin


  if Death then
    Result := HA.ActDie.start + Dir * (HA.ActDie.frame + HA.ActDie.skip) +
      (HA.ActDie.frame - 1)
  else if wmode then begin

    Result := HA.ActWarMode.start + Dir * (HA.ActWarMode.frame +
      HA.ActWarMode.skip);
  end
  else begin
    defframecount := HA.ActStand.frame;
    if currentdefframe < 0 then
      cf := 0
    else if currentdefframe >= HA.ActStand.frame then
      cf := 0
    else
      cf := currentdefframe;
    Result := HA.ActStand.start + Dir * (HA.ActStand.frame + HA.ActStand.skip) +
      cf;
  end;
end;

procedure THumActor.RunFrameAction(frame: Integer);
var
  meff: TMapEffect;
  event: TMapEff;
  mfly: TFlyingAxe;
begin
  BoHideWeapon := False;
  if CurrentAction = SM_HEAVYHIT then begin
    if (frame = 5) and (BoDigFragment) then begin
      BoDigFragment := False;
      meff := TMapEffect.Create(8 * Dir, 3, XX, YY);
      meff.ImgLib := WilEffect;
      meff.NextFrameTime := 80;
      PlaySound(s_strike_stone);

      PlayScene.EffectList.Add(meff);
      event := MapEffMan.GetEvent(XX, YY, ET_PILESTONES);
      if event <> nil then
        event.EventParam := event.EventParam + 1;
    end;
  end;
  if CurrentAction = SM_THROW then begin
    if (frame = 3) and (BoThrow) then begin
      BoThrow := False;
      mfly := TFlyingAxe(PlayScene.NewFlyObject(Self,
        XX,
        YY,
        MagicTargetX,
        MagicTargetY,
        TargetRecog,
        mtFlyAxe));
      if mfly <> nil then begin
        TFlyingAxe(mfly).ReadyFrame := 40;
        mfly.ImgLib := WilMon3;
        mfly.FlyImageBase := FLYOMAAXEBASE;
      end;

    end;
    if frame >= 3 then
      BoHideWeapon := True;
  end;
end;

procedure THumActor.DoWeaponBreakEffect;
begin
  BoWeaponEffect := True;
  CurWpEffect := 0;
end;

procedure THumActor.Run;
var
  prv: Integer;
  frametimetime: longword;
  bofly: Boolean;
begin
  if GetTickCount - genanicounttime > 120 then begin
    genanicounttime := GetTickCount;
    Inc(GenAniCount);
    if GenAniCount > 100000 then
      GenAniCount := 0;
    Inc(CurBubbleStruck);
  end;
  if BoWeaponEffect then begin
    if GetTickCount - wpeffecttime > 120 then begin
      wpeffecttime := GetTickCount;
      Inc(CurWpEffect);
      if CurWpEffect >= MAXWPEFFECTFRAME then
        BoWeaponEffect := False;
    end;
  end;

  if (CurrentAction = SM_WALK) or
    (CurrentAction = SM_BACKSTEP) or
    (CurrentAction = SM_RUN) or
    (CurrentAction = SM_RUSH) or
    (CurrentAction = SM_RUSHKUNG)
    then
    Exit;

  muchAction := False;
  if Self <> MySelf then begin
    if MsgList.Count >= 2 then
      muchAction := True; //ද
  end;


  RunActSound(currentframe - startframe);
  RunFrameAction(currentframe - startframe);

  prv := currentframe;
  if CurrentAction <> 0 then begin
    if (currentframe < startframe) or (currentframe > endframe) then
      currentframe := startframe;

    if (Self <> MySelf) and (BoUseMagic) then begin
      frametimetime := Round(frametime / 1.8);
    end
    else begin
      if muchAction then
        frametimetime := Round(frametime * 2 / 3)
      else
        frametimetime := frametime;
    end;

    if GetTickCount - starttime > (frametimetime) then begin
      if currentframe < endframe then begin



        if BoUseMagic then begin
          if (CurMagicFrame = MagicFrameCount - 2) or (MagicTimeOut) then begin
            if (CurMagic.ServerMagicCode >= 0) or (MagicTimeOut) then begin
              Inc(currentframe);
              Inc(CurMagicFrame);
              starttime := GetTickCount;
            end;
          end
          else begin
            if currentframe < endframe - 1 then
              Inc(currentframe);
            Inc(CurMagicFrame);
            starttime := GetTickCount;
          end;
        end
        else begin
          Inc(currentframe);
          Inc(CurLighteffFram);
          starttime := GetTickCount;
        end;

      end
      else begin
        if Self = MySelf then begin
          if MySelf.ServerAcceptNextAction then begin
            CurrentAction := 0;
            BoUseMagic := False;

          end;

        end
        else begin
          CurrentAction := 0;
          BoUseMagic := False;
        end;
        BoHitEffect := False;
      end;
      if BoUseMagic then begin
        if CurMagicFrame = MagicFrameCount - 1 then begin

          if CurMagic.ServerMagicCode > 0 then begin
            with CurMagic do
              PlayScene.AddNewMagic(Self,
                ServerMagicCode,
                EffectNumber,
                XX,
                YY,
                targx,
                targy,
                target,
                EffectType,
                Recusion,
                AniTime,
                bofly);
            if bofly then
              PlaySound(magicfiresound)
            else
              PlaySound(magicexplosionsound);
          end;
          if Self = MySelf then
            MySelf.LatestSpellTime := GetTickCount;
          CurMagic.ServerMagicCode := 0;
        end;
      end;

    end;
    if Race = 0 then
      currentdefframe := 0
    else
      currentdefframe := -10;
    defframetime := GetTickCount;
  end  //if CurrentAction <> 0 then
  else begin
    if GetTickCount - smoothmovetime > (200) then begin
      if GetTickCount - defframetime > (500) then begin
        defframetime := GetTickCount;
        Inc(currentdefframe);
        if currentdefframe >= defframecount then
          currentdefframe := 0;
      end;
      DefaultMotion;
    end;
  end;

  if prv <> currentframe then begin
    m_loadsurfacetime := GetTickCount;
    DoLoadSurface;
  end;

end;

function THumActor.light: Integer;
var
  l: Integer;
begin
  l := ChrLight;
  if l < MagLight then begin
    if BoUseMagic or BoHitEffect then
      l := MagLight;
  end;
  Result := l;
end;

procedure THumActor.DoLoadSurface;
var
  offset: Integer;
begin
  m_pHairSurface:= nil;
  m_pWeaponSurface:= nil;
  m_pEffectSurface:= nil;
  m_pHorseSurface:= nil;
  m_BodySurface :=  nil;
  if currentframe < 0 then currentframe := 0;
  //if currentframe > 0 then  begin
    if HairOffset >= 0 then begin
      if (Horse > 0) then
        m_pHairSurface := nil
      else
        m_pHairSurface := GetHairEx(HairOffset + currentframe, hpx, hpy);
    end
    else
      m_pHairSurface := nil;
    m_pWeaponSurface := GetWeaponEx(WeaponOffset + currentframe, wpx, wpy);
    m_BodySurface := GetHumEx(BodyOffset + currentframe, px, py);

  m_pEffectSurface := nil;
  m_pHorseSurface := nil;
  {if Horse > 0 then begin
    begin
      m_pHorseSurface := WilHorse.GetImage(600 * (Horse - 1) + currentframe, horsex, horsey);
      if (BodyOffset + currentframe) > 1200 then
        offset := (BodyOffset + currentframe) mod 1200 + 1200
      else
        offset := BodyOffset + currentframe;
      m_BodySurface := WilHumHorse.GetImage(offset, px, py);
      m_pEffectSurface := nil;
      m_pWeaponSurface := nil;
    end;
  end
  else }begin
    if (Wing > 0) then begin

        offset := (Wing - 1) * 2 + sex;
        m_pEffectSurface := WilHumEffect.GetImage((600) * offset +
          currentframe, epx, epy);
        m_pHorseSurface := nil;

    end;
    if boUseLightFram then begin
      offset := (EffectLightFram) mod 21;
        m_pEffectSurface := WilEffect.GetImage(352 + offset, epx, epy);
        m_pHorseSurface := nil;

    end;
  end;
  //end;
end;

procedure THumActor.DrawChr(dsurface: TDirectDrawSurface; dx, dy: Integer;
  blend: Boolean);
var
  idx, ax, ay, offset,Code: SmallInt;
  d: TDirectDrawSurface;
  ceff: TColorEffect;
  wimg: TTilFile;
begin
  try
  d := nil;
  wimg := nil;
  Code := 0;
  if not (Dir in [0..7]) then
    Exit;
  Code := 1;
  if GetTickCount - FaceTime > 6 * 1000 then
    IsFace := False;
  if GetTickCount - FaceStartTime > 200 then begin
    Inc(FaceFram);
    FaceStartTime := GetTickCount;
  end;
  Code := 2;
  if GetTickCount - EffectLightStarttime > 190 then begin

    Inc(EffectLightFram);
    EffectLightStarttime := GetTickCount;
    Code := 3;
    if boUseLightFram then begin
      Code := 4;
      offset := (EffectLightFram) mod 21;
        m_pEffectSurface := WilEffect.GetImage(352 + offset, epx, epy);
        m_pHorseSurface := nil;

    end;
    Code := 5;
  end;

  FaceFram := FaceFram mod 8;


  Code := 6;
  if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
    m_loadsurfacetime := GetTickCount;
    Code := 7;
    DoLoadSurface;

  end;
  Code := 8;
  ceff := GetDrawEffectValue;

  Code := 9;
  if Race = 0 then begin
    if (currentframe >= 0) and (currentframe <= 599) then
      wpord := WORDER[sex, currentframe];
    Code := 10;
    if (wpord = 0) and (not blend) and (weapon >= 2) and (m_pWeaponSurface <> nil)
      and (not BoHideWeapon) then begin
      Code := 11;
      DrawEffSurface(dsurface, m_pWeaponSurface, dx + wpx + ShiftX, dy + wpy +
        ShiftY, blend, ceNone);
      //DrawWeaponGlimmer(dsurface, dx + ShiftX, dy + ShiftY);
      
    end;
    Code := 12;
    if (m_BodySurface <> nil) and (m_pHorseSurface <> nil) then begin
      Code := 13;
      DrawEffSurface(dsurface, m_pHorseSurface, dx + horsex + ShiftX, dy + horsey +
        ShiftY, blend, ceff);

    end;
    Code := 14;
    if m_BodySurface <> nil then
      DrawEffSurface(dsurface, m_BodySurface, dx + px + ShiftX, dy + py + ShiftY,
        blend, ceff);
    Code := 15;
    if m_pHairSurface <> nil then
      DrawEffSurface(dsurface, m_pHairSurface, dx + hpx + ShiftX, dy + hpy +
        ShiftY, blend, ceff);

    Code := 16;
    if (wpord = 1) and (weapon >= 2) and (m_pWeaponSurface <> nil)
      and (not BoHideWeapon) then begin
      DrawEffSurface(dsurface, m_pWeaponSurface, dx + wpx + ShiftX, dy + wpy +
        ShiftY, blend, ceNone);
      //DrawWeaponGlimmer(dsurface, dx + ShiftX, dy + ShiftY);
      Code := 17;
    end;
    Code := 18;
    if (m_BodySurface <> nil) and (m_pEffectSurface <> nil) then begin
      DrawBlend(dsurface, dx + epx + ShiftX, dy + epy + ShiftY, m_pEffectSurface,
        DrawADDValue_ActorEffect);

      Code := 19;
    end;

    Code := 20;
    if (State and $00100000 <> 0)and (not Death) then begin
      Code := 21;
      if (CurrentAction = SM_STRUCK) and (CurBubbleStruck < 3) then
        idx := MAGBUBBLESTRUCKBASE + CurBubbleStruck
      else
        idx := MAGBUBBLEBASE + (GenAniCount mod 3);
      d := WilMagic.GetImage(idx, ax, ay);
      Code := 22;
      if d <> nil then
        DrawBlend(dsurface, dx + ax + ShiftX, dy + ay + ShiftY, d, DrawADDValue_MagicEffect);
    end;
    Code := 23;

    DrawAddBlood(dsurface, dx, dy);
    Code := 24;

    if (IsFace) and (FaceIndex > -1) then begin
      d := w16Faceimg[FaceIndex * 10 + (FaceFram) mod 8];
      if d <> nil then begin
        if m_pHorseSurface <> nil then
          dsurface.Draw(SayX - d.Width div 2, dy + hpy + ShiftY - 60,
            d.ClientRect, d, True)
        else
          dsurface.Draw(SayX - d.Width div 2, dy + hpy + ShiftY - 50,
            d.ClientRect, d, True);
      end;
      Code := 25;

    end;
  end;
  Code := 26;
  if BoUseMagic and (CurMagic.EffectNumber > 0) then begin
    if CurMagicFrame in [0..MagicFrameCount - 1] then begin
      Code := 27;
      GetMagicEffectBase(CurMagic.EffectNumber - 1, wimg, idx);
      idx := idx + CurMagicFrame;
      if wimg <> nil then
        d := wimg.GetImage(idx, ax, ay);
      if d <> nil then
        DrawBlend(dsurface, dx + ax + ShiftX, dy + ay + ShiftY, d, DrawADDValue_MagicEffect);
    end;
  end;
  Code := 28;
  if BoHitEffect and (HitEffectNumber > 0) then begin
    GetHitEffectBase(HitEffectNumber - 1, wimg, idx);
    idx := idx + Dir * 10 + (currentframe - startframe);
    if wimg <> nil then
      d := wimg.GetImage(idx, ax, ay);
    if d <> nil then
      DrawBlend(dsurface,
        dx + ax + ShiftX,
        dy + ay + ShiftY,
        d, DrawADDValue_MagicEffect);
  end;

  Code := 29;
  if BoWeaponEffect then begin
    idx := WPEFFECTBASE + Dir * 10 + CurWpEffect;
    d := WilMagic.GetImage(idx, ax, ay);
    if d <> nil then
      DrawBlend(dsurface,
        dx + ax + ShiftX,
        dy + ay + ShiftY,
        d, DrawADDValue_MagicEffect);
  end;
  except
    on E: Exception do begin

    DebugOutStr('116' +ClassName+':'+UserName+':'+inttostr(Code)+ E.Message)

              end;

  end;
end;

end.



