unit ClFunc;

interface

uses
  Windows, SysUtils, Classes, Graphics,
  DXDraws, MirGrobal, TyFunc;


const
  DR_0 = 0;
  DR_1 = 1;
  DR_2 = 2;
  DR_3 = 3;
  DR_4 = 4;
  DR_5 = 5;
  DR_6 = 6;
  DR_7 = 7;
  DR_8 = 8;
  DR_9 = 9;
  DR_10 = 10;
  DR_11 = 11;
  DR_12 = 12;
  DR_13 = 13;
  DR_14 = 14;
  DR_15 = 15;
var
  ClFunc_DropItems: TList;

function fmstr(Str: string; Len: Integer): string;
function GetGoldStr(gold: Integer): string;


procedure ClearBag;
procedure AddDropItem(ci: TClientItem);
function ClFunc_GetDropItem(iname: string; MakeIndex: Integer): PTClientItem;
procedure ClFunc_DelDropItem(iname: string; MakeIndex: Integer);
procedure AddDealItemOk(ci: TClientItem);
procedure DelDealItem(ci: TClientItem);
procedure MoveDealItemToBag;
procedure AddDealRemoteItem(ci: TClientItem);
procedure DelDealRemoteItem(ci: TClientItem);
function GetDistance(sx, sy, dx, dy: Integer): Integer;
procedure GetNextPosXY(Dir: Byte; var X, Y: Integer);
procedure GetNextRunXY(Dir: Byte; var X, Y: Integer);
procedure GetNextHorseRunXY(Dir: Byte; var X, Y: Integer);
function GetNextDirection(sx, sy, dx, dy: Integer): Byte;
function GetNextDirection1(sx, sy, dx, dy: Integer): Byte;
function GetBack(Dir: Integer): Integer;
procedure GetBackPosition(sx, sy, Dir: Integer; var newx, newy: Integer);
procedure GetFrontPosition(sx, sy, Dir: Integer; var newx, newy: Integer);
procedure GetNextHitPosition(sx, sy: Integer; var newx, newy: Integer);
function GetFlyDirection(sx, sy, ttx, tty: Integer): Integer;
function GetFlyDirection16(sx, sy, ttx, tty: Integer): Integer;
function PrivDir(ndir: Integer): Integer;
function NextDir(ndir: Integer): Integer;
procedure BoldTextOut(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor: Integer; Str: string);
procedure BoldTextOutFast(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor: Integer; Str: string);
function NameTextOut(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor:
  Integer;
  namestr: string): Integer;
function GetTakeOnPosition(smode: Integer): Integer;
function IsKeyPressed(Key: Byte): Boolean;
procedure AddChangeFace(RecogId: Integer);
procedure DelChangeFace(RecogId: Integer);
function IsChangingFace(RecogId: Integer): Boolean;
function GetJobName(Job: Integer): string;
function GetWork(Hp, Mp: Integer): string;
function DRESSfeature(Feature: Integer): Byte;
function HAIRfeature(Feature: Integer): Byte;
function RACEfeature(Feature: Integer): Byte;
function WEAPONfeature(Feature: Integer): Byte;
function APPRfeature(Feature: Integer): Word;

implementation

uses
  ClMain;

function GetJobName(Job: Integer): string;
begin
  Result := '';
  case Job of
    0: Result := 'սʿ';
    1: Result := 'ʦ';
    2: Result := 'ʿ';
  end;
end;

function fmstr(Str: string; Len: Integer): string;
var
  i: Integer;
begin
  try
    Result := Str + ' ';
    for i := 1 to Len - length(Str) - 1 do
      Result := Result + ' ';
  except
    Result := Str + ' ';
  end;
end;

function GetGoldStr(gold: Integer): string;
var
  i, n: Integer;
  Str: string;
begin
  Str := IntToStr(gold);
  n := 0;
  Result := '';
  for i := length(Str) downto 1 do begin
    if n = 3 then begin
      Result := Str[i] + ',' + Result;
      n := 1;
    end
    else begin
      Result := Str[i] + Result;
      Inc(n);
    end;
  end;
end;
function NameTextOut(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor:
  Integer;
  namestr: string): Integer;
var
  i, row: Integer;
  nstr: string;
begin
  row := 0;
  Result := 0;
  for i := 0 to 10 do begin
    if namestr = '' then
      Break;
    namestr := GetValidStr3(namestr, nstr, ['\']);
    BoldTextOut(Surface,
      X - Surface.Canvas.TextWidth(nstr) div 2,
      Y + row * 12,
      fcolor, bcolor, nstr);
    if NStr <> '' then

      Inc(row);
  end;
  Result := row;
end;
procedure AddDropItem(ci: TClientItem);
var
  pc: PTClientItem;
begin
  New(pc);
  pc^ := ci;
  ClFunc_DropItems.Add(pc);
end;

function ClFunc_GetDropItem(iname: string; MakeIndex: Integer): PTClientItem;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to ClFunc_DropItems.Count - 1 do begin
    if (PTClientItem(ClFunc_DropItems[i]).s.Name = iname) and
      (PTClientItem(ClFunc_DropItems[i]).MakeIndex = MakeIndex) then begin
      Result := PTClientItem(ClFunc_DropItems[i]);
      Break;
    end;
  end;
end;

procedure ClFunc_DelDropItem(iname: string; MakeIndex: Integer);
var
  i: Integer;
begin
  for i := 0 to ClFunc_DropItems.Count - 1 do begin
    if (PTClientItem(ClFunc_DropItems[i]).s.Name = iname) and
      (PTClientItem(ClFunc_DropItems[i]).MakeIndex = MakeIndex) then begin
      Dispose(PTClientItem(ClFunc_DropItems[i]));
      ClFunc_DropItems.Delete(i);
      Break;
    end;
  end;
end;



procedure AddDealItemOk(ci: TClientItem);
var
  i: Integer;
begin
  for i := 0 to 10 - 1 do begin
    if DealItems[i].s.Name = '' then begin
      DealItems[i] := ci;
      Break;
    end;
  end;
end;

procedure DelDealItem(ci: TClientItem);
var
  i: Integer;
begin
  for i := 0 to 10 - 1 do begin
    if (DealItems[i].s.Name = ci.s.Name) and (DealItems[i].MakeIndex =
      ci.MakeIndex) then begin
      Fillchar(DealItems[i], SizeOf(TClientItem), #0);
      Break;
    end;
  end;
end;

procedure MoveDealItemToBag;
var
  i: Integer;
begin
  for i := 0 to 10 - 1 do begin
    if DealItems[i].s.Name <> '' then
      MySelf.AddItemBag(DealItems[i]);
  end;
  Fillchar(DealItems, SizeOf(TClientItem) * 10, #0);
end;

procedure AddDealRemoteItem(ci: TClientItem);
var
  i: Integer;
begin
  for i := 0 to 20 - 1 do begin
    if DealRemoteItems[i].s.Name = '' then begin
      DealRemoteItems[i] := ci;
      Break;
    end;
  end;
end;

procedure DelDealRemoteItem(ci: TClientItem);
var
  i: Integer;
begin
  for i := 0 to 20 - 1 do begin
    if (DealRemoteItems[i].s.Name = ci.s.Name) and (DealRemoteItems[i].MakeIndex
      = ci.MakeIndex) then begin
      Fillchar(DealRemoteItems[i], SizeOf(TClientItem), #0);
      Break;
    end;
  end;
end;



function GetDistance(sx, sy, dx, dy: Integer): Integer;
begin
  Result := _MAX(abs(sx - dx), abs(sy - dy));
end;

procedure GetNextPosXY(Dir: Byte; var X, Y: Integer);
begin
  case Dir of
    DR_UP: begin
        X := X;
        Y := Y - 1;
      end;
    DR_UPRIGHT: begin
        X := X + 1;
        Y := Y - 1;
      end;
    DR_RIGHT: begin
        X := X + 1;
        Y := Y;
      end;
    DR_DOWNRIGHT: begin
        X := X + 1;
        Y := Y + 1;
      end;
    DR_DOWN: begin
        X := X;
        Y := Y + 1;
      end;
    DR_DOWNLEFT: begin
        X := X - 1;
        Y := Y + 1;
      end;
    DR_LEFT: begin
        X := X - 1;
        Y := Y;
      end;
    DR_UPLEFT: begin
        X := X - 1;
        Y := Y - 1;
      end;
  end;
end;

procedure GetNextHorseRunXY(Dir: Byte; var X, Y: Integer);
begin
  case Dir of
    DR_UP: begin
        X := X;
        Y := Y - 3;
      end;
    DR_UPRIGHT: begin
        X := X + 3;
        Y := Y - 3;
      end;
    DR_RIGHT: begin
        X := X + 3;
        Y := Y;
      end;
    DR_DOWNRIGHT: begin
        X := X + 3;
        Y := Y + 3;
      end;
    DR_DOWN: begin
        X := X;
        Y := Y + 3;
      end;
    DR_DOWNLEFT: begin
        X := X - 3;
        Y := Y + 3;
      end;
    DR_LEFT: begin
        X := X - 3;
        Y := Y;
      end;
    DR_UPLEFT: begin
        X := X - 3;
        Y := Y - 3;
      end;
  end;
end;

procedure GetNextRunXY(Dir: Byte; var X, Y: Integer);
begin
  case Dir of
    DR_UP: begin
        X := X;
        Y := Y - 2;
      end;
    DR_UPRIGHT: begin
        X := X + 2;
        Y := Y - 2;
      end;
    DR_RIGHT: begin
        X := X + 2;
        Y := Y;
      end;
    DR_DOWNRIGHT: begin
        X := X + 2;
        Y := Y + 2;
      end;
    DR_DOWN: begin
        X := X;
        Y := Y + 2;
      end;
    DR_DOWNLEFT: begin
        X := X - 2;
        Y := Y + 2;
      end;
    DR_LEFT: begin
        X := X - 2;
        Y := Y;
      end;
    DR_UPLEFT: begin
        X := X - 2;
        Y := Y - 2;
      end;
  end;
end;

function GetNextDirection1(sx, sy, dx, dy: Integer): Byte;
var
  flagx, flagy: Integer;
begin
  Result := DR_DOWN;
  if sx < dx then
    flagx := 1
  else if sx = dx then
    flagx := 0
  else
    flagx := -1;


  if sy < dy then
    flagy := 1
  else if sy = dy then
    flagy := 0
  else
    flagy := -1;


  if (flagx = 0) and (flagy = -1) then
    Result := DR_UP;
  if (flagx = 1) and (flagy = -1) then
    Result := DR_UPRIGHT;
  if (flagx = 1) and (flagy = 0) then
    Result := DR_RIGHT;
  if (flagx = 1) and (flagy = 1) then
    Result := DR_DOWNRIGHT;
  if (flagx = 0) and (flagy = 1) then
    Result := DR_DOWN;
  if (flagx = -1) and (flagy = 1) then
    Result := DR_DOWNLEFT;
  if (flagx = -1) and (flagy = 0) then
    Result := DR_LEFT;
  if (flagx = -1) and (flagy = -1) then
    Result := DR_UPLEFT;
end;

function GetNextDirection(sx, sy, dx, dy: Integer): Byte;
var
  flagx, flagy: Integer;
begin
  Result := DR_DOWN;
  if sx < dx then
    flagx := 1
  else if sx = dx then
    flagx := 0
  else
    flagx := -1;
  if abs(sy - dy) > 2 then
    if (sx >= dx - 1) and (sx <= dx + 1) then
      flagx := 0;

  if sy < dy then
    flagy := 1
  else if sy = dy then
    flagy := 0
  else
    flagy := -1;
  if abs(sx - dx) > 2 then
    if (sy > dy - 1) and (sy <= dy + 1) then
      flagy := 0;

  if (flagx = 0) and (flagy = -1) then
    Result := DR_UP;
  if (flagx = 1) and (flagy = -1) then
    Result := DR_UPRIGHT;
  if (flagx = 1) and (flagy = 0) then
    Result := DR_RIGHT;
  if (flagx = 1) and (flagy = 1) then
    Result := DR_DOWNRIGHT;
  if (flagx = 0) and (flagy = 1) then
    Result := DR_DOWN;
  if (flagx = -1) and (flagy = 1) then
    Result := DR_DOWNLEFT;
  if (flagx = -1) and (flagy = 0) then
    Result := DR_LEFT;
  if (flagx = -1) and (flagy = -1) then
    Result := DR_UPLEFT;
end;

function GetBack(Dir: Integer): Integer;
begin
  Result := DR_UP;
  case Dir of
    DR_UP: Result := DR_DOWN;
    DR_DOWN: Result := DR_UP;
    DR_LEFT: Result := DR_RIGHT;
    DR_RIGHT: Result := DR_LEFT;
    DR_UPLEFT: Result := DR_DOWNRIGHT;
    DR_UPRIGHT: Result := DR_DOWNLEFT;
    DR_DOWNLEFT: Result := DR_UPRIGHT;
    DR_DOWNRIGHT: Result := DR_UPLEFT;
  end;
end;

procedure GetBackPosition(sx, sy, Dir: Integer; var newx, newy: Integer);
begin
  newx := sx;
  newy := sy;
  case Dir of
    DR_UP: newy := newy + 1;
    DR_DOWN: newy := newy - 1;
    DR_LEFT: newx := newx + 1;
    DR_RIGHT: newx := newx - 1;
    DR_UPLEFT: begin
        newx := newx + 1;
        newy := newy + 1;
      end;
    DR_UPRIGHT: begin
        newx := newx - 1;
        newy := newy + 1;
      end;
    DR_DOWNLEFT: begin
        newx := newx + 1;
        newy := newy - 1;
      end;
    DR_DOWNRIGHT: begin
        newx := newx - 1;
        newy := newy - 1;
      end;
  end;
end;

procedure GetNextHitPosition(sx, sy: Integer; var newx, newy: Integer);
var
  dx, dy, dir: Integer;
begin

  dir := GetNextDirection(sx, sy, newx, newy);
  Newx := sx;
  Newy := Sy;
  case dir of
    DR_UP: newy := newy - 2;
    DR_DOWN: newy := newy + 2;
    DR_LEFT: newx := newx + 2;
    DR_RIGHT: newx := newx - 2;
    DR_UPLEFT: begin
        newx := newx - 2;
        newy := newy - 2;
      end;
    DR_UPRIGHT: begin
        newx := newx + 2;
        newy := newy + 2;
      end;
    DR_DOWNLEFT: begin
        newx := newx - 2;
        newy := newy + 2;
      end;
    DR_DOWNRIGHT: begin
        newx := newx + 2;
        newy := newy + 2;
      end;
  end;



end;

procedure GetFrontPosition(sx, sy, Dir: Integer; var newx, newy: Integer);
begin
  newx := sx;
  newy := sy;
  case Dir of
    DR_UP: newy := newy - 1;
    DR_DOWN: newy := newy + 1;
    DR_LEFT: newx := newx - 1;
    DR_RIGHT: newx := newx + 1;
    DR_UPLEFT: begin
        newx := newx - 1;
        newy := newy - 1;
      end;
    DR_UPRIGHT: begin
        newx := newx + 1;
        newy := newy - 1;
      end;
    DR_DOWNLEFT: begin
        newx := newx - 1;
        newy := newy + 1;
      end;
    DR_DOWNRIGHT: begin
        newx := newx + 1;
        newy := newy + 1;
      end;
  end;
end;

function GetFlyDirection(sx, sy, ttx, tty: Integer): Integer;
var
  fx, fy: real;
begin
  fx := ttx - sx;
  fy := tty - sy;
  sx := 0;
  sy := 0;
  Result := DR_DOWN;
  if fx = 0 then begin
    if fy < 0 then
      Result := DR_UP
    else
      Result := DR_DOWN;
    Exit;
  end;
  if fy = 0 then begin
    if fx < 0 then
      Result := DR_LEFT
    else
      Result := DR_RIGHT;
    Exit;
  end;
  if (fx > 0) and (fy < 0) then begin
    if - fy > fx * 2.5 then
      Result := DR_UP
    else if - fy < fx / 3 then
      Result := DR_RIGHT
    else
      Result := DR_UPRIGHT;
  end;
  if (fx > 0) and (fy > 0) then begin
    if fy < fx / 3 then
      Result := DR_RIGHT
    else if fy > fx * 2.5 then
      Result := DR_DOWN
    else
      Result := DR_DOWNRIGHT;
  end;
  if (fx < 0) and (fy > 0) then begin
    if fy < -fx / 3 then
      Result := DR_LEFT
    else if fy > -fx * 2.5 then
      Result := DR_DOWN
    else
      Result := DR_DOWNLEFT;
  end;
  if (fx < 0) and (fy < 0) then begin
    if - fy > -fx * 2.5 then
      Result := DR_UP
    else if - fy < -fx / 3 then
      Result := DR_LEFT
    else
      Result := DR_UPLEFT;
  end;
end;

function GetFlyDirection16(sx, sy, ttx, tty: Integer): Integer;
var
  fx, fy: real;
begin
  fx := ttx - sx;
  fy := tty - sy;
  sx := 0;
  sy := 0;
  Result := 0;
  if fx = 0 then begin
    if fy < 0 then
      Result := 0
    else
      Result := 8;
    Exit;
  end;
  if fy = 0 then begin
    if fx < 0 then
      Result := 12
    else
      Result := 4;
    Exit;
  end;
  if (fx > 0) and (fy < 0) then begin
    Result := 4;
    if - fy > fx / 4 then
      Result := 3;
    if - fy > fx / 1.9 then
      Result := 2;
    if - fy > fx * 1.4 then
      Result := 1;
    if - fy > fx * 4 then
      Result := 0;
  end;
  if (fx > 0) and (fy > 0) then begin
    Result := 4;
    if fy > fx / 4 then
      Result := 5;
    if fy > fx / 1.9 then
      Result := 6;
    if fy > fx * 1.4 then
      Result := 7;
    if fy > fx * 4 then
      Result := 8;
  end;
  if (fx < 0) and (fy > 0) then begin
    Result := 12;
    if fy > -fx / 4 then
      Result := 11;
    if fy > -fx / 1.9 then
      Result := 10;
    if fy > -fx * 1.4 then
      Result := 9;
    if fy > -fx * 4 then
      Result := 8;
  end;
  if (fx < 0) and (fy < 0) then begin
    Result := 12;
    if - fy > -fx / 4 then
      Result := 13;
    if - fy > -fx / 1.9 then
      Result := 14;
    if - fy > -fx * 1.4 then
      Result := 15;
    if - fy > -fx * 4 then
      Result := 0;
  end;
end;

function PrivDir(ndir: Integer): Integer;
begin
  if ndir - 1 < 0 then
    Result := 7
  else
    Result := ndir - 1;
end;

function NextDir(ndir: Integer): Integer;
begin
  if ndir + 1 > 7 then
    Result := 0
  else
    Result := ndir + 1;
end;

procedure BoldTextOut(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor:
  Integer; Str: string);
var
  old: TColor;
begin

  with Surface do begin
    SetBkMode(Canvas.handle, TRANSPARENT);
    old := Canvas.Font.Color;
    Canvas.Font.Color := bcolor;
    Canvas.TextOut(X - 1, Y, Str);
    Canvas.TextOut(X + 1, Y, Str);
    Canvas.TextOut(X, Y - 1, Str);
    Canvas.TextOut(X, Y + 1, Str);
    Canvas.Font.Color := fcolor;
    Canvas.TextOut(X, Y, Str);
    Canvas.Font.Color := old;
    Canvas.Release;
  end;
end;

procedure BoldTextOutFast(Surface: TDirectDrawSurface; X, Y, fcolor, bcolor:
  Integer; Str: string);
var
  old: TColor;
  d: TDirectDrawSurface;
  i, hx, hy: Integer;

  rc: TRect;
begin
  d := nil;
  with Surface do begin



    SetBkMode(Canvas.handle, TRANSPARENT);


    old := Canvas.Font.Color;

    Canvas.Font.Color := bcolor;
    Canvas.TextOut(X + 1, Y + 1, Str);
    Canvas.Font.Color := fcolor;


    Canvas.TextOut(X, Y, Str);
    Canvas.Font.Color := old;
    Canvas.Release;

  end;
end;

function GetTakeOnPosition(smode: Integer): Integer;
begin
  Result := -1;
  case smode of
    10, 11: Result := U_DRESS;
    5, 6: Result := U_WEAPON;
    30: Result := U_Light;
    19, 20, 21: Result := U_NECKLACE;
    15, 16: Result := U_HELMET;

    22, 23: Result := U_RINGL;
    24, 26: Result := U_ARMRINGL;

    25: Result := U_BUJUK;
    54, 64: Result := U_BELT;
    52, 62, 28: Result := U_BOOTS;
    53, 63: Result := U_CHARM;
    75: Result := -2; //ʯ
  end;
end;

function IsKeyPressed(Key: Byte): Boolean;
var
  keyvalue: TKeyBoardState;
begin
  Result := False;
  Fillchar(keyvalue, SizeOf(TKeyBoardState), #0);
  if GetKeyboardState(keyvalue) then
    if (keyvalue[Key] and $80) <> 0 then
      Result := True;
end;

procedure AddChangeFace(RecogId: Integer);
begin
  ChangeFaceReadyList.Add(Pointer(RecogId));
end;

procedure DelChangeFace(RecogId: Integer);
var
  i: Integer;
begin
  for i := 0 to ChangeFaceReadyList.Count - 1 do begin
    if Integer(ChangeFaceReadyList[i]) = RecogId then begin
      ChangeFaceReadyList.Delete(i);
      Break;
    end;
  end;
end;

function IsChangingFace(RecogId: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to ChangeFaceReadyList.Count - 1 do begin
    if Integer(ChangeFaceReadyList[i]) = RecogId then begin
      Result := True;
      Break;
    end;
  end;
end;

function GetWork(Hp, Mp: Integer): string;
var
  i: Integer;
begin
  Result := '';
   {for i:=0 to 98 do
   Begin
      if (Hp=Maxhp[0][i]) or (mp=MaxMp[0][i]) then
      Begin
         Result:=Format('/սʿ%d',[i+1]);
         Break;
      End;
   End;
   for i:=0 to 98 do
   Begin
      if (Hp=Maxhp[1][i]) or (mp=MaxMp[1][i]) then
      Begin
         Result:=Result+Format('/ʦ%d',[i+1]);
         Break;
      End;
   End;
   for i:=0 to 98 do
   Begin
      if (Hp=Maxhp[2][i]) or (mp=MaxMp[2][i]) then
      Begin
         Result:=Result+Format('/ʿ%d',[i+1]);
         Exit;
      End;
   End; }

end;

function DRESSfeature(Feature: Integer): Byte;
begin
  Result := (Feature shr 24) and 255;
end;

function HAIRfeature(Feature: Integer): Byte;
begin
  Result := (Feature shr 16) and 255;
end;


function RACEfeature(Feature: Integer): Byte;
begin
  Result := (Feature) and 255;
end;

function WEAPONfeature(Feature: Integer): Byte;
begin
  Result := (Feature shr 8) and 255;
end;



function APPRfeature(Feature: Integer): Word;
var
  nrace, npos, nn: Integer;
begin
  nrace := (Feature) and 255;
  npos := (Feature shr 16) and 255;
  nn := (Feature shr 24) and 255;
  case nrace of
    98, 99:
      Result := 900 + npos mod 4;
    0: Result := npos;
  else
    Result := npos + nn * 256;
  end;

end;


procedure ClearBag;
begin
  if MySelf <> nil then MySelf.ClearBag;
  if MyHero <> nil then MyHero.ClearBag;
end;
initialization
  ClFunc_DropItems := TList.Create;

finalization
  ClFunc_DropItems.Free;


end.
