unit DXWinCtl;

interface

uses
  Windows, Classes, SysUtils, Graphics, Controls, DXDraws, Grids,
  Dialogs,
  mywil
{$IF WithRegCom}
{$ELSE}
  ,Debug, //ϢԪ TasNat 2009-02-17 20:07:52
  MirGrobal,
  ClVarConst
{$IFEND}
  ;

const

  WINLEFT = 60;
  WINTOP = 60;
  WINRIGHT = 800 - 60;
  BOTTOMEDGE = 600 - 30;

type
  TClickSound = (csNone, csStone, csGlass, csNorm);
  TDXControl = class;
  TOnDirectPaint = procedure(Sender: TDXControl; dsurface: TDirectDrawSurface) of object;
  TOnKeyPress = procedure(Sender: TDXControl; var Key: Char) of object;
  TOnKeyDown = procedure(Sender: TDXControl; var Key: Word; Shift: TShiftState) of object;
  TOnMouseMove = procedure(Sender: TDXControl; Shift: TShiftState; X, Y: Integer) of object;
  TOnMouseDown = procedure(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer) of object;
  TOnMouseUp = procedure(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer) of object;
  TOnClick =   procedure(Sender: TDXControl) of object;
  TOnClickEx = procedure(Sender: TDXControl; X, Y: Integer) of object;
  TOnInRealArea = procedure(Sender: TDXControl; X, Y: Integer; var IsRealArea: Boolean) of object;
  TOnGridSelect = procedure(Sender: TDXControl; ACol, ARow: Integer; Shift: TShiftState) of object;
  TOnGridPaint = procedure(Sender: TDXControl; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState; dsurface: TDirectDrawSurface) of object;
  TOnClickSound = procedure(Sender: TDXControl; Clicksound: TClickSound) of object;
  TOnClose = procedure(Sender: TDXControl) of object;
  TOnOpen = procedure(Sender: TDXControl) of object;

  TOnChangeSelect = procedure(Index: Integer) of object;

  TDXControl = class(TCustomControl)
  private
    FCaption: string;
    FDParent: TDXControl;
    FEnableFocus: Boolean;
    FOnDirectPaint: TOnDirectPaint;
    FOnKeyPress: TOnKeyPress;
    FOnKeyDown: TOnKeyDown;
    FOnMouseMove: TOnMouseMove;
    FOnMouseDown: TOnMouseDown;
    FOnMouseUp: TOnMouseUp;
    FOnDblClick: TNotifyEvent;
    FOnClick: TOnClickEx;
    FOnInRealArea: TOnInRealArea;
    FOnBackgroundClick: TOnClick;
    FImageIndex: Word;
    FImageLib: TTilFile;
    procedure SetCaption(Str: string);
  protected
    FVisible: Boolean;
  public
    Background: Boolean;
    DControls: TList;


    
    WantReturn: Boolean;

    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

    procedure Paint; override;
    procedure Loaded; override;
    function SurfaceX(X: Integer): Integer;
    function SurfaceY(Y: Integer): Integer;
    function LocalX(X: Integer): Integer;
    function LocalY(Y: Integer): Integer;
    procedure AddChild(dcon: TDXControl);
    procedure ChangeChildOrder(dcon: TDXControl);
    function InRange(X, Y: Integer): Boolean;
    function KeyPress(var Key: Char): Boolean; dynamic;
    function KeyDown(var Key: Word; Shift: TShiftState): Boolean; dynamic;
    function MouseMove(Shift: TShiftState; X, Y: Integer): Boolean; dynamic;
    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean; dynamic;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean; dynamic;
    function DblClick(X, Y: Integer): Boolean; dynamic;
    function DoClick(X, Y: Integer): Boolean; dynamic;
    function CanFocusMsg: Boolean;

    procedure Initialize(Lib: TTilFile; Index: Integer); virtual;
    procedure DirectPaint(dsurface: TDirectDrawSurface); dynamic;

  published
    property OnDirectPaint: TOnDirectPaint read FOnDirectPaint write FOnDirectPaint;
    property OnKeyPress: TOnKeyPress read FOnKeyPress write FOnKeyPress;
    property Onkeydown: TOnKeyDown read FOnKeyDown write FOnKeyDown;
    property OnMouseMove: TOnMouseMove read FOnMouseMove write FOnMouseMove;
    property OnMouseDown: TOnMouseDown read FOnMouseDown write FOnMouseDown;
    property OnMouseUp: TOnMouseUp read FOnMouseUp write FOnMouseUp;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnClick: TOnClickEx read FOnClick write FOnClick;
    property OnInRealArea: TOnInRealArea read FOnInRealArea write FOnInRealArea;
    property OnBackgroundClick: TOnClick read FOnBackgroundClick write FOnBackgroundClick;
    property Caption: string read FCaption write SetCaption;
    property DParent: TDXControl read FDParent write FDParent;
    property Visible: Boolean read FVisible write FVisible;
    property ImageIndex: Word read FImageIndex write FImageIndex;
    property ImageLabrary: TTilFile read FImageLib write FImageLib;
    property EnableFocus: Boolean read FEnableFocus write FEnableFocus default False;
    property Color;
    property Hint;
  end;

  TDXButton = class(TDXControl)
  private
    FClickSound: TClickSound;
    FOnClick: TOnClickEx;
    FOnClickSound: TOnClickSound;
  public
    Downed: Boolean;
    constructor Create(aowner: TComponent); override;
    function MouseMove(Shift: TShiftState; X, Y: Integer): Boolean; override;
    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean; override;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean; override;
  published
    property ClickCount: TClickSound read FClickSound write FClickSound;
    property OnClick: TOnClickEx read FOnClick write FOnClick;
    property OnClickSound: TOnClickSound read FOnClickSound write FOnClickSound;
  end;

  TXDListBox = class(TDXControl)
  private
    FBarMinTop: Integer;
    FBarMaxTop: Integer;
    FBarMaxSize: Integer;
    FTopIndex: Integer;
    FSetIndex: Integer;

    FItemHeight: Byte;
    FLineSpace: Byte;

    FUpButton: TDXButton;
    FDownButton: TDXButton;
    FScrollBar: TDXButton;
    FOnChangeSelect: TOnChangeSelect;
    function DoChangeSelect(NewSelect: Integer): Boolean;
    procedure MoveBar(Y: Integer);
  protected
    procedure Resize; override;
    procedure SetName(const NewName: TComponentName); override;
  public
    FItemList: TStringList;

    constructor Create(aowner: TComponent); override;
    procedure UpButtoClick(Sender: TDXControl; X, Y: Integer);
    procedure DownButtonClick(Sender: TDXControl; X, Y: Integer);
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure DirectPaint(dsurface: TDirectDrawSurface); override;

    procedure UpItemHeight(ItemHeight: Integer);
    function GetTopIndex: Integer;
    function Count: Integer;

    procedure BarMouseUp(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BarMouseDown(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BarMouseMove(Sender: TDXControl; Shift: TShiftState; X, Y: Integer);


    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean; override;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean; override;

  published
    property LineSpace: Byte read FLineSpace write FLineSpace;
    property TopIndex: Integer read GetTopIndex write FTopIndex;
    property OnChangeSelect: TOnChangeSelect read FOnChangeSelect write FOnChangeSelect;
  end;
  TDXGrid = class(TDXControl)
  private
    FColCount, FRowCount: Integer;
    FColWidth, FRowHeight: Integer;
    FViewTopLine: Integer;
    SelectCell: TPoint;
    DownPos: TPoint;
    FOnGridSelect: TOnGridSelect;
    FOnGridMouseMove: TOnGridSelect;
    FOnGridPaint: TOnGridPaint;
    function GetColRow(X, Y: Integer; var ACol, ARow: Integer): Boolean;
  public
    cx, cy: Integer;
    Col, row: Integer;
    constructor Create(aowner: TComponent); override;
    function MouseMove(Shift: TShiftState; X, Y: Integer): Boolean; override;
    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean; override;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean; override;
    function DoClick(X, Y: Integer): Boolean; override;
    procedure DirectPaint(dsurface: TDirectDrawSurface); override;

  published
    property ColCount: Integer read FColCount write FColCount;
    property RowCount: Integer read FRowCount write FRowCount;
    property ColWidth: Integer read FColWidth write FColWidth;
    property RowHeight: Integer read FRowHeight write FRowHeight;
    property ViewTopLine: Integer read FViewTopLine write FViewTopLine;
    property OnGridSelect: TOnGridSelect read FOnGridSelect write FOnGridSelect;
    property OnGridMouseMove: TOnGridSelect read FOnGridMouseMove write
      FOnGridMouseMove;
    property OnGridPaint: TOnGridPaint read FOnGridPaint write FOnGridPaint;
  end;

  TDXWindow = class(TDXButton)
  private
    FFloating: Boolean;
    FOnClose:TOnClose;
    FOnOpen :TOnOpen;
    SpotX, SpotY: Integer;
  protected
    procedure SetVisible(flag: Boolean);
  public
    DialogResult: Boolean;
    constructor Create(aowner: TComponent); override;
    function KeyPress(var Key: Char): Boolean; override;
    function KeyDown(var Key: Word; Shift: TShiftState): Boolean; override;
    function MouseMove(Shift: TShiftState; X, Y: Integer): Boolean; override;
    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):Boolean; override;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):Boolean; override;
    procedure SHow;
    procedure Close;
    procedure Open;
    function ShowModal: Integer;
  published
    property Visible: Boolean read FVisible write SetVisible;
    property Floating: Boolean read FFloating write FFloating;
    property OnOpen: TOnOpen read FOnOpen write FOnOpen;
    property OnClose: TOnClose read FOnClose write FOnClose;
  end;


  TDXWinManager = class(TComponent)
  private
  public

    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

    function KeyPress(var Key: Char): Boolean;
    function KeyDown(var Key: Word; Shift: TShiftState): Boolean;
    function MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
    function MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean;
    function MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer):
      Boolean;
    function DblClick(X, Y: Integer): Boolean;
    function Click(X, Y: Integer): Boolean;
    procedure DirectPaint(dsurface: TDirectDrawSurface);

  end;

procedure Register;
procedure SetDFocus(dcon: TDXControl);
procedure ReleaseDFocus;
procedure SetDCapture(dcon: TDXControl);
procedure ReleaseDCapture;

var
  MouseCaptureControl: TDXControl = nil;
  FocusedControl: TDXControl;
  MainWinHandle: Integer;
  ModalDWindow: TDXControl;

implementation
{$IF WithRegCom}
{$ELSE}
  uses ClMain, cliUtil,ClFunc, FState;
{$IFEND}

procedure Register;
begin
  RegisterComponents('MirCom', [TDXWinManager, TDXControl, TDXButton, TDXGrid,
    TDXWindow, TXDListBox]);
end;


procedure SetDFocus(dcon: TDXControl);
begin
  FocusedControl := dcon;
end;

procedure ReleaseDFocus;
begin
  FocusedControl := nil;
end;

procedure SetDCapture(dcon: TDXControl);
begin
  SetCapture(MainWinHandle);
  MouseCaptureControl := dcon;
end;

procedure ReleaseDCapture;
begin
  ReleaseCapture;
  MouseCaptureControl := nil;
end;



constructor TDXControl.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  ControlStyle := ControlStyle + [csAcceptsControls];
  DParent := nil;
  inherited Visible := False;
  FEnableFocus := False;
  Background := False;

  FOnDirectPaint := nil;
  FOnKeyPress := nil;
  FOnKeyDown := nil;
  FOnMouseMove := nil;
  FOnMouseDown := nil;
  FOnMouseUp := nil;
  FOnInRealArea := nil;
  FOnClick := nil;

  DControls := TList.Create;
  FDParent := nil;

  Width := 80;
  Height := 24;
  FCaption := '';
  FVisible := True;

  FImageLib := nil;
  ImageIndex := 0;
end;

destructor TDXControl.Destroy;
begin
  DControls.Free;
  inherited Destroy;
end;


procedure TDXControl.SetCaption(Str: string);
begin
  FCaption := Str;
  if csDesigning in ComponentState then begin
    Refresh;
  end;
end;

procedure TDXControl.Paint;
var
  str: string;
begin
  if csDesigning in ComponentState then begin
    if Caption = '' then str := inttostr(tag) else str := Caption;
    if Self is TDXWindow then begin
      with Canvas do begin
        Pen.Color := ClBlack;
        MoveTo(0, 0);
        LineTo(Width - 1, 0);
        LineTo(Width - 1, Height - 1);
        LineTo(0, Height - 1);
        LineTo(0, 0);
        LineTo(Width - 1, Height - 1);
        MoveTo(Width - 1, 0);
        LineTo(0, Height - 1);
        TextOut((Width - TextWidth(str)) div 2, (Height -
          TextHeight(str)) div 2, str);
      end;
    end
    else begin
      with Canvas do begin
        Pen.Color := ClBlack;
        MoveTo(0, 0);
        LineTo(Width - 1, 0);
        LineTo(Width - 1, Height - 1);
        LineTo(0, Height - 1);
        LineTo(0, 0);
        TextOut((Width - TextWidth(str)) div 2, (Height -
          TextHeight(str)) div 2, str);
      end;
    end;
  end;
end;

procedure TDXControl.Loaded;
var
  i: Integer;
  dcon: TDXControl;
begin
  {$IF WithRegCom}
  {$ELSE}
  if not (csDesigning in ComponentState) then begin
    if FrmDlg.DBackground <> nil then
      if FrmDlg.DBackground.Parent <> nil then
        for i := 0 to FrmDlg.DBackground.Parent.ComponentCount - 1 do begin
          if FrmDlg.DBackground.Parent.Components[i] is TDXControl then begin
            dcon := TDXControl(FrmDlg.DBackground.Parent.Components[i]);
          {Self.Name := Self.Name;
          dcon.Name := dcon.Name;
          Parent.Name := Parent.Name;}
            if dcon.DParent = Self then begin
              AddChild(dcon);
            end;
          end;
        end;
  end;
  {$IFEND}
end;



function TDXControl.SurfaceX(X: Integer): Integer;
var
  d: TDXControl;
begin
  d := Self;
  while True do begin
    if d.DParent = nil then
      Break;
    X := X + d.DParent.Left;
    d := d.DParent;
  end;
  Result := X;
end;

function TDXControl.SurfaceY(Y: Integer): Integer;
var
  d: TDXControl;
begin
  d := Self;
  while True do begin
    if d.DParent = nil then
      Break;
    Y := Y + d.DParent.Top;
    d := d.DParent;
  end;
  Result := Y;
end;



function TDXControl.LocalX(X: Integer): Integer;
var
  d: TDXControl;
begin
  d := Self;
  while True do begin
    if d.DParent = nil then
      Break;
    X := X - d.DParent.Left;
    d := d.DParent;
  end;
  Result := X;
end;

function TDXControl.LocalY(Y: Integer): Integer;
var
  d: TDXControl;
begin
  d := Self;
  while True do begin
    if d.DParent = nil then
      Break;
    Y := Y - d.DParent.Top;
    d := d.DParent;
  end;
  Result := Y;
end;

procedure TDXControl.AddChild(dcon: TDXControl);
begin
  DControls.Add(Pointer(dcon));
end;

procedure TDXControl.ChangeChildOrder(dcon: TDXControl);
var
  i: Integer;
begin
  if not (dcon is TDXWindow) then
    Exit;
  if TDXWindow(dcon).Floating then begin
    for i := 0 to DControls.Count - 1 do begin
      if dcon = DControls[i] then begin
        DControls.Delete(i);
        Break;
      end;
    end;
    DControls.Add(dcon);
  end;
end;

function TDXControl.InRange(X, Y: Integer): Boolean;
var
  InRange: Boolean;
  d: TDirectDrawSurface;
begin
  d := nil;
  if (X >= Left) and (X < Left + Width) and (Y >= Top) and (Y < Top + Height)
    then begin
    InRange := True;
    if Assigned(FOnInRealArea) then
      FOnInRealArea(Self, X - Left, Y - Top, InRange)
    else if FImageLib <> nil then begin
          d := FImageLib.Images[ImageIndex];
      if d <> nil then
        if d.Pixels[X - Left, Y - Top] <= 0 then
          InRange := False;
    end; 
    Result := InRange;
  end
  else
    Result := False;
end;

function TDXControl.KeyPress(var Key: Char): Boolean;
var
  i: Integer;
begin
  Result := False;
  if Background then
    Exit;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).KeyPress(Key) then begin
        Result := True;
        Exit;
      end;
  if (FocusedControl = Self) then begin
    if Assigned(FOnKeyPress) then
      FOnKeyPress(Self, Key);
    Result := True;
  end;
end;

function TDXControl.KeyDown(var Key: Word; Shift: TShiftState): Boolean;
var
  i: Integer;
begin
  Result := False;
  if Background then
    Exit;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).KeyDown(Key, Shift) then begin
        Result := True;
        Exit;
      end;
  if (FocusedControl = Self) then begin
    if Assigned(FOnKeyDown) then
      FOnKeyDown(Self, Key, Shift);
    Result := True;
  end;
end;

function TDXControl.CanFocusMsg: Boolean;
begin
  if (MouseCaptureControl = nil) or ((MouseCaptureControl <> nil) and
    ((MouseCaptureControl = Self) or (MouseCaptureControl = DParent))) then
    Result := True
  else
    Result := False;
end;

function TDXControl.MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).MouseMove(Shift, X - Left, Y - Top) then begin
        Result := True;
        Exit;
      end;

  if (MouseCaptureControl <> nil) then begin
    if (MouseCaptureControl = Self) then begin
      if Assigned(FOnMouseMove) then
        FOnMouseMove(Self, Shift, X, Y);
      Result := True;
    end;
    Exit;
  end;

  if Background then
    Exit;
  if InRange(X, Y) then begin
    if Assigned(FOnMouseMove) then
      FOnMouseMove(Self, Shift, X, Y);
    Result := True;
  end;
end;

function TDXControl.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).MouseDown(Button, Shift, X - Left, Y - Top) then begin
        Result := TRUE;
        exit;
      end;
  if Background then begin
    if Assigned(FOnBackgroundClick) then begin
      WantReturn := FALSE;
      FOnBackgroundClick(self);
      if WantReturn then Result := TRUE;
    end;
    ReleaseDFocus;
    exit;
  end;
  if CanFocusMsg then begin
    if InRange(X, Y) or (MouseCaptureControl = self) then begin
      if Assigned(FOnMouseDown) then
        FOnMouseDown(self, Button, Shift, X, Y);
      if EnableFocus then SetDFocus(self);
         //else ReleaseDFocus;
      Result := TRUE;
    end;
  end;
end;

function TDXControl.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).MouseUp(Button, Shift, X - Left, Y - Top) then begin
        Result := True;
        Exit;
      end;

  if (MouseCaptureControl <> nil) then begin
    if (MouseCaptureControl = Self) then begin
      if Assigned(FOnMouseUp) then
        FOnMouseUp(Self, Button, Shift, X, Y);
      Result := True;
    end;
    Exit;
  end;

  if Background then
    Exit;
  if InRange(X, Y) then begin
    if Assigned(FOnMouseUp) then
      FOnMouseUp(Self, Button, Shift, X, Y);
    Result := True;
  end;
end;

function TDXControl.DblClick(X, Y: Integer): Boolean;
var
  i: Integer;
  str: string;
begin
  Result := False;
  str := name;
  if (MouseCaptureControl <> nil) then begin
    if (MouseCaptureControl = Self) then begin
      if Assigned(FOnDblClick) then
        FOnDblClick(Self);
      Result := True;
    end;
    Exit;
  end;

  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).DblClick(X - Left, Y - Top) then begin
        Result := True;
        Exit;
      end;
  if Background then
    Exit;
  if InRange(X, Y) then begin
    if Assigned(FOnDblClick) then
      FOnDblClick(Self);
    Result := True;
  end;
end;

function TDXControl.DoClick(X, Y: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  if (MouseCaptureControl <> nil) then begin
    if (MouseCaptureControl = Self) then begin
      if Assigned(FOnClick) then
        FOnClick(Self, X, Y);
      Result := True;
    end;
    Exit;
  end;
  for i := DControls.Count - 1 downto 0 do
    if TDXControl(DControls[i]).Visible then
      if TDXControl(DControls[i]).DoClick(X - Left, Y - Top) then begin
        Result := True;
        Exit;
      end;
  if Background then
    Exit;
  if InRange(X, Y) then begin
    if Assigned(FOnClick) then
      FOnClick(Self, X, Y);
    Result := True;
  end;
end;

procedure TDXControl.Initialize(Lib: TTilFile; Index: Integer);
var
  l, t: SmallInt;
  d: TDirectDrawSurface;
begin
  d := nil;
  if Lib = nil then Exit;
  FImageLib := Lib;
  
  if FImageIndex = 0 then
    FImageIndex  := Index;

  d := Lib.GetImage(FImageIndex, l, t);
  

  if d <> nil then begin
    Width  := d.Width;
    Height := d.Height;    
    if l + t >= 3 then begin    
      Left := l;
      Top := t;    
    end;    
  end;
end;

procedure TDXControl.DirectPaint(dsurface: TDirectDrawSurface);
var
  i: Integer;
  d: TDirectDrawSurface;
begin
  d := nil;
  {if MiniMapSetup.btViewMode <> 0 then begin
    dsurface.Canvas.Rectangle(SurfaceX(Left)-1, SurfaceY(Top)-1,SurfaceX(Left)+width+1, SurfaceY(Top)+self.Height+1);
    dsurface.Canvas.Release;
  //end;}
  if Assigned(FOnDirectPaint) then
    FOnDirectPaint(Self, dsurface)
  else if FImageLib <> nil then begin

        d := FImageLib[ImageIndex];
    if d <> nil then
      dsurface.Draw(SurfaceX(Left), SurfaceY(Top), d.ClientRect, d, True);
  end;
  for i := 0 to DControls.Count - 1 do
    if TDXControl(DControls[i]).Visible then
      TDXControl(DControls[i]).DirectPaint(dsurface);
  //BoldTextOut(dsurface, SurfaceX(Left), SurfaceY(Top), clWhite, ClBlack, {name+':'+}IntToStr(Left)+'*'+IntToStr(Top));
end;

constructor TDXButton.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  Downed := False;
  FOnClick := nil;
  FEnableFocus := True;
  FClickSound := csNone;
end;

function TDXButton.MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
begin
  Result := inherited MouseMove(Shift, X, Y);
  if (not Background) and (not Result) then begin
    Result := inherited MouseMove(Shift, X, Y);
    if MouseCaptureControl = Self then
      if InRange(X, Y) then
        Downed := True
      else
        Downed := False;
  end;
end;

function TDXButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
begin
  Result := False;
  if inherited MouseDown(Button, Shift, X, Y) then begin
    if (not Background) and (MouseCaptureControl = nil) then begin
      Downed := TRUE;
      SetDCapture(self);
    end;
    Result := TRUE;
  end;

end;

function TDXButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
begin
  Result := False;
  if inherited MouseUp(Button, Shift, X, Y) then begin
    ReleaseDCapture;
    if not Background then begin
      if InRange(X, Y) then begin

        if Assigned(FOnClickSound) then
          FOnClickSound(Self, FClickSound);
        if Assigned(FOnClick) then
          FOnClick(Self, X, Y);
      end;
    end;
    Downed := False;
    Result := True;
    Exit;
  end
  else begin
    ReleaseDCapture;
    Downed := False;
  end;
end;

constructor TXDListBox.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  FTopIndex := 0;
  FItemHeight := 12;
  FSetIndex := 0;
  FOnChangeSelect := nil;
  FItemList := nil;
  if Parent is TDXWindow then
    DParent := TDXControl(Parent);

  Width := 80;
  Height := 80;

  FUpButton := TDXButton.Create(aowner);
  FDownButton := TDXButton.Create(aowner);
  FScrollBar := TDXButton.Create(aowner);

  FUpButton.DParent := Self;
  FScrollBar.DParent := Self;
  FDownButton.DParent := Self;


  FUpButton.Caption := '^';
  FDownButton.Caption := 'v';
  FScrollBar.Caption := '*';

  FUpButton.SetParent(Self);
  FDownButton.SetParent(Self);
  FScrollBar.SetParent(Self);

  if (csDesigning in ComponentState) then Exit;

  FUpButton.FOnClick := UpButtoClick;
  FDownButton.FOnClick := DownButtonClick;
  FScrollBar.FOnMouseDown := BarMouseDown;
  FScrollBar.FOnMouseUp := BarMouseUp;
  FScrollBar.FOnMouseMove := BarMouseMove;

end;

procedure TXDListBox.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited;
  if FUpButton <> nil then
    FUpButton.SetBounds(Width - 20, 0, 20, 20);
  if FDownButton <> nil then
    FDownButton.SetBounds(Width - 20, Height - 20, 20, 20);
  if FScrollBar <> nil then
    FScrollBar.SetBounds(Width - 20, FUpButton.Top + 20, 20, Height - 40);
end;

procedure TXDListBox.DirectPaint(dsurface: TDirectDrawSurface);
begin
  dsurface.Canvas.Brush.Color := clSkyBlue;
  dsurface.Canvas.Rectangle(SurfaceX(Left), SurfaceY(Top), SurfaceX(Left + Width), SurfaceY(Top + Height));

  dsurface.Canvas.Brush.Color := clRed;
  with FUpButton do begin
    dsurface.Canvas.TextRect(Rect(SurfaceX(Left), SurfaceY(Top), SurfaceX(Left + Width), SurfaceY(Top + Height)), 0, 0, Caption);
    dsurface.Canvas.TextOut(10, 100, Format('left:%d  top:%d with:%d hige:%d  ::%s', [Left, Top, Width, Height, Caption]));
  end;

  dsurface.Canvas.Brush.Color := clYellow;
  with FScrollBar do begin
    dsurface.Canvas.TextRect(Rect(SurfaceX(Left), SurfaceY(Top), SurfaceX(Left + Width), SurfaceY(Top + Height)), 0, 0, Caption);
    dsurface.Canvas.TextOut(10, 130, Format('left:%d  top:%d with:%d hige:%d  ::%s', [Left, Top, Width, Height, Caption]));
  end;

  dsurface.Canvas.Brush.Color := clGreen;
  with FDownButton do begin
    dsurface.Canvas.TextRect(Rect(SurfaceX(Left), SurfaceY(Top), SurfaceX(Left + Width), SurfaceY(Top + Height)), 0, 0, Caption);
    dsurface.Canvas.TextOut(10, 150, Format('left:%d  top:%d with:%d hige:%d  ::%s', [Left, Top, Width, Height, Caption]));
  end;
  dsurface.Canvas.Release;
end;

procedure TXDListBox.BarMouseUp(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MoveBar(Y + FScrollBar.Color);
end;

procedure TXDListBox.BarMouseDown(Sender: TDXControl; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not InRange(X, Y) then Exit;
  FScrollBar.Color := FScrollBar.SurfaceY(FScrollBar.Top) - Y;
end;


procedure TXDListBox.BarMouseMove(Sender: TDXControl; Shift: TShiftState; X, Y: Integer);
begin
  if FScrollBar.Downed then
    MoveBar(Y + FScrollBar.Color);
end;

procedure TXDListBox.SetName(const NewName: TComponentName);
begin
  inherited;
  if not (csDesigning in ComponentState) then Exit;
  FUpButton.Name := Name + '_UpButton';
  FDownButton.Name := Name + '_DownButton';
  FScrollBar.Name := Name + '_ScrollBar';
end;

procedure TXDListBox.Resize;
begin
  FScrollBar.Top := FUpButton.Height + 1;
  FBarMinTop := FScrollBar.Top;
  FBarMaxSize := Height - FUpButton.Height + FDownButton.Height;
  FBarMaxTop := FDownButton.Top - 1;
end;

procedure TXDListBox.UpButtoClick(Sender: TDXControl; X, Y: Integer);
begin
  showmessage('UpButtoClick')

end;


procedure TXDListBox.DownButtonClick(Sender: TDXControl; X, Y: Integer);
begin
  showmessage('DownButtonClick')
end;


function TXDListBox.Count: Integer;
begin
  Result := -1;
  if (FItemList <> nil) and (FItemList.Count <> 0) then
    Result := FItemList.Count;
end;

function TXDListBox.DoChangeSelect(NewSelect: Integer): Boolean;
begin
  if (NewSelect = FTopIndex) then Exit;
  if Assigned(FOnChangeSelect) then
    OnChangeSelect(NewSelect);
  FTopIndex := NewSelect;
end;


procedure TXDListBox.UpItemHeight(ItemHeight: Integer);
begin

end;

procedure TXDListBox.MoveBar(Y: Integer);
var
  AllItemHeight, nLocalY, NewIndex: integer;
begin
  with FScrollBar do begin
    nLocalY := LocalY(Y);
    if (nLocalY < FBarMinTop) then
      nLocalY := FBarMinTop;
    if (nLocalY > (FBarMaxSize - Height + FBarMinTop)) then
      nLocalY := FBarMaxSize - Height + FBarMinTop;

    Top := nLocalY;
    if ((FBarMaxSize - Self.Height) = 0) then NewIndex := 0
    else
    begin
      AllItemHeight := Count * FItemHeight;
      NewIndex := (Top - FBarMinTop) * (Self.Height - AllItemHeight) div (FBarMaxSize - Self.Height);
    end;
  end;
  OnChangeSelect(NewIndex);
end;


function TXDListBox.GetTopIndex: Integer;
begin

end;


function TXDListBox.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean;
begin
  inherited MouseDown(Button, Shift, x, y);
end;


function TXDListBox.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer): Boolean;
var
  ret: boolean;
  NewSel: integer;
begin
  inherited MouseUp(Button, Shift, x, y);
  if (InRange(x, y)) then begin
    if (Count = 0) then
      NewSel := -1
    else
      NewSel := (GetTopIndex * -1 - Left + y) div (FItemHeight + FLineSpace); //selection de la ligne
    if (NewSel > (Count - 1)) then
      NewSel := -1;

    DoChangeSelect(NewSel);

    ret := true; //le click ne passe pas pour les autres fenetres
  end;
  result := ret;

end;

constructor TDXGrid.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  FColCount := 8;
  FRowCount := 5;
  FColWidth := 36;
  FRowHeight := 32;
  FOnGridSelect := nil;
  FOnGridMouseMove := nil;
  FOnGridPaint := nil;
end;

function TDXGrid.GetColRow(X, Y: Integer; var ACol, ARow: Integer): Boolean;
begin
  Result := False;
  if InRange(X, Y) then begin
    ACol := (X - Left) div FColWidth;
    ARow := (Y - Top) div FRowHeight;
    Result := True;
  end;
end;

function TDXGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  ACol, ARow: Integer;
begin
  Result := False;
  if mbLeft = Button then begin
    if GetColRow(X, Y, ACol, ARow) then begin
      SelectCell.X := ACol;
      SelectCell.Y := ARow;
      DownPos.X := X;
      DownPos.Y := Y;
      SetDCapture(Self);
      Result := True;
    end;
  end;
end;

function TDXGrid.MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
var
  ACol, ARow: Integer;
begin
  Result := False;
  if InRange(X, Y) then begin
    if GetColRow(X, Y, ACol, ARow) then begin
      if Assigned(FOnGridMouseMove) then
        FOnGridMouseMove(Self, ACol, ARow, Shift);
    end;
    Result := True;
  end;
end;

function TDXGrid.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  ACol, ARow: Integer;
begin
  Result := False;
  if mbLeft = Button then begin
    if GetColRow(X, Y, ACol, ARow) then begin
      if (SelectCell.X = ACol) and (SelectCell.Y = ARow) then begin
        Col := ACol;
        row := ARow;
        if Assigned(FOnGridSelect) then
          FOnGridSelect(Self, ACol, ARow, Shift);
      end;
      Result := True;
    end;
    ReleaseDCapture;
  end;
end;

function TDXGrid.DoClick(X, Y: Integer): Boolean;
var
  ACol, ARow: Integer;
begin
  Result := False;
  if Assigned(FOnClick) then
    FOnClick(Self, X, Y);


end;

procedure TDXGrid.DirectPaint(dsurface: TDirectDrawSurface);
var
  i, j: Integer;
  rc: TRect;
begin
  if Assigned(FOnGridPaint) then
    for i := 0 to FRowCount - 1 do
      for j := 0 to FColCount - 1 do begin
        rc := Rect(Left + j * FColWidth,
                   Top + i * FRowHeight,
                   Left + j *(FColWidth + 1) - 1,
                   Top + i * (FRowHeight + 1) - 1);

        if (SelectCell.Y = i) and (SelectCell.X = j) then
          FOnGridPaint(Self, j, i, rc, [gdSelected], dsurface)
        else
          FOnGridPaint(Self, j, i, rc, [], dsurface);

      end;
end;





constructor TDXWindow.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  FOnClose:= nil;
  FOnOpen := nil;
  ControlStyle := ControlStyle + [csAcceptsControls];
  FFloating := False;
  FEnableFocus := True;
  Width := 120;
  Height := 120;
end;

procedure TDXWindow.SetVisible(flag: Boolean);
begin
  if flag = FVisible then Exit;

  FVisible := flag;
  if Floating then begin
    if DParent <> nil then
      DParent.ChangeChildOrder(Self);
  end;
  if FVisible then begin
    if Assigned(FOnOpen) then FOnOpen(Self);
  end else begin
    if Assigned(FOnClose) then FOnClose(Self);
  end;

end;

function TDXWindow.MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
var
  al, at: Integer;
begin
  Result := inherited MouseMove(Shift, X, Y);
  if Result and FFloating and (MouseCaptureControl = Self) then begin
    if (SpotX <> X) or (SpotY <> Y) then begin
      al := Left + (X - SpotX);
      at := Top + (Y - SpotY);
      if al + Width < WINLEFT then
        al := WINLEFT - Width;
      if al > WINRIGHT then
        al := WINRIGHT;
      if at + Height < WINTOP then
        at := WINTOP - Height;
      if at + Height > BOTTOMEDGE then
        at := BOTTOMEDGE - Height;
      Left := al;
      Top := at;
      SpotX := X;
      SpotY := Y;
    end;
  end;
end;
function TDXWindow.KeyPress(var Key: Char): Boolean;
begin
  Result := inherited KeyPress(Key);
end;
function TDXWindow.KeyDown(var Key: Word; Shift: TShiftState): Boolean;
begin
  Result := inherited KeyDown(Key,Shift);
end;
function TDXWindow.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
begin
  Result := inherited MouseDown(Button, Shift, X, Y);
  if Result then begin
    if Floating then begin
      if DParent <> nil then
        DParent.ChangeChildOrder(self);
    end;
    SpotX := X;
    SpotY := Y;
  end;
end;

function TDXWindow.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
begin
  Result := inherited MouseUp(Button, Shift, X, Y);
end;

procedure TDXWindow.SHow;
begin
  Visible := True;
  if Floating then begin
    if DParent <> nil then
      DParent.ChangeChildOrder(Self);
  end;
  if EnableFocus then
    SetDFocus(Self);
end;

function TDXWindow.ShowModal: Integer;
begin
  Visible := True;
  ModalDWindow := Self;
  if EnableFocus then
    SetDFocus(Self);
end;

procedure TDXWindow.Close;
begin
  Visible := False;
  ReleaseDCapture;
end;

procedure TDXWindow.Open;
begin
  Visible := True;
end;




constructor TDXWinManager.Create(aowner: TComponent);
begin
  inherited Create(aowner);
  MouseCaptureControl := nil;
  FocusedControl := nil;
end;

destructor TDXWinManager.Destroy;
begin
  inherited Destroy;
end;

function TDXWinManager.KeyPress(var Key: Char): Boolean;

begin
  Result := False;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        Result := KeyPress(Key);
      Exit;
    end
    else
      ModalDWindow := nil;
    Key := #0;

  end;

  if FocusedControl <> nil then begin
    if FocusedControl.Visible then begin
      Result := FocusedControl.KeyPress(Key);
    end
    else
      ReleaseDFocus;
  end;

end;

function TDXWinManager.KeyDown(var Key: Word; Shift: TShiftState): Boolean;

begin
  Result := False;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        Result := KeyDown(Key, Shift);
      Exit;
    end
    else
      ModalDWindow := nil;
  end;
  if FocusedControl <> nil then begin
    if FocusedControl.Visible then
      Result := FocusedControl.KeyDown(Key, Shift)
    else
      ReleaseDFocus;
  end;

end;

function TDXWinManager.MouseMove(Shift: TShiftState; X, Y: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        MouseMove(Shift, LocalX(X), LocalY(Y));
      Result := True;
      Exit;
    end
    else
      ModalDWindow := nil;
  end;
  if MouseCaptureControl <> nil then begin
    with MouseCaptureControl do
      Result := MouseMove(Shift, LocalX(X), LocalY(Y));
  end
  {$IF WithRegCom}
  {$ELSE}
  else
    if FrmDlg.DBackground.Visible then begin
      if FrmDlg.DBackground.MouseMove(Shift, X, Y) then begin
        Result := True;
      end;
    end;
  {$IFEND}
end;

function TDXWinManager.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        MouseDown(Button, Shift, LocalX(X), LocalY(Y));
      Result := TRUE;
      exit;
    end else ModalDWindow := nil;
  end;
  if MouseCaptureControl <> nil then begin
    with MouseCaptureControl do
      Result := MouseDown(Button, Shift, LocalX(X), LocalY(Y));
  {$IF WithRegCom}
  {$ELSE}
  
  end else
    if FrmDlg.DBackground.Visible then begin
      if FrmDlg.DBackground.MouseDown(Button, Shift, X, Y) then begin
        Result := TRUE;
      end;
  {$IFEND}
    end;

end;

function TDXWinManager.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer): Boolean;
var
  i: Integer;
begin
  Result := True;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        Result := MouseUp(Button, Shift, LocalX(X), LocalY(Y));
      Exit;
    end
    else
      ModalDWindow := nil;
  end;
  if MouseCaptureControl <> nil then begin
    with MouseCaptureControl do
      Result := MouseUp(Button, Shift, LocalX(X), LocalY(Y));
  end
  {$IF WithRegCom}
  {$ELSE}
  else
    if FrmDlg.DBackground.Visible then begin
      if FrmDlg.DBackground.MouseUp(Button, Shift, X, Y) then begin
        Result := True;
      end;
    end;
  {$IFEND}
end;

function TDXWinManager.DblClick(X, Y: Integer): Boolean;
var
  i: Integer;
  p: Tpoint;
begin
  Result := True;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        Result := DblClick(LocalX(X), LocalY(Y));
      Exit;
    end
    else
      ModalDWindow := nil;
  end;


  if MouseCaptureControl <> nil then begin
    with MouseCaptureControl do
      Result := DblClick(LocalX(X), LocalY(Y));
  end
  {$IF WithRegCom}
  {$ELSE}
  else
    if FrmDlg.DBackground.Visible then begin
      if FrmDlg.DBackground.DblClick(x, y) then begin
        Result := True;
      end;
    end;
  {$IFEND}
end;

function TDXWinManager.Click(X, Y: Integer): Boolean;
var
  i: Integer;
begin
  Result := True;
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then begin
      with ModalDWindow do
        Result := DoClick(LocalX(X), LocalY(Y));
      Exit;
    end
    else
      ModalDWindow := nil;
  end;
  if MouseCaptureControl <> nil then begin
    with MouseCaptureControl do
      Result := DoClick(LocalX(X), LocalY(Y));
  end
  {$IF WithRegCom}
  {$ELSE}
  else
    if FrmDlg.DBackground.Visible then begin
      if FrmDlg.DBackground.DoClick(X, Y) then begin
        Result := True;
      end;
    end;
  {$IFEND}
end;

procedure TDXWinManager.DirectPaint(dsurface: TDirectDrawSurface);
var
  i: Integer;
begin
  {$IF WithRegCom}
  {$ELSE}
  if FrmDlg.DBackground.Visible then begin
    FrmDlg.DBackground.DirectPaint(dsurface);
  end;
  {$IFEND}
  if ModalDWindow <> nil then begin
    if ModalDWindow.Visible then
      with ModalDWindow do
        DirectPaint(dsurface);
  end;
end;

end.

