unit DrawScrn;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  DXDraws, DXClass, DirectX, IntroScn, Actor, cliUtil, ClFunc,
  TyFunc,
  Debug, //ϢԪ TasNat 2009-02-17 20:07:52
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  mywil,
  MirGrobal,
  ClVarConst,
  ClType;


const
  MAXSYSLINE = 8;

  BOTTOMBOARD = 1;
  VIEWCHATLINE = 11;
  AREASTATEICONBASE = 150;
  HEALTHBAR_BLACK = 0;
  HEALTHBAR_RED = 1;


type
  PBoardStyle = ^TBoardStyle;
  TBoardStyle = record
    Color: Integer;
    Time: Integer;
    Createtime: Integer;
  end;
  //TMsgType = (t_Mon, t_Hint, t_GM, t_System, t_Notice, t_MerSay, t_Cust, t_Say, t_Cry, t_Whis, t_Group, t_Guild, t_Castle);
  TChatCol = record
    FColor: Integer;
    BColor: Integer;
    MsgType: TMsgType;
  end;
  pTChatCol = ^TChatCol;
  TDrawScreen = class
  private
    frametime, framecount, drawframecount: longword;

    SysMsg: TStringList;
          //Ϣ
    m_lsSysBoard: TStringList;
    SysBoardIndex: Dword;
    SysBoardxPos: Integer;
    SysBoardTime: Integer;
  public

    HintStr :string;
    HintTime:DWORD;
    TimeHintStr :string;
    TimeHintOutTime:DWORD;
    CurrentScene: TScene;
    ChatStrsList: array[0..5] of TStringList;
    ChatTop: array[0..5] of Integer;

    FriendIndex: Integer;
    HintList: TStringList;
    HintX, HintY, HintWidth, HintHeight: Integer;
    HintTop:Boolean;
    HintUp: Boolean;
    HintTran: Boolean;
    constructor Create;
    destructor Destroy; override;
    procedure KeyPress(var Key: Char);
    procedure KeyDown(var Key: Word; Shift: TShiftState);
    procedure MouseMove(Shift: TShiftState; X, Y: Integer);
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ChatListUp;
    procedure ChatListDown;

    procedure Initialize;
    procedure Finalize;
    procedure ChangeScene(scenetype: TSceneType);
    procedure DrawScreen(MSurface: TDirectDrawSurface);

    procedure DrawScreenTop(MSurface: TDirectDrawSurface);
    procedure DrawScreenBoard(MSurface: TDirectDrawSurface);

    procedure AddSysMsg(msg: string);
    procedure AddSysBoard(msg: string; Color, Time: Integer);
    procedure AddChatBoardString(Str: string; fcolor, bcolor: Integer; ChatType: Byte = 0);
    procedure AddDebugChatBoardString(Str: string);
    procedure ClearChatBoard;
    procedure ShowHint(X, Y: Integer; Str: string; Color: TColor; drawup: Boolean; transparence: Boolean = True;boTop:Boolean = False);
    procedure ClearHint;
    procedure DrawHint(MSurface: TDirectDrawSurface);
    //  Function NameTextOut (surface: TDirectDrawSurface; x, y, fcolor, bcolor: integer; namestr: string):integer;
  end;


implementation

uses
  ClMain, PlayScn, FState;

constructor TDrawScreen.Create;
var
  i: Integer;
begin


  HintStr := '';
  TimeHintStr := '';
  CurrentScene := nil;
  frametime := GetTickCount;
  framecount := 0;
  for i := Low(ChatStrsList) to High(ChatStrsList) do
  begin
    ChatStrsList[i] := TStringList.Create;
    ChatTop[i] := 0;
  end;
  SysMsg := TStringList.Create;
  m_lsSysBoard := TStringList.Create;
  SysBoardIndex := 0;
  SysBoardxPos := 530;
  FriendIndex := 0;
  HintList := TStringList.Create;

end;

destructor TDrawScreen.Destroy;
var
  i, ii: Integer;
begin
  SysMsg.Free;

  for i := 0 to m_lsSysBoard.Count -1 do
  begin
    DisPose(PBoardStyle(m_lsSysBoard.Objects[i]));
  end;
  m_lsSysBoard.Free;
  for i := Low(ChatStrsList) to High(ChatStrsList) do
  begin
    for ii := 0 to DScreen.ChatStrsList[i].Count - 1 do
    begin
      Dispose(pTChatCol(ChatStrsList[i].Objects[ii]));
    end;
    ChatStrsList[i].Free;
    ChatTop[i] := 0;
  end;
  HintList.Free;
  inherited Destroy;
end;

procedure TDrawScreen.ChatListUp;
begin
  if PChatListTop^ > 0 then
    Dec(PChatListTop^);
end;

procedure TDrawScreen.ChatListDown;
begin
  if PChatListTop^ < ChatList.Count - 1 then
    Inc(PChatListTop^);
end;

procedure TDrawScreen.Initialize;
begin
end;

procedure TDrawScreen.Finalize;
begin
end;

procedure TDrawScreen.KeyPress(var Key: Char);
begin
  if CurrentScene <> nil then
    CurrentScene.KeyPress(Key);
end;

procedure TDrawScreen.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if CurrentScene <> nil then
    CurrentScene.KeyDown(Key, Shift);
end;

procedure TDrawScreen.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if CurrentScene <> nil then
    CurrentScene.MouseMove(Shift, X, Y);
end;

procedure TDrawScreen.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer);
begin
  if CurrentScene <> nil then
    CurrentScene.MouseDown(Button, Shift, X, Y);
end;

procedure TDrawScreen.ChangeScene(scenetype: TSceneType);
begin
  if CurrentScene <> nil then
    CurrentScene.CloseScene;
  case scenetype of
    stIntro: CurrentScene := IntroScene;
    stLogin: CurrentScene := LoginScene;
    stSelectCountry: ;
    stSelectChr: CurrentScene := SelectChrScene;
    stNewChr: ;
    stLoading: ;
    stLoginNotice: CurrentScene := LoginNoticeScene;
    stPlayGame: CurrentScene := PlayScene;
  end;
  if CurrentScene <> nil then
    CurrentScene.OpenScene;
end;

procedure TDrawScreen.AddSysMsg(msg: string);
begin
  if SysMsg.Count >= 10 then
    SysMsg.Delete(0);
  SysMsg.AddObject(msg, TObject(GetTickCount));
end;

procedure TDrawScreen.AddSysBoard(msg: string; Color, Time: Integer);
var
  Boardstyle: PBoardStyle;
begin
  if m_lsSysBoard.Count >= 100 then
  begin
    Boardstyle := PBoardStyle(m_lsSysBoard.Objects[0]);
    DisPose(Boardstyle);
    m_lsSysBoard.Delete(0);
  end;
  New(Boardstyle);
  Boardstyle^.Color := Color;
  Boardstyle^.Time := Time;
  Boardstyle^.Createtime := 0;
  m_lsSysBoard.AddObject(msg, TObject(Boardstyle));
end;

procedure TDrawScreen.AddDebugChatBoardString(Str: string);
begin
  AddChatBoardString(Str, clYellow, clYellow);
end;

procedure TDrawScreen.AddChatBoardString(Str: string; fcolor, bcolor: Integer; ChatType: Byte = 0);
var
  i, Len, aline: Integer;
  Temp: string;
  ChatCol, ChatCol2: pTChatCol;
  List: TStringList;
  PTop: ^Integer;
const
  BOXWIDTH = 245; //41;
begin
  Len := length(Str);
  Temp := '';
  i := 1;
  List := ChatStrsList[ChatType];
  PTop := @ChatTop[ChatType];
  while True do
  begin
    if i > Len then
      Break;
    if Byte(Str[i]) >= 128 then
    begin
      Temp := Temp + Str[i];
      Inc(i);
      if i <= Len then
        Temp := Temp + Str[i]
      else
        Break;
    end
    else
      Temp := Temp + Str[i];

    aline := GameWindows.Canvas.TextWidth(Temp);
    if aline > BOXWIDTH then
    begin
      New(ChatCol);
      ChatCol.FColor := Fcolor;
      ChatCol.BColor := Bcolor;
      if ChatType = 2 then
      ChatCol.MsgType := t_PaiMai;
      List.AddObject(Temp, TObject(ChatCol));
      if ChatType <> 0 then begin
        New(ChatCol2);
        Move(ChatCol^, ChatCol2^, SizeOf(TChatCol));
        ChatStrsList[0].AddObject(Temp, TObject(ChatCol2));
      end;
      Str := Copy(Str, i + 1, Len - i);
      Temp := '';
      Break;
    end;
    Inc(i);
  end;
  if Temp <> '' then
  begin
    New(ChatCol);
    ChatCol.FColor := fcolor;
    ChatCol.BColor := Bcolor;
      if ChatType = 2 then
      ChatCol.MsgType := t_PaiMai;

    List.AddObject(Temp, TObject(ChatCol));
    if ChatType <> 0 then begin
      New(ChatCol2);
      if ChatType = 2 then
      ChatCol2.MsgType := t_PaiMai;
      Move(ChatCol^, ChatCol2^, SizeOf(TChatCol));
      ChatStrsList[0].AddObject(Temp, TObject(ChatCol2));       
    end;
    Inc(ChatTop[0]);
    ChatTop[0] := Max(0,ChatStrsList[0].Count - VIEWCHATLINE+1);
    Str := '';
  end;

  if List.Count > 200 then
  begin
    Dispose(pTChatCol(List.Objects[0]));
    List.Delete(0);
    if List.Count - PTop^ < VIEWCHATLINE then
      Dec(PTop^);
  end
  else
  begin
    PTop^ := Max(0,List.Count - VIEWCHATLINE+1);

  end;

  if Str <> '' then
    AddChatBoardString(' ' + Str, fcolor, bcolor, ChatType);

end;

procedure TDrawScreen.ShowHint(X, Y: Integer; Str: string; Color: TColor;
  drawup: Boolean; transparence: Boolean;boTop:Boolean);
var
  data, d2: string;
  w, l: Integer;
  Color2: TColor;
begin
  // exit;
  ClearHint;
  HintX := X;
  HintY := Y;
  HintWidth := 0;
  HintHeight := 0;
  HintTop := boTop;
  HintUp := drawup;
  HintTran := transparence;
  while True do
  begin
    if Str = '' then
      Break;

    Str := GetValidStr3(Str, data, ['\']);
    if (data <> '') then begin
      if (data[1] = '&') then begin
        Delete(data, 1, 1);
        l := Pos('&', data);
        d2 := Copy(data, 1, l - 1);
        Color2 := Str_ToInt(d2, Color);
        Delete(data, 1, Length(d2) + 1);
      end else Color2 := Color;
      w := GameWindows.Canvas.TextWidth(data) + 8;
      if w > HintWidth then
        HintWidth := w;
      HintList.AddObject(data, TObject(Color2))
    end;
  end;
  HintHeight := (GameWindows.Canvas.TextHeight('A') + 1) * HintList.Count + 6;
  if HintUp then
    HintY := HintY - HintHeight;
end;

procedure TDrawScreen.ClearHint;
begin
  HintList.Clear;
end;

procedure TDrawScreen.ClearChatBoard;
var
  i, ii: Integer;
begin
  SysMsg.Clear;
  for i := Low(ChatStrsList) to High(ChatStrsList) do
  begin
    for ii := 0 to DScreen.ChatStrsList[i].Count - 1 do
    begin
      Dispose(pTChatCol(ChatStrsList[i].Objects[ii]));
    end;
    ChatStrsList[i].Clear;
    ChatTop[i] := 0;
  end;
end;



procedure TDrawScreen.DrawScreen(MSurface: TDirectDrawSurface);
var
  i, j, k, dy, mx, my, hh: Integer;
  Actor: TActor;
  Str: string;
  d: TDirectDrawSurface;
  rc: TRect;
  ditem: PTDropItem;
  co, co1: TColor;
  BltFx: TDDBltFX;
begin
  d := nil;
  MSurface.Fill(0);
  if CurrentScene <> nil then
    CurrentScene.PlayScene(MSurface);

  if GetTickCount - frametime > 1000 then begin
    frametime := GetTickCount;
    drawframecount := framecount;
    framecount := 0;
  end;
  Inc(framecount);

  if MySelf = nil then
    Exit;

  if CurrentScene = PlayScene then begin
    with MSurface do begin
      if neigua.Base.ShowBlood = 1 then begin
        with PlayScene do begin
          for k := 0 to ActorList.Count - 1 do begin
            Actor := ActorList[k];
            if (not Actor.Death) and (Actor.m_Abil.MaxHP <> 0) and
              (abs(MySelf.ry - Actor.ry) < 9) then begin
              d := WilPrguse3.Images[HEALTHBAR_BLACK];
              if (Actor.Horse > 0) then
                dy := Actor.Sayy - 37
              else
                dy := Actor.Sayy - 10;
              {if BoViewMiniMap then begin
                if MiniMapSetup.Fang then begin
                  if (Actor.SayX > 544) and (dy < 256) then
                    Break;
                end
                else
                  if (Actor.SayX > 672) and (dy < 128) then
                    Break;
              end;  }
              if d <> nil then
                MSurface.Draw(Actor.SayX - d.Width div 2, dy, d.ClientRect, d, True);
              d := WilPrguse3.Images[HEALTHBAR_RED];
              if d <> nil then begin
                rc := d.ClientRect;
                if Actor.m_Abil.MaxHP > 0 then begin
                  rc.Right := Round((rc.Right - rc.Left) / Actor.m_Abil.MaxHP *
                    Actor.m_Abil.Hp);
                end;
                MSurface.Draw(Actor.SayX - d.Width div 2, dy, rc, d, True);
              end;
            end;
          end;
        end;
      end;

      SetBkMode(Canvas.handle, TRANSPARENT);

      if (NeiGua.Base.SHowName = 1) and (ServerSetup.Base.SHowName > 0) then begin
        with PlayScene do begin
          if ActorList.Count < 100 then
          for k := 0 to ActorList.Count - 1 do begin
            hh := 0;
            Actor := ActorList[k];
            if (Actor <> nil) {and(Actor.Race =0)}and (Actor.isVisible) and (not Actor.Death) and
              (Actor.SayX <> 0) and (Actor.Sayy <> 0) then begin
              Co := Actor.NameColor;
              hh := NameTextOut(MSurface,
                Actor.SayX,
                Actor.Sayy + 30,
                co, ClBlack,
                Actor.DescUserName);

              //+ '\:A ' + inttostr(Actor.Appearance)+'\:R '+intToStr(Actor.Race)+'\TTT'+intToStr(g_touxiang);
              NameTextOut(MSurface,
                Actor.SayX,
                Actor.Sayy + 30 + 12 * hh,
                Actor.NameColor, ClBlack,
                Actor.UserName
                );
            end;
          end;
        end;
      end
      else 
        if (FocusCret <> nil) and PlayScene.IsValidActor(FocusCret) then begin


          hh := 0;
          Co := FocusCret.NameColor;

          hh := NameTextOut(MSurface,
            FocusCret.SayX,
            FocusCret.Sayy + 30,
            co, ClBlack,
            FocusCret.DescUserName);

          NameTextOut(MSurface,
            FocusCret.SayX,
            FocusCret.Sayy + 30 + 12 * hh,
            FocusCret.NameColor, ClBlack,
            FocusCret.UserName);
        end;


      if BoSelectMyself then begin
        hh := 0;

        Co := MySelf.NameColor;
        hh := NameTextOut(MSurface,
          MySelf.SayX,
          MySelf.Sayy + 30,
          Co, ClBlack,
          MySelf.DescUserName);
        NameTextOut(MSurface,
          MySelf.SayX,
          MySelf.Sayy + 30 + 12 * hh,
          MySelf.NameColor, ClBlack,
          MySelf.UserName);

      end;




      with PlayScene do begin
        if ActorList.Count < 1000 then
        for k := 0 to ActorList.Count - 1 do begin
          Actor := ActorList[k];
          if (Actor.Horse > 0) then
            dy := -24
          else
            dy := 0;

          if (Actor.m_Abil.Hp > 0) and (abs(MySelf.ry - Actor.ry) < 9)
           and (neigua.Base.ShowBlood = 1) and (neigua.Base.NumberBlood = 1) then begin
            SetBkMode(Canvas.handle, TRANSPARENT);

            if (NeiGua.Base.WorkShow = 1) and (Actor <> myself) and (Actor.Race = 0) then begin
              Str := IntToStr(Actor.m_Abil.Hp) + '/' + IntToStr(Actor.m_Abil.MaxHP) {11.26+ actor.WorkName};
            end
            else
              Str := IntToStr(Actor.m_Abil.Hp) + '/' + IntToStr(Actor.m_Abil.MaxHP);//+':'+inttostr(Actor.MsgList.Count);//+':'+BoolToCStr(MySelf.ActionLock);

            {if BoViewMiniMap then begin
              if MiniMapSetup.Fang then begin
                if (Actor.SayX > 544) and ((Actor.Sa.yy - 25 + dy) < 256) then
                  Break;
              end
              else
                if (Actor.SayX > 672) and ((Actor.Sa.yy - 25 + dy) < 128) then
                  Break;
            end;  }
            Canvas.Font.Color := NeiGua.SHezhi.hintcolor[7];
            MSurface.Canvas.TextOut(Actor.SayX - MSurface.Canvas.TextWidth(str) div 2, Actor.Sayy - 25 + dy, str);
          end;
          Canvas.Font.Color := clWhite;

          if Actor.saying[0] <> '' then begin
            if GetTickCount - Actor.SayTime < 4 * 1000 then begin
              for i := 0 to Actor.SayLineCount - 1 do begin

                //if MiniMapSetup.BoView then begin
                  {if MiniMapSetup.Fang then begin
                    if ((Actor.SayX - (Actor.SayWidths[i] div 2)) > 544) and ((Actor.Sa.yy - (Actor.SayLineCount * 16) + i * 14 + dy) < 256) then
                      Break;
                  end
                  else}
                  if ((Actor.SayX - (Actor.SayWidths[i] div 2)) > 672) and ((Actor.Sayy - (Actor.SayLineCount * 16) + i * 14 + dy) < 128) then
                    Break;
                //end;

                if Actor.Death then
                  BoldTextOut(MSurface, Actor.SayX - (Actor.SayWidths[i] div 2),
                    Actor.Sayy - (Actor.SayLineCount * 16) + i * 14 + dy,
                    clGray,
                    ClBlack, Actor.saying[i])
                else
                  BoldTextOut(MSurface, Actor.SayX - (Actor.SayWidths[i] div 2),
                    Actor.Sayy - (Actor.SayLineCount * 16) + i * 14 + dy, clWhite,
                    ClBlack, Actor.saying[i]);


              end;
            end
            else
              Actor.saying[0] := '';
          end;
        end;
      end;

      if (NeiGua.Goods.GoodShow = 1) or (Neigua.Goods.GoodColor = 1) then begin
        if DropedItemList.Count < 1000 then
        for i := 0 to DropedItemList.Count - 1 do begin
          ditem := PTDropItem(DropedItemList[i]);

          co1 := NeiGua.SHezhi.hintcolor[2];

          if (Neigua.Goods.GoodShow = 0) and (not Ditem.HintColor) then
            Continue;


          if ditem <> nil then begin
            if NeiGua.Goods.GoodColor = 1 then begin
              if Ditem.HintColor then
                Co1 := NeiGua.SHezhi.hintcolor[1];
            end;

            begin

              if ((NeiGua.Goods.ShowFilter = 1) and (Ditem.Canshow)) or (NeiGua.Goods.ShowFilter <> 1) then begin
                PlayScene.ScreenXYfromMCXY(ditem.X, ditem.Y, mx, my);
                BoldTextOut(MSurface, mx - 20, my - 10, Co1, ClBlack, ditem.Name);
              end;
            end;
          end;
        end;

      end;


      k := 0;
      for i := 0 to 15 do begin
        k := BitMaksList[i];
        if AreaStateValue and k <> 0 then begin
          Str := '';
          case i of
            0:Str := 'ս';
            1:Str := 'ȫ';
            2:Str := '';
          end;
          if Str <> '' then
          BoldTextOut(MSurface, 11, 76+i*13, clWhite, ClBlack, Str+'');
          {d := WilPrguse.Images[AREASTATEICONBASE + i];
          if d <> nil then begin
            k := k + d.Width;
            MSurface.Draw(SCREENWIDTH - k, 0, d.ClientRect, d, True);
          end;  }
        end;
      end;
      Canvas.Release;

    end;
  end;
end;

procedure TDrawScreen.DrawScreenBoard(MSurface: TDirectDrawSurface);
var
  sx, xpos: Integer;
  Boardstyle: PBoardStyle;
  Str, str1: string;
  Len: Integer;
begin
  if MySelf = nil then
    Exit;
  if CurrentScene = PlayScene then begin
    with MSurface do begin
      SetBkMode(Canvas.handle, TRANSPARENT);
      if m_lsSysBoard.Count > 0 then begin
        xpos := 1;
        if SysBoardIndex >= m_lsSysBoard.Count then begin
          SysBoardIndex := 0;
        end;
        if SysBoardXPos <= 314 then begin
          Xpos := (314 - sysBoardXpos) div Canvas.TextWidth('a') + 1;
        end;

        Boardstyle := PBoardStyle(m_lsSysBoard.Objects[SysBoardIndex]);
        Len := (650+14 - SysBoardXPos) div Canvas.TextWidth('a');
        Str := m_lsSysBoard[SysBoardIndex];
        Str := _Copy(Str, Xpos, Len);
        if (Str = '') or (Xpos > Length(m_lsSysBoard[SysBoardIndex])) then begin
          if SysBoardIndex < m_lsSysBoard.Count then begin
            Boardstyle := PBoardStyle(m_lsSysBoard.Objects[SysBoardIndex]);
            Inc(Boardstyle.Createtime);
          end;
          SysBoardXPos := 650;
          Inc(SysBoardIndex);
        end;
        sx := Max(314, SysBoardXPos);
        BoldTextOut(MSurface, sx, 5, Boardstyle.Color, clBlack, str);
        if (Boardstyle.Createtime >= Boardstyle.Time) and
           (Boardstyle.Time > 0) then
          m_lsSysBoard.Delete(SysBoardIndex);
        if GetTickCount - SysBoardTime > 100 then begin
          Dec(SysBoardXPos, 2);
          SysBoardTime := GetTickCount;
        end;
      end;
      //else begin
      str := Format(' ʱ:%s : %d   %d/%d ꣺%d:%d ң%d Ŀ꣺%s', [Datetimetostr(Now), MySelf.m_Abil.Exp, Myself.m_Abil.Weight, Myself.m_Abil.MaxWeight, MouseX, MouseY, myself.gold, str1]);
            BoldTextOut(MSurface, 10, 100, NeiGua.SHezhi.hintcolor[6], clBlack, str);
        if Neigua.Guaji.Guaji then begin

          BoldTextOut(MSurface, 10, 100, ClRed, ClBlack, Guajistr);

        {end
        else begin
          if (Neigua.Base.MsgShow = 1) then begin
            if FocusCret = nil then
              Str1 := '-/-'
            else
              str1 := Format('%s (%d/%d)', [FocusCret.UserName, FocusCret.Abil.HP, FocusCret.Abil.MaxHP]);

            str := Format(' ʱ:%s : %d   %d/%d ꣺%d:%d ң%d Ŀ꣺%s', [Datetimetostr(Now), MySelf.Abil.Exp, Myself.Abil.Weight, Myself.Abil.MaxWeight, mcx, mcy, myself.gold, str1]);
            BoldTextOut(MSurface, 10, 100, NeiGua.SHezhi.hintcolor[6], clBlack, str);

          end;}
        end;
        //BoldTextOut(MSurface, 10, 25, NeiGua.SHezhi.hintcolor[6], clBlack, StrFPS);
        if (TimeHintOutTime > GetTickCount) then
          BoldTextOut(MSurface, 280, 450+43, clYellow, clBlack, Format(TimeHintStr,[FmtTime((TimeHintOutTime - GetTickCount))]));

        if (HintTime > GetTickCount) then
          BoldTextOut(MSurface, 280, 508, clLime, clBlack, HintStr);
      //end;
      Canvas.Release;
    end;
  end;
end;

procedure TDrawScreen.DrawScreenTop(MSurface: TDirectDrawSurface);
var
  i, sx, sy: Integer;
  str: string;
begin
  if MySelf = nil then
    Exit;

  if CurrentScene = PlayScene then begin
    with MSurface do begin
      SetBkMode(Canvas.handle, TRANSPARENT);
      if SysMsg.Count > 0 then begin
        sx := 10;
        sy := 70;
        for i := 0 to SysMsg.Count - 1 do begin
          BoldTextOut(MSurface, sx, sy, clLime, ClBlack, SysMsg[i]);
          Inc(sy, 16);
        end;
        if GetTickCount - longword(SysMsg.Objects[0]) >= 3000 then
          SysMsg.Delete(0);
      end;


      Canvas.Release;
    end;
  end;
end;
       //d := WilPrguse.Images[394];

procedure TDrawScreen.DrawHint(MSurface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
  i, hx, hy: Integer;
  Str: string;
  rc: TRect;
begin
  if HintList.Count > 0 then begin
    d := w16ProgUse[202];
    if d <> nil then
    begin
      if HintWidth > d.Width then
        HintWidth := d.Width;
      if HintHeight > d.Height then
        HintHeight := d.Height;
      if HintX + HintWidth > SCREENWIDTH then
        hx := SCREENWIDTH - HintWidth
      else
        hx := HintX;
      if HintTop then
      Dec(HintY,HintHeight);
      
      if HintY < 0 then
        hy := 0
      else
        hy := HintY;
      if hx < 0 then
        hx := 0;

      if not HintTran then
      begin
        rc := Rect(0 + 2, 0 + 2, HintWidth, HintHeight);
        MSurface.Draw(hx, hy, rc, d, False);
        {rc := Rect(d.Width-HintWidth, d.Height-HintHeight,d.Width,d.Height);
        MSurface.Draw(hx, hy, rc, d, False); }
      end
      else begin
        rc := Rect(0, 0, HintWidth, HintHeight);
        //DrawBlend();
        MSurface.Draw(hx, hy, rc, d, False);
        //MSurface.DrawAlpha(Rect(hx, hy, hx + HintWidth, hy + HintHeight), rc, d, true, 150);
        rc := Rect(d.Width - HintWidth, d.Height - HintHeight, d.Width, d.Height);
        MSurface.Draw(hx+1, hy+1, rc, d, False);
        //MSurface.DrawAlpha(Rect(hx + 1, hy + 1, hx + HintWidth + 1, hy + HintHeight + 1), rc, d, true, 150);
      end;
    end;
  end;
  with MSurface do
  begin
    SetBkMode(Canvas.handle, TRANSPARENT);
    if HintList.Count > 0 then
    begin
      for i := 0 to HintList.Count - 1 do
      begin
        Canvas.Font.Color := Integer(HintList.Objects[i]);
        Canvas.TextOut(hx + 4, hy + 3 + (Canvas.TextHeight('A') + 1) * i, HintList[i]);
      end;
    end;
    Canvas.Release;
  end;
end;


end.
