unit HerbActor;

interface

uses
  Windows,
  MirGrobal, ClType, DXDraws, cliUtil, Actor,
  ResManager //ԴԪ TasNat 2009-02-14 22:38:49
  ;
const
   BEEQUEENBASE = 600;
   DOORDEATHEFFECTBASE = 120;
   WALLLEFTBROKENEFFECTBASE = 224;
   WALLRIGHTBROKENEFFECTBASE = 240;

type
   TDoorState = (dsOpen, dsClose, dsBroken);

   TKillingHerb = class (TActor)//ʳ˻...
   private
   public
      constructor Create; override;
      destructor Destroy; override;
      procedure CalcActorFrame; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
   end;

   TMineMon = class (TKillingHerb)
   private
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
   end;

   TBeeQueen = class (TActor)
   private
   public
      procedure CalcActorFrame; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
   end;

   TCentipedeKingMon = class (TKillingHerb)//Size 0x260
   private
      AttackEffectSurface :TDirectDrawSurface; //0x250
      BoUseDieEffect      :Boolean;            //0x254
      ax,ay                  :SmallInt;            //0x258

      procedure LoadEffect();
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer);override;
      procedure Run;override;
   end;
   TBigHeartMon = class (TKillingHerb)//Size 0x260
   private
   public
     procedure CalcActorFrame; override;
   end;
   TSpiderHouseMon = class (TKillingHerb)
   private
   public
     procedure CalcActorFrame; override;
   end;
   TCastleDoor = class (TActor)
   private
      EffectSurface: TDirectDrawSurface;
      ax, ay: SmallInt;
      oldunitx, oldunity: integer;
      procedure ApplyDoorState (dstate: TDoorState);
   public
      BoDoorOpen: Boolean;
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure  DoLoadSurface; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
      procedure  ActionEnded; override;
      procedure  Run; override;
      procedure  DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
   end;

   TWallStructure = class (TActor)//0x62
   private
      EffectSurface: TDirectDrawSurface;
      BrokenSurface: TDirectDrawSurface;
      ax, ay, bx, by: SmallInt;
      deathframe: integer;
      bomarkpos: Boolean;  //  ִ
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure  DoLoadSurface; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
      procedure  DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
      procedure  Run; override;
   end;

   TSoccerBall = class (TActor)//0x9
   private
   public
   end;
   TDragonBody = class (TKillingHerb)//0x5a
   private
   public
     procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;
     procedure CalcActorFrame(); override;
     procedure DoLoadSurface(); override;
   end;
implementation

uses
   ClMain;


{============================== TKillingHerb =============================}

//        

{--------------------------}


constructor TKillingHerb.Create;
begin
   inherited Create;
end;

destructor TKillingHerb.Destroy;
begin
   inherited Destroy;
end;

procedure TKillingHerb.CalcActorFrame;
var
   pm: PTMonsterAction;
   haircount: integer;
begin
   boUseMagic := FALSE;
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
      SM_TURN: //
         begin
            StartFrame := pm.ActStand.start; // + Dir * (pm.ActStand.frame + pm.ActStand.skip);
            EndFrame := StartFrame + pm.ActStand.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            DefFrameCount := pm.ActStand.frame;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_DIGUP: //, SM_DIGUP, .
         begin
            StartFrame := pm.ActWalk.start; // + Dir * (pm.ActWalk.frame + pm.ActWalk.skip);
            EndFrame := StartFrame + pm.ActWalk.frame - 1;
            FrameTime := pm.ActWalk.ftime;
            StartTime := GetTickCount;
            MaxTick := pm.ActWalk.UseTick;
            CurTick := 0;
            //WarMode := FALSE;
            MoveStep := 1;
            MicroMove(Dir, 0, 0, 1); //MoveStep, 0, EndFrame-startframe+1);
         end;
      SM_HIT:
         begin
            StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            //WarMode := TRUE;
            WarModeTime := GetTickCount;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := StruckFrameTime; //pm.ActStruck.ftime;
            StartTime := GetTickCount;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            StartFrame := EndFrame; //
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_DIGDOWN:
         begin
            StartFrame := pm.ActDeath.start;
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
            BoDelActionAfterFinished := TRUE;  //̵   
         end;
   end;
end;


function  TKillingHerb.GetDefaultFrame (wmode: Boolean): integer;
var
   cf, dr: integer;
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   if Death then begin
      if Skeleton then
         Result := pm.ActDeath.start
      else Result := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip) + (pm.ActDie.frame - 1);
   end else begin
      DefFrameCount := pm.ActStand.frame;
      if CurrentDefFrame < 0 then cf := 0
      else if CurrentDefFrame >= pm.ActStand.frame then cf := 0
      else cf := CurrentDefFrame;
      Result := pm.ActStand.start + cf; // ..
   end;
end;


{----------------------------------------------------------------------}
//񸷿


procedure TBeeQueen.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   boUseMagic := FALSE;
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
      SM_TURN: // ...
         begin
            StartFrame := pm.ActStand.start; // + Dir * (pm.ActStand.frame + pm.ActStand.skip);
            EndFrame := StartFrame + pm.ActStand.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            DefFrameCount := pm.ActStand.frame;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_HIT:
         begin
            StartFrame := pm.ActAttack.start; // + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            //WarMode := TRUE;
            WarModeTime := GetTickCount;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start; // + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := StruckFrameTime; //pm.ActStruck.ftime;
            StartTime := GetTickCount;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start; // + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            StartFrame := EndFrame; //
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start; // + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
   end;
end;

function  TBeeQueen.GetDefaultFrame (wmode: Boolean): integer;
var
   pm: PTMonsterAction;
   cf: integer;
begin
   Result:=0;//jacky
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   if Death then begin
      Result := pm.ActDie.start + (pm.ActDie.frame - 1);
   end else begin
      DefFrameCount := pm.ActStand.frame;
      if CurrentDefFrame < 0 then cf := 0
      else if CurrentDefFrame >= pm.ActStand.frame then cf := 0
      else cf := CurrentDefFrame;
      Result := pm.ActStand.start + cf; // ..
   end;
end;


{----------------------------------------------------------------------}
//׿


procedure TCentipedeKingMon.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   boUseMagic := FALSE;
   CurrentFrame := -1;
   BodyOffset := GetOffset(Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
      SM_TURN: //
         begin
            Dir := 0;
            inherited CalcActorFrame;
         end;
      SM_HIT:
         begin
            Dir:=0;
            StartFrame:=pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
            EndFrame := StartFrame + pm.ActCritical.frame - 1;
            FrameTime:=pm.ActCritical.ftime;
            StartTime := GetTickCount;
            BoUseDieEffect:=True;
            EffectFrame:=0;
            EffectStart:=0;
            EffectEnd:=EffectStart + 9;
            EffectFrameTime:= 62;
//            BoUseEffect:=True;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_DIGDOWN:
         begin
           inherited CalcActorFrame;
         end;
      else begin
         Dir := 0;
         inherited CalcActorFrame;
      end;
   end;
end;


{----------------------------------------------------------------------}
//, 

constructor TCastleDoor.Create;
begin
   inherited Create;
   Dir := 0;
   EffectSurface := nil;
   DownDrawLevel := 1;  //1  ׸. ( Ӹ     )
end;

procedure TCastleDoor.ApplyDoorState (dstate: TDoorState);
var
   bowalk: Boolean;
begin
   Map.MarkCanWalk (XX, yy-2, TRUE);
   Map.MarkCanWalk (XX+1, yy-1, TRUE);
   Map.MarkCanWalk (XX+1, yy-2, TRUE);
   if dstate = dsClose then bowalk := FALSE
   else bowalk := TRUE;

   Map.MarkCanWalk (XX, yy, bowalk);
   Map.MarkCanWalk (XX, yy-1, bowalk);
   Map.MarkCanWalk (XX, yy-2, bowalk);
   Map.MarkCanWalk (XX+1, yy-1, bowalk);
   Map.MarkCanWalk (XX+1, yy-2, bowalk);
   Map.MarkCanWalk (XX-1, yy-1, bowalk);
   Map.MarkCanWalk (XX-1, yy, bowalk);
   Map.MarkCanWalk (XX-1, yy+1, bowalk);
   Map.MarkCanWalk (XX-2, yy, bowalk);

   if dstate = dsOpen then begin
      Map.MarkCanWalk (XX, yy-2, FALSE);
      Map.MarkCanWalk (XX+1, yy-1, FALSE);
      Map.MarkCanWalk (XX+1, yy-2, FALSE);
   end;
end;

procedure  TCastleDoor.DoLoadSurface;
var
   mimg: TtilFile;
begin
  if currentframe < 0 then currentframe := 0;
   inherited DoLoadSurface;
   mimg := GetMonImg (Appearance);
   if boUseEffect then
      EffectSurface := mimg.GetImage (DOORDEATHEFFECTBASE + (CurrentFrame - StartFrame), ax, ay);
end;

procedure TCastleDoor.CalcActorFrame;
var
   pm: PTMonsterAction;
   haircount: integer;
begin
   boUseEffect := FALSE;
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   UserName := ' ';

   case CurrentAction of
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start;
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
            MicroMove(Dir, 0, 0, 1);
            boUseEffect := TRUE;
            ApplyDoorState (dsBroken);  //  ְ
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_DIGUP:  // 
         begin
            StartFrame := pm.ActAttack.start;
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            ApplyDoorState (dsOpen);  //  ְ
         end;
      SM_DIGDOWN:  // 
         begin
            StartFrame := pm.ActCritical.start;
            EndFrame := StartFrame + pm.ActCritical.frame - 1;
            FrameTime := pm.ActCritical.ftime;
            StartTime := GetTickCount;
            BoDoorOpen := FALSE;
            boHoldPlace := TRUE;
            ApplyDoorState (dsClose);  //
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + pm.ActDie.frame - 1;
            EndFrame := StartFrame;
            DefFrameCount := 0;
            ApplyDoorState (dsBroken);  //  ְ
         end;
      else  // ...
         begin
            if Dir < 3 then begin
               StartFrame := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
               EndFrame := StartFrame; // + pm.ActStand.frame - 1;
               FrameTime := pm.ActStand.ftime;
               StartTime := GetTickCount;
               DefFrameCount := 0; //pm.ActStand.frame;
               MicroMove(Dir, 0, 0, 1);
               BoDoorOpen := FALSE;
               boHoldPlace := TRUE;
               ApplyDoorState (dsClose);  //̰
            end else begin
               StartFrame := pm.ActCritical.start;  //ִ 
               EndFrame := StartFrame;
               DefFrameCount := 0;

               BoDoorOpen := TRUE;
               boHoldPlace := FALSE;
               ApplyDoorState (dsOpen);  //  
            end;
         end;
   end;
end;

function  TCastleDoor.GetDefaultFrame (wmode: Boolean): integer;
var
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   if Death then begin
      Result := pm.ActDie.start + pm.ActDie.frame - 1;
      DownDrawLevel := 2;
   end else begin
      if BoDoorOpen then begin
         DownDrawLevel := 2;
         Result := pm.ActCritical.start; // + Dir * (pm.ActStand.frame + pm.ActStand.skip);
      end else begin
         DownDrawLevel := 1;
         Result := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
      end;
   end;
end;

procedure  TCastleDoor.ActionEnded;
begin
   if CurrentAction = SM_DIGUP then begin  //
      BoDoorOpen := TRUE;
      boHoldPlace := FALSE;
   end;
//   if CurrentAction = SM_DIGDOWN then
//      DefaultMotion;
end;

procedure  TCastleDoor.Run;
begin
   if (Map.CurUnitX <> oldunitx) or (Map.CurUnitY <> oldunity) then begin
      if Death then ApplyDoorState (dsBroken)
      else if BoDoorOpen then ApplyDoorState (dsOpen)
      else ApplyDoorState (dsClose);
   end;
   oldunitx := Map.CurUnitX;
   oldunity := Map.CurUnitY;
   inherited Run;
end;

procedure  TCastleDoor.DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean);
begin
   inherited DrawChr (dsurface, dx, dy, blend);
   if boUseEffect and not blend then
      if EffectSurface <> nil then begin
         DrawBlend (dsurface,
                    dx + ax + ShiftX,
                    dy + ay + ShiftY,
                    EffectSurface, DrawADDValue_MagicEffect);
      end;
end;



{----------------------------------------------------------------------}
//


constructor TWallStructure.Create;
begin
   inherited Create;
   Dir := 0;
   EffectSurface := nil;
   BrokenSurface := nil;
   bomarkpos := FALSE;
   //DownDrawLevel := 1;
end;

procedure TWallStructure.CalcActorFrame;
var
   pm: PTMonsterAction;
   haircount: integer;
begin
   boUseEffect := FALSE;
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   UserName := ' ';
   deathframe := 0;
   boUseEffect := FALSE;

   case CurrentAction of
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start;
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
            deathframe := pm.ActStand.start + Dir;
            MicroMove(Dir, 0, 0, 1);
            boUseEffect := TRUE;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + pm.ActDie.frame - 1;
            EndFrame := StartFrame;
            DefFrameCount := 0;
         end;
      SM_DIGUP:  // ɶ 
         begin
            StartFrame := pm.ActDie.start;
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
            deathframe := pm.ActStand.start + Dir;
            boUseEffect := TRUE;
         end;
      else  // ...
         begin
            StartFrame := pm.ActStand.start + Dir; // * (pm.ActStand.frame + pm.ActStand.skip);
            EndFrame := StartFrame; // + pm.ActStand.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            DefFrameCount := 0; //pm.ActStand.frame;
            MicroMove(Dir, 0, 0, 1);
            boHoldPlace := TRUE;
         end;
   end;
end;

procedure  TWallStructure.DoLoadSurface;
var
   mimg: TtilFile;
begin
  if currentframe < 0 then currentframe := 0;
   mimg := GetMonImg (Appearance);
   if deathframe > 0 then begin //(CurrentAction = SM_NOWDEATH) or (CurrentAction = SM_DEATH) then begin
      m_BodySurface := mimg.GetImage (GetOffset (Appearance) + deathframe, Px, Py);
   end else begin
      inherited DoLoadSurface;
   end;
   BrokenSurface := mimg.GetImage (GetOffset (Appearance) + 8 + Dir, bx, by);

   if boUseEffect then begin
      if Appearance = 901 then
         EffectSurface := mimg.GetImage (WALLLEFTBROKENEFFECTBASE + (CurrentFrame - StartFrame), ax, ay)
      else
         EffectSurface := mimg.GetImage (WALLRIGHTBROKENEFFECTBASE + (CurrentFrame - StartFrame), ax, ay);
   end;
end;

function  TWallStructure.GetDefaultFrame (wmode: Boolean): integer;
var
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
    Result := pm.ActStand.start + Dir; // * (pm.ActStand.frame + pm.ActStand.skip);
end;

procedure TWallStructure.DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean);
begin
   inherited DrawChr (dsurface, dx, dy, blend);
   if (BrokenSurface <> nil) and (not blend) then begin
      dsurface.Draw (dx + bx + ShiftX,
                     dy + by + ShiftY,
                     BrokenSurface.ClientRect,
                     BrokenSurface, TRUE);
   end;
   if boUseEffect and (not blend) then begin
      if EffectSurface <> nil then begin
         DrawBlend (dsurface,
                    dx + ax + ShiftX,
                    dy + ay + ShiftY,
                    EffectSurface, DrawADDValue_MagicEffect);
      end;
   end;
end;

procedure  TWallStructure.Run;
begin
   if Death then begin
      if bomarkpos then begin
         Map.MarkCanWalk (XX, yy, TRUE);
         bomarkpos := FALSE;
      end;
   end else begin
      if not bomarkpos then begin
         Map.MarkCanWalk (XX, yy, FALSE);
         bomarkpos := TRUE;
      end;
   end;
   PlayScene.SetActorDrawLevel (self, 0);
   inherited Run;
end;


{ TMineMon }

procedure TMineMon.CalcActorFrame;
begin
  inherited;

end;

constructor TMineMon.Create;
begin
  inherited;

end;




procedure TCentipedeKingMon.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
 if boUseEffect then
  if AttackEffectSurface <> nil then
    DrawBlend (dsurface,dx + ax + ShiftX,dy + ay + ShiftY,AttackEffectSurface, DrawADDValue_MagicEffect);

end;

procedure TCentipedeKingMon.LoadEffect;
begin
  if boUseEffect then
    AttackEffectSurface := WilMon15.GetImage (
                        100 + EffectFrame-EffectStart, // ó  ʰ .
                        ax, ay);
end;

procedure TCentipedeKingMon.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
   inherited DoLoadSurface;
   LoadEffect();
end;

function TMineMon.GetDefaultFrame(wmode: Boolean): integer;
begin

end;

{ TBigHeartMon }

procedure TBigHeartMon.CalcActorFrame;
begin
  Dir:=0;
  inherited CalcActorFrame;
end;

{ TSpiderHouseMon }

procedure TSpiderHouseMon.CalcActorFrame;
begin
  Dir:=0;
  inherited CalcActorFrame;
end;

procedure TCentipedeKingMon.Run;
begin
   if (CurrentAction = SM_WALK) or
      (CurrentAction = SM_BACKSTEP) or
      (CurrentAction = SM_HORSERUN) or
      (CurrentAction = SM_RUN)
   then exit;
   if BoUseDieEffect then begin
     if (CurrentFrame - StartFrame) >= 5 then begin
       BoUseDieEffect:=False;
       boUseEffect:=True;
       EffectStartTime:=GetTickCount();
       EffectFrame:=0;
       LoadEffect();
     end;
   end;
   if boUseEffect then begin
     if (GetTickCount - EffectStartTime) > EffectFrameTime then begin
       EffectStartTime:=GetTickCount();
       if EffectFrame < EffectEnd then begin
         Inc(EffectFrame);
         LoadEffect();
       end else boUseEffect:=False;
     end;
   end;
  inherited;
end;

{ TDragonBody }

procedure TDragonBody.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
  Dir:=0;
  boUseMagic:=False;
  CurrentFrame:= -1;
  BodyOffset := GetOffset(Appearance);
  pm := GetRaceByPM (Race,Appearance);
  if pm = nil then exit;
  if CurrentAction = SM_DIGUP then begin
    MaxTick:=pm.ActWalk.ftime;
    CurTick:=0;
    MoveStep:=1;
    MicroMove(Dir, 0, 0, 1);
  end;
  StartFrame:=0;
  EndFrame:=1;
  FrameTime:=400;
  StartTime:=GetTickCount();
end;

procedure TDragonBody.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
//0x0046C3C0
begin
   if not (Dir in [0..7]) then exit;
   if GetTickCount - m_LoadSurfaceTime > 60 * 1000 then begin
      m_LoadSurfaceTime := GetTickCount;
      DoLoadSurface; //bodysurface loadsurface ٽ θ ʾ ޸𸮰 Ǵ  
   end;
    if m_BodySurface <> nil then
      DrawBlend (dsurface,dx + Px + ShiftX,dy + Py + ShiftY,m_BodySurface, DrawADDValue_MagicEffect);

end;

procedure TDragonBody.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
  m_BodySurface := WilDragon.GetImage(GetOffset(Appearance),Px,Hpy);
end;

end.




