unit IntroScn;

interface

uses
  Windows, SysUtils, Classes, Graphics, StdCtrls, Controls, Forms,
  Dialogs,
  ExtCtrls, DXDraws,
  FState,
  MirGrobal,
  cliUtil,
  ClVarConst,
  ClFunc,
  TyFunc,
  mywil,
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:4
  SoundUtil;


const
  SELECTEDFRAME = 16;
  FREEZEFRAME = 13;
  EFFECTFRAME = 14;
  IntroScn_Auto = False;
type


  TLoginState = (lsLogin, lsNewid, lsNewidRetry, lsChgpw, lsCloseAll);
  TSceneType = (stIntro, stLogin, stSelectCountry, stSelectChr, stNewChr,
    stLoading,
    stLoginNotice, stPlayGame);


  TSelChar = record
    Valid: Boolean;
    UserChr: TUserCharacterInfo;
    Selected: Boolean;
    FreezeState: Boolean;
    Unfreezing: Boolean;
    Freezing: Boolean;
    AniIndex: Integer;
    DarkLevel: Integer;
    EffIndex: Integer;
    starttime: longword;
    moretime: longword;
    startefftime: longword;
  end;

  TScene = class(TObject)
  public
    scenetype: TSceneType;
    constructor Create(stype: TSceneType);
    procedure CloseScene; dynamic;
    procedure Finalize; dynamic;
    procedure Initialize; dynamic;
    procedure KeyDown(var Key: Word; Shift: TShiftState); dynamic;
    procedure KeyPress(var Key: Char); dynamic;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
      Integer); dynamic;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); dynamic;
    procedure OpeningScene; dynamic;
    procedure OpenScene; dynamic;
    procedure PlayScene(MSurface: TDirectDrawSurface); dynamic;
  end;

  TIntroScene = class(TScene)
  public
    constructor Create;
    destructor Destroy; override;
    procedure CloseScene; override;
    procedure OpenScene; override;
    procedure PlayScene(MSurface: TDirectDrawSurface); override;
  end;

  TLoginScene = class(TScene)
  private
    BoOpenFirst: Boolean;
    CurFrame: Integer;
    EdAnswer1: TEdit;
    EdAnswer2: TEdit;
    EdBirthDay: TEdit;
    EdChgCurrentpw: TEdit;
    EdChgId: TEdit;
    EdChgNewPw: TEdit;
    EdChgRepeat: TEdit;
    EdConfirm: TEdit;
    EdEMail: TEdit;

    EdMobPhone: TEdit;
    EdNewId: TEdit;
    EdNewPasswd: TEdit;
    EdPhone: TEdit;
    EdQuiz1: TEdit;
    EdQuiz2: TEdit;
    EdYourName: TEdit;
    MaxFrame: Integer;
    NowOpening: Boolean;
    function CheckUserEntrys: Boolean;
    procedure EdLoginIdKeyPress(Sender: TObject; var Key: Char);
    procedure EdLoginPasswdKeyPress(Sender: TObject; var Key: Char);
    procedure EdNewIdKeyPress(Sender: TObject; var Key: Char);
    procedure EdNewOnEnter(Sender: TObject);
    procedure EdPasswordOnEnter(Sender: TObject);
    procedure EdPasswordOnExit(Sender: TObject);
    function NewIdCheckBirthDay: Boolean;
    function NewIdCheckNewId: Boolean;

  public
    ChgPw: Integer;
    EdPasswd: TEdit;
    EdId: TEdit;
    LoginID: string;
    LoginPasswd, LoginMiPassWord: string;
    starttime: longword;
    constructor Create;
    destructor Destroy; override;
    procedure ChangeLoginState(State: TLoginState);
    procedure ChgpwCancel;
    procedure ChgPwClick;
    procedure ChgpwOk;
    procedure CloseScene; override;
    procedure HideLoginBox;
    procedure NewAccountClose;
    procedure NewAccountOk;
    procedure NewClick;
    procedure OkClick;
    procedure OpenLoginDoor;
    procedure OpenScene; override;
    procedure PassWdFail;
    procedure PlayScene(MSurface: TDirectDrawSurface); override;
  end;

  TSelectChrScene = class(TScene)
  private
    CreateChrMode: Boolean;
    EdChrName: TEdit;
    SoundTimer: TTimer;
    procedure EdChrnameKeyPress(Sender: TObject; var Key: Char);

    procedure MakeNewChar(Index: Integer);
    procedure SoundOnTimer(Sender: TObject);
  public


    constructor Create;
    destructor Destroy; override;
    procedure AddChr(uname: string; Job, hair, Level, sex: Integer);
    procedure ClearChrs;
    procedure CloseScene; override;
    procedure OpenScene; override;
    procedure PlayScene(MSurface: TDirectDrawSurface); override;
    procedure SelChrCreditsClick;
    procedure SelChrEraseChrClick;
    procedure SelChrExitClick;
    procedure SelChrNewChrClick;
    procedure SelChrNewClose;
    procedure SelChrNewJob(Job: Integer);
    procedure SelChrNewOk;
    procedure SelChrNewSex(sex: Integer);
    procedure SelChrSelect1Click;
    procedure SelChrSelect2Click;
    procedure SelChrStartClick;
    procedure SelectChr(Index: Integer);
  end;

  TLoginNotice = class(TScene)
  public
    constructor Create;
    destructor Destroy; override;
    procedure PlayScene(MSurface: TDirectDrawSurface); override;
  end;

  TMusicMainWindow = class(TScene)
    edtPWD: TEdit;
    edtUser: TEdit;
    memAffiche: TMemo;
  public
    AddWindow: Boolean;
    AfficheList: TStringList;
    OrderPlay: Boolean;
    AffichePos: Integer;
    CanVisable: Boolean;
    Closed: Boolean;
    CurrentryID: Integer;
    CurrentrySong: string;
    Extended: Boolean;
    ListenMusic: Boolean;
    Logined: Boolean;
    Loop: Boolean;
    MusicDown: Boolean;
    MusicListPos: Integer;
    MusicMove: Boolean;
    Paused: Boolean;
    Played: Boolean;
    PlayID: Integer;
    PlayList: TStringList;
    PlayStateChange: Boolean;
    PlayStateStr: string;
    RealPlay: Boolean;
    ScrollBtn: Byte;
    ScrollDowned: Boolean;
    SelectID: Integer;
    Sended: Boolean;
    ServerID: Integer;
    ShowAffiche: Boolean;
    ShowList: Boolean;
    StatePanel: Boolean;
    UserID: Integer;
    UserMusicList: TStringList;
    UserMusicListPosition: Integer;
    constructor Create;
    destructor Destroy; override;
    function DisposeAffiche(Affiche: string): TStringList;
  end;



implementation

uses
  ClMain, Fui_Lcj;

constructor TScene.Create(stype: TSceneType);
begin
  scenetype := stype;
end;

procedure TScene.CloseScene;
begin
  ;
end;

procedure TScene.Finalize;
begin
end;

procedure TScene.Initialize;
begin
end;

procedure TScene.KeyDown(var Key: Word; Shift: TShiftState);
begin
end;

procedure TScene.KeyPress(var Key: Char);
begin
end;

procedure TScene.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer);
begin
end;

procedure TScene.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
end;

procedure TScene.OpeningScene;
begin
end;

procedure TScene.OpenScene;
begin
  ;
end;

procedure TScene.PlayScene(MSurface: TDirectDrawSurface);
begin
  ;
end;











constructor TIntroScene.Create;
begin
  inherited Create(stIntro);
end;

destructor TIntroScene.Destroy;
begin
  inherited Destroy;
end;

procedure TIntroScene.CloseScene;
begin
end;

procedure TIntroScene.OpenScene;
begin
end;

procedure TIntroScene.PlayScene(MSurface: TDirectDrawSurface);
begin
end;






constructor TLoginScene.Create;
var
  nx, ny: Integer;
  sl:TStringList;
begin
  inherited Create(stLogin);

  EdId := TEdit.Create(GameWindows.Owner);

  with EdId do begin
    Parent := GameWindows;
    Color := ClBlack;
    Font.Color := clWhite;
    Font.Size := 10;
    MaxLength := 10;
    Font.Name := CurFontName;
    BorderStyle := bsNone;
    OnKeyPress := EdLoginIdKeyPress;
    OnExit := EdPasswordOnExit;
    Visible := False;
    sl:=TStringList.Create;
    if FileExists('.\LcjData\ID.txt') then begin
      sl.LoadFromFile('.\LcjData\ID.txt');
      if sl.Count <> 0 then
      Text := sl[0];
    end;
    sl.Free;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 10;
  end;

  EdPasswd := TEdit.Create(GameWindows.Owner);
  with EdPasswd do begin
    Parent := GameWindows;
    Color := ClBlack;
    Font.Size := 10;
    MaxLength := 10;
    Font.Color := clWhite;
    Font.Name := CurFontName;
    BorderStyle := bsNone;
    PasswordChar := '*';
    OnKeyPress := EdLoginPasswdKeyPress;
    OnEnter := EdPasswordOnEnter;
    OnExit := EdPasswordOnExit;
    if IntroScn_Auto then
      Text := 'ddff110';
    Visible := False;
    tag := 10;
  end;


  nX := SCREENWIDTH div 2 - 320;
  nY := SCREENHEIGHT div 2 - 238;

  EdNewId := TEdit.Create(GameWindows.Owner);
  with EdNewId do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 116;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color :=
      clWhite; MaxLength := 10;
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;


  EdNewPasswd := TEdit.Create(GameWindows.Owner);
  with EdNewPasswd do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 137;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 10;
    PasswordChar := '*'; Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdConfirm := TEdit.Create(GameWindows.Owner);
  with EdConfirm do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 158;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 10;
    PasswordChar := '*';
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdYourName := TEdit.Create(GameWindows.Owner);
  with EdYourName do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 187;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 20;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;

  EdBirthDay := TEdit.Create(GameWindows.Owner);
  with EdBirthDay do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 227;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 10;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := '1987/8/8';
    tag := 11;
  end;
  EdQuiz1 := TEdit.Create(GameWindows.Owner);
  with EdQuiz1 do begin
    Parent := GameWindows;
    Height := 16;
    Width := 163;
    Left := nX + 161;
    Top := nY + 256;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 20;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdAnswer1 := TEdit.Create(GameWindows.Owner);
  with EdAnswer1 do begin
    Parent := GameWindows;
    Height := 16;
    Width := 163;
    Left := nX + 161;
    Top := nY + 276;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 12;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdQuiz2 := TEdit.Create(GameWindows.Owner);
  with EdQuiz2 do begin
    Parent := GameWindows;
    Height := 16;
    Width := 163;
    Left := nX + 161;
    Top := nY + 297;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 20;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdAnswer2 := TEdit.Create(GameWindows.Owner);
  with EdAnswer2 do begin
    Parent := GameWindows;
    Height := 16;
    Width := 163;
    Left := nX + 161;
    Top := nY + 317;
    BorderStyle := bsNone; Color := clBlack; Font.Color := clWhite; MaxLength := 12;
    Visible := FALSE; OnKeyPress := EdNewIdKeyPress; OnEnter := EdNewOnEnter;
    if IntroScn_Auto then
      Text := 'ddff110';
    tag := 11;
  end;
  EdPhone := TEdit.Create(GameWindows.Owner);
  with EdPhone do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 347;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 14;
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 11;
  end;
  EdMobPhone := TEdit.Create(GameWindows.Owner);
  with EdMobPhone do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 368;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 13;
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 11;
  end;
  EdEMail := TEdit.Create(GameWindows.Owner);
  with EdEMail do begin
    Parent := GameWindows;
    Height := 16;
    Width := 116;
    Left := nX + 161;
    Top := nY + 388;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 40;
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 11;
  end;

  nX := SCREENWIDTH div 2 - 210;
  nY := SCREENHEIGHT div 2 - 150;
  EdChgId := TEdit.Create(GameWindows.Owner);
  with EdChgId do begin
    Parent := GameWindows;
    Height := 16;
    Width := 137;
    Left := nX + 239;
    Top := nY + 117;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 10;
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 12;
  end;
  EdChgCurrentpw := TEdit.Create(GameWindows.Owner);
  with EdChgCurrentpw do begin
    Parent := GameWindows;
    Height := 16;
    Width := 137;
    Left := nX + 239;
    Top := nY + 149;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 10;
    PasswordChar := '*';
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 12;
  end;
  EdChgNewPw := TEdit.Create(GameWindows.Owner);
  with EdChgNewPw do begin
    Parent := GameWindows;
    Height := 16;
    Width := 137;
    Left := nX + 239;
    Top := nY + 176;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 10;
    PasswordChar := '*';
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 12;
  end;
  EdChgRepeat := TEdit.Create(GameWindows.Owner);
  with EdChgRepeat do begin
    Parent := GameWindows;
    Height := 16;
    Width := 137;
    Left := nX + 239;
    Top := nY + 208;
    BorderStyle := bsNone;
    Color := clBlack;
    Font.Color := clWhite;
    MaxLength := 10;
    PasswordChar := '*';
    Visible := FALSE;
    OnKeyPress := EdNewIdKeyPress;
    OnEnter := EdNewOnEnter;
    tag := 12;
  end;
end;

destructor TLoginScene.Destroy;
begin
  inherited Destroy;
end;

procedure TLoginScene.ChangeLoginState(State: TLoginState);
var
  i, Focus: Integer;
  c: TControl;
begin
  Focus := -1;
{$IF Ver_LCJ}
  case State of
    lsLogin: Focus := 10;
    lsCloseAll: Focus := -1;
  end;
{$ELSE}
  case State of
    lsLogin: Focus := 10;
    lsNewidRetry, lsNewid: Focus := 11;
    lsChgpw: Focus := 12;
    lsCloseAll: Focus := -1;
  end;
{$IFEND}
  with GameWindows do begin
    for i := 0 to ControlCount - 1 do begin
      c := Controls[i];
      if c is TEdit then begin
        if c.Tag in [10..12] then begin
          if c.tag = Focus then begin
            c.Visible := True;
            if not IntroScn_Auto then
              TEdit(c).Text := '';
          end
          else begin
            c.Visible := False;
            if not IntroScn_Auto then
              TEdit(c).Text := '';
          end;
        end;
      end;
    end;
{$IF Ver_LCJ}

    case State of
      lsLogin:
        begin
          FrmDlg.DLogin.Visible := True;
          if EdId.Visible then
            EdId.SetFocus;
          if (EdId.Text <> '')then begin
            EdPasswd.Visible := True;
            FrmDlg.DLogIn_BtJzID.Tag := 1;
            EdPasswd.SetFocus;
          end;
        end;
      lsCloseAll:
        begin
          FrmDlg.DLogin.Visible := False;
        end;
    end;
{$ELSE}
    case State of
      lsLogin: begin
          FrmDlg.DNewAccount.Visible := False;
          FrmDlg.DChgPw.Visible := False;
          FrmDlg.DLogin.Visible := True;
          if EdId.Visible then
            EdId.SetFocus;
        end;
      lsNewidRetry,
        lsNewid: begin
          FrmDlg.DNewAccount.Visible := True;
          FrmDlg.DChgPw.Visible := False;
          FrmDlg.DLogin.Visible := False;
          if EdNewId.Visible and EdNewId.Enabled then begin
            EdNewId.SetFocus;
          end
          else begin
            if EdConfirm.Visible and EdConfirm.Enabled then
              EdConfirm.SetFocus;
          end;
        end;
      lsChgpw: begin
          FrmDlg.DNewAccount.Visible := False;
          FrmDlg.DChgPw.Visible := True;

          if EdChgId.Visible then
            EdChgId.SetFocus;
        end;
      lsCloseAll: begin
          FrmDlg.DNewAccount.Visible := False;
          FrmDlg.DChgPw.Visible := False;
          FrmDlg.DLogin.Visible := False;
        end;
    end;
{$IFEND}
  end;
end;

function TLoginScene.CheckUserEntrys: Boolean;
begin
  Result := False;
  EdNewId.Text := Trim(EdNewId.Text);
  EdQuiz1.Text := Trim(EdQuiz1.Text);
  EdYourName.Text := Trim(EdYourName.Text);
  if not NewIdCheckNewId then
    Exit;



  if not NewIdCheckBirthDay then
    Exit;
  if length(EdNewId.Text) < 3 then begin
    EdNewId.SetFocus;
    Exit;
  end;
  if length(EdNewPasswd.Text) < 3 then begin
    EdNewPasswd.SetFocus;
    Exit;
  end;
  if EdNewPasswd.Text <> EdConfirm.Text then begin
    EdConfirm.SetFocus;
    Exit;
  end;
  if length(EdQuiz1.Text) < 1 then begin
    EdQuiz1.SetFocus;
    Exit;
  end;
  if length(EdAnswer1.Text) < 1 then begin
    EdAnswer1.SetFocus;
    Exit;
  end;
  if length(EdQuiz2.Text) < 1 then begin
    EdQuiz2.SetFocus;
    Exit;
  end;
  if length(EdAnswer2.Text) < 1 then begin
    EdAnswer2.SetFocus;
    Exit;
  end;
  if length(EdYourName.Text) < 1 then begin
    EdYourName.SetFocus;
    Exit;
  end;

  Result := True;
end;

procedure TLoginScene.ChgpwCancel;
begin
  ChangeLoginState(lsLogin);
end;

procedure TLoginScene.ChgPwClick;
begin
  if ChgPw = 0 then
    ChangeLoginState(lsChgpw)
  else
    ChgpwCancel;
  Inc(ChgPw);
  ChgPw := ChgPw mod 2;
end;

procedure TLoginScene.ChgpwOk;
var
  uid, passwd, newpasswd: string;
begin
  if EdChgNewPw.Text = EdChgRepeat.Text then begin
    uid := EdChgId.Text;
    passwd := EdChgCurrentpw.Text;
    newpasswd := EdChgNewPw.Text;
    GameWindows.ChgPw(uid, passwd, newpasswd);
    ChgpwCancel;
  end
  else begin
    DShowMessage('벻һ!!!');
    EdChgNewPw.SetFocus;
  end;
end;

procedure TLoginScene.CloseScene;
begin
  EdId.Visible := False;
  EdPasswd.Visible := False;
  FrmDlg.DLogin.Visible := False;
{$IF Ver_LCJ}
  FrmDlg.DWPassWord.Visible := False;
{$ELSE}
  ClearSound;
{$IFEND}


end;

procedure TLoginScene.EdLoginIdKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Key := #0;
    LoginID := LowerCase(EdId.Text);
    if LoginID <> '' then begin
      EdPasswd.SetFocus;
    end;
  end;
end;

procedure TLoginScene.EdLoginPasswdKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = '~') or (Key = '''') then
    Key := '_';
  if Key = #13 then begin
    Key := #0;
    LoginID := LowerCase(EdId.Text);

    LoginPasswd := EdPasswd.Text;
    if (LoginID <> '') and (LoginPasswd <> '') then begin
      GameWindows.Login(LoginID, LoginPasswd);


      EdId.Visible := False;
      EdPasswd.Visible := False;

    end
    else
      if (EdId.Visible) and (EdId.Text = '') then
        EdId.SetFocus;
  end;


end;

procedure TLoginScene.EdNewIdKeyPress(Sender: TObject; var Key: Char);
var
  Str, t1, t2, t3, syear, smon, sday: string;
  ayear, amon, aday, sex: Integer;
  flag: Boolean;
begin
  if (Sender = EdNewPasswd) or (Sender = EdChgNewPw) or (Sender = EdChgRepeat)
    then
    if (Key = '~') or (Key = '''') or (Key = ' ') then
      Key := #0;
  if Key = #13 then begin
    Key := #0;
    if Sender = EdNewId then begin
      if not NewIdCheckNewId then
        Exit;
    end;
    if Sender = EdNewPasswd then begin
      if length(EdNewPasswd.Text) < 4 then begin
        DShowMessage('̫.');
        Beep;
        EdNewPasswd.SetFocus;
        Exit;
      end;
    end;
    if Sender = EdConfirm then begin
      if EdNewPasswd.Text <> EdConfirm.Text then begin
        DShowMessage('벻һ.');
        Beep;
        EdConfirm.SetFocus;
        Exit;
      end;
    end;
    if (Sender = EdYourName) or (Sender = EdQuiz1) or (Sender = EdAnswer1) or
      (Sender = EdQuiz2) or (Sender = EdAnswer2) or (Sender = EdPhone) or
      (Sender = EdMobPhone) or (Sender = EdEMail)
      then begin
      TEdit(Sender).Text := Trim(TEdit(Sender).Text);
      if TEdit(Sender).Text = '' then begin
        Beep;
        TEdit(Sender).SetFocus;
        Exit;
      end;
    end;
    if Sender = EdBirthDay then begin
      if not NewIdCheckBirthDay then
        Exit;
    end;
    if TEdit(Sender).Text <> '' then begin
      if Sender = EdNewId then
        EdNewPasswd.SetFocus;
      if Sender = EdNewPasswd then
        EdConfirm.SetFocus;
      if Sender = EdConfirm then
        EdYourName.SetFocus;
      if Sender = EdYourName then
        EdBirthDay.SetFocus;
      if Sender = EdBirthDay then
        EdQuiz1.SetFocus;
      if Sender = EdQuiz1 then
        EdAnswer1.SetFocus;
      if Sender = EdAnswer1 then
        EdQuiz2.SetFocus;
      if Sender = EdQuiz2 then
        EdAnswer2.SetFocus;
      if Sender = EdAnswer2 then
        EdPhone.SetFocus;
      if Sender = EdPhone then
        EdMobPhone.SetFocus;
      if Sender = EdMobPhone then
        EdEMail.SetFocus;
      if Sender = EdEMail then begin
        if EdNewId.Enabled then
          EdNewId.SetFocus
        else if EdNewPasswd.Enabled then
          EdNewPasswd.SetFocus;
      end;

      if Sender = EdChgId then
        EdChgCurrentpw.SetFocus;
      if Sender = EdChgCurrentpw then
        EdChgNewPw.SetFocus;
      if Sender = EdChgNewPw then
        EdChgRepeat.SetFocus;
      if Sender = EdChgRepeat then
        EdChgId.SetFocus;
    end;
  end;
end;

procedure TLoginScene.EdNewOnEnter(Sender: TObject);
var
  hx, hy: Integer;
begin

  FrmDlg.NAHelps.Clear;
  hx := TEdit(Sender).Left + TEdit(Sender).Width + 10;
  hy := TEdit(Sender).Top + TEdit(Sender).Height - 18;
  if Sender = EdNewId then begin
    FrmDlg.NAHelps.Add('IDݵ');
    FrmDlg.NAHelps.Add('ַ.');
    FrmDlg.NAHelps.Add('ID4λ.');
    FrmDlg.NAHelps.Add('Ϸнɫ');
    FrmDlg.NAHelps.Add('ϸѡID');
    FrmDlg.NAHelps.Add('ĵ½');
    FrmDlg.NAHelps.Add('еķ.');
    FrmDlg.NAHelps.Add('');
    FrmDlg.NAHelps.Add('ҽһͬ');
    FrmDlg.NAHelps.Add('ϷɫõǸ');
    FrmDlg.NAHelps.Add('.');
  end;
  if Sender = EdNewPasswd then begin
    FrmDlg.NAHelps.Add('һ');
    FrmDlg.NAHelps.Add('ϣַ֣');
    FrmDlg.NAHelps.Add('Ҫ4λ');
    FrmDlg.NAHelps.Add('ס');
    FrmDlg.NAHelps.Add('ǵϷҪ');
    FrmDlg.NAHelps.Add('ȷѾǺ.');
    FrmDlg.NAHelps.Add('ǽòҪ');
    FrmDlg.NAHelps.Add('һ򵥵');
    FrmDlg.NAHelps.Add('һЩ');
    FrmDlg.NAHelps.Add('');
  end;
  if Sender = EdConfirm then begin
    FrmDlg.NAHelps.Add('ٴ');
    FrmDlg.NAHelps.Add('Աȷ.');
  end;
  if Sender = EdYourName then begin
    FrmDlg.NAHelps.Add('ȫ.');
  end;
  if Sender = EdBirthDay then begin
    FrmDlg.NAHelps.Add('ĳں·');
    FrmDlg.NAHelps.Add('// 1977/10/15');
  end;
  if Sender = EdQuiz1 then begin
    FrmDlg.NAHelps.Add('һʾ');
    FrmDlg.NAHelps.Add('ȷֻ㱾˲֪.');
    FrmDlg.NAHelps.Add('');
  end;
  if Sender = EdAnswer1 then begin
    FrmDlg.NAHelps.Add('');
    FrmDlg.NAHelps.Add('.');
  end;
  if Sender = EdQuiz2 then begin
    FrmDlg.NAHelps.Add('һʾ');
    FrmDlg.NAHelps.Add('ȷֻ㱾˲֪.');
    FrmDlg.NAHelps.Add('');
  end;
  if Sender = EdAnswer2 then begin
    FrmDlg.NAHelps.Add('');
    FrmDlg.NAHelps.Add('.');
  end;
  if (Sender = EdYourName) or (Sender = EdQuiz1) or (Sender
    = EdQuiz2) or (Sender = EdAnswer1) or (Sender = EdAnswer2) then begin
    FrmDlg.NAHelps.Add('ȷ');
    FrmDlg.NAHelps.Add('Ϣ');
    FrmDlg.NAHelps.Add('ʹÿɴϢ.');
    FrmDlg.NAHelps.Add('');
    FrmDlg.NAHelps.Add('㽫ܽ');
    FrmDlg.NAHelps.Add('еķ');
    FrmDlg.NAHelps.Add('ṩ');
    FrmDlg.NAHelps.Add('Ϣʻ ');
    FrmDlg.NAHelps.Add('ȡ');
  end;

  if Sender = EdPhone then begin
    FrmDlg.NAHelps.Add('ĵ绰');
    FrmDlg.NAHelps.Add('.');
  end;
  if Sender = EdMobPhone then begin
    FrmDlg.NAHelps.Add('ֻ.');
  end;
  if Sender = EdEMail then begin
    FrmDlg.NAHelps.Add('ʼַʼ ');
    FrmDlg.NAHelps.Add('ڷǵһЩ.');
    FrmDlg.NAHelps.Add('յµһЩϢ');
  end;
end;

procedure TLoginScene.EdPasswordOnEnter(Sender: TObject);
begin

end;

procedure TLoginScene.EdPasswordOnExit(Sender: TObject);
begin
  FrmDlg.Visible := False;
end;

procedure TLoginScene.HideLoginBox;
begin
  ChangeLoginState(lsCloseAll);
end;

procedure TLoginScene.NewAccountClose;
begin
  ChangeLoginState(lsLogin);
end;

procedure TLoginScene.NewAccountOk;
var
  ue: TUserEntryInfo;
begin
  if CheckUserEntrys then begin
    Fillchar(ue, SizeOf(TUserEntryInfo), #0);
    ue.sLoginID := LowerCase(EdNewId.Text);
    ue.sPassword := EdNewPasswd.Text;
    ue.sUserName := EdYourName.Text;

    ue.sSSNo := '650101-1455111';
    ue.sQuiz := EdQuiz1.Text;
    ue.sAnswer := Trim(EdAnswer1.Text);
    ue.sPhone := EdPhone.Text;
    ue.sEMail := Trim(EdEMail.Text);
    ue.sQuiz2 := EdQuiz2.Text;
    ue.sAnswer2 := Trim(EdAnswer2.Text);
    ue.sBirthday := EdBirthDay.Text;
    ue.sMobilePhone := EdMobPhone.Text;
    GameWindows.NewAccount(ue);
    NewAccountClose;
  end;
end;

procedure TLoginScene.NewClick;
begin
  FrmDlg.NewAccountTitle := '';
  ChangeLoginState(lsNewid);
end;

function TLoginScene.NewIdCheckBirthDay: Boolean;
var
  Str, t1, t2, t3, syear, smon, sday: string;
  ayear, amon, aday, sex: Integer;
  flag: Boolean;
begin
  Result := True;
  flag := True;
  Str := EdBirthDay.Text;
  Str := GetValidStr3(Str, syear, ['/']);
  Str := GetValidStr3(Str, smon, ['/']);
  Str := GetValidStr3(Str, sday, ['/']);
  ayear := Str_ToInt(syear, 0);
  amon := Str_ToInt(smon, 0);
  aday := Str_ToInt(sday, 0);
  if (ayear <= 1890) or (ayear > 2101) then
    flag := False;
  if (amon <= 0) or (amon > 12) then
    flag := False;
  if (aday <= 0) or (aday > 31) then
    flag := False;
  if not flag then begin
    Beep;
    EdBirthDay.SetFocus;
    Result := False;
  end;
end;

function TLoginScene.NewIdCheckNewId: Boolean;
begin
  Result := True;
  EdNewId.Text := Trim(EdNewId.Text);
  if length(EdNewId.Text) < 3 then begin

    Beep;
    EdNewId.SetFocus;
    Result := False;
  end;
end;




procedure TLoginScene.OkClick;
var
  Key: Char;
begin
  Key := #13;
  EdLoginPasswdKeyPress(Self, Key);
end;

procedure TLoginScene.OpenLoginDoor;
begin
  NowOpening := True;
  starttime := GetTickCount;
  HideLoginBox;
{$IF Ver_LCJ}
{$ELSE}
   PlaySound(s_rock_door_open);
{$IFEND}

end;

procedure TLoginScene.OpenScene;
var
  i: Integer;
  d: TDirectDrawSurface;
begin
  d := nil;
{$IF Ver_LCJ}
  CurFrame := 0;
  MaxFrame := 10;
  LoginID := '';
  LoginPasswd := '';

  begin

    with EdId do
    begin
      Height := 18;
      Width := 143;
      Left := 595;
      Top := 140;

      Visible := False;
    end;
    with EdPasswd do
    begin
      Left := 595;
      Top := 180;
      Height := 18;
      Width := 143;
      Visible := False;
    end;
  end;

  BoOpenFirst := True;

  FrmDlg.DLogin.Visible := True;
{$ELSE}
  CurFrame := 0;
  MaxFrame := 10;
  LoginID := '';
  LoginPasswd := '';
  with EdId do begin
    Left := SCREENWIDTH div 2 - 68 + 18;
    Top := SCREENHEIGHT div 2 - 8 - 34;
    Height := 16;
    Width := 137;
    Visible := FALSE;
  end;
  with EdPasswd do begin
    Left := SCREENWIDTH div 2 - 68 + 18;
    Top := SCREENHEIGHT div 2 - 8 - 2;
    Height := 16;
    Width := 137;
    Visible := FALSE;
  end;
  BoOpenFirst := True;
  FrmDlg.DLogin.Visible := True;
  FrmDlg.DNewAccount.Visible := False;
  
{$IFEND}
  NowOpening := False;
  GameWindows.PlayMusic('login', True);
end;

procedure TLoginScene.PassWdFail;
begin
  EdId.Visible := True;
  EdPasswd.Visible := True;


  EdId.SetFocus;
end;

procedure TLoginScene.PlayScene(MSurface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
begin
  d := nil;
{$IF Ver_LCJ}
  if BoOpenFirst then
  begin
    BoOpenFirst := False;
    EdId.Visible := True;
    EdPasswd.Visible := True;

    EdId.SetFocus;
    if (EdId.Text <> '')then begin
      EdPasswd.Visible := True;
      FrmDlg.DLogIn_BtJzID.Tag := 1;
      EdPasswd.SetFocus;
    end;
  end;

  if NowOpening then
  begin

    if GetTickCount - starttime > 230 then
    begin
      starttime := GetTickCount;
      Inc(CurFrame);
    end;
    if CurFrame >= OpenDoorNum - 1 then
    begin
      CurFrame := OpenDoorNum - 1;
      if not DoFadeOut and not DoFadeIn then
      begin
        DoFadeOut := True;
        DoFadeIn := True;
        FadeIndex := 30;
      end;
    end;
    d := W16ProgUse[5];
    if d <> nil then
      MSurface.Draw(0, 0, d.ClientRect,
        d, True);

    //    DrawBlend(Msurface,(800-d.Width) div 2, (600-d.Height) div 2,d,1);

    if DoFadeOut then
    begin
      //    if FadeIndex <= 1 then
      begin
        W16ProgUse.FreeOldMemorys;
        W16ChrSel.FreeOldMemorys;
        W16ChrSelEff.FreeOldMemorys;
        DScreen.ChangeScene(stSelectChr);
        // ĳ   â Ѿ.
      end;
    end;
  end;
{$ELSE}
  if BoOpenFirst then begin
    BoOpenFirst := False;
    EdId.Visible := True;
    EdPasswd.Visible := True;
    EdId.SetFocus;
  end;

  d := WilChrSel.Images[22];
  if d <> nil then begin
    MSurface.Draw(0, 0, d.ClientRect, d, False);
  end;

  if NowOpening then begin
    if GetTickCount - starttime > 230 then begin
      starttime := GetTickCount;
      Inc(CurFrame);
    end;
    if CurFrame >= 8 - 1 then begin
      CurFrame := 8 - 1;
      if not DoFadeOut and not DoFadeIn then begin
        DoFadeOut := True;
        DoFadeIn := True;
        FadeIndex := 30;
      end;
    end;
    d := WilChrSel.Images[23 + CurFrame];
    if d <> nil then
      MSurface.Draw((SCREENWIDTH - 800) div 2 + 152, (SCREENHEIGHT - 600) div 2 + 96, d.ClientRect, d, TRUE);
    if DoFadeOut then begin
      begin

        //WilChrSel.ClearCache;
        DScreen.ChangeScene(stSelectChr);
      end;
    end;
  end;
{$IFEND}
end;



constructor TSelectChrScene.Create;
begin
  CreateChrMode := False;
  Fillchar(ChrArr, SizeOf(TSelChar) * 2, #0);
  ChrArr[0].FreezeState := True;
  ChrArr[1].FreezeState := True;
  NewIndex := 0;
  EdChrName := TEdit.Create(GameWindows.Owner);
  with EdChrName do begin
    Parent := GameWindows;
    Font.Name := CurFontName;
    Height := 16;
    Width := 137;
    BorderStyle := bsNone;
    Color := ClBlack;
    Font.Color := clWhite;
    MaxLength := 14;
    Visible := False;
    OnKeyPress := EdChrnameKeyPress;
  end;
  SoundTimer := TTimer.Create(GameWindows.Owner);
  with SoundTimer do begin
    OnTimer := SoundOnTimer;
    Interval := 1;
    Enabled := False;
  end;
  inherited Create(stSelectChr);
end;

destructor TSelectChrScene.Destroy;
begin
  inherited Destroy;
end;

procedure TSelectChrScene.AddChr(uname: string; Job, hair, Level, sex: Integer);
var
  n: Integer;
begin
  if not ChrArr[0].Valid then
    n := 0
  else if not ChrArr[1].Valid then
    n := 1
  else
    Exit;
  ChrArr[n].UserChr.Name := uname;
  ChrArr[n].UserChr.Job := Job;
  ChrArr[n].UserChr.hair := hair;
  ChrArr[n].UserChr.Level := Level;
  ChrArr[n].UserChr.sex := sex;
  ChrArr[n].Valid := True;
{$IF Ver_LCJ}
  ChrArr[n].DarkLevel := (16 * (ChrArr[n].UserChr.Job)) + ChrArr[n].UserChr.sex * 48;
{$ELSE}
{$IFEND}

end;

procedure TSelectChrScene.ClearChrs;
begin
  Fillchar(ChrArr, SizeOf(TSelChar) * 2, #0);
  ChrArr[0].FreezeState := False;
  ChrArr[1].FreezeState := True;
  ChrArr[0].Selected := True;
  ChrArr[1].Selected := False;
  ChrArr[0].UserChr.Name := '';
  ChrArr[1].UserChr.Name := '';
end;

procedure TSelectChrScene.CloseScene;
begin
{$IF Ver_LCJ}
{$ELSE}
  ClearSound;
{$IFEND}
  FrmDlg.DSelectChr.Visible := False;
  SoundTimer.Enabled := False;
end;

procedure TSelectChrScene.EdChrnameKeyPress(Sender: TObject; var Key: Char);
begin

end;

procedure TSelectChrScene.MakeNewChar(Index: Integer);
begin
{$IF Ver_LCJ}
  CreateChrMode := True;
  NewIndex := Index;
  FrmDlg.DCreateChr.Visible := True;
  ChrArr[NewIndex].Valid := True;
  ChrArr[NewIndex].FreezeState := False;
  EdChrName.Left := 106;
  EdChrName.Top := 95;
  EdChrName.Width := 170;
  EdChrName.Height := 20;
  EdChrName.Visible := True;
  EdChrName.SetFocus;
  SelectChr(NewIndex);
  Fillchar(ChrArr[NewIndex].UserChr, SizeOf(TUserCharacterInfo), #0);
{$ELSE}
  CreateChrMode := True;
  NewIndex := Index;
  if Index = 0 then begin
    FrmDlg.DCreateChr.Left := 415;
    FrmDlg.DCreateChr.Top := 15;
  end
  else begin
    FrmDlg.DCreateChr.Left := 75;
    FrmDlg.DCreateChr.Top := 15;
  end;
  FrmDlg.DCreateChr.Visible := True;

  ChrArr[NewIndex].Valid := True;
  ChrArr[NewIndex].FreezeState := False;
  EdChrName.Left := FrmDlg.DCreateChr.Left + 71;
  EdChrName.Top := FrmDlg.DCreateChr.Top + 107;

  EdChrName.Visible := True;
  EdChrName.SetFocus;
  SelectChr(NewIndex);
  Fillchar(ChrArr[NewIndex].UserChr, SizeOf(TUserCharacterInfo), #0);
{$IFEND}
end;

procedure TSelectChrScene.OpenScene;
begin
  FrmDlg.DSelectChr.Visible := True;
{$IF Ver_LCJ}   
{$ELSE}
  GameWindows.PlayMusic('selchr', True);
{$IFEND}
end;

procedure TSelectChrScene.PlayScene(MSurface: TDirectDrawSurface);
var
  n, nn, bx, by, ex, ey, fx, fy, img: Integer;
  d, E, dd: TDirectDrawSurface;
begin
  E := nil;
  D := nil;
  dd := nil;
{$IF Ver_LCJ}

{$ELSE}
  d := WilPrguse3.Images[400];
  if d <> nil then begin
    MSurface.Draw(0, 0, d.ClientRect, d, True);
  end;
  for n := 0 to 1 do begin

    if ChrArr[n].Valid then begin
      ex := (SCREENWIDTH - 800) div 2 + 90;
      ey := (SCREENHEIGHT - 600) div 2 + 60 - 2;
      case ChrArr[n].UserChr.job of
        0: begin
            if ChrArr[n].UserChr.sex = 0 then begin
              bx := (SCREENWIDTH - 800) div 2 + 71;
              by := (SCREENHEIGHT - 600) div 2 + 75 - 23;
              fx := bx;
              fy := by;
            end else begin
              bx := (SCREENWIDTH - 800) div 2 + 65;
              by := (SCREENHEIGHT - 600) div 2 + 75 - 2 - 18;
              fx := bx - 28 + 28;
              fy := by - 16 + 16;
            end;
          end;
        1: begin
            if ChrArr[n].UserChr.sex = 0 then begin
              bx := (SCREENWIDTH - 800) div 2 + 77;
              by := (SCREENHEIGHT - 600) div 2 + 75 - 29;
              fx := bx;
              fy := by;
            end else begin
              bx := (SCREENWIDTH - 800) div 2 + 141 + 30;
              by := (SCREENHEIGHT - 600) div 2 + 85 + 14 - 2;
              fx := bx - 30;
              fy := by - 14;
            end;
          end;
        2: begin
            if ChrArr[n].UserChr.sex = 0 then begin
              bx := (SCREENWIDTH - 800) div 2 + 85;
              by := (SCREENHEIGHT - 600) div 2 + 75 - 12;
              fx := bx;
              fy := by;
            end else begin
              bx := (SCREENWIDTH - 800) div 2 + 141 + 23;
              by := (SCREENHEIGHT - 600) div 2 + 85 + 20 - 2;
              fx := bx - 23;
              fy := by - 20;
            end;
          end;
      end;
      if n = 1 then begin
        ex := (SCREENWIDTH - 800) div 2 + 430;
        ey := (SCREENHEIGHT - 600) div 2 + 60;
        bx := bx + 340;
        by := by + 2;
        fx := fx + 340;
        fy := fy + 2;
      end;
      if ChrArr[n].Unfreezing then begin
        img := 140 - 80 + ChrArr[n].UserChr.job * 40 + ChrArr[n].UserChr.sex * 120;
        d := WilChrSel.Images[img + ChrArr[n].AniIndex];
        E := WilChrSel.Images[4 + ChrArr[n].EffIndex];
        if d <> nil then MSurface.Draw(bx, by, d.ClientRect, d, True);
        if E <> nil then DrawBlend(MSurface, ex, ey, E, DrawADDValue_ChrSel);
        if GetTickCount - ChrArr[n].StartTime > 50 then begin
          ChrArr[n].StartTime := GetTickCount;
          ChrArr[n].AniIndex := ChrArr[n].AniIndex + 1;
        end;
        if GetTickCount - ChrArr[n].startefftime > 50 then begin
          ChrArr[n].startefftime := GetTickCount;
          ChrArr[n].EffIndex := ChrArr[n].EffIndex + 1;


        end;
        if ChrArr[n].AniIndex > FREEZEFRAME - 1 then begin
          ChrArr[n].Unfreezing := FALSE;
          ChrArr[n].FreezeState := FALSE;
          ChrArr[n].AniIndex := 0;
        end;
      end else
        if not ChrArr[n].Selected and (not ChrArr[n].FreezeState and not ChrArr[n].Freezing) then begin
          ChrArr[n].Freezing := True;
          ChrArr[n].AniIndex := 0;
          ChrArr[n].StartTime := GetTickCount;
        end;
      if ChrArr[n].Freezing then begin
        img := 140 - 80 + ChrArr[n].UserChr.job * 40 + ChrArr[n].UserChr.sex * 120;
        d := WilChrSel.Images[img + FREEZEFRAME - ChrArr[n].AniIndex - 1];
        if d <> nil then MSurface.Draw(bx, by, d.ClientRect, d, True);
        if GetTickCount - ChrArr[n].StartTime > 50 then begin
          ChrArr[n].StartTime := GetTickCount;
          ChrArr[n].AniIndex := ChrArr[n].AniIndex + 1;
        end;
        if ChrArr[n].AniIndex > FREEZEFRAME - 1 then begin
          ChrArr[n].Freezing := FALSE;
          ChrArr[n].FreezeState := True;
          ChrArr[n].AniIndex := 0;
        end;
      end;
      if not ChrArr[n].Unfreezing and not ChrArr[n].Freezing then begin
        if not ChrArr[n].FreezeState then begin
          img := 120 - 80 + ChrArr[n].UserChr.job * 40 + ChrArr[n].AniIndex + ChrArr[n].UserChr.sex * 120;
          d := WilChrSel.Images[img];
          if d <> nil then begin
            if ChrArr[n].DarkLevel > 0 then begin
              dd := TDirectDrawSurface.Create(WILCSDD);
              dd.SystemMemory := True;
              dd.SetSize(d.Width, d.Height);
              dd.Draw(0, 0, d.ClientRect, d, FALSE);

              MSurface.Draw(fx, fy, dd.ClientRect, dd, True);
              dd.Free;
            end else
              MSurface.Draw(fx, fy, d.ClientRect, d, True);

          end;
        end else begin
          img := 140 - 80 + ChrArr[n].UserChr.job * 40 + ChrArr[n].UserChr.sex * 120;
          d := WilChrSel.Images[img];
          if d <> nil then
            MSurface.Draw(bx, by, d.ClientRect, d, True);
        end;
        if ChrArr[n].Selected then begin
          if GetTickCount - ChrArr[n].StartTime > 300 then begin
            ChrArr[n].StartTime := GetTickCount;
            ChrArr[n].AniIndex := ChrArr[n].AniIndex + 1;
            if ChrArr[n].AniIndex > SELECTEDFRAME - 1 then
              ChrArr[n].AniIndex := 0;
          end;
          if GetTickCount - ChrArr[n].moretime > 25 then begin
            ChrArr[n].moretime := GetTickCount;
            if ChrArr[n].DarkLevel > 0 then
              ChrArr[n].DarkLevel := ChrArr[n].DarkLevel - 1;
          end;
        end;
      end;

      if n = 0 then begin
        if ChrArr[n].UserChr.name <> '' then begin
          with MSurface do begin
            SetBkMode(Canvas.Handle, TRANSPARENT);
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 117, (SCREENHEIGHT - 600) div 2 + 492 + 2, clWhite, clBlack, ChrArr[n].UserChr.name);
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 117, (SCREENHEIGHT - 600) div 2 + 523, clWhite, clBlack, IntToStr(ChrArr[n].UserChr.Level));
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 117, (SCREENHEIGHT - 600) div 2 + 553, clWhite, clBlack, GetJobName(ChrArr[n].UserChr.job));
            Canvas.Release;
          end;
        end;
      end else begin
        if ChrArr[n].UserChr.name <> '' then begin
          with MSurface do begin
            SetBkMode(Canvas.Handle, TRANSPARENT);
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 671, (SCREENHEIGHT - 600) div 2 + 492 + 2, clWhite, clBlack, ChrArr[n].UserChr.name);
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 671, (SCREENHEIGHT - 600) div 2 + 525 + 2, clWhite, clBlack, IntToStr(ChrArr[n].UserChr.Level));
            BoldTextOut(MSurface, (SCREENWIDTH - 800) div 2 + 671, (SCREENHEIGHT - 600) div 2 + 555 + 2, clWhite, clBlack, GetJobName(ChrArr[n].UserChr.job));
            Canvas.Release;
          end;
        end;
      end;
    end;
  end;
  with MSurface do begin
    SetBkMode(Canvas.Handle, TRANSPARENT);
    BoldTextOut(MSurface,
      SCREENWIDTH div 2 - Canvas.TextWidth(ServerName) div 2,
      (SCREENHEIGHT - 600) div 2 + 8,
      clWhite,
      clBlack,
      ServerName);
    Canvas.Release;
  end;
{$IFEND}
end;

procedure TSelectChrScene.SelChrCreditsClick;
begin
end;

procedure TSelectChrScene.SelChrEraseChrClick;
var
  n: Integer;
begin
  n := 0;
  if ChrArr[0].Valid and ChrArr[0].Selected then
    n := 0;
  if ChrArr[1].Valid and ChrArr[1].Selected then
    n := 1;

  if (ChrArr[n].Valid) and //(not ChrArr[n].FreezeState) and
    (ChrArr[n].UserChr.Name <> '') then begin

    if DQueryDlg('"' + ChrArr[n].UserChr.Name +
      '" ɾĽɫǲָܱ,\һʱʹͬĽɫ.\ȷҪɾ?') then
      GameWindows.DelChr(ChrArr[n].UserChr.Name);
  end;
end;

procedure TSelectChrScene.SelChrExitClick;
begin
  GameWindows.Close;
end;

procedure TSelectChrScene.SelChrNewChrClick;
begin
  if not ChrArr[0].Valid or not ChrArr[1].Valid then begin
    if not ChrArr[0].Valid then
      MakeNewChar(0)
    else
      MakeNewChar(1);
  end
  else
    DShowMessage('ÿ˺ֻܴɫ');
end;

procedure TSelectChrScene.SelChrNewClose;
begin
  ChrArr[NewIndex].Valid := False;
  CreateChrMode := False;
  FrmDlg.DCreateChr.Visible := False;
  EdChrName.Visible := False;
  if NewIndex = 1 then begin
    ChrArr[0].Selected := True;
    ChrArr[0].FreezeState := False;
  end;
end;

procedure TSelectChrScene.SelChrNewJob(Job: Integer);
begin
  if (Job in [0..2]) and (ChrArr[NewIndex].UserChr.Job <> Job) then begin
    ChrArr[NewIndex].UserChr.Job := Job;
    SelectChr(NewIndex);
  end;
end;



procedure TSelectChrScene.SelChrNewOk;
var
  schrname, shair, sjob, ssex,sTouXiang: string;
begin
  schrname := Trim(EdChrName.Text);
  if schrname <> '' then begin
    ChrArr[NewIndex].Valid := False;
    CreateChrMode := False;
    FrmDlg.DCreateChr.Visible := False;
    EdChrName.Visible := False;
    if NewIndex = 1 then begin
      ChrArr[0].Selected := True;
      ChrArr[0].FreezeState := False;
    end;

    shair := IntToStr(1 + random(1));

    sjob := IntToStr(ChrArr[NewIndex].UserChr.Job);
    ssex := IntToStr(ChrArr[NewIndex].UserChr.sex);
    sTouXiang := IntToStr(ChrArr[NewIndex].UserChr.TouXiang);
    GameWindows.NewChr(LoginID, schrname, shair, sjob, ssex,sTouXiang);

  end;
end;

procedure TSelectChrScene.SelChrNewSex(sex: Integer);
begin
  if sex <> ChrArr[NewIndex].UserChr.sex then begin
    ChrArr[NewIndex].UserChr.sex := sex;
    SelectChr(NewIndex);
  end;
end;

procedure TSelectChrScene.SelChrSelect1Click;
begin
  if (not ChrArr[0].Selected) and (ChrArr[0].Valid) then begin
    ChrArr[0].Selected := True;
    ChrArr[1].Selected := False;
{$IF Ver_LCJ}

{$ELSE}
    ChrArr[0].Unfreezing := True;
    ChrArr[0].AniIndex := 0;
    ChrArr[0].DarkLevel := 0;
    ChrArr[0].EffIndex := 0;
    ChrArr[0].starttime := GetTickCount;
    ChrArr[0].moretime := GetTickCount;
    ChrArr[0].startefftime := GetTickCount;
{$IFEND}
    PlaySound(s_meltstone);
  end;
end;

procedure TSelectChrScene.SelChrSelect2Click;
begin
  if (not ChrArr[1].Selected) and (ChrArr[1].Valid) then begin
    ChrArr[1].Selected := True;
    ChrArr[0].Selected := False;
{$IF Ver_LCJ}

{$ELSE}
    ChrArr[1].Unfreezing := True;
    ChrArr[1].AniIndex := 0;
    ChrArr[1].DarkLevel := 0;
    ChrArr[1].EffIndex := 0;
    ChrArr[1].starttime := GetTickCount;
    ChrArr[1].moretime := GetTickCount;
    ChrArr[1].startefftime := GetTickCount;
{$IFEND}
    PlaySound(s_meltstone);
  end;
end;

procedure TSelectChrScene.SelChrStartClick;
var
  chrname: string;
begin
  chrname := '';
  if ChrArr[0].Valid and ChrArr[0].Selected then
    chrname := ChrArr[0].UserChr.Name;
  if ChrArr[1].Valid and ChrArr[1].Selected then
    chrname := ChrArr[1].UserChr.Name;
  if chrname <> '' then begin
    if not DoFadeOut and not DoFadeIn then begin
      DoFastFadeOut := True;
      FadeIndex := 29;
    end;
    GameWindows.StartGame(chrname);
    GameWindows.LoadNeiGua(chrname, 1);
    EdChrName.Visible := False;
    ClearBag;
    DScreen.ClearChatBoard;
    DScreen.ChangeScene(stLoginNotice);
  end
  else
    DShowMessage('һʼӦôһ½ɫ.\ѡ<ɫ>ͿԽһ½ɫ.');
end;

procedure TSelectChrScene.SelectChr(Index: Integer);
begin
  ChrArr[Index].Selected := True;
{$IF Ver_LCJ}
  ChrArr[NewIndex].DarkLevel := (16 * (ChrArr[NewIndex].UserChr.Job));

  if ChrArr[NewIndex].UserChr.sex <> 0 then
    ChrArr[NewIndex].DarkLevel := ChrArr[NewIndex].DarkLevel + 48;



{$ELSE}
  ChrArr[Index].DarkLevel := 29;
{$IFEND}
  ChrArr[Index].starttime := GetTickCount;
  ChrArr[Index].moretime := GetTickCount;
  if Index = 0 then
    ChrArr[1].Selected := False
  else
    ChrArr[0].Selected := False;

end;

procedure TSelectChrScene.SoundOnTimer(Sender: TObject);
begin

  SoundTimer.Enabled := False;

end;





constructor TLoginNotice.Create;
begin
  inherited Create(stLoginNotice);
end;

destructor TLoginNotice.Destroy;
begin
  inherited Destroy;
end;

procedure TLoginNotice.PlayScene(MSurface: TDirectDrawSurface);
begin

  if not SendNoticeok then
    BoldTextOut(MSurface, 330, 300, clwhite, clblack, 'ӣԺ......');
end;



constructor TMusicMainWindow.Create;
begin
  CanVisable := True;
  Closed := False;
  PlayID := 0;
  SelectID := -1;
  AffichePos := 0;
  AddWindow := False;
  MusicMove := False;
  OrderPlay := True;
  StatePanel := False;
  Extended := False;
  PlayStateChange := False;
  AddWindow := False;
  ListenMusic := False;
  Sended := True;
  Paused := False;
  Played := True;
  Loop := False;
  ServerID := -1;
  ShowList := False;
  ShowAffiche := True;
  ScrollDowned := False;
  ScrollBtn := 0;
  Logined := False;
  MusicListPos := 0;
  UserID := -1;
  UserMusicList := TStringList.Create;
  AfficheList := TStringList.Create;
  PlayList := TStringList.Create;
  edtUser := TEdit.Create(GameWindows.Owner);
  with edtUser do begin
    Parent := GameWindows;
    Height := 17;
    Width := 57;
    Left := 3;
    Top := 147;
    BorderStyle := bsNone;
    Visible := False;
  end;
  edtPWD := TEdit.Create(GameWindows.Owner);
  with edtPWD do begin
    Parent := GameWindows;
    Height := 17;
    Width := 57;
    Left := 64;
    Top := 147;
    BorderStyle := bsNone;
    PasswordChar := '*';
    Visible := False;
  end;
end;

destructor TMusicMainWindow.Destroy;
begin
  edtUser.Free;
  UserMusicList.Free;
  edtPWD.Free;
  PlayList.Free;
  AfficheList.Free;
  inherited;
end;

function TMusicMainWindow.DisposeAffiche(Affiche: string): TStringList;
var
  a, Str: string;
  i: Integer;
begin
  Result := TStringList.Create;
  Result.Clear;
  a := Affiche;
  i := 1;
  while length(a) > 0 do begin
    Str := Copy(a, 1, Pos('&', a) - 1);
    Delete(a, 1, Pos('&', a));
    if i mod 2 = 1 then begin
      Str := '' + Str;
      if length(Str) < 26 then
        Result.Add(Str)
      else begin
        while length(Str) > 0 do begin
          if length(Str) > 26 then begin
            if ByteType(Str, 26) = mbLeadByte then begin
              Result.Add(Copy(Str, 1, 25));
              Delete(Str, 1, 25);
            end
            else begin
              Result.Add(Copy(Str, 1, 26));
              Delete(Str, 1, 26);
            end;
          end
          else begin
            Result.Add(Copy(Str, 1, length(Str)));
            Delete(Str, 1, length(Str));
          end;
        end;
      end;
    end
    else begin
      if length(Str) < 26 then
        Result.Add(Str)
      else begin
        while length(Str) > 0 do begin
          if length(Str) > 26 then begin
            if ByteType(Str, 26) = mbLeadByte then begin
              Result.Add(Copy(Str, 1, 25));
              Delete(Str, 1, 25);
            end
            else begin
              Result.Add(Copy(Str, 1, 26));
              Delete(Str, 1, 26);
            end;
          end
          else begin
            Result.Add(Copy(Str, 1, length(Str)));
            Delete(Str, 1, length(Str));
          end;
        end;
      end;
    end;
    Inc(i);
  end;
end;













end.
