unit QuickSearchMap;

interface

uses
  Windows, Classes, SysUtils, Graphics, DXDraws,
  MapUnit,
  TyFunc,
  ClVarConst,
  cliUtil;
type

  TQuickSearchMap = class
  public
    MapHeight, Mapwidth: Integer;
    MArr: array of array of Byte;
    MArr2: array of array of TMapInfo;
    pass: array of longword;
    MiniMapBmp: TBitMap;
    constructor Create;
    destructor Destroy;
    procedure LoadMap(mapname: string);
    function CanMove(mx, my: Integer): Boolean;
  end;



implementation

uses
  ClMain;


constructor TQuickSearchMap.Create;
begin
  inherited Create;
  MiniMapBmp := TBitMap.Create;
  MiniMapBmp.Width := 254;
  MiniMapBmp.Height := 237;
end;

destructor TQuickSearchMap.Destroy;
begin
  MiniMapBmp.Free;
  inherited Destroy;
end;

procedure TQuickSearchMap.LoadMap(mapname: string);
var
  aMapFile: TFileStream;
  i, j,rx,ty: Integer;
  hh:widestring;
  MapHeader :TMapHeader;
begin
  aMapFile := nil;
  if FileExists(mapname) then
  aMapFile := TFileStream.Create(mapname, fmOpenRead or fmShareDenyNone);
  try
    aMapFile.Read(MapHeader, sizeof(TMapHeader)); //
      MapWidth :=MapHeader.Width;
    MapHeight := MapHeader.Height;
    SetLength(MArr2, 0, 0);
    SetLength(MArr, 0, 0);
    SetLength(MArr2, MapWidth, MapHeight);
    SetLength(MArr, MapWidth, MapHeight);
    for i := 0 to MapHeader.width - 1 do
      for j := 0 to MapHeader.height - 1 do
        aMapFile.Read(MArr2[i, j], sizeof(MArr2[i, j]));

    MiniMapBmp.Canvas.Brush.Color := clWhite;
    MiniMapBmp.Canvas.FillRect(Rect(0, 0, MiniMapBmp.Width, MiniMapBmp.Height));
 //MapBufתΪ㷨ʹõĵͼʽMapData

  for i := 0 to MapWidth - 1 do
    for j := 0 to MapHeight - 1 do
    begin
      if ((MArr2[i, j].BkImg and $8000) = 0)then
        MArr[i, j] := 0 //ʶΪƽ
      else
        MArr[i, j] := 1; //ʶΪϰ
    end;

      for i := 0 to Mapwidth - 1 do
        for j := 0 to MapHeight - 1 do
        begin
          rx := UpInt(i * MiniMapBmp.Width / Mapwidth);
          ty := UpInt(j * MiniMapBmp.Height / MapHeight);
          if not CanMove(i, j) then
            MiniMapBmp.Canvas.Pixels[rx, ty] := ClBlack;
        end;
      //MiniMapBmp.SaveToFile('C:\1.bmp');
  finally
    if aMapFile <> nil then 
    aMapFile.Free;
  end;
end;


function TQuickSearchMap.CanMove(mx, my: Integer): Boolean;
begin
  Result := False;
  if (mx < 0) or (my < 0) then
    Exit;
    if (mx>Mapwidth) or(my>MapHeight) then
      Exit;
  Result := MArr[mx, my] = 0;
  if Result then
    Result := not PlayScene.CrashActor(mx, my);
end;


end.
