unit clMapEff;

interface

uses
  Windows, Classes,
  DXDraws,
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  mywil,
  MirGrobal, ClType,
  CliUtil;


const
  ZOMBIDIGUPDUSTBASE = 420; //нʬĶ
  STONEFRAGMENTBASE = 64; //ڿ
  HOLYCURTAINBASE = 1390; //ħ
  FIREBURNBASE = 1630; //ǽ
  SCULPTUREFRAGMENT = 1349; //

type
  TMapEff = class
    X, Y, Dir: integer;
    EventType: integer;
    EventParam: integer;
    ServerId: integer;
    DXImage: pTDXImage;
    BoBlend: Boolean;
    calcframetime: longword;
    curframe: longword;
    light: integer;
  private
  public
    constructor Create(svid, ax, ay, evtype: integer);
    destructor Destroy; override;
    procedure DrawEvent(backsurface: TDirectDrawSurface; ax, ay: integer); dynamic;
    procedure Run; dynamic;
  end;

  TMapEffManager = class
  private
  public
    EffList: TList;
    constructor Create;
    destructor Destroy; override;
    procedure ClearEvents;
    function AddEvent(Eff: TMapEff): TMapEff;
    procedure DelEvent(Eff: TMapEff);
    procedure DelEventById(svid: integer);
    function GetEvent(ax, ay, etype: integer): TMapEff;
    procedure Execute;
  end;


implementation

uses
  ClMain;

constructor TMapEff.Create(svid, ax, ay, evtype: integer);
begin
  ServerId := svid;
  X := ax;
  Y := ay;
  EventType := evtype;
  EventParam := 0;
  BoBlend := FALSE;
  calcframetime := GetTickCount;
  curframe := 0;
  light := 0;
end;

destructor TMapEff.Destroy;
begin
  inherited Destroy;
end;

procedure TMapEff.DrawEvent(backsurface: TDirectDrawSurface; ax, ay: integer);
begin
  if (DXImage <> nil)and(DXImage.Surface <> nil) then
    if BoBlend then DrawBlend_DxImage(backsurface, ax, ay, DXImage, DrawADDValue_DrawEvent)
    else backsurface.Draw(ax + DXImage.npx, ay + DXImage.npy, DXImage.Surface.ClientRect, DXImage.Surface, TRUE);
end;

procedure TMapEff.Run;
begin
  DXImage := nil;
  if GetTickCount - calcframetime > 20 then begin
    calcframetime := GetTickCount;
    Inc(curframe);
  end;
  case EventType of
    ET_DIGOUTZOMBI: {нʬĶ}
      DXImage := WilMon6.GetDxImage(ZOMBIDIGUPDUSTBASE + Dir);
    ET_PILESTONES: {ڿ} begin
        if EventParam <= 0 then EventParam := 1;
        if EventParam > 5 then EventParam := 5;
        DXImage := WilEffect.GetDxImage(STONEFRAGMENTBASE + (EventParam - 1));
      end;
    ET_HOLYCURTAIN: {ħ} begin
        DXImage := WilMagic.GetDxImage(HOLYCURTAINBASE + (curframe mod 10));
        BoBlend := TRUE;
        light := 1;
      end;
    ET_FIRE: {ǽ} begin
        DXImage := WilMagic.GetDxImage(FIREBURNBASE + ((curframe div 2) mod 6));
        BoBlend := TRUE;
        light := 1;
      end;
    ET_SCULPEICE: {} begin
        DXImage := WilMon7.GetDxImage(SCULPTUREFRAGMENT);
      end;
  end;
end;








constructor TMapEffManager.Create;
begin
  EffList := TList.Create;
end;

destructor TMapEffManager.Destroy;
begin
  ClearEvents;
  EffList.Free;
  inherited Destroy;
end;

procedure TMapEffManager.ClearEvents;
var
  i: integer;
begin
  for i := 0 to EffList.Count - 1 do
    TMapEff(EffList[i]).Free;
  EffList.Clear;
end;

function TMapEffManager.AddEvent(Eff: TMapEff): TMapEff;
var
  i: integer;
  event: TMapEff;
begin
  for i := 0 to EffList.Count - 1 do
    if (EffList[i] = Eff) or (TMapEff(EffList[i]).ServerId = Eff.ServerId) then begin
      Eff.Free;
      Result := nil;
      exit;
    end;
  EffList.Add(Eff);
  Result := Eff;
end;

procedure TMapEffManager.DelEvent(Eff: TMapEff);
var
  i: integer;
begin
  for i := 0 to EffList.Count - 1 do
    if EffList[i] = Eff then begin
      TMapEff(EffList[i]).Free;
      EffList.Delete(i);
      break;
    end;
end;

procedure TMapEffManager.DelEventById(svid: integer);
var
  i: integer;
begin
  for i := 0 to EffList.Count - 1 do
    if TMapEff(EffList[i]).ServerId = svid then begin
      TMapEff(EffList[i]).Free;
      EffList.Delete(i);
      break;
    end;
end;

function TMapEffManager.GetEvent(ax, ay, etype: integer): TMapEff;
var
  i: integer;
begin
  Result := nil;
  for i := 0 to EffList.Count - 1 do
    if (TMapEff(EffList[i]).X = ax) and (TMapEff(EffList[i]).Y = ay) and
      (TMapEff(EffList[i]).EventType = etype) then begin
      Result := TMapEff(EffList[i]);
      break;
    end;
end;

procedure TMapEffManager.Execute;
var
  i: integer;
begin
  for i := 0 to EffList.Count - 1 do
    TMapEff(EffList[i]).Run;
end;

end.
