unit CliUtil;

interface

uses
  Windows, SysUtils,DIB,
  DXDraws, DirectX,
  mywil,
  ClVarConst,
  TyFunc;


const
  MAXGRADE = 64;
  DIVUNIT = 4;
  DrawADDValue_DrawHint = 150;
  DrawADDValue_DrawMiniMap = 100;
  DrawADDValue_ActorHide = 100;

  DrawADDValue_ChrSel = 201;
  DrawADDValue_MapObjects = 101;
  DrawADDValue_MagicEffect = 201;
  DrawADDValue_CharEffect = 101;
  DrawADDValue_MapEffect = 101;
  DrawADDValue_ActorEffect = 101;
  DrawADDValue_MonEffect = 101;
  DrawADDValue_DrawEvent = 101;
type

  PRGB = ^TRGB;
  TRGB = packed record
    R, G, B: Byte;
  end;
  TColorEffect = (ceNone, ceGrayScale, ceBright, ceBlack, ceWhite, ceRed, ceGreen, ceBlue, ceYellow, ceFuchsia);

  TNearestIndexHeader = record
    Title: string[30];
    IndexCount: integer;
    desc: array[0..10] of byte;
  end;


function HasMMX: Boolean;

procedure BuildColorLevels(ctable: TRGBQuads);
procedure BuildNearestIndex(ctable: TRGBQuads);

procedure SaveNearestIndex(flname: string);
function LoadNearestIndex(flname: string): Boolean;

procedure DrawBlend_DxImage(dsuf: TDirectDrawSurface; x, y: integer; ssuf: pTDxImage; blendmode: integer);
procedure DrawBlend(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; blendmode: integer);
//procedure DrawBlendEx(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; ssufleft, ssuftop, ssufwidth, ssufheight, blendmode: integer);

procedure DrawAlpha(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; blendmode: integer);
//procedure DrawAlphaEx(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; ssufleft, ssuftop, ssufwidth, ssufheight, blendmode: integer);


procedure DrawEffect(x, y, width, height: integer; ssuf: TDirectDrawSurface; eff: TColorEffect);
procedure DrawLine(Surface: TDirectDrawSurface);



procedure DrawFog(ssuf: TDirectDrawSurface; fogmask: PByte; fogwidth: integer);
procedure DrawFog2(ssuf: TDirectDrawSurface; fogmask: PByte; fogwidth: integer);
procedure MakeDark(ssuf: TDirectDrawSurface; darklevel: integer);
procedure FogCopy(PSource: Pbyte; ssx, ssy, swidth, sheight: integer; PDest: Pbyte; ddx, ddy, dwidth, dheight, maxfog: integer);
procedure BuildAnti32;     //˶ֺɫѧ㷨
var
  darklevel: integer;


implementation

uses
  ClMain;

function IntToByte(i: Integer): Byte;
begin
  if i > 255 then
    Result := 255
  else
    if i < 0 then
      Result := 0
    else
      Result := i;
end;
var
  RgbIndexTable: array[0..MAXGRADE - 1, 0..MAXGRADE - 1, 0..MAXGRADE - 1] of byte;
  Color256Mix: array[0..255, 0..255] of byte;
  Color256Anti: array[0..255, 0..255] of byte;
  HeavyDarkColorLevel: array[0..255, 0..255] of byte;
  LightDarkColorLevel: array[0..255, 0..255] of byte;
  DengunColorLevel: array[0..255, 0..255] of byte;
  BrightColorLevel: array[0..255] of byte;
  GrayScaleLevel: array[0..255] of byte;
  RedishColorLevel: array[0..255] of byte;
  BlackColorLevel: array[0..255] of byte;
  WhiteColorLevel: array[0..255] of byte;
  GreenColorLevel: array[0..255] of byte;
  YellowColorLevel: array[0..255] of byte;
  BlueColorLevel: array[0..255] of byte;
  FuchsiaColorLevel: array[0..255] of byte;

  procedure BuildAnti32;     //˶ֺɫѧ㷨
  var
    i, j: integer;
  begin
    for i := 0 to 255 do begin          //㷨֧32λ
      for j := 0 to 255 do begin
        Color256Anti[i, j] := _MIN(255, Round(i + (255 - i) / 255 * j));
      end;
    end;
  end;

function HasMMX: Boolean;
var
  n: byte;
begin
  asm
      mov   eax, 1
      db $0F,$A2
      test  edx, 00800000H
      mov   n, 1
      jnz   @@Found
      mov   n, 0
   @@Found:
  end;
  if n = 1 then Result := TRUE
  else Result := FALSE;
end;

procedure BuildNearestIndex(ctable: TRGBQuads);
var
  r, g, b, rr, gg, bb, color, MinDif, ColDif: integer;
  MatchColor: byte;
  pal0, pal1, pal2: TRGBQuad;

  procedure BuildMix;
  var
    i, j, n: integer;
  begin
    for i := 0 to 255 do begin
      pal0 := ctable[i];
      for j := 0 to 255 do begin
        pal1 := ctable[j];
        pal1.rgbRed := pal0.rgbRed div 2 + pal1.rgbRed div 2;
        pal1.rgbGreen := pal0.rgbGreen div 2 + pal1.rgbGreen div 2;
        pal1.rgbBlue := pal0.rgbBlue div 2 + pal1.rgbBlue div 2;
        MinDif := 768;
        MatchColor := 0;
        for n := 0 to 255 do begin
          pal2 := ctable[n];
          ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
            Abs(pal2.rgbGreen - pal1.rgbGreen) +
            Abs(pal2.rgbBlue - pal1.rgbBlue);
          if ColDif < MinDif then begin
            MinDif := ColDif;
            MatchColor := n;
          end;
        end;
        Color256Mix[i, j] := MatchColor;
      end;
    end;
  end;

  procedure BuildAnti;
  var
    i, j, n, ever: integer;
  begin
    for i := 0 to 255 do begin
      pal0 := ctable[i];
      for j := 0 to 255 do begin
        pal1 := ctable[j];
        ever := _MAX(pal0.rgbRed, pal0.rgbGreen);
        ever := _MAX(ever, pal0.rgbBlue);
        pal1.rgbRed := _MIN(255, Round(pal0.rgbRed + (255 - pal0.rgbRed) / 255 * pal1.rgbRed));
        pal1.rgbGreen := _MIN(255, Round(pal0.rgbGreen + (255 - pal0.rgbGreen) / 255 * pal1.rgbGreen));
        pal1.rgbBlue := _MIN(255, Round(pal0.rgbBlue + (255 - pal0.rgbBlue) / 255 * pal1.rgbBlue));
        MinDif := 768;
        MatchColor := 0;
        for n := 0 to 255 do begin
          pal2 := ctable[n];
          ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
            Abs(pal2.rgbGreen - pal1.rgbGreen) +
            Abs(pal2.rgbBlue - pal1.rgbBlue);
          if ColDif < MinDif then begin
            MinDif := ColDif;
            MatchColor := n;
          end;
        end;
        Color256Anti[i, j] := MatchColor;
      end;
    end;
  end;
  procedure BuildColorLevels;
  var
    n, i, j, rr, gg, bb: integer;
  begin
    for n := 0 to 30 do begin
      for i := 0 to 255 do begin
        pal1 := ctable[i];
        rr := _MIN(Round(pal1.rgbRed * (n + 1) / 31) - 5, 255);
        gg := _MIN(Round(pal1.rgbGreen * (n + 1) / 31) - 5, 255);
        bb := _MIN(Round(pal1.rgbBlue * (n + 1) / 31) - 5, 255);
        pal1.rgbRed := _MAX(0, rr);
        pal1.rgbGreen := _MAX(0, gg);
        pal1.rgbBlue := _MAX(0, bb);
        MinDif := 768;
        MatchColor := 0;
        for j := 0 to 255 do begin
          pal2 := ctable[j];
          ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
            Abs(pal2.rgbGreen - pal1.rgbGreen) +
            Abs(pal2.rgbBlue - pal1.rgbBlue);
          if ColDif < MinDif then begin
            MinDif := ColDif;
            MatchColor := j;
          end;
        end;
        HeavyDarkColorLevel[n, i] := MatchColor;
      end;
    end;
    for n := 0 to 30 do begin
      for i := 0 to 255 do begin
        pal1 := ctable[i];
        pal1.rgbRed := _MIN(Round(pal1.rgbRed * (n * 3 + 47) / 140), 255);
        pal1.rgbGreen := _MIN(Round(pal1.rgbGreen * (n * 3 + 47) / 140), 255);
        pal1.rgbBlue := _MIN(Round(pal1.rgbBlue * (n * 3 + 47) / 140), 255);
        MinDif := 768;
        MatchColor := 0;
        for j := 0 to 255 do begin
          pal2 := ctable[j];
          ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
            Abs(pal2.rgbGreen - pal1.rgbGreen) +
            Abs(pal2.rgbBlue - pal1.rgbBlue);
          if ColDif < MinDif then begin
            MinDif := ColDif;
            MatchColor := j;
          end;
        end;
        LightDarkColorLevel[n, i] := MatchColor;
      end;
    end;
    for n := 0 to 30 do begin
      for i := 0 to 255 do begin
        pal1 := ctable[i];
        pal1.rgbRed := _MIN(Round(pal1.rgbRed * (n * 3 + 120) / 214), 255);
        pal1.rgbGreen := _MIN(Round(pal1.rgbGreen * (n * 3 + 120) / 214), 255);
        pal1.rgbBlue := _MIN(Round(pal1.rgbBlue * (n * 3 + 120) / 214), 255);
        MinDif := 768;
        MatchColor := 0;
        for j := 0 to 255 do begin
          pal2 := ctable[j];
          ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
            Abs(pal2.rgbGreen - pal1.rgbGreen) +
            Abs(pal2.rgbBlue - pal1.rgbBlue);
          if ColDif < MinDif then begin
            MinDif := ColDif;
            MatchColor := j;
          end;
        end;
        DengunColorLevel[n, i] := MatchColor;
      end;
    end;


    for n := 31 to 255 do
      for i := 0 to 255 do begin
        HeavyDarkColorLevel[n, i] := HeavyDarkColorLevel[30, i];
        LightDarkColorLevel[n, i] := LightDarkColorLevel[30, i];
        DengunColorLevel[n, i] := DengunColorLevel[30, i];
      end;
  end;
begin
  BuildMix;
  BuildAnti;

  BuildColorLevels;
end;

procedure BuildColorLevels(ctable: TRGBQuads);
var
  n, i, j, MinDif, ColDif: integer;
  pal1, pal2: TRGBQuad;
  MatchColor: byte;
begin
  BrightColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    pal1.rgbRed := _MIN(Round(pal1.rgbRed * 1.3), 255);
    pal1.rgbGreen := _MIN(Round(pal1.rgbGreen * 1.3), 255);
    pal1.rgbBlue := _MIN(Round(pal1.rgbBlue * 1.3), 255);
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    BrightColorLevel[i] := MatchColor;
  end;
  GrayScaleLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := n;
    pal1.rgbGreen := n;
    pal1.rgbBlue := n;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    GrayScaleLevel[i] := MatchColor;
  end;
  BlackColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := Round((pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) / 3 * 0.6);
    pal1.rgbRed := n;
    pal1.rgbGreen := n;
    pal1.rgbBlue := n;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    BlackColorLevel[i] := MatchColor;
  end;
  WhiteColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := _MIN(Round((pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) / 3 * 1.6), 255);
    pal1.rgbRed := n;
    pal1.rgbGreen := n;
    pal1.rgbBlue := n;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    WhiteColorLevel[i] := MatchColor;
  end;
  RedishColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := n;
    pal1.rgbGreen := 0;
    pal1.rgbBlue := 0;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    RedishColorLevel[i] := MatchColor;
  end;
  GreenColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];




    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := 0;
    pal1.rgbGreen := n;
    pal1.rgbBlue := 0;



    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    GreenColorLevel[i] := MatchColor;
  end;
  YellowColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := n;
    pal1.rgbGreen := n;
    pal1.rgbBlue := 0;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    YellowColorLevel[i] := MatchColor;
  end;
  BlueColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];

    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := 0;
    pal1.rgbGreen := 0;
    pal1.rgbBlue := n;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    BlueColorLevel[i] := MatchColor;
  end;
  FuchsiaColorLevel[0] := 0;
  for i := 1 to 255 do begin
    pal1 := ctable[i];
    n := (pal1.rgbRed + pal1.rgbGreen + pal1.rgbBlue) div 3;
    pal1.rgbRed := n;
    pal1.rgbGreen := 0;
    pal1.rgbBlue := n;
    MinDif := 768;
    MatchColor := 0;
    for j := 1 to 255 do begin
      pal2 := ctable[j];
      ColDif := Abs(pal2.rgbRed - pal1.rgbRed) +
        Abs(pal2.rgbGreen - pal1.rgbGreen) +
        Abs(pal2.rgbBlue - pal1.rgbBlue);
      if ColDif < MinDif then begin
        MinDif := ColDif;
        MatchColor := j;
      end;
    end;
    FuchsiaColorLevel[i] := MatchColor;
  end;
end;

procedure SaveNearestIndex(flname: string);
var
  nih: TNearestIndexHeader;
  fhandle: integer;
begin
  nih.Title := 'WEMADE Entertainment Inc.';
  nih.IndexCount := Sizeof(Color256Mix);
  if FileExists(flname) then begin
    fhandle := FileOpen(flname, fmOpenWrite or fmShareDenyNone);
  end else
    fhandle := FileCreate(flname);
  if fhandle > 0 then begin
    FileWrite(fhandle, nih, Sizeof(TNearestIndexHeader));
    FileWrite(fhandle, Color256Mix, Sizeof(Color256Mix));
    FileWrite(fhandle, Color256Anti, Sizeof(Color256Anti));
    FileWrite(fhandle, HeavyDarkColorLevel, Sizeof(HeavyDarkColorLevel));
    FileWrite(fhandle, LightDarkColorLevel, Sizeof(LightDarkColorLevel));
    FileWrite(fhandle, DengunColorLevel, Sizeof(DengunColorLevel));
    FileClose(fhandle);
  end;
end;

function LoadNearestIndex(flname: string): Boolean;
var
  nih: TNearestIndexHeader;
  fhandle, rsize: integer;
begin
  Result := FALSE;
  if FileExists(flname) then begin
    fhandle := FileOpen(flname, fmOpenRead or fmShareDenyNone);
    if fhandle > 0 then begin
      FileRead(fhandle, nih, Sizeof(TNearestIndexHeader));
      if nih.IndexCount = Sizeof(Color256Mix) then begin
        Result := TRUE;
        rsize := 256 * 256;
        if rsize <> FileRead(fhandle, Color256Mix, Sizeof(Color256Mix)) then Result := FALSE;
        if rsize <> FileRead(fhandle, Color256Anti, Sizeof(Color256Anti)) then Result := FALSE;
        if rsize <> FileRead(fhandle, HeavyDarkColorLevel, Sizeof(HeavyDarkColorLevel)) then Result := FALSE;
        if rsize <> FileRead(fhandle, LightDarkColorLevel, Sizeof(LightDarkColorLevel)) then Result := FALSE;
        if rsize <> FileRead(fhandle, DengunColorLevel, Sizeof(DengunColorLevel)) then Result := FALSE;
      end;
      FileClose(fhandle);
    end;
  end;
end;

procedure FogCopy(PSource: PByte; ssx, ssy, swidth, sheight: integer;
  PDest: PByte; ddx, ddy, dwidth, dheight, maxfog: integer);
var
  i, j, n, k, row, srclen, scount, si, di, srcheight, spitch, dpitch: integer;
  sptr, dptr: PByte;
begin
  if (PSource = nil) or (PDest = nil) then Exit;
  spitch := swidth;
  dpitch := dwidth;
  if ddx < 0 then begin
    ssx := ssx - ddx;
    swidth := swidth + ddx;

    ddx := 0;
  end;
  if ddy < 0 then begin
    ssy := ssy - ddy;
    sheight := sheight + ddy;

    ddy := 0;
  end;


  srclen := _MIN(swidth, dwidth - ddx);
  srcheight := _MIN(sheight, dheight - ddy);
  if (srclen <= 0) or (srcheight <= 0) then Exit;

  asm
         mov   row, 0
      @@NextRow:
         mov   eax, row
         cmp   eax, srcheight
         jae   @@Finish

         mov   esi, psource
         mov   eax, ssy
         add   eax, row
         mov   ebx, spitch
         imul  eax, ebx
         add   eax, ssx
         add   esi, eax

         mov   edi, pdest
         mov   eax, ddy
         add   eax, row
         mov   ebx, dpitch
         imul  eax, ebx
         add   eax, ddx
         add   edi, eax

         mov   ebx, srclen
      @@FogNext:
         cmp   ebx, 0
         jbe   @@FinOne
         cmp   ebx, 8
         jb    @@FinOne

         db $0F,$6F,$06
         db $0F,$6F,$0F
         db $0F,$FE,$C8
         db $0F,$7F,$0F

         sub   ebx, 8
         add   esi, 8
         add   edi, 8
         jmp   @@FogNext

      @@FinOne:
         inc   row
         jmp   @@NextRow

      @@Finish:
         db $0F,$77
  end;
end;



procedure DrawFog(ssuf: TDirectDrawSurface; fogmask: PByte; fogwidth: integer);
var
  i, j, idx, row, n, count: integer;
  ddsd: TDDSurfaceDesc;
  sptr, mptr, pmix: PByte;

  bitindex, scount, dcount, srclen, destlen, srcheight: integer;
  lpitch: integer;
  src, msk: array[0..7] of byte;
  pSrc, PSource, pColorLevel: PByte;
begin
  if ssuf.width > 800 + 100 then Exit;
  if ssuf.BitCount <> 8 then Exit;
  case darklevel of
    1: pColorLevel := @HeavyDarkColorLevel;
    2: pColorLevel := @LightDarkColorLevel;
    3: pColorLevel := @DengunColorLevel;
  else Exit;
  end;

  try
    ddsd.dwSize := Sizeof(ddsd);
    ssuf.Lock(TRect(nil^), ddsd);
    srclen := _MIN(ssuf.width, fogwidth);
    pSrc := @src;
    srcheight := ssuf.height;
    lpitch := ddsd.lpitch;
    PSource := ddsd.lpSurface;

    asm
            mov   row, 0
         @@NextRow:
            mov   ebx, row
            mov   eax, srcheight
            cmp   ebx, eax
            jae   @@DrawFogFin

            mov   esi, psource
            mov   eax, lpitch
            mov   ebx, row
            imul  eax, ebx
            add   esi, eax

            mov   edi, fogmask
            mov   eax, fogwidth
            mov   ebx, row
            imul  eax, ebx
            add   edi, eax

            mov   ecx, srclen
            mov   edx, pColorLevel

         @@NextByte:
            cmp   ecx, 0
            jbe   @@Finish

            movzx eax, [edi].byte


            imul  eax, 256
            movzx ebx, [esi].byte
            add   eax, ebx
            mov   al, [edx+eax].byte
            mov   [esi].byte, al

            dec   ecx
            inc   esi
            inc   edi
            jmp   @@NextByte

         @@Finish:
            inc   row
            jmp   @@NextRow

         @@DrawFogFin:
            db $0F,$77
    end;
  finally
    ssuf.UnLock();
  end;
end;

procedure DrawFog2(ssuf: TDirectDrawSurface; fogmask: PByte; fogwidth: integer);
var
  i, j, n, scount, srclen, offsvalue: integer;
  sddsd: TDDSurfaceDesc;
  sptr, fptr, pColorLevel: PByte;
  source: array[0..810] of byte;
begin
  if ssuf.width > 800 then Exit;
  if ssuf.BitCount <> 8 then Exit;
  try
    sddsd.dwSize := Sizeof(sddsd);
    ssuf.Lock(TRect(nil^), sddsd);
    srclen := _MIN(ssuf.width, fogwidth);
    case darklevel of
      0: pColorLevel := @HeavyDarkColorLevel;
      1: pColorLevel := @LightDarkColorLevel;
      2: pColorLevel := @DengunColorLevel;
    end;
    for i := 0 to ssuf.height - 1 do begin
      sptr := PByte(integer(sddsd.lpSurface) + i * sddsd.lpitch);
      fptr := PByte(integer(fogmask) + i * fogwidth);
      asm
               mov   scount, 0
               mov   esi, sptr
               lea   edi, source
            @@CopySource:
               mov   ebx, scount
               cmp   ebx, srclen
               jae   @@EndSourceCopy
               db $0F,$6F,$04,$1E
               db $0F,$7F,$07
               xor   ebx, ebx
            @@Loop8:
               cmp   ebx, 8
               jz    @@EndLoop8
               mov   ecx, fptr
               add   ecx, scount
               add   ecx, ebx
               movzx eax, [ecx].byte
               cmp   eax, 30
               jae   @@Skip
               imul  eax, 256
               mov   ecx, eax
               movzx eax, [edi+ebx].byte
               mov   edx, pColorLevel
               add   edx, ecx
               movzx eax, [edx+eax].byte
               mov   [edi+ebx], al
            @@Skip:
               inc   ebx
               jmp   @@Loop8
            @@EndLoop8:
               mov   ebx, scount
               db $0F,$6F,$07
               db $0F,$7F,$04,$1E

               add   edi, 8
               add   scount, 8
               jmp   @@CopySource
            @@EndSourceCopy:
               db $0F,$77
      end;
    end;
  finally
    ssuf.UnLock();
  end;
end;

procedure MakeDark(ssuf: TDirectDrawSurface; darklevel: integer);
var
  i, j, idx, row, n, count: integer;
  ddsd: TDDSurfaceDesc;
  sptr, mptr, pmix: PByte;

  bitindex, scount, dcount, srclen, destlen, srcheight: integer;
  lpitch: integer;
  src, msk: array[0..7] of byte;
  pSrc, PSource, pColorLevel: PByte;
begin
  if not darklevel in [1..30] then Exit;
  if ssuf.width > 800 + 100 then Exit;
  if ssuf.BitCount <> 8 then Exit;
  try
    ddsd.dwSize := Sizeof(ddsd);
    ssuf.Lock(TRect(nil^), ddsd);
    srclen := ssuf.width;
    srcheight := ssuf.height;
    pSrc := @src;


    pColorLevel := @HeavyDarkColorLevel;
    lpitch := ddsd.lpitch;
    PSource := ddsd.lpSurface;

    asm
            mov   row, 0
         @@NextRow:
            mov   ebx, row
            mov   eax, srcheight
            cmp   ebx, eax
            jae   @@DrawFogFin

            mov   esi, psource
            mov   eax, lpitch
            mov   ebx, row
            imul  eax, ebx
            add   esi, eax

            mov   eax, srclen
            mov   scount, eax
         @@FogNext:
            mov   edx, pSrc
            mov   ebx, scount
            cmp   ebx, 0
            jbe   @@Finish
            cmp   ebx, 8
            jb    @@FogSmall

            db $0F,$6F,$06
            db $0F,$7F,$02
            mov   count, 8

          @@LevelChange:
            mov   eax, darklevel
            imul  eax, 256
            movzx ebx, [edx].byte
            add   eax, ebx
            mov   ebx, pColorLevel
            mov   al, [ebx+eax].byte
            mov   [edx].byte, al

         @@Skip1:
            dec   count
            inc   edx
            inc   edi
            cmp   count, 0
            ja    @@LevelChange
            sub   edx, 8

            db $0F,$6F,$02
            db $0F,$7F,$06
         @@Skip_8Byte:
            sub   scount, 8
            add   esi, 8
            jmp   @@FogNext

         @@FogSmall:
            mov   eax, darklevel
            imul  eax, 256
            movzx ebx, [edx].byte
            add   eax, ebx
            mov   ebx, pColorLevel
            mov   al, [ebx+eax].byte
            mov   [esi].byte, al

         @@Skip2:
            inc   edi
            inc   esi
            dec   scount
            jmp   @@FogNext

         @@Finish:
            inc   row
            jmp   @@NextRow

         @@DrawFogFin:
            db $0F,$77
    end;
  finally
    ssuf.UnLock();
  end;
end;


procedure DrawBlend_DxImage(dsuf: TDirectDrawSurface; x, y: integer; ssuf: pTDxImage; blendmode: integer);
begin
  if (dsuf = nil) or (ssuf = nil) then Exit;
  DrawBlend(dsuf, x + ssuf.npx, y + ssuf.npy, ssuf.Surface, blendmode);
end;


procedure DrawBlendEx(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; ssufwidth, ssufheight, blendmode: integer);
var
  tasnat: TRect;
  i, j, srcleft, srctop, srcwidth, srcbottom, sidx, didx: integer;
  sddsd, dddsd: TDDSurfaceDesc;
  sptr, dptr, pmix: PByte;
  source, Dest: array[0..910] of byte;
  bitindex, scount, dcount, srclen, destlen, wcount, awidth, bwidth: integer;
  label Draw32;
begin

  if x >= dsuf.width then Exit;
  if y >= dsuf.height then Exit;

  if (dsuf.BitCount <> 8) then begin
    Draw32:
    if X < 0 then begin
      srcleft := -X;
      X := 0;
    end else begin
      srcleft := 0;
    end;
    srcwidth := ssufwidth -srcleft;
    if Y < 0 then begin
      srctop := -Y;
      srcbottom := ssufheight;
      Y := 0;
    end else begin
      srctop := 0;
      srcbottom := srctop + ssufheight;
    end;
    if srcleft + srcwidth > ssuf.Width then srcwidth := ssuf.Width - srcleft;
    if srcbottom > ssuf.Height then
      srcbottom := ssuf.Height; //-srcheight;
    if X + srcwidth > dsuf.Width then srcwidth := (dsuf.Width - X) div 4 * 4;
    if Y + srcbottom - srctop > dsuf.Height then
      srcbottom := dsuf.Height - Y + srctop;
    if (X + srcwidth) * (Y + srcbottom - srctop) > dsuf.Width * dsuf.Height then
      srcbottom := srctop + (srcbottom - srctop) div 2;

    if (srcwidth <= 0) or
       (srcbottom <= 0) or
       (srcleft >= ssuf.Width) or
       (srctop >= ssuf.Height) then Exit;

    if srcwidth > SCREENWIDTH + 100 then Exit;
    try
      sddsd.dwSize := SizeOf(sddsd);
      dddsd.dwSize := SizeOf(dddsd);
      ssuf.Lock(TRect(nil^), sddsd);
      dsuf.Lock(TRect(nil^), dddsd);
      awidth := srcwidth div 4; //ssuf.Width div 4;
      bwidth := srcwidth; //ssuf.Width;
      srclen := srcwidth; //ssuf.Width;
      destlen := srcwidth; //ssuf.Width;
      case blendmode of
        0: pmix := @Color256Mix[0, 0];
      else pmix := @Color256Anti[0, 0];
      end;
      for i:=srctop to srcbottom - 1 do begin
        sptr := PByte((integer(sddsd.lpSurface) + sddsd.lpitch * i)+srcleft*4);
        dptr := PByte(integer(dddsd.lpSurface) + ((y + i - srctop) * dddsd.lpitch) + X*4);
        for j:= 0 to srcwidth-1 do begin    //Ļתɸ߼
          if pDWord(sptr)^ <> 0 then begin
            dptr^:=Color256Anti[sptr^,dptr^];
            inc(dptr);
            inc(sptr);
            dptr^:=Color256Anti[sptr^,dptr^];
            inc(dptr);
            inc(sptr);
            dptr^:=Color256Anti[sptr^,dptr^];
            inc(dptr);
            inc(sptr);
            dptr^:=Color256Anti[sptr^,dptr^];
            inc(dptr);
            inc(sptr);
          end else begin
            inc(dptr,4);
            inc(sptr,4);
          end;
        end;
      end;
    finally
      ssuf.UnLock;
      dsuf.UnLock;
    end;
    Exit;
  end else begin
    if not FullScreen then begin
      goto Draw32;
    end;
    blendmode := Byte((blendmode mod 2) = 1);


    if X < 0 then begin
      srcleft := -X;
      srcwidth := ssufwidth + X;
      X := 0;
    end else begin
      srcleft := 0;
      srcwidth := ssufwidth;
    end;
    if Y < 0 then begin
      srctop := -Y;
      srcbottom := ssufheight;
      Y := 0;
    end else begin
      srctop := 0;
      srcbottom := srctop + ssufheight;
    end;
    if srcleft + srcwidth > ssuf.Width then srcwidth := ssuf.Width - srcleft;
    if srcbottom > ssuf.Height then
      srcbottom := ssuf.Height; //-srcheight;
    if X + srcwidth > dsuf.Width then srcwidth := (dsuf.Width - X) div 4 * 4;
    if Y + srcbottom - srctop > dsuf.Height then
      srcbottom := dsuf.Height - Y + srctop;
    if (X + srcwidth) * (Y + srcbottom - srctop) > dsuf.Width * dsuf.Height then
      srcbottom := srctop + (srcbottom - srctop) div 2;

    if (srcwidth <= 0) or
       (srcbottom <= 0) or
       (srcleft >= ssuf.Width) or
       (srctop >= ssuf.Height) then Exit;

    if srcwidth > SCREENWIDTH + 100 then Exit;
    try
      sddsd.dwSize := SizeOf(sddsd);
      dddsd.dwSize := SizeOf(dddsd);
      ssuf.Lock(TRect(nil^), sddsd);
      dsuf.Lock(TRect(nil^), dddsd);
      awidth := srcwidth div 4; //ssuf.Width div 4;
      bwidth := srcwidth; //ssuf.Width;
      srclen := srcwidth; //ssuf.Width;
      destlen := srcwidth; //ssuf.Width;
      case blendmode of
        0: pmix := @Color256Mix[0, 0];
      else pmix := @Color256Anti[0, 0];
      end;

      for i := srctop to srcbottom - 1 do begin
        sptr := PByte(Integer(sddsd.lpSurface) + sddsd.lpitch * i + srcleft);
        dptr := PByte(Integer(dddsd.lpSurface) + (Y + i - srctop) * dddsd.lpitch + X);

        asm
                 mov   scount, 0
                 mov   esi, sptr
                 lea   edi, source
                 mov   ebx, scount        //ebx = scount
              @@CopySource:
                 cmp   ebx, srclen
                 jae    @@EndSourceCopy
                 db $0F,$6F,$04,$1E       /// movq  mm0, [esi+ebx]
                 db $0F,$7F,$04,$1F       /// movq  [edi+ebx], mm0
                 add   ebx, 8
                 jmp   @@CopySource
              @@EndSourceCopy:

                 mov   dcount, 0
                 mov   esi, dptr
                 lea   edi, dest
                 mov   ebx, dcount
              @@CopyDest:
                 cmp   ebx, destlen
                 jae    @@EndDestCopy
                 db $0F,$6F,$04,$1E       /// movq  mm0, [esi+ebx]
                 db $0F,$7F,$04,$1F       /// movq  [edi+ebx], mm0
                 add   ebx, 8
                 jmp   @@CopyDest
              @@EndDestCopy:

                 lea   esi, source
                 lea   edi, dest
                 mov   wcount, 0

              @@BlendNext:
                 mov   ebx, wcount
                 cmp   [esi+ebx].byte, 0     //if _src[bitindex] > 0
                 jz    @@EndBlend

                 movzx eax, [esi+ebx].byte     //sidx := _src[bitindex]
                 shl   eax, 8                  //sidx * 256
                 mov   sidx, eax

                 movzx eax, [edi+ebx].byte     //didx := _dest[bitindex]
                 add   sidx, eax

                 mov   edx, pmix
                 mov   ecx, sidx
                 movzx eax, [edx+ecx].byte     //
                 mov   [edi+ebx], al

              @@EndBlend:
                 inc   wcount
                 mov   eax, bwidth
                 cmp   wcount, eax
                 jb    @@BlendNext

                 lea   esi, dest               //Move (_src, dptr^, 4)
                 mov   edi, dptr
                 mov   ecx, awidth
                 cld
                 rep movsd
        end;
      end;
      asm
           db $0F,$77               /// emms
      end;
    finally
      ssuf.UnLock;
      dsuf.UnLock;
    end;
  end;
  {dsuf.Canvas.TextOut(x,y,IntToStr(dsuf.BitCount));
  dsuf.Canvas.Release; }
end;

procedure DrawBlend(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; blendmode: integer);
begin
  if (dsuf = nil) or (ssuf = nil) then Exit;
  DrawBlendEx(dsuf, x, y, ssuf,ssuf.width, ssuf.height, blendmode);
end;


procedure DrawAlphaEx(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; ssufwidth, ssufheight, blendmode: integer);
var
  tasnat: TRect;
  i, j, srcleft, srctop, srcwidth, srcbottom, sidx, didx: integer;
  sddsd, dddsd: TDDSurfaceDesc;
  sptr, dptr, pmix: PByte;
  source, Dest: array[0..910] of byte;
  bitindex, scount, dcount, srclen, destlen, wcount, awidth, bwidth: integer;
begin
  if (dsuf = nil) or (ssuf = nil) then Exit;
  if x >= dsuf.width then Exit;
  if y >= dsuf.height then Exit;

  tasnat.Top := 0 + Y;
  tasnat.Left := 0 + X;
  tasnat.Right := ssufwidth + X;
  tasnat.Bottom := ssufheight + Y;
  if blendmode < 2 then
    dsuf.DrawAlpha(tasnat, ssuf.ClientRect, ssuf, true, 150)
  else dsuf.DrawAlpha(tasnat, ssuf.ClientRect, ssuf, true, blendmode);

end;

procedure DrawAlpha(dsuf: TDirectDrawSurface; x, y: integer; ssuf: TDirectDrawSurface; blendmode: integer);
begin
  DrawBlendEx(dsuf, x, y, ssuf,ssuf.width, ssuf.height, blendmode);
end;



procedure DrawEffect(x, y, width, height: integer; ssuf: TDirectDrawSurface; eff: TColorEffect);

var
  i, j, n, scount, srclen: integer;
  sddsd: TDDSurfaceDesc;

  source: array[0..800 + 10] of byte;
  r, g, b, x2, y2: Integer;
  sptr, peff: PByte;
label effnot256;
begin
  if width > 800 then Exit;
  if eff = ceNone then Exit;
  if ssuf = nil then Exit;
  if ssuf.BitCount <> 8 then begin
    effnot256:
    try
      sddsd.dwSize := Sizeof(sddsd);
      ssuf.Lock(TRect(nil^), sddsd);
      case eff of
        ceGrayScale: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := n;
                G := n;
                B := n;
              end;
            end;
          end;
        end;
        ceBright: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                R := _MIN(Round(R * 1.3), 255);
                G := _MIN(Round(G * 1.3), 255);
                B := _MIN(Round(B * 1.3), 255);
              end;
            end;
          end;
        end;
        ceBlack: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := Round((R + G + B) / 3 * 0.6);
                R := n;
                G := n;
                B := n;
              end;
            end;
          end;
        end;
        ceWhite: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := _MIN(Round((R + G + B) / 3 * 1.6), 255);
                R := n;
                G := n;
                B := n;
              end;
            end;
          end;
          end;
        ceRed: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := 0;
                G := 0;
                B := n;
              end;
            end;
          end;
        end;
        ceGreen: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := 0;
                G := n;
                B := 0;
              end;
            end;
          end;
        end;
        ceBlue: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := n;
                G := 0;
                B := 0;
              end;
            end;
          end;
        end;
        ceYellow: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := n;
                G := n;
                B := 0;
              end;
            end;
          end;
        end;
        ceFuchsia: begin
          for y2 := 0 to ssuf.Height - 1 do begin
            for x2 := 0 to ssuf.Width - 1 do begin
              if PInteger(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^<> 0 then
              with PRGB(Integer(sddsd.lpSurface) + y2 * sddsd.lPitch + x2 * 4)^ do begin
                n := (R + G + B) div 3;
                R := n;
                G := 0;
                B := n;
              end;
            end;
          end;
        end;
      end;
    finally
      ssuf.UnLock();
    end;
    Exit;
  end else begin
    if not FullScreen then begin
      goto effnot256;
    end;

    peff := nil;
    case eff of
      ceGrayScale: peff := @GrayScaleLevel;
      ceBright: peff := @BrightColorLevel;
      ceBlack: peff := @BlackColorLevel;
      ceWhite: peff := @WhiteColorLevel;
      ceRed: peff := @RedishColorLevel;
      ceGreen: peff := @GreenColorLevel;
      ceBlue: peff := @BlueColorLevel;
      ceYellow: peff := @YellowColorLevel;
      ceFuchsia: peff := @FuchsiaColorLevel;

    end;
    if peff = nil then begin
      peff := nil;
      Exit;
    end;
    try
      sddsd.dwSize := Sizeof(sddsd);
      ssuf.Lock(TRect(nil^), sddsd);
      srclen := width;
      for i := 0 to height - 1 do begin
        sptr := PByte(integer(sddsd.lpSurface) + (y + i) * sddsd.lpitch + x);
        asm
               mov   scount, 0
               mov   esi, sptr
               lea   edi, source
            @@CopySource:
               mov   ebx, scount
               cmp   ebx, srclen
               jae   @@EndSourceCopy
               db $0F,$6F,$04,$1E
               db $0F,$7F,$07

               mov   ebx, 0
            @@Loop8:
               cmp   ebx, 8
               jz    @@EndLoop8
               movzx eax, [edi+ebx].byte
               mov   edx, peff
               movzx eax, [edx+eax].byte
               mov   [edi+ebx], al
               inc   ebx
               jmp   @@Loop8
            @@EndLoop8:

               mov   ebx, scount
               db $0F,$6F,$07
               db $0F,$7F,$04,$1E

               add   edi, 8
               add   scount, 8
               jmp   @@CopySource
            @@EndSourceCopy:
               db $0F,$77

        end;
      end;
    finally
      ssuf.UnLock();
    end;
  end;
end;

procedure DrawLine(Surface: TDirectDrawSurface);
var
  i: integer;
  nX, nY: integer;
begin
  for nX := 0 to Surface.width - 1 do begin
    Surface.Pixels[nX, 0] := 255;
  end;
  for nY := 0 to Surface.height - 1 do begin
    Surface.Pixels[0, nY] := 255;
  end;
end;

end.
