unit fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JSocket, ComCtrls, Menus, ExtCtrls,IniFiles, Spin;

type
  TForm1 = class(TForm)
    ServerSocket: TServerSocket;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    MemoLog: TMemo;
    ListBox_Ip: TListBox;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    A1: TMenuItem;
    N1: TMenuItem;
    D1: TMenuItem;
    C1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    S1: TMenuItem;
    L1: TMenuItem;
    Timer1: TTimer;
    ListBox_Chr: TListBox;
    ListBox_Gui: TListBox;
    ListBox_Acc: TListBox;
    GroupBox5: TGroupBox;
    Memo1: TMemo;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure L1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MemoLogChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure OutMsg(sMsg:string);
begin
  Form1.MemoLog.Lines.Add(DateTimeToStr(Now)+':'+sMsg);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListBox_Ip.Items.LoadFromFile('HasIp.txt');

  ListBox_Acc.Items.LoadFromFile('ʺ.txt');
  ListBox_Chr.Items.LoadFromFile('ɫ.txt');
  ListBox_Gui.Items.LoadFromFile('л.txt');


  if FileExists('.\Cfg.ini') then
    with TIniFile.Create('.\Cfg.ini') do begin
      ServerSocket.Port := ReadInteger('', '˿',7890);
      ServerSocket.Address := ReadString('', 'IP','0.0.0.0');
      Free;
    end;
  try
    ServerSocket.Open;
  except
    on E:Exception do begin
      OutMsg('쳣...');
      OutMsg(E.Message);
    end;
  end;
  StatusBar1.Panels[0].Text := 'ȴ...';
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin

  ListBox_Ip.Items.SaveToFile('HasIp.txt');
  ListBox_Acc.Items.SaveToFile('ʺ.txt');
  ListBox_Chr.Items.SaveToFile('ɫ.txt');
  ListBox_Gui.Items.SaveToFile('л.txt');
   //if not FileExists('.\Cfg.ini') then
    with TIniFile.Create('.\Cfg.ini') do begin
      WriteInteger('', '˿',ServerSocket.Port);
      WriteString('', 'IP',ServerSocket.Address);
      Free;
    end;
end;
procedure TForm1.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  OutMsg(Socket.RemoteAddress+':'+'...');
  if ListBox_Ip.Items.IndexOf(Socket.RemoteAddress) < 0 then begin
    OutMsg(Socket.RemoteAddress+':'+'ڷбT֮...');
    Socket.Close;
    Exit;
  end;
  OutMsg(Socket.RemoteAddress+':'+'ӳɹ...');
  Memo1.Lines.Add(Socket.RemoteAddress+':'+inttostr(Socket.RemotePort));

end;

procedure TForm1.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  idx:Integer;
begin
  OutMsg(Socket.RemoteAddress+':'+'Ͽ...');
  idx := Memo1.Lines.IndexOf(Socket.RemoteAddress+':'+inttostr(Socket.RemotePort));
  Memo1.Lines.Delete(idx);
end;

procedure TForm1.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var
  idx:Integer;
begin
  OutMsg(Socket.RemoteAddress+':'+'Ӵ'+inttostr(ErrorCode)+'...');
  ErrorCode := 0;
  Socket.Close;
  idx := Memo1.Lines.IndexOf(Socket.RemoteAddress);
  Memo1.Lines.Delete(idx);
end;

procedure TForm1.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  CheckType:Char;
  SocketStr:string;
  boPass:Boolean;
begin
  SocketStr := Socket.ReceiveText;
  OutMsg(Socket.RemoteAddress+'/'+SocketStr+':...');
  if (SocketStr = '') or (Length(SocketStr)< 3) then begin
    OutMsg(Socket.RemoteAddress+'/'+SocketStr+':Ȳ Exit...');
    Exit;
  end;
  CheckType := SocketStr[1];
  Delete(SocketStr,1,1);
  boPass := False;
  case CheckType of
    'I':begin
      OutMsg('ʺ  '+SocketStr);
      if ListBox_Acc.Items.IndexOf(SocketStr) < 0 then  begin
        ListBox_Acc.Items.Add(SocketStr);
        boPass := True
      end;
    end;
    'C':begin
      OutMsg('ɫ  '+SocketStr);
      if ListBox_Chr.Items.IndexOf(SocketStr) < 0 then  begin
        ListBox_Chr.Items.Add(SocketStr);
        boPass := True;
      end;
    end;
    'G':begin
      OutMsg('л  '+SocketStr);
      if ListBox_Gui.Items.IndexOf(SocketStr) < 0 then begin
        ListBox_Gui.Items.Add(SocketStr);
        boPass := True;
      end;
    end;
  end;
  if boPass then begin
    Socket.SendText('O');
    OutMsg('  '+SocketStr+':Pass...');
  end
  else begin
    Socket.SendText('F');
    OutMsg('  '+SocketStr+':Find...')
  end;
end;



procedure TForm1.A1Click(Sender: TObject);
var
  sIp:string;
begin
  sIp := InputBox('IP',':127.0.0.1','');
  if sIp <> '' then
  with TListBox(PopupMenu1.PopupComponent) do begin
    Items.Add(sIp);
  end;
end;

procedure TForm1.D1Click(Sender: TObject);
begin
  with TListBox(PopupMenu1.PopupComponent) do begin
    if ItemIndex < 0 then Exit;
    Items.Delete(ItemIndex);
  end;
end;

procedure TForm1.C1Click(Sender: TObject);
begin
  TListBox(PopupMenu1.PopupComponent).Items.Clear;
end;

procedure TForm1.S1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then Exit;
  with TListBox(PopupMenu1.PopupComponent) do begin
    Items.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.L1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  with TListBox(PopupMenu1.PopupComponent) do begin
    Items.LoadFromFile(OpenDialog1.FileName);
  end;
end;



procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ListBox_Acc.Items.SaveToFile('ʺ.txt');
  ListBox_Chr.Items.SaveToFile('ɫ.txt');
  ListBox_Gui.Items.SaveToFile('л.txt');
  if ServerSocket.Active then Exit;
  try
    ServerSocket.Open;
  except
    on E:Exception do begin
      OutMsg('쳣...');
      OutMsg(E.Message);
    end;
  end;
  StatusBar1.Panels[0].Text := 'ȴ...';
end;

procedure TForm1.MemoLogChange(Sender: TObject);
begin
  if MemoLog.Lines.Count > SpinEdit1.Value then MemoLog.Clear;
end;

end.
