unit UnitMainWork;

interface

uses Windows, SysUtils, Classes, SerGrobal;

const
  THREADWORK    = TRUE;

type
  TListArray  = array [Ord('A')..Ord('Z') + 10 + 1] of TStrings;
  TMainWorkThread = class{$IF THREADWORK}(TThread){$IFEND}
    m_MainHumLists    : TListArray;
    m_MainIDLists     : TListArray;



    m_sWorkingFor     : string;
    m_nTotalMax       : Integer;
    m_nTotalPostion   : Integer;
    m_nCurMax         : Integer;
    m_nCurPostion     : Integer;
    m_nFailed         : Integer;
    m_sMainRoot       : string;
    m_sMainGuildList  : TStrings;
    m_sGuildChangedList:TStrings;
  private
    m_SubIDLists      : TListArray;
    m_sCurMessage     : string;
    m_WorkRoots       : TStrings;
    m_nNewItemIndex   : Integer;
    IDChangedLists    : TListArray;
    IDOldLists        : TListArray;//TStrings;
    NameChangedList   : TStrings;
    NameOldList       : TStrings;
    m_IDHeader        : TIDDBHeader; //0x1C
    m_HumHeader       : THumDBHeader; //0x1C
    m_HumDBHeader     : THumDBHeader; //0x1C
    f_MainIDH         : THandle;
    f_MainHumH        : THandle;
    f_MainMirH        : THandle;
    FAddIdCount       : Integer;
    FAddChrCount      : Integer;
    FAddChr2Count     : Integer;
    procedure OutMessage;
    procedure LoadHumDB(const sRoot: string; ListArray: TListArray);
    procedure LoadIDDB(const sRoot: string; ListArray: TListArray);
    function  GetMaxWorkCount : Integer;
    function  GetFileSize(const sFile: string; const OffSet: Integer; const DefSize: Integer): Integer;
    procedure SaveIDChangeList;
    procedure SaveNameChangeList;
    procedure MakeInOne(sRoot: string);
    procedure ReSetItemsIndex;
  protected
    procedure Execute; {$IF THREADWORK}override;{$IFEND}
  public
    constructor Create(CreateSupsbended: Boolean = True);reintroduce;
    destructor  Destroy;override;
    procedure   SetWorkRoots(const SL: TStrings);
    {$IF NOT THREADWORK}
    procedure   Run;
    {$IFEND}
  end;

  TMainOutProcList    = procedure (const smsg: string) of Object;

  var
    MainOutInforProc  : TMainOutProcList;
    MainWorkThread    : TMainWorkThread;
{$IF not THREADWORK}
    g_Terminated      : Boolean = False;
{$IFEND}
function  GetFirstChar(const  AHzStr:  string):  string;
function  GetWWIndex(const S: string): Integer;
function  _Max14ReName(S: string; DefChar: Char): string;
function  _Max10ReName(S: string; DefChar: Char): string;
implementation

uses Forms;

{ TMainWorkThread }
function  GetFirstChar(const  AHzStr:  string):  string;
const
   ChinaCode:  array[0..25,  0..1]  of  Integer  =  ((1601,  1636),
                                                     (1637,  1832),
                                                     (1833,  2077),
                                                     (2078,  2273),
                                                     (2274,  2301),
                                                     (2302,  2432),
                                                     (2433,  2593),
                                                     (2594,  2786),
                                                     (9999,  0000),
                                                     (2787,  3105),
                                                     (3106,  3211),
                                                     (3212,  3471),
                                                     (3472,  3634),
                                                     (3635,  3722),
                                                     (3723,  3729),
                                                     (3730,  3857),
                                                     (3858,  4026),
                                                     (4027,  4085),
                                                     (4086,  4389),
                                                     (4390,  4557),
                                                     (9999,  0000),
                                                     (9999,  0000),
                                                     (4558,  4683),
                                                     (4684,  4924),
                                                     (4925,  5248),
                                                     (5249,  5589));
var  
   i, j, HzOrd:  Integer;
begin  
   i  :=  1;
   while  i  <=  Length(AHzStr)  do  
    begin
      if  (AHzStr[i]  >=  #160)  and  (AHzStr[i  +  1]  >=  #160)  then
        begin
          HzOrd  :=  (Ord(AHzStr[i])  -  160)  *  100  +  Ord(AHzStr[i  +  1])  -  160;
          for  j  :=  0  to  25  do
            begin
              if  (HzOrd  >=  ChinaCode[j][0])  and  (HzOrd  <=  ChinaCode[j][1])  then
               begin
                Result  :=  Result  +  Char(Byte('A')  +  j);
                Break;
               end;
            end;
          Inc(i);
        end  else  Result  :=  Result  +  AHzStr[i];
      Inc(i);
    end;
  Result := UpperCase(Result);
end;

function GetWWIndex(const S: string): Integer;
var
  Str2: string;
begin
  Str2  :=  GetFirstChar(S);
  Result  := High(TListArray);
  if Str2 <> '' then
    begin
      Result := Ord(Str2[1]);
      if Result < 65 then
        Result := Result - 47 + 90;
    end;
  if Result > High(TListArray) - 1
    then Result := High(TListArray);
end;

function  _Max14ReName(S: string; DefChar: Char): string;
begin
  if Length(S) >= 14 then
    begin
     case ByteType(S, Length(S)) of
       mbSingleByte: S := Copy(S, 1, Length(S) - 1);
       mbLeadByte,
       mbTrailByte : S := Copy(S, 1, Length(S) - 2);
     end;
    end;
  Result  := S + DefChar;
end;

function  _Max10ReName(S: string; DefChar: Char): string;
begin
  if Length(S) >= 10 then
    begin
     case ByteType(S, Length(S)) of
       mbSingleByte: S := Copy(S, 1, Length(S) - 1);
       mbLeadByte,
       mbTrailByte : S := Copy(S, 1, Length(S) - 2);
     end;
    end;
  Result  := S + DefChar;
end;
constructor TMainWorkThread.Create(CreateSupsbended: Boolean);
var
  I: Integer;
begin
  Inherited Create{$IF THREADWORK}(CreateSupsbended){$IFEND};
  for I := Low(m_MainHumLists) to High(m_MainHumLists) do
    m_MainHumLists[I] := TStringList.Create;
  for I := Low(m_MainIDLists) to High(m_MainIDLists) do
    m_MainIDLists[I]  := TStringList.Create;
  for I := Low(m_SubIDLists) to High(m_SubIDLists) do
    m_SubIDLists[I] := TStringList.Create;

  m_nTotalMax     := 0;
  m_nTotalPostion := 0;
  m_nCurMax       := 0;
  m_nCurPostion   := 0;
  m_nFailed       := 0;
  m_nNewItemIndex := 10000000;
  f_MainIDH       := 0;
  f_MainHumH      := 0;
  f_MainMirH      := 0;

  for I := Low(IDChangedLists) to High(IDChangedLists) do
    IDChangedLists[I]   := TStringList.Create;
  for I := Low(IDOldLists) to High(IDOldLists) do
    IDOldLists[I]       := TStringList.Create;

  NameChangedList := TStringList.Create;
  NameOldList     := TStringList.Create;
  m_sMainGuildList:= TStringList.Create;
  m_sGuildChangedList := TStringList.Create;
end;

destructor TMainWorkThread.Destroy;
var
  I: Integer;
begin
  for I := Low(m_MainHumLists) to High(m_MainHumLists) do
    FreeAndNil(m_MainHumLists[I]);
  for I := Low(m_MainIDLists) to High(m_MainIDLists) do
    FreeAndNil(m_MainIDLists[I]);
  for I := Low(m_SubIDLists) to High(m_SubIDLists) do
    FreeAndNil(m_SubIDLists[I]);


  for I := Low(IDChangedLists) to High(IDChangedLists) do
    FreeAndNil(IDChangedLists[I]);
  for I := Low(IDOldLists) to High(IDOldLists) do
    FreeAndNil(IDOldLists[I]);

  FreeAndNil(NameChangedList);
  FreeAndNil(NameOldList);
  FreeAndNil(m_sMainGuildList);
  FreeAndNil(m_sGuildChangedList);
  if f_MainIDH > 0 then FileClose(f_MainIDH);
  if f_MainHumH > 0 then FileClose(f_MainHumH);
  if f_MainMirH > 0 then FileClose(f_MainMirH);
  inherited Destroy;
end;

procedure TMainWorkThread.Execute;
var
  I: Integer;
begin
  inherited;
  m_sWorkingFor:= 'ڶȡ...';
  m_nTotalMax     := GetMaxWorkCount * 2;
  m_nTotalPostion := 0;
  
  m_sCurMessage := 'ڶȡ...';
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  LoadIDDB(m_sMainRoot + '\IDDB', m_MainIDLists);
  LoadHumDB(m_sMainRoot + '\FDB', m_MainHumLists);
  m_sMainGuildList.LoadFromFile(m_sMainRoot + '\GuildBase\GuildList.txt');
  (m_sMainGuildList as TStringList).Sort;
  //m_nTotalPostion := 0;
  Sleep(1);
  FAddIdCount     := 0;
  FAddChrCount    := 0;
  FAddChr2Count   := 0;
  m_sWorkingFor := 'ںϲ...';
  for I := 0 to m_WorkRoots.Count - 1 do
    begin
      m_sCurMessage := 'ڶȡݣ:' + IntToStr(I + 1) + '';
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
      LoadIDDB(m_WorkRoots[I] + '\IDDB\', m_SubIDLists);
      m_sCurMessage := 'ںϲݣ:' + IntToStr(I + 1) + '';
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
      //ϲ
      
      MakeInOne(m_WorkRoots[I]);
      Sleep(1);
    end;



  m_sWorkingFor := 'Ʒ...';
  ReSetItemsIndex;

  if (f_MainIDH > 0)and (FAddIdCount <> 0) then begin
    Inc(m_IDHeader.nIDCount,FAddIdCount);
    FileSeek(f_MainIDH,0,0);
    FileWrite(f_MainIDH, m_IDHeader, Sizeof(m_IDHeader));
  end;
  if (f_MainHumH > 0)and (FAddChrCount <> 0) then begin
    Inc(m_HumHeader.nHumCount,FAddChrCount);
    FileSeek(f_MainHumH,0,0);
    FileWrite(f_MainHumH, m_HumHeader, Sizeof(m_HumHeader));
    with m_HumHeader do
    m_sCurMessage := Format('Mir.db sDesc:%s  nLastIndex :%d :%d',[sDesc,
    nLastIndex,
    nHumCount]);
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  end;
  if (f_MainMirH > 0)and (FAddChr2Count <> 0)  then begin
    Inc(m_HumDBHeader.nHumCount,FAddChr2Count);
    FileSeek(f_MainMirH,0,0);
    FileWrite(f_MainMirH, m_HumDBHeader, Sizeof(m_HumDBHeader));
    with m_HumDBHeader do
    m_sCurMessage := Format('Mir.db sDesc:%s  nLastIndex :%d :%d',[sDesc,
    nLastIndex,
    nHumCount]);
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  end;


  if f_MainIDH > 0 then FileClose(f_MainIDH);
  if f_MainHumH > 0 then FileClose(f_MainHumH);
  if f_MainMirH > 0 then FileClose(f_MainMirH);

  f_MainIDH       := 0;
  f_MainHumH      := 0;
  f_MainMirH      := 0;







  for I := Low(IDChangedLists) to High(IDChangedLists) do
    if IDChangedLists[I].Count  > 0 then
      begin
        SaveIDChangeList;
        Break;
      end;
      
  if NameChangedList.Count > 0 then
    SaveNameChangeList;
  m_sMainGuildList.SaveToFile(m_sMainRoot + '\GuildBase\GuildList.txt');
  if m_sGuildChangedList.Count > 0 then
    m_sGuildChangedList.SaveToFile(ExtRactFilePath(Application.ExeName) + 'л.txt');
  m_sWorkingFor := '!';

end;

function TMainWorkThread.GetFileSize(const sFile: string; const OffSet,
  DefSize: Integer): Integer;
var
  Sc: TSearchRec;
begin
  if FindFirst(sFile, faAnyFile, Sc) = 0 then
    Result  := (Sc.Size - OffSet) div DefSize
    else Result  := 0;
  if Result < 0 then
    Result  := 0;
end;

function TMainWorkThread.GetMaxWorkCount: Integer;
var
  I, nC: Integer;
begin
  m_sCurMessage := 'ͳ...';
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  nC  := 0;

  for I := 0 to m_WorkRoots.Count - 1 do
    begin
      Inc(nC, GetFileSize(m_WorkRoots[I] + '\FDB\HUM.db', Sizeof(THumDBHeader), Sizeof(THumInfo)));
      Sleep(1);
    end;
  Result  := nC;
end;

procedure TMainWorkThread.LoadHumDB(const sRoot: string; ListArray: TListArray);
var
  f_H: THandle;
  DBHum: THumInfo;
  nCIDX, nC: Integer;
begin
  if not FileExists(sRoot + '\Hum.db') then
    Raise Exception.Create(sRoot + ' Ҳ Hum.db');
  f_H := FileOpen(sRoot + '\Hum.db', 0);
  if f_H <= 0 then Raise Exception.Create('ļʧ! ' + #13 + sRoot + '\Hum.db');
  m_sCurMessage := 'ڶȡ ' + sRoot + '\Hum.db';
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  FileSeek(f_H, Sizeof(THumDBHeader), 0);
  nC  := 0;
  m_nCurMax := GetFileSize(sRoot + '\Hum.db', Sizeof(THumDBHeader), Sizeof(THumInfo));
  while FileRead(f_H, DBHum, Sizeof(DBHum)) = Sizeof(DBHum) do
    begin
      nCIDX :=  GetWWIndex(DBHum.sChrName);
      ListArray[nCIDX].AddObject(DBHum.sChrName, TObject(nC));
      Inc(nC);
      //Inc(m_nCurPostion);
      //Inc(m_nTotalPostion);
      {$IF THREADWORK}if Self.Terminated then Break;
      {$ELSE}
        if g_Terminated then Break;
        Application.ProcessMessages;
      {$IFEND}
    end;
  m_sCurMessage := 'Ѷȡ ' + IntToStr(nC) + ' ';
  for nC := Low(ListArray) to High(ListArray) do
    (ListArray[nC] as TStringList).Sort;
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  FileClose(f_H);
end;

procedure TMainWorkThread.LoadIDDB(const sRoot: string; ListArray: TListArray);
var
  f_H: THandle;
  //FS  : TStream;
  ID: TIDDBRecord;
  nCIDX, nC: Integer;
begin
  if not FileExists(sRoot + '\ID.db') then
    Raise Exception.Create(sRoot + ' Ҳ ID.db');
  f_H := FileOpen(sRoot + '\ID.db', 0);
  //FS  := TFileStream.Create(sRoot + '\ID.db', fmShareDenyNone);
  if f_H <= 0 then Raise Exception.Create('ļʧ! ' + #13 + sRoot + '\ID.db');
  m_sCurMessage := 'ڶȡ ' + sRoot + '\ID.db';
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  FileSeek(f_H, Sizeof(TIDDBHeader), 0);
  nC  := 0;
  m_nCurMax := GetFileSize(sRoot + '\ID.db', Sizeof(TIDDBHeader), Sizeof(ID));
  m_nCurPostion := 0;
  while FileRead(f_H, ID, Sizeof(ID)) = Sizeof(ID) do
  //while FS.Read(ID, Sizeof(ID)) = Sizeof(ID) do
    begin
      nCIDX :=  GetWWIndex(ID.UserEntry.sLoginID);
      ListArray[nCIDX].AddObject(ID.UserEntry.sLoginID, TObject(nC));
      Inc(nC);
      //Inc(m_nCurPostion);
      //Inc(m_nTotalPostion);
      {$IF THREADWORK}if Self.Terminated then Break;
      {$ELSE}
        if g_Terminated then Break;
        Application.ProcessMessages;
      {$IFEND}
    end;
  m_sCurMessage := 'Ѷȡ ' + IntToStr(nC) + ' ID';
  for nC := Low(ListArray) to High(ListArray) do
    (ListArray[nC] as TStringList).Sort;
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  //FreeAndNil(FS);
  FileClose(f_H);
end;


{procedure ReThisHumInGuild(const sHumName,sRoot: string; sNewHumName: string);
var
  SL: TStrings;
  Sc: TSearchRec;
  n_0023C : Integer;
begin
  SL  := TStringList.Create;
  if FindFirst(sRoot + '\GuilBase\Guilds\*.txt', faAnyFile, Sc) = 0 then
    begin
      SL.LoadFromFile(sRoot + '\GuilBase\Guilds\' + Sc.Name);
      n_0023C := SL.IndexOf('+' + sHumName);
      if n_0023C > -1 then
        begin
          SL.Strings[n_0023C] := '+' + sNewHumName;
          SL.SaveToFile(sRoot + '\GuilBase\Guilds\' + Sc.Name);
          SL.Free;
          Exit;
        end;
    end;
  while FindNext(Sc) = 0 do
    begin
      SL.LoadFromFile(sRoot + '\GuilBase\Guilds\' + Sc.Name);
      n_0023C := SL.IndexOf('+' + sHumName);
      if n_0023C > -1 then
        begin
          SL.Strings[n_0023C] := sNewHumName;
          SL.SaveToFile(sRoot + '\GuilBase\Guilds\' + Sc.Name);
          SL.Free;
          Exit;
        end;
      Application.ProcessMessages;
    end;
  SL.Free;
end;
     }
procedure TMainWorkThread.MakeInOne(sRoot: string);
var
  f_IDH, f_HumInfo, f_MirH: THandle;
  ID: TIDDBRecord;
  DBHum: THumInfo;
  HumData: THumDataInfo;
  nCIDX, I, J, nStep, nC_01 : Integer;
  sName, sAccount : string;
  boReNameOK: Boolean;
  GuildList : TStrings;
  TempIDLists: TListArray;
begin
  if f_MainIDH = 0 then begin
    f_MainIDH := FileOpen(Self.m_sMainRoot + '\IDDB\Id.db', fmOpenReadWrite);
    FileRead(f_MainIDH, m_IDHeader, Sizeof(m_IDHeader));
  end;
  if f_MainHumH = 0 then begin  //ڴ˷˸ͼһ
    f_MainHumH  := FileOpen(Self.m_sMainRoot + '\FDB\Hum.db', fmOpenReadWrite);
    FileRead(f_MainHumH, m_HumHeader, Sizeof(m_HumHeader));
    with m_HumHeader do
    m_sCurMessage := Format('Hum.db sDesc:%s  nLastIndex :%d :%d',[sDesc,
    nLastIndex,
    nHumCount]);
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  end;
  if f_MainMirH = 0 then begin
    f_MainMirH  := FileOpen(Self.m_sMainRoot + '\FDB\Mir.db', fmOpenReadWrite);
    FileRead(f_MainMirH, m_HumDBHeader, Sizeof(THumDBHeader));
    with m_HumDBHeader do
    m_sCurMessage := Format('Mir.db sDesc:%s  nLastIndex :%d :%d',[sDesc,
    nLastIndex,
    nHumCount]);
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
  end;

  f_IDH := FileOpen(sRoot + '\IDDB\Id.db', 0);//ʺļ
  f_HumInfo  := FileOpen(sRoot + '\FDB\Hum.db', 0);
  f_MirH  := FileOpen(sRoot + '\FDB\Mir.db', 0);

  FileSeek(f_MainIDH, 0, 2); //ļָƶļβ
  FileSeek(f_MainHumH, 0, 2);
  FileSeek(f_MainMirH, 0, 2);

  m_nCurMax  := GetFileSize(sRoot + '\FDB\Hum.db', Sizeof(THumDBHeader), Sizeof(THumInfo)); //FileSeek(f_HumH, Sizeof(TDBFileHeader), 2) div Sizeof(DBHum);
  FileSeek(f_HumInfo, Sizeof(THumDBHeader), 0);

  m_nCurPostion := 0;
  for I := Low(TempIDLists) to HIgh(TempIDLists) do
    TempIDLists[I]    := TStringList.Create;

  while FileRead(f_HumInfo, DBHum, Sizeof(THumInfo)) = Sizeof(THumInfo) do begin
    if DBHum.boDeleted then begin
      m_sCurMessage := DBHum.sChrName + '['+DBHum.sAccount+']: ɾ,!';
      {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
      Inc(m_nTotalPostion);
      Inc(m_nCurPostion);
      Continue;
    end;
    {Hum.db û˳}
    nStep := 0;
    try
      sName := DBHum.sChrName;
      nCIDX := GetWWIndex(DBHum.sChrName);
      nStep := 1;
      if m_MainHumLists[nCIDX].IndexOf(sName) > -1 then begin //ɫظ
        nStep := 2;
        boReNameOK  := False;
        for I := Ord('a') to Ord('z') do
          begin  
            sName := _Max14ReName(sName, Chr(I));
            if not (m_MainHumLists[nCIDX].IndexOf(sName) > -1) then  
              begin
                boReNameOK := True;  
                Break;  
              end;  
          end;  
        if not boReNameOK then  
          while True do  
            begin  
              sName := IntToHex(Random(MaxInt), 14);
              if not (m_MainHumLists[nCIDX].IndexOf(sName) > -1) then
                Break;
            end;
        nStep := 3;  
        //ReThisHumInGuild(sRoot,DBHum.sChrName, sName);  
        Self.NameChangedList.Add(sName);
        Self.NameOldList.Add(DBHum.sChrName);
      end; //ظ
      nStep := 4;
      {Mir.db}
      FileSeek(f_MirH, Sizeof(THumDBHeader) + Sizeof(HumData) * m_nCurPostion, 0);
      FileRead(f_MirH, HumData, Sizeof(HumData));

      if CompareText(HumData.Data.sChrName, DBHum.sChrName) <> 0 then
        begin
          m_sCurMessage := 'ʧ!' + DBHum.sChrName + '/'+HumData.Data.sChrName+': ݲƥ!';
          {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
          Inc(m_nFailed);
          Inc(m_nTotalPostion);
          Inc(m_nCurPostion);
          Continue;
        end;
      DBHum.Header.sName  := sName;
      DBHum.sChrName      := sName;
      HumData.Header.sName := sName;
      HumData.Data.sChrName    := sName;
      //HumData.sChrName1   := sName;
      m_MainHumLists[nCIDX].Add(sName);
      nStep := 5;
      nCIDX := GetWWIndex(DBHum.sAccount);
      J := m_SubIDLists[nCIDX].IndexOf(DBHum.sAccount);
      if J < 0 then
        begin
          m_sCurMessage := 'ʧ!' + DBHum.sChrName + '/'+inttostr(nCIDX)+': ûƥʺ!';
          {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
          Inc(m_nFailed);
          Inc(m_nTotalPostion);
          Inc(m_nCurPostion);
          Continue;
        end;
      nStep := 6;
      {ID.db}
      FileSeek(f_IDH, Sizeof(TIDDBHeader) + Sizeof(ID) * Integer(m_SubIDLists[nCIDX].Objects[J]), 0);
      FileRead(f_IDH, ID, Sizeof(ID));
      sAccount  := ID.UserEntry.sLoginID;
      //1
      if CompareText(sAccount, DBHum.sAccount) <> 0 then
        begin
          m_sCurMessage := 'ʧ!' + DBHum.sChrName + '['+sAccount+'/'+DBHum.sAccount+']: ʺŲƥ!';
          {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
          Inc(m_nFailed);
          Inc(m_nTotalPostion);
          Inc(m_nCurPostion);
          Continue;
        end;
      nStep := 7;
      //2
      nC_01 := IDOldLists[nCIDX].IndexOf(sAccount);
      if nC_01 > -1 then
        begin
          sAccount  := IDChangedLists[nCIDX].Strings[nC_01];
        end
        else begin
          if not (TempIDLists[nCIDX].IndexOf(sAccount) > - 1) then // TempIDLists
            begin
              TempIDLists[nCIDX].Add(sAccount);
              if m_MainIDLists[nCIDX].IndexOf(sAccount) > -1 then //Ѿ
                begin
                  boReNameOK  := False;
                  nStep := 8;
                  for I := Ord('a') to Ord('z') do
                    begin
                      sAccount := _Max10ReName(sAccount, Chr(I));
                      if not (m_MainIDLists[nCIDX].IndexOf(sAccount) > -1) then
                        begin
                          boReNameOK := True;
                          Break;
                        end;
                    end;
                  if not boReNameOK then
                    while True do
                      begin
                        sAccount := IntToHex(Random(MaxInt), 10);
                        nCIDX    := GetWWIndex(sAccount);
                        if not (m_MainIDLists[nCIDX].IndexOf(sAccount) > -1) then
                          Break;
                      end;
                  nStep:= 9;
                  Self.IDChangedLists[nCIDX].Add(sAccount);
                  Self.IDOldLists[nCIDX].Add(ID.UserEntry.sLoginID);
                end;
            end;
        end;

      nStep := 10;
      ID.Header.sAccount    := sAccount;
      ID.UserEntry.sLoginID := sAccount;
      DBHum.sAccount        := sAccount;
      HumData.Data.sAccount      := sAccount;
      m_MainIDLists[nCIDX].Add(sAccount);

      nStep := 11;
      FillChar(HumData.Data.wStatusTimeArr, Sizeof(HumData.Data.wStatusTimeArr), 0);
      Inc(FAddIdCount);
      Inc(FAddChrCount);
      Inc(FAddChr2Count);
      FileWrite(f_MainIDH, ID, Sizeof(ID));
      FileWrite(f_MainHumH, DBHum, Sizeof(DBHum));
      FileWrite(f_MainMirH, HumData, Sizeof(HumData));
    except
        On E: Exception do
          begin
            m_sCurMessage := '쳣:' + sName + ' Step:' + IntToStr(nStep);
            {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
            m_sCurMessage := E.Message;
            {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
          end;
    end;
      //f_MainIDH
      Inc(m_nTotalPostion);
      Inc(m_nCurPostion);      
      {$IF THREADWORK}if Self.Terminated then Break;
      {$ELSE}
        if g_Terminated then Break;
        Application.ProcessMessages;
      {$IFEND}
  end;

  (*GuildList := TStringList.Create;
  GuildList.LoadFromFile(sRoot + '\GuildBase\GuildList.txt');
  (GuildList as TStringList).Sort;
  while GuildList.Count > 0 do
    begin
     try
      sName := GuildList.Strings[0];
      if Self.m_sMainGuildList.IndexOf(sName) > -1 then
        begin
          boReNameOK  := False;
          for I := Ord('a') to Ord('z') do
            begin
              sName :=  sName + Chr(I);
              if not (Self.m_sMainGuildList.IndexOf(sName) > -1) then
                begin
                  boReNameOK  := True;
                  Break;
                end;
            end;
          if not boReNameOK then
            while True do
              begin
                sName := IntToHex(Random(MaxInt), 32);
                if not (m_sMainGuildList.IndexOf(sName) > -1) then
                  Break;
              end;
        end;
      if sName <> GuildList.Strings[0] then
        Self.m_sGuildChangedList.Add('"' + GuildList.Strings[0] + '"' + #9#9#9#9 + '"' + sName + '"');
      Windows.CopyFile(PChar(sRoot + '\GuildBase\Guilds\' + GuildList.Strings[0] + '.txt'),
                       PChar(m_sMainRoot + '\GuildBase\Guilds\' + sName + '.txt'),
                       True);
      Windows.CopyFile(PChar(sRoot + '\GuildBase\Guilds\' + GuildList.Strings[0] + '.ini'),
                       PChar(m_sMainRoot + '\GuildBase\Guilds\' + sName + '.ini'),
                       True);
      m_sMainGuildList.Add(sName);
      GuildList.Delete(0);
     Except
      On E: Exception do
        begin
          m_sCurMessage := E.Message;
          {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
        end;
      end;
      Application.ProcessMessages;
    end; *)
  for I := Low(TempIDLists) to High(TempIDLists) do
    TempIDLists[I].Free;
  FileClose(f_IDH);
  FileClose(f_HumInfo);
  FileClose(f_MirH);
end;

procedure TMainWorkThread.OutMessage;
begin
  if Assigned(MainOutInforProc) then
    MainOutInforProc(m_sCurMessage);
end;

procedure TMainWorkThread.ReSetItemsIndex;
var
  HumData: THumDataInfo;
  I      : Integer;
begin

  m_nCurMax := (FileSeek(f_MainMirH, 0, 2) - Sizeof(THumDBHeader)) div Sizeof(HumData);
  FileSeek(f_MainMirH, Sizeof(THumDBHeader), 0);
  m_nCurPostion := 0;
  while FileRead(f_MainMirH, HumData, Sizeof(HumData)) = Sizeof(HumData) do
    begin
      if HumData.Data.sChrName = 'С' then begin
        Sleep(1);
      end;
      for I := Low(HumData.Data.HumItems) to High(HumData.Data.HumItems) do
      with HumData.Data.HumItems[I] do
        if wIndex > 0 then
          begin
            MakeIndex := m_nNewItemIndex;
            Inc(m_nNewItemIndex);
          end;

      for I := Low(HumData.Data.BagItems) to High(HumData.Data.BagItems) do
        with HumData.Data.BagItems[I] do
        if wIndex > 0 then
          begin
            MakeIndex := m_nNewItemIndex;
            Inc(m_nNewItemIndex);
          end;

      for I := Low(HumData.Data.StorageItems) to High(HumData.Data.StorageItems) do
        with HumData.Data.StorageItems[I] do
        if wIndex > 0 then
          begin
            MakeIndex := m_nNewItemIndex;
            Inc(m_nNewItemIndex);
          end;

      FileSeek(f_MainMirH, Sizeof(THumDBHeader) + Sizeof(HumData) * m_nCurPostion, 0);
      FileWrite(f_MainMirH, HumData, Sizeof(HumData));
      Inc(m_nTotalPostion);
      Inc(m_nCurPostion);
      {$IF THREADWORK}if Self.Terminated then Break;
      {$ELSE}
        if g_Terminated then Break;
        Application.ProcessMessages;
      {$IFEND}
    end;
  m_sCurMessage := 'µƷŴ 10000000 ʼ  ' + IntToStr(m_nNewItemIndex);
  {$IF THREADWORK}Synchronize({$IFEND}OutMessage{$IF THREADWORK}){$IFEND};
end;

{$IF not THREADWORK}
procedure TMainWorkThread.Run;
begin
  g_Terminated  := False;
  Execute;
end;
{$IFEND}

procedure TMainWorkThread.SaveIDChangeList;
var
  I, J: Integer;
  SL  : TStrings;
begin
  SL  := TStringList.Create;
  for J := Low(IDChangedLists) to High(IDChangedLists) do
    for I := 0 to IDChangedLists[J].Count - 1 do
      begin
        SL.Add('"' + IDOldLists[J].Strings[I] + '"' + #9#9#9 + '"' + IDChangedLists[J].Strings[I] + '"');
      end;
  (SL as TStringList).Sort;
  SL.SaveToFile(ExtRactFilePath(Application.ExeName) + 'ID.txt');
  SL.Free;
end;

procedure TMainWorkThread.SaveNameChangeList;
var
  I: Integer;
  SL  : TStrings;
begin
  SL  := TStringList.Create;
  for I := 0 to NameChangedList.Count - 1 do
    begin
      SL.Add('"' + NameOldList.Strings[I] + '"' + #9#9#9 + '"' + NameChangedList.Strings[I] + '"');
    end;
  (SL as TStringList).Sort;
  SL.SaveToFile(ExtRactFilePath(Application.ExeName) + 'ֱ.txt');
  SL.Free;
end;

procedure TMainWorkThread.SetWorkRoots(const SL: TStrings);
begin
  m_WorkRoots := SL;
end;

end.
