unit fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    ListBox1: TListBox;
    PopupMenu1: TPopupMenu;
    D1: TMenuItem;
    C1: TMenuItem;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    Label4: TLabel;
    N1: TMenuItem;
    A1: TMenuItem;
    Label5: TLabel;
    Label6: TLabel;
    procedure D1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure ShowInformation(const smsg: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UnitMainWork, FileCtrl;

{$R *.dfm}

const
  g_InforTimerId  = 2001;

procedure GetWorkInformations;
begin
  if not Assigned(MainWorkThread) then Exit;
  Form1.ProgressBar1.Max        := MainWorkThread.m_nTotalMax;
  Form1.ProgressBar1.Position   := MainWorkThread.m_nTotalPostion;
  Form1.ProgressBar2.Max        := MainWorkThread.m_nCurMax;
  Form1.ProgressBar2.Position   := MainWorkThread.m_nCurPostion;
  Form1.Label3.Caption          := MainWorkThread.m_sWorkingFor;
  Form1.Label4.Caption          := IntToStr(MainWorkThread.m_nTotalPostion) + '/' + IntToStr(MainWorkThread.m_nTotalMax);
  Form1.Label5.Caption          := 'ʧ:' + IntToStr(MainWorkThread.m_nFailed);
  Form1.Label6.Caption          := IntToStr(MainWorkThread.m_nCurPostion) + '/' + IntToStr(MainWorkThread.m_nCurMax);
  
end;

procedure TForm1.D1Click(Sender: TObject);
begin
  ListBox1.DeleteSelected;
end;

procedure TForm1.C1Click(Sender: TObject);
begin
  ListBox1.Clear;
end;

procedure TForm1.ShowInformation(const smsg: string);
begin
  Memo1.Lines.Add(smsg);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MainOutInforProc  := Self.ShowInformation;
  SetTimer(Application.Handle, g_InforTimerId, 10, @GetWorkInformations);
end;

procedure TForm1.A1Click(Sender: TObject);
var
  s: string;
begin
  if SelectDirectory('ѡ·...', '', S) then
    ListBox1.Items.Add(S);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  s: string;
begin
  if SelectDirectory('ѡ·...', '', S) then
    Edit1.Text  := S;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  KillTimer(Application.Handle, g_InforTimerId);
  if MainWorkThread <> nil then
    begin
      {$IF THREADWORK}
      MainWorkThread.FreeOnTerminate  := True;
      MainWorkThread.Terminate;
      {$ELSE}
        g_Terminated  := True;
        MainWorkThread.Free;
      {$IFEND}
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Application.MessageBox('ǷȷѾԭݱݲ׼˺Ҫļʼϲ',
                                'ʾ',
                                mb_YESNO + mb_IconQuestion) = ID_NO then Exit;
  if MainWorkThread = nil then
    MainWorkThread := TMainWorkThread.Create(True);
  MainWorkThread.m_sMainRoot  := Edit1.Text;
  MainWorkThread.SetWorkRoots(ListBox1.Items);
  Button3.Enabled := False;
  Button1.Enabled := True;
  Button2.Enabled := True;
  {$IF THREADWORK}
  MainWorkThread.Resume;
  {$ELSE}
  MainWorkThread.Run;
  {$IFEND}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
{$IF THREADWORK}
  if MainWorkThread <> nil then
    begin
      if MainWorkThread.Suspended then
        begin
         MainWorkThread.Resume;
         Button1.Caption  := 'ͣ(&P)';
        end
        else begin
         MainWorkThread.Suspend;
         Button1.Caption  := 'ָ(&R)';
        end;
    end;
{$IFEND}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if MainWorkThread <> nil then
    begin
      {$IF THREADWORK}
      MainWorkThread.Terminate;
      {$ELSE}
      g_Terminated  := True;
      {$IFEND}
      MainWorkThread.Free;
      MainWorkThread  := nil;
      Button3.Enabled := True;
      Button1.Enabled := False;
      Button2.Enabled := False;
    end;
end;

end.
