unit ObjNpc;

interface
uses
  Windows, Classes, SysUtils, StrUtils, IniFiles,
  SList,
  ObjBase, MirGrobal,SerGrobal,
  TyFunc,
  M2Type, SDK;
type
  TUpgradeInfo = record //0x40
    sUserName: string[14]; //0x00
    UserItem: TUserItem; //0x10
    btDc: Byte; //0x28
    btSc: Byte; //0x29
    btMc: Byte; //0x2A
    btDura: Byte; //0x2B
    n2C: Integer;
    dtTime: TDateTime; //0x30
    dwGetBackTick: LongWord; //0x38
    //n3C: Integer;
  end;
  pTUpgradeInfo = ^TUpgradeInfo;
  TItemPrice = record
    wIndex: Word;
    nPrice: Integer;
  end;
  pTItemPrice = ^TItemPrice;
  TGoods = record //0x1C
    sItemName: string[14];
    nCount: Integer;
    dwRefillTime: LongWord;
    dwRefillTick: LongWord;
  end;
  pTGoods = ^TGoods;

  TSellItemPrice = record
    wIndex: Word;
    nPrice: Integer;
  end;
  pTSellItemPrice = ^TSellItemPrice;

  TQuestActionInfo = record
    nCMDCode: Integer;
    sParam1: string;
    nParam1: Integer;
    sParam2: string;
    nParam2: Integer;
    sParam3: string;
    nParam3: Integer;
    sParam4: string;
    nParam4: Integer;
    sParam5: string;
    nParam5: Integer;
    sParam6: string;
    nParam6: Integer;
  end;
  pTQuestActionInfo = ^TQuestActionInfo;
  TQuestConditionInfo = record //0x14
    nCMDCode: Integer; //0x00
    sParam1: string; //0x04
    nParam1: Integer; //0x08
    sParam2: string; //0x0C
    nParam2: Integer; //0x10
    sParam3: string;
    nParam3: Integer;
    sParam4: string;
    nParam4: Integer;
    sParam5: string;
    nParam5: Integer;
    sParam6: string;
    nParam6: Integer;
  end;
  pTQuestConditionInfo = ^TQuestConditionInfo;
  TSayingProcedure = record //0x14
    ConditionList: TList; //0x00
    ActionList: TList; //0x04
    sSayMsg: string; //0x08
    ElseActionList: TList; //0x0C
    sElseSayMsg: string; //0x10
  end;
  pTSayingProcedure = ^TSayingProcedure;
  TSayingRecord = record //0x08
    sLabel: string;
    ProcedureList: TList; //0x04
    boExtJmp: Boolean; //Ƿⲿת
  end;
  pTSayingRecord = ^TSayingRecord;
  TNormNpc = class(TAnimalObject) //0x564

    m_nNPCFlag: ShortInt; //0x550 //ڱʶNPCǷЧ¼NPCб(-1 ΪЧ)
    m_ScriptList: TSimpleList; //0x554
    m_sFilePath: string; //0x558 űļĿ¼
    m_boIsHide: Boolean; //0x55C NPCǷصģʾڵͼ
    m_boIsQuest: Boolean; //0x55D NPCΪͼ͵ģؽűʱĽűļΪ ɫ-ͼ.txt
    m_sPath: string; //0x560
    m_btNpcAutoChangeColorMode: Byte;
    m_dwNpcAutoChangeColorTick: LongWord;
    m_dwNpcAutoChangeColorTime: LongWord;
    m_nNpcAutoChangeIdx: Integer;

  private
    function GetHumanInfoValue(PlayObject: TPlayObject;sVariable: string; var sValue: string): Boolean;
    procedure ScriptActionError(PlayObject: TPlayObject; sErrMsg: string; QuestActionInfo: pTQuestActionInfo; sCmd: string);
    procedure ScriptConditionError(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo; sCmd: string);

    procedure ExeAction(PlayObject: TPlayObject; sParam1, sParam2, sParam3: string; nParam1, nParam2, nParam3: Integer);

    procedure ActionOfChangeLevel(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMarry(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMaster(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfUnMarry(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfUnMaster(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGiveItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfGetMarry(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGetMaster(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearSkill(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDelNoJobSkill(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDelSkill(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfAddSkill(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSkillLevel(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangePkPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeExp(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeCreditPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeJob(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfRecallGroupMembers(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearNameList(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMission(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMobPlace(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo; nX, nY, nCount, nRange: Integer);
    procedure ActionOfSetMemberType(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSetMemberLevel(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfHUEICHENGCOUNT(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSueiJiCount(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGameGold(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGamePoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfChangeHairStyle(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfLineMsg(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeNameColor(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearPassword(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfReNewLevel(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeGender(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfKillSlave(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfKillMonExpRate(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfPowerRate(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeMode(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangePerMission(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfKill(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfKick(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfBonusPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfRestReNewLevel(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDelMarry(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDelMaster(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearNeedItems(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearMakeItems(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfUpgradeItems(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfUpgradeItemsEx(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMonGenEx(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfClearMapMon(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    //лԱ
    procedure ActionOfAddGuildMember(PlayObject: TPlayObject;QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfChangeSlaveName(PlayObject: TPlayObject;QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfSetMapMode(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfPkZone(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfRestBonusPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfTakeCastleGold(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfHumanHP(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfHumanMP(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGuildBuildPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGuildAuraePoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGuildstabilityPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGuildFlourishPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfOpenMagicBox(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSetRankLevelName(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGmExecute(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfGuildChiefItemCount(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfAddNameDateList(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDelNameDateList(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMobFireBurn(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfMessageBox(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfAutoGetExp(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfRecallmob(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfVar(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfLoadVar(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSaveVar(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfCalcVar(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfNotLineAddPiont(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfCommendGameGold(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfStartTakeGold(PlayObject: TPlayObject);

    procedure ActionOfAnsiReplaceText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfEncodeText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfDecodeText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfUseBonusPoint(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    procedure ActionOfRepairItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfTakeOnItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfTakeOffItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);


    //ȥǶȥĶ
    procedure ActionOfUnInlayItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    //ˢװ
    procedure ActionOfThrowItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
    procedure ActionOfSendTimeMsg(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);

    //ַǷıĵ
    function CheckStringList(sHumName, sListFileName: string): Boolean;
    //
    function CheckVarNameNo(PlayObject: TPlayObject;CheckQuestConditionInfo: pTQuestConditionInfo; var n140, n180: Integer): Boolean;
    function ConditionOfCheckGroupCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseDir(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseLevel(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseGender(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseMarry(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckLevelEx(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSlaveCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckBonusPoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckAccountIPList(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckNameIPList(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMarry(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMarryCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfHaveMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfPoseHaveMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;

    function ConditionOfCheckIsMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPoseIsMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckHaveGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsGuildMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsCastleaGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsCastleMaster(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMemberType(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMemBerLevel(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckGameGold(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckGamePoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckNameListPostion(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckGuildList(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckReNewLevel(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSlaveLevel(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSlaveName(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;


    function ConditionOfCheckCreditPoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckOfGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPayMent(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckUseItem(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckBagSize(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckListCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckDC(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMC(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSC(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckHP(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMP(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckItemType(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckExp(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckCastleGold(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckPasswordErrorCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfIsLockPassword(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfIsLockStorage(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckGuildBuildPoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckGuildAuraePoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckStabilityPoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckFlourishPoint(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckContribution(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckRangeMonCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckItemAddValue(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckInMapRange(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsAttackGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsDefenseGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckCastleDoorStatus(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsAttackAllyGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckIsDefenseAllyGuild(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckCastleChageDay(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckCastleWarDay(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckOnlineLongMin(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckChiefItemCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckNameDateList(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMapHumanCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMapMonCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckVar(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckServerName(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    //Ƿ
    function ConditionOfCheckOnline(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckMapName(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSafeZone(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCheckSkill(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;

    function GetDynamicVarList(PlayObject: TPlayObject; sType: string; var sName: string): TSimpleList;

    function ConditionOfGetValValue(PlayObject: TPlayObject; sMsg: string; var sValue: string): Boolean; overload;
    function ConditionOfGetValValue(PlayObject: TPlayObject; sMsg: string; var nValue: Integer): Boolean; overload;

    function ConditionOfAnsiContainsText(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
    function ConditionOfCompareText(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;


    function ConditionOfCheckMonMapCount(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
  public
    constructor Create(); override;
    destructor Destroy; override;
    procedure Initialize(); override;
    function Operate(ProcessMsg: pTProcessMessage): Boolean; override;
    procedure Run; override;
    function HasModeSell(SellMode: TSellMode): Boolean; virtual;
    function HasModeBuy(BuyMode: TBuyMode): Boolean; virtual;
    procedure Click(PlayObject: TPlayObject); virtual;
    procedure UserSelect(PlayObject: TPlayObject; sData: string); virtual;
    procedure GetVariableText(PlayObject: TPlayObject; var sMsg: string; sVariable: string); virtual; //FFE9
    function GetLineVariableText(PlayObject: TPlayObject; sMsg: string): string;
    procedure GotoLable(PlayObject: TPlayObject; sLabel: string; boExtJmp: Boolean;IsAction:Boolean = False);
    function sub_49ADB8(sMsg, sStr, sText: string): string;
    procedure LoadScript();  
    procedure ClearScript(); virtual;
    procedure AddMsgToUser(PlayObject: TPlayObject; sMsg: string);
  end;
  TMerchant = class(TNormNpc) //0x594
    m_sScriptFileName: string; //0x568
    m_nPriceRate: Integer; //0x570   Ʒ۸ ĬΪ 100%
    bo574: Boolean;
    m_boCastle: Boolean; //0x575
    dwRefillGoodsTick: LongWord; //0x578
    dwClearExpreUpgradeTick: LongWord; //0x57C
    m_ItemTypeList: TSimpleList; //0x580  NPCƷбűǰ +1 +30 ֮
    m_RefillGoodsList: TSimpleList; //0x584

    m_ItemPriceList: TSimpleList; //0x58C

    m_UpgradeWeaponList: TSimpleList;
    m_boCanMove: Boolean;
    m_dwMoveTime: LongWord;
    m_dwMoveTick: LongWord;
    m_boBuy: Boolean;
    m_boSell: Boolean;
    m_boPrices: Boolean;
    m_boStorage: Boolean;
    m_boGetback: Boolean;
    m_boBigStorage: Boolean;
    m_boBigGetback: Boolean;
    m_boUpgradenow: Boolean;
    m_boGetBackupgnow: Boolean;
    m_boRepair: Boolean;
    m_boS_repair: Boolean;
    m_boGetMarry: Boolean;
    m_boGetMaster: Boolean;
    m_boUseItemName: Boolean;
    m_boHoleItem: Boolean;
    m_boUpItem: Boolean;
  private
    m_GoodsList: TSimpleList; //0x588
    procedure ClearExpreUpgradeListData();

    function GetRefillList(nIndex: Integer): TSimpleList;
    procedure AddItemPrice(nIndex, nPrice: Integer);


    function AddItemToGoodsList(UserItem: pTUserItem): Boolean;
    procedure GetBackupgWeapon(User: TPlayObject);
    procedure UpgradeWapon(User: TPlayObject);
    procedure ChangeUseItemName(PlayObject: TPlayObject; sLabel, sItemName: string);
    procedure SaveUpgradingList;
    procedure GetMarry(PlayObject: TPlayObject; sDearName: string);
    procedure GetMaster(PlayObject: TPlayObject; sMasterName: string);

  public
    constructor Create(); override;
    destructor Destroy; override;
    function HasModeSell(SellMode: TSellMode): Boolean; override;
    function HasModeBuy(BuyMode: TBuyMode): Boolean; override;
    function GetOpenHolePrice(UserItem: pTUserItem): Integer;
    function GetItemPrice(nIndex: Integer): Integer;
    function GetUserPrice(PlayObject: TPlayObject; nPrice: Integer): Integer;
    function CheckItemType(nStdMode: Integer): Boolean;
    procedure CheckItemPrice(nIndex: Integer);
    function GetUserItemPrice(UserItem: pTUserItem): Integer;


    function Operate(ProcessMsg: pTProcessMessage): Boolean; override;
    procedure Run; override;
    procedure UserSelect(PlayObject: TPlayObject; sData: string); override;
    procedure LoadNPCData();
    procedure LoadUpgradeList();
    procedure RefillGoods();
    procedure LoadScript();  
    procedure Click(PlayObject: TPlayObject); override;
    procedure ClearScript(); override;
    procedure ClearData();
    procedure GetVariableText(PlayObject: TPlayObject; var sMsg: string; sVariable: string); override; //FFE9
    procedure ClientBuyItem(PlayObject: TPlayObject; sItemName: string; MakeIndex: Integer);

    procedure ClientGetDetailGoodsList(PlayObject: TPlayObject; sItemName: string);

    function ClientQuerySellPrice(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
    function ClientSellItem(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
    function QueryRepairCost(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
    function RepairItem(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
    procedure SendInPutS(PlayObject: TPlayObject; sMsg,spos: string);
    procedure SendInPutI(PlayObject: TPlayObject; sMsg,spos: string);
    function OpenHoleItem(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
    function ItemUp(PlayObject: TPlayObject; DesItem: pTUserItem; KS, BS, JLS: Integer): Integer;

  end;
  TGuildOfficial = class(TNormNpc) //0x568
  private
    function ReQuestBuildGuild(PlayObject: TPlayObject;
      sGuildName: string): Integer;
    function ReQuestGuildWar(PlayObject: TPlayObject;
      sGuildName: string): Integer;
    procedure ReQuestCastleWar(PlayObject: TPlayObject; sIndex: string);
  public
    constructor Create(); override;
    destructor Destroy; override;
    procedure GetVariableText(PlayObject: TPlayObject; var sMsg: string; sVariable: string); override; //FFE9
    procedure Run; override; //FFFB
    procedure Click(PlayObject: TPlayObject); override; //FFEB
    procedure UserSelect(PlayObject: TPlayObject; sData: string); override; //FFEA
  end;
  TTrainer = class(TNormNpc) //0x574
    n564: Integer;
    m_dw568: LongWord;
    n56C: Integer;
    n570: Integer;
  private
  public
    constructor Create(); override;
    destructor Destroy; override;
    function Operate(ProcessMsg: pTProcessMessage): Boolean; override; //FFFC
    procedure Run; override;
  end;
  //  TCastleManager = class(TMerchant)
  TCastleOfficial = class(TMerchant)
  private
    procedure HireArcher(sIndex: string; PlayObject: TPlayObject);
    procedure HireGuard(sIndex: string; PlayObject: TPlayObject);
    procedure RepairDoor(PlayObject: TPlayObject);
    procedure RepairWallNow(nWallIndex: Integer; PlayObject: TPlayObject);
  public
    constructor Create(); override;
    destructor Destroy; override;
    procedure Click(PlayObject: TPlayObject); override; //FFEB
    procedure UserSelect(PlayObject: TPlayObject; sData: string); override; //FFEA
    procedure GetVariableText(PlayObject: TPlayObject; var sMsg: string; sVariable: string); override; //FFE9
  end;
implementation

uses Castle, M2Config, M2Share, HUtil32, LocalDB, GameMap, Guild, EDcode, ObjMon2,
  Event, ObjPlayMon,svMain;

procedure TCastleOfficial.Click(PlayObject: TPlayObject); //004A4588
begin
  if m_Castle = nil then begin
    PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
    Exit;
  end;
  if TUserCastle(m_Castle).IsMasterGuild(TGUild(PlayObject.m_MyGuild)) or (PlayObject.m_btPermission >= 3) then
    inherited;
end;

procedure TCastleOfficial.GetVariableText(PlayObject: TPlayObject;
  var sMsg: string; sVariable: string);
var
  i: Integer;
  sText: string;
  CastleDoor: TCastleDoor;
  List: TStringList;
begin
  inherited;
  if m_Castle = nil then begin
    sMsg := '????';
    Exit;
  end;
  if sVariable = '$CASTLEGOLD' then begin
    sText := IntToStr(TUserCastle(m_Castle).m_nTotalGold);
    sMsg := sub_49ADB8(sMsg, '<$CASTLEGOLD>', sText);
  end else
    if sVariable = '$TODAYINCOME' then begin
      sText := IntToStr(TUserCastle(m_Castle).m_nTodayIncome);
      sMsg := sub_49ADB8(sMsg, '<$TODAYINCOME>', sText);
    end else
      if sVariable = '$CASTLEDOORSTATE' then begin
        CastleDoor := TCastleDoor(TUserCastle(m_Castle).m_MainDoor.BaseObject);
        if CastleDoor.m_boDeath then sText := ''
        else if CastleDoor.m_boOpened then sText := ''
        else sText := 'ر';
        sMsg := sub_49ADB8(sMsg, '<$CASTLEDOORSTATE>', sText);
      end else
        if sVariable = '$REPAIRDOORGOLD' then begin
          sText := IntToStr(g_Config.nRepairDoorPrice);
          sMsg := sub_49ADB8(sMsg, '<$REPAIRDOORGOLD>', sText);
        end else
          if sVariable = '$REPAIRWALLGOLD' then begin
            sText := IntToStr(g_Config.nRepairWallPrice);
            sMsg := sub_49ADB8(sMsg, '<$REPAIRWALLGOLD>', sText);
          end else
            if sVariable = '$GUARDFEE' then begin
              sText := IntToStr(g_Config.nHireGuardPrice);
              sMsg := sub_49ADB8(sMsg, '<$GUARDFEE>', sText);
            end else
              if sVariable = '$ARCHERFEE' then begin
                sText := IntToStr(g_Config.nHireArcherPrice);
                sMsg := sub_49ADB8(sMsg, '<$ARCHERFEE>', sText);
              end else
                if sVariable = '$GUARDRULE' then begin
                  sText := 'Ч';
                  sMsg := sub_49ADB8(sMsg, '<$GUARDRULE>', sText);
                end;
end;

procedure TCastleOfficial.UserSelect(PlayObject: TPlayObject; sData: string);
var
  s18, s20, sMsg, sLabel: string;
  boCanJmp: Boolean;
const
  sExceptionMsg = '[쳣!!] TCastleManager::UserSelect... ';
begin
  inherited;
  try
    //    PlayObject.m_nScriptGotoCount:=0;
    if m_Castle = nil then begin
      PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
      Exit;
    end;
    if (sData <> '') and (sData[1] = '@') then begin
      sMsg := GetValidStr3(sData, sLabel, [#13]);
      s18 := '';
      PlayObject.m_sScriptLable := sData;
      if TUserCastle(m_Castle).IsMasterGuild(TGUild(PlayObject.m_MyGuild)) and (PlayObject.IsGuildMaster) then begin
        boCanJmp := PlayObject.LableIsCanJmp(sLabel);
        GotoLable(PlayObject, sLabel, not boCanJmp);
        //GotoLable(PlayObject,sLabel,not PlayObject.LableIsCanJmp(sLabel));
        if not boCanJmp then Exit;
          if CompareText(sLabel, sCASTLENAME) = 0 then begin
            sMsg := Trim(sMsg);
            if sMsg <> '' then begin
              TUserCastle(m_Castle).m_sName := sMsg;
              TUserCastle(m_Castle).Save;
              TUserCastle(m_Castle).m_MasterGuild.RefMemberName;
              s18 := 'ǱƸĳɹ...';
            end else begin
              s18 := 'ǱƸʧܣ';
            end;
            PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, s18);
          end else
            if CompareText(sLabel, sWITHDRAWAL) = 0 then begin
              case TUserCastle(m_Castle).WithDrawalGolds(PlayObject, Str_ToInt(sMsg, 0)) of
                -4: s18 := 'Ľȷ';
                -3: s18 := '޷ЯĶˡ';
                -2: s18 := 'óûô.';
                -1: s18 := 'ֻл ' + TUserCastle(m_Castle).m_sOwnGuild + ' ˲ʹã';
                1: GotoLable(PlayObject, sMAIN, False);
              end;
              PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, s18);
            end else
              if CompareText(sLabel, sRECEIPTS) = 0 then begin
                case TUserCastle(m_Castle).ReceiptGolds(PlayObject, Str_ToInt(sMsg, 0)) of
                  -4: s18 := 'Ľȷ';
                  -3: s18 := 'ѾﵽڳڴŻˡ';
                  -2: s18 := 'ûô.';
                  -1: s18 := 'ֻл ' + TUserCastle(m_Castle).m_sOwnGuild + ' ˲ʹã';
                  1: GotoLable(PlayObject, sMAIN, False);
                end;
                PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, s18);
              end else
                if CompareText(sLabel, sOPENMAINDOOR) = 0 then begin
                  TUserCastle(m_Castle).MainDoorControl(False);
                end else
                  if CompareText(sLabel, sCLOSEMAINDOOR) = 0 then begin
                    TUserCastle(m_Castle).MainDoorControl(True);
                  end else
                    if CompareText(sLabel, sREPAIRDOORNOW) = 0 then begin
                      RepairDoor(PlayObject);
                      GotoLable(PlayObject, sMAIN, False);
                    end else
                      if CompareText(sLabel, sREPAIRWALLNOW1) = 0 then begin
                        RepairWallNow(1, PlayObject);
                        GotoLable(PlayObject, sMAIN, False);
                      end else
                        if CompareText(sLabel, sREPAIRWALLNOW2) = 0 then begin
                          RepairWallNow(2, PlayObject);
                          GotoLable(PlayObject, sMAIN, False);
                        end else
                          if CompareText(sLabel, sREPAIRWALLNOW3) = 0 then begin
                            RepairWallNow(3, PlayObject);
                            GotoLable(PlayObject, sMAIN, False);
                          end else
                            if CompareLStr(sLabel, sHIREGUARDNOW, Length(sHIREGUARDNOW)) then begin
                              s20 := Copy(sLabel, Length(sHIREGUARDNOW) + 1, Length(sLabel));
                              HireGuard(s20, PlayObject);
                              PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, '');
          //GotoLable(PlayObject,sHIREGUARDOK,False);
                            end else
                              if CompareLStr(sLabel, sHIREARCHERNOW, Length(sHIREARCHERNOW)) then begin
                                s20 := Copy(sLabel, Length(sHIREARCHERNOW) + 1, Length(sLabel));
                                HireArcher(s20, PlayObject);
                                PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, '');
                              end else
                                if CompareText(sLabel, sEXIT) = 0 then begin
                                  PlayObject.AddAction(Self, RM_MERCHANTDLGCLOSE, 0, Integer(Self), 0, 0, '');
                                end else
                                  if CompareText(sLabel, sBACK) = 0 then begin
                                    if PlayObject.m_sScriptGoBackLable = '' then PlayObject.m_sScriptGoBackLable := sMAIN;
                                    GotoLable(PlayObject, PlayObject.m_sScriptGoBackLable, False);
                                  end;
      end else begin
        s18 := 'ûȨʹ';
        PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(Self), 0, 0, s18);
      end;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
  //  inherited;
end;

procedure TCastleOfficial.HireGuard(sIndex: string; PlayObject: TPlayObject);
var
  n10: Integer;
  ObjUnit: pTObjUnit;
begin
  if m_Castle = nil then begin
    PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
    Exit;
  end;
  if TUserCastle(m_Castle).m_nTotalGold >= g_Config.nHireGuardPrice then begin
    n10 := Str_ToInt(sIndex, 0) - 1;
    if n10 <= MAXCALSTEGUARD then begin
      if TUserCastle(m_Castle).m_Guard[n10].BaseObject = nil then begin
        if not TUserCastle(m_Castle).m_boUnderWar then begin
          ObjUnit := @TUserCastle(m_Castle).m_Guard[n10];
          ObjUnit.BaseObject := UserEngine.RegenMonsterByName(TUserCastle(m_Castle).m_sMapName,
            ObjUnit.nX,
            ObjUnit.nY,
            ObjUnit.sName);
          if ObjUnit.BaseObject <> nil then begin
            Dec(TUserCastle(m_Castle).m_nTotalGold, g_Config.nHireGuardPrice);
            ObjUnit.BaseObject.m_Castle := TUserCastle(m_Castle);
            TGuardUnit(ObjUnit.BaseObject).m_nX550 := ObjUnit.nX;
            TGuardUnit(ObjUnit.BaseObject).m_nY554 := ObjUnit.nY;
            TGuardUnit(ObjUnit.BaseObject).m_nDirection := 3;
            PlayObject.SysMsg('Ӷɹ.', c_Green, t_Hint);
          end else PlayObject.SysMsg('ӶʧϵϷ...', c_Green, t_Hint);
        end else begin
          PlayObject.SysMsg('޷Ӷ', c_Red, t_Hint);
        end;
      end
    end else begin
      PlayObject.SysMsg('ָ󣡣', c_Red, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡', c_Red, t_Hint);
  end;
end;

procedure TCastleOfficial.HireArcher(sIndex: string; PlayObject: TPlayObject);
var
  n10: Integer;
  ObjUnit: pTObjUnit;
begin
  if m_Castle = nil then begin
    PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
    Exit;
  end;
  if TUserCastle(m_Castle).m_nTotalGold >= g_Config.nHireArcherPrice then begin
    n10 := Str_ToInt(sIndex, 0) - 1;
    if n10 <= MAXCASTLEARCHER then begin
      if TUserCastle(m_Castle).m_Archer[n10].BaseObject = nil then begin
        if not TUserCastle(m_Castle).m_boUnderWar then begin
          ObjUnit := @TUserCastle(m_Castle).m_Archer[n10];
          ObjUnit.BaseObject := UserEngine.RegenMonsterByName(TUserCastle(m_Castle).m_sMapName,
            ObjUnit.nX,
            ObjUnit.nY,
            ObjUnit.sName);
          if ObjUnit.BaseObject <> nil then begin
            Dec(TUserCastle(m_Castle).m_nTotalGold, g_Config.nHireArcherPrice);
            ObjUnit.BaseObject.m_Castle := TUserCastle(m_Castle);
            TGuardUnit(ObjUnit.BaseObject).m_nX550 := ObjUnit.nX;
            TGuardUnit(ObjUnit.BaseObject).m_nY554 := ObjUnit.nY;
            TGuardUnit(ObjUnit.BaseObject).m_nDirection := 3;
            PlayObject.SysMsg('Ӷɹ.', c_Green, t_Hint);
          end else  PlayObject.SysMsg('ӶʧϵϷ...', c_Green, t_Hint);
        end else begin
          PlayObject.SysMsg('޷Ӷ', c_Red, t_Hint);
        end;
      end else begin
        PlayObject.SysMsg('ѹӶ', c_Red, t_Hint);
      end;
    end else begin
      PlayObject.SysMsg('ָ󣡣', c_Red, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡', c_Red, t_Hint);
  end;
end;
{ TMerchant }

function TMerchant.HasModeSell(SellMode: TSellMode): Boolean;
begin
  Result := True;
  case SellMode of
    smSell: Result := m_boSell;
    //smUNItem: Result :=m_boUnItem;
    smRepair: Result := m_boRepair;
    smStorage: Result := m_boStorage;
    smBigStorage: Result := m_boBigStorage;
    smOpenHole: Result := m_boHoleItem;
    smItemUp: Result := m_boUpItem;
  end
end;

function TNormNpc.HasModeSell(SellMode: TSellMode): Boolean;
begin
  Result := True;
end;

function TMerchant.HasModeBuy(BuyMode: TBuyMode): Boolean;
begin
  Result := True;
  case BuyMode of
    bmBuy: Result := m_boBuy;
    bmGetBack: Result := m_boGetback;
    bmBigGetBack: Result := m_boBigGetback;
  end
end;

function TNormNpc.HasModeBuy(BuyMode: TBuyMode): Boolean;
begin
  Result := True;
end;

procedure TMerchant.AddItemPrice(nIndex: Integer; nPrice: Integer);
var
  ItemPrice: pTItemPrice;
begin
  New(ItemPrice);
  ItemPrice.wIndex := nIndex;
  ItemPrice.nPrice := nPrice;
  m_ItemPriceList.Add(ItemPrice);
end;

procedure TMerchant.CheckItemPrice(nIndex: Integer);
var
  i: Integer;
  ItemPrice: pTItemPrice;
  n10: Integer;
  StdItem: pTStdItem;
begin
  
  for i := 0 to m_ItemPriceList.Count - 1 do begin
    ItemPrice := m_ItemPriceList.Items[i];
    if ItemPrice = nil then Continue;
    if ItemPrice.wIndex = nIndex then begin
      {n10 ֻдû
      n10 := ItemPrice.nPrice;
      if ROUND(n10 * 1.1) > n10 then begin
        n10 := ROUND(n10 * 1.1);
      end else Inc(n10); }
      Exit;
    end;
  end;  
  StdItem := UserEngine.GetStdItem(nIndex);
  if StdItem <> nil then begin
    AddItemPrice(nIndex, ROUND(StdItem.Price * 1.1));
  end;
end;

function TMerchant.GetRefillList(nIndex: Integer): TSimpleList;
var
  i: Integer;
  List: TSimpleList;
begin
  Result := nil;
  if nIndex <= 0 then Exit;
  for i := 0 to m_GoodsList.Count - 1 do begin
    List := TSimpleList(m_GoodsList.Items[i]);
    if List = nil then Continue;
    if (List.Count > 0)then begin
      if pTUserItem(List.Items[0]).wIndex = nIndex then begin
        Result := List;
        break;
      end;
    end;
  end;
end;
//ţ BXX 
procedure TMerchant.SendInPutS(PlayObject: TPlayObject; sMsg,spos: string);
var
  NiouBXXJiaoBen:pTScript;
  ActionInfo:pTQuestActionInfo;
  label lOut;
begin
  if (sMsg <> '') and (sMsg[1] ='<') then
  ArrestStringEx(sMsg, '<', '>', sMsg);
  New(NiouBXXJiaoBen);
  New(ActionInfo);
  try
    FillChar(NiouBXXJiaoBen^,SizeOf(TScript),0);
    FillChar(ActionInfo^,SizeOf(TQuestActionInfo),0);
    NiouBXXJiaoBen.RecordList := TList.Create;
    ActionInfo.nCMDCode := nMOV;
    ActionInfo.sParam1 :=  spos;//Ŀ
    // Ŀ Զ
    if IsVarNumber(spos) then begin
      ActionInfo.sParam3 := sMsg;
    end else begin
      if GetValNameNo(spos) < 600 then begin
        MainOutMessage(Self.m_sCharName+'::ַ!!!Ŀ:'+spos+'ַͱ...');
        goto lOut;
      end else begin
        ActionInfo.sParam2 := sMsg;
      end;
    end;
    NiouBXXJiaoBen.RecordList.Add(ActionInfo);
    PlayObject.m_Script:= NiouBXXJiaoBen;
    GotoLable(PlayObject,'',False,True);
    lOut:
    if PlayObject.m_Script = nil then
      GotoLable(PlayObject,'@PutOk'+spos,False)
    else
      GotoLable(PlayObject,'@PutFail'+spos,False);
    PlayObject.m_Script := nil;
  finally
    NiouBXXJiaoBen.RecordList.Free;
    Dispose(NiouBXXJiaoBen);
    Dispose(ActionInfo);
  end;
end;
procedure TMerchant.SendInPutI(PlayObject: TPlayObject; sMsg,spos: string);
var
  NiouBXXJiaoBen:pTScript;
  ActionInfo:pTQuestActionInfo;
  label lOut;
begin
  if (sMsg <> '') and (sMsg[1] ='<') then
  ArrestStringEx(sMsg, '<', '>', sMsg);
  if not IsStringNumber(sMsg)  then begin
    GotoLable(PlayObject,'@PutFail'+spos,False);
    Exit;
  end;
  New(NiouBXXJiaoBen);
  New(ActionInfo);
  try
    FillChar(NiouBXXJiaoBen^,SizeOf(TScript),0);
    FillChar(ActionInfo^,SizeOf(TQuestActionInfo),0);
    NiouBXXJiaoBen.RecordList := TList.Create;
    ActionInfo.nCMDCode := nMOV;
    ActionInfo.sParam1 :=  spos;//Ŀ
    // Ŀ Զ
    if IsVarNumber(spos) then begin
      ActionInfo.sParam3 := sMsg;
      ActionInfo.nParam3 := Str_ToInt(sMsg,0);
    end else begin
      if GetValNameNo(spos) >= 600 then begin
        MainOutMessage(Self.m_sCharName+'::!!!Ŀ:'+spos+'ͱ...');
        goto lOut;
      end else begin
        ActionInfo.sParam2 := sMsg;
        ActionInfo.nParam2 := Str_ToInt(sMsg,0);
      end;
    end;
    NiouBXXJiaoBen.RecordList.Add(ActionInfo);
    PlayObject.m_Script:= NiouBXXJiaoBen;
    GotoLable(PlayObject,'',False,True);
    lOut:
    if PlayObject.m_Script = nil then
      GotoLable(PlayObject,'@PutOk'+spos,False)
    else
      GotoLable(PlayObject,'@PutFail'+spos,False);
    PlayObject.m_Script := nil;
  finally

    NiouBXXJiaoBen.RecordList.Free;
    Dispose(NiouBXXJiaoBen);
    Dispose(ActionInfo);
  end;

end;
procedure TMerchant.RefillGoods;
  procedure RefillItems(var List: TSimpleList; sItemName: string; nInt: Integer);
  var
    i: Integer;
    UserItem: pTUserItem;
  begin
    if List = nil then begin
      List := TSimpleList.Create;
      m_GoodsList.Add(List);
    end;
    for i := 0 to nInt - 1 do begin
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(sItemName, UserItem) then begin
        List.Add(UserItem);
      end else DisPose(UserItem);
    end;
  end;
  procedure DelReFillItem(var List: TSimpleList; nInt: Integer);
  var
    i: Integer;
  begin
    for i := List.Count - 1 downto 0 do begin
      if nInt <= 0 then break;
      if pTUserItem(List.Items[i]) <> nil then begin
        DisPose(pTUserItem(List.Items[i]));
      end;
      List.Delete(i);
      Dec(nInt);
    end;
  end;
var
  i, ii: Integer;
  Goods: pTGoods;
  nIndex, nRefillCount: Integer;
  RefillList, RefillList20: TSimpleList;
  bo21: Boolean;
const
  sExceptionMsg = '[쳣!!] TMerchant::RefillGoods %s/%d:%d Code:%d [%s]';
begin
  try
    for i := 0 to m_RefillGoodsList.Count - 1 do begin
      Goods := m_RefillGoodsList.Items[i];
      if Goods = nil then Continue;
      if (GetTickCount - Goods.dwRefillTick) > Goods.dwRefillTime * 60 * 1000 then begin
        Goods.dwRefillTick := GetTickCount();
        nIndex := UserEngine.GetStdItemIdx(Goods.sItemName);
        if nIndex >= 0 then begin
          RefillList := GetRefillList(nIndex);
          nRefillCount := 0;
          if RefillList <> nil then nRefillCount := RefillList.Count;
          if Goods.nCount > nRefillCount then begin
            CheckItemPrice(nIndex);
            RefillItems(RefillList, Goods.sItemName, Goods.nCount - nRefillCount);
          end;
          if Goods.nCount < nRefillCount then begin
            DelReFillItem(RefillList, nRefillCount - Goods.nCount);
          end;
        end;
      end;
    end;
    for i := 0 to m_GoodsList.Count - 1 do begin
      RefillList20 := TSimpleList(m_GoodsList.Items[i]);
      if RefillList20 = nil then Continue;
      if RefillList20.Count > 1000 then begin
        bo21 := False;
        for ii := 0 to m_RefillGoodsList.Count - 1 do begin
          Goods := m_RefillGoodsList.Items[ii];
          if Goods = nil then Continue;
          nIndex := UserEngine.GetStdItemIdx(Goods.sItemName);
          if (pTItemPrice(RefillList20.Items[0]) <> nil) and (pTItemPrice(RefillList20.Items[0]).wIndex = nIndex) then begin
            bo21 := True;
            break;
          end;
        end;
        if not bo21 then begin
          DelReFillItem(RefillList20, RefillList20.Count - 1000);
        end else begin
          DelReFillItem(RefillList20, RefillList20.Count - 5000);
        end;
      end;
    end;
  except
    on E: Exception do
      MainOutMessage(format(sExceptionMsg, [m_sCharName, m_nCurrX, m_nCurrY, nCHECK, E.Message]));
  end;
end;

function TMerchant.CheckItemType(nStdMode: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to m_ItemTypeList.Count - 1 do begin
    if Integer(m_ItemTypeList.Items[i]) = nStdMode then begin
      Result := True;
      break;
    end;
  end;
end;

function TMerchant.GetItemPrice(nIndex: Integer): Integer;
var
  i: Integer;
  ItemPrice: pTItemPrice;
  StdItem: pTStdItem;
begin
  Result := -1;
  for i := 0 to m_ItemPriceList.Count - 1 do begin
    ItemPrice := m_ItemPriceList.Items[i];
    if ItemPrice = nil then Continue;
    if ItemPrice.wIndex = nIndex then begin
      Result := ItemPrice.nPrice;
      break;
    end;
  end; // for
  if Result < 0 then begin
    StdItem := UserEngine.GetStdItem(nIndex);
    if StdItem <> nil then begin
      if CheckItemType(StdItem.StdMode) then
        Result := StdItem.Price;
    end;
  end;
end;

procedure TMerchant.SaveUpgradingList();
begin
  try
    //FrmDB.SaveUpgradeWeaponRecord(m_sCharName,m_UpgradeWeaponList);
    FrmDB.SaveUpgradeWeaponRecord(m_sScriptFileName + '-' + m_sMapName, m_UpgradeWeaponList);
  except
    MainOutMessage('Failure in saving upgradinglist - ' + m_sCharName);
  end;
end;

procedure TMerchant.UpgradeWapon(User: TPlayObject); //004A0920
  procedure sub_4A0218(ItemList: TList; var btDc: Byte; var btSc: Byte; var btMc: Byte; var btDura: Byte);
  var
    i, ii: Integer;
    DuraList: TList;
    UserItem: pTUserItem;
    StdItem: pTStdItem;
    StdItem80: TStdItem;
    DelItemList: TStringList;
    nDc, nSc, nMc, nDcMin, nDcMax, nScMin, nScMax, nMcMin, nMcMax, nDura, nItemCount: Integer;
  begin
    nDcMin := 0;
    nDcMax := 0;
    nScMin := 0;
    nScMax := 0;
    nMcMin := 0;
    nMcMax := 0;
    nDura := 0;
    nItemCount := 0;
    DelItemList := nil;
    DuraList := TList.Create;
    for i := ItemList.Count - 1 downto 0 do begin
      UserItem := ItemList.Items[i];
      if UserItem = nil then Continue;
      if UserEngine.GetStdItemName(UserItem.wIndex) = g_Config.sBlackStone then begin
        DuraList.Add(Pointer(ROUND(UserItem.Dura / 1.0E3)));
        if DelItemList = nil then DelItemList := TStringList.Create;
        DelItemList.AddObject(g_Config.sBlackStone, TObject(UserItem.MakeIndex));
        DisPose(UserItem);
        ItemList.Delete(i);
      end else begin
        if IsUseItem(UserItem.wIndex) then begin
          StdItem := UserEngine.GetStdItem(UserItem.wIndex);
          if StdItem <> nil then begin
            StdItem80 := StdItem^;
            ItemUnit.GetItemAddValue(UserItem, StdItem80);
            nDc := 0;
            nSc := 0;
            nMc := 0;
            case StdItem80.StdMode of
              19, 20, 21: begin //004A0421
                  nDc := HiWord(StdItem80.DC) + LoWord(StdItem80.DC);
                  nSc := HiWord(StdItem80.SC) + LoWord(StdItem80.SC);
                  nMc := HiWord(StdItem80.MC) + LoWord(StdItem80.MC);
                end;
              22, 23: begin //004A046E
                  nDc := HiWord(StdItem80.DC) + LoWord(StdItem80.DC);
                  nSc := HiWord(StdItem80.SC) + LoWord(StdItem80.SC);
                  nMc := HiWord(StdItem80.MC) + LoWord(StdItem80.MC);
                end;
              24, 26: begin
                  nDc := HiWord(StdItem80.DC) + LoWord(StdItem80.DC) + 1;
                  nSc := HiWord(StdItem80.SC) + LoWord(StdItem80.SC) + 1;
                  nMc := HiWord(StdItem80.MC) + LoWord(StdItem80.MC) + 1;
                end;
            end;
            if nDcMin < nDc then begin
              nDcMax := nDcMin;
              nDcMin := nDc;
            end else begin
              if nDcMax < nDc then nDcMax := nDc;
            end;
            if nScMin < nSc then begin
              nScMax := nScMin;
              nScMin := nSc;
            end else begin
              if nScMax < nSc then nScMax := nSc;
            end;
            if nMcMin < nMc then begin
              nMcMax := nMcMin;
              nMcMin := nMc;
            end else begin
              if nMcMax < nMc then nMcMax := nMc;
            end;
            if DelItemList = nil then DelItemList := TStringList.Create;
            DelItemList.AddObject(StdItem.Name, TObject(UserItem.MakeIndex));
            //004A06DB
            if IsBitOn(StdItem.NeedIdentify, 12)  then
              AddGameDataLog('26' + #9 +
                User.m_sMapName + #9 +
                IntToStr(User.m_nCurrX) + #9 +
                IntToStr(User.m_nCurrY) + #9 +
                User.m_sCharName + #9 +
                StdItem.Name + #9 +
                IntToStr(UserItem.MakeIndex) + #9 +
                '1' + #9 +
                '0');
            DisPose(UserItem);
            ItemList.Delete(i);
          end;
        end;
      end;
    end; // for
    for i := 0 to DuraList.Count - 1 do begin
      if DuraList.Count <= 0 then break;
      for ii := DuraList.Count - 1 downto i + 1 do begin
        if Integer(DuraList.Items[ii]) > Integer(DuraList.Items[ii - 1]) then
          DuraList.Exchange(ii, ii - 1);
      end; // for
    end; // for
    for i := 0 to DuraList.Count - 1 do begin
      nDura := nDura + Integer(DuraList.Items[i]);
      Inc(nItemCount);
      if nItemCount >= 5 then break;
    end;
    btDura := ROUND(_MIN(5, nItemCount) + _MIN(5, nItemCount) * ((nDura / nItemCount) / 5.0));
    btDc := nDcMin div 5 + nDcMax div 3;
    btSc := nScMin div 5 + nScMax div 3;
    btMc := nMcMin div 5 + nMcMax div 3;
    if DelItemList <> nil then
      User.AddAction(Self, RM_SENDDELITEMLIST, 0, Integer(DelItemList), 0, 0, '');
    if DuraList <> nil then DuraList.Free;
  end;
var
  i: Integer;
  bo0D: Boolean;
  UpgradeInfo: pTUpgradeInfo;
  StdItem: pTStdItem;
begin
  bo0D := False;
  for i := 0 to m_UpgradeWeaponList.Count - 1 do begin
    UpgradeInfo := m_UpgradeWeaponList.Items[i];
    if UpgradeInfo = nil then Continue;
    if UpgradeInfo.sUserName = User.m_sCharName then begin
      GotoLable(User, sUPGRADEING, False);
      Exit;
    end;
  end;
  if (User.m_UseItems[U_WEAPON].wIndex <> 0) and (User.m_nGold >= g_Config.nUpgradeWeaponPrice) and
    (User.CheckItems(g_Config.sBlackStone) <> nil) then begin
    User.DecGold(g_Config.nUpgradeWeaponPrice);
    //    if m_boCastle or g_Config.boGetAllNpcTax then UserCastle.IncRateGold(g_Config.nUpgradeWeaponPrice);
    if m_boCastle or g_Config.boGetAllNpcTax then begin
      if m_Castle <> nil then begin
        TUserCastle(m_Castle).IncRateGold(g_Config.nUpgradeWeaponPrice);
      end else
        if g_Config.boGetAllNpcTax then begin
          g_CastleManager.IncRateGold(g_Config.nUpgradeWeaponPrice);
        end;
    end;
    User.GoldChanged();
    New(UpgradeInfo);
    UpgradeInfo.sUserName := User.m_sCharName;
    UpgradeInfo.UserItem := User.m_UseItems[U_WEAPON];
    StdItem := UserEngine.GetStdItem(User.m_UseItems[U_WEAPON].wIndex);

    if IsBitOn(StdItem.NeedIdentify, 12) then
      AddGameDataLog('25' + #9 +
        User.m_sMapName + #9 +
        IntToStr(User.m_nCurrX) + #9 +
        IntToStr(User.m_nCurrY) + #9 +
        User.m_sCharName + #9 +
        //UserEngine.GetStdItemName(User.m_UseItems[U_WEAPON].wIndex) + #9 +
        StdItem.Name + #9 +
        IntToStr(User.m_UseItems[U_WEAPON].MakeIndex) + #9 +
        '1' + #9 +
        '0');
    User.SendDelItems(@User.m_UseItems[U_WEAPON]);
    User.m_UseItems[U_WEAPON].wIndex := 0;
    User.RecalcAbilitys();
    User.FeatureChanged();
    User.AddAction(User, RM_ABILITY, 0, 0, 0, 0, '');
    sub_4A0218(User.m_ItemList, UpgradeInfo.btDc, UpgradeInfo.btSc, UpgradeInfo.btMc, UpgradeInfo.btDura);
    UpgradeInfo.dtTime := Now();
    UpgradeInfo.dwGetBackTick := GetTickCount();
    m_UpgradeWeaponList.Add(UpgradeInfo);
    SaveUpgradingList();
    bo0D := True;
  end;
  if bo0D then GotoLable(User, sUPGRADEOK, False)
  else GotoLable(User, sUPGRADEFAIL, False);
end;

procedure TMerchant.GetBackupgWeapon(User: TPlayObject); //004A0CB8
var
  i: Integer;
  UpgradeInfo: pTUpgradeInfo;
  n10, n14, n18, n1C, n90: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  n18 := 0;
  UpgradeInfo := nil;
  if not User.IsEnoughBag then begin
    //    User.SysMsg('ıѾˣ޷ЯκƷˣ',0);
    GotoLable(User, sGETBACKUPGFULL, False);
    Exit;
  end;
  for i := m_UpgradeWeaponList.Count - 1 downto 0 do begin //for i := 0 to m_UpgradeWeaponList.Count - 1 do begin
    if m_UpgradeWeaponList.Count <= 0 then break;
    if pTUpgradeInfo(m_UpgradeWeaponList.Items[i]).sUserName = User.m_sCharName then begin
      n18 := 1;
      if ((GetTickCount - pTUpgradeInfo(m_UpgradeWeaponList.Items[i]).dwGetBackTick) > g_Config.dwUPgradeWeaponGetBackTime) or (User.m_btPermission >= 4) then begin
        UpgradeInfo := m_UpgradeWeaponList.Items[i];
        m_UpgradeWeaponList.Delete(i);
        SaveUpgradingList();
        n18 := 2;
        break;
      end;
    end;
  end;
  if UpgradeInfo <> nil then begin
    case UpgradeInfo.btDura of //
      0..8: begin //004A0DE5
          //       n14:=_MAX(3000,UpgradeInfo.UserItem.DuraMax shr 1);
          if UpgradeInfo.UserItem.DuraMax > 3000 then begin
            Dec(UpgradeInfo.UserItem.DuraMax, 3000);
          end else begin
            UpgradeInfo.UserItem.DuraMax := UpgradeInfo.UserItem.DuraMax shr 1;
          end;
          if UpgradeInfo.UserItem.Dura > UpgradeInfo.UserItem.DuraMax then
            UpgradeInfo.UserItem.Dura := UpgradeInfo.UserItem.DuraMax;
        end;
      9..15: begin //004A0E41
          if Random(UpgradeInfo.btDura) < 6 then begin
            if UpgradeInfo.UserItem.DuraMax > 1000 then
              Dec(UpgradeInfo.UserItem.DuraMax, 1000);
            if UpgradeInfo.UserItem.Dura > UpgradeInfo.UserItem.DuraMax then
              UpgradeInfo.UserItem.Dura := UpgradeInfo.UserItem.DuraMax;
          end;
        end;
      18..255: begin
          case Random(UpgradeInfo.btDura - 18) of
            1..4: Inc(UpgradeInfo.UserItem.DuraMax, 1000);
            5..7: Inc(UpgradeInfo.UserItem.DuraMax, 2000);
            8..255: Inc(UpgradeInfo.UserItem.DuraMax, 4000)
          end;
        end;
    end; // case
    if (UpgradeInfo.btDc = UpgradeInfo.btMc) and (UpgradeInfo.btMc = UpgradeInfo.btSc) then begin
      n1C := Random(3);
    end else begin
      n1C := -1;
    end;
    if ((UpgradeInfo.btDc >= UpgradeInfo.btMc) and (UpgradeInfo.btDc >= UpgradeInfo.btSc)) or
      (n1C = 0) then begin
      n90 := _MIN(11, UpgradeInfo.btDc);
      n10 := _MIN(85, n90 shl 3 - n90 + 10 +
      UpgradeInfo.UserItem.btAddValue[IVIWeaptonLuck]
    - UpgradeInfo.UserItem.btAddValue[IVIWeaptonUnLuck] + User.m_nBodyLuckLevel);

      if Random(g_Config.nUpgradeWeaponDCRate) < n10 then begin //if Random(100) < n10 then begin
        UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 10;

        if (n10 > 63) and (Random(g_Config.nUpgradeWeaponDCTwoPointRate) = 0) then //if (n10 > 63) and (Random(30) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 11;

        if (n10 > 79) and (Random(g_Config.nUpgradeWeaponDCThreePointRate) = 0) then //if (n10 > 79) and (Random(200) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 12;
      end else UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 1; //004A0F89
    end;
    if ((UpgradeInfo.btMc >= UpgradeInfo.btDc) and (UpgradeInfo.btMc >= UpgradeInfo.btSc)) or
      (n1C = 1) then begin
      n90 := _MIN(11, UpgradeInfo.btMc);
      n10 := _MIN(85, n90 shl 3 - n90 + 10 + UpgradeInfo.UserItem.btAddValue[IVIWeaptonLuck] - UpgradeInfo.UserItem.btAddValue[IVIWeaptonUnLuck] + User.m_nBodyLuckLevel);

      if Random(g_Config.nUpgradeWeaponMCRate) < n10 then begin //if Random(100) < n10 then begin
        UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 20;

        if (n10 > 63) and (Random(g_Config.nUpgradeWeaponMCTwoPointRate) = 0) then //if (n10 > 63) and (Random(30) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 21;

        if (n10 > 79) and (Random(g_Config.nUpgradeWeaponMCThreePointRate) = 0) then //if (n10 > 79) and (Random(200) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 22;
      end else UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 1;
    end;
    if ((UpgradeInfo.btSc >= UpgradeInfo.btMc) and (UpgradeInfo.btSc >= UpgradeInfo.btDc)) or
      (n1C = 2) then begin
      n90 := _MIN(11, UpgradeInfo.btMc);
      n10 := _MIN(85, n90 shl 3 - n90 + 10 + UpgradeInfo.UserItem.btAddValue[IVIWeaptonLuck] - UpgradeInfo.UserItem.btAddValue[IVIWeaptonUnLuck] + User.m_nBodyLuckLevel);

      if Random(g_Config.nUpgradeWeaponSCRate) < n10 then begin //if Random(100) < n10 then begin
        UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 30;

        if (n10 > 63) and (Random(g_Config.nUpgradeWeaponSCTwoPointRate) = 0) then //if (n10 > 63) and (Random(30) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 31;

        if (n10 > 79) and (Random(g_Config.nUpgradeWeaponSCThreePointRate) = 0) then //if (n10 > 79) and (Random(200) = 0) then
          UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 32;
      end else UpgradeInfo.UserItem.btAddValue[IVIWeaptonUp] := 1;
    end;
    New(UserItem);
    UserItem^ := UpgradeInfo.UserItem;
    DisPose(UpgradeInfo);
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    //004A120E
    if IsBitOn(StdItem.NeedIdentify, 12) then
      AddGameDataLog('24' + #9 +
        User.m_sMapName + #9 +
        IntToStr(User.m_nCurrX) + #9 +
        IntToStr(User.m_nCurrY) + #9 +
        User.m_sCharName + #9 +
        //UserEngine.GetStdItemName(UserItem.wIndex) + #9 +
        StdItem.Name + #9 +
        IntToStr(UserItem.MakeIndex) + #9 +
        '1' + #9 +
        '0');
    User.AddItemToBag(UserItem);
    User.SendAddItem(UserItem);
  end;
  case n18 of //
    0: GotoLable(User, sGETBACKUPGFAIL, False);
    1: GotoLable(User, sGETBACKUPGING, False);
    2: GotoLable(User, sGETBACKUPGOK, False);
  end; // case
end;

function TMerchant.GetUserPrice(PlayObject: TPlayObject; nPrice: Integer): Integer; //0049F6E0
var
  n14: Integer;
begin
  {
  if m_boCastle then begin
    if UserCastle.IsMasterGuild(TGuild(PlayObject.m_MyGuild)) then begin
      n14:=_MAX(60,ROUND(m_nPriceRate * 8.0000000000000000001e-1));//80%
      Result:=ROUND(nPrice / 1.0e2 * n14); //100
    end else begin
      Result:=ROUND(nPrice / 1.0e2 * m_nPriceRate);
    end;
  end else begin
    Result:=ROUND(nPrice / 1.0e2 * m_nPriceRate);
  end;
  }
  if m_boCastle then begin
    //    if UserCastle.IsMasterGuild(TGuild(PlayObject.m_MyGuild)) then begin
    if (m_Castle <> nil) and TUserCastle(m_Castle).IsMasterGuild(TGUild(PlayObject.m_MyGuild)) then begin
      n14 := _MAX(60, ROUND(m_nPriceRate * (g_Config.nCastleMemberPriceRate / 100))); //80%
      Result := ROUND(nPrice / 100 * n14); //100
    end else begin
      Result := ROUND(nPrice / 100 * m_nPriceRate);
    end;
  end else begin
    Result := ROUND(nPrice / 100 * m_nPriceRate);
  end;
end;

procedure TMerchant.UserSelect(PlayObject: TPlayObject; sData: string);
  // 
  procedure SellItem(User: TPlayObject); //004A1544
  begin
    User.AddAction(Self, RM_OpenSellDlg, 0, Integer(Self), Byte(User.m_SellMode), 0, '');
  end;

  // ȡ 
  procedure OpenBuyItemDlg(User: TPlayObject);
  var
    i, n10, nStock, nPrice: Integer;
    nSubMenu: ShortInt;
    sSendMsg, sName: string;
    ClientItem: TClientItem;
    UserItem: pTUserItem;
    StdItem: pTStdItem;
    List14: TList;
    sUserItemName: string;
    pcg: TClientGoods;
  begin
    sSendMsg := '';
    n10 := 0;
    case User.m_BuyMode of
      bmBuy: begin
          for i := 0 to m_GoodsList.Count - 1 do begin
            List14 := TList(m_GoodsList.Items[i]);
            if List14 = nil then Continue;
            UserItem := List14.Items[0];
            if UserItem = nil then Continue;
            StdItem := UserEngine.GetStdItem(UserItem.wIndex);
            if StdItem <> nil then begin
            //ȡԶƷ
              FillChar(pcg, SizeOf(TClientGoods), 0);
              sName := ItemUnit.GetCustomItemName(UserItem);
              if sName = '' then
                sName := StdItem.Name;
              pcg.Name := sName;
              pcg.Price := GetUserPrice(User, GetItemPrice(UserItem.wIndex));
              pcg.Count := List14.Count;
              pcg.looks := StdItem.Looks;
              pcg.MakeIndex := UserItem.MakeIndex;
              if not ((StdItem.StdMode <= 4) or
                (StdItem.StdMode = 42) or
                (StdItem.StdMode = 31)) then pcg.MakeIndex := 0;

              sSendMsg := sSendMsg + EncodeBuffer(@pcg, SizeOf(TClientGoods)) + '/';
              Inc(n10);
            end;
          end; // for  SM_GetItem_Success
          User.m_DefMsg := MakeDefaultMsg(SM_GoodsList, Integer(Self), Byte(User.m_BuyMode), 0, n10);
          User.SendSocket(@User.m_DefMsg, (sSendMsg));
        end; //bmBuy
      bmGetBack: begin
          for i := 0 to User.m_StorageItemList.Count - 1 do
          begin
            UserItem := User.m_StorageItemList.Items[i];
          //sItemNewName:=GetItemName(UserItem.MakeIndex);
            StdItem := UserEngine.GetStdItem(UserItem.wIndex);
            if StdItem <> nil then
            begin
              FillChar(ClientItem, SizeOf(ClientItem), 0);
              ClientItem.s := StdItem^;
              ItemUnit.GetItemAddValue(UserItem, ClientItem.s);
            //ȡԶƷ

              sUserItemName := ItemUnit.GetCustomItemName(UserItem);
              if sUserItemName <> '' then
                ClientItem.s.Name := sUserItemName;

              ClientItem.Dura := UserItem.Dura;
              ClientItem.DuraMax := UserItem.DuraMax;
              ClientItem.MakeIndex := UserItem.MakeIndex;
              sSendMsg := sSendMsg + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) +
                '/';
            end;
          end;
        //MainOutMessage(sSendMsg);
          User.m_DefMsg := MakeDefaultMsg(SM_DetailGoodsList, Integer(Self), Byte(User.m_BuyMode), 0, User.m_StorageItemList.Count);
          User.SendSocket(@User.m_DefMsg, (sSendMsg));
        end;
    end;
  end;
var
  sLabel, s18, s19, sMsg: string;
  boCanJmp: Boolean;
const
  sExceptionMsg = '[쳣!!] TMerchant::UserSelect... Data: %s';
begin
  inherited;
  if not (ClassNameIs(TMerchant.ClassName)) then Exit; // TMerchant ִ´
  try
    if not m_boCastle or not ((m_Castle <> nil) and TUserCastle(m_Castle).m_boUnderWar) and (PlayObject <> nil) then begin
      if {not PlayObject.m_boDeath and }(sData <> '') and (sData[1] = '@') then begin
        sMsg := GetValidStr3(sData, sLabel, [#13]);
        s18 := '';
        PlayObject.m_sScriptLable := sData;
        boCanJmp := PlayObject.LableIsCanJmp(sLabel);
        GotoLable(PlayObject, sLabel, not boCanJmp);
        if not boCanJmp then Exit;
        
        if CompareLStr(sLabel, sSL_InPutS,Length(sSL_InPutS))then begin

            s18 := Copy(sLabel, Length(sSL_InPutS) + 1, Length(sLabel));
            SendInPutS(PlayObject, sMsg,s18);
        end else
        if CompareLStr(sLabel, sSL_InPutI,Length(sSL_InPutI)) then begin
            s18 := Copy(sLabel, Length(sSL_InPutI) + 1, Length(sLabel));
            SendInPutI(PlayObject, sMsg,s18);
        end else
          if CompareText(sLabel, sSUPERREPAIR) = 0 then begin
            if m_boS_repair then begin
              PlayObject.m_SellMode := smSRepair;
              SellItem(PlayObject);
            end;
          end else
            if CompareText(sLabel, sSELL) = 0 then begin //
              if m_boSell then begin
                PlayObject.m_SellMode := smSell;
                SellItem(PlayObject);
              end;
            end else
              if CompareText(sLabel, sREPAIR) = 0 then begin //
                if m_boRepair then begin
                  PlayObject.m_SellMode := smRepair;
                  SellItem(PlayObject);
                end;
              end else
                if CompareText(sLabel, sSTORAGE) = 0 then begin //涫
                  if m_boStorage then begin
                    PlayObject.m_SellMode := smStorage;
                    SellItem(PlayObject);
                  end;
                end else
                  if CompareText(sLabel, sBIGSTORAGE) = 0 then begin //涫
                    if m_boBigStorage then begin
                      PlayObject.m_SellMode := smBigStorage;
                      SellItem(PlayObject);
                    end;
                  end else
                    if CompareText(sLabel, sUpItem) = 0 then begin
                      if m_boUpItem then begin
                        PlayObject.m_SellMode := smItemUp;
                        SellItem(PlayObject);
                      end;
                    end else
                      if CompareText(sLabel, sHoleItem) = 0 then begin
                        if m_boHoleItem then begin
                          PlayObject.m_SellMode := smOpenHole;
                          SellItem(PlayObject);
                        end;
                      end else

        {if CompareText(sLabel, sPRICES) = 0 then begin
          if m_boPrices then ItemPrices(PlayObject);
        end else        }
                        if CompareText(sLabel, sBUY) = 0 then begin
                          if m_boBuy then begin
                            PlayObject.m_BuyMode := bmBuy;
                            OpenBuyItemDlg(PlayObject);
                          end;
                        end else
                          if CompareText(sLabel, sGETBACK) = 0 then begin
                            if m_boGetback then begin
                              PlayObject.m_BuyMode := bmGetBack;
                              OpenBuyItemDlg(PlayObject);
                            end;
                          end else
                            if CompareText(sLabel, sBIGGETBACK) = 0 then begin
                              if m_boBigGetback then begin
                                PlayObject.m_BuyMode := bmBigGetBack;
                                OpenBuyItemDlg(PlayObject);
                              end;
                            end else

                              if CompareText(sLabel, sUPGRADENOW) = 0 then begin
                                if m_boUpgradenow then UpgradeWapon(PlayObject);
                              end else
                                if CompareText(sLabel, sGETBACKUPGNOW) = 0 then begin
                                  if m_boGetBackupgnow then GetBackupgWeapon(PlayObject);
                                end else
                                  if CompareText(sLabel, sGETMARRY) = 0 then begin
                                    if m_boGetMarry then GetBackupgWeapon(PlayObject);
                                  end else
                                    if CompareText(sLabel, sGETMASTER) = 0 then begin
                                      if m_boGetMaster then GetBackupgWeapon(PlayObject);
                                    end else
                                      if CompareLStr(sLabel, sUSEITEMNAME, Length(sUSEITEMNAME)) then begin
                                        if m_boUseItemName then ChangeUseItemName(PlayObject, sLabel, sMsg);
                                      end else
                                        if CompareText(sLabel, sEXIT) = 0 then begin
                                          PlayObject.AddAction(Self, RM_MERCHANTDLGCLOSE, 0, Integer(Self), 0, 0, '');
                                        end else
                                          if CompareText(sLabel, sBACK) = 0 then begin
                                            if PlayObject.m_sScriptGoBackLable = '' then PlayObject.m_sScriptGoBackLable := sMAIN;
                                            GotoLable(PlayObject, PlayObject.m_sScriptGoBackLable, False);
                                          end else begin
                                          end;
      end;
    end;
  except
    MainOutMessage(format(sExceptionMsg, [sData]));
  end;
end;

procedure TMerchant.Run();
var
  nCheckCode: Integer;
const
  sExceptionMsg1 = '[쳣!!] TMerchant::Run... Code = %d';
  sExceptionMsg2 = '[쳣!!] TMerchant::Run -> Move Code = %d';
begin
  nCheckCode := 0;
  try
    if (GetTickCount - dwRefillGoodsTick) > 30000 then begin
      //if (GetTickCount - dwTick578) > 3000 then begin
      dwRefillGoodsTick := GetTickCount();
      RefillGoods();
    end;

    nCheckCode := 1;
    if (GetTickCount - dwClearExpreUpgradeTick) > 10 * 60 * 1000 then begin
      dwClearExpreUpgradeTick := GetTickCount();
      ClearExpreUpgradeListData();
    end;
    nCheckCode := 2;
    if Random(50) = 0 then begin
      TurnTo(Random(8));
    end else begin
      if Random(50) = 0 then
        AddRefAction(RM_HIT, m_btDirection, m_nCurrX, m_nCurrY, 0, '');
    end;
    nCheckCode := 3;
    //    if m_boCastle and (UserCastle.m_boUnderWar)then begin
    if m_boCastle and (m_Castle <> nil) and TUserCastle(m_Castle).m_boUnderWar then begin
      if not m_boFixedHideMode then begin
        AddRefAction(RM_DISAPPEAR, 0, 0, 0, 0, '');
        m_boFixedHideMode := True;
      end;
    end else begin
      if m_boFixedHideMode then begin
        m_boFixedHideMode := False;
        AddRefAction(RM_HIT, m_btDirection, m_nCurrX, m_nCurrY, 0, '');
      end;
    end;
    nCheckCode := 4;
  except
    on E: Exception do begin
      MainOutMessage(format(sExceptionMsg1, [nCheckCode]));
      MainOutMessage(E.Message);
    end;
  end;
  try
    if m_boCanMove and (GetTickCount - m_dwMoveTick > m_dwMoveTime * 1000) then begin
      m_dwMoveTick := GetTickCount();
      AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
      MapRandomMove(m_sMapName, 0);
    end;
  except
    on E: Exception do begin
      MainOutMessage(format(sExceptionMsg2, [nCheckCode]));
      MainOutMessage(E.Message);
    end;
  end;
  inherited;
end;

function TMerchant.Operate(ProcessMsg: pTProcessMessage): Boolean;
begin
  Result := inherited Operate(ProcessMsg);
end;

procedure TMerchant.LoadNPCData;
var
  sFile: string;
begin
  sFile := m_sScriptFileName + '-' + m_sMapName;
  LoadUpgradeList();
end;


constructor TMerchant.Create; //0049EC70
begin
  inherited;
  m_btRaceImg := RCC_MERCHANT;
  m_wAppr := 0;
  m_nPriceRate := 100;
  m_boCastle := False;
  m_ItemTypeList := TSimpleList.Create;
  m_RefillGoodsList := TSimpleList.Create;
  m_GoodsList := TSimpleList.Create;
  m_ItemPriceList := TSimpleList.Create;
  m_UpgradeWeaponList := TSimpleList.Create;

  dwRefillGoodsTick := GetTickCount();
  dwClearExpreUpgradeTick := GetTickCount();
  m_boBuy := False;
  m_boSell := False;
  m_boPrices := False;
  m_boStorage := False;
  m_boGetback := False;
  m_boBigStorage := False;
  m_boBigGetback := False;
  m_boUpgradenow := False;
  m_boGetBackupgnow := False;
  m_boRepair := False;
  m_boS_repair := False;
  m_boGetMarry := False;
  m_boGetMaster := False;
  m_boUseItemName := False;
  m_boHoleItem := False;
  m_boUpItem := False;
  m_dwMoveTick := GetTickCount();
end;

destructor TMerchant.Destroy; //0049ED70
var
  i: Integer;
  ii: Integer;
  List: TList;
begin
  m_ItemTypeList.Free;
  for i := 0 to m_RefillGoodsList.Count - 1 do begin
    DisPose(pTGoods(m_RefillGoodsList.Items[i]));
  end;
  m_RefillGoodsList.Free;

  for i := 0 to m_UpgradeWeaponList.Count - 1 do begin
    DisPose(pTUpgradeInfo(m_UpgradeWeaponList.Items[i]));
  end;
  m_UpgradeWeaponList.Free;

  inherited Destroy;
end;


procedure TMerchant.ClearExpreUpgradeListData; //004A01A0
var
  i: Integer;
  UpgradeInfo: pTUpgradeInfo;
begin
  for i := m_UpgradeWeaponList.Count - 1 downto 0 do begin
    if m_UpgradeWeaponList.Count <= 0 then break;
    UpgradeInfo := m_UpgradeWeaponList.Items[i];
    if UpgradeInfo = nil then Continue;
    if Integer(ROUND(Now - UpgradeInfo.dtTime)) >= g_Config.nClearExpireUpgradeWeaponDays then begin
      DisPose(UpgradeInfo);
      m_UpgradeWeaponList.Delete(i);
    end;
  end;
end;

procedure TMerchant.LoadScript;
var
  SC                                    : string;
begin
  m_ItemTypeList.Clear;
  m_sPath := sMarket_Def;
  SC := m_sScriptFileName + '-' + m_sMapName;
  FrmDB.LoadScriptFile(self, sMarket_Def, SC, True);
end; 

procedure TMerchant.Click(PlayObject: TPlayObject); //0049FF24
begin
  //  GotoLable(PlayObject,'@main');
  inherited;
end;

procedure TMerchant.GetVariableText(PlayObject: TPlayObject;
  var sMsg: string; sVariable: string); //0049FD04
var
  sText, s14: string;
  n18: Integer;
begin
  inherited;
  if sVariable = '$PRICERATE' then begin
    sText := IntToStr(m_nPriceRate);
    sMsg := sub_49ADB8(sMsg, '<$PRICERATE>', sText);
  end;
  if sVariable = '$UPGRADEWEAPONFEE' then begin
    sText := IntToStr(g_Config.nUpgradeWeaponPrice);
    sMsg := sub_49ADB8(sMsg, '<$UPGRADEWEAPONFEE>', sText);
  end;
  if sVariable = '$USERWEAPON' then begin
    if PlayObject.m_UseItems[U_WEAPON].wIndex <> 0 then begin
      sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_WEAPON].wIndex);
    end else begin
      sText := '';
    end;
    sMsg := sub_49ADB8(sMsg, '<$USERWEAPON>', sText);
  end;
end;

function TMerchant.GetUserItemPrice(UserItem: pTUserItem): Integer;
var
  n10: Integer;
  StdItem: pTStdItem;
  n20: real;
  nC: Integer;
  n14: Integer;
begin
  n10 := GetItemPrice(UserItem.wIndex);
  if n10 > 0 then begin
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if (StdItem <> nil) and
      (StdItem.StdMode > 4) and
      (StdItem.DuraMax > 0) and
      (UserItem.DuraMax > 0) then begin
      if StdItem.StdMode = 40 then begin //
        if UserItem.Dura <= UserItem.DuraMax then begin
          n20 := (n10 / 2.0 / UserItem.DuraMax * (UserItem.DuraMax - UserItem.Dura));
          n10 := _MAX(2, ROUND(n10 - n20));
        end else begin
          n10 := n10 + ROUND(n10 / UserItem.DuraMax * 2.0 * (UserItem.DuraMax - UserItem.Dura));
        end;
      end;
      if (StdItem.StdMode = 43) then begin
        if UserItem.DuraMax < 10000 then UserItem.DuraMax := 10000;
        if UserItem.Dura <= UserItem.DuraMax then begin
          n20 := (n10 / 2.0 / UserItem.DuraMax * (UserItem.DuraMax - UserItem.Dura));
          n10 := _MAX(2, ROUND(n10 - n20));
        end else begin
          n10 := n10 + ROUND(n10 / UserItem.DuraMax * 1.3 * (UserItem.DuraMax - UserItem.Dura));
        end;
      end;
      if StdItem.StdMode > 4 then begin
        n14 := 0;
        nC := 0;
        while (True) do begin
          Inc(n14, UserItem.btAddValue[nC]);
          Inc(nC);
          if nC >= 8 then break;
        end;
        if n14 > 0 then begin
          n10 := n10 div 5 * n14;
        end;
        n10 := ROUND(n10 / StdItem.DuraMax * UserItem.DuraMax);
        n20 := (n10 / 2.0 / UserItem.DuraMax * (UserItem.DuraMax - UserItem.Dura));
        n10 := _MAX(2, ROUND(n10 - n20));
      end;
    end;
  end;
  Result := n10;
end;

procedure TMerchant.ClientBuyItem(PlayObject: TPlayObject; sItemName: string;
  MakeIndex: Integer);
var
  i, ii: Integer;
  bo29: Boolean;
  List20: TList;
  ItemPrice: pTItemPrice;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  n1C, nPrice: Integer;
  sUserItemName: string;
begin
  bo29 := False;
  n1C := -1;
  i := 0;
  while True do begin //for i := 0 to m_GoodsList.Count - 1 do begin
    if i >= m_GoodsList.Count then break;
    if m_GoodsList.Count <= 0 then break;
    if bo29 or (bo574) then break;
    List20 := TList(m_GoodsList.Items[i]);
    if List20 = nil then Continue;
    if List20.Count <= 0 then Continue;
    UserItem := List20.Items[0];
    //ȡԶƷ
    sUserItemName := '';

    sUserItemName := ItemUnit.GetCustomItemName(UserItem);
    if sUserItemName = '' then
      sUserItemName := UserEngine.GetStdItemName(UserItem.wIndex);

    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if StdItem <> nil then begin
      if IsBitOn(StdItem.NeedIdentify, 1) then begin
        Exit;
      end;
      if PlayObject.IsAddWeightAvailable(StdItem.Weight) then begin
        if sUserItemName = sItemName then begin
          ii := 0;
          while True do begin //for ii := 0 to List20.Count - 1 do begin
            if ii >= List20.Count then break;
            if List20.Count <= 0 then break;
            UserItem := List20.Items[ii];
            if (StdItem.StdMode <= 4) or
              (StdItem.StdMode = 42) or
              (StdItem.StdMode = 31) or
              (UserItem.MakeIndex = MakeIndex) then begin

              nPrice := GetUserPrice(PlayObject, GetUserItemPrice(UserItem));
              if (PlayObject.m_nGold >= nPrice) and (nPrice > 0) then begin
                if PlayObject.AddItemToBag(UserItem) then begin
                  Dec(PlayObject.m_nGold, nPrice);
                  if m_boCastle or g_Config.boGetAllNpcTax then begin
                    if m_Castle <> nil then begin
                      TUserCastle(m_Castle).IncRateGold(nPrice);
                    end else
                      if g_Config.boGetAllNpcTax then begin
                        g_CastleManager.IncRateGold(g_Config.nUpgradeWeaponPrice);
                      end;
                  end;
                  {
                  if m_boCastle or g_Config.boGetAllNpcTax then
                    UserCastle.IncRateGold(nPrice);
                  }
                  PlayObject.SendAddItem(UserItem);
                  //004A25DC
                  if IsBitOn(StdItem.NeedIdentify, 12) then
                    AddGameDataLog('9' + #9 +
                      PlayObject.m_sMapName + #9 +
                      IntToStr(PlayObject.m_nCurrX) + #9 +
                      IntToStr(PlayObject.m_nCurrY) + #9 +
                      PlayObject.m_sCharName + #9 +
                      //UserEngine.GetStdItemName(UserItem.wIndex) + #9 +
                      StdItem.Name + #9 +
                      IntToStr(UserItem.MakeIndex) + #9 +
                      '1' + #9 +
                      m_sCharName);

                  List20.Delete(ii);
                  if List20.Count <= 0 then begin
                    List20.Free;
                    m_GoodsList.Delete(i);
                  end;
                  n1C := PlayObject.m_nGold;
                end else n1C := -2; //PlayObject.AddItemToBag(UserItem)
              end else n1C := -3; // (PlayObject.m_nGold >= nPrice) and (nPrice > 0)
              bo29 := True;
              break;
            end;
            Inc(ii);
          end;
        end else n1C := -4; //sUserItemName = sItemName
      end else n1C := -5; //PlayObject.IsAddWeightAvailable(StdItem.Weight)
    end;
    Inc(i);
  end; // for

  PlayObject.AddAction(Self, RM_BuyItemSuccess, 0, n1C, MakeIndex, 0, '');


end;

procedure TMerchant.ClientGetDetailGoodsList(PlayObject: TPlayObject; sItemName: string);
var
  i, ii,n18: Integer;
  List20: TList;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  ClientItem: TClientItem;
  s1C: string;
begin
  begin
    n18 := 0;
    for i := 0 to m_GoodsList.Count - 1 do begin
      List20 := TList(m_GoodsList.Items[i]);
      if List20 = nil then Continue;
      if List20.Count <= 0 then Continue;
      UserItem := List20.Items[0];
      if UserItem = nil then Continue;
      StdItem := UserEngine.GetStdItem(UserItem.wIndex);
      if (StdItem <> nil) and (StdItem.Name = sItemName) then begin
        s1C := '';
        for ii := List20.Count - 1 downto 0 do begin
          if List20.Count <= 0 then break;
          UserItem := List20.Items[ii];
          if UserItem <> nil then begin
            ClientItem.s := StdItem^;
            ClientItem.s.Price := GetUserPrice(PlayObject, GetUserItemPrice(UserItem));
            ClientItem.Dura := UserItem.Dura;
            ClientItem.DuraMax := UserItem.DuraMax;
            ClientItem.MakeIndex := UserItem.MakeIndex;
            s1C := s1C + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
            Inc(n18);
              //if n18 >= 10 then break;
          end;
        end;
        break;
      end;
    end;
    PlayObject.m_DefMsg := MakeDefaultMsg(SM_DetailGoodsList, Integer(Self), Byte(PlayObject.m_BuyMode), 0, n18);
    PlayObject.SendSocket(@PlayObject.m_DefMsg, s1C);
  end;
end;

function TMerchant.ClientQuerySellPrice(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
begin
  Result := GetSellItemPrice(GetUserItemPrice(UserItem));
end;

function TMerchant.GetOpenHolePrice(UserItem: pTUserItem): Integer;
var
  I,Count:Integer;
begin
  I := 0;
  Count := 0;
  while True do begin
    if i > High(UserItem.btArrXQ) then Exit;
    if UserItem.btArrXQ[i] = 0 then begin
      Break; //ֻܲ iȫ?
    end else Inc(Count);
    Inc(i);
  end;
  Result := g_Config.OpenHolePicList[Count];
end;


function TMerchant.ClientSellItem(PlayObject: TPlayObject;
  UserItem: pTUserItem): Integer;
  function sub_4A1C84(UserItem: pTUserItem): Boolean;
  var
    StdItem: pTStdItem;
  begin
    Result := True;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if (StdItem <> nil) and ((StdItem.StdMode = 25) or (StdItem.StdMode = 30)) then begin
      if UserItem.Dura < 4000 then Result := False;
    end;
  end;
var
  nPrice: Integer;
  StdItem: pTStdItem;
begin
  Result := -1;
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if IsBitOn(StdItem.NeedIdentify, 1) then begin
    Exit;
  end;
  nPrice := GetSellItemPrice(GetUserItemPrice(UserItem));
  if (nPrice > 0) and (not bo574) and
    sub_4A1C84(UserItem) then begin
    if PlayObject.IncGold(nPrice) then begin
      {
      if m_boCastle or g_Config.boGetAllNpcTax then
        UserCastle.IncRateGold(nPrice);
      }
      if m_boCastle or g_Config.boGetAllNpcTax then begin
        if m_Castle <> nil then begin
          TUserCastle(m_Castle).IncRateGold(nPrice);
        end else
          if g_Config.boGetAllNpcTax then begin
            g_CastleManager.IncRateGold(g_Config.nUpgradeWeaponPrice);
          end;
      end;
      AddItemToGoodsList(UserItem);

      if IsBitOn(StdItem.NeedIdentify, 12) then
        AddGameDataLog('10' + #9 +
          PlayObject.m_sMapName + #9 +
          IntToStr(PlayObject.m_nCurrX) + #9 +
          IntToStr(PlayObject.m_nCurrY) + #9 +
          PlayObject.m_sCharName + #9 +
          //UserEngine.GetStdItemName(UserItem.wIndex) + #9 +
          StdItem.Name + #9 +
          IntToStr(UserItem.MakeIndex) + #9 +
          '1' + #9 +
          m_sCharName);
      Result := PlayObject.m_nGold;
    end else Result := -2;
  end else Result := -3;
end;

//  TasNat
// 2009-10-06 12:25:36
//
//
//


function TMerchant.OpenHoleItem(PlayObject: TPlayObject; UserItem: pTUserItem): Integer; //004A2024
var
  StdItem: pTStdItem;
  i,ii,Count: Integer;
  nPrice: Integer;
  can:Boolean;
begin
  Result := -1;
  i := 0;
  Count := 0;
  can := False;
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if (StdItem = nil) then Exit;
  for ii := low(THumItems) to High(THumItems) do
  begin
    if CheckUserItems(ii,StdItem) then begin
      can := True;
      Break;
    end;
  end;
  if StdItem.StdMode = 25 then Exit; 
  if not can then Exit;

  while True do begin
    if i > High(UserItem.btArrXQ) then Exit;
    if UserItem.btArrXQ[i] = 0 then begin
      Break; //ֻܲ iȫ?
    end else Inc(Count);
    Inc(i);
  end;

  nPrice := g_Config.OpenHolePicList[Count];
  if nPrice < 0 then nPrice := 0;
  if g_Config.boOpenHoleUseGameGold then  begin
    if PlayObject.m_nGameGold >= nPrice then begin
      PlayObject.DecGameGold(nPrice);
      UserItem.btArrXQ[i] := 1;
      UserItem.Dura := i;
      Result := PlayObject.m_nGameGold;
    end else Result := -2;
  end else begin
    if PlayObject.DecGold(nPrice) then begin
      UserItem.btArrXQ[i] := 1;
      UserItem.Dura := i;
      Result := PlayObject.m_nGold;
    end else Result := -2;
  end;
end;


function TMerchant.ItemUp(PlayObject: TPlayObject; DesItem: pTUserItem; KS, BS, JLS: Integer): Integer;
var
  i, IndexLevel, ItemJL, JL: Integer;
  StdItem: pTStdItem;
  nItemCount: Integer;
  ItemKS, ItemBS: pTStdItem;
  UserItemKS, UserItemBS, UserItemJLS, FindUserItem: pTUserItem;
begin
  if PlayObject.m_nGameGold < 20 then begin
    Result := -1;
    PlayObject.SysMsg('Ҫ20Ԫ..', c_Green, t_Hint);
    Exit;
  end;
  if (DesItem = nil) then begin
    Result := -1;
    Exit;
  end;
  ItemJL := 0;
  IndexLevel := DesItem.btUpValue[0];
  if IndexLevel >= 10 then begin
    if Random(g_Config.UpItemJiLu10) = 0 then begin //10 sc 8mc 6dc
      Inc(DesItem.btUpValue[0]);
      JL := Random(1) + 1;
      i := Random(9);
      Inc(DesItem.btUpValue[i]);
    end;
    Result := DesItem.btUpValue[0];
    PlayObject.SendAddItem(DesItem);
    //PlayObject.SysMsg(IntToStr(DesItem.btUpValue[0]), c_Green, t_Hint);
    PlayObject.m_nScriptGotoCount := 0;
    Exit;
  end;
  UserItemKS := nil;
  ItemKS := nil;
  for i := 0 to PlayObject.m_ItemList.Count - 1 do
  begin
    FindUserItem := PlayObject.m_ItemList[i];
    if (FindUserItem <> nil) and (FindUserItem.MakeIndex = KS) then begin
      UserItemKS := FindUserItem;
      ItemKS := UserEngine.GetStdItem(UserItemKS.wIndex);
      break;
    end;
  end;
  if (UserItemKS = nil) or (ItemKS = nil) or (ItemKS.StdMode <> 43) then begin
    Result := -2;
    Exit;
  end;

{*********************************}
  UserItemBS := nil;
  for i := 0 to PlayObject.m_ItemList.Count - 1 do
  begin
    FindUserItem := PlayObject.m_ItemList[i];
    if (FindUserItem <> nil) and (FindUserItem.MakeIndex = BS) then begin
      UserItemBS := FindUserItem;
      break;
    end;
  end;
  ItemBS := nil;
  if (UserItemBS <> nil) then
    ItemBS := UserEngine.GetStdItem(UserItemBS.wIndex);
  if (ItemBS = nil) then begin
    Result := -3;
    Exit;
  end;
{+++++++++++++++++++++++++++++++++++}
  UserItemJLS := nil;
  for i := 0 to PlayObject.m_ItemList.Count - 1 do
  begin
    FindUserItem := PlayObject.m_ItemList[i];
    if (FindUserItem <> nil) and (FindUserItem.MakeIndex = JLS) then begin
      UserItemJLS := FindUserItem;
      break;
    end;
  end;
  if (UserItemJLS <> nil) then
    ItemJL := _MIN(100, UserItemJLS.DuraMax);

  i := g_Config.UpItemJiLu[IndexLevel];

  if ItemJL <> 0 then
    JL := _MAX(0, i - (Round(i * (ItemJL / 100))))
  else
    JL := i;
    
  IndexLevel := Random(JL);
  if IndexLevel <= 0 then
  begin
    Inc(DesItem.btUpValue[0]);
    StdItem := UserEngine.GetStdItem(DesItem.wIndex);
    if (StdItem <> nil) and (not (StdItem.StdMode in [5..6])) then begin
      DesItem.btUpValue[7] := LoWord(ItemBS.AC);
      DesItem.btUpValue[8] := HiWord(ItemBS.AC);
      DesItem.btUpValue[9] := LoWord(ItemBS.MAC);
      DesItem.btUpValue[10] := HiWord(ItemBS.MAC);
    end;
    Inc(DesItem.btUpValue[1], LoWord(ItemBS.DC));
    Inc(DesItem.btUpValue[2], HiWord(ItemBS.DC));

    Inc(DesItem.btUpValue[3], LoWord(ItemBS.MC));
    Inc(DesItem.btUpValue[4], HiWord(ItemBS.MC));

    Inc(DesItem.btUpValue[5], LoWord(ItemBS.SC));
    Inc(DesItem.btUpValue[6], HiWord(ItemBS.SC));

    {PlayObject.SysMsg(Format('DC[%d-%d],MC[%d-%d],SC[%d-%d]',
      [

      DesItem.btUpValue[1],
        DesItem.btUpValue[2],
        DesItem.btUpValue[3],
        DesItem.btUpValue[4],
        DesItem.btUpValue[5],
        DesItem.btUpValue[6]]), c_Green, t_Hint);}
    PlayObject.SysMsg('ɹ..', c_Green, t_Hint);
    PlayObject.m_nMval[0] := DesItem.btUpValue[0]; //ɱ˽ֱ
    PlayObject.m_sString[0] := UserEngine.GetStdItemName(DesItem.wIndex); //ʱ˽˱
    PlayObject.UpItemFunc; //ִнű
  end else PlayObject.SysMsg('ʧ..', c_Green, t_Hint);

  if UserItemJLS <> nil then begin
    PlayObject.m_ItemList.Delete(PlayObject.m_ItemList.IndexOf(UserItemJLS));
    Dispose(UserItemJLS);
      //MainOutMessage('Err Dispose(UserItemJLS)');
  end;
  PlayObject.m_ItemList.Remove(UserItemBS);
  Dispose(UserItemBS);

  PlayObject.m_ItemList.Remove(UserItemKS);
  Dispose(UserItemKS);
  PlayObject.DecGameGold(20);
  PlayObject.GameGoldChanged;
  PlayObject.SendAddItem(DesItem);
  {PlayObject.SysMsg(Format('Random(JL)=:%d  Config:%d  JL:%d  Level%d',
    [IndexLevel, i, JL, DesItem.btUpValue[0]]), c_Green, t_Hint); }

  Result := DesItem.btUpValue[0];

  PlayObject.m_nScriptGotoCount := 0;
end;

function TMerchant.AddItemToGoodsList(UserItem: pTUserItem): Boolean;
var
  n10: Integer;
  ItemList: TSimpleList;
begin
  Result := False;
  if UserItem.Dura <= 0 then Exit;
  ItemList := GetRefillList(UserItem.wIndex);
  if ItemList = nil then begin
    ItemList := TSimpleList.Create;
    m_GoodsList.Add(ItemList);
  end;
  ItemList.Add(UserItem);
  Result := True;
end;

function TMerchant.QueryRepairCost(PlayObject: TPlayObject; UserItem: pTUserItem): Integer;
var
  nPrice, nRepairPrice: Integer;
begin
  nPrice := GetUserPrice(PlayObject, GetUserItemPrice(UserItem));
  if (nPrice > 0) and (UserItem.DuraMax > UserItem.Dura) then begin
    if UserItem.DuraMax > 0 then begin
      nRepairPrice := ROUND(nPrice div 3 / UserItem.DuraMax * (UserItem.DuraMax - UserItem.Dura));
    end else begin
      nRepairPrice := nPrice;
    end;
    if (PlayObject.m_SellMode = smSRepair) then begin
      if m_boS_repair then
        nRepairPrice := nRepairPrice * g_Config.nSuperRepairPriceRate {3}
      else nRepairPrice := -1;
    end else  begin
      if not m_boRepair then nRepairPrice := -1;
    end;
    Result := nRepairPrice;
  end else Result := -1;
end;

function TMerchant.RepairItem(PlayObject: TPlayObject;
  UserItem: pTUserItem): Integer;
var
  nPrice, nRepairPrice: Integer;
  StdItem: pTStdItem;
begin
  Result := -1;
  nPrice := GetUserPrice(PlayObject, GetUserItemPrice(UserItem));
  if PlayObject.m_sScriptLable = sSUPERREPAIR then begin
    nPrice := nPrice * g_Config.nSuperRepairPriceRate {3};
  end;
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if StdItem <> nil then begin
    if IsBitOn(StdItem.NeedIdentify, 2) then begin
      Exit;
    end;
    if (nPrice > 0) and (UserItem.DuraMax > UserItem.Dura) and (StdItem.StdMode <> 43) then begin
      if UserItem.DuraMax > 0 then begin
        nRepairPrice := ROUND(nPrice div 3 / UserItem.DuraMax * (UserItem.DuraMax - UserItem.Dura));
      end else begin
        nRepairPrice := nPrice;
      end;
      if PlayObject.DecGold(nRepairPrice) then begin
        //        if m_boCastle or g_Config.boGetAllNpcTax then UserCastle.IncRateGold(nRepairPrice);
        if m_boCastle or g_Config.boGetAllNpcTax then begin
          if m_Castle <> nil then begin
            TUserCastle(m_Castle).IncRateGold(nRepairPrice);
          end else
            if g_Config.boGetAllNpcTax then begin
              g_CastleManager.IncRateGold(g_Config.nUpgradeWeaponPrice);
            end;
        end;
        if PlayObject.m_sScriptLable = sSUPERREPAIR then begin
          UserItem.Dura := UserItem.DuraMax;
          //PlayObject.AddAction(Self, RM_USERREPAIRITEM_OK, 0, PlayObject.m_nGold, UserItem.Dura, UserItem.DuraMax, '');
          GotoLable(PlayObject, sSUPERREPAIROK, False);
        end else begin
          Dec(UserItem.DuraMax, (UserItem.DuraMax - UserItem.Dura) div g_Config.nRepairItemDecDura {30});
          UserItem.Dura := UserItem.DuraMax;
          //PlayObject.AddAction(Self, RM_USERREPAIRITEM_OK, 0, PlayObject.m_nGold, UserItem.Dura, UserItem.DuraMax, '');
          GotoLable(PlayObject, sREPAIROK, False);
        end;
        Result := PlayObject.m_nGold;
      end else Result := -2;
    end else Result := -3;
  end;
end;

procedure TMerchant.ClearScript;
begin
  m_boBuy := False;
  m_boSell := False;
  m_boPrices := False;
  m_boStorage := False;
  m_boGetback := False;
  m_boBigStorage := False;
  m_boBigGetback := False;
  m_boUpgradenow := False;
  m_boGetBackupgnow := False;
  m_boRepair := False;
  m_boS_repair := False;
  m_boGetMarry := False;
  m_boGetMaster := False;
  m_boUseItemName := False;
  m_boHoleItem := False;
  m_boUpItem := False;
  ClearData;
  inherited ClearScript;
end;

procedure TMerchant.LoadUpgradeList;
var
  i: Integer;
begin
  for i := 0 to m_UpgradeWeaponList.Count - 1 do begin
    DisPose(pTUpgradeInfo(m_UpgradeWeaponList.Items[i]));
  end; // for
  m_UpgradeWeaponList.Clear;
  try
    //FrmDB.LoadUpgradeWeaponRecord(m_sCharName,m_UpgradeWeaponList);
    FrmDB.LoadUpgradeWeaponRecord(m_sScriptFileName + '-' + m_sMapName, m_UpgradeWeaponList);
  except
    MainOutMessage('Failure in loading upgradinglist - ' + m_sCharName);
  end;
end;

procedure TMerchant.GetMarry(PlayObject: TPlayObject; sDearName: string);
var
  MarryHuman: TPlayObject;
begin
  MarryHuman := UserEngine.GetPlayObject(sDearName);
  if (MarryHuman <> nil) and
    (MarryHuman.m_PMap = PlayObject.m_PMap) and
    (abs(PlayObject.m_nCurrX - MarryHuman.m_nCurrX) < 5) and
    (abs(PlayObject.m_nCurrY - MarryHuman.m_nCurrY) < 5) then begin
    AddMsgToUser(MarryHuman, PlayObject.m_sCharName + ' 飬ǷԸ޸Ϊޣ');
  end else begin
    Self.AddMsgToUser(PlayObject, sDearName + ' ûߣЧ');
  end;
end;

procedure TMerchant.GetMaster(PlayObject: TPlayObject; sMasterName: string);
begin

end;

//ʱļ׿棬۸

procedure TMerchant.ClearData;
var
  i, ii,code: Integer;
  UserItem: pTUserItem;
  ItemList: TList;
  ItemPrice: pTItemPrice;
const
  sExceptionMsg = '[쳣!!] NPC%s::ClearData code %d';
begin
  try
    code := 0;
    for i := 0 to m_GoodsList.Count - 1 do begin
      code := 1;
      ItemList := TList(m_GoodsList.Items[i]);
      code := 2;
      if ItemList = nil then Continue;
      code := 3;
      for ii := 0 to ItemList.Count - 1 do begin
        code := 4;
        UserItem := ItemList.Items[ii];
        code := 5;
        if UserItem <> nil then
          DisPose(UserItem);
        UserItem := nil;
        code := 6;
      end;
      code := 7;
      ItemList.Free;
      code := 8;
      ItemList:=nil;
    end;
    code := 9;
    if m_GoodsList <> nil then
    m_GoodsList.Clear;
    code := 10;
    for i := 0 to m_ItemPriceList.Count - 1 do begin
      code := 11;
      ItemPrice := m_ItemPriceList.Items[i];
      code := 12;
      if ItemPrice <> nil then
        DisPose(ItemPrice);
      ItemPrice := nil;
      code := 13;
    end;
    code := 14;
    m_ItemPriceList.Clear;
  except
    on E: Exception do begin
      MainOutMessage(Format(sExceptionMsg,[m_sCharName,code]));
      MainOutMessage(E.Message);
    end;
  end;
end;

procedure TMerchant.ChangeUseItemName(PlayObject: TPlayObject;
  sLabel, sItemName: string);
var
  sWhere: string;
  btWhere: Byte;
  UserItem: pTUserItem;
  nLabelLen: Integer;
  sMsg: string;
  sItemNewName: string;
  StdItem: pTStdItem;
begin
  sWhere := Copy(sLabel, Length(sUSEITEMNAME) + 1, Length(sLabel) - Length(sUSEITEMNAME));
  btWhere := Str_ToInt(sWhere, -1);
  if btWhere in [Low(THumItems)..High(THumItems)] then begin
    UserItem := @PlayObject.m_UseItems[btWhere];
    if UserItem.wIndex = 0 then begin
      sMsg := format(g_sYourUseItemIsNul, [GetUseItemName(btWhere)]);
      PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(PlayObject), 0, 0, sMsg);
      Exit;
    end;
    ItemUnit.DelCustomItemName(UserItem);
    if sItemName <> '' then begin
      if g_Config.boChangeUseItemNameByPlayName then begin
        ItemUnit.AddCustomItemName(UserItem, PlayObject.m_sCharName + '' + sItemName);
      end else begin
        ItemUnit.AddCustomItemName(UserItem, g_Config.sChangeUseItemName + sItemName);
      end;
    end else begin
      ItemUnit.DelCustomItemName(UserItem);
    end;
    ItemUnit.SaveCustomItemName();
    PlayObject.AddAction(PlayObject, RM_SENDUSEITEMS, 0, 0, 0, 0, '');
    PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(PlayObject), 0, 0, '');
  end;
end;

{ TTrainer }

constructor TTrainer.Create; //004A385C
begin
  inherited;
  m_dw568 := GetTickCount();
  n56C := 0;
  n570 := 0;
end;

destructor TTrainer.Destroy;
begin

  inherited;
end;

function TTrainer.Operate(ProcessMsg: pTProcessMessage): Boolean; //004A38C4
begin
  Result := False;
  if (ProcessMsg.wIdent = RM_STRUCK) or (ProcessMsg.wIdent = RM_MAGSTRUCK) then begin
    //  if (ProcessMsg.wIdent = RM_10101) or (ProcessMsg.wIdent = RM_MAGSTRUCK) then begin

    if (ProcessMsg.BaseObject = Self) { and (ProcessMsg.nParam3 <> 0)} then begin
      Inc(n56C, ProcessMsg.wParam);
      m_dw568 := GetTickCount();
      Inc(n570);
      ProcessSayMsg('ƻΪ ' + IntToStr(ProcessMsg.wParam) + ',ƽֵΪ ' + IntToStr(n56C div n570));
    end;
  end;
  if ProcessMsg.wIdent = RM_MAGSTRUCK then
    Result := inherited Operate(ProcessMsg);
end;

procedure TTrainer.Run;
begin
  m_Abil.HP := m_Abil.MaxHP;
  m_WAbil.HP := m_WAbil.MaxHP;
  if n570 > 0 then begin
    if (GetTickCount - m_dw568) > 3 * 1000 then begin
      ProcessSayMsg('ƻΪ  ' + IntToStr(n56C) + ',ƽֵΪ ' + IntToStr(n56C div n570));
      n570 := 0;
      n56C := 0;
    end;
  end;
  inherited;
end;
{ TNormNpc }

procedure TNormNpc.ActionOfAddNameDateList(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  LoadList: TStringList;
  boFound: Boolean;
  sListFileName, sLineText, sHumName, sDate: string;
begin
  sListFileName := g_Config.sEnvirDir + m_sPath + QuestActionInfo.sParam1;
  LoadList := TStringList.Create;
  if FileExists(sListFileName) then begin
    try
      LoadList.LoadFromFile(sListFileName);
    except
      MainOutMessage('loading fail.... => ' + sListFileName);
    end;
  end;
  boFound := False;
  for i := 0 to LoadList.Count - 1 do begin
    sLineText := Trim(LoadList.Strings[i]);
    sLineText := GetValidStr3(sLineText, sHumName, [' ', #9]);
    sLineText := GetValidStr3(sLineText, sDate, [' ', #9]);
    if CompareText(sHumName, PlayObject.m_sCharName) = 0 then begin
      LoadList.Strings[i] := PlayObject.m_sCharName + #9 + DateToStr(Date);
      boFound := True;
      break;
    end;
  end;
  if not boFound then
    LoadList.Add(PlayObject.m_sCharName + #9 + DateToStr(Date));
  try
    LoadList.SaveToFile(sListFileName);
  except
    MainOutMessage('saving fail.... => ' + sListFileName);
  end;
  LoadList.Free;
end;

procedure TNormNpc.ActionOfDelNameDateList(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  LoadList: TStringList;
  sLineText, sListFileName, sHumName, sDate: string;
  boFound: Boolean;
begin
  sListFileName := g_Config.sEnvirDir + m_sPath + QuestActionInfo.sParam1;
  LoadList := TStringList.Create;
  if FileExists(sListFileName) then begin
    try
      LoadList.LoadFromFile(sListFileName);
    except
      MainOutMessage('loading fail.... => ' + sListFileName);
    end;
  end;
  boFound := False;
  for i := 0 to LoadList.Count - 1 do begin
    sLineText := Trim(LoadList.Strings[i]);
    sLineText := GetValidStr3(sLineText, sHumName, [' ', #9]);
    sLineText := GetValidStr3(sLineText, sDate, [' ', #9]);
    if CompareText(sHumName, PlayObject.m_sCharName) = 0 then begin
      LoadList.Delete(i);
      boFound := True;
      break;
    end;
  end;
  if boFound then begin
    try
      LoadList.SaveToFile(sListFileName);
    except
      MainOutMessage('saving fail.... => ' + sListFileName);
    end;
  end;
  LoadList.Free;
end;

procedure TNormNpc.ActionOfAddSkill(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  Magic: pTMagic;
  UserMagic: pTUserMagic;
  nLevel: Integer;
begin
  nLevel := _MIN(3, Str_ToInt(QuestActionInfo.sParam2, 0));
  Magic := UserEngine.FindMagic(QuestActionInfo.sParam1);
  if Magic <> nil then begin
    if not PlayObject.IsTrainingSkill(Magic.wMagicId) then begin
      New(UserMagic);
      UserMagic.MagicInfo := Magic;
      UserMagic.wMagIdx := Magic.wMagicId;
      UserMagic.btKey := 0;
      UserMagic.btLevel := nLevel;
      UserMagic.nTranPoint := 0;
      PlayObject.m_MagicList.Add(UserMagic);
      PlayObject.SendAddMagic(UserMagic);
      PlayObject.RecalcAbilitys();
      if g_Config.boShowScriptActionMsg then begin
        PlayObject.SysMsg(Magic.sMagicName + 'ϰɹ', c_Green, t_Hint);
      end;
    end;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ADDSKILL);
  end;
end;


//SETAUTOGETEXP ʱ  Ƿȫ ͼ

procedure TNormNpc.ActionOfAutoGetExp(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nTime, nPoint: Integer;
  boIsSafeZone: Boolean;
  sMAP: string;
  Map: TMap;
begin
  Map := nil;
  nTime := Str_ToInt(QuestActionInfo.sParam1, -1);
  nPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  boIsSafeZone := QuestActionInfo.sParam3[1] = '1';
  sMAP := QuestActionInfo.sParam4;
  if sMAP <> '' then begin
    Map := g_MapManager.FindMap(sMAP);
  end;
  if (nTime <= 0) or (nPoint <= 0) or ((sMAP <> '') and (Map = nil)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETAUTOGETEXP);
    Exit;
  end;
  PlayObject.m_boAutoGetExpInSafeZone := boIsSafeZone;
  PlayObject.m_AutoGetExpEnvir := Map;
  PlayObject.m_nAutoGetExpTime := nTime * 1000;
  PlayObject.m_nAutoGetExpPoint := nPoint;
end;



procedure TNormNpc.ActionOfChangeCreditPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  boChgOK: Boolean;
  nCreditPoint: Integer;
  nLv: Integer;
  nOldLevel: Integer;
  cMethod: Char;
  dwInt: LongWord;
begin
  boChgOK := False;
  nCreditPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nCreditPoint < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nCreditPoint)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CREDITPOINT);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if nCreditPoint >= 0 then begin
          if nCreditPoint > High(Byte) then begin
            PlayObject.m_btCreditPoint := High(Byte);
          end else begin
            PlayObject.m_btCreditPoint := nCreditPoint;
          end;
        end;
      end;
    '-': begin
        if PlayObject.m_btCreditPoint > Byte(nCreditPoint) then begin
          Dec(PlayObject.m_btCreditPoint, Byte(nCreditPoint));
        end else begin
          PlayObject.m_btCreditPoint := 0;
        end;
      end;
    '+': begin
        if PlayObject.m_btCreditPoint + Byte(nCreditPoint) > High(Byte) then begin
          PlayObject.m_btCreditPoint := High(Byte);
        end else begin
          Inc(PlayObject.m_btCreditPoint, Byte(nCreditPoint));
        end;
      end;
  else begin
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CREDITPOINT);
      Exit;
    end;
  end;
end;

procedure TNormNpc.ActionOfChangeExp(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  boChgOK: Boolean;
  nExp: Integer;
  nLv: Integer;
  nOldLevel: Integer;
  cMethod: Char;
  dwInt: LongWord;
begin
  boChgOK := False;
  nExp := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nExp < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nExp)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEEXP);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if nExp >= 0 then begin
          PlayObject.m_Abil.Exp := LongWord(nExp);
          dwInt := LongWord(nExp);
        end;
      end;
    '-': begin
        if PlayObject.m_Abil.Exp > LongWord(nExp) then begin
          Dec(PlayObject.m_Abil.Exp, LongWord(nExp));
        end else begin
          PlayObject.m_Abil.Exp := 0;
        end;
      end;
    '+': begin
        if PlayObject.m_Abil.Exp >= LongWord(nExp) then begin
          if (PlayObject.m_Abil.Exp - LongWord(nExp)) > (High(LongWord) - PlayObject.m_Abil.Exp) then begin
            dwInt := High(LongWord) - PlayObject.m_Abil.Exp;
          end else begin
            dwInt := LongWord(nExp);
          end;
        end else begin
          if (LongWord(nExp) - PlayObject.m_Abil.Exp) > (High(LongWord) - LongWord(nExp)) then begin
            dwInt := High(LongWord) - LongWord(nExp);
          end else begin
            dwInt := LongWord(nExp);
          end;
        end;
        //if PlayObject.m_Abil.Exp + dwInt >= PlayObject.m_Abil.MaxExp then
        //Inc(PlayObject.m_Abil.Exp, dwInt);
        PlayObject.GetExp(dwInt);
        //PlayObject.AddAction(PlayObject, RM_WINEXP, 0, dwInt, 0, 0, '');
      end;
  end;
end;

procedure TNormNpc.ActionOfChangeHairStyle(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nHair: Integer;
begin
  nHair := Str_ToInt(QuestActionInfo.sParam1, -1);
  if (QuestActionInfo.sParam1 <> '') and (nHair >= 0) then begin
    PlayObject.m_btHair := nHair;
    PlayObject.FeatureChanged;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_HAIRSTYLE);
  end;
end;

procedure TNormNpc.ActionOfChangeJob(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nJob: Integer;
begin
  nJob := -1;
  if CompareLStr(QuestActionInfo.sParam1, sWARRIOR, 3) then nJob := 0;
  if CompareLStr(QuestActionInfo.sParam1, sWIZARD, 3) then nJob := 1;
  if CompareLStr(QuestActionInfo.sParam1, sTAOS, 3) then nJob := 2;

  if nJob < 0 then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEJOB);
    Exit;
  end;

  if PlayObject.m_btJob <> nJob then begin
    PlayObject.m_btJob := nJob;
    {
    PlayObject.RecalcLevelAbilitys();
    PlayObject.RecalcAbilitys();
    }
    PlayObject.HasLevelUp(0);
  end;
end;

procedure TNormNpc.ActionOfChangeLevel(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  boChgOK: Boolean;
  nLevel: Integer;
  nLv: Integer;
  nOldLevel: Integer;
  cMethod: Char;
begin
  boChgOK := False;
  nOldLevel := PlayObject.m_Abil.Level;
  nLevel := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nLevel < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nLevel)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGELEVEL);
    Exit;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nLevel > 0) and (nLevel <= MAXLEVEL) then begin
          PlayObject.m_Abil.Level := nLevel;
          boChgOK := True;
        end;
      end;
    '-': begin
        nLv := _MAX(0, PlayObject.m_Abil.Level - nLevel);
        nLv := _MIN(MAXLEVEL, nLv);
        PlayObject.m_Abil.Level := nLv;
        boChgOK := True;
      end;
    '+': begin
        nLv := _MAX(0, PlayObject.m_Abil.Level + nLevel);
        nLv := _MIN(MAXLEVEL, nLv);
        PlayObject.m_Abil.Level := nLv;
        boChgOK := True;
      end;
  end;
  if boChgOK then
    PlayObject.HasLevelUp(nOldLevel);
end;

procedure TNormNpc.ActionOfChangePkPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nPKPOINT: Integer;
  nPoint: Integer;
  nOldPKLevel: Integer;
  cMethod: Char;
begin
  nOldPKLevel := PlayObject.PKLevel;
  nPKPOINT := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nPKPOINT < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nPKPOINT)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEPKPOINT);
    Exit;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nPKPOINT >= 0) then begin
          PlayObject.m_wPkPoint := nPKPOINT;
        end;
      end;
    '-': begin
        nPoint := _MAX(0, PlayObject.m_wPkPoint - nPKPOINT);
        PlayObject.m_wPkPoint := nPoint;
      end;
    '+': begin
        nPoint := _MAX(0, PlayObject.m_wPkPoint + nPKPOINT);
        PlayObject.m_wPkPoint := nPoint;
      end;
  end;
  if nOldPKLevel <> PlayObject.PKLevel then
    PlayObject.RefNameColor;
end;

procedure TNormNpc.ActionOfClearMapMon(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  MonList: TList;
  mon: TBaseObject;
  ii: Integer;
begin
  MonList := TList.Create;
  UserEngine.GetMapMonster(g_MapManager.FindMap(QuestActionInfo.sParam1), MonList);
  for ii := 0 to MonList.Count - 1 do begin
    mon := TBaseObject(MonList.Items[ii]);
    if mon.m_Master <> nil then Continue;
    if GetNoClearMonList(mon.m_sCharName) then Continue;

    mon.m_boNoItem := True;
    mon.MakeGhost;
  end;
  MonList.Free;
end;

procedure TNormNpc.ActionOfClearNameList(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  LoadList: TStringList;
  sListFileName: string;
begin
  sListFileName := g_Config.sEnvirDir + m_sPath + QuestActionInfo.sParam1;
  LoadList := TStringList.Create;
  {
  if FileExists(sListFileName) then begin
    try
      LoadList.LoadFromFile(sListFileName);
    except
      MainOutMessage('loading fail.... => ' + sListFileName);
    end;
  end;
  }
  LoadList.Clear;
  try
    LoadList.SaveToFile(sListFileName);
  except
    MainOutMessage('saving fail.... => ' + sListFileName);
  end;
  LoadList.Free;
end;

procedure TNormNpc.ActionOfClearSkill(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  UserMagic: pTUserMagic;
begin
  for i := PlayObject.m_MagicList.Count - 1 downto 0 do begin
    UserMagic := PlayObject.m_MagicList.Items[i];
    PlayObject.SendDelMagic(UserMagic);
    DisPose(UserMagic);
    PlayObject.m_MagicList.Delete(i);
  end;
  PlayObject.RecalcAbilitys();
end;

procedure TNormNpc.ActionOfDelNoJobSkill(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  UserMagic: pTUserMagic;
begin
  for i := PlayObject.m_MagicList.Count - 1 downto 0 do begin
    if PlayObject.m_MagicList.Count <= 0 then break;
    UserMagic := PlayObject.m_MagicList.Items[i];
    if UserMagic = nil then Continue;
    if UserMagic.MagicInfo.btJob <> PlayObject.m_btJob then begin
      PlayObject.SendDelMagic(UserMagic);
      DisPose(UserMagic);
      PlayObject.m_MagicList.Delete(i);
    end;
  end;
end;

procedure TNormNpc.ActionOfDelSkill(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sMagicName: string;
  Magic: pTMagic;
  UserMagic: pTUserMagic;
begin
  sMagicName := QuestActionInfo.sParam1;
  Magic := UserEngine.FindMagic(sMagicName);
  if Magic = nil then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_DELSKILL);
    Exit;
  end;
  for i := PlayObject.m_MagicList.Count - 1 downto 0 do begin
    if PlayObject.m_MagicList.Count <= 0 then break;
    UserMagic := PlayObject.m_MagicList.Items[i];
    if UserMagic = nil then Continue;
    if UserMagic.MagicInfo = Magic then begin
      PlayObject.m_MagicList.Delete(i);
      PlayObject.SendDelMagic(UserMagic);
      DisPose(UserMagic);
      PlayObject.RecalcAbilitys();
      break;
    end;
  end;

end;

procedure TNormNpc.ActionOfHUEICHENGCOUNT(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nVal: Integer;
  nOld: Integer;
  cMethod: Char;
begin
  nOld := PlayObject.m_btHueiChengCount;
  nVal := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nVal < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nVal)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETHUEICHENGCOUNT);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nVal >= 0) then begin
          PlayObject.m_btHueiChengCount := nVal;
        end;
      end;
    '-': begin
        nVal := _MAX(0, PlayObject.m_btHueiChengCount - nVal);
        PlayObject.m_btHueiChengCount := nVal;
      end;
    '+': begin
        nVal := _MAX(0, PlayObject.m_btHueiChengCount + nVal);
        PlayObject.m_btHueiChengCount := nVal;
      end;
  end;
  if nOld <> PlayObject.m_btHueiChengCount then
    PlayObject.GameGoldChanged;
end;

procedure TNormNpc.ActionOfSueiJiCount(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nVal: Integer;
  nOld: Integer;
  cMethod: Char;
begin
  nOld := PlayObject.m_btSueiJiCount;
  nVal := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nVal < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nVal)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETSUEIJICOUNT);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nVal >= 0) then begin
          PlayObject.m_btSueiJiCount := nVal;
        end;
      end;
    '-': begin
        nVal := _MAX(0, PlayObject.m_btSueiJiCount - nVal);
        PlayObject.m_btSueiJiCount := nVal;
      end;
    '+': begin
        nVal := _MAX(0, PlayObject.m_btSueiJiCount + nVal);
        PlayObject.m_btSueiJiCount := nVal;
      end;
  end;
  if nOld <> PlayObject.m_btSueiJiCount then
    PlayObject.GameGoldChanged;
end;

procedure TNormNpc.ActionOfGameGold(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nGameGold: Integer;
  nOldGameGold: Integer;
  cMethod: Char;
begin
  nOldGameGold := PlayObject.m_nGameGold;
  nGameGold := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nGameGold < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nGameGold)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_GAMEGOLD);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nGameGold >= 0) then begin
          PlayObject.m_nGameGold := nGameGold;
        end;
      end;
    '-': begin
        nGameGold := _MAX(0, PlayObject.m_nGameGold - nGameGold);
        PlayObject.m_nGameGold := nGameGold;
      end;
    '+': begin
        nGameGold := _MAX(0, PlayObject.m_nGameGold + nGameGold);
        PlayObject.m_nGameGold := nGameGold;
      end;
  end;
  //'%d'#9'%s'#9'%d'#9'%d'#9'%s'#9'%s'#9'%d'#9'%s'#9'%s'
  if g_boGameLogGameGold then begin
    AddGameDataLog(format(g_sGameLogMsg1, [LOG_GAMEGOLD,
      PlayObject.m_sMapName,
        PlayObject.m_nCurrX,
        PlayObject.m_nCurrY,
        PlayObject.m_sCharName,
        g_Config.sGameGoldName,
        nGameGold,
        cMethod,
        m_sCharName]));
  end;
  if nOldGameGold <> PlayObject.m_nGameGold then
    PlayObject.GameGoldChanged;
end;

procedure TNormNpc.ActionOfGamePoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nGamePoint: Integer;
  nOldGamePoint: Integer;
  cMethod: Char;
begin
  nOldGamePoint := PlayObject.m_nGamePoint;
  nGamePoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nGamePoint < 0) and (not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nGamePoint)) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_GAMEPOINT);
    Exit;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        if (nGamePoint >= 0) then begin
          PlayObject.m_nGamePoint := nGamePoint;
        end;
      end;
    '-': begin
        nGamePoint := _MAX(0, PlayObject.m_nGamePoint - nGamePoint);
        PlayObject.m_nGamePoint := nGamePoint;
      end;
    '+': begin
        nGamePoint := _MAX(0, PlayObject.m_nGamePoint + nGamePoint);
        PlayObject.m_nGamePoint := nGamePoint;
      end;
  end;
  //'%d'#9'%s'#9'%d'#9'%d'#9'%s'#9'%s'#9'%d'#9'%s'#9'%s'
  if g_boGameLogGamePoint then begin
    AddGameDataLog(format(g_sGameLogMsg1, [LOG_GAMEPOINT,
      PlayObject.m_sMapName,
        PlayObject.m_nCurrX,
        PlayObject.m_nCurrY,
        PlayObject.m_sCharName,
        g_Config.sGamePointName,
        nGamePoint,
        cMethod,
        m_sCharName]));
  end;
  if nOldGamePoint <> PlayObject.m_nGamePoint then
    PlayObject.GameGoldChanged;
end;

procedure TNormNpc.ActionOfGetMarry(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseBaseObject: TBaseObject;
begin
  PoseBaseObject := PlayObject.GetPoseCreate();
  if (PoseBaseObject <> nil) and (PoseBaseObject.m_btRaceServer = RC_PLAYOBJECT) and (PoseBaseObject.m_btGender <> PlayObject.m_btGender) then begin
    PlayObject.m_sDearName := PoseBaseObject.m_sCharName;
    PlayObject.RefShowName;
    PoseBaseObject.RefShowName;
  end else begin
    GotoLable(PlayObject, '@MarryError', False);
  end;
end;

procedure TNormNpc.ActionOfGetMaster(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseBaseObject: TBaseObject;
begin
  PoseBaseObject := PlayObject.GetPoseCreate();
  if (PoseBaseObject <> nil) and (PoseBaseObject.m_btRaceServer = RC_PLAYOBJECT) and (PoseBaseObject.m_btGender <> PlayObject.m_btGender) then begin
    PlayObject.m_sMasterName := PoseBaseObject.m_sCharName;
    PlayObject.RefShowName;
    PoseBaseObject.RefShowName;
  end else begin
    GotoLable(PlayObject, '@MasterError', False);
  end;
end;

procedure TNormNpc.ActionOfLineMsg(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  sMsg: string;
  sParam2: string;

begin
  sParam2 := QuestActionInfo.sParam2;
  ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, sParam2);
  sMsg := GetLineVariableText(PlayObject, sParam2);
  sMsg := AnsiReplaceText(sMsg, '%s', PlayObject.m_sCharName);
  sMsg := AnsiReplaceText(sMsg, '%x', IntToStr(PlayObject.m_nCurrX));
  sMsg := AnsiReplaceText(sMsg, '%y', IntToStr(PlayObject.m_nCurrY));
  if PlayObject.m_PMap <> nil then
    sMsg := AnsiReplaceText(sMsg, '%m', PlayObject.m_PMap.sMapDesc)
  else sMsg := AnsiReplaceText(sMsg, '%m', '????');
  sMsg := AnsiReplaceText(sMsg, '%d', m_sCharName);
  
  case QuestActionInfo.nParam1 of
    0: UserEngine.SendBroadCastMsg(sMsg, t_System);
    1: UserEngine.SendBroadCastMsg('(*) ' + sMsg, t_System);
    2: UserEngine.SendBroadCastMsg('[' + m_sCharName + ']' + sMsg, t_System);
    3: UserEngine.SendBroadCastMsg('[' + PlayObject.m_sCharName + ']' + sMsg, t_System);
    4: ProcessSayMsg(sMsg);
    5: PlayObject.SysMsg(sMsg, c_Red, t_Hint);
    6: PlayObject.SysMsg(sMsg, c_Green, t_Hint);
    7: PlayObject.SysMsg(sMsg, c_Blue, t_Hint);
    8: UserEngine.SendBroadCastMsg(sMsg, t_TopHint);
    
  else begin
      ScriptActionError(PlayObject, 'Ϣʹ', QuestActionInfo, sSENDMESG);
    end;
  end;
end;



procedure TNormNpc.ActionOfMarry(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseHuman: TPlayObject;
  sSayMsg: string;
begin
  if PlayObject.m_sDearName <> '' then Exit;
  PoseHuman := TPlayObject(PlayObject.GetPoseCreate());
  if PoseHuman = nil then begin
    GotoLable(PlayObject, '@MarryCheckDir', False);
    Exit;
  end;
  if QuestActionInfo.sParam1 = '' then begin
    if PoseHuman.m_btRaceServer <> RC_PLAYOBJECT then begin
      GotoLable(PlayObject, '@HumanTypeErr', False);
      Exit;
    end;
    if PoseHuman.GetPoseCreate = PlayObject then begin
      if PlayObject.m_btGender <> PoseHuman.m_btGender then begin
        GotoLable(PlayObject, '@StartMarry', False);
        GotoLable(PoseHuman, '@StartMarry', False);
        if (PlayObject.m_btGender = 0) and (PoseHuman.m_btGender = 1) then begin
          sSayMsg := AnsiReplaceText(g_sStartMarryManMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
          sSayMsg := AnsiReplaceText(g_sStartMarryManAskQuestionMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
        end else if (PlayObject.m_btGender = 1) and (PoseHuman.m_btGender = 0) then begin
          sSayMsg := AnsiReplaceText(g_sStartMarryWoManMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
          sSayMsg := AnsiReplaceText(g_sStartMarryWoManAskQuestionMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
        end;
        PlayObject.m_boStartMarry := True;
        PoseHuman.m_boStartMarry := True;
      end else begin
        GotoLable(PoseHuman, '@MarrySexErr', False);
        GotoLable(PlayObject, '@MarrySexErr', False);
      end;
    end else begin
      GotoLable(PlayObject, '@MarryDirErr', False);
      GotoLable(PoseHuman, '@MarryCheckDir', False);
    end;
    Exit;
  end;
  if CompareText(QuestActionInfo.sParam1, 'REQUESTMARRY' {sREQUESTMARRY}) = 0 then begin
    if PlayObject.m_boStartMarry and PoseHuman.m_boStartMarry then begin
      if (PlayObject.m_btGender = 0) and (PoseHuman.m_btGender = 1) then begin
        sSayMsg := AnsiReplaceText(g_sMarryManAnswerQuestionMsg, '%n', m_sCharName);
        sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
        sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
        UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
        sSayMsg := AnsiReplaceText(g_sMarryManAskQuestionMsg, '%n', m_sCharName);
        sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
        sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
        UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
        GotoLable(PlayObject, '@WateMarry', False);
        GotoLable(PoseHuman, '@RevMarry', False);
      end;
    end;
    Exit;
  end;
  if CompareText(QuestActionInfo.sParam1, 'RESPONSEMARRY' {sRESPONSEMARRY}) = 0 then begin
    if (PlayObject.m_btGender = 1) and (PoseHuman.m_btGender = 0) then begin
      if CompareText(QuestActionInfo.sParam2, 'OK') = 0 then begin
        if PlayObject.m_boStartMarry and PoseHuman.m_boStartMarry then begin
          sSayMsg := AnsiReplaceText(g_sMarryWoManAnswerQuestionMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
          sSayMsg := AnsiReplaceText(g_sMarryWoManGetMarryMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
          GotoLable(PlayObject, '@EndMarry', False);
          GotoLable(PoseHuman, '@EndMarry', False);
          PlayObject.m_boStartMarry := False;
          PoseHuman.m_boStartMarry := False;
          PlayObject.m_sDearName := PoseHuman.m_sCharName;
          PlayObject.m_DearHuman := PoseHuman;
          PoseHuman.m_sDearName := PlayObject.m_sCharName;
          PoseHuman.m_DearHuman := PlayObject;
          PlayObject.RefShowName;
          PoseHuman.RefShowName;
        end;
      end else begin
        if PlayObject.m_boStartMarry and PoseHuman.m_boStartMarry then begin
          GotoLable(PlayObject, '@EndMarryFail', False);
          GotoLable(PoseHuman, '@EndMarryFail', False);
          PlayObject.m_boStartMarry := False;
          PoseHuman.m_boStartMarry := False;
          sSayMsg := AnsiReplaceText(g_sMarryWoManDenyMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
          sSayMsg := AnsiReplaceText(g_sMarryWoManCancelMsg, '%n', m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%s', PlayObject.m_sCharName);
          sSayMsg := AnsiReplaceText(sSayMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sSayMsg, t_Say);
        end;
      end;
    end;
    Exit;
  end;
end;

procedure TNormNpc.ActionOfMaster(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseHuman: TPlayObject;
  sSayMsg: string;
begin
  if PlayObject.m_sMasterName <> '' then Exit;
  PoseHuman := TPlayObject(PlayObject.GetPoseCreate());
  if PoseHuman = nil then begin
    GotoLable(PlayObject, '@MasterCheckDir', False);
    Exit;
  end;
  if QuestActionInfo.sParam1 = '' then begin
    if PoseHuman.m_btRaceServer <> RC_PLAYOBJECT then begin
      GotoLable(PlayObject, '@HumanTypeErr', False);
      Exit;
    end;
    if PoseHuman.GetPoseCreate = PlayObject then begin
      GotoLable(PlayObject, '@StartGetMaster', False);
      GotoLable(PoseHuman, '@StartMaster', False);
      PlayObject.m_boStartMaster := True;
      PoseHuman.m_boStartMaster := True;
    end else begin
      GotoLable(PlayObject, '@MasterDirErr', False);
      GotoLable(PoseHuman, '@MasterCheckDir', False);
    end;
    Exit;
  end;
  if CompareText(QuestActionInfo.sParam1, 'REQUESTMASTER') = 0 then begin
    if PlayObject.m_boStartMaster and PoseHuman.m_boStartMaster then begin
      PlayObject.m_PoseBaseObject := PoseHuman;
      PoseHuman.m_PoseBaseObject := PlayObject;
      GotoLable(PlayObject, '@WateMaster', False);
      GotoLable(PoseHuman, '@RevMaster', False);
    end;
    Exit;
  end;
  if CompareText(QuestActionInfo.sParam1, 'RESPONSEMASTER') = 0 then begin
    if CompareText(QuestActionInfo.sParam2, 'OK') = 0 then begin
      if (PlayObject.m_PoseBaseObject = PoseHuman) and (PoseHuman.m_PoseBaseObject = PlayObject) then begin
        if PlayObject.m_boStartMaster and PoseHuman.m_boStartMaster then begin
          GotoLable(PlayObject, '@EndMaster', False);
          GotoLable(PoseHuman, '@EndMaster', False);
          PlayObject.m_boStartMaster := False;
          PoseHuman.m_boStartMaster := False;
          if PlayObject.m_sMasterName = '' then begin
            PlayObject.m_sMasterName := PoseHuman.m_sCharName;
            PlayObject.m_boMaster := True;
          end;
          PlayObject.m_MasterList.Add(PoseHuman);
          PoseHuman.m_sMasterName := PlayObject.m_sCharName;
          PoseHuman.m_boMaster := False;
          PlayObject.RefShowName;
          PoseHuman.RefShowName;
        end;
      end;
    end else begin
      if PlayObject.m_boStartMaster and PoseHuman.m_boStartMaster then begin
        GotoLable(PlayObject, '@EndMasterFail', False);
        GotoLable(PoseHuman, '@EndMasterFail', False);
        PlayObject.m_boStartMaster := False;
        PoseHuman.m_boStartMaster := False;
      end;
    end;
    Exit;
  end;
end;

procedure TNormNpc.ActionOfMessageBox(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  sParam1: string;
begin
  sParam1 := QuestActionInfo.sParam1;
  ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, sParam1);
  PlayObject.AddAction(Self, RM_MENU_OK, 0, Integer(PlayObject), 0, 0, GetLineVariableText(PlayObject, sParam1));
end;

procedure TNormNpc.ActionOfMission(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  if (QuestActionInfo.sParam1 <> '') and (QuestActionInfo.nParam2 > 0) and (QuestActionInfo.nParam3 > 0) then begin
    g_sMissionMap := QuestActionInfo.sParam1;
    g_nMissionX := QuestActionInfo.nParam2;
    g_nMissionY := QuestActionInfo.nParam3;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_MISSION);
  end;
end;

//MOBFIREBURN MAP X Y TYPE TIME POINT

procedure TNormNpc.ActionOfMobFireBurn(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  sMAP: string;
  nX, nY, nType, nTime, nPoint: Integer;
  FireBurnEvent: TFireBurnEvent;
  Map: TMap;
  OldMap: TMap;
begin
  sMAP := QuestActionInfo.sParam1;
  nX := Str_ToInt(QuestActionInfo.sParam2, -1);
  nY := Str_ToInt(QuestActionInfo.sParam3, -1);
  nType := Str_ToInt(QuestActionInfo.sParam4, -1);
  nTime := Str_ToInt(QuestActionInfo.sParam5, -1);
  nPoint := Str_ToInt(QuestActionInfo.sParam6, -1);
  if (sMAP = '') or (nX < 0) or (nY < 0) or (nType < 0) or (nTime < 0) or (nPoint < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_MOBFIREBURN);
    Exit;
  end;
  Map := g_MapManager.FindMap(sMAP);
  if Map <> nil then begin
    OldMap := PlayObject.m_PMap;
    PlayObject.m_PMap := Map;
    FireBurnEvent := TFireBurnEvent.Create(PlayObject, nX, nY, nType, nTime * 1000, nPoint);
    g_EventManager.AddEvent(FireBurnEvent);
    PlayObject.m_PMap := OldMap;
    Exit;
  end;
  ScriptActionError(PlayObject, '', QuestActionInfo, sSC_MOBFIREBURN);
end;

procedure TNormNpc.ActionOfMobPlace(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo; nX, nY, nCount, nRange: Integer);
var
  i: Integer;
  nRandX, nRandY: Integer;
  mon: TBaseObject;
begin
  for i := 0 to nCount - 1 do begin
    nRandX := Random(nRange * 2 + 1) + (nX - nRange);
    nRandY := Random(nRange * 2 + 1) + (nY - nRange);
    mon := UserEngine.RegenMonsterByName(g_sMissionMap, nRandX, nRandY, QuestActionInfo.sParam1);
    if mon <> nil then begin
      mon.m_boMission := True;
      mon.m_nMissionX := g_nMissionX;
      mon.m_nMissionY := g_nMissionY;
    end else begin
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_MOBPLACE);
      break;
    end;
  end;
end;

procedure TNormNpc.ActionOfRecallGroupMembers(PlayObject: TPlayObject;QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  TagPlay: TPlayObject;
begin   
  with PlayObject do begin
    if m_GroupOwner = Self then begin
      for i := 1 to m_GroupMembers.Count - 1 do begin
        TagPlay := TPlayObject(m_GroupMembers.Objects[i]);
        if TagPlay.m_boAllowGroupReCall then begin
          if TagPlay.m_PMap.m_boNORECALL then begin
            SysMsg(format('%s ڵĵͼ͡', [TagPlay.m_sCharName]), c_Red, t_Hint);
          end else begin
            RecallHuman(TagPlay.m_sCharName);
          end;
        end else begin
          SysMsg(format('%s غһ', [TagPlay.m_sCharName]), c_Red, t_Hint);
        end;
      end;
    end;
  end;
end;

procedure TNormNpc.ActionOfSetRankLevelName(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  DynamicVar: pTDynamicVar;
  DynamicVarList: TSimpleList;
  sName: string;
  boVarFound: Boolean;
  sRankLevelName: string;
  n10: Integer;
const
  sVarFound = '%sڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  sRankLevelName := QuestActionInfo.sParam1;
  if sRankLevelName = '' then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SKILLLEVEL);
    Exit;
  end;
  if QuestActionInfo.sParam2 <> '' then begin
    boVarFound := False;
    DynamicVarList := GetDynamicVarList(PlayObject, sRankLevelName, sName);
    if DynamicVarList = nil then begin
      DisPose(DynamicVar);
      ScriptActionError(PlayObject, format(sVarTypeError, [sRankLevelName]), QuestActionInfo, sSC_SETRANKLEVELNAME);
      Exit;
    end;
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if CompareText(DynamicVar.sName, QuestActionInfo.sParam2) = 0 then begin
        case DynamicVar.VarType of
          vInteger: begin
            end;
          vString: begin
              sRankLevelName := DynamicVar.sString;
            end;
        end;
        boVarFound := True;
        break;
      end;
    end;
    if not boVarFound then begin
      ScriptActionError(PlayObject, format(sVarFound, [QuestActionInfo.sParam2, QuestActionInfo.sParam1]), QuestActionInfo, sSC_SETRANKLEVELNAME);
      Exit;
    end;
  end else begin
    n10 := GetValNameNo(sRankLevelName);
    if n10 >= 0 then begin
      case n10 of
        600..699: begin
            sRankLevelName := PlayObject.m_sString[n10 - 600];
          end;
        700..799: begin
            sRankLevelName := g_Config.sGlobalAVal[n10 - 700];
          end;
      end;
    end;
  end;
  if sRankLevelName = '' then begin
    sRankLevelName := g_sRankLevelName;
  end else
    if (UpCase(sRankLevelName[1]) <> '%') and (UpCase(sRankLevelName[2]) <> 's') then begin
      sRankLevelName := '%s\' + sRankLevelName;
    end;
  PlayObject.m_sRankLevelName := sRankLevelName;
  PlayObject.RefShowName;
end;



procedure TNormNpc.ActionOfSkillLevel(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  Magic: pTMagic;
  UserMagic: pTUserMagic;
  nLevel: Integer;
  cMethod: Char;
begin
  nLevel := Str_ToInt(QuestActionInfo.sParam3, 0);
  if nLevel < 0 then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SKILLLEVEL);
    Exit;
  end;
  cMethod := QuestActionInfo.sParam2[1];
  Magic := UserEngine.FindMagic(QuestActionInfo.sParam1);
  if Magic <> nil then begin
    for i := 0 to PlayObject.m_MagicList.Count - 1 do begin
      UserMagic := PlayObject.m_MagicList.Items[i];
      if UserMagic.MagicInfo = Magic then begin
        case cMethod of
          '=': begin
              if nLevel >= 0 then begin
                nLevel := _MAX(3, nLevel);
                UserMagic.btLevel := nLevel;
              end;
            end;
          '-': begin
              if UserMagic.btLevel >= nLevel then begin
                Dec(UserMagic.btLevel, nLevel);
              end else begin
                UserMagic.btLevel := 0;
              end;
            end;
          '+': begin
              if UserMagic.btLevel + nLevel <= 3 then begin
                Inc(UserMagic.btLevel, nLevel);
              end else begin
                UserMagic.btLevel := 3;
              end;
            end;
        end;
        PlayObject.AddDelayAction(PlayObject, RM_MAGIC_LVEXP, 0, UserMagic.MagicInfo.wMagicId, UserMagic.btLevel, UserMagic.nTranPoint, '', 100);
        break;
      end;
    end;
  end;
end;

procedure TNormNpc.ActionOfTakeCastleGold(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nGold: Integer;
begin
  nGold := Str_ToInt(QuestActionInfo.sParam1, -1);
  if nGold < 0 then
    ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nGold);
  if (nGold < 0) or (m_Castle = nil) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_TAKECASTLEGOLD);
    Exit;
  end;
  if nGold <= TUserCastle(m_Castle).m_nTotalGold then begin
    Dec(TUserCastle(m_Castle).m_nTotalGold, nGold);
  end else begin
    TUserCastle(m_Castle).m_nTotalGold := 0;
  end;
end;





procedure TNormNpc.ActionOfUnMarry(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseHuman: TPlayObject;
  LoadList: TStringList;
  sUnMarryFileName: string;
begin
  if PlayObject.m_sDearName = '' then begin
    GotoLable(PlayObject, '@ExeMarryFail', False);
    Exit;
  end;
  PoseHuman := TPlayObject(PlayObject.GetPoseCreate);
  if PoseHuman = nil then begin
    GotoLable(PlayObject, '@UnMarryCheckDir', False);
  end;
  if PoseHuman <> nil then begin
    if QuestActionInfo.sParam1 = '' then begin
      if PoseHuman.m_btRaceServer <> RC_PLAYOBJECT then begin
        GotoLable(PlayObject, '@UnMarryTypeErr', False);
        Exit;
      end;
      if PoseHuman.GetPoseCreate = PlayObject then begin
        if (PlayObject.m_sDearName = PoseHuman.m_sCharName) {and (PosHum.AddInfo.sDearName = Hum.sName)} then begin
          GotoLable(PlayObject, '@StartUnMarry', False);
          GotoLable(PoseHuman, '@StartUnMarry', False);
          Exit;
        end;
      end;
    end;
  end;
  if (CompareText(QuestActionInfo.sParam1, 'REQUESTUNMARRY' {sREQUESTUNMARRY}) = 0) then begin
    if (QuestActionInfo.sParam2 = '') then begin
      if PoseHuman <> nil then begin
        PlayObject.m_boStartUnMarry := True;
        if PlayObject.m_boStartUnMarry and PoseHuman.m_boStartUnMarry then begin
          UserEngine.SendBroadCastMsg('[' + m_sCharName + ']: ' + '' {sUnMarryMsg8} + PoseHuman.m_sCharName + ' ' + '' {sMarryMsg0} + PlayObject.m_sCharName + ' ' + ' ' + 'ʽ޹ϵ' {sUnMarryMsg9}, t_Say);
          PlayObject.m_sDearName := '';
          PoseHuman.m_sDearName := '';
          Inc(PlayObject.m_btMarryCount);
          Inc(PoseHuman.m_btMarryCount);
          PlayObject.m_boStartUnMarry := False;
          PoseHuman.m_boStartUnMarry := False;
          PlayObject.RefShowName;
          PoseHuman.RefShowName;
          GotoLable(PlayObject, '@UnMarryEnd', False);
          GotoLable(PoseHuman, '@UnMarryEnd', False);
        end else begin
          GotoLable(PlayObject, '@WateUnMarry', False);
          //          GotoLable(PoseHuman,'@RevUnMarry',False);
        end;
      end;
      Exit;
    end else begin
      //ǿ
      if (CompareText(QuestActionInfo.sParam2, 'FORCE') = 0) then begin
        UserEngine.SendBroadCastMsg('[' + m_sCharName + ']: ' + '' {sUnMarryMsg8} + PlayObject.m_sCharName + ' ' + '' {sMarryMsg0} + PlayObject.m_sDearName + ' ' + ' ' + 'Ѿʽ޹ϵ' {sUnMarryMsg9}, t_Say);
        PoseHuman := UserEngine.GetPlayObject(PlayObject.m_sDearName);
        if PoseHuman <> nil then begin
          PoseHuman.m_sDearName := '';
          Inc(PoseHuman.m_btMarryCount);
          PoseHuman.RefShowName;
        end else begin
          sUnMarryFileName := g_Config.sEnvirDir + 'UnMarry.txt';
          LoadList := TStringList.Create;
          if FileExists(sUnMarryFileName) then begin
            LoadList.LoadFromFile(sUnMarryFileName);
          end;
          LoadList.Add(PlayObject.m_sDearName);
          LoadList.SaveToFile(sUnMarryFileName);
          LoadList.Free;
        end;
        PlayObject.m_sDearName := '';
        Inc(PlayObject.m_btMarryCount);
        GotoLable(PlayObject, '@UnMarryEnd', False);
        PlayObject.RefShowName;
      end;
      Exit;
    end;
  end;
end;

procedure TNormNpc.ActionOfCommendGameGold(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin

end;
procedure TNormNpc.ActionOfNotLineAddPiont(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo); //߹һ
var
  dwAutoGetExpTime: LongWord;
  i: Integer;
  BaseObject:TBaseObject;
begin
  //MainOutMessage('ActionOfNotLineAddPiont: QuestActionInfo.sParam1:'+QuestActionInfo.sParam1+' QuestActionInfo.sParam2: '+QuestActionInfo.sParam2);
  if not PlayObject.m_boIsAuto then begin
    PlayObject.m_boIsAuto := True;
    PlayObject.m_boKillIsAuto := False;
    PlayObject.m_boKickFlag := True;
    if QuestActionInfo.nParam1 >= 1 then begin
      case QuestActionInfo.nParam1 of
        1:begin
          if PlayObject.m_SlaveList <> nil then
          for i := 0 to PlayObject.m_SlaveList.Count -1 do begin
            BaseObject:= PlayObject.m_SlaveList[i];
            BaseObject.m_Master := nil;
            BaseObject.MakeGhost;
          end;
        end;
        2:begin
          if (QuestActionInfo.nParam2 > 0) and (QuestActionInfo.nParam3 > 0) then begin
            PlayObject.m_dwAutoAddExpStartTick:= GetTickCount;
            PlayObject.m_dwAutoAddExpTimeLong:= QuestActionInfo.nParam2;
            PlayObject.m_dwAutoAddExpTick:=  GetTickCount;
            PlayObject.m_nAutoAddExpPoint := QuestActionInfo.nParam3;
          end else ScriptActionError(PlayObject, '', QuestActionInfo, sOFFLINEPLAY);
        end;
      end;
    end;
  end;
end;
procedure TNormNpc.ActionOfStartTakeGold(PlayObject: TPlayObject);
var
  PoseHuman: TPlayObject;
begin
  PoseHuman := TPlayObject(PlayObject.GetPoseCreate());
  if (PoseHuman <> nil) and (PoseHuman.GetPoseCreate = PlayObject) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    PlayObject.m_nDealGoldPose := 1;
    GotoLable(PlayObject, '@startdealgold', False);
  end else begin
    GotoLable(PlayObject, '@dealgoldpost', False);
  end;
end;

procedure TNormNpc.ClearScript;
var
  III, IIII: Integer;
  i, ii: Integer;
  Script: pTScript;
  SayingRecord: pTSayingRecord;
  SayingProcedure: pTSayingProcedure;
begin
  for i := 0 to m_ScriptList.Count - 1 do begin
    Script := m_ScriptList.Items[i];
    for ii := 0 to Script.RecordList.Count - 1 do begin
      SayingRecord := Script.RecordList.Items[ii];
      for III := 0 to SayingRecord.ProcedureList.Count - 1 do begin
        SayingProcedure := SayingRecord.ProcedureList.Items[III];
        for IIII := 0 to SayingProcedure.ConditionList.Count - 1 do begin
          DisPose(pTQuestConditionInfo(SayingProcedure.ConditionList.Items[IIII]));
        end;
        for IIII := 0 to SayingProcedure.ActionList.Count - 1 do begin
          DisPose(pTQuestActionInfo(SayingProcedure.ActionList.Items[IIII]));
        end;
        for IIII := 0 to SayingProcedure.ElseActionList.Count - 1 do begin
          DisPose(pTQuestActionInfo(SayingProcedure.ElseActionList.Items[IIII]));
        end;
        SayingProcedure.ConditionList.Free;
        SayingProcedure.ActionList.Free;
        SayingProcedure.ElseActionList.Free;
        DisPose(SayingProcedure);
      end; // for
      SayingRecord.ProcedureList.Free;
      DisPose(SayingRecord);
    end; // for
    Script.RecordList.Free;
    DisPose(Script);
  end; // for
  m_ScriptList.Clear;

end;

procedure TNormNpc.Click(PlayObject: TPlayObject); //0049EC18
begin
  PlayObject.m_nScriptGotoCount := 0;
  PlayObject.m_sScriptGoBackLable := '';
  PlayObject.m_sScriptCurrLable := '';
  GotoLable(PlayObject, '@main', False);
end;

function TNormNpc.ConditionOfCheckAccountIPList(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  LoadList: TStringList;
  sCharName: string;
  sCharAccount: string;
  sCharIPaddr: string;
  sLine: string;
  sName: string;
  sIPaddr: string;
begin
  Result := False;
  try
    sCharName := PlayObject.m_sCharName;
    sCharAccount := PlayObject.m_sUserID;
    sCharIPaddr := PlayObject.m_sIPaddr;
    LoadList := TStringList.Create;
    if FileExists(g_Config.sEnvirDir + QuestConditionInfo.sParam1) then begin
      LoadList.LoadFromFile(g_Config.sEnvirDir + QuestConditionInfo.sParam1);
      for i := 0 to LoadList.Count - 1 do begin
        sLine := LoadList.Strings[i];
        if sLine[1] = ';' then Continue;
        sIPaddr := GetValidStr3(sLine, sName, [' ', '/', #9]);
        sIPaddr := Trim(sIPaddr);
        if (sName = sCharAccount) and (sIPaddr = sCharIPaddr) then begin
          Result := True;
          break;
        end;
      end;
    end else begin
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKACCOUNTIPLIST);
    end;
  finally
    LoadList.Free
  end;
end;

function TNormNpc.ConditionOfCheckBagSize(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nSize: Integer;
begin
  Result := False;
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, nSize) then begin //ӱ֧
    nSize := QuestConditionInfo.nParam1;
  end;
  if (nSize <= 0) or (nSize > MAXBAGITEM) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKBAGSIZE);
    Exit;
  end;
  if PlayObject.m_ItemList.Count + nSize <= MAXBAGITEM then
    Result := True;
end;


function TNormNpc.ConditionOfCheckBonusPoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nTotlePoint, nCount: Integer;
  cMethod: Char;
begin
  Result := False;
  nTotlePoint := PlayObject.m_BonusAbil.DC +
    PlayObject.m_BonusAbil.MC +
    PlayObject.m_BonusAbil.SC +
    PlayObject.m_BonusAbil.AC +
    PlayObject.m_BonusAbil.MAC +
    PlayObject.m_BonusAbil.HP +
    PlayObject.m_BonusAbil.MP +
    PlayObject.m_BonusAbil.Hit +
    PlayObject.m_BonusAbil.Speed;
  nTotlePoint := nTotlePoint + PlayObject.m_nBonusPoint;
  cMethod := QuestConditionInfo.sParam1[1];
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount) then begin //ӱ֧
    nCount := QuestConditionInfo.nParam2;
  end;
  case cMethod of
    '=': if nTotlePoint = nCount then Result := True;
    '>': if nTotlePoint > nCount then Result := True;
    '<': if nTotlePoint < nCount then Result := True;
  else if nTotlePoint >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckHP(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethodMin, cMethodMax: Char;
  nMIN, nMax: Integer;
  function CheckHigh(): Boolean;
  begin
    Result := False;
    case cMethodMax of
      '=': begin
          if PlayObject.m_WAbil.MaxHP = nMax then begin
            Result := True;
          end;
        end;
      '>': begin
          if PlayObject.m_WAbil.MaxHP > nMax then begin
            Result := True;
          end;
        end;
      '<': begin
          if PlayObject.m_WAbil.MaxHP < nMax then begin
            Result := True;
          end;
        end;
    else begin
        if PlayObject.m_WAbil.MaxHP >= nMax then begin
          Result := True;
        end;
      end;
    end;
  end;
begin
  Result := False;
  cMethodMin := QuestConditionInfo.sParam1[1];
  cMethodMax := QuestConditionInfo.sParam1[3];
  nMIN := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nMax := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nMIN < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nMIN); //ӱ֧
  end;
  if nMax < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nMax); //ӱ֧
  end;
  if (nMIN < 0) or (nMax < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKHP);
    Exit;
  end;

  case cMethodMin of
    '=': begin
        if (m_WAbil.HP = nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '>': begin
        if (PlayObject.m_WAbil.HP > nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '<': begin
        if (PlayObject.m_WAbil.HP < nMIN) then begin
          Result := CheckHigh;
        end;
      end;
  else begin
      if (PlayObject.m_WAbil.HP >= nMIN) then begin
        Result := CheckHigh;
      end;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckMP(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethodMin, cMethodMax: Char;
  nMIN, nMax: Integer;
  function CheckHigh(): Boolean;
  begin
    Result := False;
    case cMethodMax of
      '=': begin
          if PlayObject.m_WAbil.MaxMP = nMax then begin
            Result := True;
          end;
        end;
      '>': begin
          if PlayObject.m_WAbil.MaxMP > nMax then begin
            Result := True;
          end;
        end;
      '<': begin
          if PlayObject.m_WAbil.MaxMP < nMax then begin
            Result := True;
          end;
        end;
    else begin
        if PlayObject.m_WAbil.MaxMP >= nMax then begin
          Result := True;
        end;
      end;
    end;
  end;
begin
  Result := False;
  cMethodMin := QuestConditionInfo.sParam1[1];
  cMethodMax := QuestConditionInfo.sParam1[3];
  nMIN := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nMax := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nMIN < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nMIN); //ӱ֧
  end;
  if nMax < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nMax); //ӱ֧
  end;
  if (nMIN < 0) or (nMax < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMP);
    Exit;
  end;
  case cMethodMin of
    '=': begin
        if (m_WAbil.MP = nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '>': begin
        if (PlayObject.m_WAbil.MP > nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '<': begin
        if (PlayObject.m_WAbil.MP < nMIN) then begin
          Result := CheckHigh;
        end;
      end;
  else begin
      if (PlayObject.m_WAbil.MP >= nMIN) then begin
        Result := CheckHigh;
      end;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckDC(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethodMin, cMethodMax: Char;
  nMIN, nMax: Integer;
  function CheckHigh(): Boolean;
  begin
    Result := False;
    case cMethodMax of
      '=': begin
          if HiWord(PlayObject.m_WAbil.DC) = nMax then begin
            Result := True;
          end;
        end;
      '>': begin
          if HiWord(PlayObject.m_WAbil.DC) > nMax then begin
            Result := True;
          end;
        end;
      '<': begin
          if HiWord(PlayObject.m_WAbil.DC) < nMax then begin
            Result := True;
          end;
        end;
    else begin
        if HiWord(PlayObject.m_WAbil.DC) >= nMax then begin
          Result := True;
        end;
      end;
    end;
  end;
begin
  Result := False;
  cMethodMin := QuestConditionInfo.sParam1[1];
  cMethodMax := QuestConditionInfo.sParam1[3];
  nMIN := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nMax := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nMIN < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nMIN); //ӱ֧
  end;
  if nMax < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nMax); //ӱ֧
  end;
  if (nMIN < 0) or (nMax < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKDC);
    Exit;
  end;
  case cMethodMin of
    '=': begin
        if (LoWord(PlayObject.m_WAbil.DC) = nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '>': begin
        if (LoWord(PlayObject.m_WAbil.DC) > nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '<': begin
        if (LoWord(PlayObject.m_WAbil.DC) < nMIN) then begin
          Result := CheckHigh;
        end;
      end;
  else begin
      if (LoWord(PlayObject.m_WAbil.DC) >= nMIN) then begin
        Result := CheckHigh;
      end;
    end;
  end;
  Result := False;
end;

function TNormNpc.ConditionOfCheckMC(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethodMin, cMethodMax: Char;
  nMIN, nMax: Integer;
  function CheckHigh(): Boolean;
  begin
    Result := False;
    case cMethodMax of
      '=': begin
          if HiWord(PlayObject.m_WAbil.MC) = nMax then begin
            Result := True;
          end;
        end;
      '>': begin
          if HiWord(PlayObject.m_WAbil.MC) > nMax then begin
            Result := True;
          end;
        end;
      '<': begin
          if HiWord(PlayObject.m_WAbil.MC) < nMax then begin
            Result := True;
          end;
        end;
    else begin
        if HiWord(PlayObject.m_WAbil.MC) >= nMax then begin
          Result := True;
        end;
      end;
    end;
  end;
begin
  Result := False;
  cMethodMin := QuestConditionInfo.sParam1[1];
  cMethodMax := QuestConditionInfo.sParam1[3];
  nMIN := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nMax := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nMIN < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nMIN); //ӱ֧
  end;
  if nMax < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nMax); //ӱ֧
  end;
  if (nMIN < 0) or (nMax < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMC);
    Exit;
  end;

  case cMethodMin of
    '=': begin
        if (LoWord(PlayObject.m_WAbil.MC) = nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '>': begin
        if (LoWord(PlayObject.m_WAbil.MC) > nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '<': begin
        if (LoWord(PlayObject.m_WAbil.MC) < nMIN) then begin
          Result := CheckHigh;
        end;
      end;
  else begin
      if (LoWord(PlayObject.m_WAbil.MC) >= nMIN) then begin
        Result := CheckHigh;
      end;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckSC(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethodMin, cMethodMax: Char;
  nMIN, nMax: Integer;
  function CheckHigh(): Boolean;
  begin
    Result := False;
    case cMethodMax of
      '=': begin
          if HiWord(PlayObject.m_WAbil.SC) = nMax then begin
            Result := True;
          end;
        end;
      '>': begin
          if HiWord(PlayObject.m_WAbil.SC) > nMax then begin
            Result := True;
          end;
        end;
      '<': begin
          if HiWord(PlayObject.m_WAbil.SC) < nMax then begin
            Result := True;
          end;
        end;
    else begin
        if HiWord(PlayObject.m_WAbil.SC) >= nMax then begin
          Result := True;
        end;
      end;
    end;
  end;
begin
  Result := False;
  cMethodMin := QuestConditionInfo.sParam1[1];
  cMethodMax := QuestConditionInfo.sParam1[3];
  nMIN := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nMax := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nMIN < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nMIN); //ӱ֧
  end;
  if nMax < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nMax); //ӱ֧
  end;
  if (nMIN < 0) or (nMax < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKSC);
    Exit;
  end;

  case cMethodMin of
    '=': begin
        if (LoWord(PlayObject.m_WAbil.SC) = nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '>': begin
        if (LoWord(PlayObject.m_WAbil.SC) > nMIN) then begin
          Result := CheckHigh;
        end;
      end;
    '<': begin
        if (LoWord(PlayObject.m_WAbil.SC) < nMIN) then begin
          Result := CheckHigh;
        end;
      end;
  else begin
      if (LoWord(PlayObject.m_WAbil.SC) >= nMIN) then begin
        Result := CheckHigh;
      end;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckExp(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  dwExp: LongWord;
  nExp: Integer;
begin
  Result := False;
  dwExp := Str_ToInt(QuestConditionInfo.sParam2, 0);
  if dwExp = 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nExp) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKEXP);
      Exit;
    end else dwExp := nExp;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_Abil.Exp = dwExp then Result := True;
    '>': if PlayObject.m_Abil.Exp > dwExp then Result := True;
    '<': if PlayObject.m_Abil.Exp < dwExp then Result := True;
  else if PlayObject.m_Abil.Exp >= dwExp then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckFlourishPoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nPoint: Integer;
  Guild: TGUild;
begin
  Result := False;
  nPoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nPoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKFLOURISHPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if Guild.nFlourishing = nPoint then Result := True;
    '>': if Guild.nFlourishing > nPoint then Result := True;
    '<': if Guild.nFlourishing < nPoint then Result := True;
  else if Guild.nFlourishing >= nPoint then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckChiefItemCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nCount: Integer;
  Guild: TGUild;
begin
  Result := False;
  nCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKFLOURISHPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if Guild.nChiefItemCount = nCount then Result := True;
    '>': if Guild.nChiefItemCount > nCount then Result := True;
    '<': if Guild.nChiefItemCount < nCount then Result := True;
  else if Guild.nChiefItemCount >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckGuildAuraePoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nPoint: Integer;
  Guild: TGUild;
begin
  Result := False;
  nPoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nPoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKAURAEPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if Guild.nAurae = nPoint then Result := True;
    '>': if Guild.nAurae > nPoint then Result := True;
    '<': if Guild.nAurae < nPoint then Result := True;
  else if Guild.nAurae >= nPoint then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckGuildBuildPoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nPoint: Integer;
  Guild: TGUild;
begin
  Result := False;
  nPoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nPoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKBUILDPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if Guild.nBuildPoint = nPoint then Result := True;
    '>': if Guild.nBuildPoint > nPoint then Result := True;
    '<': if Guild.nBuildPoint < nPoint then Result := True;
  else if Guild.nBuildPoint >= nPoint then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckStabilityPoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nPoint: Integer;
  Guild: TGUild;
begin
  Result := False;
  nPoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nPoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKSTABILITYPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if Guild.nStability = nPoint then Result := True;
    '>': if Guild.nStability > nPoint then Result := True;
    '<': if Guild.nStability < nPoint then Result := True;
  else if Guild.nStability >= nPoint then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckGameGold(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nGameGold: Integer;
begin
  Result := False;
  nGameGold := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nGameGold < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nGameGold) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKGAMEGOLD);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_nGameGold = nGameGold then Result := True;
    '>': if PlayObject.m_nGameGold > nGameGold then Result := True;
    '<': if PlayObject.m_nGameGold < nGameGold then Result := True;
  else if PlayObject.m_nGameGold >= nGameGold then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckGamePoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nGamePoint: Integer;
begin
  Result := False;
  nGamePoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nGamePoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nGamePoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKGAMEPOINT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_nGamePoint = nGamePoint then Result := True;
    '>': if PlayObject.m_nGamePoint > nGamePoint then Result := True;
    '<': if PlayObject.m_nGamePoint < nGamePoint then Result := True;
  else if PlayObject.m_nGamePoint >= nGamePoint then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckGroupCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nCount: Integer;
begin
  Result := False;
  if PlayObject.m_GroupOwner = nil then Exit;

  nCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKGROUPCOUNT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_GroupOwner.m_GroupMembers.Count = nCount then Result := True;
    '>': if PlayObject.m_GroupOwner.m_GroupMembers.Count > nCount then Result := True;
    '<': if PlayObject.m_GroupOwner.m_GroupMembers.Count < nCount then Result := True;
  else if PlayObject.m_GroupOwner.m_GroupMembers.Count >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckHaveGuild(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  //  Result:=PlayObject.m_MyGuild = nil;
  Result := PlayObject.m_MyGuild <> nil; // 01-16 
end;

function TNormNpc.ConditionOfCheckInMapRange(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sMapName: string;
  nX, nY, nRange: Integer;
begin
  Result := False;
  sMapName := QuestConditionInfo.sParam1;
  nX := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nY := Str_ToInt(QuestConditionInfo.sParam3, -1);
  nRange := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nX < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nX); //ӱ֧
  end;
  if nY < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nY); //ӱ֧
  end;
  if nRange < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nRange); //ӱ֧
  end;
  if (sMapName = '') or (nX < 0) or (nY < 0) or (nRange < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKINMAPRANGE);
    Exit;
  end;
  if CompareText(PlayObject.m_sMapName, sMapName) <> 0 then Exit;
  if (abs(PlayObject.m_nCurrX - nX) <= nRange) and (abs(PlayObject.m_nCurrY - nY) <= nRange) then
    Result := True;
end;

function TNormNpc.ConditionOfCheckIsAttackGuild(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if m_Castle = nil then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_ISATTACKGUILD);
    Exit;
  end;
  if PlayObject.m_MyGuild = nil then Exit;
  Result := TUserCastle(m_Castle).IsAttackGuild(TGUild(PlayObject.m_MyGuild));
end;

function TNormNpc.ConditionOfCheckCastleChageDay(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nDay: Integer;
  cMethod: Char;
  nChangeDay: Integer;
begin
  Result := False;
  nDay := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nDay < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nDay); //ӱ֧
  end;
  if (nDay < 0) or (m_Castle = nil) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CASTLECHANGEDAY);
    Exit;
  end;
  nChangeDay := GetDayCount(Now, TUserCastle(m_Castle).m_ChangeDate);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if nChangeDay = nDay then Result := True;
    '>': if nChangeDay > nDay then Result := True;
    '<': if nChangeDay < nDay then Result := True;
  else if nChangeDay >= nDay then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckCastleWarDay(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nDay: Integer;
  cMethod: Char;
  nWarDay: Integer;
begin
  Result := False;
  nDay := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nDay < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nDay); //ӱ֧
  end;
  if (nDay < 0) or (m_Castle = nil) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CASTLEWARDAY);
    Exit;
  end;
  nWarDay := GetDayCount(Now, TUserCastle(m_Castle).m_WarDate);
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if nWarDay = nDay then Result := True;
    '>': if nWarDay > nDay then Result := True;
    '<': if nWarDay < nDay then Result := True;
  else if nWarDay >= nDay then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckCastleDoorStatus(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nDay: Integer;
  cMethod: Char;
  nDoorStatus: Integer;
  CastleDoor: TCastleDoor;
begin
  Result := False;
  nDay := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nDay < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nDay); //ӱ֧
  end;
  nDoorStatus := -1;
  if CompareText(QuestConditionInfo.sParam1, '') = 0 then nDoorStatus := 0;
  if CompareText(QuestConditionInfo.sParam1, '') = 0 then nDoorStatus := 1;
  if CompareText(QuestConditionInfo.sParam1, 'ر') = 0 then nDoorStatus := 2;

  if (nDay < 0) or (m_Castle = nil) or (nDoorStatus < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKCASTLEDOOR);
    Exit;
  end;
  CastleDoor := TCastleDoor(TUserCastle(m_Castle).m_MainDoor.BaseObject);

  case nDoorStatus of
    0: if CastleDoor.m_boDeath then Result := True;
    1: if CastleDoor.m_boOpened then Result := True;
    2: if not CastleDoor.m_boOpened then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckIsAttackAllyGuild(
  PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if m_Castle = nil then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_ISATTACKALLYGUILD);
    Exit;
  end;
  if PlayObject.m_MyGuild = nil then Exit;
  Result := TUserCastle(m_Castle).IsAttackAllyGuild(TGUild(PlayObject.m_MyGuild));
end;

function TNormNpc.ConditionOfCheckIsDefenseAllyGuild(
  PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if m_Castle = nil then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_ISDEFENSEALLYGUILD);
    Exit;
  end;

  if PlayObject.m_MyGuild = nil then Exit;
  Result := TUserCastle(m_Castle).IsDefenseAllyGuild(TGUild(PlayObject.m_MyGuild));
end;

function TNormNpc.ConditionOfCheckIsDefenseGuild(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if m_Castle = nil then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_ISDEFENSEGUILD);
    Exit;
  end;

  if PlayObject.m_MyGuild = nil then Exit;
  Result := TUserCastle(m_Castle).IsDefenseGuild(TGUild(PlayObject.m_MyGuild));
end;

function TNormNpc.ConditionOfCheckIsCastleaGuild(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  //  if (PlayObject.m_MyGuild <> nil) and (UserCastle.m_MasterGuild = PlayObject.m_MyGuild) then
  if g_CastleManager.IsCastleMember(PlayObject) <> nil then
    Result := True;
end;

function TNormNpc.ConditionOfCheckIsCastleMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  //if PlayObject.IsGuildMaster and (UserCastle.m_MasterGuild = PlayObject.m_MyGuild) then
  if PlayObject.IsGuildMaster and (g_CastleManager.IsCastleMember(PlayObject) <> nil) then
    Result := True;
end;

function TNormNpc.ConditionOfCheckIsGuildMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := PlayObject.IsGuildMaster;
end;

function TNormNpc.ConditionOfCheckIsMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if (PlayObject.m_sMasterName <> '') and (PlayObject.m_boMaster) then
    Result := True;
end;

function TNormNpc.ConditionOfCheckListCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin

end;

function TNormNpc.ConditionOfCheckItemAddValue(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  nWhere: Integer;
  nValuePos, nAddValue,nAddAllValue: Integer;
  UserItem: pTUserItem;
  cMethod: Char;
begin
  Result := False;
  nWhere := Str_ToInt(QuestConditionInfo.sParam1, -1);
  if nWhere < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, nWhere); //ӱ֧
  end;
  cMethod := QuestConditionInfo.sParam2[1];
  nValuePos := Str_ToInt(QuestConditionInfo.sParam3, -1);
  if nValuePos < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nValuePos); //ӱ֧
  end;
  nAddValue := Str_ToInt(QuestConditionInfo.sParam4, -1);
  if nAddValue < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nAddValue); //ӱ֧
  end;
  if not (nWhere in [Low(THumItems)..High(THumItems)]) or (nAddValue < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKITEMADDVALUE);
    Exit;
  end;
  UserItem := @PlayObject.m_UseItems[nWhere];
  if UserItem.wIndex = 0 then begin
    Exit;
  end;
  nAddAllValue := 0;
  if nValuePos in [Low(UserItem.btAddValue) .. High(UserItem.btAddValue)] then
    nAddAllValue := UserItem.btAddValue[nValuePos]
  else begin
    for i := Low(UserItem.btAddValue) to High(UserItem.btAddValue) do begin
      Inc(nAddAllValue, UserItem.btAddValue[i]);
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if nAddAllValue = nAddValue then Result := True;
    '>': if nAddAllValue > nAddValue then Result := True;
    '<': if nAddAllValue < nAddValue then Result := True;
  else if nAddAllValue >= nAddValue then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckItemType(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nWhere: Integer;
  nType: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  Result := False;
  nWhere := Str_ToInt(QuestConditionInfo.sParam1, -1);
  nType := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nWhere < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, nWhere); //ӱ֧
  end;
  if nType < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nType); //ӱ֧
  end;
  if not (nWhere in [Low(THumItems)..High(THumItems)]) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKITEMTYPE);
    Exit;
  end;
  UserItem := @PlayObject.m_UseItems[nWhere];
  if UserItem.wIndex = 0 then Exit;
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if (StdItem <> nil) and (StdItem.StdMode = nType) then begin
    Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckLevelEx(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nLevel: Integer;
  cMethod: Char;
begin
  Result := False;
  nLevel := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nLevel) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKLEVELEX);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_Abil.Level = nLevel then Result := True;
    '>': if PlayObject.m_Abil.Level > nLevel then Result := True;
    '<': if PlayObject.m_Abil.Level < nLevel then Result := True;
  else if PlayObject.m_Abil.Level >= nLevel then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckNameListPostion(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  LoadList: TStringList;
  sCharName: string;
  nNamePostion, nPostion: Integer;
  sLine: string;
begin
  Result := False;
  nNamePostion := -1;
  try
    sCharName := PlayObject.m_sCharName;
    LoadList := TStringList.Create;
    if FileExists(g_Config.sEnvirDir + QuestConditionInfo.sParam1) then begin
      LoadList.LoadFromFile(g_Config.sEnvirDir + QuestConditionInfo.sParam1);
      for i := 0 to LoadList.Count - 1 do begin
        sLine := Trim(LoadList.Strings[i]);
        if sLine[1] = ';' then Continue;
        if CompareText(sLine, sCharName) = 0 then begin
          nNamePostion := i;
          break;
        end;
      end;
    end else begin
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKNAMELISTPOSITION);
    end;
  finally
    LoadList.Free
  end;
  nPostion := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nPostion < 0 then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKNAMELISTPOSITION);
    Exit;
  end;
  if nNamePostion >= nPostion then
    Result := True;
end;

function TNormNpc.ConditionOfCheckMarry(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if PlayObject.m_sDearName <> '' then Result := True;
end;

function TNormNpc.ConditionOfCheckMarryCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nCount: Integer;
  cMethod: Char;
begin
  Result := False;
  nCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMARRYCOUNT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_btMarryCount = nCount then Result := True;
    '>': if PlayObject.m_btMarryCount > nCount then Result := True;
    '<': if PlayObject.m_btMarryCount < nCount then Result := True;
  else if PlayObject.m_btMarryCount >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if (PlayObject.m_sMasterName <> '') and (not PlayObject.m_boMaster) then
    Result := True;
end;

function TNormNpc.ConditionOfCheckMemBerLevel(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nLevel: Integer;
  cMethod: Char;
begin
  Result := False;
  nLevel := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nLevel) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMEMBERLEVEL);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_nMemberLevel = nLevel then Result := True;
    '>': if PlayObject.m_nMemberLevel > nLevel then Result := True;
    '<': if PlayObject.m_nMemberLevel < nLevel then Result := True;
  else if PlayObject.m_nMemberLevel >= nLevel then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckMemberType(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nType: Integer;
  cMethod: Char;
begin
  Result := False;
  nType := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nType < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nType) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMEMBERTYPE);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_nMemberType = nType then Result := True;
    '>': if PlayObject.m_nMemberType > nType then Result := True;
    '<': if PlayObject.m_nMemberType < nType then Result := True;
  else if PlayObject.m_nMemberType >= nType then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckNameIPList(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  LoadList: TStringList;
  sCharName: string;
  sCharAccount: string;
  sCharIPaddr: string;
  sLine: string;
  sName: string;
  sIPaddr: string;
begin
  Result := False;
  try
    sCharName := PlayObject.m_sCharName;
    sCharAccount := PlayObject.m_sUserID;
    sCharIPaddr := PlayObject.m_sIPaddr;
    LoadList := TStringList.Create;
    if FileExists(g_Config.sEnvirDir + QuestConditionInfo.sParam1) then begin
      LoadList.LoadFromFile(g_Config.sEnvirDir + QuestConditionInfo.sParam1);
      for i := 0 to LoadList.Count - 1 do begin
        sLine := LoadList.Strings[i];
        if sLine[1] = ';' then Continue;
        sIPaddr := GetValidStr3(sLine, sName, [' ', '/', #9]);
        sIPaddr := Trim(sIPaddr);
        if (sName = sCharName) and (sIPaddr = sCharIPaddr) then begin
          Result := True;
          break;
        end;
      end;
    end else begin
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKNAMEIPLIST);
    end;
  finally
    LoadList.Free
  end;
end;

function TNormNpc.ConditionOfCheckPoseDir(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
begin
  Result := False;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.GetPoseCreate = PlayObject) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    case QuestConditionInfo.nParam1 of
      1: if PoseHuman.m_btGender = PlayObject.m_btGender then Result := True; //ҪͬԱ
      2: if PoseHuman.m_btGender <> PlayObject.m_btGender then Result := True; //ҪͬԱ
    else Result := True; //޲ʱбԱ
    end;
  end;
end;

function TNormNpc.ConditionOfCheckPoseGender(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
  btSex: Byte;
begin
  Result := False;
  btSex := 0;
  if CompareText(QuestConditionInfo.sParam1, 'MAN') = 0 then begin
    btSex := 0;
  end else
    if CompareText(QuestConditionInfo.sParam1, '') = 0 then begin
      btSex := 0;
    end else
      if CompareText(QuestConditionInfo.sParam1, 'WOMAN') = 0 then begin
        btSex := 1;
      end else
        if CompareText(QuestConditionInfo.sParam1, 'Ů') = 0 then begin
          btSex := 1;
        end;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    if PoseHuman.m_btGender = btSex then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckPoseIsMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
begin
  Result := False;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    if (TPlayObject(PoseHuman).m_sMasterName <> '') and (TPlayObject(PoseHuman).m_boMaster) then
      Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckPoseLevel(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nLevel: Integer;
  PoseHuman: TBaseObject;
  cMethod: Char;
begin
  Result := False;
  nLevel := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nLevel) then begin //ֱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKPOSELEVEL);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    case cMethod of
      '=': if PoseHuman.m_Abil.Level = nLevel then Result := True;
      '>': if PoseHuman.m_Abil.Level > nLevel then Result := True;
      '<': if PoseHuman.m_Abil.Level < nLevel then Result := True;
    else if PoseHuman.m_Abil.Level >= nLevel then Result := True;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckPoseMarry(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
begin
  Result := False;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    if TPlayObject(PoseHuman).m_sDearName <> '' then
      Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckPoseMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
begin
  Result := False;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    if (TPlayObject(PoseHuman).m_sMasterName <> '') and not (TPlayObject(PoseHuman).m_boMaster) then
      Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckServerName(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sServerName: string;
begin
  Result := False;
  if QuestConditionInfo.sParam1 = g_Config.sServerName then Result := True;
end;

function TNormNpc.ConditionOfCheckSlaveCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nCount: Integer;
  cMethod: Char;
begin
  Result := False;
  nCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount) then begin
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKSLAVECOUNT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_SlaveList.Count = nCount then Result := True;
    '>': if PlayObject.m_SlaveList.Count > nCount then Result := True;
    '<': if PlayObject.m_SlaveList.Count < nCount then Result := True;
  else if PlayObject.m_SlaveList.Count >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckSafeZone(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := PlayObject.InSafeZone;
end;

function TNormNpc.ConditionOfCheckMapName(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if QuestConditionInfo.sParam1 = PlayObject.m_sMapName then Result := True;
end;

function TNormNpc.ConditionOfCheckSkill(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nSkillLevel: Integer;
  cMethod: Char;
  UserMagic: pTUserMagic;
begin
  Result := False;
  nSkillLevel := Str_ToInt(QuestConditionInfo.sParam3, -1);
  if nSkillLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nSkillLevel) then begin
      ScriptConditionError(PlayObject, QuestConditionInfo, sCHECKSKILL);
      Exit;
    end;
  end;
  UserMagic := nil;
  UserMagic := TPlayObject(PlayObject).GetMagicInfo(QuestConditionInfo.sParam1);
  if UserMagic = nil then Exit;
  cMethod := QuestConditionInfo.sParam2[1];
  case cMethod of
    '=': if UserMagic.btLevel = nSkillLevel then Result := True;
    '>': if UserMagic.btLevel > nSkillLevel then Result := True;
    '<': if UserMagic.btLevel < nSkillLevel then Result := True;
  else if UserMagic.btLevel >= nSkillLevel then Result := True;
  end;
end;

function TNormNpc.ConditionOfAnsiContainsText(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sValue1: string;
  sValue2: string;
begin
  Result := False;
  sValue1 := QuestConditionInfo.sParam1;
  sValue2 := QuestConditionInfo.sParam2;
  ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sValue1);
  ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, sValue2);
  if AnsiContainsText(sValue1, sValue2) then Result := True;
end;

function TNormNpc.ConditionOfCompareText(PlayObject: TPlayObject; QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sValue1: string;
  sValue2: string;
begin
  Result := False;
  sValue1 := QuestConditionInfo.sParam1;
  sValue2 := QuestConditionInfo.sParam2;
  ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sValue1);
  if not GetHumanInfoValue(PlayObject,QuestConditionInfo.sParam2, sValue2) then
    ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, sValue2);
  if CompareText(sValue1, sValue2) = 0 then Result := True;
end;

function TNormNpc.ConditionOfGetValValue(PlayObject: TPlayObject;
  sMsg: string; var nValue: Integer): Boolean;
var
  n01: Integer;
begin
  Result := False;
  if sMsg = '' then Exit;
  n01 := GetValNameNo(sMsg);
  if n01 >= 0 then begin
    case n01 of
      0..9: begin
          nValue := PlayObject.m_nVal[n01];
          Result := True;
        end;
      100..199: begin
          nValue := g_Config.nGlobalVal[n01 - 100];
          Result := True;
        end;
      200..209: begin
          nValue := PlayObject.m_DyVal[n01 - 200];
          Result := True;
        end;
      300..399: begin
          nValue := PlayObject.m_nMval[n01 - 300];
          Result := True;
        end;
      400..499: begin
          nValue := g_Config.nGlobaDyMval[n01 - 400];
          Result := True;
        end;
      500..599: begin
          nValue := PlayObject.m_nInteger[n01 - 500];
          Result := True;
        end;
    end;
  end;
end;

function TNormNpc.ConditionOfGetValValue(PlayObject: TPlayObject;
  sMsg: string; var sValue: string): Boolean;
var
  n01: Integer;
begin
  Result := False;
  if sMsg = '' then Exit;
  n01 := GetValNameNo(sMsg);
  if n01 >= 0 then begin
    case n01 of
      600..699: begin
          sValue := PlayObject.m_sString[n01 - 600];
          Result := True;
        end;
      700..799: begin
          sValue := g_Config.sGlobalAVal[n01 - 700];
          Result := True;
        end;
    end;
  end;
end;

procedure TNormNpc.ActionOfAnsiReplaceText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  sValue1: string;
  sValue2: string;
  sValue3: string;
  n01: Integer;
begin
  sValue1 := QuestActionInfo.sParam1;
  sValue2 := QuestActionInfo.sParam2;
  sValue3 := QuestActionInfo.sParam3;
  if (sValue1 = '') or (sValue2 = '') then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ANSIREPLACETEXT);
    Exit;
  end;
  ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, sValue2);
  ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, sValue3);
  n01 := GetValNameNo(sValue1);
  if n01 >= 0 then begin
    case n01 of
      600..699: begin
          sValue1 := PlayObject.m_sString[n01 - 600];
          if AnsiContainsText(sValue1, sValue2) then
            PlayObject.m_sString[n01 - 600] := AnsiReplaceText(sValue1, sValue2, sValue3);
        end;
      700..799: begin
          sValue1 := g_Config.sGlobalAVal[n01 - 700];
          if AnsiContainsText(sValue1, sValue2) then
            g_Config.sGlobalAVal[n01 - 700] := AnsiReplaceText(sValue1, sValue2, sValue3);
        end;
    else begin
        ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ANSIREPLACETEXT);
      end;
    end;
  end else ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ANSIREPLACETEXT);
end;
function TNormNpc.GetHumanInfoValue(PlayObject: TPlayObject;sVariable: string; var sValue: string): Boolean;
  var
    sMsg, s10: string;
  begin
    Result := False;
    if sVariable = '' then Exit;
    sMsg := sVariable;
    ArrestStringEx(sMsg, '<', '>', s10);
    if s10 = '' then Exit;
    sVariable := s10;
    //Ϣ
    if sVariable = '$USERNAME' then begin
      sValue := PlayObject.m_sCharName;
      Result := True;
      Exit;
    end;
    if sVariable = '$GUILDNAME' then begin
      if PlayObject.m_MyGuild <> nil then begin
        sValue := TGUild(PlayObject.m_MyGuild).sGuildName;
      end else begin
        sValue := '';
      end;
      Result := True;
      Exit;
    end;
    if sVariable = '$RANKNAME' then begin
      sValue := PlayObject.m_sGuildRankName;
      Result := True;
      Exit;
    end;
    if sVariable = '$DRESS' then begin
      sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_DRESS].wIndex);
      Result := True;
      Exit;
    end else
      if sVariable = '$WEAPON' then begin
        sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_WEAPON].wIndex);
        Result := True;
        Exit;
      end else
        if sVariable = '$RIGHTHAND' then begin
          sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_Light].wIndex);
          Result := True;
          Exit;
        end else
          if sVariable = '$HELMET' then begin
            sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_HELMET].wIndex);
            Result := True;
            Exit;
          end else
            if sVariable = '$NECKLACE' then begin
              sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_NECKLACE].wIndex);
              Result := True;
              Exit;
            end else
              if sVariable = '$RING_R' then begin
                sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGR].wIndex);
                Result := True;
                Exit;
              end else
                if sVariable = '$RING_L' then begin
                  sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGL].wIndex);
                  Result := True;
                  Exit;
                end else
                  if sVariable = '$ARMRING_R' then begin
                    sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGR].wIndex);
                    Result := True;
                    Exit;
                  end else
                    if sVariable = '$ARMRING_L' then begin
                      sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGL].wIndex);
                      Result := True;
                      Exit;
                    end else
                      if sVariable = '$BUJUK' then begin
                        sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BUJUK].wIndex);
                        Result := True;
                        Exit;
                      end else
                        if sVariable = '$BELT' then begin
                          sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BELT].wIndex);
                          Result := True;
                          Exit;
                        end else
                          if sVariable = '$BOOTS' then begin
                            sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BOOTS].wIndex);
                            Result := True;
                            Exit;
                          end else
                            if sVariable = '$CHARM' then begin
                              sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_CHARM].wIndex);
                              Result := True;
                              Exit;
                            end else
                              if sVariable = '$IPADDR' then begin
                                sValue := PlayObject.m_sIPaddr;
                                Result := True;
                                Exit;
                              end else
                                if sVariable = '$IPLOCAL' then begin
                                  sValue := PlayObject.m_sIPLocal; // GetIPLocal(PlayObject.m_sIPaddr);
                                  Result := True;
                                  Exit;
                                end;
  end;
procedure TNormNpc.ActionOfEncodeText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  sNewValue: string;
  sValue1: string;
  sValue2: string;
  sValue3: string;
  sValue4: string;
  sValue5: string;
  sValue6: string;
  n01: Integer;

  procedure SetEncodeText(sValName, sValue: string);
  begin
    n01 := GetValNameNo(sValName);
    if n01 >= 0 then begin
      case n01 of
        600..699: begin
            PlayObject.m_sString[n01 - 600] := sValue;
          end;
        700..799: begin
            g_Config.sGlobalAVal[n01 - 700] := sValue;
          end;
      else begin
          ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ENCODETEXT);
        end;
      end;
    end else ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ENCODETEXT);
  end;
begin
  sValue1 := QuestActionInfo.sParam1;
  sValue2 := QuestActionInfo.sParam2;
  sValue3 := QuestActionInfo.sParam3;
  sValue4 := QuestActionInfo.sParam4;
  sValue5 := QuestActionInfo.sParam5;
  sValue6 := QuestActionInfo.sParam6;
  if (sValue2 <> '') and (sValue2[1] = '<') and (sValue2[Length(sValue2)] = '>') then begin
    GetHumanInfoValue(PlayObject,sValue2, sValue2);
  end else begin
    ConditionOfGetValValue(PlayObject, sValue2, sValue2);
  end;
  if (sValue3 <> '') and (sValue3[1] = '<') and (sValue3[Length(sValue3)] = '>') then begin
    GetHumanInfoValue(PlayObject,sValue3, sValue3);
  end else begin
    ConditionOfGetValValue(PlayObject, sValue3, sValue3);
  end;
  if (sValue4 <> '') and (sValue4[1] = '<') and (sValue4[Length(sValue4)] = '>') then begin
    GetHumanInfoValue(PlayObject,sValue4, sValue4);
  end else begin
    ConditionOfGetValValue(PlayObject, sValue4, sValue4);
  end;
  if (sValue5 <> '') and (sValue5[1] = '<') and (sValue5[Length(sValue5)] = '>') then begin
    GetHumanInfoValue(PlayObject,sValue5, sValue5);
  end else begin
    ConditionOfGetValValue(PlayObject, sValue5, sValue5);
  end;
  if (sValue6 <> '') and (sValue6[1] = '<') and (sValue6[Length(sValue6)] = '>') then begin
    GetHumanInfoValue(PlayObject,sValue6, sValue6);
  end else begin
    ConditionOfGetValValue(PlayObject, sValue6, sValue6);
  end;
  sNewValue := sValue2 + sValue3 + sValue4 + sValue5 + sValue6;
  SetEncodeText(sValue1, sNewValue)
end;

procedure TNormNpc.ActionOfDecodeText(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
begin

end;

procedure TNormNpc.ActionOfRepairItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  nWhere: Integer;
  StdItem: pTStdItem;
  sCheckItemName: string;
begin
  if Str_ToInt(QuestActionInfo.sParam1, -1) >= 0 then begin
    nWhere := Str_ToInt(QuestActionInfo.sParam1, -1);
    if (nWhere in [Low(THumItems)..High(THumItems)]) then begin
      if PlayObject.m_UseItems[nWhere].wIndex > 0 then begin
        StdItem := UserEngine.GetStdItem(PlayObject.m_UseItems[nWhere].wIndex);
        if StdItem <> nil then begin
          if (PlayObject.m_UseItems[nWhere].DuraMax > PlayObject.m_UseItems[nWhere].Dura) and (StdItem.StdMode <> 43) then begin
            PlayObject.m_UseItems[nWhere].Dura := PlayObject.m_UseItems[nWhere].DuraMax;
            PlayObject.AddAction(PlayObject, RM_DURACHANGE, nWhere, PlayObject.m_UseItems[nWhere].Dura, PlayObject.m_UseItems[nWhere].DuraMax, 0, '');
          end;
        end;
      end;
    end else begin
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_REPAIRITEM);
    end;
  end else
    if Str_ToInt(QuestActionInfo.sParam1, -1) < 0 then begin
      for nWhere := Low(THumItems) to High(THumItems) do begin
        if PlayObject.m_UseItems[nWhere].wIndex > 0 then begin
          StdItem := UserEngine.GetStdItem(PlayObject.m_UseItems[nWhere].wIndex);
          if StdItem <> nil then begin
            if (PlayObject.m_UseItems[nWhere].DuraMax > PlayObject.m_UseItems[nWhere].Dura) and (StdItem.StdMode <> 43) then begin
              PlayObject.m_UseItems[nWhere].Dura := PlayObject.m_UseItems[nWhere].DuraMax;
              PlayObject.AddAction(PlayObject, RM_DURACHANGE, nWhere, PlayObject.m_UseItems[nWhere].Dura, PlayObject.m_UseItems[nWhere].DuraMax, 0, '');
            end;
          end;
        end;
      end;
    end;
end;
procedure TNormNpc.ActionOfSendTimeMsg(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  sMsg: string;
  sParam2: string;
  nTime:Integer;
begin
  if QuestActionInfo.nParam1 <= 3 then begin
    ScriptActionError(PlayObject, 'ʱ3', QuestActionInfo, sSC_SendTimeMsg);
    Exit;
  end;
  nTime   := QuestActionInfo.nParam1 * 60 * 1000;
  sMsg := QuestActionInfo.sParam2;
  PlayObject.m_sTimeGotoLable := QuestActionInfo.sParam3;
  PlayObject.m_dwTimeGotoTick := GetTickCount + nTime;
  PlayObject.m_boTimeGoto := True;
  PlayObject.m_TimeGotoNPC := g_FunctionNPC;
  PlayObject.SysMsg(sMsg, TMsgColor(QuestActionInfo.nParam1), t_TimeHint);

end;
procedure TNormNpc.ActionOfThrowItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sMapName, sItemName,sUserItemName: string;  
  nMapX, nMapY, nRange, nCount: Integer;
  dx, dy: Integer;
  MapItem, pr: PTMapItem;
  StdItem: pTStdItem;
  nRandX, nRandY: Integer;
  pMap:TMap;
begin
  sMapName := QuestActionInfo.sParam1;
  nMapX := Str_ToInt(QuestActionInfo.sParam2, -1);
  nMapY := Str_ToInt(QuestActionInfo.sParam3, -1);
  nRange := QuestActionInfo.nParam4 div 2;
  sItemName := QuestActionInfo.sParam5;
  nCount := QuestActionInfo.nParam6;
  pMap := g_MapManager.FindMap(sMapName);
  StdItem := UserEngine.GetStdItem(sItemName);
  if (sMapName = '') or (nMapX <= 0) or (nMapY <= 0) or (sMapName = '') or (nRange <= 0) or (nCount <= 0)or(StdItem = nil) or (pMap = nil) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_ThrowItem);
    Exit;
  end;

  for i := 0 to nCount-1 do begin
    New(MapItem);
    if not UserEngine.CopyToUserItemFromName(StdItem.Name,@MapItem.UserItem) then begin
      Dispose(MapItem);
      Continue;
    end;
    MapItem.Name := StdItem.Name;

    //ȡԶƷ
    sUserItemName := '';

    //sUserItemName := ItemUnit.GetCustomItemName(UserItem);
    if sUserItemName <> '' then
      MapItem.Name := sUserItemName;

    MapItem.Looks := StdItem.Looks;
    MapItem.AniCount := StdItem.AniCount;
    MapItem.Reserved := 0;
    MapItem.Count := nCount;
    MapItem.OfBaseObject := nil;
    MapItem.dwCanPickUpTick := GetTickCount();
    MapItem.DropBaseObject := nil;

    GetDropPosition(nRange-Random(nRange+nRange)+nMapX, nRange-Random(nRange+nRange)+nMapY, nRange, dx, dy,pMap);
    pr := m_PMap.AddToMap(dx, dy, MotItem, TObject(MapItem));
    if pr = MapItem then begin
    end else begin
      DisPose(MapItem);
    end;
  end;
end;


procedure TNormNpc.ActionOfUnInlayItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  I, nInlayIdx: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  sItemName, sUserItemName: string;
  nWhere: Integer;
begin
  nWhere := QuestActionInfo.nParam1;
  nInlayIdx := QuestActionInfo.nParam2;

  if ((nInlayIdx < 0)or (nInlayIdx >4)) or (not (nWhere in [Low(THumItems)..High(THumItems)])) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_UnInlayItem);
    Exit;
  end;
  try
    UserItem := @PlayObject.m_UseItems[nWhere];
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if (UserItem.btArrXQ[nInlayIdx] > 1) then begin
      UserItem.btArrXQ[nInlayIdx]:=1;
      //wIdent: Word; nRecog: Integer; nParam, nTag, nSeries
      PlayObject.SendDefMessage(SM_TAKEON_OK, -1, nWhere, nInlayIdx, 1, '');
      //exit;
    end
    else PlayObject.SysMsg('ժʧ!!!', c_Green, t_Hint);
  except
    MainOutMessage('[쳣!!]::ActionOfUnInlayItem '+m_sCharName+  'Where:'+inttostr(nWhere)+'InlayIdx:'+inttostr(nInlayIdx));
  end;
end;


procedure TNormNpc.ActionOfTakeOnItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  I: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  sItemName, sUserItemName: string;
  nWhere: Integer;
begin
  sItemName := QuestActionInfo.sParam1;
  nWhere := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (sItemName = '') or (not (nWhere in [Low(THumItems)..High(THumItems)])) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_TAKEONITEM);
    Exit;
  end;
  for I := 0 to PlayObject.m_ItemList.Count - 1 do begin
    UserItem := PlayObject.m_ItemList.Items[I];
    if UserItem <> nil then begin
      //ȡԶƷ
      sUserItemName := ItemUnit.GetCustomItemName(UserItem);
      if sUserItemName = '' then
        sUserItemName := UserEngine.GetStdItemName(UserItem.wIndex);
      StdItem := UserEngine.GetStdItem(UserItem.wIndex);
      if StdItem <> nil then begin
        if CompareText(sUserItemName, sItemName) = 0 then begin
          PlayObject.TakeOnItems(nWhere, UserItem.MakeIndex, sItemName);
          Break;
        end;
      end;
    end;
  end;
end;

procedure TNormNpc.ActionOfTakeOffItem(PlayObject: TPlayObject; QuestActionInfo: pTQuestActionInfo);
var
  nItemIdx: Integer;
  StdItem: pTStdItem;
  sItemName, sUserItemName: string;
  nWhere: Integer;
begin
  sItemName := QuestActionInfo.sParam1;
  nWhere := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (sItemName = '') or (not (nWhere in [Low(THumItems)..High(THumItems)])) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_TAKEONITEM);
    Exit;
  end;
  if PlayObject.m_UseItems[nWhere].wIndex > 0 then begin
    sUserItemName := ItemUnit.GetCustomItemName(@PlayObject.m_UseItems[nWhere]);
    if sUserItemName = '' then
      sUserItemName := UserEngine.GetStdItemName(PlayObject.m_UseItems[nWhere].wIndex);
    if CompareText(sUserItemName, sItemName) = 0 then begin
      nItemIdx := PlayObject.m_UseItems[nWhere].MakeIndex;
      PlayObject.TakeOffItems(nWhere, nItemIdx, sItemName);
    end;
  end;
end;

constructor TNormNpc.Create; //0049AA38
begin
  inherited;
  m_boSuperMan := True;
  m_btRaceServer := RC_NPC;
  m_nLight := 2;
  m_btAntiPoison := 99;
  m_ScriptList := TSimpleList.Create;
  m_boStickMode := True;
  m_sFilePath := sNpc_def;
  m_boIsHide := False;
  m_boIsQuest := True;
  m_btNpcAutoChangeColorMode := 0;
  m_dwNpcAutoChangeColorTime := 0;
  m_nNpcAutoChangeIdx := 0;
end;

destructor TNormNpc.Destroy; //0049AAE4
var
  i: Integer;
begin
  ClearScript();
  {
  for I := 0 to ScriptList.Count - 1 do begin
    Dispose(pTScript(ScriptList.Items[I]));
  end;
  }
  m_ScriptList.Free;
  inherited;
end;

procedure TNormNpc.ExeAction(PlayObject: TPlayObject; sParam1, sParam2,
  sParam3: string; nParam1, nParam2, nParam3: Integer);
var
  nInt1, nInt2, nInt3: Integer;
  dwInt: LongWord;
  BaseObject: TBaseObject;
begin
  //================================================
  //ﵱǰֵ
  //EXEACTION CHANGEEXP 0   Ϊֵָ
  //EXEACTION CHANGEEXP 1   ָ
  //EXEACTION CHANGEEXP 2   ָ
  //================================================
  if CompareText(sParam1, 'CHANGEEXP') = 0 then begin
    nInt1 := Str_ToInt(sParam2, -1);
    case nInt1 of //
      0: begin
          if nParam3 >= 0 then begin
            PlayObject.m_Abil.Exp := LongWord(nParam3);
            PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
          end;
        end;
      1: begin
          if PlayObject.m_Abil.Exp >= LongWord(nParam3) then begin
            if (PlayObject.m_Abil.Exp - LongWord(nParam3)) > (High(LongWord) - PlayObject.m_Abil.Exp) then begin
              dwInt := High(LongWord) - PlayObject.m_Abil.Exp;
            end else begin
              dwInt := LongWord(nParam3);
            end;
          end else begin
            if (LongWord(nParam3) - PlayObject.m_Abil.Exp) > (High(LongWord) - LongWord(nParam3)) then begin
              dwInt := High(LongWord) - LongWord(nParam3);
            end else begin
              dwInt := LongWord(nParam3);
            end;
          end;
          Inc(PlayObject.m_Abil.Exp, dwInt);
          PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
        end;
      2: begin
          if PlayObject.m_Abil.Exp > LongWord(nParam3) then begin
            Dec(PlayObject.m_Abil.Exp, LongWord(nParam3));
          end else begin
            PlayObject.m_Abil.Exp := 0;
          end;
          PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
        end;
    end;
    PlayObject.SysMsg('ǰΪ: ' + IntToStr(PlayObject.m_Abil.Exp) + '/' + IntToStr(PlayObject.m_Abil.MaxExp), c_Green, t_Hint);
    Exit;
  end;

  //================================================
  //ﵱǰȼ
  //EXEACTION CHANGELEVEL 0 ȼ  Ϊָȼ
  //EXEACTION CHANGELEVEL 1 ȼ  ָȼ
  //EXEACTION CHANGELEVEL 2 ȼ  ָȼ
  //================================================
  if CompareText(sParam1, 'CHANGELEVEL') = 0 then begin
    nInt1 := Str_ToInt(sParam2, -1);
    case nInt1 of //
      0: begin
          if nParam3 >= 0 then begin
            PlayObject.m_Abil.Level := LongWord(nParam3);
            PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
          end;
        end;
      1: begin
          if PlayObject.m_Abil.Level >= LongWord(nParam3) then begin
            if (PlayObject.m_Abil.Level - LongWord(nParam3)) > (High(Word) - PlayObject.m_Abil.Level) then begin
              dwInt := High(Word) - PlayObject.m_Abil.Level;
            end else begin
              dwInt := LongWord(nParam3);
            end;
          end else begin
            if (LongWord(nParam3) - PlayObject.m_Abil.Level) > (High(Word) - LongWord(nParam3)) then begin
              dwInt := High(LongWord) - LongWord(nParam3);
            end else begin
              dwInt := LongWord(nParam3);
            end;
          end;
          Inc(PlayObject.m_Abil.Level, dwInt);
          PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
        end;
      2: begin
          if PlayObject.m_Abil.Level > LongWord(nParam3) then begin
            Dec(PlayObject.m_Abil.Level, LongWord(nParam3));
          end else begin
            PlayObject.m_Abil.Level := 0;
          end;
          PlayObject.HasLevelUp(PlayObject.m_Abil.Level - 1);
        end;
    end;
    PlayObject.SysMsg('ǰȼΪ: ' + IntToStr(PlayObject.m_Abil.Level), c_Green, t_Hint);
    Exit;
  end;

  //================================================
  //ɱ
  //EXEACTION KILL 0 ,ʾϢ
  //EXEACTION KILL 1 Ʒ,ʾϢ
  //EXEACTION KILL 2 ,ʾϢΪNPC
  //EXEACTION KILL 3 Ʒ,ʾϢΪNPC
  //================================================
  if CompareText(sParam1, 'KILL') = 0 then begin
    nInt1 := Str_ToInt(sParam2, -1);
    case nInt1 of //
      1: begin
          PlayObject.m_boNoItem := True;
          PlayObject.Die;
        end;
      2: begin
          PlayObject.SetLastHiter(Self);
          PlayObject.Die;
        end;
      3: begin
          PlayObject.m_boNoItem := True;
          PlayObject.SetLastHiter(Self);
          PlayObject.Die;
        end;
    else begin
        PlayObject.Die;
      end;
    end;
    //MainOutMessage('ExeA ction D-ie');
    Exit;
  end;

  //================================================
  //
  //EXEACTION KICK
  //================================================
  if CompareText(sParam1, 'KICK') = 0 then begin
    PlayObject.m_boKickFlag := True;
    Exit;
  end;


  //==============================================================================
end;

function TNormNpc.GetLineVariableText(PlayObject: TPlayObject;
  sMsg: string): string;
var
  nC: Integer;
  s10: string;
begin
  nC := 0;
  while (True) do begin
    if TagCount(sMsg, '>') < 1 then break;
    ArrestStringEx(sMsg, '<', '>', s10);
    GetVariableText(PlayObject, sMsg, s10);
    Inc(nC);
    if nC >= 101 then break;
  end;
  Result := sMsg;
end;

procedure TNormNpc.GetVariableText(PlayObject: TPlayObject; var sMsg: string; sVariable: string); //0049AEA4
var
  sText, s14: string;
  i, ii: Integer;
  n18, n20: Integer;
  wHour: Word;
  wMinute: Word;
  wSecond: Word;
  nSecond: Integer;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;

  nSellGold: Integer;
  nRate: Integer;
  s1C: string;
  Merchant: TMerchant;
  List20: TList;
  PoseHuman: TPlayObject;
begin

  //ȫϢ
  if sVariable = '$SERVERNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$SERVERNAME>', g_Config.sServerName);
    Exit;
  end;
  if sVariable = '$SERVERIP' then begin
    sMsg := sub_49ADB8(sMsg, '<$SERVERIP>', g_Config.sServerIPaddr);
    Exit;
  end;
  if sVariable = '$WEBSITE' then begin
    sMsg := sub_49ADB8(sMsg, '<$WEBSITE>', g_Config.sWebSite);
    Exit;
  end;
  if sVariable = '$BBSSITE' then begin
    sMsg := sub_49ADB8(sMsg, '<$BBSSITE>', g_Config.sBbsSite);
    Exit;
  end;
  if sVariable = '$CLIENTDOWNLOAD' then begin
    sMsg := sub_49ADB8(sMsg, '<$CLIENTDOWNLOAD>', g_Config.sClientDownload);
    Exit;
  end;
  if sVariable = '$QQ' then begin
    sMsg := sub_49ADB8(sMsg, '<$QQ>', g_Config.sQQ);
    Exit;
  end;
  if sVariable = '$PHONE' then begin
    sMsg := sub_49ADB8(sMsg, '<$PHONE>', g_Config.sPhone);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT0' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT0>', g_Config.sBankAccount0);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT1' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT1>', g_Config.sBankAccount1);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT2' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT2>', g_Config.sBankAccount2);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT3' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT3>', g_Config.sBankAccount3);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT4' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT4>', g_Config.sBankAccount4);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT5' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT5>', g_Config.sBankAccount5);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT6' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT6>', g_Config.sBankAccount6);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT7' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT7>', g_Config.sBankAccount7);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT8' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT8>', g_Config.sBankAccount8);
    Exit;
  end;
  if sVariable = '$BANKACCOUNT9' then begin
    sMsg := sub_49ADB8(sMsg, '<$BANKACCOUNT9>', g_Config.sBankAccount9);
    Exit;
  end;
  if sVariable = '$GAMEGOLDNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$GAMEGOLDNAME>', g_Config.sGameGoldName);
    Exit;
  end;
  if sVariable = '$GAMEPOINTNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$GAMEPOINTNAME>', g_Config.sGamePointName);
    Exit;
  end;
  if sVariable = '$USERCOUNT' then begin
    sText := IntToStr(UserEngine.PlayObjectCount);
    sMsg := sub_49ADB8(sMsg, '<$USERCOUNT>', sText);
    Exit;
  end;
  if sVariable = '$MACRUNTIME' then begin
    sText := CurrToStr(GetTickCount / (24 * 60 * 60 * 1000));
    sMsg := sub_49ADB8(sMsg, '<$MACRUNTIME>', sText);
    Exit;
  end;
  if sVariable = '$SERVERRUNTIME' then begin
    nSecond := (GetTickCount() - g_dwStartTick) div 1000;
    wHour := nSecond div 3600;
    wMinute := (nSecond div 60) mod 60;
    wSecond := nSecond mod 60;
    sText := format('%d:%d:%d', [wHour, wMinute, wSecond]);
    sMsg := sub_49ADB8(sMsg, '<$SERVERRUNTIME>', sText);
    Exit;
  end;
  if sVariable = '$DATETIME' then begin
    //    sText:=DateTimeToStr(Now);
    sText := FormatDateTime('dddddd,dddd,hh:mm:nn', Now);
    sMsg := sub_49ADB8(sMsg, '<$DATETIME>', sText);
    Exit;
  end;

  if sVariable = '$HIGHLEVELINFO' then begin
    if g_HighLevelHuman <> nil then begin
      sText := TPlayObject(g_HighLevelHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHLEVELINFO>', sText);
    Exit;
  end;
  if sVariable = '$HIGHPKINFO' then begin
    if g_HighPKPointHuman <> nil then begin
      sText := TPlayObject(g_HighPKPointHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHPKINFO>', sText);
    Exit;
  end;
  if sVariable = '$HIGHDCINFO' then begin
    if g_HighDCHuman <> nil then begin
      sText := TPlayObject(g_HighDCHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHDCINFO>', sText);
    Exit;
  end;
  if sVariable = '$HIGHMCINFO' then begin
    if g_HighMCHuman <> nil then begin
      sText := TPlayObject(g_HighMCHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHMCINFO>', sText);
    Exit;
  end;
  if sVariable = '$HIGHSCINFO' then begin
    if g_HighSCHuman <> nil then begin
      sText := TPlayObject(g_HighSCHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHSCINFO>', sText);
    Exit;
  end;
  if sVariable = '$HIGHONLINEINFO' then begin
    if g_HighOnlineHuman <> nil then begin
      sText := TPlayObject(g_HighOnlineHuman).GetMyInfo;
    end else sText := '????';
    sMsg := sub_49ADB8(sMsg, '<$HIGHONLINEINFO>', sText);
    Exit;
  end;

  //Ϣ
  if sVariable = '$USERNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$USERNAME>', PlayObject.m_sCharName);
    Exit;
  end;
  if sVariable = '$MAPNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$MAPNAME>', PlayObject.m_PMap.sMapDesc);
    Exit;
  end;
  if sVariable = '$GUILDNAME' then begin
    if PlayObject.m_MyGuild <> nil then begin
      sMsg := sub_49ADB8(sMsg, '<$GUILDNAME>', TGUild(PlayObject.m_MyGuild).sGuildName);
    end else begin
      sMsg := '';
    end;
    Exit;
  end;
  if sVariable = '$RANKNAME' then begin
    sMsg := sub_49ADB8(sMsg, '<$RANKNAME>', PlayObject.m_sGuildRankName);
    Exit;
  end;

  if sVariable = '$LEVEL' then begin
    sText := IntToStr(PlayObject.m_Abil.Level);
    sMsg := sub_49ADB8(sMsg, '<$LEVEL>', sText);
    Exit;
  end;

  if sVariable = '$HP' then begin
    sText := IntToStr(PlayObject.m_WAbil.HP);
    sMsg := sub_49ADB8(sMsg, '<$HP>', sText);
    Exit;
  end;
  if sVariable = '$MAXHP' then begin
    sText := IntToStr(PlayObject.m_WAbil.MaxHP);
    sMsg := sub_49ADB8(sMsg, '<$MAXHP>', sText);
    Exit;
  end;

  if sVariable = '$MP' then begin
    sText := IntToStr(PlayObject.m_WAbil.MP);
    sMsg := sub_49ADB8(sMsg, '<$MP>', sText);
    Exit;
  end;
  if sVariable = '$MAXMP' then begin
    sText := IntToStr(PlayObject.m_WAbil.MaxMP);
    sMsg := sub_49ADB8(sMsg, '<$MAXMP>', sText);
    Exit;
  end;

  if sVariable = '$AC' then begin
    sText := IntToStr(LoWord(PlayObject.m_WAbil.AC));
    sMsg := sub_49ADB8(sMsg, '<$AC>', sText);
    Exit;
  end;
  if sVariable = '$MAXAC' then begin
    sText := IntToStr(HiWord(PlayObject.m_WAbil.AC));
    sMsg := sub_49ADB8(sMsg, '<$MAXAC>', sText);
    Exit;
  end;
  if sVariable = '$MAC' then begin
    sText := IntToStr(LoWord(PlayObject.m_WAbil.MAC));
    sMsg := sub_49ADB8(sMsg, '<$MAC>', sText);
    Exit;
  end;
  if sVariable = '$MAXMAC' then begin
    sText := IntToStr(HiWord(PlayObject.m_WAbil.MAC));
    sMsg := sub_49ADB8(sMsg, '<$MAXMAC>', sText);
    Exit;
  end;

  if sVariable = '$DC' then begin
    sText := IntToStr(LoWord(PlayObject.m_WAbil.DC));
    sMsg := sub_49ADB8(sMsg, '<$DC>', sText);
    Exit;
  end;
  if sVariable = '$MAXDC' then begin
    sText := IntToStr(HiWord(PlayObject.m_WAbil.DC));
    sMsg := sub_49ADB8(sMsg, '<$MAXDC>', sText);
    Exit;
  end;

  if sVariable = '$MC' then begin
    sText := IntToStr(LoWord(PlayObject.m_WAbil.MC));
    sMsg := sub_49ADB8(sMsg, '<$MC>', sText);
    Exit;
  end;
  if sVariable = '$MAXMC' then begin
    sText := IntToStr(HiWord(PlayObject.m_WAbil.MC));
    sMsg := sub_49ADB8(sMsg, '<$MAXMC>', sText);
    Exit;
  end;

  if sVariable = '$SC' then begin
    sText := IntToStr(LoWord(PlayObject.m_WAbil.SC));
    sMsg := sub_49ADB8(sMsg, '<$SC>', sText);
    Exit;
  end;
  if sVariable = '$MAXSC' then begin
    sText := IntToStr(HiWord(PlayObject.m_WAbil.SC));
    sMsg := sub_49ADB8(sMsg, '<$MAXSC>', sText);
    Exit;
  end;

  if sVariable = '$EXP' then begin
    sText := IntToStr(PlayObject.m_Abil.Exp);
    sMsg := sub_49ADB8(sMsg, '<$EXP>', sText);
    Exit;
  end;
  if sVariable = '$MAXEXP' then begin
    sText := IntToStr(PlayObject.m_Abil.MaxExp);
    sMsg := sub_49ADB8(sMsg, '<$MAXEXP>', sText);
    Exit;
  end;

  if sVariable = '$PKPOINT' then begin
    sText := IntToStr(PlayObject.m_wPkPoint);
    sMsg := sub_49ADB8(sMsg, '<$PKPOINT>', sText);
    Exit;
  end;
  if sVariable = '$CREDITPOINT' then begin
    sText := IntToStr(PlayObject.m_btCreditPoint);
    sMsg := sub_49ADB8(sMsg, '<$CREDITPOINT>', sText);
    Exit;
  end;

  if sVariable = '$HW' then begin
    sText := IntToStr(PlayObject.m_WAbil.HandWeight);
    sMsg := sub_49ADB8(sMsg, '<$HW>', sText);
    Exit;
  end;
  if sVariable = '$MAXHW' then begin
    sText := IntToStr(PlayObject.m_WAbil.MaxHandWeight);
    sMsg := sub_49ADB8(sMsg, '<$MAXHW>', sText);
    Exit;
  end;

  if sVariable = '$BW' then begin
    sText := IntToStr(PlayObject.m_WAbil.Weight);
    sMsg := sub_49ADB8(sMsg, '<$BW>', sText);
    Exit;
  end;
  if sVariable = '$MAXBW' then begin
    sText := IntToStr(PlayObject.m_WAbil.MaxWeight);
    sMsg := sub_49ADB8(sMsg, '<$MAXBW>', sText);
    Exit;
  end;

  if sVariable = '$WW' then begin
    sText := IntToStr(PlayObject.m_WAbil.WearWeight);
    sMsg := sub_49ADB8(sMsg, '<$WW>', sText);
    Exit;
  end;
  if sVariable = '$MAXWW' then begin
    sText := IntToStr(PlayObject.m_WAbil.MaxWearWeight);
    sMsg := sub_49ADB8(sMsg, '<$MAXWW>', sText);
    Exit;
  end;

  if sVariable = '$GOLDCOUNT' then begin
    sText := IntToStr(PlayObject.m_nGold) + '/' + IntToStr(PlayObject.m_nGoldMax);
    sMsg := sub_49ADB8(sMsg, '<$GOLDCOUNT>', sText);
    Exit;
  end;
  if sVariable = '$GAMEGOLD' then begin
    sText := IntToStr(PlayObject.m_nGameGold);
    sMsg := sub_49ADB8(sMsg, '<$GAMEGOLD>', sText);
    Exit;
  end;
  if sVariable = '$GAMEPOINT' then begin
    sText := IntToStr(PlayObject.m_nGamePoint);
    sMsg := sub_49ADB8(sMsg, '<$GAMEPOINT>', sText);
    Exit;
  end;

  if sVariable = '$LOGINTIME' then begin
    sText := DateTimeToStr(PlayObject.m_dLogonTime);
    sMsg := sub_49ADB8(sMsg, '<$LOGINTIME>', sText);
    Exit;
  end;
  if sVariable = '$LOGINLONG' then begin
    sText := IntToStr((GetTickCount - PlayObject.m_dwLogonTick) div 60000) + '';
    sMsg := sub_49ADB8(sMsg, '<$LOGINLONG>', sText);
    Exit;
  end;
  if sVariable = '$DRESS' then begin
    sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_DRESS].wIndex);
    sMsg := sub_49ADB8(sMsg, '<$DRESS>', sText);
    Exit;
  end else
    if sVariable = '$WEAPON' then begin
      sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_WEAPON].wIndex);
      sMsg := sub_49ADB8(sMsg, '<$WEAPON>', sText);
      Exit;
    end else
      if sVariable = '$RIGHTHAND' then begin
        sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_Light].wIndex);
        sMsg := sub_49ADB8(sMsg, '<$RIGHTHAND>', sText);
        Exit;
      end else
        if sVariable = '$HELMET' then begin
          sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_HELMET].wIndex);
          sMsg := sub_49ADB8(sMsg, '<$HELMET>', sText);
          Exit;
        end else
          if sVariable = '$NECKLACE' then begin
            sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_NECKLACE].wIndex);
            sMsg := sub_49ADB8(sMsg, '<$NECKLACE>', sText);
            Exit;
          end else
            if sVariable = '$RING_R' then begin
              sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGR].wIndex);
              sMsg := sub_49ADB8(sMsg, '<$RING_R>', sText);
              Exit;
            end else
              if sVariable = '$RING_L' then begin
                sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGL].wIndex);
                sMsg := sub_49ADB8(sMsg, '<$RING_L>', sText);
                Exit;
              end else
                if sVariable = '$ARMRING_R' then begin
                  sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGR].wIndex);
                  sMsg := sub_49ADB8(sMsg, '<$ARMRING_R>', sText);
                  Exit;
                end else
                  if sVariable = '$ARMRING_L' then begin
                    sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGL].wIndex);
                    sMsg := sub_49ADB8(sMsg, '<$ARMRING_L>', sText);
                    Exit;
                  end else
                    if sVariable = '$BUJUK' then begin
                      sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BUJUK].wIndex);
                      sMsg := sub_49ADB8(sMsg, '<$BUJUK>', sText);
                      Exit;
                    end else
                      if sVariable = '$BELT' then begin
                        sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BELT].wIndex);
                        sMsg := sub_49ADB8(sMsg, '<$BELT>', sText);
                        Exit;
                      end else
                        if sVariable = '$BOOTS' then begin
                          sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BOOTS].wIndex);
                          sMsg := sub_49ADB8(sMsg, '<$BOOTS>', sText);
                          Exit;
                        end else
                          if sVariable = '$CHARM' then begin
                            sText := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_CHARM].wIndex);
                            sMsg := sub_49ADB8(sMsg, '<$CHARM>', sText);
                            Exit;
                          end else
                            if sVariable = '$IPADDR' then begin
                              sText := PlayObject.m_sIPaddr;
                              sMsg := sub_49ADB8(sMsg, '<$IPADDR>', sText);
                              Exit;
                            end else
                              if sVariable = '$IPLOCAL' then begin
                                sText := PlayObject.m_sIPLocal; // GetIPLocal(PlayObject.m_sIPaddr);
                                sMsg := sub_49ADB8(sMsg, '<$IPLOCAL>', sText);
                                Exit;
                              end else
                                if sVariable = '$GUILDBUILDPOINT' then begin
                                  if PlayObject.m_MyGuild = nil then begin
                                    sText := '';
                                  end else begin
                                    sText := IntToStr(TGUild(PlayObject.m_MyGuild).nBuildPoint);
                                  end;
                                  sMsg := sub_49ADB8(sMsg, '<$GUILDBUILDPOINT>', sText);
                                  Exit;
                                end else
                                  if sVariable = '$GUILDAURAEPOINT' then begin
                                    if PlayObject.m_MyGuild = nil then begin
                                      sText := '';
                                    end else begin
                                      sText := IntToStr(TGUild(PlayObject.m_MyGuild).nAurae);
                                    end;
                                    sMsg := sub_49ADB8(sMsg, '<$GUILDAURAEPOINT>', sText);
                                    Exit;
                                  end else
                                    if sVariable = '$GUILDSTABILITYPOINT' then begin
                                      if PlayObject.m_MyGuild = nil then begin
                                        sText := '';
                                      end else begin
                                        sText := IntToStr(TGUild(PlayObject.m_MyGuild).nStability);
                                      end;
                                      sMsg := sub_49ADB8(sMsg, '<$GUILDSTABILITYPOINT>', sText);
                                      Exit;
                                    end;
  if sVariable = '$GUILDFLOURISHPOINT' then begin
    if PlayObject.m_MyGuild = nil then begin
      sText := '';
    end else begin
      sText := IntToStr(TGUild(PlayObject.m_MyGuild).nFlourishing);
    end;
    sMsg := sub_49ADB8(sMsg, '<$GUILDFLOURISHPOINT>', sText);
    Exit;
  end;

  //Ϣ
  if sVariable = '$REQUESTCASTLEWARITEM' then begin
    sText := g_Config.sZumaPiece;
    sMsg := sub_49ADB8(sMsg, '<$REQUESTCASTLEWARITEM>', sText);
    Exit;
  end;
  if sVariable = '$REQUESTCASTLEWARDAY' then begin
    sText := g_Config.sZumaPiece;
    sMsg := sub_49ADB8(sMsg, '<$REQUESTCASTLEWARDAY>', sText);
    Exit;
  end;
  if sVariable = '$REQUESTBUILDGUILDITEM' then begin
    sText := g_Config.sWomaHorn;
    sMsg := sub_49ADB8(sMsg, '<$REQUESTBUILDGUILDITEM>', sText);
    Exit;
  end;
  if sVariable = '$OWNERGUILD' then begin
    if m_Castle <> nil then begin
      sText := TUserCastle(m_Castle).m_sOwnGuild;
      if sText = '' then sText := 'Ϸ';
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$OWNERGUILD>', sText);
    Exit;
  end; //0049AF32

  if sVariable = '$CASTLENAME' then begin
    if m_Castle <> nil then begin
      sText := TUserCastle(m_Castle).m_sName;
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$CASTLENAME>', sText);
    Exit;
  end;
  if sVariable = '$LORD' then begin
    if m_Castle <> nil then begin
      if TUserCastle(m_Castle).m_MasterGuild <> nil then begin
        sText := TUserCastle(m_Castle).m_MasterGuild.GetChiefName();
      end else sText := 'Ա';
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$LORD>', sText);
    Exit;
  end; //0049AF32

  if sVariable = '$GUILDWARFEE' then begin
    sMsg := sub_49ADB8(sMsg, '<$GUILDWARFEE>', IntToStr(g_Config.nGuildWarPrice));
    Exit;
  end;
  if sVariable = '$BUILDGUILDFEE' then begin
    sMsg := sub_49ADB8(sMsg, '<$BUILDGUILDFEE>', IntToStr(g_Config.nBuildGuildPrice));
    Exit;
  end;

  if sVariable = '$CASTLEWARDATE' then begin
    if m_Castle = nil then begin
      m_Castle := g_CastleManager.GetCastle(0);
    end;
    if m_Castle <> nil then begin
      if not TUserCastle(m_Castle).m_boUnderWar then begin
        sText := TUserCastle(m_Castle).GetWarDate();
        if sText <> '' then begin
          sMsg := sub_49ADB8(sMsg, '<$CASTLEWARDATE>', sText);
        end else sMsg := 'ʱûлṥǣ\ \</@main>';
      end else sMsg := 'ڹУ\ \</@main>';
    end else begin
      sText := '????';
    end;
    Exit;
  end;

  if sVariable = '$LISTOFWAR' then begin
    if m_Castle <> nil then begin
      sText := TUserCastle(m_Castle).GetAttackWarList();
    end else begin
      sText := '????';
    end;
    if sText <> '' then begin
      sMsg := sub_49ADB8(sMsg, '<$LISTOFWAR>', sText);
    end else sMsg := 'ûл빥ս\ \</@main>';
    Exit;
  end;

  if sVariable = '$CASTLECHANGEDATE' then begin
    if m_Castle <> nil then begin
      sText := DateTimeToStr(TUserCastle(m_Castle).m_ChangeDate);
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$CASTLECHANGEDATE>', sText);
    Exit;
  end;

  if sVariable = '$CASTLEWARLASTDATE' then begin
    if m_Castle <> nil then begin
      sText := DateTimeToStr(TUserCastle(m_Castle).m_WarDate);
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$CASTLEWARLASTDATE>', sText);
    Exit;
  end;
  if sVariable = '$CASTLEGETDAYS' then begin
    if m_Castle <> nil then begin
      sText := IntToStr(GetDayCount(Now, TUserCastle(m_Castle).m_ChangeDate));
    end else begin
      sText := '????';
    end;
    sMsg := sub_49ADB8(sMsg, '<$CASTLEGETDAYS>', sText);
    Exit;
  end;

  if sVariable = '$CMD_DATE' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_DATE>', g_GameCommand.Data.sCmd);
    Exit;
  end;
  if sVariable = '$CMD_ALLOWMSG' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_ALLOWMSG>', g_GameCommand.ALLOWMSG.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_LETSHOUT' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_LETSHOUT>', g_GameCommand.LETSHOUT.sCmd);
    Exit;
  end;
  if sVariable = '$CMD_LETTRADE' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_LETTRADE>', g_GameCommand.LETTRADE.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_LETGUILD' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_LETGUILD>', g_GameCommand.LETGUILD.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_ENDGUILD' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_ENDGUILD>', g_GameCommand.ENDGUILD.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_BANGUILDCHAT' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_BANGUILDCHAT>', g_GameCommand.BANGUILDCHAT.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_AUTHALLY' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_AUTHALLY>', g_GameCommand.AUTHALLY.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_AUTH' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_AUTH>', g_GameCommand.AUTH.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_AUTHCANCEL' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_AUTHCANCEL>', g_GameCommand.AUTHCANCEL.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_USERMOVE' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_USERMOVE>', g_GameCommand.USERMOVE.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_SEARCHING' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_SEARCHING>', g_GameCommand.SEARCHING.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_ALLOWGROUPCALL' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_ALLOWGROUPCALL>', g_GameCommand.ALLOWGROUPCALL.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_GROUPRECALLL' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_GROUPRECALLL>', g_GameCommand.GROUPRECALLL.sCmd);
    Exit;
  end;
  {---------------------------}
  if sVariable = '$CMD_DEAR' then begin //ѯ
    sMsg := sub_49ADB8(sMsg, '<$CMD_DEAR>', g_GameCommand.DEAR.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_ALLOWDEARRCALL' then begin //Ͱ
    sMsg := sub_49ADB8(sMsg, '<$CMD_ALLOWDEARRCALL>', g_GameCommand.ALLOWDEARRCALL.sCmd);
    Exit;
  end;


  if sVariable = '$CMD_ALLOWGROUPCALL' then begin   //˺һ
    sMsg := sub_49ADB8(sMsg, '<$CMD_ALLOWGROUPCALL>', g_GameCommand.ALLOWGROUPCALL.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_ALLOWGUILDRECALL' then begin     //лһ
    sMsg := sub_49ADB8(sMsg, '<$CMD_ALLOWGUILDRECALL>', g_GameCommand.ALLOWGUILDRECALL.sCmd);
    Exit;
  end;

  if sVariable = '$CMD_GUILDRECALLL' then begin     //лһ
    sMsg := sub_49ADB8(sMsg, '<$CMD_GUILDRECALLL>', g_GameCommand.GUILDRECALLL.sCmd);
    Exit;
  end;

  {---------------------------}


  if sVariable = '$CMD_STORAGELOCK' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_STORAGELOCK>', g_GameCommand.Lock.sCmd);
    Exit;
  end;
  if sVariable = '$CMD_STORAGEUNLOCK' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_STORAGEUNLOCK>', g_GameCommand.UNLOCKSTORAGE.sCmd);
    Exit;
  end;
  if sVariable = '$CMD_UNLOCK' then begin
    sMsg := sub_49ADB8(sMsg, '<$CMD_UNLOCK>', g_GameCommand.UnLock.sCmd);
    Exit;
  end;
  if CompareLStr(sVariable, '$V_P(', Length('$V_P(')) then begin
    ArrestStringEx(sVariable, '(', ')', s14);
    boFoundVar := False;
    for i := 0 to PlayObject.m_DynamicVarList.Count - 1 do begin
      DynamicVar := PlayObject.m_DynamicVarList.Items[i];
      if CompareText(DynamicVar.sName, s14) = 0 then begin
        case DynamicVar.VarType of
          vInteger: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(DynamicVar.nInternet));
              boFoundVar := True;
            end;
          vString: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', DynamicVar.sString);
              boFoundVar := True;
            end;
        end;
        break;
      end;
    end;
    if not boFoundVar then sMsg := '??';

    Exit;
  end;
  if CompareLStr(sVariable, '$V_G(', Length('$V_G(')) then begin
    if PlayObject.m_MyGuild = nil then Exit;
    ArrestStringEx(sVariable, '(', ')', s14);
    boFoundVar := False;
    for i := 0 to TGUild(PlayObject.m_MyGuild).m_DynamicVarList.Count - 1 do begin
      DynamicVar := TGUild(PlayObject.m_MyGuild).m_DynamicVarList.Items[i];
      if CompareText(DynamicVar.sName, s14) = 0 then begin
        case DynamicVar.VarType of
          vInteger: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(DynamicVar.nInternet));
              boFoundVar := True;
            end;
          vString: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', DynamicVar.sString);
              boFoundVar := True;
            end;
        end;
        break;
      end;
    end;
    if not boFoundVar then sMsg := '??';
    Exit;
  end;
  if CompareLStr(sVariable, '$V_S(', Length('$V_S(')) then begin
    ArrestStringEx(sVariable, '(', ')', s14);
    boFoundVar := False;
    for i := 0 to g_DynamicVarList.Count - 1 do begin
      DynamicVar := g_DynamicVarList.Items[i];
      if CompareText(DynamicVar.sName, s14) = 0 then begin
        case DynamicVar.VarType of
          vInteger: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(DynamicVar.nInternet));
              boFoundVar := True;
            end;
          vString: begin
              sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', DynamicVar.sString);
              boFoundVar := True;
            end;
        end;
        break;
      end;
    end;
    if not boFoundVar then sMsg := '??';
    Exit;
  end;
  if CompareLStr(sVariable, '$STR(', Length('$STR(')) then begin
    ArrestStringEx(sVariable, '(', ')', s14);
    n18 := GetValNameNo(s14);
    if n18 >= 0 then begin
      case n18 of
        0..9: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(PlayObject.m_nVal[n18]));
          end;
        100..199: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(g_Config.nGlobalVal[n18 - 100]));
          end;
        200..209: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(PlayObject.m_DyVal[n18 - 200]));
          end;
        300..399: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(PlayObject.m_nMval[n18 - 300]));
          end;
        400..499: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(g_Config.nGlobaDyMval[n18 - 400]));
          end;
        500..599: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', IntToStr(PlayObject.m_nInteger[n18 - 500]));
          end;
        600..699: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', PlayObject.m_sString[n18 - 600]);
          end;
        700..799: begin
            sMsg := sub_49ADB8(sMsg, '<' + sVariable + '>', g_Config.sGlobalAVal[n18 - 700]);
          end;
      end;
    end;
  end;
end;

procedure TNormNpc.GotoLable(PlayObject: TPlayObject; sLabel: string; boExtJmp: Boolean;IsAction:Boolean = False); //0049E584
var
  i, ii, III, J: Integer;
  List1C: TStringList;
  bo11: Boolean;
  n18: Integer;
  n20: Integer;
  sSendMsg: string;
  Script: pTScript;
  Script3C: pTScript;
  SayingRecord: pTSayingRecord;
  SayingProcedure: pTSayingProcedure;
  UserItem: pTUserItem;
  sSC: string;
  {$i gotofun.pas}
begin
  //TasNat  ִţBXX Ľű...
  if (IsAction)and(PlayObject.m_Script <> nil) then begin
    if QuestActionProcess(PlayObject.m_Script.RecordList) then
    PlayObject.m_Script := nil;
    Exit;
  end;
  Script := nil;
  n18 := 1000;
  n20 := 0;
  if PlayObject.m_NPC <> Self then begin
    if PlayObject.m_boIsGotoHelpLabel then
      PlayObject.m_boIsGotoHelpLabel:= False;
    PlayObject.m_NPC := nil;
    PlayObject.m_Script := nil;
    FillChar(PlayObject.m_nVal, SizeOf(PlayObject.m_nVal), #0);
  end;
  if CompareText(sLabel, '@main') = 0 then begin
    for i := 0 to m_ScriptList.Count - 1 do begin
      Script3C := m_ScriptList.Items[i];
      if Script3C = nil then Continue;
      for ii := 0 to Script3C.RecordList.Count - 1 do begin
        SayingRecord := Script3C.RecordList.Items[ii];
        if SayingRecord = nil then Continue;
        if CompareText(sLabel, SayingRecord.sLabel) = 0 then begin
          Script := Script3C;
          PlayObject.m_Script := Script;
          PlayObject.m_NPC := Self;
          break;
        end;
        if Script <> nil then break;
      end;
    end;
  end;
  if (Script = nil) then begin
    if (PlayObject.m_Script <> nil) then begin
      {//if m_ScriptList.IndexOf(PlayObject.m_Script) <> -1 then
      //Script :=  PlayObject.m_Script;
      }
      for i := m_ScriptList.Count - 1 downto 0 do begin
        if m_ScriptList.Count <= 0 then break;
        if (m_ScriptList.Items[i] <> nil) and
        (m_ScriptList.Items[i] = PlayObject.m_Script) then begin
          Script := m_ScriptList.Items[i];
          Break;//ҵ˻˳.     TasNat Add 2009-10-17 07:22:19
        end;
      end;  
    end;
    if (Script = nil) then begin
      for i := m_ScriptList.Count - 1 downto 0 do begin
        if m_ScriptList.Count <= 0 then break;
        if (pTScript(m_ScriptList.Items[i]) <> nil) and CheckQuestStatus(pTScript(m_ScriptList.Items[i])) then begin
          Script := m_ScriptList.Items[i];
          PlayObject.m_Script := Script;
          PlayObject.m_NPC := Self;
        end;
      end;
    end;
  end;

  //תָʾǩִ
  if (Script <> nil) then begin
    for ii := 0 to Script.RecordList.Count - 1 do begin
      SayingRecord := Script.RecordList.Items[ii];
      if SayingRecord = nil then Continue;
      if CompareText(sLabel, SayingRecord.sLabel) = 0 then begin
        //MainOutMessage('sLabel '+sLabel+' boExtJmp '+BooleanToStr(boExtJmp)+' SayingRecord.boExtJmp '+BooleanToStr(SayingRecord.boExtJmp));
        if boExtJmp and not SayingRecord.boExtJmp then break;
        sSendMsg := '';
        for III := 0 to SayingRecord.ProcedureList.Count - 1 do begin
          SayingProcedure := SayingRecord.ProcedureList.Items[III];
          if SayingProcedure = nil then Continue;
          bo11 := False;
          if QuestCheckCondition(SayingProcedure.ConditionList) then begin
            sSendMsg := sSendMsg + SayingProcedure.sSayMsg;
            if not QuestActionProcess(SayingProcedure.ActionList) then break;
            if bo11 then SendMerChantSayMsg(sSendMsg, True);
          end else begin
            sSendMsg := sSendMsg + SayingProcedure.sElseSayMsg;
            if not QuestActionProcess(SayingProcedure.ElseActionList) then break;
            if bo11 then SendMerChantSayMsg(sSendMsg, True);
          end;
        end;
        if sSendMsg <> '' then SendMerChantSayMsg(sSendMsg, False);
        break;
      end;
    end;
  end;

end;

procedure TNormNpc.LoadScript;
var
  s08                                   : string;
begin
  if m_boIsQuest then
  begin
    m_sPath := sNpc_def;
    s08 := m_sCharName + '-' + m_sMapName;
    FrmDB.LoadScriptFile(self, m_sFilePath, s08,False);
  end
  else
  begin                                                     //0049EB8E
    m_sPath := m_sFilePath;
    FrmDB.LoadScriptFile(self, m_sFilePath, m_sCharName,False);
  end;
end;

function TNormNpc.Operate(ProcessMsg: pTProcessMessage): Boolean; //0049AB64
begin
  Result := inherited Operate(ProcessMsg);
end;

procedure TNormNpc.Run;
var
  nInteger: Integer;
begin
  if m_Master <> nil then m_Master := nil; //ٻΪ
  //NPCɫ
  if (m_btNpcAutoChangeColorMode = 1) and (m_dwNpcAutoChangeColorTime > 0) and (GetTickCount - m_dwNpcAutoChangeColorTick > m_dwNpcAutoChangeColorTime) then begin
    m_dwNpcAutoChangeColorTick := GetTickCount();
    case m_nNpcAutoChangeIdx of
      0: nInteger := STATE_TRANSPARENT;
      1: nInteger := POISON_STONE;
      2: nInteger := POISON_DONTMOVE;
      3: nInteger := POISON_68;
      4: nInteger := POISON_DECHEALTH;
      5: nInteger := POISON_LOCKSPELL;
      6: nInteger := POISON_DAMAGEARMOR;
    else begin
        m_nNpcAutoChangeIdx := 0;
        nInteger := STATE_TRANSPARENT;
      end;
    end;
    Inc(m_nNpcAutoChangeIdx);
    m_nCharStatus := (m_nCharStatusEx and $FFFFF) or (($80000000 shr nInteger) or 0);
    StatusChanged();
  end;
  inherited;
end;

procedure TNormNpc.ScriptActionError(PlayObject: TPlayObject; sErrMsg: string;
  QuestActionInfo: pTQuestActionInfo; sCmd: string);
var
  sMsg: string;
const
  sOutMessage = '[ű] %s ű:%s NPC:%s ͼ:%s(%d:%d) 1:%s 2:%s 3:%s 4:%s 5:%s 6:%s';
begin
  sMsg := format(sOutMessage, [sErrMsg,
    sCmd,
      m_sCharName,
      m_sMapName,
      m_nCurrX,
      m_nCurrY,
      QuestActionInfo.sParam1,
      QuestActionInfo.sParam2,
      QuestActionInfo.sParam3,
      QuestActionInfo.sParam4,
      QuestActionInfo.sParam5,
      QuestActionInfo.sParam6]);
  MainOutMessage(sMsg);
end;

procedure TNormNpc.ScriptConditionError(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo; sCmd: string);
var
  sMsg: string;
begin
  sMsg := 'Cmd:' + sCmd +
    ' NPC:' + m_sCharName +
    ' ͼ:' + m_sMapName +
    ' :' + IntToStr(m_nCurrX) + ':' + IntToStr(m_nCurrY) +
    ' 1:' + QuestConditionInfo.sParam1 +
    ' 2:' + QuestConditionInfo.sParam2 +
    ' 3:' + QuestConditionInfo.sParam3 +
    ' 4:' + QuestConditionInfo.sParam4 +
    ' 5:' + QuestConditionInfo.sParam5;
  MainOutMessage('[űȷ] ' + sMsg);
end;

procedure TNormNpc.AddMsgToUser(PlayObject: TPlayObject; sMsg: string); //0049AD14
begin
  PlayObject.AddAction(Self, RM_Chat,0 , 0, 0, Byte(t_MerSay), m_sCharName + '/' + sMsg);
end;

function TNormNpc.sub_49ADB8(sMsg, sStr, sText: string): string; //0049ADB8
var
  n10: Integer;
  s14, s18: string;
begin
  n10 := Pos(sStr, sMsg);
  if n10 > 0 then begin
    s14 := Copy(sMsg, 1, n10 - 1);
    s18 := Copy(sMsg, Length(sStr) + n10, Length(sMsg));
    Result := s14 + sText + s18;
  end else Result := sMsg;
end;

procedure TNormNpc.UserSelect(PlayObject: TPlayObject; sData: string); //0049EC28
var
  sMsg, sLabel: string;
begin
  PlayObject.m_nScriptGotoCount := 0;

  //==============================================
  //ű @back ϼǩ
  if (sData <> '') and (sData[1] = '@') then begin
    sMsg := GetValidStr3(sData, sLabel, [#13]);
    if (PlayObject.m_sScriptCurrLable <> sLabel) then begin
      if (sLabel <> sBACK) then begin
        PlayObject.m_sScriptGoBackLable := PlayObject.m_sScriptCurrLable;
        PlayObject.m_sScriptCurrLable := sLabel;
      end else begin
        if PlayObject.m_sScriptCurrLable <> '' then begin
          PlayObject.m_sScriptCurrLable := '';
        end else begin
          PlayObject.m_sScriptGoBackLable := '';
        end;
      end;
    end;
  end;
  //==============================================
end;

procedure TNormNpc.ActionOfChangeNameColor(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nColor: Integer;
begin
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nColor) then begin //ӱ֧
    nColor := QuestActionInfo.nParam1;
  end;
  if (nColor < 0) or (nColor > 255) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGENAMECOLOR);
    Exit;
  end;
  PlayObject.m_btNameColor := nColor;
  PlayObject.RefNameColor();
end;

procedure TNormNpc.ActionOfClearPassword(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  PlayObject.m_sStoragePwd := '';
  PlayObject.m_boPasswordLocked := False;
end;
//RECALLMOB  ȼ ѱʱ ɫ(0,1) ̶ɫ(1 - 7)
//ɫΪ0 ʱ̶ɫ

procedure TNormNpc.ActionOfRecallmob(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  boAutoChangeColor: Boolean;
  mon: TBaseObject;
  i: Integer;
  UserItem: pTUserItem;
begin
  if QuestActionInfo.nParam3 <= 1 then begin
    mon := PlayObject.MakeSlave(QuestActionInfo.sParam1, 3, Str_ToInt(QuestActionInfo.sParam2, 0), 100, 10 * 24 * 60 * 60);
  end else begin
    mon := PlayObject.MakeSlave(QuestActionInfo.sParam1, 3, Str_ToInt(QuestActionInfo.sParam2, 0), 100, QuestActionInfo.nParam3 * 60)
  end;
  if mon <> nil then begin
    if (QuestActionInfo.sParam4 <> '') and (QuestActionInfo.sParam4[1] = '1') then begin
      mon.m_boAutoChangeColor := True;
    end else
      if QuestActionInfo.nParam5 > 0 then begin
        mon.m_boFixColor := True;
        mon.m_nFixColorIdx := QuestActionInfo.nParam5 - 1;
      end;

    if mon.m_btRaceServer = RC_PLAYMOSTER then begin //ι֣ԳҩͼƷ
      mon.m_nCopyHumanLevel := 1;
      for i := 0 to m_ItemList.Count - 1 do begin //
        DisPose(m_ItemList.Items[i]);
      end;
      m_ItemList.Clear;
      TPlayMonster(mon).InitializeMonster; //¼ع
    end;
  end;
end;

procedure TNormNpc.ActionOfReNewLevel(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nReLevel, nLevel: Integer;
  nBounsuPoint: Integer;
begin
  nReLevel := Str_ToInt(QuestActionInfo.sParam1, -1);
  nLevel := Str_ToInt(QuestActionInfo.sParam2, -1);
  nBounsuPoint := Str_ToInt(QuestActionInfo.sParam3, -1);
  if nReLevel < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nReLevel); //ӱ֧
  end;
  if nLevel < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nLevel); //ӱ֧
  end;
  if nBounsuPoint < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, nBounsuPoint); //ӱ֧
  end;
  if (nReLevel < 0) or (nLevel < 0) or (nBounsuPoint < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_RENEWLEVEL);
    Exit;
  end;
  if (PlayObject.m_btReLevel + nReLevel) <= 255 then begin
    Inc(PlayObject.m_btReLevel, nReLevel);
    if nLevel > 0 then PlayObject.m_Abil.Level := nLevel;
    if g_Config.boReNewLevelClearExp then PlayObject.m_Abil.Exp := 0;
    Inc(PlayObject.m_nBonusPoint, nBounsuPoint);
    PlayObject.AddAction(PlayObject, RM_ADJUST_BONUS, 0, 0, 0, 0, '');
    PlayObject.HasLevelUp(0);
    PlayObject.RefShowName();
  end;
end;

procedure TNormNpc.ActionOfChangeGender(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nGENDER: Integer;
begin
  nGENDER := Str_ToInt(QuestActionInfo.sParam1, -1);
  if not (nGENDER in [0, 1]) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEGENDER);
    Exit;
  end;
  PlayObject.m_btGender := nGENDER;
  PlayObject.FeatureChanged;
end;

procedure TNormNpc.ActionOfKillSlave(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  Slave: TBaseObject;
begin
  for i := 0 to PlayObject.m_SlaveList.Count - 1 do begin
    Slave := TBaseObject(PlayObject.m_SlaveList.Items[i]);
    Slave.m_WAbil.HP := 0;
  end;
end;

procedure TNormNpc.ActionOfKillMonExpRate(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nRate: Integer;
  nTime: Integer;
begin
  nRate := Str_ToInt(QuestActionInfo.sParam1, -1);
  nTime := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nRate < 0) or (nTime < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_KILLMONEXPRATE);
    Exit;
  end;

  PlayObject.m_nKillMonExpRate := nRate;
  PlayObject.m_dwKillMonExpRateTime := LongWord(nTime);
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sChangeKillMonExpRateMsg, [PlayObject.m_nKillMonExpRate / 100, PlayObject.m_dwKillMonExpRateTime]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfMonGenEx(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sMapName, sMonName: string;
  nMapX, nMapY, nRange, nCount: Integer;
  nRandX, nRandY: Integer;
begin
  sMapName := QuestActionInfo.sParam1;
  nMapX := Str_ToInt(QuestActionInfo.sParam2, -1);
  nMapY := Str_ToInt(QuestActionInfo.sParam3, -1);
  sMonName := QuestActionInfo.sParam4;
  nRange := QuestActionInfo.nParam5;
  nCount := QuestActionInfo.nParam6;
  if (sMapName = '') or (nMapX <= 0) or (nMapY <= 0) or (sMapName = '') or (nRange <= 0) or (nCount <= 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_MONGENEX);
    Exit;
  end;
  for i := 0 to nCount - 1 do begin
    nRandX := Random(nRange * 2 + 1) + (nMapX - nRange);
    nRandY := Random(nRange * 2 + 1) + (nMapY - nRange);
    if UserEngine.RegenMonsterByName(sMapName, nRandX, nRandY, sMonName) = nil then begin
      break;
    end;
  end;
end;

procedure TNormNpc.ActionOfOpenMagicBox(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  Monster: TBaseObject;
  sMonName: string;
  nX, nY: SmallInt;
begin
  sMonName := QuestActionInfo.sParam1;
  if sMonName = '' then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_OPENMAGICBOX);
    Exit;
  end;
  PlayObject.GetFrontPosition(nX, nY);
  Monster := UserEngine.RegenMonsterByName(PlayObject.m_PMap.sMapName, nX, nY, sMonName);
  if Monster = nil then begin
    Exit;
  end;
  Monster.Die;
end;

procedure TNormNpc.ActionOfPkZone(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nX, nY: Integer;
  FireBurnEvent: TFireBurnEvent;
  nMinX, nMaxX, nMinY, nMaxY: Integer;
  nRange, nType, nTime, nPoint: Integer;
begin
  nRange := Str_ToInt(QuestActionInfo.sParam1, -1);
  nType := Str_ToInt(QuestActionInfo.sParam2, -1);
  nTime := Str_ToInt(QuestActionInfo.sParam3, -1);
  nPoint := Str_ToInt(QuestActionInfo.sParam4, -1);
  if (nRange < 0) or (nType < 0) or (nTime < 0) or (nPoint < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_PKZONE);
    Exit;
  end;
  nMinX := m_nCurrX - nRange;
  nMaxX := m_nCurrX + nRange;
  nMinY := m_nCurrY - nRange;
  nMaxY := m_nCurrY + nRange;
  for nX := nMinX to nMaxX do begin
    for nY := nMinY to nMaxY do begin
      if ((nX < nMaxX) and (nY = nMinY)) or
        ((nY < nMaxY) and (nX = nMinX)) or
        (nX = nMaxX) or (nY = nMaxY) then begin
        FireBurnEvent := TFireBurnEvent.Create(PlayObject, nX, nY, nType, nTime * 1000, nPoint);
        g_EventManager.AddEvent(FireBurnEvent);
      end;
    end;
  end;
end;

procedure TNormNpc.ActionOfPowerRate(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nRate: Integer;
  nTime: Integer;
begin
  nRate := Str_ToInt(QuestActionInfo.sParam1, -1);
  nTime := Str_ToInt(QuestActionInfo.sParam2, -1);
  if (nRate < 0) or (nTime < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_POWERRATE);
    Exit;
  end;

  PlayObject.m_nPowerRate := nRate;
  PlayObject.m_dwPowerRateTime := LongWord(nTime);
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sChangePowerRateMsg, [PlayObject.m_nPowerRate / 100, PlayObject.m_dwPowerRateTime]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfChangeMode(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nMode: Integer;
  boOpen: Boolean;
begin
  nMode := QuestActionInfo.nParam1;
  boOpen := Str_ToInt(QuestActionInfo.sParam2, -1) = 1;
  if nMode in [1..3] then begin
    case nMode of //
      1: begin
          PlayObject.m_boAdminMode := boOpen;
          if PlayObject.m_boAdminMode then PlayObject.SysMsg(sGameMasterMode, c_Green, t_Hint)
          else PlayObject.SysMsg(sReleaseGameMasterMode, c_Green, t_Hint);
        end;
      2: begin
          PlayObject.m_boSuperMan := boOpen;
          if PlayObject.m_boSuperMan then PlayObject.SysMsg(sSupermanMode, c_Green, t_Hint)
          else PlayObject.SysMsg(sReleaseSupermanMode, c_Green, t_Hint);
        end;
      3: begin
          PlayObject.m_boObMode := boOpen;
          if PlayObject.m_boObMode then PlayObject.SysMsg(sObserverMode, c_Green, t_Hint)
          else PlayObject.SysMsg(g_sReleaseObserverMode, c_Green, t_Hint);
        end;
    end;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEMODE);
  end;
end;

procedure TNormNpc.ActionOfChangePerMission(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nPermission: Integer;
begin
  nPermission := Str_ToInt(QuestActionInfo.sParam1, -1);
  if nPermission in [0..10] then begin
    PlayObject.m_btPermission := nPermission;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CHANGEPERMISSION);
    Exit;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sChangePermissionMsg, [PlayObject.m_btPermission]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfGiveItem(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  sItemName: string;
  nItemCount: Integer;
begin
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, sItemName) then begin //ӱ֧
    sItemName := QuestActionInfo.sParam1;
  end;
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nItemCount) then begin //ӱ֧
    nItemCount := QuestActionInfo.nParam2;
  end;
  if (sItemName = '') or (nItemCount <= 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_GIVE);
    Exit;
  end;
  if nItemCount <= 0 then Exit;
  if CompareText(sItemName, g_Config.sGoldName) = 0 then begin
    PlayObject.IncGold(nItemCount);
    PlayObject.GoldChanged();
    //0049D2FE
    if g_boGameLogGold then
      AddGameDataLog('9' + #9 +
        PlayObject.m_sMapName + #9 +
        IntToStr(PlayObject.m_nCurrX) + #9 +
        IntToStr(PlayObject.m_nCurrY) + #9 +
        PlayObject.m_sCharName + #9 +
        g_Config.sGoldName + #9 +
        IntToStr(nItemCount) + #9 +
        '1' + #9 +
        m_sCharName);
    Exit;
  end;

  if UserEngine.GetStdItemIdx(sItemName) > 0 then begin
    //    if nItemCount > 50 then nItemCount:=50;//11.22 С
    if not (nItemCount in [1..50]) then nItemCount := 1; //12.28 һ
    for i := 0 to nItemCount - 1 do begin //nItemCount Ϊ0ʱѭ
      if PlayObject.IsEnoughBag then begin
        New(UserItem);
        if UserEngine.CopyToUserItemFromName(sItemName, UserItem) then begin
          PlayObject.m_ItemList.Add((UserItem));
          PlayObject.SendAddItem(UserItem);
          StdItem := UserEngine.GetStdItem(UserItem.wIndex);
          //0049D46B
          if IsBitOn(StdItem.NeedIdentify, 12) then
            AddGameDataLog('9' + #9 +
              PlayObject.m_sMapName + #9 +
              IntToStr(PlayObject.m_nCurrX) + #9 +
              IntToStr(PlayObject.m_nCurrY) + #9 +
              PlayObject.m_sCharName + #9 +
              sItemName + #9 +
              IntToStr(UserItem.MakeIndex) + #9 +
              '1' + #9 +
              m_sCharName);
        end else DisPose(UserItem);
      end else begin
        New(UserItem);
        if UserEngine.CopyToUserItemFromName(sItemName, UserItem) then begin
          StdItem := UserEngine.GetStdItem(UserItem.wIndex);
          //0049D5A5
          if IsBitOn(StdItem.NeedIdentify, 12) then
            AddGameDataLog('9' + #9 +
              PlayObject.m_sMapName + #9 +
              IntToStr(PlayObject.m_nCurrX) + #9 +
              IntToStr(PlayObject.m_nCurrY) + #9 +
              PlayObject.m_sCharName + #9 +
              sItemName + #9 +
              IntToStr(UserItem.MakeIndex) + #9 +
              '1' + #9 +
              m_sCharName);
          PlayObject.DropItemDown(UserItem, 3, False, PlayObject, nil);
        end;
        DisPose(UserItem);
      end;
    end;
  end;
end;

procedure TNormNpc.ActionOfGmExecute(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  sData: string;
  btOldPermission: Byte;
  sParam1, sParam2, sParam3, sParam4, sParam5, sParam6: string;
begin
  sParam1 := QuestActionInfo.sParam1;
  sParam2 := QuestActionInfo.sParam2;
  sParam3 := QuestActionInfo.sParam3;
  sParam4 := QuestActionInfo.sParam4;
  sParam5 := QuestActionInfo.sParam5;
  sParam6 := QuestActionInfo.sParam6;
  if CompareText(sParam2, 'Self') = 0 then sParam2 := PlayObject.m_sCharName;

  sData := format('@%s %s %s %s %s %s', [sParam1,
    sParam2,
      sParam3,
      sParam4,
      sParam5,
      sParam6]);
  btOldPermission := PlayObject.m_btPermission;
  try
    PlayObject.m_btPermission := 10;
    PlayObject.ProcessUserLineMsg(sData);
  finally
    PlayObject.m_btPermission := btOldPermission;
  end;
end;

procedure TNormNpc.ActionOfGuildAuraePoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nAuraePoint: Integer;
  cMethod: Char;
  Guild: TGUild;
begin
  nAuraePoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nAuraePoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nAuraePoint) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_AURAEPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    PlayObject.SysMsg(g_sScriptGuildAuraePointNoGuild, c_Red, t_Hint);
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        Guild.nAurae := nAuraePoint;
      end;
    '-': begin
        if Guild.nAurae >= nAuraePoint then begin
          Guild.nAurae := Guild.nAurae - nAuraePoint;
        end else begin
          Guild.nAurae := 0;
        end;
      end;
    '+': begin
        if (High(Integer) - Guild.nAurae) >= nAuraePoint then begin
          Guild.nAurae := Guild.nAurae + nAuraePoint;
        end else begin
          Guild.nAurae := High(Integer);
        end;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptGuildAuraePointMsg, [Guild.nAurae]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfGuildBuildPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nBuildPoint: Integer;
  cMethod: Char;
  Guild: TGUild;
begin
  nBuildPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nBuildPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nBuildPoint) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_BUILDPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    PlayObject.SysMsg(g_sScriptGuildBuildPointNoGuild, c_Red, t_Hint);
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        Guild.nBuildPoint := nBuildPoint;
      end;
    '-': begin
        if Guild.nBuildPoint >= nBuildPoint then begin
          Guild.nBuildPoint := Guild.nBuildPoint - nBuildPoint;
        end else begin
          Guild.nBuildPoint := 0;
        end;
      end;
    '+': begin
        if (High(Integer) - Guild.nBuildPoint) >= nBuildPoint then begin
          Guild.nBuildPoint := Guild.nBuildPoint + nBuildPoint;
        end else begin
          Guild.nBuildPoint := High(Integer);
        end;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptGuildBuildPointMsg, [Guild.nBuildPoint]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfGuildChiefItemCount(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nItemCount: Integer;
  cMethod: Char;
  Guild: TGUild;
begin
  nItemCount := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nItemCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nItemCount) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_GUILDCHIEFITEMCOUNT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    PlayObject.SysMsg(g_sScriptGuildFlourishPointNoGuild, c_Red, t_Hint);
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        Guild.nChiefItemCount := nItemCount;
      end;
    '-': begin
        if Guild.nChiefItemCount >= nItemCount then begin
          Guild.nChiefItemCount := Guild.nChiefItemCount - nItemCount;
        end else begin
          Guild.nChiefItemCount := 0;
        end;
      end;
    '+': begin
        if (High(Integer) - Guild.nChiefItemCount) >= nItemCount then begin
          Guild.nChiefItemCount := Guild.nChiefItemCount + nItemCount;
        end else begin
          Guild.nChiefItemCount := High(Integer);
        end;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptChiefItemCountMsg, [Guild.nChiefItemCount]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfGuildFlourishPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nFlourishPoint: Integer;
  cMethod: Char;
  Guild: TGUild;
begin
  nFlourishPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nFlourishPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nFlourishPoint) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_FLOURISHPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    PlayObject.SysMsg(g_sScriptGuildFlourishPointNoGuild, c_Red, t_Hint);
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        Guild.nFlourishing := nFlourishPoint;
      end;
    '-': begin
        if Guild.nFlourishing >= nFlourishPoint then begin
          Guild.nFlourishing := Guild.nFlourishing - nFlourishPoint;
        end else begin
          Guild.nFlourishing := 0;
        end;
      end;
    '+': begin
        if (High(Integer) - Guild.nFlourishing) >= nFlourishPoint then begin
          Guild.nFlourishing := Guild.nFlourishing + nFlourishPoint;
        end else begin
          Guild.nFlourishing := High(Integer);
        end;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptGuildFlourishPointMsg, [Guild.nFlourishing]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfGuildstabilityPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);

var
  nStabilityPoint: Integer;
  cMethod: Char;
  Guild: TGUild;
begin
  nStabilityPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nStabilityPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nStabilityPoint) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_STABILITYPOINT);
      Exit;
    end;
  end;
  if PlayObject.m_MyGuild = nil then begin
    PlayObject.SysMsg(g_sScriptGuildStabilityPointNoGuild, c_Red, t_Hint);
    Exit;
  end;
  Guild := TGUild(PlayObject.m_MyGuild);

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        Guild.nStability := nStabilityPoint;
      end;
    '-': begin
        if Guild.nStability >= nStabilityPoint then begin
          Guild.nStability := Guild.nStability - nStabilityPoint;
        end else begin
          Guild.nStability := 0;
        end;
      end;
    '+': begin
        if (High(Integer) - Guild.nStability) >= nStabilityPoint then begin
          Guild.nStability := Guild.nStability + nStabilityPoint;
        end else begin
          Guild.nStability := High(Integer);
        end;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptGuildStabilityPointMsg, [Guild.nStability]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfHumanHP(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nHP: Integer;
  cMethod: Char;
begin
  nHP := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nHP < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nHP) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_HUMANHP);
      Exit;
    end;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        PlayObject.m_WAbil.HP := nHP;
      end;
    '-': begin
        if PlayObject.m_WAbil.HP >= nHP then begin
          Dec(PlayObject.m_WAbil.HP, nHP);
        end else begin
          PlayObject.m_WAbil.HP := 0;
        end;
      end;
    '+': begin
        Inc(PlayObject.m_WAbil.HP, nHP);
        if PlayObject.m_WAbil.HP > PlayObject.m_WAbil.MaxHP then PlayObject.m_WAbil.HP := PlayObject.m_WAbil.MaxHP;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptChangeHumanHPMsg, [PlayObject.m_WAbil.MaxHP]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfHumanMP(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nMP: Integer;
  cMethod: Char;
begin
  nMP := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nMP < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nMP) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_HUMANMP);
      Exit;
    end;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        PlayObject.m_WAbil.MP := nMP;
      end;
    '-': begin
        if PlayObject.m_WAbil.MP >= nMP then begin
          Dec(PlayObject.m_WAbil.MP, nMP);
        end else begin
          PlayObject.m_WAbil.MP := 0;
        end;
      end;
    '+': begin
        Inc(PlayObject.m_WAbil.MP, nMP);
        if PlayObject.m_WAbil.MP > PlayObject.m_WAbil.MaxMP then PlayObject.m_WAbil.MP := PlayObject.m_WAbil.MaxMP;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sScriptChangeHumanMPMsg, [PlayObject.m_WAbil.MaxMP]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfUseBonusPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nPosition, nCount: Integer;
  cMethod: Char;
begin
  nPosition := Str_ToInt(QuestActionInfo.sParam1, -1);
  cMethod := QuestActionInfo.sParam2[1];
  nCount := Str_ToInt(QuestActionInfo.sParam3, -1);
  if (nPosition < 0) or (nCount < 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_USEBONUSPOINT);
    Exit;
  end;
  case cMethod of
    '+': begin
        case nPosition of
          1: Inc(PlayObject.m_BonusAbil.DC, nCount);
          2: Inc(PlayObject.m_BonusAbil.MC, nCount);
          3: Inc(PlayObject.m_BonusAbil.SC, nCount);
          4: Inc(PlayObject.m_BonusAbil.AC, nCount);
          5: Inc(PlayObject.m_BonusAbil.MAC, nCount);
          6: Inc(PlayObject.m_BonusAbil.HP, nCount);
          7: Inc(PlayObject.m_BonusAbil.MP, nCount);
          8: Inc(PlayObject.m_BonusAbil.Hit, nCount);
          9: Inc(PlayObject.m_BonusAbil.Speed, nCount);
        end;
      end;
    '-': begin
        case nPosition of
          1: Dec(PlayObject.m_BonusAbil.DC, nCount);
          2: Dec(PlayObject.m_BonusAbil.MC, nCount);
          3: Dec(PlayObject.m_BonusAbil.SC, nCount);
          4: Dec(PlayObject.m_BonusAbil.AC, nCount);
          5: Dec(PlayObject.m_BonusAbil.MAC, nCount);
          6: Dec(PlayObject.m_BonusAbil.HP, nCount);
          7: Dec(PlayObject.m_BonusAbil.MP, nCount);
          8: Dec(PlayObject.m_BonusAbil.Hit, nCount);
          9: Dec(PlayObject.m_BonusAbil.Speed, nCount);
        end;
      end;
    '=': begin
        case nPosition of
          1: PlayObject.m_BonusAbil.DC := nCount;
          2: PlayObject.m_BonusAbil.MC := nCount;
          3: PlayObject.m_BonusAbil.SC := nCount;
          4: PlayObject.m_BonusAbil.AC := nCount;
          5: PlayObject.m_BonusAbil.MAC := nCount;
          6: PlayObject.m_BonusAbil.HP := nCount;
          7: PlayObject.m_BonusAbil.MP := nCount;
          8: PlayObject.m_BonusAbil.Hit := nCount;
          9: PlayObject.m_BonusAbil.Speed := nCount;
        end;
      end;
  end;
  PlayObject.RecalcAbilitys();
  PlayObject.AddAction(PlayObject, RM_ABILITY, 0, 0, 0, 0, '');
  PlayObject.AddAction(PlayObject, RM_SUBABILITY, 0, 0, 0, 0, '');
end;

procedure TNormNpc.ActionOfKick(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  PlayObject.m_boKickFlag := True;
end;

procedure TNormNpc.ActionOfKill(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nMode: Integer;
begin
  nMode := Str_ToInt(QuestActionInfo.sParam1, -1);
  if nMode in [0..3] then begin
    case nMode of //
      1: begin
          PlayObject.m_boNoItem := True;
          PlayObject.Die;
        end;
      2: begin
          PlayObject.SetLastHiter(Self);
          PlayObject.Die;
        end;
      3: begin
          PlayObject.m_boNoItem := True;
          PlayObject.SetLastHiter(Self);
          PlayObject.Die;
        end;
    else begin
        PlayObject.Die;
      end;
    end;
  end else begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_KILL);
  end;
end;

procedure TNormNpc.ActionOfBonusPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nBonusPoint: Integer;
  nPoint: Integer;
  nOldPKLevel: Integer;
  cMethod: Char;
begin
  nBonusPoint := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nBonusPoint < 0 then begin
    ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nBonusPoint); //ӱ֧
  end;
  if (nBonusPoint < 0) or (nBonusPoint > 10000) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_BONUSPOINT);
    Exit;
  end;

  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        FillChar(PlayObject.m_BonusAbil, SizeOf(TNakedAbility), #0);
        PlayObject.HasLevelUp(0);
        PlayObject.m_nBonusPoint := nBonusPoint;
        PlayObject.AddAction(PlayObject, RM_ADJUST_BONUS, 0, 0, 0, 0, '');
      end;
    '-': begin
        if PlayObject.m_nBonusPoint >= nBonusPoint then begin
          Dec(PlayObject.m_nBonusPoint, nBonusPoint);
        end else begin
          PlayObject.m_nBonusPoint := 0;
        end;
        PlayObject.AddAction(PlayObject, RM_ADJUST_BONUS, 0, 0, 0, 0, '');
      end;
    '+': begin
        Inc(PlayObject.m_nBonusPoint, nBonusPoint);
        PlayObject.AddAction(PlayObject, RM_ADJUST_BONUS, 0, 0, 0, 0, '');
      end;
  end;
end;

procedure TNormNpc.ActionOfDelMarry(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  PlayObject.m_sDearName := '';
  PlayObject.RefShowName;
end;

procedure TNormNpc.ActionOfDelMaster(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  PlayObject.m_sMasterName := '';
  PlayObject.RefShowName;
end;

procedure TNormNpc.ActionOfRestBonusPoint(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nTotleUsePoint: Integer;
begin
  nTotleUsePoint := PlayObject.m_BonusAbil.DC +
    PlayObject.m_BonusAbil.MC +
    PlayObject.m_BonusAbil.SC +
    PlayObject.m_BonusAbil.AC +
    PlayObject.m_BonusAbil.MAC +
    PlayObject.m_BonusAbil.HP +
    PlayObject.m_BonusAbil.MP +
    PlayObject.m_BonusAbil.Hit +
    PlayObject.m_BonusAbil.Speed;
  FillChar(PlayObject.m_BonusAbil, SizeOf(TNakedAbility), #0);
  Inc(PlayObject.m_nBonusPoint, nTotleUsePoint);
  PlayObject.AddAction(PlayObject, RM_ADJUST_BONUS, 0, 0, 0, 0, '');
  PlayObject.HasLevelUp(0);
  PlayObject.SysMsg('Ѹλ', c_Red, t_Hint);
end;

procedure TNormNpc.ActionOfRestReNewLevel(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
begin
  PlayObject.m_btReLevel := 0;
  PlayObject.HasLevelUp(0);
end;

procedure TNormNpc.ActionOfSetMapMode(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  Map: TMap;
  sMapName: string;
  sMapMode, sParam1, sParam2 {,sParam3,sParam4}: string;
  OldMINE:Boolean;
begin
  sMapName := QuestActionInfo.sParam1;
  sMapMode := QuestActionInfo.sParam2;
  sParam1 := QuestActionInfo.sParam3;
  sParam2 := QuestActionInfo.sParam4;
  //  sParam3:=QuestActionInfo.sParam5;
  //  sParam4:=QuestActionInfo.sParam6;

  Map := g_MapManager.FindMap(sMapName);
  if (Map = nil) or (sMapMode = '') then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETMAPMODE);
    Exit;
  end;
  OldMINE := Map.m_boMINE;
  if CompareText(sMapMode, 'SAFE') = 0 then begin
    if (sParam1 <> '') then begin
      Map.m_boSAFE := True;
    end else begin
      Map.m_boSAFE := False;
    end;
  end else
    if CompareText(sMapMode, 'DARK') = 0 then begin
      if (sParam1 <> '') then begin
        Map.m_boDARK := True;
      end else begin
        Map.m_boDARK := False;
      end;
    end else
      if CompareText(sMapMode, 'DARK') = 0 then begin
        if (sParam1 <> '') then begin
          Map.m_boDARK := True;
        end else begin
          Map.m_boDARK := False;
        end;
      end else
        if CompareText(sMapMode, 'FIGHT') = 0 then begin
          if (sParam1 <> '') then begin
            Map.m_boFightZone := True;
          end else begin
            Map.m_boFightZone := False;
          end;
        end else
          if CompareText(sMapMode, 'FIGHT3') = 0 then begin
            if (sParam1 <> '') then begin
              Map.m_boFight3Zone := True;
            end else begin
              Map.m_boFight3Zone := False;
            end;
          end else
            if CompareText(sMapMode, 'DAY') = 0 then begin
              if (sParam1 <> '') then begin
                Map.m_boDAY := True;
              end else begin
                Map.m_boDAY := False;
              end;
            end else
              if CompareText(sMapMode, 'QUIZ') = 0 then begin
                if (sParam1 <> '') then begin
                  Map.m_boQUIZ := True;
                end else begin
                  Map.m_boQUIZ := False;
                end;
              end else
                if CompareText(sMapMode, 'NORECONNECT') = 0 then begin
                  if (sParam1 <> '') then begin
                    Map.m_boNORECONNECT := True;
                    Map.sNoReconnectMap := sParam1;
                  end else begin
                    Map.m_boNORECONNECT := False;
                  end;
                end else
                    if CompareText(sMapMode, 'EXPRATE') = 0 then begin
                      if (sParam1 <> '') then begin
                        Map.m_boEXPRATE := True;
                        Map.m_nEXPRATE := Str_ToInt(sParam1, -1);
                      end else begin
                        Map.m_boEXPRATE := False;
                      end;
                    end else
                      if CompareText(sMapMode, 'PKWINLEVEL') = 0 then begin
                        if (sParam1 <> '') then begin
                          Map.m_boPKWINLEVEL := True;
                          Map.m_nPKWINLEVEL := Str_ToInt(sParam1, -1);
                        end else begin
                          Map.m_boPKWINLEVEL := False;
                        end;
                      end else
                        if CompareText(sMapMode, 'PKWINEXP') = 0 then begin
                          if (sParam1 <> '') then begin
                            Map.m_boPKWINEXP := True;
                            Map.m_nPKWINEXP := Str_ToInt(sParam1, -1);
                          end else begin
                            Map.m_boPKWINEXP := False;
                          end;
                        end else
                          if CompareText(sMapMode, 'PKLOSTLEVEL') = 0 then begin
                            if (sParam1 <> '') then begin
                              Map.m_boPKLOSTLEVEL := True;
                              Map.m_nPKLOSTLEVEL := Str_ToInt(sParam1, -1);
                            end else begin
                              Map.m_boPKLOSTLEVEL := False;
                            end;
                          end else
                            if CompareText(sMapMode, 'PKLOSTEXP') = 0 then begin
                              if (sParam1 <> '') then begin
                                Map.m_boPKLOSTEXP := True;
                                Map.m_nPKLOSTEXP := Str_ToInt(sParam1, -1);
                              end else begin
                                Map.m_boPKLOSTEXP := False;
                              end;
                            end else
                              if CompareText(sMapMode, 'DECHP') = 0 then begin
                                if (sParam1 <> '') and (sParam2 <> '') then begin
                                  Map.m_boDECHP := True;
                                  Map.m_nDECHPTIME := Str_ToInt(sParam1, -1);
                                  Map.m_nDECHPPOINT := Str_ToInt(sParam2, -1);
                                end else begin
                                  Map.m_boDECHP := False;
                                end;
                              end else
                                if CompareText(sMapMode, 'RUNHUMAN') = 0 then begin
                                  if (sParam1 <> '') then begin
                                    Map.m_boRUNHUMAN := True;
                                  end else begin
                                    Map.m_boRUNHUMAN := False;
                                  end;
                                end else
                                  if CompareText(sMapMode, 'RUNMON') = 0 then begin
                                    if (sParam1 <> '') then begin
                                      Map.m_boRUNMON := True;
                                    end else begin
                                      Map.m_boRUNMON := False;
                                    end;
                                  end else
                                    if CompareText(sMapMode, 'NEEDHOLE') = 0 then begin
                                      if (sParam1 <> '') then begin
                                        Map.m_boNEEDHOLE := True;
                                      end else begin
                                        Map.m_boNEEDHOLE := False;
                                      end;
                                    end else
                                      if CompareText(sMapMode, 'NORECALL') = 0 then begin
                                        if (sParam1 <> '') then begin
                                          Map.m_boNORECALL := True;
                                        end else begin
                                          Map.m_boNORECALL := False;
                                        end;
                                      end else
                                        if CompareText(sMapMode, 'NOGUILDRECALL') = 0 then begin
                                          if (sParam1 <> '') then begin
                                            Map.m_boNOGUILDRECALL := True;
                                          end else begin
                                            Map.m_boNOGUILDRECALL := False;
                                          end;
                                        end else
                                          if CompareText(sMapMode, 'NODEARRECALL') = 0 then begin
                                            if (sParam1 <> '') then begin
                                              Map.m_boNODEARRECALL := True;
                                            end else begin
                                              Map.m_boNODEARRECALL := False;
                                            end;
                                          end else
                                            if CompareText(sMapMode, 'NOMASTERRECALL') = 0 then begin
                                              if (sParam1 <> '') then begin
                                                Map.m_boNOMASTERRECALL := True;
                                              end else begin
                                                Map.m_boNOMASTERRECALL := False;
                                              end;
                                            end else
                                              if CompareText(sMapMode, 'NORANDOMMOVE') = 0 then begin
                                                if (sParam1 <> '') then begin
                                                  Map.m_boNORANDOMMOVE := True;
                                                end else begin
                                                  Map.m_boNORANDOMMOVE := False;
                                                end;
                                              end else
                                                if CompareText(sMapMode, 'NODRUG') = 0 then begin
                                                  if (sParam1 <> '') then begin
                                                    Map.m_boNODRUG := True;
                                                  end else begin
                                                    Map.m_boNODRUG := False;
                                                  end;
                                                end else
                                                  if CompareText(sMapMode, 'MINE') = 0 then begin
                                                    if (sParam1 <> '') then begin
                                                      Map.m_boMINE := True;
                                                    end else begin
                                                      Map.m_boMINE := False;
                                                    end;
                                                  end else
                                                    if CompareText(sMapMode, 'NOPOSITIONMOVE') = 0 then begin
                                                      if (sParam1 <> '') then begin
                                                        Map.m_boNOPOSITIONMOVE := True;
                                                      end else begin
                                                        Map.m_boNOPOSITIONMOVE := False;
                                                      end;
                                                    end;
  if Map.m_boMINE and not OldMINE then begin
    Map.MakeStoneMines;
  end;
end;

procedure TNormNpc.ActionOfSetMemberLevel(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nLevel: Integer;
  cMethod: Char;
begin
  nLevel := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nLevel) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETMEMBERLEVEL);
      Exit;
    end;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        PlayObject.m_nMemberLevel := nLevel;
      end;
    '-': begin
        Dec(PlayObject.m_nMemberLevel, nLevel);
        if PlayObject.m_nMemberLevel < 0 then PlayObject.m_nMemberLevel := 0;
      end;
    '+': begin
        Inc(PlayObject.m_nMemberLevel, nLevel);
        if PlayObject.m_nMemberLevel > 65535 then PlayObject.m_nMemberLevel := 65535;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sChangeMemberLevelMsg, [PlayObject.m_nMemberLevel]), c_Green, t_Hint);
  end;
end;

procedure TNormNpc.ActionOfSetMemberType(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nType: Integer;
  cMethod: Char;
begin
  nType := Str_ToInt(QuestActionInfo.sParam2, -1);
  if nType < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nType) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SETMEMBERTYPE);
      Exit;
    end;
  end;
  cMethod := QuestActionInfo.sParam1[1];
  case cMethod of
    '=': begin
        PlayObject.m_nMemberType := nType;
      end;
    '-': begin
        Dec(PlayObject.m_nMemberType, nType);
        if PlayObject.m_nMemberType < 0 then PlayObject.m_nMemberType := 0;
      end;
    '+': begin
        Inc(PlayObject.m_nMemberType, nType);
        if PlayObject.m_nMemberType > 65535 then PlayObject.m_nMemberType := 65535;
      end;
  end;
  if g_Config.boShowScriptActionMsg then begin
    PlayObject.SysMsg(format(g_sChangeMemberTypeMsg, [PlayObject.m_nMemberType]), c_Green, t_Hint);
  end;
end;
function TNormNpc.CheckVarNameNo(PlayObject: TPlayObject;CheckQuestConditionInfo: pTQuestConditionInfo; var n140, n180: Integer): Boolean;
  function GetValValue(sValName: string; var nValue: Integer): Boolean;
  var
    n100: Integer;
  begin  
    Result := False;  
    nValue := 0;
    n100 := GetValNameNo(sValName);  
    if n100 >= 0 then begin
      case n100 of  
        0..9: begin  
            nValue := PlayObject.m_nVal[n100];
            Result := True;  
          end;
        100..199: begin  
            nValue := g_Config.nGlobalVal[n100 - 100];  
            Result := True;  
          end;  
        200..209: begin  
            nValue := PlayObject.m_DyVal[n100 - 200];  
            Result := True;  
          end;  
        300..399: begin  
            nValue := PlayObject.m_nMval[n100 - 300];  
            Result := True;  
          end;  
        400..499: begin  
            nValue := g_Config.nGlobaDyMval[n100 - 400];  
            Result := True;  
          end;  
        500..599: begin  
            nValue := PlayObject.m_nInteger[n100 - 500];  
            Result := True;  
          end;  
      end;  
    end;  
  end;  

  function GetDynamicVarValue(sVarType, sValName: string; var nValue: Integer): Boolean;  
  var  
    n100: Integer;  
    III: Integer;  
    DynamicVar: pTDynamicVar;  
    DynamicVarList: TSimpleList;
    sName: string;  
  begin  
    Result := False;  
    DynamicVarList := GetDynamicVarList(PlayObject, sVarType, sName);
    if DynamicVarList = nil then begin  
      DisPose(DynamicVar);  
      Exit;  
    end else begin  
      for III := 0 to DynamicVarList.Count - 1 do begin  
        DynamicVar := DynamicVarList.Items[III];  
        if DynamicVar <> nil then begin  
          if CompareText(DynamicVar.sName, sValName) = 0 then begin  
            case DynamicVar.VarType of  
              vInteger: begin  
                  nValue := DynamicVar.nInternet;  
                  Result := True;  
                end;  
              vString: begin  
                end;  
            end;  
            break;  
          end;  
        end;  
      end;  
    end;  
  end;  
  function GetDataType: Integer; //  
  var  
    s10: string;  
    sParam1: string;  
    sParam2: string;  
    sParam3: string;  
  begin  
    Result := -1;  
    sParam1 := CheckQuestConditionInfo.sParam1;  
    sParam2 := CheckQuestConditionInfo.sParam2;  
    sParam3 := CheckQuestConditionInfo.sParam3;  
    if IsVarNumber(sParam1) then begin  
      if (sParam3 <> '') and (GetValNameNo(sParam3) >= 0) then begin  
        Result := 0;  
      end else  
        if (sParam3 <> '') and IsStringNumber(sParam3) then begin  
          Result := 1;  
        end;  
      Exit;  
    end;  
    if GetValNameNo(sParam1) >= 0 then begin  
      if (sParam2 <> '') and (GetValNameNo(sParam2) >= 0) then begin  
        Result := 2;  
      end else  
        if (sParam2 <> '') and IsVarNumber(sParam2) and (sParam3 <> '') then begin  
          Result := 3;  
        end else  
          if (sParam2 <> '') and IsStringNumber(sParam2) then begin  
            Result := 4;  
          end;  
    end;  
  end;  
begin  
  Result := False;  
  n140 := -1;  
  n180 := -1;  
  case GetDataType of  
    0: begin  
        if GetDynamicVarValue(CheckQuestConditionInfo.sParam1, CheckQuestConditionInfo.sParam2, n140) and  
          GetValValue(CheckQuestConditionInfo.sParam3, n180) then Result := True;  
      end;  
    1: begin  
        n180 := CheckQuestConditionInfo.nParam3;  
        if GetDynamicVarValue(CheckQuestConditionInfo.sParam1, CheckQuestConditionInfo.sParam2, n140) then Result := True;  
      end;  
    2: begin  
        if GetValValue(CheckQuestConditionInfo.sParam1, n140) and  
          GetValValue(CheckQuestConditionInfo.sParam2, n180) then Result := True;  
      end;  
    3: begin  
        if GetValValue(CheckQuestConditionInfo.sParam1, n140) and  
          GetDynamicVarValue(CheckQuestConditionInfo.sParam2, CheckQuestConditionInfo.sParam3, n180) then Result := True;  
      end;  
    4: begin  
        n180 := CheckQuestConditionInfo.nParam2;  
        if GetValValue(CheckQuestConditionInfo.sParam1, n140) then Result := True;  
      end;  
  end;  
end;  
function TNormNpc.CheckStringList(sHumName, sListFileName: string): Boolean;
var  
  i: Integer;  
  LoadList: TStringList;
begin  
  Result := False;  
  sListFileName := g_Config.sEnvirDir + sListFileName;  
  if FileExists(sListFileName) then begin  
    LoadList := TStringList.Create;  
    try  
      LoadList.LoadFromFile(sListFileName);  
    except  
      MainOutMessage('loading fail.... => ' + sListFileName);  
    end;  
    for i := 0 to LoadList.Count - 1 do begin  
      if CompareText(Trim(LoadList.Strings[i]), sHumName) = 0 then begin  
        Result := True;  
        break;  
      end;  
    end;  
    LoadList.Free;  
  end else begin  
    MainOutMessage('file not found => ' + sListFileName);  
  end;  
end;
function TNormNpc.ConditionOfCheckGuildList(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
end;

function TNormNpc.ConditionOfCheckMonMapCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  sMapName: string;
  nCount: Integer;
  nMapRangeCount: Integer;
  Map: TMap;
  MonList: TList;
  BaseObject: TBaseObject;
begin
  Result := False;
  sMapName := QuestConditionInfo.sParam1;
  nCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCount < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCount);
  Map := g_MapManager.FindMap(sMapName);
  if (Map = nil) or (nCount < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sCHECKMONMAP);
    Exit;
  end;
  MonList := TList.Create;
  nMapRangeCount := UserEngine.GetMapMonster(Map, MonList);
  for i := MonList.Count - 1 downto 0 do begin
    if MonList.Count <= 0 then break;
    BaseObject := TBaseObject(MonList.Items[i]);
    if (BaseObject.m_btRaceServer < RC_ANIMAL) or (BaseObject.m_btRaceServer = RC_ARCHERGUARD) or (BaseObject.m_Master <> nil) or (BaseObject.m_btRaceServer = RC_NPC) or (BaseObject.m_btRaceServer = RC_PEACENPC) then
      MonList.Delete(i);
  end;
  nMapRangeCount := MonList.Count;
  if nMapRangeCount >= nCount then Result := True;
  MonList.Free;
end;

function TNormNpc.ConditionOfCheckRangeMonCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  sMapName: string;
  nX, nY, nRange, nCount: Integer;
  cMethod: Char;
  nMapRangeCount: Integer;
  Map: TMap;
  MonList: TList;
  BaseObject: TBaseObject;
begin
  Result := False;
  sMapName := QuestConditionInfo.sParam1;
  nX := Str_ToInt(QuestConditionInfo.sParam2, -1);
  nY := Str_ToInt(QuestConditionInfo.sParam3, -1);
  nRange := Str_ToInt(QuestConditionInfo.sParam4, -1);
  cMethod := QuestConditionInfo.sParam5[1];
  nCount := Str_ToInt(QuestConditionInfo.sParam6, -1);
  if nX < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nX);
  if nY < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nY);
  if nRange < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nRange);
  if nCount < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam6, nCount);
  Map := g_MapManager.FindMap(sMapName);
  if (Map = nil) or (nX < 0) or (nY < 0) or (nRange < 0) or (nCount < 0) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKRANGEMONCOUNT);
    Exit;
  end;
  MonList := TList.Create;
  nMapRangeCount := Map.GetRangeBaseObject(nX, nY, nRange, True, MonList);
  for i := MonList.Count - 1 downto 0 do begin
    if MonList.Count <= 0 then break;
    BaseObject := TBaseObject(MonList.Items[i]);
    if (BaseObject.m_btRaceServer < RC_ANIMAL) or (BaseObject.m_btRaceServer = RC_ARCHERGUARD) or (BaseObject.m_Master <> nil) or (BaseObject.m_btRaceServer = RC_NPC) or (BaseObject.m_btRaceServer = RC_PEACENPC) then
      MonList.Delete(i);
  end;
  nMapRangeCount := MonList.Count;
  case cMethod of
    '=': if nMapRangeCount = nCount then Result := True;
    '>': if nMapRangeCount > nCount then Result := True;
    '<': if nMapRangeCount < nCount then Result := True;
  else if nMapRangeCount >= nCount then Result := True;
  end;
  MonList.Free;
end;

function TNormNpc.ConditionOfCheckReNewLevel(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nLevel: Integer;
  cMethod: Char;
begin
  Result := False;
  nLevel := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nLevel) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKLEVELEX);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_btReLevel = nLevel then Result := True;
    '>': if PlayObject.m_btReLevel > nLevel then Result := True;
    '<': if PlayObject.m_btReLevel < nLevel then Result := True;
  else if PlayObject.m_btReLevel >= nLevel then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckSlaveLevel(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  nLevel: Integer;
  cMethod: Char;
  BaseObject: TBaseObject;
  nSlaveLevel: Integer;
begin
  Result := False;
  nLevel := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nLevel < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nLevel) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKLEVELEX);
      Exit;
    end;
  end;
  nSlaveLevel := -1;
  for i := 0 to PlayObject.m_SlaveList.Count - 1 do begin
    BaseObject := TBaseObject(PlayObject.m_SlaveList.Items[i]);
    if BaseObject.m_Abil.Level > nSlaveLevel then nSlaveLevel := BaseObject.m_Abil.Level;
  end;
  if nSlaveLevel < 0 then Exit;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if nSlaveLevel = nLevel then Result := True;
    '>': if nSlaveLevel > nLevel then Result := True;
    '<': if nSlaveLevel < nLevel then Result := True;
  else if nSlaveLevel >= nLevel then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckUseItem(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nWhere: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  Result := False;
  nWhere := Str_ToInt(QuestConditionInfo.sParam1, -1);
  if nWhere < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, nWhere);
  if (nWhere < 0) or (nWhere > High(THumItems)) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKUSEITEM);
    Exit;
  end;
  if PlayObject.m_UseItems[nWhere].wIndex > 0 then
    Result := True;
end;

function TNormNpc.ConditionOfCheckVar(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  sType: string;
  VarType: TVarType;
  sVarName: string;
  sVarValue: string;
  nVarValue: Integer;
  sName: string;
  sMethod: string;
  cMethod: Char;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;
  DynamicVarList: TSimpleList;
const
  sVarFound = '%sѴڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  Result := False;
  sType := QuestConditionInfo.sParam1;
  sVarName := QuestConditionInfo.sParam2;
  sMethod := QuestConditionInfo.sParam3;
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, nVarValue) then //ӱ֧
    nVarValue := Str_ToInt(QuestConditionInfo.sParam4, 0);
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam4, sVarValue) then
    if not GetHumanInfoValue(PlayObject,QuestConditionInfo.sParam4, sVarValue) then //ӱ֧
      sVarValue := QuestConditionInfo.sParam4;

  if (sType = '') or (sVarName = '') or (sMethod = '') then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKVAR);
    Exit;
  end;
  cMethod := sMethod[1];
  DynamicVarList := GetDynamicVarList(PlayObject, sType, sName);
  if DynamicVarList = nil then begin
    ScriptConditionError(PlayObject {,format(sVarTypeError,[sType])}, QuestConditionInfo, sSC_CHECKVAR);
    Exit;
  end else begin
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if DynamicVar <> nil then begin
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          case DynamicVar.VarType of
            vInteger: begin
                case cMethod of
                  '=': if DynamicVar.nInternet = nVarValue then Result := True;
                  '>': if DynamicVar.nInternet > nVarValue then Result := True;
                  '<': if DynamicVar.nInternet < nVarValue then Result := True;
                else if DynamicVar.nInternet >= nVarValue then Result := True;
                end;
              end;
            vString:begin
                case cMethod of
                  '=': if DynamicVar.sString = sVarValue   then Result := True;

                end;
              end;
          end;
          boFoundVar := True;
          break;
        end;
      end;
    end;
    if not boFoundVar then
      ScriptConditionError(PlayObject, {format(sVarFound,[sVarName,sType]),} QuestConditionInfo, sSC_CHECKVAR);
  end;
end;

function TNormNpc.ConditionOfHaveMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := False;
  if PlayObject.m_sMasterName <> '' then
    Result := True;
end;

function TNormNpc.ConditionOfPoseHaveMaster(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  PoseHuman: TBaseObject;
begin
  Result := False;
  PoseHuman := PlayObject.GetPoseCreate();
  if (PoseHuman <> nil) and (PoseHuman.m_btRaceServer = RC_PLAYOBJECT) then begin
    if (TPlayObject(PoseHuman).m_sMasterName <> '') then
      Result := True;
  end;
end;

procedure TNormNpc.ActionOfUnMaster(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  PoseHuman: TPlayObject;
  LoadList: TStringList;
  sUnMarryFileName: string;
  sMsg: string;
begin
  if PlayObject.m_sMasterName = '' then begin
    GotoLable(PlayObject, '@ExeMasterFail', False);
    Exit;
  end;
  PoseHuman := TPlayObject(PlayObject.GetPoseCreate);
  if PoseHuman = nil then begin
    GotoLable(PlayObject, '@UnMasterCheckDir', False);
  end;
  if PoseHuman <> nil then begin
    if QuestActionInfo.sParam1 = '' then begin
      if PoseHuman.m_btRaceServer <> RC_PLAYOBJECT then begin
        GotoLable(PlayObject, '@UnMasterTypeErr', False);
        Exit;
      end;
      if PoseHuman.GetPoseCreate = PlayObject then begin
        if (PlayObject.m_sMasterName = PoseHuman.m_sCharName) then begin
          if PlayObject.m_boMaster then begin
            GotoLable(PlayObject, '@UnIsMaster', False);
            Exit;
          end;
          if PlayObject.m_sMasterName <> PoseHuman.m_sCharName then begin
            GotoLable(PlayObject, '@UnMasterError', False);
            Exit;
          end;

          GotoLable(PlayObject, '@StartUnMaster', False);
          GotoLable(PoseHuman, '@WateUnMaster', False);
          Exit;
        end;
      end;
    end;
  end;
  if (CompareText(QuestActionInfo.sParam1, 'REQUESTUNMASTER' {sREQUESTUNMARRY}) = 0) then begin
    if (QuestActionInfo.sParam2 = '') then begin
      if PoseHuman <> nil then begin
        PlayObject.m_boStartUnMaster := True;
        if PlayObject.m_boStartUnMaster and PoseHuman.m_boStartUnMaster then begin
          sMsg := AnsiReplaceText(g_sNPCSayUnMasterOKMsg, '%n', m_sCharName);
          sMsg := AnsiReplaceText(sMsg, '%s', PlayObject.m_sCharName);
          sMsg := AnsiReplaceText(sMsg, '%d', PoseHuman.m_sCharName);
          UserEngine.SendBroadCastMsg(sMsg, t_Say);
          PlayObject.m_sMasterName := '';
          PoseHuman.m_sMasterName := '';
          PlayObject.m_boStartUnMaster := False;
          PoseHuman.m_boStartUnMaster := False;
          PlayObject.RefShowName;
          PoseHuman.RefShowName;
          GotoLable(PlayObject, '@UnMasterEnd', False);
          GotoLable(PoseHuman, '@UnMasterEnd', False);
        end else begin
          GotoLable(PlayObject, '@WateUnMaster', False);
          GotoLable(PoseHuman, '@RevUnMaster', False);
        end;
      end;
      Exit;
    end else begin
      //ǿгʦ
      if (CompareText(QuestActionInfo.sParam2, 'FORCE') = 0) then begin
        sMsg := AnsiReplaceText(g_sNPCSayForceUnMasterMsg, '%n', m_sCharName);
        sMsg := AnsiReplaceText(sMsg, '%s', PlayObject.m_sCharName);
        sMsg := AnsiReplaceText(sMsg, '%d', PlayObject.m_sMasterName);
        UserEngine.SendBroadCastMsg(sMsg, t_Say);

        PoseHuman := UserEngine.GetPlayObject(PlayObject.m_sMasterName);
        if PoseHuman <> nil then begin
          PoseHuman.m_sMasterName := '';
          PoseHuman.RefShowName;
        end else begin
          g_UnForceMasterList.Lock;
          try
            g_UnForceMasterList.Add(PlayObject.m_sMasterName);
            SaveUnForceMasterList();
          finally
            g_UnForceMasterList.UnLock;
          end;
        end;
        PlayObject.m_sMasterName := '';
        GotoLable(PlayObject, '@UnMasterEnd', False);
        PlayObject.RefShowName;
      end;
      Exit;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckCastleGold(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nGold: Integer;
begin
  Result := False;
  nGold := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nGold < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nGold);
  if (nGold < 0) or (m_Castle = nil) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKCASTLEGOLD);
    Exit;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if TUserCastle(m_Castle).m_nTotalGold = nGold then Result := True;
    '>': if TUserCastle(m_Castle).m_nTotalGold > nGold then Result := True;
    '<': if TUserCastle(m_Castle).m_nTotalGold < nGold then Result := True;
  else if TUserCastle(m_Castle).m_nTotalGold >= nGold then Result := True;
  end;
  {
  Result:=False;
  nGold:=Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nGold < 0 then begin
    ScriptConditionError(PlayObject,QuestConditionInfo,sSC_CHECKCASTLEGOLD);
    exit;
  end;
  cMethod:=QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if UserCastle.m_nTotalGold = nGold then Result:=True;
    '>': if UserCastle.m_nTotalGold > nGold then Result:=True;
    '<': if UserCastle.m_nTotalGold < nGold then Result:=True;
    else if UserCastle.m_nTotalGold >= nGold then Result:=True;
  end;
  }
end;


function TNormNpc.ConditionOfCheckContribution(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nContribution: Integer;
  cMethod: Char;
begin
  Result := False;
  nContribution := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nContribution < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nContribution) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKCONTRIBUTION);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_wContribution = nContribution then Result := True;
    '>': if PlayObject.m_wContribution > nContribution then Result := True;
    '<': if PlayObject.m_wContribution < nContribution then Result := True;
  else if PlayObject.m_wContribution >= nContribution then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckCreditPoint(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nCreditPoint: Integer;
  cMethod: Char;
begin
  Result := False;
  nCreditPoint := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nCreditPoint < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nCreditPoint) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKCREDITPOINT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_btCreditPoint = nCreditPoint then Result := True;
    '>': if PlayObject.m_btCreditPoint > nCreditPoint then Result := True;
    '<': if PlayObject.m_btCreditPoint < nCreditPoint then Result := True;
  else if PlayObject.m_btCreditPoint >= nCreditPoint then Result := True;
  end;
end;

procedure TNormNpc.ActionOfClearNeedItems(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  nNeed: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  nNeed := Str_ToInt(QuestActionInfo.sParam1, -1);
  if (nNeed < 0) then begin
    if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nNeed) then begin //ӱ֧
      ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CLEARNEEDITEMS);
      Exit;
    end;
  end;
  for i := PlayObject.m_ItemList.Count - 1 downto 0 do begin
    if PlayObject.m_ItemList.Count <= 0 then break;
    UserItem := PlayObject.m_ItemList.Items[i];
    if UserItem = nil then Continue;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if (StdItem <> nil) and (StdItem.btNeedType = nNeed) then begin
      PlayObject.SendDelItems(UserItem);
      DisPose(UserItem);
      PlayObject.m_ItemList.Delete(i);
    end;
  end;

  for i := PlayObject.m_StorageItemList.Count - 1 downto 0 do begin
    if PlayObject.m_StorageItemList.Count <= 0 then break;
    UserItem := PlayObject.m_StorageItemList.Items[i];
    if UserItem = nil then Continue;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if (StdItem <> nil) and (StdItem.btNeedType = nNeed) then begin
      DisPose(UserItem);
      PlayObject.m_StorageItemList.Delete(i);
    end;
  end;
end;

procedure TNormNpc.ActionOfClearMakeItems(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  nMakeIndex: Integer;
  sItemName: string;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  boMatchName: Boolean;
begin
  sItemName := QuestActionInfo.sParam1;
  nMakeIndex := QuestActionInfo.nParam2;
  boMatchName := QuestActionInfo.sParam3 = '1';
  if (sItemName = '') or (nMakeIndex <= 0) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CLEARMAKEITEMS);
    Exit;
  end;
  for i := PlayObject.m_ItemList.Count - 1 downto 0 do begin
    if PlayObject.m_ItemList.Count <= 0 then break;
    UserItem := PlayObject.m_ItemList.Items[i];
    if UserItem = nil then Continue;
    if UserItem.MakeIndex <> nMakeIndex then Continue;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if not boMatchName or ((StdItem <> nil) and (CompareText(StdItem.Name, sItemName) = 0)) then begin
      PlayObject.SendDelItems(UserItem);
      DisPose(UserItem);
      PlayObject.m_ItemList.Delete(i);
    end;
  end;

  for i := PlayObject.m_StorageItemList.Count - 1 downto 0 do begin
    if PlayObject.m_StorageItemList.Count <= 0 then break;
    UserItem := PlayObject.m_ItemList.Items[i];
    if UserItem = nil then Continue;
    if UserItem.MakeIndex <> nMakeIndex then Continue;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if not boMatchName or ((StdItem <> nil) and (CompareText(StdItem.Name, sItemName) = 0)) then begin
      DisPose(UserItem);
      PlayObject.m_StorageItemList.Delete(i);
    end;
  end;

  for i := Low(PlayObject.m_UseItems) to High(PlayObject.m_UseItems) do begin
    UserItem := @PlayObject.m_UseItems[i];
    if UserItem.MakeIndex <> nMakeIndex then Continue;
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if not boMatchName or ((StdItem <> nil) and (CompareText(StdItem.Name, sItemName) = 0)) then begin
      UserItem.wIndex := 0;
    end;
  end;
end;

function TNormNpc.ConditionOfCheckOfGuild(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sGuildName: string;
begin
  Result := False;
  if QuestConditionInfo.sParam1 = '' then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKOFGUILD);
    Exit;
  end;
  if (PlayObject.m_MyGuild <> nil) then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sGuildName) then begin //ӱ֧
      sGuildName := QuestConditionInfo.sParam1;
    end;
    if CompareText(TGUild(PlayObject.m_MyGuild).sGuildName, sGuildName) = 0 then begin
      Result := True;
    end;
  end;
end;
function TNormNpc.ConditionOfCheckOnline(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  sWhere: string;
begin
  Result := False;
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sWhere)then
    sWhere := QuestConditionInfo.sParam1;
  if (sWhere = '')  then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKUSEITEM);
    Exit;
  end;
  if UserEngine.GetPlayObject(sWhere) <> nil then
    Result := True;

end;  
function TNormNpc.ConditionOfCheckOnlineLongMin(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  cMethod: Char;
  nOnlineMin: Integer;
  nOnlineTime: Integer;
begin
  Result := False;
  nOnlineMin := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nOnlineMin < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nOnlineMin) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_ONLINELONGMIN);
      Exit;
    end;
  end;
  nOnlineTime := (GetTickCount - PlayObject.m_dwLogonTick) div 60000;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if nOnlineTime = nOnlineMin then Result := True;
    '>': if nOnlineTime > nOnlineMin then Result := True;
    '<': if nOnlineTime < nOnlineMin then Result := True;
  else if nOnlineTime >= nOnlineMin then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckPasswordErrorCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nErrorCount: Integer;
  cMethod: Char;
begin
  Result := False;
  nErrorCount := Str_ToInt(QuestConditionInfo.sParam2, -1);
  if nErrorCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam2, nErrorCount) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_PASSWORDERRORCOUNT);
      Exit;
    end;
  end;
  cMethod := QuestConditionInfo.sParam1[1];
  case cMethod of
    '=': if PlayObject.m_btPwdFailCount = nErrorCount then Result := True;
    '>': if PlayObject.m_btPwdFailCount > nErrorCount then Result := True;
    '<': if PlayObject.m_btPwdFailCount < nErrorCount then Result := True;
  else if PlayObject.m_btPwdFailCount >= nErrorCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfIsLockPassword(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := PlayObject.m_boPasswordLocked;
end;

function TNormNpc.ConditionOfIsLockStorage(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
begin
  Result := not PlayObject.m_boCanGetBackItem;
end;

function TNormNpc.ConditionOfCheckPayMent(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nPayMent: Integer;
begin
  Result := False;
  nPayMent := Str_ToInt(QuestConditionInfo.sParam1, -1);
  if nPayMent < 1 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, nPayMent) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKPAYMENT);
      Exit;
    end;
  end;
  if PlayObject.m_nPayMent = nPayMent then Result := True;
end;

function TNormNpc.ConditionOfCheckSlaveName(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  sSlaveName: string;
  BaseObject: TBaseObject;
begin
  Result := False;
  if QuestConditionInfo.sParam1 = '' then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKSLAVENAME);
    Exit;
  end;
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sSlaveName) then begin //ӱ֧
    sSlaveName := QuestConditionInfo.sParam1;
  end;
  for i := 0 to PlayObject.m_SlaveList.Count - 1 do begin
    BaseObject := TBaseObject(PlayObject.m_SlaveList.Items[i]);
    if CompareText(sSlaveName, BaseObject.m_sCharName) = 0 then begin
      Result := True;
      break;
    end;
  end;
end;
procedure TNormNpc.ActionOfChangeSlaveName(PlayObject: TPlayObject;QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  BaseObject: TBaseObject;
begin
  if PlayObject.m_sString[0] = '' then begin
    ScriptActionError(PlayObject, '',QuestActionInfo, sSC_ChangeSlaveName);
    Exit;
  end;
  for i := 0 to PlayObject.m_SlaveList.Count - 1 do begin
    BaseObject := TBaseObject(PlayObject.m_SlaveList.Items[i]);
    BaseObject.m_sCharName := PlayObject.m_sString[0];
    BaseObject.RefShowName;
    {if CompareText(sSlaveName, BaseObject.m_sCharName) = 0 then begin
      Result := True;
      break;
    end;}
  end;
end;

procedure TNormNpc.ActionOfAddGuildMember(PlayObject: TPlayObject;QuestActionInfo: pTQuestActionInfo);
var
  DesGuild:TGUild;
  DesGuildName:string;
begin
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, DesGuildName) then begin //ӱ֧
    DesGuildName := QuestActionInfo.sParam1;
  end;
  DesGuild := g_GuildManager.FindGuild(DesGuildName);
  if (DesGuild = nil) then  begin
    ScriptActionError(PlayObject, '',QuestActionInfo, sSC_AddGuildMember);
    Exit;
  end;
  if (not DesGuild.IsMember(PlayObject.m_sCharName)) then begin
    if (PlayObject.m_MyGuild = nil) and (DesGuild.m_RankList.Count < 400) then begin
      DesGuild.AddMember(PlayObject);
      PlayObject.m_MyGuild := DesGuild;
      PlayObject.m_sGuildRankName := DesGuild.GetRankName(PlayObject, PlayObject.m_nGuildRankNo);
      PlayObject.RefShowName();
      PlayObject.SysMsg('Ѽл: ' + DesGuild.sGuildName +
                        ' ǰΪ: ' + PlayObject.m_sGuildRankName, c_Green, t_Hint);

    end;
  end;
end;
procedure TNormNpc.ActionOfUpgradeItems(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nRate, nWhere, nValType, nPoint, nAddPoint: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  nWhere := Str_ToInt(QuestActionInfo.sParam1, -1);
  nRate := Str_ToInt(QuestActionInfo.sParam2, -1);
  nPoint := Str_ToInt(QuestActionInfo.sParam3, -1);
  if nWhere < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nWhere); //ӱ֧
  if nRate < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nRate); //ӱ֧
  if nPoint < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, nPoint); //ӱ֧
  if (nWhere < 0) or (nWhere > High(THumItems )) or (nRate < 0) or (nPoint < 0) or (nPoint > 255) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_UPGRADEITEMS);
    Exit;
  end;
  UserItem := @PlayObject.m_UseItems[nWhere];
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if (UserItem.wIndex <= 0) or (StdItem = nil) then begin
    PlayObject.SysMsg('ûдָƷ', c_Red, t_Hint);
    Exit;
  end;
  nRate := Random(nRate);
  nPoint := Random(nPoint);
  nValType := Random(13);
  if nRate <> 0 then begin
    PlayObject.SysMsg('װʧܣ', c_Red, t_Hint);
    Exit;
  end;
  if nValType = 13 then begin
    nAddPoint := (nPoint * 1000);
    if UserItem.DuraMax + nAddPoint > High(Word) then begin
      nAddPoint := High(Word) - UserItem.DuraMax;
    end;
    UserItem.DuraMax := UserItem.DuraMax + nAddPoint;
  end else begin
    nAddPoint := nPoint;
    if UserItem.btAddValue[nValType] + nAddPoint > High(Byte) then begin
      nAddPoint := High(Byte) - UserItem.btAddValue[nValType];
    end;
    UserItem.btAddValue[nValType] := UserItem.btAddValue[nValType] + nAddPoint;
  end;
  PlayObject.SendUpdateItem(UserItem);
  PlayObject.SysMsg('װɹ...', c_Green, t_Hint);
  {PlayObject.SysMsg(StdItem.Name + ': ' +
    IntToStr(UserItem.Dura) + '/' + GetAddValue('/',UserItem.btAddValue)
    , c_Blue, t_Hint);}
end;

procedure TNormNpc.ActionOfUpgradeItemsEx(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  nRate, nWhere, nValType, nPoint, nAddPoint: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  nUpgradeItemStatus: Integer;
  nRatePoint: Integer;
begin
  nWhere := Str_ToInt(QuestActionInfo.sParam1, -1);
  nValType := Str_ToInt(QuestActionInfo.sParam2, -1);
  nRate := Str_ToInt(QuestActionInfo.sParam3, -1);
  nPoint := Str_ToInt(QuestActionInfo.sParam4, -1);
  if nWhere < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, nWhere); //ӱ֧
  if nValType < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, nValType); //ӱ֧
  if nRate < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, nRate); //ӱ֧
  if nPoint < 0 then ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam4, nPoint); //ӱ֧
  nUpgradeItemStatus := Str_ToInt(QuestActionInfo.sParam5, -1);
  if (nValType < 0) or (nValType > 13) or (nWhere < 0) or (nWhere > High(THumItems)) or (nRate < 0) or (nPoint < 0) or (nPoint > 255) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_UPGRADEITEMSEX);
    Exit;
  end;
  UserItem := @PlayObject.m_UseItems[nWhere];
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if (UserItem.wIndex <= 0) or (StdItem = nil) then begin
    PlayObject.SysMsg('ûдָƷ', c_Red, t_Hint);
    Exit;
  end;
  nRatePoint := Random(nRate * 10);
  nPoint := _MAX(1, Random(nPoint));

  if not (nRatePoint in [0..10]) then begin
    case nUpgradeItemStatus of //
      0: begin
          PlayObject.SysMsg('װδɹ', c_Red, t_Hint);
        end;
      1: begin
          PlayObject.SendDelItems(UserItem);
          UserItem.wIndex := 0;
          PlayObject.SysMsg('װ飡', c_Red, t_Hint);
        end;
      2: begin
          PlayObject.SysMsg('װʧܣװԻָĬϣ', c_Red, t_Hint);
          if nValType <> 13 then
            UserItem.btAddValue[nValType] := 0;
        end;
    end;
    Exit;
  end;
  if nValType = 13 then begin
    nAddPoint := (nPoint * 1000);
    if UserItem.DuraMax + nAddPoint > High(Word) then begin
      nAddPoint := High(Word) - UserItem.DuraMax;
    end;
    UserItem.DuraMax := UserItem.DuraMax + nAddPoint;
  end else begin
    nAddPoint := nPoint;
    if UserItem.btAddValue[nValType] + nAddPoint > High(Byte) then begin
      nAddPoint := High(Byte) - UserItem.btAddValue[nValType];
    end;
    UserItem.btAddValue[nValType] := UserItem.btAddValue[nValType] + nAddPoint;
  end;
  PlayObject.SendUpdateItem(UserItem);
  PlayObject.SysMsg('װɹ...', c_Green, t_Hint);
  {PlayObject.SysMsg(StdItem.Name + ': ' +GetAddValue('/',UserItem.btAddValue)
    , c_Blue, t_Hint);}
end;

//
//VAR (Integer String) (HUMAN GUILD GLOBAL) ֵ

procedure TNormNpc.ActionOfVar(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sType: string;
  VarType: TVarType;
  sVarName: string;
  sVarValue: string;
  nVarValue: Integer;
  sName: string;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;
  DynamicVarList: TSimpleList;
const
  sVarFound = '%sѴڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  sType := QuestActionInfo.sParam2;
  sVarName := QuestActionInfo.sParam3;
  sVarValue := QuestActionInfo.sParam4;
  nVarValue := Str_ToInt(QuestActionInfo.sParam4, 0);
  VarType := vNone;
  if CompareText(QuestActionInfo.sParam1, 'Integer') = 0 then VarType := vInteger;
  if CompareText(QuestActionInfo.sParam1, 'String') = 0 then VarType := vString;

  if (sType = '') or (sVarName = '') or (VarType = vNone) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_VAR);
    Exit;
  end;
  New(DynamicVar);
  DynamicVar.sName := sVarName;
  DynamicVar.VarType := VarType;
  DynamicVar.nInternet := nVarValue;
  DynamicVar.sString := sVarValue;
  boFoundVar := False;
  DynamicVarList := GetDynamicVarList(PlayObject, sType, sName);
  if DynamicVarList = nil then begin
    DisPose(DynamicVar);
    ScriptActionError(PlayObject, format(sVarTypeError, [sType]), QuestActionInfo, sSC_VAR);
    Exit;
  end;
  for i := 0 to DynamicVarList.Count - 1 do begin
    if CompareText(pTDynamicVar(DynamicVarList.Items[i]).sName, sVarName) = 0 then begin
      boFoundVar := True;
      break;
    end;
  end;
  if not boFoundVar then begin
    DynamicVarList.Add(DynamicVar);
  end else begin
    ScriptActionError(PlayObject, format(sVarFound, [sVarName, sType]), QuestActionInfo, sSC_VAR);
  end;
end;
//ȡֵ
//LOADVAR   ļ

procedure TNormNpc.ActionOfLoadVar(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sType: string;
  sVarName: string;
  sFileName: string;
  sName: string;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;
  DynamicVarList: TSimpleList;
  IniFile: TIniFile;
const
  sVarFound = '%sڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  sType := QuestActionInfo.sParam1;
  sVarName := QuestActionInfo.sParam2;
  sFileName := g_Config.sEnvirDir + m_sPath + QuestActionInfo.sParam3;
  if (sType = '') or (sVarName = '') or not FileExists(sFileName) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_LOADVAR);
    Exit;
  end;
  boFoundVar := False;
  DynamicVarList := GetDynamicVarList(PlayObject, sType, sName);
  if DynamicVarList = nil then begin
    DisPose(DynamicVar);
    ScriptActionError(PlayObject, format(sVarTypeError, [sType]), QuestActionInfo, sSC_VAR);
    Exit;
  end else begin
    IniFile := TIniFile.Create(sFileName);
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if DynamicVar <> nil then begin
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          case DynamicVar.VarType of
            vInteger: DynamicVar.nInternet := IniFile.ReadInteger(sName, DynamicVar.sName, 0);
            vString: DynamicVar.sString := IniFile.ReadString(sName, DynamicVar.sName, '');
          end;
          boFoundVar := True;
          break;
        end;
      end;
    end;
    if not boFoundVar then
      ScriptActionError(PlayObject, format(sVarFound, [sVarName, sType]), QuestActionInfo, sSC_LOADVAR);
    IniFile.Free;
  end;
end;

//ֵ
//SAVEVAR   ļ

procedure TNormNpc.ActionOfSaveVar(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sType: string;
  sVarName: string;
  sFileName: string;
  sName: string;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;
  DynamicVarList: TSimpleList;
  IniFile: TIniFile;
const
  sVarFound = '%sڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  sType := QuestActionInfo.sParam1;
  sVarName := QuestActionInfo.sParam2;
  sFileName := g_Config.sEnvirDir + m_sPath + QuestActionInfo.sParam3;
  if (sType = '') or (sVarName = '') or not FileExists(sFileName) then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_SAVEVAR);
    Exit;
  end;
  boFoundVar := False;
  DynamicVarList := GetDynamicVarList(PlayObject, sType, sName);
  if DynamicVarList = nil then begin
    DisPose(DynamicVar);
    ScriptActionError(PlayObject, format(sVarTypeError, [sType]), QuestActionInfo, sSC_VAR);
    Exit;
  end else begin
    IniFile := TIniFile.Create(sFileName);
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if DynamicVar <> nil then begin
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          case DynamicVar.VarType of
            vInteger: IniFile.WriteInteger(sName, DynamicVar.sName, DynamicVar.nInternet);
            vString: IniFile.WriteString(sName, DynamicVar.sName, DynamicVar.sString);
          end;
          boFoundVar := True;
          break;
        end;
      end;
    end;
    if not boFoundVar then
      ScriptActionError(PlayObject, format(sVarFound, [sVarName, sType]), QuestActionInfo, sSC_SAVEVAR);
    IniFile.Free;
  end;
end;
//Ա(+-*/)

procedure TNormNpc.ActionOfCalcVar(PlayObject: TPlayObject;
  QuestActionInfo: pTQuestActionInfo);
var
  i: Integer;
  sType: string;
  sVarName: string;
  sName: string;
  sVarValue: string;
  sVarValue2: string;
  nVarValue: Integer;
  nVarValue2: Integer;
  sMethod: string;
  cMethod: Char;
  DynamicVar: pTDynamicVar;
  boFoundVar: Boolean;
  DynamicVarList: TSimpleList;
  sString: string;
const
  sVarFound = '%sڣ:%s';
  sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
begin
  sType := QuestActionInfo.sParam1;
  sVarName := QuestActionInfo.sParam2;
  sMethod := QuestActionInfo.sParam3;
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam4, nVarValue) then //ӱ֧
    nVarValue := Str_ToInt(QuestActionInfo.sParam4, 0);
  if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam4, sVarValue) then //ӱ֧
    if not GetHumanInfoValue(PlayObject, QuestActionInfo.sParam4, sVarValue) then
    sVarValue := QuestActionInfo.sParam4;

  //sVarValue2 := QuestActionInfo.sParam5;
  if (sType = '') or (sVarName = '') or (sMethod = '') then begin
    ScriptActionError(PlayObject, '', QuestActionInfo, sSC_CALCVAR);
    Exit;
  end;
  boFoundVar := False;
  {if (sVarValue <> '') and (sVarValue2 <> '') and (not IsStringNumber(sVarValue)) and (not IsStringNumber(sVarValue2)) then begin
    DynamicVarList := GetDynamicVarList(PlayObject, sVarValue, sName);
    if DynamicVarList = nil then begin
      //DisPose(DynamicVar);  ʲô˼?
      ScriptActionError(PlayObject, format(sVarTypeError, [sVarValue]), QuestActionInfo, sSC_CALCVAR);
      Exit;
    end;
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if CompareText(DynamicVar.sName, sVarValue2) = 0 then begin
        case DynamicVar.VarType of
          vInteger: begin
              nVarValue := DynamicVar.nInternet;
            end;
          vString: begin

            end;
        end;
        boFoundVar := True;
        break;
      end;
    end;
    if not boFoundVar then begin
      ScriptActionError(PlayObject, format(sVarFound, [sVarValue2, sVarValue]), QuestActionInfo, sSC_CALCVAR);
      Exit;
    end;
  end else nVarValue := Str_ToInt(QuestActionInfo.sParam4, 0);}

  boFoundVar := False;
  cMethod := sMethod[1];
  DynamicVarList := GetDynamicVarList(PlayObject, sType, sName);
  if DynamicVarList = nil then begin
    DisPose(DynamicVar);
    ScriptActionError(PlayObject, format(sVarTypeError, [sType]), QuestActionInfo, sSC_CALCVAR);
    Exit;
  end else begin
    for i := 0 to DynamicVarList.Count - 1 do begin
      DynamicVar := DynamicVarList.Items[i];
      if DynamicVar <> nil then begin
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          case DynamicVar.VarType of
            vInteger: begin
                case cMethod of
                  '=': DynamicVar.nInternet := nVarValue;
                  '+': DynamicVar.nInternet := DynamicVar.nInternet + nVarValue;
                  '-': DynamicVar.nInternet := DynamicVar.nInternet - nVarValue;
                  '*': DynamicVar.nInternet := DynamicVar.nInternet * nVarValue;
                  '/': DynamicVar.nInternet := DynamicVar.nInternet div nVarValue;
                end;
              end;
            vString: begin
                case cMethod of
                  '=': DynamicVar.sString := sVarValue;
                end;

              end;
          end;
          boFoundVar := True;
          break;
        end;
      end;
    end;
    if not boFoundVar then
      ScriptActionError(PlayObject, format(sVarFound, [sVarName, sType]), QuestActionInfo, sSC_CALCVAR);
  end;
end;

procedure TNormNpc.Initialize;
var
  nInteger:Integer;
begin
  inherited Initialize;
  if m_btNpcAutoChangeColorMode <> 0 then  begin
    case m_btNpcAutoChangeColorMode  of
      1: m_dwNpcAutoChangeColorTick := GetTickCount +Random(35)*100;
      2: begin
        m_boFixColor := True;
        case m_dwNpcAutoChangeColorTime div 1000 of
          0: nInteger := STATE_TRANSPARENT;
          1: nInteger := POISON_STONE;
          2: nInteger := POISON_DONTMOVE;
          3: nInteger := POISON_68;
          4: nInteger := POISON_DECHEALTH;
          5: nInteger := POISON_LOCKSPELL;
          6: nInteger := POISON_DAMAGEARMOR;
        else begin
            m_nFixColorIdx := 0;
            nInteger := STATE_TRANSPARENT;
          end;
        end;
        m_nCharStatus := (m_nCharStatusEx and $FFFFF) or (($80000000 shr nInteger) or 0);
        m_nFixStatus := m_nCharStatus;
      end;
    end;
  end;
  m_Castle := g_CastleManager.InCastleWarArea(Self);
end;

function TNormNpc.ConditionOfCheckNameDateList(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  i: Integer;
  LoadList: TStringList;
  sListFileName, sLineText, sHumName, sDate: string;
  boDeleteExprie, boNoCompareHumanName: Boolean;
  dOldDate: TDateTime;
  cMethod: Char;
  nValNo, nValNoDay, nDayCount, nDay: Integer;
begin
  Result := False;
  nDayCount := Str_ToInt(QuestConditionInfo.sParam3, -1);
  nValNo := GetValNameNo(QuestConditionInfo.sParam4);
  nValNoDay := GetValNameNo(QuestConditionInfo.sParam5);
  boDeleteExprie := CompareText(QuestConditionInfo.sParam6, '') = 0;
  boNoCompareHumanName := CompareText(QuestConditionInfo.sParam6, '1') = 0;
  cMethod := QuestConditionInfo.sParam2[1];
  if nDayCount < 0 then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKNAMEDATELIST);
    Exit;
  end;
  sListFileName := g_Config.sEnvirDir + m_sPath + QuestConditionInfo.sParam1;
  if FileExists(sListFileName) then begin
    LoadList := TStringList.Create;
    try
      LoadList.LoadFromFile(sListFileName);
    except
      MainOutMessage('loading fail.... => ' + sListFileName);
    end;
    for i := 0 to LoadList.Count - 1 do begin
      sLineText := Trim(LoadList.Strings[i]);
      sLineText := GetValidStr3(sLineText, sHumName, [' ', #9]);
      sLineText := GetValidStr3(sLineText, sDate, [' ', #9]);
      if (CompareText(sHumName, PlayObject.m_sCharName) = 0) or boNoCompareHumanName then begin
        nDay := High(Integer);
        if TryStrToDateTime(sDate, dOldDate) then
          nDay := GetDayCount(Now, dOldDate);
        case cMethod of
          '=': if nDay = nDayCount then Result := True;
          '>': if nDay > nDayCount then Result := True;
          '<': if nDay < nDayCount then Result := True;
        else if nDay >= nDayCount then Result := True;
        end;
        if nValNo >= 0 then begin
          case nValNo of
            0..9: begin
                PlayObject.m_nVal[nValNo] := nDay;
              end;
            100..199: begin
                g_Config.nGlobalVal[nValNo - 100] := nDay;
              end;
            200..209: begin
                PlayObject.m_DyVal[nValNo - 200] := nDay;
              end;
            300..399: begin
                PlayObject.m_nMval[nValNo - 300] := nDay;
              end;
            400..499: begin
                g_Config.nGlobaDyMval[nValNo - 400] := nDay;
              end;
            500..599: begin
                PlayObject.m_nInteger[nValNo - 500] := nDay;
              end;
          end;
        end;

        if nValNoDay >= 0 then begin
          case nValNoDay of
            0..9: begin
                PlayObject.m_nVal[nValNoDay] := nDayCount - nDay;
              end;
            100..199: begin
                g_Config.nGlobalVal[nValNoDay - 100] := nDayCount - nDay;
              end;
            200..209: begin
                PlayObject.m_DyVal[nValNoDay - 200] := nDayCount - nDay;
              end;
            300..399: begin
                PlayObject.m_nMval[nValNoDay - 300] := nDayCount - nDay;
              end;
            400..499: begin
                g_Config.nGlobaDyMval[nValNo - 400] := nDayCount - nDay;
              end;
            500..599: begin
                PlayObject.m_nInteger[nValNo - 500] := nDayCount - nDay;
              end;
          end;
        end;
        if not Result then begin
          if boDeleteExprie then begin
            LoadList.Delete(i);
            try
              LoadList.SaveToFile(sListFileName);
            except
              MainOutMessage('Save fail.... => ' + sListFileName);
            end;
          end;
        end;
        break;
      end;
    end;
    LoadList.Free;
  end else begin
    MainOutMessage('file not found => ' + sListFileName);
  end;
end;
//CHECKMAPHUMANCOUNT MAP = COUNT

function TNormNpc.ConditionOfCheckMapHumanCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nCount, nHumanCount: Integer;
  cMethod: Char;
  sMapName: string;
begin
  Result := False;
  nCount := Str_ToInt(QuestConditionInfo.sParam3, -1);
  if nCount < 0 then begin
    if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nCount) then begin //ӱ֧
      ScriptConditionError(PlayObject, QuestConditionInfo,
      sSC_CHECKMAPHUMANCOUNT);
      Exit;
    end;
  end;
  if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, sMapName) then begin //ӱ֧
    sMapName := QuestConditionInfo.sParam1;
  end;
  nHumanCount := UserEngine.GetMapHuman(sMapName);
  cMethod := QuestConditionInfo.sParam2[1];
  case cMethod of
    '=': if nHumanCount = nCount then Result := True;
    '>': if nHumanCount > nCount then Result := True;
    '<': if nHumanCount < nCount then Result := True;
  else if nHumanCount >= nCount then Result := True;
  end;
end;

function TNormNpc.ConditionOfCheckMapMonCount(PlayObject: TPlayObject;
  QuestConditionInfo: pTQuestConditionInfo): Boolean;
var
  nCount, nMonCount: Integer;
  cMethod: Char;
  Map: TMap;
begin
  Result := False;
  nCount := Str_ToInt(QuestConditionInfo.sParam3, -1);
  Map := g_MapManager.FindMap(QuestConditionInfo.sParam1);
  if nCount < 0 then ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, nCount);
  if (nCount < 0) or (Map = nil) then begin
    ScriptConditionError(PlayObject, QuestConditionInfo, sSC_CHECKMAPMONCOUNT);
    Exit;
  end;
  nMonCount := UserEngine.GetMapMonster(Map, nil);
  cMethod := QuestConditionInfo.sParam2[1];
  case cMethod of
    '=': if nMonCount = nCount then Result := True;
    '>': if nMonCount > nCount then Result := True;
    '<': if nMonCount < nCount then Result := True;
  else if nMonCount >= nCount then Result := True;
  end;
end;

function TNormNpc.GetDynamicVarList(PlayObject: TPlayObject;
  sType: string; var sName: string): TSimpleList;
begin
  Result := nil;
  if CompareLStr(sType, 'V_P', Length('V_P')) then begin
    Result := PlayObject.m_DynamicVarList;
    sName := PlayObject.m_sCharName;
  end else
    if CompareLStr(sType, 'V_G', Length('V_G')) then begin
      if PlayObject.m_MyGuild = nil then Exit;
      Result := TGUild(PlayObject.m_MyGuild).m_DynamicVarList;
      sName := TGUild(PlayObject.m_MyGuild).sGuildName;
    end else
      if CompareLStr(sType, 'V_S', Length('V_S')) then begin
        Result := g_DynamicVarList;
        sName := 'V_S';
      end;
end;

{ TGuildOfficial }

procedure TGuildOfficial.Click(PlayObject: TPlayObject); //004A30F4
begin
  //  GotoLable(PlayObject,'@main');
  inherited;
end;

procedure TGuildOfficial.GetVariableText(PlayObject: TPlayObject;
  var sMsg: string; sVariable: string);
var
  i, ii: Integer;
  sText: string;
  List: TStringList;
  sStr: string;
begin
  inherited;
  if sVariable = '$REQUESTCASTLELIST' then begin
    sText := '';
    List := TStringList.Create;
    g_CastleManager.GetCastleNameList(List);
    for i := 0 to List.Count - 1 do begin
      ii := i + 1;
      if ((ii div 2) * 2 = ii) then sStr := '\'
      else sStr := '';
      sText := sText + format('<%s/@requestcastlewarnow%d> %s', [List.Strings[i], i, sStr]);
    end;
    sText := sText + '\ \';
    List.Free;
    sMsg := sub_49ADB8(sMsg, '<$REQUESTCASTLELIST>', sText);
  end;
end;

procedure TGuildOfficial.Run; //004A37F0
begin
  if Random(40) = 0 then begin
    TurnTo(Random(8));
  end else begin
    if Random(30) = 0 then
      AddRefAction(RM_HIT, m_btDirection, m_nCurrX, m_nCurrY, 0, '');
  end;
  inherited;
end;

procedure TGuildOfficial.UserSelect(PlayObject: TPlayObject; sData: string);
var
  sMsg, sLabel: string;
  boCanJmp: Boolean;
const
  sExceptionMsg = '[쳣!!] TGuildOfficial::UserSelect... ';
begin
  inherited;
  try
    //    PlayObject.m_nScriptGotoCount:=0;
    if (sData <> '') and (sData[1] = '@') then begin
      sMsg := GetValidStr3(sData, sLabel, [#13]);

      boCanJmp := PlayObject.LableIsCanJmp(sLabel);

      GotoLable(PlayObject, sLabel, not boCanJmp);

      //GotoLable(PlayObject,sLabel,not PlayObject.LableIsCanJmp(sLabel));
      if not boCanJmp then Exit;
      if CompareText(sLabel, sBUILDGUILDNOW) = 0 then begin
        ReQuestBuildGuild(PlayObject, sMsg);
      end else
        if CompareText(sLabel, sSCL_GUILDWAR) = 0 then begin
          ReQuestGuildWar(PlayObject, sMsg);
        end else
        {
        if CompareText(sLabel,sREQUESTCASTLEWAR) = 0 then begin
          ReQuestCastleWar(PlayObject,sMsg);
        end else
        }
          if CompareLStr(sLabel, sREQUESTCASTLEWAR, Length(sREQUESTCASTLEWAR)) then begin
            ReQuestCastleWar(PlayObject, Copy(sLabel, Length(sREQUESTCASTLEWAR) + 1, Length(sLabel) - Length(sREQUESTCASTLEWAR)));
          end else
            if CompareText(sLabel, sEXIT) = 0 then begin
              PlayObject.AddAction(Self, RM_MERCHANTDLGCLOSE, 0, Integer(Self), 0, 0, '');
            end else
              if CompareText(sLabel, sBACK) = 0 then begin
                if PlayObject.m_sScriptGoBackLable = '' then PlayObject.m_sScriptGoBackLable := sMAIN;
                GotoLable(PlayObject, PlayObject.m_sScriptGoBackLable, False);
              end;
    end;
  except
    MainOutMessage(sExceptionMsg);
  end;
  //  inherited;
end;

function TGuildOfficial.ReQuestBuildGuild(PlayObject: TPlayObject; sGuildName: string): Integer; //004A3124
var
  UserItem: pTUserItem;
  sKey: string;
  function Check(sName: string):Boolean;
  begin
    Result := GetSockMsg(FrmMain.CSCheckName.Socket,'G'+sName,1000) ='O';
  end;  
begin
  Result := 0;
  sGuildName := Trim(sGuildName);
  UserItem := nil;
  if sGuildName = '' then begin
    Result := -4;
  end;
  if PlayObject.m_MyGuild = nil then begin
    if PlayObject.m_nGold >= g_Config.nBuildGuildPrice then begin
      UserItem := PlayObject.CheckItems(g_Config.sWomaHorn);
      if UserItem = nil then begin
        Result := -3; //'û׼ҪȫƷ'
      end;
    end else Result := -2; //'ȱٴá'
  end else Result := -1; //'Ѿлᡣ'
  if Length(sGuildName) > sGuildNameLength then Result := -5;
  if sGuildName = '' then Result := -6;
  if not Check(sGuildName) then Result := -6;
  if Result = 0 then begin
    if g_GuildManager.AddGuild(sGuildName, PlayObject.m_sCharName) then begin
      UserEngine.SendServerGroupMsg(ISM_ADDGUILD, nServerIndex, sGuildName + '/' + PlayObject.m_sCharName);
      PlayObject.SendDelItems(UserItem);
      PlayObject.DelBagItem(UserItem.MakeIndex, g_Config.sWomaHorn);
      PlayObject.DecGold(g_Config.nBuildGuildPrice);
      PlayObject.GoldChanged();
      PlayObject.m_MyGuild := g_GuildManager.MemberOfGuild(PlayObject.m_sCharName);
      if PlayObject.m_MyGuild <> nil then begin
        PlayObject.m_sGuildRankName := TGUild(PlayObject.m_MyGuild).GetRankName(PlayObject, PlayObject.m_nGuildRankNo);
        RefShowName();
      end;
    end else Result := -4;
  end;
  if Result >= 0 then begin
    PlayObject.AddAction(Self, RM_BUILDGUILD_OK, 0, 0, 0, 0, '');
  end else begin
    PlayObject.AddAction(Self, RM_BUILDGUILD_FAIL, 0, Result, 0, 0, '');
  end;
end;

function TGuildOfficial.ReQuestGuildWar(PlayObject: TPlayObject; sGuildName: string): Integer; //004A3368
begin
  if g_GuildManager.FindGuild(sGuildName) <> nil then begin
    if PlayObject.m_nGold >= g_Config.nGuildWarPrice then begin
      PlayObject.DecGold(g_Config.nGuildWarPrice);
      PlayObject.GoldChanged();
      PlayObject.ReQuestGuildWar(sGuildName);
    end else begin
      PlayObject.SysMsg('û㹻Ľң', c_Red, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('л ' + sGuildName + ' ڣ', c_Red, t_Hint);
  end;
  Result := 1;
end;


procedure TGuildOfficial.ReQuestCastleWar(PlayObject: TPlayObject; sIndex: string); //004A3498
var
  UserItem: pTUserItem;
  Castle: TUserCastle;
  nIndex: Integer;
begin
  //  if PlayObject.IsGuildMaster and
  //     (not UserCastle.IsMasterGuild(TGuild(PlayObject.m_MyGuild))) then begin
  nIndex := Str_ToInt(sIndex, -1);
  if nIndex < 0 then nIndex := 0;

  Castle := g_CastleManager.GetCastle(nIndex);
  if PlayObject.IsGuildMaster and
    not Castle.IsMember(PlayObject) then begin

    UserItem := PlayObject.CheckItems(g_Config.sZumaPiece);
    if UserItem <> nil then begin
      if Castle.AddAttackerInfo(TGUild(PlayObject.m_MyGuild)) then begin
        PlayObject.SendDelItems(UserItem);
        PlayObject.DelBagItem(UserItem.MakeIndex, g_Config.sZumaPiece);
        GotoLable(PlayObject, '~@request_ok', False);
      end else begin
        PlayObject.SysMsg('޷󹥳ǣ', c_Red, t_Hint);
      end;
      end else begin
      PlayObject.SysMsg('û' + g_Config.sZumaPiece + '', c_Red, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ȡ', c_Red, t_Hint);
  end;
end;

procedure TCastleOfficial.RepairDoor(PlayObject: TPlayObject); //004A3FB8
begin
  if m_Castle = nil then begin
    PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
    Exit;
  end;
  if TUserCastle(m_Castle).m_nTotalGold >= g_Config.nRepairDoorPrice then begin
    if TUserCastle(m_Castle).RepairDoor then begin
      Dec(TUserCastle(m_Castle).m_nTotalGold, g_Config.nRepairDoorPrice);
      PlayObject.SysMsg('ɹ', c_Green, t_Hint);
    end else begin
      PlayObject.SysMsg('ŲҪ', c_Green, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡', c_Red, t_Hint);
  end;
  {
  if UserCastle.m_nTotalGold >= g_Config.nRepairDoorPrice then begin
    if UserCastle.RepairDoor then begin
      Dec(UserCastle.m_nTotalGold,g_Config.nRepairDoorPrice);
      PlayObject.SysMsg('ɹ',c_Green,t_Hint);
    end else begin
      PlayObject.SysMsg('ŲҪ',c_Green,t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡',c_Red,t_Hint);
  end;
  }
end;

procedure TCastleOfficial.RepairWallNow(nWallIndex: Integer;
  PlayObject: TPlayObject); //004A4074
begin
  if m_Castle = nil then begin
    PlayObject.SysMsg('NPCڳǱ', c_Red, t_Hint);
    Exit;
  end;

  if TUserCastle(m_Castle).m_nTotalGold >= g_Config.nRepairWallPrice then begin
    if TUserCastle(m_Castle).RepairWall(nWallIndex) then begin
      Dec(TUserCastle(m_Castle).m_nTotalGold, g_Config.nRepairWallPrice);
      PlayObject.SysMsg('ɹ', c_Green, t_Hint);
    end else begin
      PlayObject.SysMsg('ŲҪ', c_Green, t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡', c_Red, t_Hint);
  end;
  {
  if UserCastle.m_nTotalGold >= g_Config.nRepairWallPrice then begin
    if UserCastle.RepairWall(nWallIndex) then begin
      Dec(UserCastle.m_nTotalGold,g_Config.nRepairWallPrice);
      PlayObject.SysMsg('ɹ',c_Green,t_Hint);
    end else begin
      PlayObject.SysMsg('ŲҪ',c_Green,t_Hint);
    end;
  end else begin
    PlayObject.SysMsg('ʽ㣡',c_Red,t_Hint);
  end;
  }
end;

constructor TCastleOfficial.Create;
begin
  inherited;

end;

destructor TCastleOfficial.Destroy;
begin

  inherited;
end;

constructor TGuildOfficial.Create;
begin
  inherited;
  m_btRaceImg := RCC_MERCHANT;
  m_wAppr := 8;
end;

destructor TGuildOfficial.Destroy;
begin   
  inherited;
end;


end.


